function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value1) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value1,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value1;
    }
    return obj;
}
function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
        _get = Reflect.get;
    } else {
        _get = function get(target, property, receiver) {
            var base = _super_prop_base(target, property);
            if (!base) return;
            var desc = Object.getOwnPropertyDescriptor(base, property);
            if (desc.get) {
                return desc.get.call(receiver || target);
            }
            return desc.value;
        };
    }
    return _get(target, property, receiver || target);
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _super_prop_base(object, property) {
    while(!Object.prototype.hasOwnProperty.call(object, property)){
        object = _get_prototype_of(object);
        if (object === null) break;
    }
    return object;
}
function _tagged_template_literal(strings, raw) {
    if (!raw) {
        raw = strings.slice(0);
    }
    return Object.freeze(Object.defineProperties(strings, {
        raw: {
            value: Object.freeze(raw)
        }
    }));
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _create_super(Derived) {
    var hasNativeReflectConstruct = _is_native_reflect_construct();
    return function _createSuperInternal() {
        var Super = _get_prototype_of(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _get_prototype_of(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possible_constructor_return(this, result);
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
function _templateObject() {
    var data = _tagged_template_literal([
        "pipelineOperator"
    ]);
    _templateObject = function _templateObject() {
        return data;
    };
    return data;
}
function _templateObject1() {
    var data = _tagged_template_literal([
        "flow"
    ]);
    _templateObject1 = function _templateObject() {
        return data;
    };
    return data;
}
function _templateObject2() {
    var data = _tagged_template_literal([
        "jsx"
    ]);
    _templateObject2 = function _templateObject() {
        return data;
    };
    return data;
}
function _templateObject3() {
    var data = _tagged_template_literal([
        "typescript"
    ]);
    _templateObject3 = function _templateObject() {
        return data;
    };
    return data;
}
function _templateObject4() {
    var data = _tagged_template_literal([
        "placeholders"
    ]);
    _templateObject4 = function _templateObject() {
        return data;
    };
    return data;
}
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = function(obj, key, value1) {
    return key in obj ? __defProp(obj, key, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: value1
    }) : obj[key] = value1;
};
var __commonJS = function(cb, mod) {
    return function __require() {
        return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = {
            exports: {}
        }).exports, mod), mod.exports;
    };
};
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && typeof from === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toESM = function(mod, isNodeMode, target) {
    return target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(// If the importer is in node compatibility mode or this is not an ESM
    // file that has been converted to a CommonJS file using a Babel-
    // compatible transform (i.e. "__esModule" has not been set), then set
    // "default" to the CommonJS "module.exports" for node compatibility.
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", {
        value: mod,
        enumerable: true
    }) : target, mod);
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
var __publicField = function(obj, key, value1) {
    __defNormalProp(obj, (typeof key === "undefined" ? "undefined" : _type_of(key)) !== "symbol" ? key + "" : key, value1);
    return value1;
};
// node_modules/to-fast-properties/index.js
var require_to_fast_properties = __commonJS({
    "node_modules/to-fast-properties/index.js": function(exports2, module2) {
        "use strict";
        var fastProto = null;
        function FastObject(o) {
            if (fastProto !== null && _type_of(fastProto.property)) {
                var result = fastProto;
                fastProto = FastObject.prototype = null;
                return result;
            }
            fastProto = FastObject.prototype = o == null ? /* @__PURE__ */ Object.create(null) : o;
            return new FastObject();
        }
        var inlineCacheCutoff = 10;
        for(var i = 0; i <= inlineCacheCutoff; i++){
            FastObject();
        }
        module2.exports = function toFastproperties(o) {
            return FastObject(o);
        };
    }
});
// node_modules/@babel/highlight/node_modules/js-tokens/index.js
var require_js_tokens = __commonJS({
    "node_modules/@babel/highlight/node_modules/js-tokens/index.js": function(exports2, module2) {
        var Identifier2;
        var JSXIdentifier2;
        var JSXPunctuator;
        var JSXString;
        var JSXText2;
        var KeywordsWithExpressionAfter;
        var KeywordsWithNoLineTerminatorAfter;
        var LineTerminatorSequence;
        var MultiLineComment;
        var Newline;
        var NumericLiteral3;
        var Punctuator;
        var RegularExpressionLiteral;
        var SingleLineComment;
        var StringLiteral3;
        var Template;
        var TokensNotPrecedingObjectLiteral;
        var TokensPrecedingExpression;
        var WhiteSpace;
        var jsTokens2;
        RegularExpressionLiteral = RegExp("\\/(?![*\\/])(?:\\[(?:(?![\\]\\\\]).|\\\\.)*\\]|(?![\\/\\\\]).|\\\\.)*(\\/[$_\\u200C\\u200D\\p{ID_Continue}]*|\\\\)?", "yu");
        Punctuator = RegExp("--|\\+\\+|=>|\\.{3}|\\??\\.(?!\\d)|(?:&&|\\|\\||\\?\\?|[+\\-%&|^]|\\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2}|\\/(?![\\/*]))=?|[?~,:;[\\](){}]", "y");
        Identifier2 = RegExp("(\\x23?)(?=[$_\\p{ID_Start}\\\\])(?:[$_\\u200C\\u200D\\p{ID_Continue}]|\\\\u[\\da-fA-F]{4}|\\\\u\\{[\\da-fA-F]+\\})+", "yu");
        StringLiteral3 = RegExp("(['\"])(?:(?!\\1)[^\\\\\\n\\r]|\\\\(?:\\r\\n|[^]))*(\\1)?", "y");
        NumericLiteral3 = RegExp("(?:0[xX][\\da-fA-F](?:_?[\\da-fA-F])*|0[oO][0-7](?:_?[0-7])*|0[bB][01](?:_?[01])*)n?|0n|[1-9](?:_?\\d)*n|(?:(?:0(?!\\d)|0\\d*[89]\\d*|[1-9](?:_?\\d)*)(?:\\.(?:\\d(?:_?\\d)*)?)?|\\.\\d(?:_?\\d)*)(?:[eE][+-]?\\d(?:_?\\d)*)?|0[0-7]+", "y");
        Template = RegExp("[`}](?:[^`\\\\$]|\\\\[^]|\\$(?!\\{))*(`|\\$\\{)?", "y");
        WhiteSpace = RegExp("[\\t\\v\\f\\ufeff\\p{Zs}]+", "yu");
        LineTerminatorSequence = RegExp("\\r?\\n|[\\r\\u2028\\u2029]", "y");
        MultiLineComment = RegExp("\\/\\*(?:[^*]|\\*(?!\\/))*(\\*\\/)?", "y");
        SingleLineComment = RegExp("\\/\\/.*", "y");
        JSXPunctuator = RegExp("[<>.:={}]|\\/(?![\\/*])", "y");
        JSXIdentifier2 = RegExp("[$_\\p{ID_Start}][$_\\u200C\\u200D\\p{ID_Continue}-]*", "yu");
        JSXString = RegExp("(['\"])(?:(?!\\1)[^])*(\\1)?", "y");
        JSXText2 = RegExp("[^<>{}]+", "y");
        TokensPrecedingExpression = /^(?:[\/+-]|\.{3}|\?(?:InterpolationIn(?:JSX|Template)|NoLineTerminatorHere|NonExpressionParenEnd|UnaryIncDec))?$|[{}([,;<>=*%&|^!~?:]$/;
        TokensNotPrecedingObjectLiteral = /^(?:=>|[;\]){}]|else|\?(?:NoLineTerminatorHere|NonExpressionParenEnd))?$/;
        KeywordsWithExpressionAfter = /^(?:await|case|default|delete|do|else|instanceof|new|return|throw|typeof|void|yield)$/;
        KeywordsWithNoLineTerminatorAfter = /^(?:return|throw|yield)$/;
        Newline = RegExp(LineTerminatorSequence.source);
        module2.exports = jsTokens2 = function jsTokens2(input) {
            var _ref, tmp, jsx2, braces, firstCodePoint, isExpression3, lastIndex, lastSignificantToken, length, match, mode, nextLastIndex, nextLastSignificantToken, parenNesting, postfixIncDec, punctuator, stack, _, _1, _2;
            var _arguments = arguments;
            return _ts_generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        _ref = _arguments.length > 1 && _arguments[1] !== void 0 ? _arguments[1] : {}, tmp = _ref.jsx, jsx2 = tmp === void 0 ? false : tmp;
                        length = input.length;
                        lastIndex = 0;
                        lastSignificantToken = "";
                        stack = [
                            {
                                tag: "JS"
                            }
                        ];
                        braces = [];
                        parenNesting = 0;
                        postfixIncDec = false;
                        _state.label = 1;
                    case 1:
                        if (!(lastIndex < length)) return [
                            3,
                            62
                        ];
                        mode = stack[stack.length - 1];
                        _ = mode.tag;
                        switch(_){
                            case "JS":
                                return [
                                    3,
                                    2
                                ];
                            case "JSNonExpressionParen":
                                return [
                                    3,
                                    2
                                ];
                            case "InterpolationInTemplate":
                                return [
                                    3,
                                    2
                                ];
                            case "InterpolationInJSX":
                                return [
                                    3,
                                    2
                                ];
                            case "JSXTag":
                                return [
                                    3,
                                    38
                                ];
                            case "JSXTagEnd":
                                return [
                                    3,
                                    38
                                ];
                            case "JSXChildren":
                                return [
                                    3,
                                    45
                                ];
                        }
                        return [
                            3,
                            52
                        ];
                    case 2:
                        if (!(input[lastIndex] === "/" && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken)))) return [
                            3,
                            4
                        ];
                        RegularExpressionLiteral.lastIndex = lastIndex;
                        if (!(match = RegularExpressionLiteral.exec(input))) return [
                            3,
                            4
                        ];
                        lastIndex = RegularExpressionLiteral.lastIndex;
                        lastSignificantToken = match[0];
                        postfixIncDec = true;
                        return [
                            4,
                            {
                                type: "RegularExpressionLiteral",
                                value: match[0],
                                closed: match[1] !== void 0 && match[1] !== "\\"
                            }
                        ];
                    case 3:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 4:
                        Punctuator.lastIndex = lastIndex;
                        if (!(match = Punctuator.exec(input))) return [
                            3,
                            26
                        ];
                        punctuator = match[0];
                        nextLastIndex = Punctuator.lastIndex;
                        nextLastSignificantToken = punctuator;
                        switch(punctuator){
                            case "(":
                                return [
                                    3,
                                    5
                                ];
                            case ")":
                                return [
                                    3,
                                    6
                                ];
                            case "{":
                                return [
                                    3,
                                    7
                                ];
                            case "}":
                                return [
                                    3,
                                    8
                                ];
                            case "]":
                                return [
                                    3,
                                    18
                                ];
                            case "++":
                                return [
                                    3,
                                    19
                                ];
                            case "--":
                                return [
                                    3,
                                    19
                                ];
                            case "<":
                                return [
                                    3,
                                    20
                                ];
                        }
                        return [
                            3,
                            23
                        ];
                    case 5:
                        if (lastSignificantToken === "?NonExpressionParenKeyword") {
                            stack.push({
                                tag: "JSNonExpressionParen",
                                nesting: parenNesting
                            });
                        }
                        parenNesting++;
                        postfixIncDec = false;
                        return [
                            3,
                            24
                        ];
                    case 6:
                        parenNesting--;
                        postfixIncDec = true;
                        if (mode.tag === "JSNonExpressionParen" && parenNesting === mode.nesting) {
                            stack.pop();
                            nextLastSignificantToken = "?NonExpressionParenEnd";
                            postfixIncDec = false;
                        }
                        return [
                            3,
                            24
                        ];
                    case 7:
                        Punctuator.lastIndex = 0;
                        isExpression3 = !TokensNotPrecedingObjectLiteral.test(lastSignificantToken) && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken));
                        braces.push(isExpression3);
                        postfixIncDec = false;
                        return [
                            3,
                            24
                        ];
                    case 8:
                        _1 = mode.tag;
                        switch(_1){
                            case "InterpolationInTemplate":
                                return [
                                    3,
                                    9
                                ];
                            case "InterpolationInJSX":
                                return [
                                    3,
                                    15
                                ];
                        }
                        return [
                            3,
                            17
                        ];
                    case 9:
                        if (!(braces.length === mode.nesting)) return [
                            3,
                            14
                        ];
                        Template.lastIndex = lastIndex;
                        match = Template.exec(input);
                        lastIndex = Template.lastIndex;
                        lastSignificantToken = match[0];
                        if (!(match[1] === "${")) return [
                            3,
                            11
                        ];
                        lastSignificantToken = "?InterpolationInTemplate";
                        postfixIncDec = false;
                        return [
                            4,
                            {
                                type: "TemplateMiddle",
                                value: match[0]
                            }
                        ];
                    case 10:
                        _state.sent();
                        return [
                            3,
                            13
                        ];
                    case 11:
                        stack.pop();
                        postfixIncDec = true;
                        return [
                            4,
                            {
                                type: "TemplateTail",
                                value: match[0],
                                closed: match[1] === "`"
                            }
                        ];
                    case 12:
                        _state.sent();
                        _state.label = 13;
                    case 13:
                        return [
                            3,
                            1
                        ];
                    case 14:
                        return [
                            3,
                            17
                        ];
                    case 15:
                        if (!(braces.length === mode.nesting)) return [
                            3,
                            17
                        ];
                        stack.pop();
                        lastIndex += 1;
                        lastSignificantToken = "}";
                        return [
                            4,
                            {
                                type: "JSXPunctuator",
                                value: "}"
                            }
                        ];
                    case 16:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 17:
                        postfixIncDec = braces.pop();
                        nextLastSignificantToken = postfixIncDec ? "?ExpressionBraceEnd" : "}";
                        return [
                            3,
                            24
                        ];
                    case 18:
                        postfixIncDec = true;
                        return [
                            3,
                            24
                        ];
                    case 19:
                        nextLastSignificantToken = postfixIncDec ? "?PostfixIncDec" : "?UnaryIncDec";
                        return [
                            3,
                            24
                        ];
                    case 20:
                        if (!(jsx2 && (TokensPrecedingExpression.test(lastSignificantToken) || KeywordsWithExpressionAfter.test(lastSignificantToken)))) return [
                            3,
                            22
                        ];
                        stack.push({
                            tag: "JSXTag"
                        });
                        lastIndex += 1;
                        lastSignificantToken = "<";
                        return [
                            4,
                            {
                                type: "JSXPunctuator",
                                value: punctuator
                            }
                        ];
                    case 21:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 22:
                        postfixIncDec = false;
                        return [
                            3,
                            24
                        ];
                    case 23:
                        postfixIncDec = false;
                        _state.label = 24;
                    case 24:
                        lastIndex = nextLastIndex;
                        lastSignificantToken = nextLastSignificantToken;
                        return [
                            4,
                            {
                                type: "Punctuator",
                                value: punctuator
                            }
                        ];
                    case 25:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 26:
                        Identifier2.lastIndex = lastIndex;
                        if (!(match = Identifier2.exec(input))) return [
                            3,
                            28
                        ];
                        lastIndex = Identifier2.lastIndex;
                        nextLastSignificantToken = match[0];
                        switch(match[0]){
                            case "for":
                            case "if":
                            case "while":
                            case "with":
                                if (lastSignificantToken !== "." && lastSignificantToken !== "?.") {
                                    nextLastSignificantToken = "?NonExpressionParenKeyword";
                                }
                        }
                        lastSignificantToken = nextLastSignificantToken;
                        postfixIncDec = !KeywordsWithExpressionAfter.test(match[0]);
                        return [
                            4,
                            {
                                type: match[1] === "#" ? "PrivateIdentifier" : "IdentifierName",
                                value: match[0]
                            }
                        ];
                    case 27:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 28:
                        StringLiteral3.lastIndex = lastIndex;
                        if (!(match = StringLiteral3.exec(input))) return [
                            3,
                            30
                        ];
                        lastIndex = StringLiteral3.lastIndex;
                        lastSignificantToken = match[0];
                        postfixIncDec = true;
                        return [
                            4,
                            {
                                type: "StringLiteral",
                                value: match[0],
                                closed: match[2] !== void 0
                            }
                        ];
                    case 29:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 30:
                        NumericLiteral3.lastIndex = lastIndex;
                        if (!(match = NumericLiteral3.exec(input))) return [
                            3,
                            32
                        ];
                        lastIndex = NumericLiteral3.lastIndex;
                        lastSignificantToken = match[0];
                        postfixIncDec = true;
                        return [
                            4,
                            {
                                type: "NumericLiteral",
                                value: match[0]
                            }
                        ];
                    case 31:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 32:
                        Template.lastIndex = lastIndex;
                        if (!(match = Template.exec(input))) return [
                            3,
                            37
                        ];
                        lastIndex = Template.lastIndex;
                        lastSignificantToken = match[0];
                        if (!(match[1] === "${")) return [
                            3,
                            34
                        ];
                        lastSignificantToken = "?InterpolationInTemplate";
                        stack.push({
                            tag: "InterpolationInTemplate",
                            nesting: braces.length
                        });
                        postfixIncDec = false;
                        return [
                            4,
                            {
                                type: "TemplateHead",
                                value: match[0]
                            }
                        ];
                    case 33:
                        _state.sent();
                        return [
                            3,
                            36
                        ];
                    case 34:
                        postfixIncDec = true;
                        return [
                            4,
                            {
                                type: "NoSubstitutionTemplate",
                                value: match[0],
                                closed: match[1] === "`"
                            }
                        ];
                    case 35:
                        _state.sent();
                        _state.label = 36;
                    case 36:
                        return [
                            3,
                            1
                        ];
                    case 37:
                        return [
                            3,
                            52
                        ];
                    case 38:
                        JSXPunctuator.lastIndex = lastIndex;
                        if (!(match = JSXPunctuator.exec(input))) return [
                            3,
                            40
                        ];
                        lastIndex = JSXPunctuator.lastIndex;
                        nextLastSignificantToken = match[0];
                        switch(match[0]){
                            case "<":
                                stack.push({
                                    tag: "JSXTag"
                                });
                                break;
                            case ">":
                                stack.pop();
                                if (lastSignificantToken === "/" || mode.tag === "JSXTagEnd") {
                                    nextLastSignificantToken = "?JSX";
                                    postfixIncDec = true;
                                } else {
                                    stack.push({
                                        tag: "JSXChildren"
                                    });
                                }
                                break;
                            case "{":
                                stack.push({
                                    tag: "InterpolationInJSX",
                                    nesting: braces.length
                                });
                                nextLastSignificantToken = "?InterpolationInJSX";
                                postfixIncDec = false;
                                break;
                            case "/":
                                if (lastSignificantToken === "<") {
                                    stack.pop();
                                    if (stack[stack.length - 1].tag === "JSXChildren") {
                                        stack.pop();
                                    }
                                    stack.push({
                                        tag: "JSXTagEnd"
                                    });
                                }
                        }
                        lastSignificantToken = nextLastSignificantToken;
                        return [
                            4,
                            {
                                type: "JSXPunctuator",
                                value: match[0]
                            }
                        ];
                    case 39:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 40:
                        JSXIdentifier2.lastIndex = lastIndex;
                        if (!(match = JSXIdentifier2.exec(input))) return [
                            3,
                            42
                        ];
                        lastIndex = JSXIdentifier2.lastIndex;
                        lastSignificantToken = match[0];
                        return [
                            4,
                            {
                                type: "JSXIdentifier",
                                value: match[0]
                            }
                        ];
                    case 41:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 42:
                        JSXString.lastIndex = lastIndex;
                        if (!(match = JSXString.exec(input))) return [
                            3,
                            44
                        ];
                        lastIndex = JSXString.lastIndex;
                        lastSignificantToken = match[0];
                        return [
                            4,
                            {
                                type: "JSXString",
                                value: match[0],
                                closed: match[2] !== void 0
                            }
                        ];
                    case 43:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 44:
                        return [
                            3,
                            52
                        ];
                    case 45:
                        JSXText2.lastIndex = lastIndex;
                        if (!(match = JSXText2.exec(input))) return [
                            3,
                            47
                        ];
                        lastIndex = JSXText2.lastIndex;
                        lastSignificantToken = match[0];
                        return [
                            4,
                            {
                                type: "JSXText",
                                value: match[0]
                            }
                        ];
                    case 46:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 47:
                        _2 = input[lastIndex];
                        switch(_2){
                            case "<":
                                return [
                                    3,
                                    48
                                ];
                            case "{":
                                return [
                                    3,
                                    50
                                ];
                        }
                        return [
                            3,
                            52
                        ];
                    case 48:
                        stack.push({
                            tag: "JSXTag"
                        });
                        lastIndex++;
                        lastSignificantToken = "<";
                        return [
                            4,
                            {
                                type: "JSXPunctuator",
                                value: "<"
                            }
                        ];
                    case 49:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 50:
                        stack.push({
                            tag: "InterpolationInJSX",
                            nesting: braces.length
                        });
                        lastIndex++;
                        lastSignificantToken = "?InterpolationInJSX";
                        postfixIncDec = false;
                        return [
                            4,
                            {
                                type: "JSXPunctuator",
                                value: "{"
                            }
                        ];
                    case 51:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 52:
                        WhiteSpace.lastIndex = lastIndex;
                        if (!(match = WhiteSpace.exec(input))) return [
                            3,
                            54
                        ];
                        lastIndex = WhiteSpace.lastIndex;
                        return [
                            4,
                            {
                                type: "WhiteSpace",
                                value: match[0]
                            }
                        ];
                    case 53:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 54:
                        LineTerminatorSequence.lastIndex = lastIndex;
                        if (!(match = LineTerminatorSequence.exec(input))) return [
                            3,
                            56
                        ];
                        lastIndex = LineTerminatorSequence.lastIndex;
                        postfixIncDec = false;
                        if (KeywordsWithNoLineTerminatorAfter.test(lastSignificantToken)) {
                            lastSignificantToken = "?NoLineTerminatorHere";
                        }
                        return [
                            4,
                            {
                                type: "LineTerminatorSequence",
                                value: match[0]
                            }
                        ];
                    case 55:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 56:
                        MultiLineComment.lastIndex = lastIndex;
                        if (!(match = MultiLineComment.exec(input))) return [
                            3,
                            58
                        ];
                        lastIndex = MultiLineComment.lastIndex;
                        if (Newline.test(match[0])) {
                            postfixIncDec = false;
                            if (KeywordsWithNoLineTerminatorAfter.test(lastSignificantToken)) {
                                lastSignificantToken = "?NoLineTerminatorHere";
                            }
                        }
                        return [
                            4,
                            {
                                type: "MultiLineComment",
                                value: match[0],
                                closed: match[1] !== void 0
                            }
                        ];
                    case 57:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 58:
                        SingleLineComment.lastIndex = lastIndex;
                        if (!(match = SingleLineComment.exec(input))) return [
                            3,
                            60
                        ];
                        lastIndex = SingleLineComment.lastIndex;
                        postfixIncDec = false;
                        return [
                            4,
                            {
                                type: "SingleLineComment",
                                value: match[0]
                            }
                        ];
                    case 59:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 60:
                        firstCodePoint = String.fromCodePoint(input.codePointAt(lastIndex));
                        lastIndex += firstCodePoint.length;
                        lastSignificantToken = firstCodePoint;
                        postfixIncDec = false;
                        return [
                            4,
                            {
                                type: mode.tag.startsWith("JSX") ? "JSXInvalid" : "Invalid",
                                value: firstCodePoint
                            }
                        ];
                    case 61:
                        _state.sent();
                        return [
                            3,
                            1
                        ];
                    case 62:
                        return [
                            2,
                            void 0
                        ];
                }
            });
        };
    }
});
// node_modules/jsesc/jsesc.js
var require_jsesc = __commonJS({
    "node_modules/jsesc/jsesc.js": function(exports2, module2) {
        "use strict";
        var object = {};
        var hasOwnProperty = object.hasOwnProperty;
        var forOwn = function(object2, callback) {
            for(var key in object2){
                if (hasOwnProperty.call(object2, key)) {
                    callback(key, object2[key]);
                }
            }
        };
        var extend = function(destination, source) {
            if (!source) {
                return destination;
            }
            forOwn(source, function(key, value1) {
                destination[key] = value1;
            });
            return destination;
        };
        var forEach = function(array, callback) {
            var length = array.length;
            var index3 = -1;
            while(++index3 < length){
                callback(array[index3]);
            }
        };
        var fourHexEscape = function(hex) {
            return "\\u" + ("0000" + hex).slice(-4);
        };
        var hexadecimal = function(code2, lowercase) {
            var hexadecimal2 = code2.toString(16);
            if (lowercase) return hexadecimal2;
            return hexadecimal2.toUpperCase();
        };
        var toString = object.toString;
        var isArray = Array.isArray;
        var isBuffer = function(value1) {
            return typeof Buffer === "function" && Buffer.isBuffer(value1);
        };
        var isObject = function(value1) {
            return toString.call(value1) == "[object Object]";
        };
        var isString = function(value1) {
            return typeof value1 == "string" || toString.call(value1) == "[object String]";
        };
        var isNumber2 = function(value1) {
            return typeof value1 == "number" || toString.call(value1) == "[object Number]";
        };
        var isFunction5 = function(value1) {
            return typeof value1 == "function";
        };
        var isMap = function(value1) {
            return toString.call(value1) == "[object Map]";
        };
        var isSet = function(value1) {
            return toString.call(value1) == "[object Set]";
        };
        var singleEscapes = {
            "\\": "\\\\",
            "\b": "\\b",
            "\f": "\\f",
            "\n": "\\n",
            "\r": "\\r",
            "	": "\\t"
        };
        var regexSingleEscape = /[\\\b\f\n\r\t]/;
        var regexDigit = /[0-9]/;
        var regexWhitespace = /[\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/;
        var escapeEverythingRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^]/g;
        var escapeNonAsciiRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^ !#-&\(-\[\]-_a-~]/g;
        var jsesc2 = function(argument, options) {
            var increaseIndentation = function() {
                oldIndent = indent;
                ++options.indentLevel;
                indent = options.indent.repeat(options.indentLevel);
            };
            var defaults = {
                "escapeEverything": false,
                "minimal": false,
                "isScriptContext": false,
                "quotes": "single",
                "wrap": false,
                "es6": false,
                "json": false,
                "compact": true,
                "lowercaseHex": false,
                "numbers": "decimal",
                "indent": "	",
                "indentLevel": 0,
                "__inline1__": false,
                "__inline2__": false
            };
            var json = options && options.json;
            if (json) {
                defaults.quotes = "double";
                defaults.wrap = true;
            }
            options = extend(defaults, options);
            if (options.quotes != "single" && options.quotes != "double" && options.quotes != "backtick") {
                options.quotes = "single";
            }
            var quote = options.quotes == "double" ? '"' : options.quotes == "backtick" ? "`" : "'";
            var compact = options.compact;
            var lowercaseHex = options.lowercaseHex;
            var indent = options.indent.repeat(options.indentLevel);
            var oldIndent = "";
            var inline1 = options.__inline1__;
            var inline2 = options.__inline2__;
            var newLine = compact ? "" : "\n";
            var result;
            var isEmpty = true;
            var useBinNumbers = options.numbers == "binary";
            var useOctNumbers = options.numbers == "octal";
            var useDecNumbers = options.numbers == "decimal";
            var useHexNumbers = options.numbers == "hexadecimal";
            if (json && argument && isFunction5(argument.toJSON)) {
                argument = argument.toJSON();
            }
            if (!isString(argument)) {
                if (isMap(argument)) {
                    if (argument.size == 0) {
                        return "new Map()";
                    }
                    if (!compact) {
                        options.__inline1__ = true;
                        options.__inline2__ = false;
                    }
                    return "new Map(" + jsesc2(Array.from(argument), options) + ")";
                }
                if (isSet(argument)) {
                    if (argument.size == 0) {
                        return "new Set()";
                    }
                    return "new Set(" + jsesc2(Array.from(argument), options) + ")";
                }
                if (isBuffer(argument)) {
                    if (argument.length == 0) {
                        return "Buffer.from([])";
                    }
                    return "Buffer.from(" + jsesc2(Array.from(argument), options) + ")";
                }
                if (isArray(argument)) {
                    result = [];
                    options.wrap = true;
                    if (inline1) {
                        options.__inline1__ = false;
                        options.__inline2__ = true;
                    }
                    if (!inline2) {
                        increaseIndentation();
                    }
                    forEach(argument, function(value1) {
                        isEmpty = false;
                        if (inline2) {
                            options.__inline2__ = false;
                        }
                        result.push((compact || inline2 ? "" : indent) + jsesc2(value1, options));
                    });
                    if (isEmpty) {
                        return "[]";
                    }
                    if (inline2) {
                        return "[" + result.join(", ") + "]";
                    }
                    return "[" + newLine + result.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "]";
                } else if (isNumber2(argument)) {
                    if (json) {
                        return JSON.stringify(argument);
                    }
                    if (useDecNumbers) {
                        return String(argument);
                    }
                    if (useHexNumbers) {
                        var hexadecimal2 = argument.toString(16);
                        if (!lowercaseHex) {
                            hexadecimal2 = hexadecimal2.toUpperCase();
                        }
                        return "0x" + hexadecimal2;
                    }
                    if (useBinNumbers) {
                        return "0b" + argument.toString(2);
                    }
                    if (useOctNumbers) {
                        return "0o" + argument.toString(8);
                    }
                } else if (!isObject(argument)) {
                    if (json) {
                        return JSON.stringify(argument) || "null";
                    }
                    return String(argument);
                } else {
                    result = [];
                    options.wrap = true;
                    increaseIndentation();
                    forOwn(argument, function(key, value1) {
                        isEmpty = false;
                        result.push((compact ? "" : indent) + jsesc2(key, options) + ":" + (compact ? "" : " ") + jsesc2(value1, options));
                    });
                    if (isEmpty) {
                        return "{}";
                    }
                    return "{" + newLine + result.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "}";
                }
            }
            var regex = options.escapeEverything ? escapeEverythingRegex : escapeNonAsciiRegex;
            result = argument.replace(regex, function(char, pair, lone, quoteChar, index3, string) {
                if (pair) {
                    if (options.minimal) return pair;
                    var first = pair.charCodeAt(0);
                    var second = pair.charCodeAt(1);
                    if (options.es6) {
                        var codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
                        var hex2 = hexadecimal(codePoint, lowercaseHex);
                        return "\\u{" + hex2 + "}";
                    }
                    return fourHexEscape(hexadecimal(first, lowercaseHex)) + fourHexEscape(hexadecimal(second, lowercaseHex));
                }
                if (lone) {
                    return fourHexEscape(hexadecimal(lone.charCodeAt(0), lowercaseHex));
                }
                if (char == "\0" && !json && !regexDigit.test(string.charAt(index3 + 1))) {
                    return "\\0";
                }
                if (quoteChar) {
                    if (quoteChar == quote || options.escapeEverything) {
                        return "\\" + quoteChar;
                    }
                    return quoteChar;
                }
                if (regexSingleEscape.test(char)) {
                    return singleEscapes[char];
                }
                if (options.minimal && !regexWhitespace.test(char)) {
                    return char;
                }
                var hex = hexadecimal(char.charCodeAt(0), lowercaseHex);
                if (json || hex.length > 2) {
                    return fourHexEscape(hex);
                }
                return "\\x" + ("00" + hex).slice(-2);
            });
            if (quote == "`") {
                result = result.replace(/\$\{/g, "\\${");
            }
            if (options.isScriptContext) {
                result = result.replace(/<\/(script|style)/gi, "<\\/$1").replace(/<!--/g, json ? "\\u003C!--" : "\\x3C!--");
            }
            if (options.wrap) {
                result = quote + result + quote;
            }
            return result;
        };
        jsesc2.version = "3.0.2";
        module2.exports = jsesc2;
    }
});
// node_modules/ms/index.js
var require_ms = __commonJS({
    "node_modules/ms/index.js": function(exports2, module2) {
        var s = 1e3;
        var m = s * 60;
        var h = m * 60;
        var d = h * 24;
        var w = d * 7;
        var y = d * 365.25;
        module2.exports = function(val, options) {
            options = options || {};
            var type = typeof val === "undefined" ? "undefined" : _type_of(val);
            if (type === "string" && val.length > 0) {
                return parse2(val);
            } else if (type === "number" && isFinite(val)) {
                return options.long ? fmtLong(val) : fmtShort(val);
            }
            throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
        };
        function parse2(str) {
            str = String(str);
            if (str.length > 100) {
                return;
            }
            var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);
            if (!match) {
                return;
            }
            var n2 = parseFloat(match[1]);
            var type = (match[2] || "ms").toLowerCase();
            switch(type){
                case "years":
                case "year":
                case "yrs":
                case "yr":
                case "y":
                    return n2 * y;
                case "weeks":
                case "week":
                case "w":
                    return n2 * w;
                case "days":
                case "day":
                case "d":
                    return n2 * d;
                case "hours":
                case "hour":
                case "hrs":
                case "hr":
                case "h":
                    return n2 * h;
                case "minutes":
                case "minute":
                case "mins":
                case "min":
                case "m":
                    return n2 * m;
                case "seconds":
                case "second":
                case "secs":
                case "sec":
                case "s":
                    return n2 * s;
                case "milliseconds":
                case "millisecond":
                case "msecs":
                case "msec":
                case "ms":
                    return n2;
                default:
                    return void 0;
            }
        }
        function fmtShort(ms) {
            var msAbs = Math.abs(ms);
            if (msAbs >= d) {
                return Math.round(ms / d) + "d";
            }
            if (msAbs >= h) {
                return Math.round(ms / h) + "h";
            }
            if (msAbs >= m) {
                return Math.round(ms / m) + "m";
            }
            if (msAbs >= s) {
                return Math.round(ms / s) + "s";
            }
            return ms + "ms";
        }
        function fmtLong(ms) {
            var msAbs = Math.abs(ms);
            if (msAbs >= d) {
                return plural(ms, msAbs, d, "day");
            }
            if (msAbs >= h) {
                return plural(ms, msAbs, h, "hour");
            }
            if (msAbs >= m) {
                return plural(ms, msAbs, m, "minute");
            }
            if (msAbs >= s) {
                return plural(ms, msAbs, s, "second");
            }
            return ms + " ms";
        }
        function plural(ms, msAbs, n2, name) {
            var isPlural = msAbs >= n2 * 1.5;
            return Math.round(ms / n2) + " " + name + (isPlural ? "s" : "");
        }
    }
});
// node_modules/debug/src/common.js
var require_common = __commonJS({
    "node_modules/debug/src/common.js": function(exports2, module2) {
        function setup2(env3) {
            createDebug.debug = createDebug;
            createDebug.default = createDebug;
            createDebug.coerce = coerce;
            createDebug.disable = disable;
            createDebug.enable = enable;
            createDebug.enabled = enabled;
            createDebug.humanize = require_ms();
            createDebug.destroy = destroy;
            Object.keys(env3).forEach(function(key) {
                createDebug[key] = env3[key];
            });
            createDebug.names = [];
            createDebug.skips = [];
            createDebug.formatters = {};
            function selectColor(namespace) {
                var hash = 0;
                for(var i = 0; i < namespace.length; i++){
                    hash = (hash << 5) - hash + namespace.charCodeAt(i);
                    hash |= 0;
                }
                return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
            }
            createDebug.selectColor = selectColor;
            function createDebug(namespace) {
                var prevTime;
                var enableOverride = null;
                var namespacesCache;
                var enabledCache;
                function debug2() {
                    for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                        args[_key] = arguments[_key];
                    }
                    if (!debug2.enabled) {
                        return;
                    }
                    var self = debug2;
                    var curr = Number(/* @__PURE__ */ new Date());
                    var ms = curr - (prevTime || curr);
                    self.diff = ms;
                    self.prev = prevTime;
                    self.curr = curr;
                    prevTime = curr;
                    args[0] = createDebug.coerce(args[0]);
                    if (typeof args[0] !== "string") {
                        args.unshift("%O");
                    }
                    var index3 = 0;
                    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
                        if (match === "%%") {
                            return "%";
                        }
                        index3++;
                        var formatter = createDebug.formatters[format];
                        if (typeof formatter === "function") {
                            var val = args[index3];
                            match = formatter.call(self, val);
                            args.splice(index3, 1);
                            index3--;
                        }
                        return match;
                    });
                    createDebug.formatArgs.call(self, args);
                    var logFn = self.log || createDebug.log;
                    logFn.apply(self, args);
                }
                debug2.namespace = namespace;
                debug2.useColors = createDebug.useColors();
                debug2.color = createDebug.selectColor(namespace);
                debug2.extend = extend;
                debug2.destroy = createDebug.destroy;
                Object.defineProperty(debug2, "enabled", {
                    enumerable: true,
                    configurable: false,
                    get: function() {
                        if (enableOverride !== null) {
                            return enableOverride;
                        }
                        if (namespacesCache !== createDebug.namespaces) {
                            namespacesCache = createDebug.namespaces;
                            enabledCache = createDebug.enabled(namespace);
                        }
                        return enabledCache;
                    },
                    set: function(v) {
                        enableOverride = v;
                    }
                });
                if (typeof createDebug.init === "function") {
                    createDebug.init(debug2);
                }
                return debug2;
            }
            function extend(namespace, delimiter) {
                var newDebug = createDebug(this.namespace + (typeof delimiter === "undefined" ? ":" : delimiter) + namespace);
                newDebug.log = this.log;
                return newDebug;
            }
            function enable(namespaces) {
                createDebug.save(namespaces);
                createDebug.namespaces = namespaces;
                createDebug.names = [];
                createDebug.skips = [];
                var i;
                var split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
                var len = split.length;
                for(i = 0; i < len; i++){
                    if (!split[i]) {
                        continue;
                    }
                    namespaces = split[i].replace(/\*/g, ".*?");
                    if (namespaces[0] === "-") {
                        createDebug.skips.push(new RegExp("^" + namespaces.slice(1) + "$"));
                    } else {
                        createDebug.names.push(new RegExp("^" + namespaces + "$"));
                    }
                }
            }
            function disable() {
                var namespaces = _to_consumable_array(createDebug.names.map(toNamespace)).concat(_to_consumable_array(createDebug.skips.map(toNamespace).map(function(namespace) {
                    return "-" + namespace;
                }))).join(",");
                createDebug.enable("");
                return namespaces;
            }
            function enabled(name) {
                if (name[name.length - 1] === "*") {
                    return true;
                }
                var i;
                var len;
                for(i = 0, len = createDebug.skips.length; i < len; i++){
                    if (createDebug.skips[i].test(name)) {
                        return false;
                    }
                }
                for(i = 0, len = createDebug.names.length; i < len; i++){
                    if (createDebug.names[i].test(name)) {
                        return true;
                    }
                }
                return false;
            }
            function toNamespace(regexp) {
                return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, "*");
            }
            function coerce(val) {
                if (_instanceof(val, Error)) {
                    return val.stack || val.message;
                }
                return val;
            }
            function destroy() {
                console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
            }
            createDebug.enable(createDebug.load());
            return createDebug;
        }
        module2.exports = setup2;
    }
});
// node_modules/debug/src/browser.js
var require_browser = __commonJS({
    "node_modules/debug/src/browser.js": function(exports2, module2) {
        exports2.formatArgs = formatArgs;
        exports2.save = save;
        exports2.load = load;
        exports2.useColors = useColors;
        exports2.storage = localstorage();
        exports2.destroy = /* @__PURE__ */ function() {
            var warned = false;
            return function() {
                if (!warned) {
                    warned = true;
                    console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
                }
            };
        }();
        exports2.colors = [
            "#0000CC",
            "#0000FF",
            "#0033CC",
            "#0033FF",
            "#0066CC",
            "#0066FF",
            "#0099CC",
            "#0099FF",
            "#00CC00",
            "#00CC33",
            "#00CC66",
            "#00CC99",
            "#00CCCC",
            "#00CCFF",
            "#3300CC",
            "#3300FF",
            "#3333CC",
            "#3333FF",
            "#3366CC",
            "#3366FF",
            "#3399CC",
            "#3399FF",
            "#33CC00",
            "#33CC33",
            "#33CC66",
            "#33CC99",
            "#33CCCC",
            "#33CCFF",
            "#6600CC",
            "#6600FF",
            "#6633CC",
            "#6633FF",
            "#66CC00",
            "#66CC33",
            "#9900CC",
            "#9900FF",
            "#9933CC",
            "#9933FF",
            "#99CC00",
            "#99CC33",
            "#CC0000",
            "#CC0033",
            "#CC0066",
            "#CC0099",
            "#CC00CC",
            "#CC00FF",
            "#CC3300",
            "#CC3333",
            "#CC3366",
            "#CC3399",
            "#CC33CC",
            "#CC33FF",
            "#CC6600",
            "#CC6633",
            "#CC9900",
            "#CC9933",
            "#CCCC00",
            "#CCCC33",
            "#FF0000",
            "#FF0033",
            "#FF0066",
            "#FF0099",
            "#FF00CC",
            "#FF00FF",
            "#FF3300",
            "#FF3333",
            "#FF3366",
            "#FF3399",
            "#FF33CC",
            "#FF33FF",
            "#FF6600",
            "#FF6633",
            "#FF9900",
            "#FF9933",
            "#FFCC00",
            "#FFCC33"
        ];
        function useColors() {
            if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
                return true;
            }
            if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
                return false;
            }
            return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // Is firebug? http://stackoverflow.com/a/398120/376773
            typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || // Is firefox >= v31?
            // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
            typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // Double check webkit in userAgent just in case we are in a worker
            typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
        }
        function formatArgs(args) {
            args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module2.exports.humanize(this.diff);
            if (!this.useColors) {
                return;
            }
            var c = "color: " + this.color;
            args.splice(1, 0, c, "color: inherit");
            var index3 = 0;
            var lastC = 0;
            args[0].replace(/%[a-zA-Z%]/g, function(match) {
                if (match === "%%") {
                    return;
                }
                index3++;
                if (match === "%c") {
                    lastC = index3;
                }
            });
            args.splice(lastC, 0, c);
        }
        exports2.log = console.debug || console.log || function() {};
        function save(namespaces) {
            try {
                if (namespaces) {
                    exports2.storage.setItem("debug", namespaces);
                } else {
                    exports2.storage.removeItem("debug");
                }
            } catch (error) {}
        }
        function load() {
            var r;
            try {
                r = exports2.storage.getItem("debug");
            } catch (error) {}
            if (!r && typeof process !== "undefined" && "env" in process) {
                r = process.env.DEBUG;
            }
            return r;
        }
        function localstorage() {
            try {
                return localStorage;
            } catch (error) {}
        }
        module2.exports = require_common()(exports2);
        var formatters = module2.exports.formatters;
        formatters.j = function(v) {
            try {
                return JSON.stringify(v);
            } catch (error) {
                return "[UnexpectedJSONParseError]: " + error.message;
            }
        };
    }
});
// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
    "node_modules/has-flag/index.js": function(exports2, module2) {
        "use strict";
        module2.exports = function(flag) {
            var argv = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : process.argv;
            var prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
            var position = argv.indexOf(prefix2 + flag);
            var terminatorPosition = argv.indexOf("--");
            return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
        };
    }
});
// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
    "node_modules/supports-color/index.js": function(exports2, module2) {
        "use strict";
        var os3 = require("os");
        var tty3 = require("tty");
        var hasFlag3 = require_has_flag();
        var env3 = process.env;
        var forceColor;
        if (hasFlag3("no-color") || hasFlag3("no-colors") || hasFlag3("color=false") || hasFlag3("color=never")) {
            forceColor = 0;
        } else if (hasFlag3("color") || hasFlag3("colors") || hasFlag3("color=true") || hasFlag3("color=always")) {
            forceColor = 1;
        }
        if ("FORCE_COLOR" in env3) {
            if (env3.FORCE_COLOR === "true") {
                forceColor = 1;
            } else if (env3.FORCE_COLOR === "false") {
                forceColor = 0;
            } else {
                forceColor = env3.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env3.FORCE_COLOR, 10), 3);
            }
        }
        function translateLevel3(level) {
            if (level === 0) {
                return false;
            }
            return {
                level: level,
                hasBasic: true,
                has256: level >= 2,
                has16m: level >= 3
            };
        }
        function supportsColor3(haveStream, streamIsTTY) {
            if (forceColor === 0) {
                return 0;
            }
            if (hasFlag3("color=16m") || hasFlag3("color=full") || hasFlag3("color=truecolor")) {
                return 3;
            }
            if (hasFlag3("color=256")) {
                return 2;
            }
            if (haveStream && !streamIsTTY && forceColor === void 0) {
                return 0;
            }
            var min = forceColor || 0;
            if (env3.TERM === "dumb") {
                return min;
            }
            if (process.platform === "win32") {
                var osRelease = os3.release().split(".");
                if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
                    return Number(osRelease[2]) >= 14931 ? 3 : 2;
                }
                return 1;
            }
            if ("CI" in env3) {
                if ([
                    "TRAVIS",
                    "CIRCLECI",
                    "APPVEYOR",
                    "GITLAB_CI",
                    "GITHUB_ACTIONS",
                    "BUILDKITE"
                ].some(function(sign) {
                    return sign in env3;
                }) || env3.CI_NAME === "codeship") {
                    return 1;
                }
                return min;
            }
            if ("TEAMCITY_VERSION" in env3) {
                return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env3.TEAMCITY_VERSION) ? 1 : 0;
            }
            if (env3.COLORTERM === "truecolor") {
                return 3;
            }
            if ("TERM_PROGRAM" in env3) {
                var version = parseInt((env3.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
                switch(env3.TERM_PROGRAM){
                    case "iTerm.app":
                        return version >= 3 ? 3 : 2;
                    case "Apple_Terminal":
                        return 2;
                }
            }
            if (/-256(color)?$/i.test(env3.TERM)) {
                return 2;
            }
            if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env3.TERM)) {
                return 1;
            }
            if ("COLORTERM" in env3) {
                return 1;
            }
            return min;
        }
        function getSupportLevel(stream) {
            var level = supportsColor3(stream, stream && stream.isTTY);
            return translateLevel3(level);
        }
        module2.exports = {
            supportsColor: getSupportLevel,
            stdout: translateLevel3(supportsColor3(true, tty3.isatty(1))),
            stderr: translateLevel3(supportsColor3(true, tty3.isatty(2)))
        };
    }
});
// node_modules/debug/src/node.js
var require_node = __commonJS({
    "node_modules/debug/src/node.js": function(exports2, module2) {
        var tty3 = require("tty");
        var util = require("util");
        exports2.init = init;
        exports2.log = log;
        exports2.formatArgs = formatArgs;
        exports2.save = save;
        exports2.load = load;
        exports2.useColors = useColors;
        exports2.destroy = util.deprecate(function() {}, "Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
        exports2.colors = [
            6,
            2,
            3,
            4,
            5,
            1
        ];
        try {
            var supportsColor3 = require_supports_color();
            if (supportsColor3 && (supportsColor3.stderr || supportsColor3).level >= 2) {
                exports2.colors = [
                    20,
                    21,
                    26,
                    27,
                    32,
                    33,
                    38,
                    39,
                    40,
                    41,
                    42,
                    43,
                    44,
                    45,
                    56,
                    57,
                    62,
                    63,
                    68,
                    69,
                    74,
                    75,
                    76,
                    77,
                    78,
                    79,
                    80,
                    81,
                    92,
                    93,
                    98,
                    99,
                    112,
                    113,
                    128,
                    129,
                    134,
                    135,
                    148,
                    149,
                    160,
                    161,
                    162,
                    163,
                    164,
                    165,
                    166,
                    167,
                    168,
                    169,
                    170,
                    171,
                    172,
                    173,
                    178,
                    179,
                    184,
                    185,
                    196,
                    197,
                    198,
                    199,
                    200,
                    201,
                    202,
                    203,
                    204,
                    205,
                    206,
                    207,
                    208,
                    209,
                    214,
                    215,
                    220,
                    221
                ];
            }
        } catch (error) {}
        exports2.inspectOpts = Object.keys(process.env).filter(function(key) {
            return /^debug_/i.test(key);
        }).reduce(function(obj, key) {
            var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, function(_, k) {
                return k.toUpperCase();
            });
            var val = process.env[key];
            if (/^(yes|on|true|enabled)$/i.test(val)) {
                val = true;
            } else if (/^(no|off|false|disabled)$/i.test(val)) {
                val = false;
            } else if (val === "null") {
                val = null;
            } else {
                val = Number(val);
            }
            obj[prop] = val;
            return obj;
        }, {});
        function useColors() {
            return "colors" in exports2.inspectOpts ? Boolean(exports2.inspectOpts.colors) : tty3.isatty(process.stderr.fd);
        }
        function formatArgs(args) {
            var _this = this, name = _this.namespace, useColors2 = _this.useColors;
            if (useColors2) {
                var c = this.color;
                var colorCode = "\x1b[3" + (c < 8 ? c : "8;5;" + c);
                var prefix2 = "  ".concat(colorCode, ";1m").concat(name, " \x1b[0m");
                args[0] = prefix2 + args[0].split("\n").join("\n" + prefix2);
                args.push(colorCode + "m+" + module2.exports.humanize(this.diff) + "\x1b[0m");
            } else {
                args[0] = getDate() + name + " " + args[0];
            }
        }
        function getDate() {
            if (exports2.inspectOpts.hideDate) {
                return "";
            }
            return /* @__PURE__ */ new Date().toISOString() + " ";
        }
        function log() {
            for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                args[_key] = arguments[_key];
            }
            var _util;
            return process.stderr.write((_util = util).format.apply(_util, _to_consumable_array(args)) + "\n");
        }
        function save(namespaces) {
            if (namespaces) {
                process.env.DEBUG = namespaces;
            } else {
                delete process.env.DEBUG;
            }
        }
        function load() {
            return process.env.DEBUG;
        }
        function init(debug2) {
            debug2.inspectOpts = {};
            var keys = Object.keys(exports2.inspectOpts);
            for(var i = 0; i < keys.length; i++){
                debug2.inspectOpts[keys[i]] = exports2.inspectOpts[keys[i]];
            }
        }
        module2.exports = require_common()(exports2);
        var formatters = module2.exports.formatters;
        formatters.o = function(v) {
            this.inspectOpts.colors = this.useColors;
            return util.inspect(v, this.inspectOpts).split("\n").map(function(str) {
                return str.trim();
            }).join(" ");
        };
        formatters.O = function(v) {
            this.inspectOpts.colors = this.useColors;
            return util.inspect(v, this.inspectOpts);
        };
    }
});
// node_modules/debug/src/index.js
var require_src = __commonJS({
    "node_modules/debug/src/index.js": function(exports2, module2) {
        if (typeof process === "undefined" || process.type === "renderer" || process.browser === true || process.__nwjs) {
            module2.exports = require_browser();
        } else {
            module2.exports = require_node();
        }
    }
});
// node_modules/globals/globals.json
var require_globals = __commonJS({
    "node_modules/globals/globals.json": function(exports2, module2) {
        module2.exports = {
            builtin: {
                AggregateError: false,
                Array: false,
                ArrayBuffer: false,
                Atomics: false,
                BigInt: false,
                BigInt64Array: false,
                BigUint64Array: false,
                Boolean: false,
                constructor: false,
                DataView: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                FinalizationRegistry: false,
                Float32Array: false,
                Float64Array: false,
                Function: false,
                globalThis: false,
                hasOwnProperty: false,
                Infinity: false,
                Int16Array: false,
                Int32Array: false,
                Int8Array: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Map: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                Promise: false,
                propertyIsEnumerable: false,
                Proxy: false,
                RangeError: false,
                ReferenceError: false,
                Reflect: false,
                RegExp: false,
                Set: false,
                SharedArrayBuffer: false,
                String: false,
                Symbol: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                Uint16Array: false,
                Uint32Array: false,
                Uint8Array: false,
                Uint8ClampedArray: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false,
                WeakMap: false,
                WeakRef: false,
                WeakSet: false
            },
            es5: {
                Array: false,
                Boolean: false,
                constructor: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                Function: false,
                hasOwnProperty: false,
                Infinity: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                propertyIsEnumerable: false,
                RangeError: false,
                ReferenceError: false,
                RegExp: false,
                String: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false
            },
            es2015: {
                Array: false,
                ArrayBuffer: false,
                Boolean: false,
                constructor: false,
                DataView: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                Float32Array: false,
                Float64Array: false,
                Function: false,
                hasOwnProperty: false,
                Infinity: false,
                Int16Array: false,
                Int32Array: false,
                Int8Array: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Map: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                Promise: false,
                propertyIsEnumerable: false,
                Proxy: false,
                RangeError: false,
                ReferenceError: false,
                Reflect: false,
                RegExp: false,
                Set: false,
                String: false,
                Symbol: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                Uint16Array: false,
                Uint32Array: false,
                Uint8Array: false,
                Uint8ClampedArray: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false,
                WeakMap: false,
                WeakSet: false
            },
            es2017: {
                Array: false,
                ArrayBuffer: false,
                Atomics: false,
                Boolean: false,
                constructor: false,
                DataView: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                Float32Array: false,
                Float64Array: false,
                Function: false,
                hasOwnProperty: false,
                Infinity: false,
                Int16Array: false,
                Int32Array: false,
                Int8Array: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Map: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                Promise: false,
                propertyIsEnumerable: false,
                Proxy: false,
                RangeError: false,
                ReferenceError: false,
                Reflect: false,
                RegExp: false,
                Set: false,
                SharedArrayBuffer: false,
                String: false,
                Symbol: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                Uint16Array: false,
                Uint32Array: false,
                Uint8Array: false,
                Uint8ClampedArray: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false,
                WeakMap: false,
                WeakSet: false
            },
            es2020: {
                Array: false,
                ArrayBuffer: false,
                Atomics: false,
                BigInt: false,
                BigInt64Array: false,
                BigUint64Array: false,
                Boolean: false,
                constructor: false,
                DataView: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                Float32Array: false,
                Float64Array: false,
                Function: false,
                globalThis: false,
                hasOwnProperty: false,
                Infinity: false,
                Int16Array: false,
                Int32Array: false,
                Int8Array: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Map: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                Promise: false,
                propertyIsEnumerable: false,
                Proxy: false,
                RangeError: false,
                ReferenceError: false,
                Reflect: false,
                RegExp: false,
                Set: false,
                SharedArrayBuffer: false,
                String: false,
                Symbol: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                Uint16Array: false,
                Uint32Array: false,
                Uint8Array: false,
                Uint8ClampedArray: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false,
                WeakMap: false,
                WeakSet: false
            },
            es2021: {
                AggregateError: false,
                Array: false,
                ArrayBuffer: false,
                Atomics: false,
                BigInt: false,
                BigInt64Array: false,
                BigUint64Array: false,
                Boolean: false,
                constructor: false,
                DataView: false,
                Date: false,
                decodeURI: false,
                decodeURIComponent: false,
                encodeURI: false,
                encodeURIComponent: false,
                Error: false,
                escape: false,
                eval: false,
                EvalError: false,
                FinalizationRegistry: false,
                Float32Array: false,
                Float64Array: false,
                Function: false,
                globalThis: false,
                hasOwnProperty: false,
                Infinity: false,
                Int16Array: false,
                Int32Array: false,
                Int8Array: false,
                isFinite: false,
                isNaN: false,
                isPrototypeOf: false,
                JSON: false,
                Map: false,
                Math: false,
                NaN: false,
                Number: false,
                Object: false,
                parseFloat: false,
                parseInt: false,
                Promise: false,
                propertyIsEnumerable: false,
                Proxy: false,
                RangeError: false,
                ReferenceError: false,
                Reflect: false,
                RegExp: false,
                Set: false,
                SharedArrayBuffer: false,
                String: false,
                Symbol: false,
                SyntaxError: false,
                toLocaleString: false,
                toString: false,
                TypeError: false,
                Uint16Array: false,
                Uint32Array: false,
                Uint8Array: false,
                Uint8ClampedArray: false,
                undefined: false,
                unescape: false,
                URIError: false,
                valueOf: false,
                WeakMap: false,
                WeakRef: false,
                WeakSet: false
            },
            browser: {
                AbortController: false,
                AbortSignal: false,
                addEventListener: false,
                alert: false,
                AnalyserNode: false,
                Animation: false,
                AnimationEffectReadOnly: false,
                AnimationEffectTiming: false,
                AnimationEffectTimingReadOnly: false,
                AnimationEvent: false,
                AnimationPlaybackEvent: false,
                AnimationTimeline: false,
                applicationCache: false,
                ApplicationCache: false,
                ApplicationCacheErrorEvent: false,
                atob: false,
                Attr: false,
                Audio: false,
                AudioBuffer: false,
                AudioBufferSourceNode: false,
                AudioContext: false,
                AudioDestinationNode: false,
                AudioListener: false,
                AudioNode: false,
                AudioParam: false,
                AudioProcessingEvent: false,
                AudioScheduledSourceNode: false,
                AudioWorkletGlobalScope: false,
                AudioWorkletNode: false,
                AudioWorkletProcessor: false,
                BarProp: false,
                BaseAudioContext: false,
                BatteryManager: false,
                BeforeUnloadEvent: false,
                BiquadFilterNode: false,
                Blob: false,
                BlobEvent: false,
                blur: false,
                BroadcastChannel: false,
                btoa: false,
                BudgetService: false,
                ByteLengthQueuingStrategy: false,
                Cache: false,
                caches: false,
                CacheStorage: false,
                cancelAnimationFrame: false,
                cancelIdleCallback: false,
                CanvasCaptureMediaStreamTrack: false,
                CanvasGradient: false,
                CanvasPattern: false,
                CanvasRenderingContext2D: false,
                ChannelMergerNode: false,
                ChannelSplitterNode: false,
                CharacterData: false,
                clearInterval: false,
                clearTimeout: false,
                clientInformation: false,
                ClipboardEvent: false,
                ClipboardItem: false,
                close: false,
                closed: false,
                CloseEvent: false,
                Comment: false,
                CompositionEvent: false,
                CompressionStream: false,
                confirm: false,
                console: false,
                ConstantSourceNode: false,
                ConvolverNode: false,
                CountQueuingStrategy: false,
                createImageBitmap: false,
                Credential: false,
                CredentialsContainer: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CSS: false,
                CSSConditionRule: false,
                CSSFontFaceRule: false,
                CSSGroupingRule: false,
                CSSImportRule: false,
                CSSKeyframeRule: false,
                CSSKeyframesRule: false,
                CSSMatrixComponent: false,
                CSSMediaRule: false,
                CSSNamespaceRule: false,
                CSSPageRule: false,
                CSSPerspective: false,
                CSSRotate: false,
                CSSRule: false,
                CSSRuleList: false,
                CSSScale: false,
                CSSSkew: false,
                CSSSkewX: false,
                CSSSkewY: false,
                CSSStyleDeclaration: false,
                CSSStyleRule: false,
                CSSStyleSheet: false,
                CSSSupportsRule: false,
                CSSTransformValue: false,
                CSSTranslate: false,
                CustomElementRegistry: false,
                customElements: false,
                CustomEvent: false,
                DataTransfer: false,
                DataTransferItem: false,
                DataTransferItemList: false,
                DecompressionStream: false,
                defaultstatus: false,
                defaultStatus: false,
                DelayNode: false,
                DeviceMotionEvent: false,
                DeviceOrientationEvent: false,
                devicePixelRatio: false,
                dispatchEvent: false,
                document: false,
                Document: false,
                DocumentFragment: false,
                DocumentType: false,
                DOMError: false,
                DOMException: false,
                DOMImplementation: false,
                DOMMatrix: false,
                DOMMatrixReadOnly: false,
                DOMParser: false,
                DOMPoint: false,
                DOMPointReadOnly: false,
                DOMQuad: false,
                DOMRect: false,
                DOMRectList: false,
                DOMRectReadOnly: false,
                DOMStringList: false,
                DOMStringMap: false,
                DOMTokenList: false,
                DragEvent: false,
                DynamicsCompressorNode: false,
                Element: false,
                ErrorEvent: false,
                event: false,
                Event: false,
                EventSource: false,
                EventTarget: false,
                external: false,
                fetch: false,
                File: false,
                FileList: false,
                FileReader: false,
                find: false,
                focus: false,
                FocusEvent: false,
                FontFace: false,
                FontFaceSetLoadEvent: false,
                FormData: false,
                FormDataEvent: false,
                frameElement: false,
                frames: false,
                GainNode: false,
                Gamepad: false,
                GamepadButton: false,
                GamepadEvent: false,
                getComputedStyle: false,
                getSelection: false,
                HashChangeEvent: false,
                Headers: false,
                history: false,
                History: false,
                HTMLAllCollection: false,
                HTMLAnchorElement: false,
                HTMLAreaElement: false,
                HTMLAudioElement: false,
                HTMLBaseElement: false,
                HTMLBodyElement: false,
                HTMLBRElement: false,
                HTMLButtonElement: false,
                HTMLCanvasElement: false,
                HTMLCollection: false,
                HTMLContentElement: false,
                HTMLDataElement: false,
                HTMLDataListElement: false,
                HTMLDetailsElement: false,
                HTMLDialogElement: false,
                HTMLDirectoryElement: false,
                HTMLDivElement: false,
                HTMLDListElement: false,
                HTMLDocument: false,
                HTMLElement: false,
                HTMLEmbedElement: false,
                HTMLFieldSetElement: false,
                HTMLFontElement: false,
                HTMLFormControlsCollection: false,
                HTMLFormElement: false,
                HTMLFrameElement: false,
                HTMLFrameSetElement: false,
                HTMLHeadElement: false,
                HTMLHeadingElement: false,
                HTMLHRElement: false,
                HTMLHtmlElement: false,
                HTMLIFrameElement: false,
                HTMLImageElement: false,
                HTMLInputElement: false,
                HTMLLabelElement: false,
                HTMLLegendElement: false,
                HTMLLIElement: false,
                HTMLLinkElement: false,
                HTMLMapElement: false,
                HTMLMarqueeElement: false,
                HTMLMediaElement: false,
                HTMLMenuElement: false,
                HTMLMetaElement: false,
                HTMLMeterElement: false,
                HTMLModElement: false,
                HTMLObjectElement: false,
                HTMLOListElement: false,
                HTMLOptGroupElement: false,
                HTMLOptionElement: false,
                HTMLOptionsCollection: false,
                HTMLOutputElement: false,
                HTMLParagraphElement: false,
                HTMLParamElement: false,
                HTMLPictureElement: false,
                HTMLPreElement: false,
                HTMLProgressElement: false,
                HTMLQuoteElement: false,
                HTMLScriptElement: false,
                HTMLSelectElement: false,
                HTMLShadowElement: false,
                HTMLSlotElement: false,
                HTMLSourceElement: false,
                HTMLSpanElement: false,
                HTMLStyleElement: false,
                HTMLTableCaptionElement: false,
                HTMLTableCellElement: false,
                HTMLTableColElement: false,
                HTMLTableElement: false,
                HTMLTableRowElement: false,
                HTMLTableSectionElement: false,
                HTMLTemplateElement: false,
                HTMLTextAreaElement: false,
                HTMLTimeElement: false,
                HTMLTitleElement: false,
                HTMLTrackElement: false,
                HTMLUListElement: false,
                HTMLUnknownElement: false,
                HTMLVideoElement: false,
                IDBCursor: false,
                IDBCursorWithValue: false,
                IDBDatabase: false,
                IDBFactory: false,
                IDBIndex: false,
                IDBKeyRange: false,
                IDBObjectStore: false,
                IDBOpenDBRequest: false,
                IDBRequest: false,
                IDBTransaction: false,
                IDBVersionChangeEvent: false,
                IdleDeadline: false,
                IIRFilterNode: false,
                Image: false,
                ImageBitmap: false,
                ImageBitmapRenderingContext: false,
                ImageCapture: false,
                ImageData: false,
                indexedDB: false,
                innerHeight: false,
                innerWidth: false,
                InputEvent: false,
                IntersectionObserver: false,
                IntersectionObserverEntry: false,
                Intl: false,
                isSecureContext: false,
                KeyboardEvent: false,
                KeyframeEffect: false,
                KeyframeEffectReadOnly: false,
                length: false,
                localStorage: false,
                location: true,
                Location: false,
                locationbar: false,
                matchMedia: false,
                MediaDeviceInfo: false,
                MediaDevices: false,
                MediaElementAudioSourceNode: false,
                MediaEncryptedEvent: false,
                MediaError: false,
                MediaKeyMessageEvent: false,
                MediaKeySession: false,
                MediaKeyStatusMap: false,
                MediaKeySystemAccess: false,
                MediaList: false,
                MediaMetadata: false,
                MediaQueryList: false,
                MediaQueryListEvent: false,
                MediaRecorder: false,
                MediaSettingsRange: false,
                MediaSource: false,
                MediaStream: false,
                MediaStreamAudioDestinationNode: false,
                MediaStreamAudioSourceNode: false,
                MediaStreamConstraints: false,
                MediaStreamEvent: false,
                MediaStreamTrack: false,
                MediaStreamTrackEvent: false,
                menubar: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                MIDIAccess: false,
                MIDIConnectionEvent: false,
                MIDIInput: false,
                MIDIInputMap: false,
                MIDIMessageEvent: false,
                MIDIOutput: false,
                MIDIOutputMap: false,
                MIDIPort: false,
                MimeType: false,
                MimeTypeArray: false,
                MouseEvent: false,
                moveBy: false,
                moveTo: false,
                MutationEvent: false,
                MutationObserver: false,
                MutationRecord: false,
                name: false,
                NamedNodeMap: false,
                NavigationPreloadManager: false,
                navigator: false,
                Navigator: false,
                NavigatorUAData: false,
                NetworkInformation: false,
                Node: false,
                NodeFilter: false,
                NodeIterator: false,
                NodeList: false,
                Notification: false,
                OfflineAudioCompletionEvent: false,
                OfflineAudioContext: false,
                offscreenBuffering: false,
                OffscreenCanvas: true,
                OffscreenCanvasRenderingContext2D: false,
                onabort: true,
                onafterprint: true,
                onanimationend: true,
                onanimationiteration: true,
                onanimationstart: true,
                onappinstalled: true,
                onauxclick: true,
                onbeforeinstallprompt: true,
                onbeforeprint: true,
                onbeforeunload: true,
                onblur: true,
                oncancel: true,
                oncanplay: true,
                oncanplaythrough: true,
                onchange: true,
                onclick: true,
                onclose: true,
                oncontextmenu: true,
                oncuechange: true,
                ondblclick: true,
                ondevicemotion: true,
                ondeviceorientation: true,
                ondeviceorientationabsolute: true,
                ondrag: true,
                ondragend: true,
                ondragenter: true,
                ondragleave: true,
                ondragover: true,
                ondragstart: true,
                ondrop: true,
                ondurationchange: true,
                onemptied: true,
                onended: true,
                onerror: true,
                onfocus: true,
                ongotpointercapture: true,
                onhashchange: true,
                oninput: true,
                oninvalid: true,
                onkeydown: true,
                onkeypress: true,
                onkeyup: true,
                onlanguagechange: true,
                onload: true,
                onloadeddata: true,
                onloadedmetadata: true,
                onloadstart: true,
                onlostpointercapture: true,
                onmessage: true,
                onmessageerror: true,
                onmousedown: true,
                onmouseenter: true,
                onmouseleave: true,
                onmousemove: true,
                onmouseout: true,
                onmouseover: true,
                onmouseup: true,
                onmousewheel: true,
                onoffline: true,
                ononline: true,
                onpagehide: true,
                onpageshow: true,
                onpause: true,
                onplay: true,
                onplaying: true,
                onpointercancel: true,
                onpointerdown: true,
                onpointerenter: true,
                onpointerleave: true,
                onpointermove: true,
                onpointerout: true,
                onpointerover: true,
                onpointerup: true,
                onpopstate: true,
                onprogress: true,
                onratechange: true,
                onrejectionhandled: true,
                onreset: true,
                onresize: true,
                onscroll: true,
                onsearch: true,
                onseeked: true,
                onseeking: true,
                onselect: true,
                onstalled: true,
                onstorage: true,
                onsubmit: true,
                onsuspend: true,
                ontimeupdate: true,
                ontoggle: true,
                ontransitionend: true,
                onunhandledrejection: true,
                onunload: true,
                onvolumechange: true,
                onwaiting: true,
                onwheel: true,
                open: false,
                openDatabase: false,
                opener: false,
                Option: false,
                origin: false,
                OscillatorNode: false,
                outerHeight: false,
                outerWidth: false,
                OverconstrainedError: false,
                PageTransitionEvent: false,
                pageXOffset: false,
                pageYOffset: false,
                PannerNode: false,
                parent: false,
                Path2D: false,
                PaymentAddress: false,
                PaymentRequest: false,
                PaymentRequestUpdateEvent: false,
                PaymentResponse: false,
                performance: false,
                Performance: false,
                PerformanceEntry: false,
                PerformanceLongTaskTiming: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceNavigation: false,
                PerformanceNavigationTiming: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformancePaintTiming: false,
                PerformanceResourceTiming: false,
                PerformanceTiming: false,
                PeriodicWave: false,
                Permissions: false,
                PermissionStatus: false,
                personalbar: false,
                PhotoCapabilities: false,
                Plugin: false,
                PluginArray: false,
                PointerEvent: false,
                PopStateEvent: false,
                postMessage: false,
                Presentation: false,
                PresentationAvailability: false,
                PresentationConnection: false,
                PresentationConnectionAvailableEvent: false,
                PresentationConnectionCloseEvent: false,
                PresentationConnectionList: false,
                PresentationReceiver: false,
                PresentationRequest: false,
                print: false,
                ProcessingInstruction: false,
                ProgressEvent: false,
                PromiseRejectionEvent: false,
                prompt: false,
                PushManager: false,
                PushSubscription: false,
                PushSubscriptionOptions: false,
                queueMicrotask: false,
                RadioNodeList: false,
                Range: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                registerProcessor: false,
                RemotePlayback: false,
                removeEventListener: false,
                reportError: false,
                Request: false,
                requestAnimationFrame: false,
                requestIdleCallback: false,
                resizeBy: false,
                ResizeObserver: false,
                ResizeObserverEntry: false,
                resizeTo: false,
                Response: false,
                RTCCertificate: false,
                RTCDataChannel: false,
                RTCDataChannelEvent: false,
                RTCDtlsTransport: false,
                RTCIceCandidate: false,
                RTCIceGatherer: false,
                RTCIceTransport: false,
                RTCPeerConnection: false,
                RTCPeerConnectionIceEvent: false,
                RTCRtpContributingSource: false,
                RTCRtpReceiver: false,
                RTCRtpSender: false,
                RTCSctpTransport: false,
                RTCSessionDescription: false,
                RTCStatsReport: false,
                RTCTrackEvent: false,
                screen: false,
                Screen: false,
                screenLeft: false,
                ScreenOrientation: false,
                screenTop: false,
                screenX: false,
                screenY: false,
                ScriptProcessorNode: false,
                scroll: false,
                scrollbars: false,
                scrollBy: false,
                scrollTo: false,
                scrollX: false,
                scrollY: false,
                SecurityPolicyViolationEvent: false,
                Selection: false,
                self: false,
                ServiceWorker: false,
                ServiceWorkerContainer: false,
                ServiceWorkerRegistration: false,
                sessionStorage: false,
                setInterval: false,
                setTimeout: false,
                ShadowRoot: false,
                SharedWorker: false,
                SourceBuffer: false,
                SourceBufferList: false,
                speechSynthesis: false,
                SpeechSynthesisEvent: false,
                SpeechSynthesisUtterance: false,
                StaticRange: false,
                status: false,
                statusbar: false,
                StereoPannerNode: false,
                stop: false,
                Storage: false,
                StorageEvent: false,
                StorageManager: false,
                structuredClone: false,
                styleMedia: false,
                StyleSheet: false,
                StyleSheetList: false,
                SubmitEvent: false,
                SubtleCrypto: false,
                SVGAElement: false,
                SVGAngle: false,
                SVGAnimatedAngle: false,
                SVGAnimatedBoolean: false,
                SVGAnimatedEnumeration: false,
                SVGAnimatedInteger: false,
                SVGAnimatedLength: false,
                SVGAnimatedLengthList: false,
                SVGAnimatedNumber: false,
                SVGAnimatedNumberList: false,
                SVGAnimatedPreserveAspectRatio: false,
                SVGAnimatedRect: false,
                SVGAnimatedString: false,
                SVGAnimatedTransformList: false,
                SVGAnimateElement: false,
                SVGAnimateMotionElement: false,
                SVGAnimateTransformElement: false,
                SVGAnimationElement: false,
                SVGCircleElement: false,
                SVGClipPathElement: false,
                SVGComponentTransferFunctionElement: false,
                SVGDefsElement: false,
                SVGDescElement: false,
                SVGDiscardElement: false,
                SVGElement: false,
                SVGEllipseElement: false,
                SVGFEBlendElement: false,
                SVGFEColorMatrixElement: false,
                SVGFEComponentTransferElement: false,
                SVGFECompositeElement: false,
                SVGFEConvolveMatrixElement: false,
                SVGFEDiffuseLightingElement: false,
                SVGFEDisplacementMapElement: false,
                SVGFEDistantLightElement: false,
                SVGFEDropShadowElement: false,
                SVGFEFloodElement: false,
                SVGFEFuncAElement: false,
                SVGFEFuncBElement: false,
                SVGFEFuncGElement: false,
                SVGFEFuncRElement: false,
                SVGFEGaussianBlurElement: false,
                SVGFEImageElement: false,
                SVGFEMergeElement: false,
                SVGFEMergeNodeElement: false,
                SVGFEMorphologyElement: false,
                SVGFEOffsetElement: false,
                SVGFEPointLightElement: false,
                SVGFESpecularLightingElement: false,
                SVGFESpotLightElement: false,
                SVGFETileElement: false,
                SVGFETurbulenceElement: false,
                SVGFilterElement: false,
                SVGForeignObjectElement: false,
                SVGGElement: false,
                SVGGeometryElement: false,
                SVGGradientElement: false,
                SVGGraphicsElement: false,
                SVGImageElement: false,
                SVGLength: false,
                SVGLengthList: false,
                SVGLinearGradientElement: false,
                SVGLineElement: false,
                SVGMarkerElement: false,
                SVGMaskElement: false,
                SVGMatrix: false,
                SVGMetadataElement: false,
                SVGMPathElement: false,
                SVGNumber: false,
                SVGNumberList: false,
                SVGPathElement: false,
                SVGPatternElement: false,
                SVGPoint: false,
                SVGPointList: false,
                SVGPolygonElement: false,
                SVGPolylineElement: false,
                SVGPreserveAspectRatio: false,
                SVGRadialGradientElement: false,
                SVGRect: false,
                SVGRectElement: false,
                SVGScriptElement: false,
                SVGSetElement: false,
                SVGStopElement: false,
                SVGStringList: false,
                SVGStyleElement: false,
                SVGSVGElement: false,
                SVGSwitchElement: false,
                SVGSymbolElement: false,
                SVGTextContentElement: false,
                SVGTextElement: false,
                SVGTextPathElement: false,
                SVGTextPositioningElement: false,
                SVGTitleElement: false,
                SVGTransform: false,
                SVGTransformList: false,
                SVGTSpanElement: false,
                SVGUnitTypes: false,
                SVGUseElement: false,
                SVGViewElement: false,
                TaskAttributionTiming: false,
                Text: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TextEvent: false,
                TextMetrics: false,
                TextTrack: false,
                TextTrackCue: false,
                TextTrackCueList: false,
                TextTrackList: false,
                TimeRanges: false,
                ToggleEvent: false,
                toolbar: false,
                top: false,
                Touch: false,
                TouchEvent: false,
                TouchList: false,
                TrackEvent: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                TransitionEvent: false,
                TreeWalker: false,
                UIEvent: false,
                URL: false,
                URLSearchParams: false,
                ValidityState: false,
                visualViewport: false,
                VisualViewport: false,
                VTTCue: false,
                WaveShaperNode: false,
                WebAssembly: false,
                WebGL2RenderingContext: false,
                WebGLActiveInfo: false,
                WebGLBuffer: false,
                WebGLContextEvent: false,
                WebGLFramebuffer: false,
                WebGLProgram: false,
                WebGLQuery: false,
                WebGLRenderbuffer: false,
                WebGLRenderingContext: false,
                WebGLSampler: false,
                WebGLShader: false,
                WebGLShaderPrecisionFormat: false,
                WebGLSync: false,
                WebGLTexture: false,
                WebGLTransformFeedback: false,
                WebGLUniformLocation: false,
                WebGLVertexArrayObject: false,
                WebSocket: false,
                WheelEvent: false,
                window: false,
                Window: false,
                Worker: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false,
                XMLDocument: false,
                XMLHttpRequest: false,
                XMLHttpRequestEventTarget: false,
                XMLHttpRequestUpload: false,
                XMLSerializer: false,
                XPathEvaluator: false,
                XPathExpression: false,
                XPathResult: false,
                XRAnchor: false,
                XRBoundedReferenceSpace: false,
                XRCPUDepthInformation: false,
                XRDepthInformation: false,
                XRFrame: false,
                XRInputSource: false,
                XRInputSourceArray: false,
                XRInputSourceEvent: false,
                XRInputSourcesChangeEvent: false,
                XRPose: false,
                XRReferenceSpace: false,
                XRReferenceSpaceEvent: false,
                XRRenderState: false,
                XRRigidTransform: false,
                XRSession: false,
                XRSessionEvent: false,
                XRSpace: false,
                XRSystem: false,
                XRView: false,
                XRViewerPose: false,
                XRViewport: false,
                XRWebGLBinding: false,
                XRWebGLDepthInformation: false,
                XRWebGLLayer: false,
                XSLTProcessor: false
            },
            worker: {
                addEventListener: false,
                applicationCache: false,
                atob: false,
                Blob: false,
                BroadcastChannel: false,
                btoa: false,
                ByteLengthQueuingStrategy: false,
                Cache: false,
                caches: false,
                clearInterval: false,
                clearTimeout: false,
                close: true,
                CompressionStream: false,
                console: false,
                CountQueuingStrategy: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CustomEvent: false,
                DecompressionStream: false,
                ErrorEvent: false,
                Event: false,
                fetch: false,
                File: false,
                FileReaderSync: false,
                FormData: false,
                Headers: false,
                IDBCursor: false,
                IDBCursorWithValue: false,
                IDBDatabase: false,
                IDBFactory: false,
                IDBIndex: false,
                IDBKeyRange: false,
                IDBObjectStore: false,
                IDBOpenDBRequest: false,
                IDBRequest: false,
                IDBTransaction: false,
                IDBVersionChangeEvent: false,
                ImageData: false,
                importScripts: true,
                indexedDB: false,
                location: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                name: false,
                navigator: false,
                Notification: false,
                onclose: true,
                onconnect: true,
                onerror: true,
                onlanguagechange: true,
                onmessage: true,
                onoffline: true,
                ononline: true,
                onrejectionhandled: true,
                onunhandledrejection: true,
                performance: false,
                Performance: false,
                PerformanceEntry: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceNavigation: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformanceResourceTiming: false,
                PerformanceTiming: false,
                postMessage: true,
                Promise: false,
                queueMicrotask: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                removeEventListener: false,
                reportError: false,
                Request: false,
                Response: false,
                self: true,
                ServiceWorkerRegistration: false,
                setInterval: false,
                setTimeout: false,
                SubtleCrypto: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                URL: false,
                URLSearchParams: false,
                WebAssembly: false,
                WebSocket: false,
                Worker: false,
                WorkerGlobalScope: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false,
                XMLHttpRequest: false
            },
            node: {
                __dirname: false,
                __filename: false,
                AbortController: false,
                AbortSignal: false,
                atob: false,
                Blob: false,
                BroadcastChannel: false,
                btoa: false,
                Buffer: false,
                ByteLengthQueuingStrategy: false,
                clearImmediate: false,
                clearInterval: false,
                clearTimeout: false,
                CompressionStream: false,
                console: false,
                CountQueuingStrategy: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CustomEvent: false,
                DecompressionStream: false,
                DOMException: false,
                Event: false,
                EventTarget: false,
                exports: true,
                fetch: false,
                File: false,
                FormData: false,
                global: false,
                Headers: false,
                Intl: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                module: false,
                performance: false,
                PerformanceEntry: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformanceResourceTiming: false,
                process: false,
                queueMicrotask: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                Request: false,
                require: false,
                Response: false,
                setImmediate: false,
                setInterval: false,
                setTimeout: false,
                structuredClone: false,
                SubtleCrypto: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                URL: false,
                URLSearchParams: false,
                WebAssembly: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false
            },
            nodeBuiltin: {
                AbortController: false,
                AbortSignal: false,
                atob: false,
                Blob: false,
                BroadcastChannel: false,
                btoa: false,
                Buffer: false,
                ByteLengthQueuingStrategy: false,
                clearImmediate: false,
                clearInterval: false,
                clearTimeout: false,
                CompressionStream: false,
                console: false,
                CountQueuingStrategy: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CustomEvent: false,
                DecompressionStream: false,
                DOMException: false,
                Event: false,
                EventTarget: false,
                fetch: false,
                File: false,
                FormData: false,
                global: false,
                Headers: false,
                Intl: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                performance: false,
                PerformanceEntry: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformanceResourceTiming: false,
                process: false,
                queueMicrotask: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                Request: false,
                Response: false,
                setImmediate: false,
                setInterval: false,
                setTimeout: false,
                structuredClone: false,
                SubtleCrypto: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                URL: false,
                URLSearchParams: false,
                WebAssembly: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false
            },
            commonjs: {
                exports: true,
                global: false,
                module: false,
                require: false
            },
            amd: {
                define: false,
                require: false
            },
            mocha: {
                after: false,
                afterEach: false,
                before: false,
                beforeEach: false,
                context: false,
                describe: false,
                it: false,
                mocha: false,
                run: false,
                setup: false,
                specify: false,
                suite: false,
                suiteSetup: false,
                suiteTeardown: false,
                teardown: false,
                test: false,
                xcontext: false,
                xdescribe: false,
                xit: false,
                xspecify: false
            },
            jasmine: {
                afterAll: false,
                afterEach: false,
                beforeAll: false,
                beforeEach: false,
                describe: false,
                expect: false,
                expectAsync: false,
                fail: false,
                fdescribe: false,
                fit: false,
                it: false,
                jasmine: false,
                pending: false,
                runs: false,
                spyOn: false,
                spyOnAllFunctions: false,
                spyOnProperty: false,
                waits: false,
                waitsFor: false,
                xdescribe: false,
                xit: false
            },
            jest: {
                afterAll: false,
                afterEach: false,
                beforeAll: false,
                beforeEach: false,
                describe: false,
                expect: false,
                fdescribe: false,
                fit: false,
                it: false,
                jest: false,
                pit: false,
                require: false,
                test: false,
                xdescribe: false,
                xit: false,
                xtest: false
            },
            qunit: {
                asyncTest: false,
                deepEqual: false,
                equal: false,
                expect: false,
                module: false,
                notDeepEqual: false,
                notEqual: false,
                notOk: false,
                notPropEqual: false,
                notStrictEqual: false,
                ok: false,
                propEqual: false,
                QUnit: false,
                raises: false,
                start: false,
                stop: false,
                strictEqual: false,
                test: false,
                throws: false
            },
            phantomjs: {
                console: true,
                exports: true,
                phantom: true,
                require: true,
                WebPage: true
            },
            couch: {
                emit: false,
                exports: false,
                getRow: false,
                log: false,
                module: false,
                provides: false,
                require: false,
                respond: false,
                send: false,
                start: false,
                sum: false
            },
            rhino: {
                defineClass: false,
                deserialize: false,
                gc: false,
                help: false,
                importClass: false,
                importPackage: false,
                java: false,
                load: false,
                loadClass: false,
                Packages: false,
                print: false,
                quit: false,
                readFile: false,
                readUrl: false,
                runCommand: false,
                seal: false,
                serialize: false,
                spawn: false,
                sync: false,
                toint32: false,
                version: false
            },
            nashorn: {
                __DIR__: false,
                __FILE__: false,
                __LINE__: false,
                com: false,
                edu: false,
                exit: false,
                java: false,
                Java: false,
                javafx: false,
                JavaImporter: false,
                javax: false,
                JSAdapter: false,
                load: false,
                loadWithNewGlobal: false,
                org: false,
                Packages: false,
                print: false,
                quit: false
            },
            wsh: {
                ActiveXObject: false,
                CollectGarbage: false,
                Debug: false,
                Enumerator: false,
                GetObject: false,
                RuntimeObject: false,
                ScriptEngine: false,
                ScriptEngineBuildVersion: false,
                ScriptEngineMajorVersion: false,
                ScriptEngineMinorVersion: false,
                VBArray: false,
                WScript: false,
                WSH: false
            },
            jquery: {
                $: false,
                jQuery: false
            },
            yui: {
                YAHOO: false,
                YAHOO_config: false,
                YUI: false,
                YUI_config: false
            },
            shelljs: {
                cat: false,
                cd: false,
                chmod: false,
                config: false,
                cp: false,
                dirs: false,
                echo: false,
                env: false,
                error: false,
                exec: false,
                exit: false,
                find: false,
                grep: false,
                ln: false,
                ls: false,
                mkdir: false,
                mv: false,
                popd: false,
                pushd: false,
                pwd: false,
                rm: false,
                sed: false,
                set: false,
                target: false,
                tempdir: false,
                test: false,
                touch: false,
                which: false
            },
            prototypejs: {
                $: false,
                $$: false,
                $A: false,
                $break: false,
                $continue: false,
                $F: false,
                $H: false,
                $R: false,
                $w: false,
                Abstract: false,
                Ajax: false,
                Autocompleter: false,
                Builder: false,
                Class: false,
                Control: false,
                Draggable: false,
                Draggables: false,
                Droppables: false,
                Effect: false,
                Element: false,
                Enumerable: false,
                Event: false,
                Field: false,
                Form: false,
                Hash: false,
                Insertion: false,
                ObjectRange: false,
                PeriodicalExecuter: false,
                Position: false,
                Prototype: false,
                Scriptaculous: false,
                Selector: false,
                Sortable: false,
                SortableObserver: false,
                Sound: false,
                Template: false,
                Toggle: false,
                Try: false
            },
            meteor: {
                $: false,
                Accounts: false,
                AccountsClient: false,
                AccountsCommon: false,
                AccountsServer: false,
                App: false,
                Assets: false,
                Blaze: false,
                check: false,
                Cordova: false,
                DDP: false,
                DDPRateLimiter: false,
                DDPServer: false,
                Deps: false,
                EJSON: false,
                Email: false,
                HTTP: false,
                Log: false,
                Match: false,
                Meteor: false,
                Mongo: false,
                MongoInternals: false,
                Npm: false,
                Package: false,
                Plugin: false,
                process: false,
                Random: false,
                ReactiveDict: false,
                ReactiveVar: false,
                Router: false,
                ServiceConfiguration: false,
                Session: false,
                share: false,
                Spacebars: false,
                Template: false,
                Tinytest: false,
                Tracker: false,
                UI: false,
                Utils: false,
                WebApp: false,
                WebAppInternals: false
            },
            mongo: {
                _isWindows: false,
                _rand: false,
                BulkWriteResult: false,
                cat: false,
                cd: false,
                connect: false,
                db: false,
                getHostName: false,
                getMemInfo: false,
                hostname: false,
                ISODate: false,
                listFiles: false,
                load: false,
                ls: false,
                md5sumFile: false,
                mkdir: false,
                Mongo: false,
                NumberInt: false,
                NumberLong: false,
                ObjectId: false,
                PlanCache: false,
                print: false,
                printjson: false,
                pwd: false,
                quit: false,
                removeFile: false,
                rs: false,
                sh: false,
                UUID: false,
                version: false,
                WriteResult: false
            },
            applescript: {
                $: false,
                Application: false,
                Automation: false,
                console: false,
                delay: false,
                Library: false,
                ObjC: false,
                ObjectSpecifier: false,
                Path: false,
                Progress: false,
                Ref: false
            },
            serviceworker: {
                addEventListener: false,
                applicationCache: false,
                atob: false,
                Blob: false,
                BroadcastChannel: false,
                btoa: false,
                ByteLengthQueuingStrategy: false,
                Cache: false,
                caches: false,
                CacheStorage: false,
                clearInterval: false,
                clearTimeout: false,
                Client: false,
                clients: false,
                Clients: false,
                close: true,
                CompressionStream: false,
                console: false,
                CountQueuingStrategy: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CustomEvent: false,
                DecompressionStream: false,
                ErrorEvent: false,
                Event: false,
                ExtendableEvent: false,
                ExtendableMessageEvent: false,
                fetch: false,
                FetchEvent: false,
                File: false,
                FileReaderSync: false,
                FormData: false,
                Headers: false,
                IDBCursor: false,
                IDBCursorWithValue: false,
                IDBDatabase: false,
                IDBFactory: false,
                IDBIndex: false,
                IDBKeyRange: false,
                IDBObjectStore: false,
                IDBOpenDBRequest: false,
                IDBRequest: false,
                IDBTransaction: false,
                IDBVersionChangeEvent: false,
                ImageData: false,
                importScripts: false,
                indexedDB: false,
                location: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                name: false,
                navigator: false,
                Notification: false,
                onclose: true,
                onconnect: true,
                onerror: true,
                onfetch: true,
                oninstall: true,
                onlanguagechange: true,
                onmessage: true,
                onmessageerror: true,
                onnotificationclick: true,
                onnotificationclose: true,
                onoffline: true,
                ononline: true,
                onpush: true,
                onpushsubscriptionchange: true,
                onrejectionhandled: true,
                onsync: true,
                onunhandledrejection: true,
                performance: false,
                Performance: false,
                PerformanceEntry: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceNavigation: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformanceResourceTiming: false,
                PerformanceTiming: false,
                postMessage: true,
                Promise: false,
                queueMicrotask: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                registration: false,
                removeEventListener: false,
                Request: false,
                Response: false,
                self: false,
                ServiceWorker: false,
                ServiceWorkerContainer: false,
                ServiceWorkerGlobalScope: false,
                ServiceWorkerMessageEvent: false,
                ServiceWorkerRegistration: false,
                setInterval: false,
                setTimeout: false,
                skipWaiting: false,
                SubtleCrypto: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                URL: false,
                URLSearchParams: false,
                WebAssembly: false,
                WebSocket: false,
                WindowClient: false,
                Worker: false,
                WorkerGlobalScope: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false,
                XMLHttpRequest: false
            },
            atomtest: {
                advanceClock: false,
                atom: false,
                fakeClearInterval: false,
                fakeClearTimeout: false,
                fakeSetInterval: false,
                fakeSetTimeout: false,
                resetTimeouts: false,
                waitsForPromise: false
            },
            embertest: {
                andThen: false,
                click: false,
                currentPath: false,
                currentRouteName: false,
                currentURL: false,
                fillIn: false,
                find: false,
                findAll: false,
                findWithAssert: false,
                keyEvent: false,
                pauseTest: false,
                resumeTest: false,
                triggerEvent: false,
                visit: false,
                wait: false
            },
            protractor: {
                $: false,
                $$: false,
                browser: false,
                by: false,
                By: false,
                DartObject: false,
                element: false,
                protractor: false
            },
            "shared-node-browser": {
                AbortController: false,
                AbortSignal: false,
                atob: false,
                Blob: false,
                BroadcastChannel: false,
                btoa: false,
                ByteLengthQueuingStrategy: false,
                clearInterval: false,
                clearTimeout: false,
                CompressionStream: false,
                console: false,
                CountQueuingStrategy: false,
                crypto: false,
                Crypto: false,
                CryptoKey: false,
                CustomEvent: false,
                DecompressionStream: false,
                DOMException: false,
                Event: false,
                EventTarget: false,
                fetch: false,
                File: false,
                FormData: false,
                Headers: false,
                Intl: false,
                MessageChannel: false,
                MessageEvent: false,
                MessagePort: false,
                performance: false,
                PerformanceEntry: false,
                PerformanceMark: false,
                PerformanceMeasure: false,
                PerformanceObserver: false,
                PerformanceObserverEntryList: false,
                PerformanceResourceTiming: false,
                queueMicrotask: false,
                ReadableByteStreamController: false,
                ReadableStream: false,
                ReadableStreamBYOBReader: false,
                ReadableStreamBYOBRequest: false,
                ReadableStreamDefaultController: false,
                ReadableStreamDefaultReader: false,
                Request: false,
                Response: false,
                setInterval: false,
                setTimeout: false,
                structuredClone: false,
                SubtleCrypto: false,
                TextDecoder: false,
                TextDecoderStream: false,
                TextEncoder: false,
                TextEncoderStream: false,
                TransformStream: false,
                TransformStreamDefaultController: false,
                URL: false,
                URLSearchParams: false,
                WebAssembly: false,
                WritableStream: false,
                WritableStreamDefaultController: false,
                WritableStreamDefaultWriter: false
            },
            webextensions: {
                browser: false,
                chrome: false,
                opr: false
            },
            greasemonkey: {
                cloneInto: false,
                createObjectIn: false,
                exportFunction: false,
                GM: false,
                GM_addElement: false,
                GM_addStyle: false,
                GM_addValueChangeListener: false,
                GM_deleteValue: false,
                GM_download: false,
                GM_getResourceText: false,
                GM_getResourceURL: false,
                GM_getTab: false,
                GM_getTabs: false,
                GM_getValue: false,
                GM_info: false,
                GM_listValues: false,
                GM_log: false,
                GM_notification: false,
                GM_openInTab: false,
                GM_registerMenuCommand: false,
                GM_removeValueChangeListener: false,
                GM_saveTab: false,
                GM_setClipboard: false,
                GM_setValue: false,
                GM_unregisterMenuCommand: false,
                GM_xmlhttpRequest: false,
                unsafeWindow: false
            },
            devtools: {
                $: false,
                $_: false,
                $$: false,
                $0: false,
                $1: false,
                $2: false,
                $3: false,
                $4: false,
                $x: false,
                chrome: false,
                clear: false,
                copy: false,
                debug: false,
                dir: false,
                dirxml: false,
                getEventListeners: false,
                inspect: false,
                keys: false,
                monitor: false,
                monitorEvents: false,
                profile: false,
                profileEnd: false,
                queryObjects: false,
                table: false,
                undebug: false,
                unmonitor: false,
                unmonitorEvents: false,
                values: false
            }
        };
    }
});
// node_modules/globals/index.js
var require_globals2 = __commonJS({
    "node_modules/globals/index.js": function(exports2, module2) {
        "use strict";
        module2.exports = require_globals();
    }
});
// lib/index.mjs
var lib_exports2 = {};
__export(lib_exports2, {
    codeFrameColumns: function() {
        return codeFrameColumns;
    },
    generate: function() {
        return generate;
    },
    parse: function() {
        return parse;
    },
    parseExpression: function() {
        return parseExpression;
    },
    template: function() {
        return index;
    },
    tokTypes: function() {
        return tokTypes;
    },
    traverse: function() {
        return traverse3;
    },
    types: function() {
        return lib_exports;
    }
});
module.exports = __toCommonJS(lib_exports2);
// node_modules/@babel/types/lib/index.js
var lib_exports = {};
__export(lib_exports, {
    ACCESSOR_TYPES: function() {
        return ACCESSOR_TYPES;
    },
    ALIAS_KEYS: function() {
        return ALIAS_KEYS;
    },
    ASSIGNMENT_OPERATORS: function() {
        return ASSIGNMENT_OPERATORS;
    },
    AnyTypeAnnotation: function() {
        return anyTypeAnnotation;
    },
    ArgumentPlaceholder: function() {
        return argumentPlaceholder;
    },
    ArrayExpression: function() {
        return arrayExpression;
    },
    ArrayPattern: function() {
        return arrayPattern;
    },
    ArrayTypeAnnotation: function() {
        return arrayTypeAnnotation;
    },
    ArrowFunctionExpression: function() {
        return arrowFunctionExpression;
    },
    AssignmentExpression: function() {
        return assignmentExpression;
    },
    AssignmentPattern: function() {
        return assignmentPattern;
    },
    AwaitExpression: function() {
        return awaitExpression;
    },
    BINARY_OPERATORS: function() {
        return BINARY_OPERATORS;
    },
    BINARY_TYPES: function() {
        return BINARY_TYPES;
    },
    BLOCKPARENT_TYPES: function() {
        return BLOCKPARENT_TYPES;
    },
    BLOCK_SCOPED_SYMBOL: function() {
        return BLOCK_SCOPED_SYMBOL;
    },
    BLOCK_TYPES: function() {
        return BLOCK_TYPES;
    },
    BOOLEAN_BINARY_OPERATORS: function() {
        return BOOLEAN_BINARY_OPERATORS;
    },
    BOOLEAN_NUMBER_BINARY_OPERATORS: function() {
        return BOOLEAN_NUMBER_BINARY_OPERATORS;
    },
    BOOLEAN_UNARY_OPERATORS: function() {
        return BOOLEAN_UNARY_OPERATORS;
    },
    BUILDER_KEYS: function() {
        return BUILDER_KEYS;
    },
    BigIntLiteral: function() {
        return bigIntLiteral;
    },
    BinaryExpression: function() {
        return binaryExpression;
    },
    BindExpression: function() {
        return bindExpression;
    },
    BlockStatement: function() {
        return blockStatement;
    },
    BooleanLiteral: function() {
        return booleanLiteral;
    },
    BooleanLiteralTypeAnnotation: function() {
        return booleanLiteralTypeAnnotation;
    },
    BooleanTypeAnnotation: function() {
        return booleanTypeAnnotation;
    },
    BreakStatement: function() {
        return breakStatement;
    },
    CLASS_TYPES: function() {
        return CLASS_TYPES;
    },
    COMMENT_KEYS: function() {
        return COMMENT_KEYS;
    },
    COMPARISON_BINARY_OPERATORS: function() {
        return COMPARISON_BINARY_OPERATORS;
    },
    COMPLETIONSTATEMENT_TYPES: function() {
        return COMPLETIONSTATEMENT_TYPES;
    },
    CONDITIONAL_TYPES: function() {
        return CONDITIONAL_TYPES;
    },
    CallExpression: function() {
        return callExpression;
    },
    CatchClause: function() {
        return catchClause;
    },
    ClassAccessorProperty: function() {
        return classAccessorProperty;
    },
    ClassBody: function() {
        return classBody;
    },
    ClassDeclaration: function() {
        return classDeclaration;
    },
    ClassExpression: function() {
        return classExpression;
    },
    ClassImplements: function() {
        return classImplements;
    },
    ClassMethod: function() {
        return classMethod;
    },
    ClassPrivateMethod: function() {
        return classPrivateMethod;
    },
    ClassPrivateProperty: function() {
        return classPrivateProperty;
    },
    ClassProperty: function() {
        return classProperty;
    },
    ConditionalExpression: function() {
        return conditionalExpression;
    },
    ContinueStatement: function() {
        return continueStatement;
    },
    DECLARATION_TYPES: function() {
        return DECLARATION_TYPES;
    },
    DEPRECATED_ALIASES: function() {
        return DEPRECATED_ALIASES;
    },
    DEPRECATED_KEYS: function() {
        return DEPRECATED_KEYS;
    },
    DebuggerStatement: function() {
        return debuggerStatement;
    },
    DecimalLiteral: function() {
        return decimalLiteral;
    },
    DeclareClass: function() {
        return declareClass;
    },
    DeclareExportAllDeclaration: function() {
        return declareExportAllDeclaration;
    },
    DeclareExportDeclaration: function() {
        return declareExportDeclaration;
    },
    DeclareFunction: function() {
        return declareFunction;
    },
    DeclareInterface: function() {
        return declareInterface;
    },
    DeclareModule: function() {
        return declareModule;
    },
    DeclareModuleExports: function() {
        return declareModuleExports;
    },
    DeclareOpaqueType: function() {
        return declareOpaqueType;
    },
    DeclareTypeAlias: function() {
        return declareTypeAlias;
    },
    DeclareVariable: function() {
        return declareVariable;
    },
    DeclaredPredicate: function() {
        return declaredPredicate;
    },
    Decorator: function() {
        return decorator;
    },
    Directive: function() {
        return directive;
    },
    DirectiveLiteral: function() {
        return directiveLiteral;
    },
    DoExpression: function() {
        return doExpression;
    },
    DoWhileStatement: function() {
        return doWhileStatement;
    },
    ENUMBODY_TYPES: function() {
        return ENUMBODY_TYPES;
    },
    ENUMMEMBER_TYPES: function() {
        return ENUMMEMBER_TYPES;
    },
    EQUALITY_BINARY_OPERATORS: function() {
        return EQUALITY_BINARY_OPERATORS;
    },
    EXPORTDECLARATION_TYPES: function() {
        return EXPORTDECLARATION_TYPES;
    },
    EXPRESSIONWRAPPER_TYPES: function() {
        return EXPRESSIONWRAPPER_TYPES;
    },
    EXPRESSION_TYPES: function() {
        return EXPRESSION_TYPES;
    },
    EmptyStatement: function() {
        return emptyStatement;
    },
    EmptyTypeAnnotation: function() {
        return emptyTypeAnnotation;
    },
    EnumBooleanBody: function() {
        return enumBooleanBody;
    },
    EnumBooleanMember: function() {
        return enumBooleanMember;
    },
    EnumDeclaration: function() {
        return enumDeclaration;
    },
    EnumDefaultedMember: function() {
        return enumDefaultedMember;
    },
    EnumNumberBody: function() {
        return enumNumberBody;
    },
    EnumNumberMember: function() {
        return enumNumberMember;
    },
    EnumStringBody: function() {
        return enumStringBody;
    },
    EnumStringMember: function() {
        return enumStringMember;
    },
    EnumSymbolBody: function() {
        return enumSymbolBody;
    },
    ExistsTypeAnnotation: function() {
        return existsTypeAnnotation;
    },
    ExportAllDeclaration: function() {
        return exportAllDeclaration;
    },
    ExportDefaultDeclaration: function() {
        return exportDefaultDeclaration;
    },
    ExportDefaultSpecifier: function() {
        return exportDefaultSpecifier;
    },
    ExportNamedDeclaration: function() {
        return exportNamedDeclaration;
    },
    ExportNamespaceSpecifier: function() {
        return exportNamespaceSpecifier;
    },
    ExportSpecifier: function() {
        return exportSpecifier;
    },
    ExpressionStatement: function() {
        return expressionStatement;
    },
    FLATTENABLE_KEYS: function() {
        return FLATTENABLE_KEYS;
    },
    FLIPPED_ALIAS_KEYS: function() {
        return FLIPPED_ALIAS_KEYS;
    },
    FLOWBASEANNOTATION_TYPES: function() {
        return FLOWBASEANNOTATION_TYPES;
    },
    FLOWDECLARATION_TYPES: function() {
        return FLOWDECLARATION_TYPES;
    },
    FLOWPREDICATE_TYPES: function() {
        return FLOWPREDICATE_TYPES;
    },
    FLOWTYPE_TYPES: function() {
        return FLOWTYPE_TYPES;
    },
    FLOW_TYPES: function() {
        return FLOW_TYPES;
    },
    FORXSTATEMENT_TYPES: function() {
        return FORXSTATEMENT_TYPES;
    },
    FOR_INIT_KEYS: function() {
        return FOR_INIT_KEYS;
    },
    FOR_TYPES: function() {
        return FOR_TYPES;
    },
    FUNCTIONPARENT_TYPES: function() {
        return FUNCTIONPARENT_TYPES;
    },
    FUNCTION_TYPES: function() {
        return FUNCTION_TYPES;
    },
    File: function() {
        return file;
    },
    ForInStatement: function() {
        return forInStatement;
    },
    ForOfStatement: function() {
        return forOfStatement;
    },
    ForStatement: function() {
        return forStatement;
    },
    FunctionDeclaration: function() {
        return functionDeclaration;
    },
    FunctionExpression: function() {
        return functionExpression;
    },
    FunctionTypeAnnotation: function() {
        return functionTypeAnnotation;
    },
    FunctionTypeParam: function() {
        return functionTypeParam;
    },
    GenericTypeAnnotation: function() {
        return genericTypeAnnotation;
    },
    IMMUTABLE_TYPES: function() {
        return IMMUTABLE_TYPES;
    },
    IMPORTOREXPORTDECLARATION_TYPES: function() {
        return IMPORTOREXPORTDECLARATION_TYPES;
    },
    INHERIT_KEYS: function() {
        return INHERIT_KEYS;
    },
    Identifier: function() {
        return identifier;
    },
    IfStatement: function() {
        return ifStatement;
    },
    Import: function() {
        return _import;
    },
    ImportAttribute: function() {
        return importAttribute;
    },
    ImportDeclaration: function() {
        return importDeclaration;
    },
    ImportDefaultSpecifier: function() {
        return importDefaultSpecifier;
    },
    ImportExpression: function() {
        return importExpression;
    },
    ImportNamespaceSpecifier: function() {
        return importNamespaceSpecifier;
    },
    ImportSpecifier: function() {
        return importSpecifier;
    },
    IndexedAccessType: function() {
        return indexedAccessType;
    },
    InferredPredicate: function() {
        return inferredPredicate;
    },
    InterfaceDeclaration: function() {
        return interfaceDeclaration;
    },
    InterfaceExtends: function() {
        return interfaceExtends;
    },
    InterfaceTypeAnnotation: function() {
        return interfaceTypeAnnotation;
    },
    InterpreterDirective: function() {
        return interpreterDirective;
    },
    IntersectionTypeAnnotation: function() {
        return intersectionTypeAnnotation;
    },
    JSXAttribute: function() {
        return jsxAttribute;
    },
    JSXClosingElement: function() {
        return jsxClosingElement;
    },
    JSXClosingFragment: function() {
        return jsxClosingFragment;
    },
    JSXElement: function() {
        return jsxElement;
    },
    JSXEmptyExpression: function() {
        return jsxEmptyExpression;
    },
    JSXExpressionContainer: function() {
        return jsxExpressionContainer;
    },
    JSXFragment: function() {
        return jsxFragment;
    },
    JSXIdentifier: function() {
        return jsxIdentifier;
    },
    JSXMemberExpression: function() {
        return jsxMemberExpression;
    },
    JSXNamespacedName: function() {
        return jsxNamespacedName;
    },
    JSXOpeningElement: function() {
        return jsxOpeningElement;
    },
    JSXOpeningFragment: function() {
        return jsxOpeningFragment;
    },
    JSXSpreadAttribute: function() {
        return jsxSpreadAttribute;
    },
    JSXSpreadChild: function() {
        return jsxSpreadChild;
    },
    JSXText: function() {
        return jsxText;
    },
    JSX_TYPES: function() {
        return JSX_TYPES;
    },
    LITERAL_TYPES: function() {
        return LITERAL_TYPES;
    },
    LOGICAL_OPERATORS: function() {
        return LOGICAL_OPERATORS;
    },
    LOOP_TYPES: function() {
        return LOOP_TYPES;
    },
    LVAL_TYPES: function() {
        return LVAL_TYPES;
    },
    LabeledStatement: function() {
        return labeledStatement;
    },
    LogicalExpression: function() {
        return logicalExpression;
    },
    METHOD_TYPES: function() {
        return METHOD_TYPES;
    },
    MISCELLANEOUS_TYPES: function() {
        return MISCELLANEOUS_TYPES;
    },
    MODULEDECLARATION_TYPES: function() {
        return MODULEDECLARATION_TYPES;
    },
    MODULESPECIFIER_TYPES: function() {
        return MODULESPECIFIER_TYPES;
    },
    MemberExpression: function() {
        return memberExpression;
    },
    MetaProperty: function() {
        return metaProperty;
    },
    MixedTypeAnnotation: function() {
        return mixedTypeAnnotation;
    },
    ModuleExpression: function() {
        return moduleExpression;
    },
    NODE_FIELDS: function() {
        return NODE_FIELDS;
    },
    NODE_PARENT_VALIDATIONS: function() {
        return NODE_PARENT_VALIDATIONS;
    },
    NOT_LOCAL_BINDING: function() {
        return NOT_LOCAL_BINDING;
    },
    NUMBER_BINARY_OPERATORS: function() {
        return NUMBER_BINARY_OPERATORS;
    },
    NUMBER_UNARY_OPERATORS: function() {
        return NUMBER_UNARY_OPERATORS;
    },
    NewExpression: function() {
        return newExpression;
    },
    Noop: function() {
        return noop;
    },
    NullLiteral: function() {
        return nullLiteral;
    },
    NullLiteralTypeAnnotation: function() {
        return nullLiteralTypeAnnotation;
    },
    NullableTypeAnnotation: function() {
        return nullableTypeAnnotation;
    },
    NumberLiteral: function() {
        return NumberLiteral;
    },
    NumberLiteralTypeAnnotation: function() {
        return numberLiteralTypeAnnotation;
    },
    NumberTypeAnnotation: function() {
        return numberTypeAnnotation;
    },
    NumericLiteral: function() {
        return numericLiteral;
    },
    OBJECTMEMBER_TYPES: function() {
        return OBJECTMEMBER_TYPES;
    },
    ObjectExpression: function() {
        return objectExpression;
    },
    ObjectMethod: function() {
        return objectMethod;
    },
    ObjectPattern: function() {
        return objectPattern;
    },
    ObjectProperty: function() {
        return objectProperty;
    },
    ObjectTypeAnnotation: function() {
        return objectTypeAnnotation;
    },
    ObjectTypeCallProperty: function() {
        return objectTypeCallProperty;
    },
    ObjectTypeIndexer: function() {
        return objectTypeIndexer;
    },
    ObjectTypeInternalSlot: function() {
        return objectTypeInternalSlot;
    },
    ObjectTypeProperty: function() {
        return objectTypeProperty;
    },
    ObjectTypeSpreadProperty: function() {
        return objectTypeSpreadProperty;
    },
    OpaqueType: function() {
        return opaqueType;
    },
    OptionalCallExpression: function() {
        return optionalCallExpression;
    },
    OptionalIndexedAccessType: function() {
        return optionalIndexedAccessType;
    },
    OptionalMemberExpression: function() {
        return optionalMemberExpression;
    },
    PATTERNLIKE_TYPES: function() {
        return PATTERNLIKE_TYPES;
    },
    PATTERN_TYPES: function() {
        return PATTERN_TYPES;
    },
    PLACEHOLDERS: function() {
        return PLACEHOLDERS;
    },
    PLACEHOLDERS_ALIAS: function() {
        return PLACEHOLDERS_ALIAS;
    },
    PLACEHOLDERS_FLIPPED_ALIAS: function() {
        return PLACEHOLDERS_FLIPPED_ALIAS;
    },
    PRIVATE_TYPES: function() {
        return PRIVATE_TYPES;
    },
    PROPERTY_TYPES: function() {
        return PROPERTY_TYPES;
    },
    PUREISH_TYPES: function() {
        return PUREISH_TYPES;
    },
    ParenthesizedExpression: function() {
        return parenthesizedExpression;
    },
    PipelineBareFunction: function() {
        return pipelineBareFunction;
    },
    PipelinePrimaryTopicReference: function() {
        return pipelinePrimaryTopicReference;
    },
    PipelineTopicExpression: function() {
        return pipelineTopicExpression;
    },
    Placeholder: function() {
        return placeholder;
    },
    PrivateName: function() {
        return privateName;
    },
    Program: function() {
        return program;
    },
    QualifiedTypeIdentifier: function() {
        return qualifiedTypeIdentifier;
    },
    RecordExpression: function() {
        return recordExpression;
    },
    RegExpLiteral: function() {
        return regExpLiteral;
    },
    RegexLiteral: function() {
        return RegexLiteral;
    },
    RestElement: function() {
        return restElement;
    },
    RestProperty: function() {
        return RestProperty;
    },
    ReturnStatement: function() {
        return returnStatement;
    },
    SCOPABLE_TYPES: function() {
        return SCOPABLE_TYPES;
    },
    STANDARDIZED_TYPES: function() {
        return STANDARDIZED_TYPES;
    },
    STATEMENT_OR_BLOCK_KEYS: function() {
        return STATEMENT_OR_BLOCK_KEYS;
    },
    STATEMENT_TYPES: function() {
        return STATEMENT_TYPES;
    },
    STRING_UNARY_OPERATORS: function() {
        return STRING_UNARY_OPERATORS;
    },
    SequenceExpression: function() {
        return sequenceExpression;
    },
    SpreadElement: function() {
        return spreadElement;
    },
    SpreadProperty: function() {
        return SpreadProperty;
    },
    StaticBlock: function() {
        return staticBlock;
    },
    StringLiteral: function() {
        return stringLiteral;
    },
    StringLiteralTypeAnnotation: function() {
        return stringLiteralTypeAnnotation;
    },
    StringTypeAnnotation: function() {
        return stringTypeAnnotation;
    },
    Super: function() {
        return _super;
    },
    SwitchCase: function() {
        return switchCase;
    },
    SwitchStatement: function() {
        return switchStatement;
    },
    SymbolTypeAnnotation: function() {
        return symbolTypeAnnotation;
    },
    TERMINATORLESS_TYPES: function() {
        return TERMINATORLESS_TYPES;
    },
    TSAnyKeyword: function() {
        return tsAnyKeyword;
    },
    TSArrayType: function() {
        return tsArrayType;
    },
    TSAsExpression: function() {
        return tsAsExpression;
    },
    TSBASETYPE_TYPES: function() {
        return TSBASETYPE_TYPES;
    },
    TSBigIntKeyword: function() {
        return tsBigIntKeyword;
    },
    TSBooleanKeyword: function() {
        return tsBooleanKeyword;
    },
    TSCallSignatureDeclaration: function() {
        return tsCallSignatureDeclaration;
    },
    TSConditionalType: function() {
        return tsConditionalType;
    },
    TSConstructSignatureDeclaration: function() {
        return tsConstructSignatureDeclaration;
    },
    TSConstructorType: function() {
        return tsConstructorType;
    },
    TSDeclareFunction: function() {
        return tsDeclareFunction;
    },
    TSDeclareMethod: function() {
        return tsDeclareMethod;
    },
    TSENTITYNAME_TYPES: function() {
        return TSENTITYNAME_TYPES;
    },
    TSEnumDeclaration: function() {
        return tsEnumDeclaration;
    },
    TSEnumMember: function() {
        return tsEnumMember;
    },
    TSExportAssignment: function() {
        return tsExportAssignment;
    },
    TSExpressionWithTypeArguments: function() {
        return tsExpressionWithTypeArguments;
    },
    TSExternalModuleReference: function() {
        return tsExternalModuleReference;
    },
    TSFunctionType: function() {
        return tsFunctionType;
    },
    TSImportEqualsDeclaration: function() {
        return tsImportEqualsDeclaration;
    },
    TSImportType: function() {
        return tsImportType;
    },
    TSIndexSignature: function() {
        return tsIndexSignature;
    },
    TSIndexedAccessType: function() {
        return tsIndexedAccessType;
    },
    TSInferType: function() {
        return tsInferType;
    },
    TSInstantiationExpression: function() {
        return tsInstantiationExpression;
    },
    TSInterfaceBody: function() {
        return tsInterfaceBody;
    },
    TSInterfaceDeclaration: function() {
        return tsInterfaceDeclaration;
    },
    TSIntersectionType: function() {
        return tsIntersectionType;
    },
    TSIntrinsicKeyword: function() {
        return tsIntrinsicKeyword;
    },
    TSLiteralType: function() {
        return tsLiteralType;
    },
    TSMappedType: function() {
        return tsMappedType;
    },
    TSMethodSignature: function() {
        return tsMethodSignature;
    },
    TSModuleBlock: function() {
        return tsModuleBlock;
    },
    TSModuleDeclaration: function() {
        return tsModuleDeclaration;
    },
    TSNamedTupleMember: function() {
        return tsNamedTupleMember;
    },
    TSNamespaceExportDeclaration: function() {
        return tsNamespaceExportDeclaration;
    },
    TSNeverKeyword: function() {
        return tsNeverKeyword;
    },
    TSNonNullExpression: function() {
        return tsNonNullExpression;
    },
    TSNullKeyword: function() {
        return tsNullKeyword;
    },
    TSNumberKeyword: function() {
        return tsNumberKeyword;
    },
    TSObjectKeyword: function() {
        return tsObjectKeyword;
    },
    TSOptionalType: function() {
        return tsOptionalType;
    },
    TSParameterProperty: function() {
        return tsParameterProperty;
    },
    TSParenthesizedType: function() {
        return tsParenthesizedType;
    },
    TSPropertySignature: function() {
        return tsPropertySignature;
    },
    TSQualifiedName: function() {
        return tsQualifiedName;
    },
    TSRestType: function() {
        return tsRestType;
    },
    TSSatisfiesExpression: function() {
        return tsSatisfiesExpression;
    },
    TSStringKeyword: function() {
        return tsStringKeyword;
    },
    TSSymbolKeyword: function() {
        return tsSymbolKeyword;
    },
    TSTYPEELEMENT_TYPES: function() {
        return TSTYPEELEMENT_TYPES;
    },
    TSTYPE_TYPES: function() {
        return TSTYPE_TYPES;
    },
    TSThisType: function() {
        return tsThisType;
    },
    TSTupleType: function() {
        return tsTupleType;
    },
    TSTypeAliasDeclaration: function() {
        return tsTypeAliasDeclaration;
    },
    TSTypeAnnotation: function() {
        return tsTypeAnnotation;
    },
    TSTypeAssertion: function() {
        return tsTypeAssertion;
    },
    TSTypeLiteral: function() {
        return tsTypeLiteral;
    },
    TSTypeOperator: function() {
        return tsTypeOperator;
    },
    TSTypeParameter: function() {
        return tsTypeParameter;
    },
    TSTypeParameterDeclaration: function() {
        return tsTypeParameterDeclaration;
    },
    TSTypeParameterInstantiation: function() {
        return tsTypeParameterInstantiation;
    },
    TSTypePredicate: function() {
        return tsTypePredicate;
    },
    TSTypeQuery: function() {
        return tsTypeQuery;
    },
    TSTypeReference: function() {
        return tsTypeReference;
    },
    TSUndefinedKeyword: function() {
        return tsUndefinedKeyword;
    },
    TSUnionType: function() {
        return tsUnionType;
    },
    TSUnknownKeyword: function() {
        return tsUnknownKeyword;
    },
    TSVoidKeyword: function() {
        return tsVoidKeyword;
    },
    TYPES: function() {
        return TYPES;
    },
    TYPESCRIPT_TYPES: function() {
        return TYPESCRIPT_TYPES;
    },
    TaggedTemplateExpression: function() {
        return taggedTemplateExpression;
    },
    TemplateElement: function() {
        return templateElement;
    },
    TemplateLiteral: function() {
        return templateLiteral;
    },
    ThisExpression: function() {
        return thisExpression;
    },
    ThisTypeAnnotation: function() {
        return thisTypeAnnotation;
    },
    ThrowStatement: function() {
        return throwStatement;
    },
    TopicReference: function() {
        return topicReference;
    },
    TryStatement: function() {
        return tryStatement;
    },
    TupleExpression: function() {
        return tupleExpression;
    },
    TupleTypeAnnotation: function() {
        return tupleTypeAnnotation;
    },
    TypeAlias: function() {
        return typeAlias;
    },
    TypeAnnotation: function() {
        return typeAnnotation;
    },
    TypeCastExpression: function() {
        return typeCastExpression;
    },
    TypeParameter: function() {
        return typeParameter;
    },
    TypeParameterDeclaration: function() {
        return typeParameterDeclaration;
    },
    TypeParameterInstantiation: function() {
        return typeParameterInstantiation;
    },
    TypeofTypeAnnotation: function() {
        return typeofTypeAnnotation;
    },
    UNARYLIKE_TYPES: function() {
        return UNARYLIKE_TYPES;
    },
    UNARY_OPERATORS: function() {
        return UNARY_OPERATORS;
    },
    UPDATE_OPERATORS: function() {
        return UPDATE_OPERATORS;
    },
    USERWHITESPACABLE_TYPES: function() {
        return USERWHITESPACABLE_TYPES;
    },
    UnaryExpression: function() {
        return unaryExpression;
    },
    UnionTypeAnnotation: function() {
        return unionTypeAnnotation;
    },
    UpdateExpression: function() {
        return updateExpression;
    },
    V8IntrinsicIdentifier: function() {
        return v8IntrinsicIdentifier;
    },
    VISITOR_KEYS: function() {
        return VISITOR_KEYS;
    },
    VariableDeclaration: function() {
        return variableDeclaration;
    },
    VariableDeclarator: function() {
        return variableDeclarator;
    },
    Variance: function() {
        return variance;
    },
    VoidTypeAnnotation: function() {
        return voidTypeAnnotation;
    },
    WHILE_TYPES: function() {
        return WHILE_TYPES;
    },
    WhileStatement: function() {
        return whileStatement;
    },
    WithStatement: function() {
        return withStatement;
    },
    YieldExpression: function() {
        return yieldExpression;
    },
    __internal__deprecationWarning: function() {
        return deprecationWarning;
    },
    addComment: function() {
        return addComment;
    },
    addComments: function() {
        return addComments;
    },
    anyTypeAnnotation: function() {
        return anyTypeAnnotation;
    },
    appendToMemberExpression: function() {
        return appendToMemberExpression;
    },
    argumentPlaceholder: function() {
        return argumentPlaceholder;
    },
    arrayExpression: function() {
        return arrayExpression;
    },
    arrayPattern: function() {
        return arrayPattern;
    },
    arrayTypeAnnotation: function() {
        return arrayTypeAnnotation;
    },
    arrowFunctionExpression: function() {
        return arrowFunctionExpression;
    },
    assertAccessor: function() {
        return assertAccessor;
    },
    assertAnyTypeAnnotation: function() {
        return assertAnyTypeAnnotation;
    },
    assertArgumentPlaceholder: function() {
        return assertArgumentPlaceholder;
    },
    assertArrayExpression: function() {
        return assertArrayExpression;
    },
    assertArrayPattern: function() {
        return assertArrayPattern;
    },
    assertArrayTypeAnnotation: function() {
        return assertArrayTypeAnnotation;
    },
    assertArrowFunctionExpression: function() {
        return assertArrowFunctionExpression;
    },
    assertAssignmentExpression: function() {
        return assertAssignmentExpression;
    },
    assertAssignmentPattern: function() {
        return assertAssignmentPattern;
    },
    assertAwaitExpression: function() {
        return assertAwaitExpression;
    },
    assertBigIntLiteral: function() {
        return assertBigIntLiteral;
    },
    assertBinary: function() {
        return assertBinary;
    },
    assertBinaryExpression: function() {
        return assertBinaryExpression;
    },
    assertBindExpression: function() {
        return assertBindExpression;
    },
    assertBlock: function() {
        return assertBlock;
    },
    assertBlockParent: function() {
        return assertBlockParent;
    },
    assertBlockStatement: function() {
        return assertBlockStatement;
    },
    assertBooleanLiteral: function() {
        return assertBooleanLiteral;
    },
    assertBooleanLiteralTypeAnnotation: function() {
        return assertBooleanLiteralTypeAnnotation;
    },
    assertBooleanTypeAnnotation: function() {
        return assertBooleanTypeAnnotation;
    },
    assertBreakStatement: function() {
        return assertBreakStatement;
    },
    assertCallExpression: function() {
        return assertCallExpression;
    },
    assertCatchClause: function() {
        return assertCatchClause;
    },
    assertClass: function() {
        return assertClass;
    },
    assertClassAccessorProperty: function() {
        return assertClassAccessorProperty;
    },
    assertClassBody: function() {
        return assertClassBody;
    },
    assertClassDeclaration: function() {
        return assertClassDeclaration;
    },
    assertClassExpression: function() {
        return assertClassExpression;
    },
    assertClassImplements: function() {
        return assertClassImplements;
    },
    assertClassMethod: function() {
        return assertClassMethod;
    },
    assertClassPrivateMethod: function() {
        return assertClassPrivateMethod;
    },
    assertClassPrivateProperty: function() {
        return assertClassPrivateProperty;
    },
    assertClassProperty: function() {
        return assertClassProperty;
    },
    assertCompletionStatement: function() {
        return assertCompletionStatement;
    },
    assertConditional: function() {
        return assertConditional;
    },
    assertConditionalExpression: function() {
        return assertConditionalExpression;
    },
    assertContinueStatement: function() {
        return assertContinueStatement;
    },
    assertDebuggerStatement: function() {
        return assertDebuggerStatement;
    },
    assertDecimalLiteral: function() {
        return assertDecimalLiteral;
    },
    assertDeclaration: function() {
        return assertDeclaration;
    },
    assertDeclareClass: function() {
        return assertDeclareClass;
    },
    assertDeclareExportAllDeclaration: function() {
        return assertDeclareExportAllDeclaration;
    },
    assertDeclareExportDeclaration: function() {
        return assertDeclareExportDeclaration;
    },
    assertDeclareFunction: function() {
        return assertDeclareFunction;
    },
    assertDeclareInterface: function() {
        return assertDeclareInterface;
    },
    assertDeclareModule: function() {
        return assertDeclareModule;
    },
    assertDeclareModuleExports: function() {
        return assertDeclareModuleExports;
    },
    assertDeclareOpaqueType: function() {
        return assertDeclareOpaqueType;
    },
    assertDeclareTypeAlias: function() {
        return assertDeclareTypeAlias;
    },
    assertDeclareVariable: function() {
        return assertDeclareVariable;
    },
    assertDeclaredPredicate: function() {
        return assertDeclaredPredicate;
    },
    assertDecorator: function() {
        return assertDecorator;
    },
    assertDirective: function() {
        return assertDirective;
    },
    assertDirectiveLiteral: function() {
        return assertDirectiveLiteral;
    },
    assertDoExpression: function() {
        return assertDoExpression;
    },
    assertDoWhileStatement: function() {
        return assertDoWhileStatement;
    },
    assertEmptyStatement: function() {
        return assertEmptyStatement;
    },
    assertEmptyTypeAnnotation: function() {
        return assertEmptyTypeAnnotation;
    },
    assertEnumBody: function() {
        return assertEnumBody;
    },
    assertEnumBooleanBody: function() {
        return assertEnumBooleanBody;
    },
    assertEnumBooleanMember: function() {
        return assertEnumBooleanMember;
    },
    assertEnumDeclaration: function() {
        return assertEnumDeclaration;
    },
    assertEnumDefaultedMember: function() {
        return assertEnumDefaultedMember;
    },
    assertEnumMember: function() {
        return assertEnumMember;
    },
    assertEnumNumberBody: function() {
        return assertEnumNumberBody;
    },
    assertEnumNumberMember: function() {
        return assertEnumNumberMember;
    },
    assertEnumStringBody: function() {
        return assertEnumStringBody;
    },
    assertEnumStringMember: function() {
        return assertEnumStringMember;
    },
    assertEnumSymbolBody: function() {
        return assertEnumSymbolBody;
    },
    assertExistsTypeAnnotation: function() {
        return assertExistsTypeAnnotation;
    },
    assertExportAllDeclaration: function() {
        return assertExportAllDeclaration;
    },
    assertExportDeclaration: function() {
        return assertExportDeclaration;
    },
    assertExportDefaultDeclaration: function() {
        return assertExportDefaultDeclaration;
    },
    assertExportDefaultSpecifier: function() {
        return assertExportDefaultSpecifier;
    },
    assertExportNamedDeclaration: function() {
        return assertExportNamedDeclaration;
    },
    assertExportNamespaceSpecifier: function() {
        return assertExportNamespaceSpecifier;
    },
    assertExportSpecifier: function() {
        return assertExportSpecifier;
    },
    assertExpression: function() {
        return assertExpression;
    },
    assertExpressionStatement: function() {
        return assertExpressionStatement;
    },
    assertExpressionWrapper: function() {
        return assertExpressionWrapper;
    },
    assertFile: function() {
        return assertFile;
    },
    assertFlow: function() {
        return assertFlow;
    },
    assertFlowBaseAnnotation: function() {
        return assertFlowBaseAnnotation;
    },
    assertFlowDeclaration: function() {
        return assertFlowDeclaration;
    },
    assertFlowPredicate: function() {
        return assertFlowPredicate;
    },
    assertFlowType: function() {
        return assertFlowType;
    },
    assertFor: function() {
        return assertFor;
    },
    assertForInStatement: function() {
        return assertForInStatement;
    },
    assertForOfStatement: function() {
        return assertForOfStatement;
    },
    assertForStatement: function() {
        return assertForStatement;
    },
    assertForXStatement: function() {
        return assertForXStatement;
    },
    assertFunction: function() {
        return assertFunction;
    },
    assertFunctionDeclaration: function() {
        return assertFunctionDeclaration;
    },
    assertFunctionExpression: function() {
        return assertFunctionExpression;
    },
    assertFunctionParent: function() {
        return assertFunctionParent;
    },
    assertFunctionTypeAnnotation: function() {
        return assertFunctionTypeAnnotation;
    },
    assertFunctionTypeParam: function() {
        return assertFunctionTypeParam;
    },
    assertGenericTypeAnnotation: function() {
        return assertGenericTypeAnnotation;
    },
    assertIdentifier: function() {
        return assertIdentifier;
    },
    assertIfStatement: function() {
        return assertIfStatement;
    },
    assertImmutable: function() {
        return assertImmutable;
    },
    assertImport: function() {
        return assertImport;
    },
    assertImportAttribute: function() {
        return assertImportAttribute;
    },
    assertImportDeclaration: function() {
        return assertImportDeclaration;
    },
    assertImportDefaultSpecifier: function() {
        return assertImportDefaultSpecifier;
    },
    assertImportExpression: function() {
        return assertImportExpression;
    },
    assertImportNamespaceSpecifier: function() {
        return assertImportNamespaceSpecifier;
    },
    assertImportOrExportDeclaration: function() {
        return assertImportOrExportDeclaration;
    },
    assertImportSpecifier: function() {
        return assertImportSpecifier;
    },
    assertIndexedAccessType: function() {
        return assertIndexedAccessType;
    },
    assertInferredPredicate: function() {
        return assertInferredPredicate;
    },
    assertInterfaceDeclaration: function() {
        return assertInterfaceDeclaration;
    },
    assertInterfaceExtends: function() {
        return assertInterfaceExtends;
    },
    assertInterfaceTypeAnnotation: function() {
        return assertInterfaceTypeAnnotation;
    },
    assertInterpreterDirective: function() {
        return assertInterpreterDirective;
    },
    assertIntersectionTypeAnnotation: function() {
        return assertIntersectionTypeAnnotation;
    },
    assertJSX: function() {
        return assertJSX;
    },
    assertJSXAttribute: function() {
        return assertJSXAttribute;
    },
    assertJSXClosingElement: function() {
        return assertJSXClosingElement;
    },
    assertJSXClosingFragment: function() {
        return assertJSXClosingFragment;
    },
    assertJSXElement: function() {
        return assertJSXElement;
    },
    assertJSXEmptyExpression: function() {
        return assertJSXEmptyExpression;
    },
    assertJSXExpressionContainer: function() {
        return assertJSXExpressionContainer;
    },
    assertJSXFragment: function() {
        return assertJSXFragment;
    },
    assertJSXIdentifier: function() {
        return assertJSXIdentifier;
    },
    assertJSXMemberExpression: function() {
        return assertJSXMemberExpression;
    },
    assertJSXNamespacedName: function() {
        return assertJSXNamespacedName;
    },
    assertJSXOpeningElement: function() {
        return assertJSXOpeningElement;
    },
    assertJSXOpeningFragment: function() {
        return assertJSXOpeningFragment;
    },
    assertJSXSpreadAttribute: function() {
        return assertJSXSpreadAttribute;
    },
    assertJSXSpreadChild: function() {
        return assertJSXSpreadChild;
    },
    assertJSXText: function() {
        return assertJSXText;
    },
    assertLVal: function() {
        return assertLVal;
    },
    assertLabeledStatement: function() {
        return assertLabeledStatement;
    },
    assertLiteral: function() {
        return assertLiteral;
    },
    assertLogicalExpression: function() {
        return assertLogicalExpression;
    },
    assertLoop: function() {
        return assertLoop;
    },
    assertMemberExpression: function() {
        return assertMemberExpression;
    },
    assertMetaProperty: function() {
        return assertMetaProperty;
    },
    assertMethod: function() {
        return assertMethod;
    },
    assertMiscellaneous: function() {
        return assertMiscellaneous;
    },
    assertMixedTypeAnnotation: function() {
        return assertMixedTypeAnnotation;
    },
    assertModuleDeclaration: function() {
        return assertModuleDeclaration;
    },
    assertModuleExpression: function() {
        return assertModuleExpression;
    },
    assertModuleSpecifier: function() {
        return assertModuleSpecifier;
    },
    assertNewExpression: function() {
        return assertNewExpression;
    },
    assertNode: function() {
        return assertNode;
    },
    assertNoop: function() {
        return assertNoop;
    },
    assertNullLiteral: function() {
        return assertNullLiteral;
    },
    assertNullLiteralTypeAnnotation: function() {
        return assertNullLiteralTypeAnnotation;
    },
    assertNullableTypeAnnotation: function() {
        return assertNullableTypeAnnotation;
    },
    assertNumberLiteral: function() {
        return assertNumberLiteral;
    },
    assertNumberLiteralTypeAnnotation: function() {
        return assertNumberLiteralTypeAnnotation;
    },
    assertNumberTypeAnnotation: function() {
        return assertNumberTypeAnnotation;
    },
    assertNumericLiteral: function() {
        return assertNumericLiteral;
    },
    assertObjectExpression: function() {
        return assertObjectExpression;
    },
    assertObjectMember: function() {
        return assertObjectMember;
    },
    assertObjectMethod: function() {
        return assertObjectMethod;
    },
    assertObjectPattern: function() {
        return assertObjectPattern;
    },
    assertObjectProperty: function() {
        return assertObjectProperty;
    },
    assertObjectTypeAnnotation: function() {
        return assertObjectTypeAnnotation;
    },
    assertObjectTypeCallProperty: function() {
        return assertObjectTypeCallProperty;
    },
    assertObjectTypeIndexer: function() {
        return assertObjectTypeIndexer;
    },
    assertObjectTypeInternalSlot: function() {
        return assertObjectTypeInternalSlot;
    },
    assertObjectTypeProperty: function() {
        return assertObjectTypeProperty;
    },
    assertObjectTypeSpreadProperty: function() {
        return assertObjectTypeSpreadProperty;
    },
    assertOpaqueType: function() {
        return assertOpaqueType;
    },
    assertOptionalCallExpression: function() {
        return assertOptionalCallExpression;
    },
    assertOptionalIndexedAccessType: function() {
        return assertOptionalIndexedAccessType;
    },
    assertOptionalMemberExpression: function() {
        return assertOptionalMemberExpression;
    },
    assertParenthesizedExpression: function() {
        return assertParenthesizedExpression;
    },
    assertPattern: function() {
        return assertPattern;
    },
    assertPatternLike: function() {
        return assertPatternLike;
    },
    assertPipelineBareFunction: function() {
        return assertPipelineBareFunction;
    },
    assertPipelinePrimaryTopicReference: function() {
        return assertPipelinePrimaryTopicReference;
    },
    assertPipelineTopicExpression: function() {
        return assertPipelineTopicExpression;
    },
    assertPlaceholder: function() {
        return assertPlaceholder;
    },
    assertPrivate: function() {
        return assertPrivate;
    },
    assertPrivateName: function() {
        return assertPrivateName;
    },
    assertProgram: function() {
        return assertProgram;
    },
    assertProperty: function() {
        return assertProperty;
    },
    assertPureish: function() {
        return assertPureish;
    },
    assertQualifiedTypeIdentifier: function() {
        return assertQualifiedTypeIdentifier;
    },
    assertRecordExpression: function() {
        return assertRecordExpression;
    },
    assertRegExpLiteral: function() {
        return assertRegExpLiteral;
    },
    assertRegexLiteral: function() {
        return assertRegexLiteral;
    },
    assertRestElement: function() {
        return assertRestElement;
    },
    assertRestProperty: function() {
        return assertRestProperty;
    },
    assertReturnStatement: function() {
        return assertReturnStatement;
    },
    assertScopable: function() {
        return assertScopable;
    },
    assertSequenceExpression: function() {
        return assertSequenceExpression;
    },
    assertSpreadElement: function() {
        return assertSpreadElement;
    },
    assertSpreadProperty: function() {
        return assertSpreadProperty;
    },
    assertStandardized: function() {
        return assertStandardized;
    },
    assertStatement: function() {
        return assertStatement;
    },
    assertStaticBlock: function() {
        return assertStaticBlock;
    },
    assertStringLiteral: function() {
        return assertStringLiteral;
    },
    assertStringLiteralTypeAnnotation: function() {
        return assertStringLiteralTypeAnnotation;
    },
    assertStringTypeAnnotation: function() {
        return assertStringTypeAnnotation;
    },
    assertSuper: function() {
        return assertSuper;
    },
    assertSwitchCase: function() {
        return assertSwitchCase;
    },
    assertSwitchStatement: function() {
        return assertSwitchStatement;
    },
    assertSymbolTypeAnnotation: function() {
        return assertSymbolTypeAnnotation;
    },
    assertTSAnyKeyword: function() {
        return assertTSAnyKeyword;
    },
    assertTSArrayType: function() {
        return assertTSArrayType;
    },
    assertTSAsExpression: function() {
        return assertTSAsExpression;
    },
    assertTSBaseType: function() {
        return assertTSBaseType;
    },
    assertTSBigIntKeyword: function() {
        return assertTSBigIntKeyword;
    },
    assertTSBooleanKeyword: function() {
        return assertTSBooleanKeyword;
    },
    assertTSCallSignatureDeclaration: function() {
        return assertTSCallSignatureDeclaration;
    },
    assertTSConditionalType: function() {
        return assertTSConditionalType;
    },
    assertTSConstructSignatureDeclaration: function() {
        return assertTSConstructSignatureDeclaration;
    },
    assertTSConstructorType: function() {
        return assertTSConstructorType;
    },
    assertTSDeclareFunction: function() {
        return assertTSDeclareFunction;
    },
    assertTSDeclareMethod: function() {
        return assertTSDeclareMethod;
    },
    assertTSEntityName: function() {
        return assertTSEntityName;
    },
    assertTSEnumDeclaration: function() {
        return assertTSEnumDeclaration;
    },
    assertTSEnumMember: function() {
        return assertTSEnumMember;
    },
    assertTSExportAssignment: function() {
        return assertTSExportAssignment;
    },
    assertTSExpressionWithTypeArguments: function() {
        return assertTSExpressionWithTypeArguments;
    },
    assertTSExternalModuleReference: function() {
        return assertTSExternalModuleReference;
    },
    assertTSFunctionType: function() {
        return assertTSFunctionType;
    },
    assertTSImportEqualsDeclaration: function() {
        return assertTSImportEqualsDeclaration;
    },
    assertTSImportType: function() {
        return assertTSImportType;
    },
    assertTSIndexSignature: function() {
        return assertTSIndexSignature;
    },
    assertTSIndexedAccessType: function() {
        return assertTSIndexedAccessType;
    },
    assertTSInferType: function() {
        return assertTSInferType;
    },
    assertTSInstantiationExpression: function() {
        return assertTSInstantiationExpression;
    },
    assertTSInterfaceBody: function() {
        return assertTSInterfaceBody;
    },
    assertTSInterfaceDeclaration: function() {
        return assertTSInterfaceDeclaration;
    },
    assertTSIntersectionType: function() {
        return assertTSIntersectionType;
    },
    assertTSIntrinsicKeyword: function() {
        return assertTSIntrinsicKeyword;
    },
    assertTSLiteralType: function() {
        return assertTSLiteralType;
    },
    assertTSMappedType: function() {
        return assertTSMappedType;
    },
    assertTSMethodSignature: function() {
        return assertTSMethodSignature;
    },
    assertTSModuleBlock: function() {
        return assertTSModuleBlock;
    },
    assertTSModuleDeclaration: function() {
        return assertTSModuleDeclaration;
    },
    assertTSNamedTupleMember: function() {
        return assertTSNamedTupleMember;
    },
    assertTSNamespaceExportDeclaration: function() {
        return assertTSNamespaceExportDeclaration;
    },
    assertTSNeverKeyword: function() {
        return assertTSNeverKeyword;
    },
    assertTSNonNullExpression: function() {
        return assertTSNonNullExpression;
    },
    assertTSNullKeyword: function() {
        return assertTSNullKeyword;
    },
    assertTSNumberKeyword: function() {
        return assertTSNumberKeyword;
    },
    assertTSObjectKeyword: function() {
        return assertTSObjectKeyword;
    },
    assertTSOptionalType: function() {
        return assertTSOptionalType;
    },
    assertTSParameterProperty: function() {
        return assertTSParameterProperty;
    },
    assertTSParenthesizedType: function() {
        return assertTSParenthesizedType;
    },
    assertTSPropertySignature: function() {
        return assertTSPropertySignature;
    },
    assertTSQualifiedName: function() {
        return assertTSQualifiedName;
    },
    assertTSRestType: function() {
        return assertTSRestType;
    },
    assertTSSatisfiesExpression: function() {
        return assertTSSatisfiesExpression;
    },
    assertTSStringKeyword: function() {
        return assertTSStringKeyword;
    },
    assertTSSymbolKeyword: function() {
        return assertTSSymbolKeyword;
    },
    assertTSThisType: function() {
        return assertTSThisType;
    },
    assertTSTupleType: function() {
        return assertTSTupleType;
    },
    assertTSType: function() {
        return assertTSType;
    },
    assertTSTypeAliasDeclaration: function() {
        return assertTSTypeAliasDeclaration;
    },
    assertTSTypeAnnotation: function() {
        return assertTSTypeAnnotation;
    },
    assertTSTypeAssertion: function() {
        return assertTSTypeAssertion;
    },
    assertTSTypeElement: function() {
        return assertTSTypeElement;
    },
    assertTSTypeLiteral: function() {
        return assertTSTypeLiteral;
    },
    assertTSTypeOperator: function() {
        return assertTSTypeOperator;
    },
    assertTSTypeParameter: function() {
        return assertTSTypeParameter;
    },
    assertTSTypeParameterDeclaration: function() {
        return assertTSTypeParameterDeclaration;
    },
    assertTSTypeParameterInstantiation: function() {
        return assertTSTypeParameterInstantiation;
    },
    assertTSTypePredicate: function() {
        return assertTSTypePredicate;
    },
    assertTSTypeQuery: function() {
        return assertTSTypeQuery;
    },
    assertTSTypeReference: function() {
        return assertTSTypeReference;
    },
    assertTSUndefinedKeyword: function() {
        return assertTSUndefinedKeyword;
    },
    assertTSUnionType: function() {
        return assertTSUnionType;
    },
    assertTSUnknownKeyword: function() {
        return assertTSUnknownKeyword;
    },
    assertTSVoidKeyword: function() {
        return assertTSVoidKeyword;
    },
    assertTaggedTemplateExpression: function() {
        return assertTaggedTemplateExpression;
    },
    assertTemplateElement: function() {
        return assertTemplateElement;
    },
    assertTemplateLiteral: function() {
        return assertTemplateLiteral;
    },
    assertTerminatorless: function() {
        return assertTerminatorless;
    },
    assertThisExpression: function() {
        return assertThisExpression;
    },
    assertThisTypeAnnotation: function() {
        return assertThisTypeAnnotation;
    },
    assertThrowStatement: function() {
        return assertThrowStatement;
    },
    assertTopicReference: function() {
        return assertTopicReference;
    },
    assertTryStatement: function() {
        return assertTryStatement;
    },
    assertTupleExpression: function() {
        return assertTupleExpression;
    },
    assertTupleTypeAnnotation: function() {
        return assertTupleTypeAnnotation;
    },
    assertTypeAlias: function() {
        return assertTypeAlias;
    },
    assertTypeAnnotation: function() {
        return assertTypeAnnotation;
    },
    assertTypeCastExpression: function() {
        return assertTypeCastExpression;
    },
    assertTypeParameter: function() {
        return assertTypeParameter;
    },
    assertTypeParameterDeclaration: function() {
        return assertTypeParameterDeclaration;
    },
    assertTypeParameterInstantiation: function() {
        return assertTypeParameterInstantiation;
    },
    assertTypeScript: function() {
        return assertTypeScript;
    },
    assertTypeofTypeAnnotation: function() {
        return assertTypeofTypeAnnotation;
    },
    assertUnaryExpression: function() {
        return assertUnaryExpression;
    },
    assertUnaryLike: function() {
        return assertUnaryLike;
    },
    assertUnionTypeAnnotation: function() {
        return assertUnionTypeAnnotation;
    },
    assertUpdateExpression: function() {
        return assertUpdateExpression;
    },
    assertUserWhitespacable: function() {
        return assertUserWhitespacable;
    },
    assertV8IntrinsicIdentifier: function() {
        return assertV8IntrinsicIdentifier;
    },
    assertVariableDeclaration: function() {
        return assertVariableDeclaration;
    },
    assertVariableDeclarator: function() {
        return assertVariableDeclarator;
    },
    assertVariance: function() {
        return assertVariance;
    },
    assertVoidTypeAnnotation: function() {
        return assertVoidTypeAnnotation;
    },
    assertWhile: function() {
        return assertWhile;
    },
    assertWhileStatement: function() {
        return assertWhileStatement;
    },
    assertWithStatement: function() {
        return assertWithStatement;
    },
    assertYieldExpression: function() {
        return assertYieldExpression;
    },
    assignmentExpression: function() {
        return assignmentExpression;
    },
    assignmentPattern: function() {
        return assignmentPattern;
    },
    awaitExpression: function() {
        return awaitExpression;
    },
    bigIntLiteral: function() {
        return bigIntLiteral;
    },
    binaryExpression: function() {
        return binaryExpression;
    },
    bindExpression: function() {
        return bindExpression;
    },
    blockStatement: function() {
        return blockStatement;
    },
    booleanLiteral: function() {
        return booleanLiteral;
    },
    booleanLiteralTypeAnnotation: function() {
        return booleanLiteralTypeAnnotation;
    },
    booleanTypeAnnotation: function() {
        return booleanTypeAnnotation;
    },
    breakStatement: function() {
        return breakStatement;
    },
    buildMatchMemberExpression: function() {
        return buildMatchMemberExpression;
    },
    buildUndefinedNode: function() {
        return buildUndefinedNode;
    },
    callExpression: function() {
        return callExpression;
    },
    catchClause: function() {
        return catchClause;
    },
    classAccessorProperty: function() {
        return classAccessorProperty;
    },
    classBody: function() {
        return classBody;
    },
    classDeclaration: function() {
        return classDeclaration;
    },
    classExpression: function() {
        return classExpression;
    },
    classImplements: function() {
        return classImplements;
    },
    classMethod: function() {
        return classMethod;
    },
    classPrivateMethod: function() {
        return classPrivateMethod;
    },
    classPrivateProperty: function() {
        return classPrivateProperty;
    },
    classProperty: function() {
        return classProperty;
    },
    clone: function() {
        return clone;
    },
    cloneDeep: function() {
        return cloneDeep;
    },
    cloneDeepWithoutLoc: function() {
        return cloneDeepWithoutLoc;
    },
    cloneNode: function() {
        return cloneNode;
    },
    cloneWithoutLoc: function() {
        return cloneWithoutLoc;
    },
    conditionalExpression: function() {
        return conditionalExpression;
    },
    continueStatement: function() {
        return continueStatement;
    },
    createFlowUnionType: function() {
        return createFlowUnionType;
    },
    createTSUnionType: function() {
        return createTSUnionType;
    },
    createTypeAnnotationBasedOnTypeof: function() {
        return createTypeAnnotationBasedOnTypeof;
    },
    createUnionTypeAnnotation: function() {
        return createFlowUnionType;
    },
    debuggerStatement: function() {
        return debuggerStatement;
    },
    decimalLiteral: function() {
        return decimalLiteral;
    },
    declareClass: function() {
        return declareClass;
    },
    declareExportAllDeclaration: function() {
        return declareExportAllDeclaration;
    },
    declareExportDeclaration: function() {
        return declareExportDeclaration;
    },
    declareFunction: function() {
        return declareFunction;
    },
    declareInterface: function() {
        return declareInterface;
    },
    declareModule: function() {
        return declareModule;
    },
    declareModuleExports: function() {
        return declareModuleExports;
    },
    declareOpaqueType: function() {
        return declareOpaqueType;
    },
    declareTypeAlias: function() {
        return declareTypeAlias;
    },
    declareVariable: function() {
        return declareVariable;
    },
    declaredPredicate: function() {
        return declaredPredicate;
    },
    decorator: function() {
        return decorator;
    },
    directive: function() {
        return directive;
    },
    directiveLiteral: function() {
        return directiveLiteral;
    },
    doExpression: function() {
        return doExpression;
    },
    doWhileStatement: function() {
        return doWhileStatement;
    },
    emptyStatement: function() {
        return emptyStatement;
    },
    emptyTypeAnnotation: function() {
        return emptyTypeAnnotation;
    },
    ensureBlock: function() {
        return ensureBlock;
    },
    enumBooleanBody: function() {
        return enumBooleanBody;
    },
    enumBooleanMember: function() {
        return enumBooleanMember;
    },
    enumDeclaration: function() {
        return enumDeclaration;
    },
    enumDefaultedMember: function() {
        return enumDefaultedMember;
    },
    enumNumberBody: function() {
        return enumNumberBody;
    },
    enumNumberMember: function() {
        return enumNumberMember;
    },
    enumStringBody: function() {
        return enumStringBody;
    },
    enumStringMember: function() {
        return enumStringMember;
    },
    enumSymbolBody: function() {
        return enumSymbolBody;
    },
    existsTypeAnnotation: function() {
        return existsTypeAnnotation;
    },
    exportAllDeclaration: function() {
        return exportAllDeclaration;
    },
    exportDefaultDeclaration: function() {
        return exportDefaultDeclaration;
    },
    exportDefaultSpecifier: function() {
        return exportDefaultSpecifier;
    },
    exportNamedDeclaration: function() {
        return exportNamedDeclaration;
    },
    exportNamespaceSpecifier: function() {
        return exportNamespaceSpecifier;
    },
    exportSpecifier: function() {
        return exportSpecifier;
    },
    expressionStatement: function() {
        return expressionStatement;
    },
    file: function() {
        return file;
    },
    forInStatement: function() {
        return forInStatement;
    },
    forOfStatement: function() {
        return forOfStatement;
    },
    forStatement: function() {
        return forStatement;
    },
    functionDeclaration: function() {
        return functionDeclaration;
    },
    functionExpression: function() {
        return functionExpression;
    },
    functionTypeAnnotation: function() {
        return functionTypeAnnotation;
    },
    functionTypeParam: function() {
        return functionTypeParam;
    },
    genericTypeAnnotation: function() {
        return genericTypeAnnotation;
    },
    getBindingIdentifiers: function() {
        return getBindingIdentifiers;
    },
    getOuterBindingIdentifiers: function() {
        return getOuterBindingIdentifiers;
    },
    identifier: function() {
        return identifier;
    },
    ifStatement: function() {
        return ifStatement;
    },
    import: function() {
        return _import;
    },
    importAttribute: function() {
        return importAttribute;
    },
    importDeclaration: function() {
        return importDeclaration;
    },
    importDefaultSpecifier: function() {
        return importDefaultSpecifier;
    },
    importExpression: function() {
        return importExpression;
    },
    importNamespaceSpecifier: function() {
        return importNamespaceSpecifier;
    },
    importSpecifier: function() {
        return importSpecifier;
    },
    indexedAccessType: function() {
        return indexedAccessType;
    },
    inferredPredicate: function() {
        return inferredPredicate;
    },
    inheritInnerComments: function() {
        return inheritInnerComments;
    },
    inheritLeadingComments: function() {
        return inheritLeadingComments;
    },
    inheritTrailingComments: function() {
        return inheritTrailingComments;
    },
    inherits: function() {
        return inherits;
    },
    inheritsComments: function() {
        return inheritsComments;
    },
    interfaceDeclaration: function() {
        return interfaceDeclaration;
    },
    interfaceExtends: function() {
        return interfaceExtends;
    },
    interfaceTypeAnnotation: function() {
        return interfaceTypeAnnotation;
    },
    interpreterDirective: function() {
        return interpreterDirective;
    },
    intersectionTypeAnnotation: function() {
        return intersectionTypeAnnotation;
    },
    is: function() {
        return is;
    },
    isAccessor: function() {
        return isAccessor;
    },
    isAnyTypeAnnotation: function() {
        return isAnyTypeAnnotation;
    },
    isArgumentPlaceholder: function() {
        return isArgumentPlaceholder;
    },
    isArrayExpression: function() {
        return isArrayExpression;
    },
    isArrayPattern: function() {
        return isArrayPattern;
    },
    isArrayTypeAnnotation: function() {
        return isArrayTypeAnnotation;
    },
    isArrowFunctionExpression: function() {
        return isArrowFunctionExpression;
    },
    isAssignmentExpression: function() {
        return isAssignmentExpression;
    },
    isAssignmentPattern: function() {
        return isAssignmentPattern;
    },
    isAwaitExpression: function() {
        return isAwaitExpression;
    },
    isBigIntLiteral: function() {
        return isBigIntLiteral;
    },
    isBinary: function() {
        return isBinary;
    },
    isBinaryExpression: function() {
        return isBinaryExpression;
    },
    isBindExpression: function() {
        return isBindExpression;
    },
    isBinding: function() {
        return isBinding;
    },
    isBlock: function() {
        return isBlock;
    },
    isBlockParent: function() {
        return isBlockParent;
    },
    isBlockScoped: function() {
        return isBlockScoped;
    },
    isBlockStatement: function() {
        return isBlockStatement;
    },
    isBooleanLiteral: function() {
        return isBooleanLiteral;
    },
    isBooleanLiteralTypeAnnotation: function() {
        return isBooleanLiteralTypeAnnotation;
    },
    isBooleanTypeAnnotation: function() {
        return isBooleanTypeAnnotation;
    },
    isBreakStatement: function() {
        return isBreakStatement;
    },
    isCallExpression: function() {
        return isCallExpression;
    },
    isCatchClause: function() {
        return isCatchClause;
    },
    isClass: function() {
        return isClass;
    },
    isClassAccessorProperty: function() {
        return isClassAccessorProperty;
    },
    isClassBody: function() {
        return isClassBody;
    },
    isClassDeclaration: function() {
        return isClassDeclaration;
    },
    isClassExpression: function() {
        return isClassExpression;
    },
    isClassImplements: function() {
        return isClassImplements;
    },
    isClassMethod: function() {
        return isClassMethod;
    },
    isClassPrivateMethod: function() {
        return isClassPrivateMethod;
    },
    isClassPrivateProperty: function() {
        return isClassPrivateProperty;
    },
    isClassProperty: function() {
        return isClassProperty;
    },
    isCompletionStatement: function() {
        return isCompletionStatement;
    },
    isConditional: function() {
        return isConditional;
    },
    isConditionalExpression: function() {
        return isConditionalExpression;
    },
    isContinueStatement: function() {
        return isContinueStatement;
    },
    isDebuggerStatement: function() {
        return isDebuggerStatement;
    },
    isDecimalLiteral: function() {
        return isDecimalLiteral;
    },
    isDeclaration: function() {
        return isDeclaration;
    },
    isDeclareClass: function() {
        return isDeclareClass;
    },
    isDeclareExportAllDeclaration: function() {
        return isDeclareExportAllDeclaration;
    },
    isDeclareExportDeclaration: function() {
        return isDeclareExportDeclaration;
    },
    isDeclareFunction: function() {
        return isDeclareFunction;
    },
    isDeclareInterface: function() {
        return isDeclareInterface;
    },
    isDeclareModule: function() {
        return isDeclareModule;
    },
    isDeclareModuleExports: function() {
        return isDeclareModuleExports;
    },
    isDeclareOpaqueType: function() {
        return isDeclareOpaqueType;
    },
    isDeclareTypeAlias: function() {
        return isDeclareTypeAlias;
    },
    isDeclareVariable: function() {
        return isDeclareVariable;
    },
    isDeclaredPredicate: function() {
        return isDeclaredPredicate;
    },
    isDecorator: function() {
        return isDecorator;
    },
    isDirective: function() {
        return isDirective;
    },
    isDirectiveLiteral: function() {
        return isDirectiveLiteral;
    },
    isDoExpression: function() {
        return isDoExpression;
    },
    isDoWhileStatement: function() {
        return isDoWhileStatement;
    },
    isEmptyStatement: function() {
        return isEmptyStatement;
    },
    isEmptyTypeAnnotation: function() {
        return isEmptyTypeAnnotation;
    },
    isEnumBody: function() {
        return isEnumBody;
    },
    isEnumBooleanBody: function() {
        return isEnumBooleanBody;
    },
    isEnumBooleanMember: function() {
        return isEnumBooleanMember;
    },
    isEnumDeclaration: function() {
        return isEnumDeclaration;
    },
    isEnumDefaultedMember: function() {
        return isEnumDefaultedMember;
    },
    isEnumMember: function() {
        return isEnumMember;
    },
    isEnumNumberBody: function() {
        return isEnumNumberBody;
    },
    isEnumNumberMember: function() {
        return isEnumNumberMember;
    },
    isEnumStringBody: function() {
        return isEnumStringBody;
    },
    isEnumStringMember: function() {
        return isEnumStringMember;
    },
    isEnumSymbolBody: function() {
        return isEnumSymbolBody;
    },
    isExistsTypeAnnotation: function() {
        return isExistsTypeAnnotation;
    },
    isExportAllDeclaration: function() {
        return isExportAllDeclaration;
    },
    isExportDeclaration: function() {
        return isExportDeclaration;
    },
    isExportDefaultDeclaration: function() {
        return isExportDefaultDeclaration;
    },
    isExportDefaultSpecifier: function() {
        return isExportDefaultSpecifier;
    },
    isExportNamedDeclaration: function() {
        return isExportNamedDeclaration;
    },
    isExportNamespaceSpecifier: function() {
        return isExportNamespaceSpecifier;
    },
    isExportSpecifier: function() {
        return isExportSpecifier;
    },
    isExpression: function() {
        return isExpression;
    },
    isExpressionStatement: function() {
        return isExpressionStatement;
    },
    isExpressionWrapper: function() {
        return isExpressionWrapper;
    },
    isFile: function() {
        return isFile;
    },
    isFlow: function() {
        return isFlow;
    },
    isFlowBaseAnnotation: function() {
        return isFlowBaseAnnotation;
    },
    isFlowDeclaration: function() {
        return isFlowDeclaration;
    },
    isFlowPredicate: function() {
        return isFlowPredicate;
    },
    isFlowType: function() {
        return isFlowType;
    },
    isFor: function() {
        return isFor;
    },
    isForInStatement: function() {
        return isForInStatement;
    },
    isForOfStatement: function() {
        return isForOfStatement;
    },
    isForStatement: function() {
        return isForStatement;
    },
    isForXStatement: function() {
        return isForXStatement;
    },
    isFunction: function() {
        return isFunction;
    },
    isFunctionDeclaration: function() {
        return isFunctionDeclaration;
    },
    isFunctionExpression: function() {
        return isFunctionExpression;
    },
    isFunctionParent: function() {
        return isFunctionParent;
    },
    isFunctionTypeAnnotation: function() {
        return isFunctionTypeAnnotation;
    },
    isFunctionTypeParam: function() {
        return isFunctionTypeParam;
    },
    isGenericTypeAnnotation: function() {
        return isGenericTypeAnnotation;
    },
    isIdentifier: function() {
        return isIdentifier;
    },
    isIfStatement: function() {
        return isIfStatement;
    },
    isImmutable: function() {
        return isImmutable;
    },
    isImport: function() {
        return isImport;
    },
    isImportAttribute: function() {
        return isImportAttribute;
    },
    isImportDeclaration: function() {
        return isImportDeclaration;
    },
    isImportDefaultSpecifier: function() {
        return isImportDefaultSpecifier;
    },
    isImportExpression: function() {
        return isImportExpression;
    },
    isImportNamespaceSpecifier: function() {
        return isImportNamespaceSpecifier;
    },
    isImportOrExportDeclaration: function() {
        return isImportOrExportDeclaration;
    },
    isImportSpecifier: function() {
        return isImportSpecifier;
    },
    isIndexedAccessType: function() {
        return isIndexedAccessType;
    },
    isInferredPredicate: function() {
        return isInferredPredicate;
    },
    isInterfaceDeclaration: function() {
        return isInterfaceDeclaration;
    },
    isInterfaceExtends: function() {
        return isInterfaceExtends;
    },
    isInterfaceTypeAnnotation: function() {
        return isInterfaceTypeAnnotation;
    },
    isInterpreterDirective: function() {
        return isInterpreterDirective;
    },
    isIntersectionTypeAnnotation: function() {
        return isIntersectionTypeAnnotation;
    },
    isJSX: function() {
        return isJSX;
    },
    isJSXAttribute: function() {
        return isJSXAttribute;
    },
    isJSXClosingElement: function() {
        return isJSXClosingElement;
    },
    isJSXClosingFragment: function() {
        return isJSXClosingFragment;
    },
    isJSXElement: function() {
        return isJSXElement;
    },
    isJSXEmptyExpression: function() {
        return isJSXEmptyExpression;
    },
    isJSXExpressionContainer: function() {
        return isJSXExpressionContainer;
    },
    isJSXFragment: function() {
        return isJSXFragment;
    },
    isJSXIdentifier: function() {
        return isJSXIdentifier;
    },
    isJSXMemberExpression: function() {
        return isJSXMemberExpression;
    },
    isJSXNamespacedName: function() {
        return isJSXNamespacedName;
    },
    isJSXOpeningElement: function() {
        return isJSXOpeningElement;
    },
    isJSXOpeningFragment: function() {
        return isJSXOpeningFragment;
    },
    isJSXSpreadAttribute: function() {
        return isJSXSpreadAttribute;
    },
    isJSXSpreadChild: function() {
        return isJSXSpreadChild;
    },
    isJSXText: function() {
        return isJSXText;
    },
    isLVal: function() {
        return isLVal;
    },
    isLabeledStatement: function() {
        return isLabeledStatement;
    },
    isLet: function() {
        return isLet;
    },
    isLiteral: function() {
        return isLiteral;
    },
    isLogicalExpression: function() {
        return isLogicalExpression;
    },
    isLoop: function() {
        return isLoop;
    },
    isMemberExpression: function() {
        return isMemberExpression;
    },
    isMetaProperty: function() {
        return isMetaProperty;
    },
    isMethod: function() {
        return isMethod;
    },
    isMiscellaneous: function() {
        return isMiscellaneous;
    },
    isMixedTypeAnnotation: function() {
        return isMixedTypeAnnotation;
    },
    isModuleDeclaration: function() {
        return isModuleDeclaration;
    },
    isModuleExpression: function() {
        return isModuleExpression;
    },
    isModuleSpecifier: function() {
        return isModuleSpecifier;
    },
    isNewExpression: function() {
        return isNewExpression;
    },
    isNode: function() {
        return isNode;
    },
    isNodesEquivalent: function() {
        return isNodesEquivalent;
    },
    isNoop: function() {
        return isNoop;
    },
    isNullLiteral: function() {
        return isNullLiteral;
    },
    isNullLiteralTypeAnnotation: function() {
        return isNullLiteralTypeAnnotation;
    },
    isNullableTypeAnnotation: function() {
        return isNullableTypeAnnotation;
    },
    isNumberLiteral: function() {
        return isNumberLiteral;
    },
    isNumberLiteralTypeAnnotation: function() {
        return isNumberLiteralTypeAnnotation;
    },
    isNumberTypeAnnotation: function() {
        return isNumberTypeAnnotation;
    },
    isNumericLiteral: function() {
        return isNumericLiteral;
    },
    isObjectExpression: function() {
        return isObjectExpression;
    },
    isObjectMember: function() {
        return isObjectMember;
    },
    isObjectMethod: function() {
        return isObjectMethod;
    },
    isObjectPattern: function() {
        return isObjectPattern;
    },
    isObjectProperty: function() {
        return isObjectProperty;
    },
    isObjectTypeAnnotation: function() {
        return isObjectTypeAnnotation;
    },
    isObjectTypeCallProperty: function() {
        return isObjectTypeCallProperty;
    },
    isObjectTypeIndexer: function() {
        return isObjectTypeIndexer;
    },
    isObjectTypeInternalSlot: function() {
        return isObjectTypeInternalSlot;
    },
    isObjectTypeProperty: function() {
        return isObjectTypeProperty;
    },
    isObjectTypeSpreadProperty: function() {
        return isObjectTypeSpreadProperty;
    },
    isOpaqueType: function() {
        return isOpaqueType;
    },
    isOptionalCallExpression: function() {
        return isOptionalCallExpression;
    },
    isOptionalIndexedAccessType: function() {
        return isOptionalIndexedAccessType;
    },
    isOptionalMemberExpression: function() {
        return isOptionalMemberExpression;
    },
    isParenthesizedExpression: function() {
        return isParenthesizedExpression;
    },
    isPattern: function() {
        return isPattern;
    },
    isPatternLike: function() {
        return isPatternLike;
    },
    isPipelineBareFunction: function() {
        return isPipelineBareFunction;
    },
    isPipelinePrimaryTopicReference: function() {
        return isPipelinePrimaryTopicReference;
    },
    isPipelineTopicExpression: function() {
        return isPipelineTopicExpression;
    },
    isPlaceholder: function() {
        return isPlaceholder;
    },
    isPlaceholderType: function() {
        return isPlaceholderType;
    },
    isPrivate: function() {
        return isPrivate;
    },
    isPrivateName: function() {
        return isPrivateName;
    },
    isProgram: function() {
        return isProgram;
    },
    isProperty: function() {
        return isProperty;
    },
    isPureish: function() {
        return isPureish;
    },
    isQualifiedTypeIdentifier: function() {
        return isQualifiedTypeIdentifier;
    },
    isRecordExpression: function() {
        return isRecordExpression;
    },
    isReferenced: function() {
        return isReferenced;
    },
    isRegExpLiteral: function() {
        return isRegExpLiteral;
    },
    isRegexLiteral: function() {
        return isRegexLiteral;
    },
    isRestElement: function() {
        return isRestElement;
    },
    isRestProperty: function() {
        return isRestProperty;
    },
    isReturnStatement: function() {
        return isReturnStatement;
    },
    isScopable: function() {
        return isScopable;
    },
    isScope: function() {
        return isScope;
    },
    isSequenceExpression: function() {
        return isSequenceExpression;
    },
    isSpecifierDefault: function() {
        return isSpecifierDefault;
    },
    isSpreadElement: function() {
        return isSpreadElement;
    },
    isSpreadProperty: function() {
        return isSpreadProperty;
    },
    isStandardized: function() {
        return isStandardized;
    },
    isStatement: function() {
        return isStatement;
    },
    isStaticBlock: function() {
        return isStaticBlock;
    },
    isStringLiteral: function() {
        return isStringLiteral;
    },
    isStringLiteralTypeAnnotation: function() {
        return isStringLiteralTypeAnnotation;
    },
    isStringTypeAnnotation: function() {
        return isStringTypeAnnotation;
    },
    isSuper: function() {
        return isSuper;
    },
    isSwitchCase: function() {
        return isSwitchCase;
    },
    isSwitchStatement: function() {
        return isSwitchStatement;
    },
    isSymbolTypeAnnotation: function() {
        return isSymbolTypeAnnotation;
    },
    isTSAnyKeyword: function() {
        return isTSAnyKeyword;
    },
    isTSArrayType: function() {
        return isTSArrayType;
    },
    isTSAsExpression: function() {
        return isTSAsExpression;
    },
    isTSBaseType: function() {
        return isTSBaseType;
    },
    isTSBigIntKeyword: function() {
        return isTSBigIntKeyword;
    },
    isTSBooleanKeyword: function() {
        return isTSBooleanKeyword;
    },
    isTSCallSignatureDeclaration: function() {
        return isTSCallSignatureDeclaration;
    },
    isTSConditionalType: function() {
        return isTSConditionalType;
    },
    isTSConstructSignatureDeclaration: function() {
        return isTSConstructSignatureDeclaration;
    },
    isTSConstructorType: function() {
        return isTSConstructorType;
    },
    isTSDeclareFunction: function() {
        return isTSDeclareFunction;
    },
    isTSDeclareMethod: function() {
        return isTSDeclareMethod;
    },
    isTSEntityName: function() {
        return isTSEntityName;
    },
    isTSEnumDeclaration: function() {
        return isTSEnumDeclaration;
    },
    isTSEnumMember: function() {
        return isTSEnumMember;
    },
    isTSExportAssignment: function() {
        return isTSExportAssignment;
    },
    isTSExpressionWithTypeArguments: function() {
        return isTSExpressionWithTypeArguments;
    },
    isTSExternalModuleReference: function() {
        return isTSExternalModuleReference;
    },
    isTSFunctionType: function() {
        return isTSFunctionType;
    },
    isTSImportEqualsDeclaration: function() {
        return isTSImportEqualsDeclaration;
    },
    isTSImportType: function() {
        return isTSImportType;
    },
    isTSIndexSignature: function() {
        return isTSIndexSignature;
    },
    isTSIndexedAccessType: function() {
        return isTSIndexedAccessType;
    },
    isTSInferType: function() {
        return isTSInferType;
    },
    isTSInstantiationExpression: function() {
        return isTSInstantiationExpression;
    },
    isTSInterfaceBody: function() {
        return isTSInterfaceBody;
    },
    isTSInterfaceDeclaration: function() {
        return isTSInterfaceDeclaration;
    },
    isTSIntersectionType: function() {
        return isTSIntersectionType;
    },
    isTSIntrinsicKeyword: function() {
        return isTSIntrinsicKeyword;
    },
    isTSLiteralType: function() {
        return isTSLiteralType;
    },
    isTSMappedType: function() {
        return isTSMappedType;
    },
    isTSMethodSignature: function() {
        return isTSMethodSignature;
    },
    isTSModuleBlock: function() {
        return isTSModuleBlock;
    },
    isTSModuleDeclaration: function() {
        return isTSModuleDeclaration;
    },
    isTSNamedTupleMember: function() {
        return isTSNamedTupleMember;
    },
    isTSNamespaceExportDeclaration: function() {
        return isTSNamespaceExportDeclaration;
    },
    isTSNeverKeyword: function() {
        return isTSNeverKeyword;
    },
    isTSNonNullExpression: function() {
        return isTSNonNullExpression;
    },
    isTSNullKeyword: function() {
        return isTSNullKeyword;
    },
    isTSNumberKeyword: function() {
        return isTSNumberKeyword;
    },
    isTSObjectKeyword: function() {
        return isTSObjectKeyword;
    },
    isTSOptionalType: function() {
        return isTSOptionalType;
    },
    isTSParameterProperty: function() {
        return isTSParameterProperty;
    },
    isTSParenthesizedType: function() {
        return isTSParenthesizedType;
    },
    isTSPropertySignature: function() {
        return isTSPropertySignature;
    },
    isTSQualifiedName: function() {
        return isTSQualifiedName;
    },
    isTSRestType: function() {
        return isTSRestType;
    },
    isTSSatisfiesExpression: function() {
        return isTSSatisfiesExpression;
    },
    isTSStringKeyword: function() {
        return isTSStringKeyword;
    },
    isTSSymbolKeyword: function() {
        return isTSSymbolKeyword;
    },
    isTSThisType: function() {
        return isTSThisType;
    },
    isTSTupleType: function() {
        return isTSTupleType;
    },
    isTSType: function() {
        return isTSType;
    },
    isTSTypeAliasDeclaration: function() {
        return isTSTypeAliasDeclaration;
    },
    isTSTypeAnnotation: function() {
        return isTSTypeAnnotation;
    },
    isTSTypeAssertion: function() {
        return isTSTypeAssertion;
    },
    isTSTypeElement: function() {
        return isTSTypeElement;
    },
    isTSTypeLiteral: function() {
        return isTSTypeLiteral;
    },
    isTSTypeOperator: function() {
        return isTSTypeOperator;
    },
    isTSTypeParameter: function() {
        return isTSTypeParameter;
    },
    isTSTypeParameterDeclaration: function() {
        return isTSTypeParameterDeclaration;
    },
    isTSTypeParameterInstantiation: function() {
        return isTSTypeParameterInstantiation;
    },
    isTSTypePredicate: function() {
        return isTSTypePredicate;
    },
    isTSTypeQuery: function() {
        return isTSTypeQuery;
    },
    isTSTypeReference: function() {
        return isTSTypeReference;
    },
    isTSUndefinedKeyword: function() {
        return isTSUndefinedKeyword;
    },
    isTSUnionType: function() {
        return isTSUnionType;
    },
    isTSUnknownKeyword: function() {
        return isTSUnknownKeyword;
    },
    isTSVoidKeyword: function() {
        return isTSVoidKeyword;
    },
    isTaggedTemplateExpression: function() {
        return isTaggedTemplateExpression;
    },
    isTemplateElement: function() {
        return isTemplateElement;
    },
    isTemplateLiteral: function() {
        return isTemplateLiteral;
    },
    isTerminatorless: function() {
        return isTerminatorless;
    },
    isThisExpression: function() {
        return isThisExpression;
    },
    isThisTypeAnnotation: function() {
        return isThisTypeAnnotation;
    },
    isThrowStatement: function() {
        return isThrowStatement;
    },
    isTopicReference: function() {
        return isTopicReference;
    },
    isTryStatement: function() {
        return isTryStatement;
    },
    isTupleExpression: function() {
        return isTupleExpression;
    },
    isTupleTypeAnnotation: function() {
        return isTupleTypeAnnotation;
    },
    isType: function() {
        return isType;
    },
    isTypeAlias: function() {
        return isTypeAlias;
    },
    isTypeAnnotation: function() {
        return isTypeAnnotation;
    },
    isTypeCastExpression: function() {
        return isTypeCastExpression;
    },
    isTypeParameter: function() {
        return isTypeParameter;
    },
    isTypeParameterDeclaration: function() {
        return isTypeParameterDeclaration;
    },
    isTypeParameterInstantiation: function() {
        return isTypeParameterInstantiation;
    },
    isTypeScript: function() {
        return isTypeScript;
    },
    isTypeofTypeAnnotation: function() {
        return isTypeofTypeAnnotation;
    },
    isUnaryExpression: function() {
        return isUnaryExpression;
    },
    isUnaryLike: function() {
        return isUnaryLike;
    },
    isUnionTypeAnnotation: function() {
        return isUnionTypeAnnotation;
    },
    isUpdateExpression: function() {
        return isUpdateExpression;
    },
    isUserWhitespacable: function() {
        return isUserWhitespacable;
    },
    isV8IntrinsicIdentifier: function() {
        return isV8IntrinsicIdentifier;
    },
    isValidES3Identifier: function() {
        return isValidES3Identifier;
    },
    isValidIdentifier: function() {
        return isValidIdentifier;
    },
    isVar: function() {
        return isVar;
    },
    isVariableDeclaration: function() {
        return isVariableDeclaration;
    },
    isVariableDeclarator: function() {
        return isVariableDeclarator;
    },
    isVariance: function() {
        return isVariance;
    },
    isVoidTypeAnnotation: function() {
        return isVoidTypeAnnotation;
    },
    isWhile: function() {
        return isWhile;
    },
    isWhileStatement: function() {
        return isWhileStatement;
    },
    isWithStatement: function() {
        return isWithStatement;
    },
    isYieldExpression: function() {
        return isYieldExpression;
    },
    jSXAttribute: function() {
        return jsxAttribute;
    },
    jSXClosingElement: function() {
        return jsxClosingElement;
    },
    jSXClosingFragment: function() {
        return jsxClosingFragment;
    },
    jSXElement: function() {
        return jsxElement;
    },
    jSXEmptyExpression: function() {
        return jsxEmptyExpression;
    },
    jSXExpressionContainer: function() {
        return jsxExpressionContainer;
    },
    jSXFragment: function() {
        return jsxFragment;
    },
    jSXIdentifier: function() {
        return jsxIdentifier;
    },
    jSXMemberExpression: function() {
        return jsxMemberExpression;
    },
    jSXNamespacedName: function() {
        return jsxNamespacedName;
    },
    jSXOpeningElement: function() {
        return jsxOpeningElement;
    },
    jSXOpeningFragment: function() {
        return jsxOpeningFragment;
    },
    jSXSpreadAttribute: function() {
        return jsxSpreadAttribute;
    },
    jSXSpreadChild: function() {
        return jsxSpreadChild;
    },
    jSXText: function() {
        return jsxText;
    },
    jsxAttribute: function() {
        return jsxAttribute;
    },
    jsxClosingElement: function() {
        return jsxClosingElement;
    },
    jsxClosingFragment: function() {
        return jsxClosingFragment;
    },
    jsxElement: function() {
        return jsxElement;
    },
    jsxEmptyExpression: function() {
        return jsxEmptyExpression;
    },
    jsxExpressionContainer: function() {
        return jsxExpressionContainer;
    },
    jsxFragment: function() {
        return jsxFragment;
    },
    jsxIdentifier: function() {
        return jsxIdentifier;
    },
    jsxMemberExpression: function() {
        return jsxMemberExpression;
    },
    jsxNamespacedName: function() {
        return jsxNamespacedName;
    },
    jsxOpeningElement: function() {
        return jsxOpeningElement;
    },
    jsxOpeningFragment: function() {
        return jsxOpeningFragment;
    },
    jsxSpreadAttribute: function() {
        return jsxSpreadAttribute;
    },
    jsxSpreadChild: function() {
        return jsxSpreadChild;
    },
    jsxText: function() {
        return jsxText;
    },
    labeledStatement: function() {
        return labeledStatement;
    },
    logicalExpression: function() {
        return logicalExpression;
    },
    matchesPattern: function() {
        return matchesPattern;
    },
    memberExpression: function() {
        return memberExpression;
    },
    metaProperty: function() {
        return metaProperty;
    },
    mixedTypeAnnotation: function() {
        return mixedTypeAnnotation;
    },
    moduleExpression: function() {
        return moduleExpression;
    },
    newExpression: function() {
        return newExpression;
    },
    noop: function() {
        return noop;
    },
    nullLiteral: function() {
        return nullLiteral;
    },
    nullLiteralTypeAnnotation: function() {
        return nullLiteralTypeAnnotation;
    },
    nullableTypeAnnotation: function() {
        return nullableTypeAnnotation;
    },
    numberLiteral: function() {
        return NumberLiteral;
    },
    numberLiteralTypeAnnotation: function() {
        return numberLiteralTypeAnnotation;
    },
    numberTypeAnnotation: function() {
        return numberTypeAnnotation;
    },
    numericLiteral: function() {
        return numericLiteral;
    },
    objectExpression: function() {
        return objectExpression;
    },
    objectMethod: function() {
        return objectMethod;
    },
    objectPattern: function() {
        return objectPattern;
    },
    objectProperty: function() {
        return objectProperty;
    },
    objectTypeAnnotation: function() {
        return objectTypeAnnotation;
    },
    objectTypeCallProperty: function() {
        return objectTypeCallProperty;
    },
    objectTypeIndexer: function() {
        return objectTypeIndexer;
    },
    objectTypeInternalSlot: function() {
        return objectTypeInternalSlot;
    },
    objectTypeProperty: function() {
        return objectTypeProperty;
    },
    objectTypeSpreadProperty: function() {
        return objectTypeSpreadProperty;
    },
    opaqueType: function() {
        return opaqueType;
    },
    optionalCallExpression: function() {
        return optionalCallExpression;
    },
    optionalIndexedAccessType: function() {
        return optionalIndexedAccessType;
    },
    optionalMemberExpression: function() {
        return optionalMemberExpression;
    },
    parenthesizedExpression: function() {
        return parenthesizedExpression;
    },
    pipelineBareFunction: function() {
        return pipelineBareFunction;
    },
    pipelinePrimaryTopicReference: function() {
        return pipelinePrimaryTopicReference;
    },
    pipelineTopicExpression: function() {
        return pipelineTopicExpression;
    },
    placeholder: function() {
        return placeholder;
    },
    prependToMemberExpression: function() {
        return prependToMemberExpression;
    },
    privateName: function() {
        return privateName;
    },
    program: function() {
        return program;
    },
    qualifiedTypeIdentifier: function() {
        return qualifiedTypeIdentifier;
    },
    react: function() {
        return react;
    },
    recordExpression: function() {
        return recordExpression;
    },
    regExpLiteral: function() {
        return regExpLiteral;
    },
    regexLiteral: function() {
        return RegexLiteral;
    },
    removeComments: function() {
        return removeComments;
    },
    removeProperties: function() {
        return removeProperties;
    },
    removePropertiesDeep: function() {
        return removePropertiesDeep;
    },
    removeTypeDuplicates: function() {
        return removeTypeDuplicates$1;
    },
    restElement: function() {
        return restElement;
    },
    restProperty: function() {
        return RestProperty;
    },
    returnStatement: function() {
        return returnStatement;
    },
    sequenceExpression: function() {
        return sequenceExpression;
    },
    shallowEqual: function() {
        return shallowEqual;
    },
    spreadElement: function() {
        return spreadElement;
    },
    spreadProperty: function() {
        return SpreadProperty;
    },
    staticBlock: function() {
        return staticBlock;
    },
    stringLiteral: function() {
        return stringLiteral;
    },
    stringLiteralTypeAnnotation: function() {
        return stringLiteralTypeAnnotation;
    },
    stringTypeAnnotation: function() {
        return stringTypeAnnotation;
    },
    super: function() {
        return _super;
    },
    switchCase: function() {
        return switchCase;
    },
    switchStatement: function() {
        return switchStatement;
    },
    symbolTypeAnnotation: function() {
        return symbolTypeAnnotation;
    },
    tSAnyKeyword: function() {
        return tsAnyKeyword;
    },
    tSArrayType: function() {
        return tsArrayType;
    },
    tSAsExpression: function() {
        return tsAsExpression;
    },
    tSBigIntKeyword: function() {
        return tsBigIntKeyword;
    },
    tSBooleanKeyword: function() {
        return tsBooleanKeyword;
    },
    tSCallSignatureDeclaration: function() {
        return tsCallSignatureDeclaration;
    },
    tSConditionalType: function() {
        return tsConditionalType;
    },
    tSConstructSignatureDeclaration: function() {
        return tsConstructSignatureDeclaration;
    },
    tSConstructorType: function() {
        return tsConstructorType;
    },
    tSDeclareFunction: function() {
        return tsDeclareFunction;
    },
    tSDeclareMethod: function() {
        return tsDeclareMethod;
    },
    tSEnumDeclaration: function() {
        return tsEnumDeclaration;
    },
    tSEnumMember: function() {
        return tsEnumMember;
    },
    tSExportAssignment: function() {
        return tsExportAssignment;
    },
    tSExpressionWithTypeArguments: function() {
        return tsExpressionWithTypeArguments;
    },
    tSExternalModuleReference: function() {
        return tsExternalModuleReference;
    },
    tSFunctionType: function() {
        return tsFunctionType;
    },
    tSImportEqualsDeclaration: function() {
        return tsImportEqualsDeclaration;
    },
    tSImportType: function() {
        return tsImportType;
    },
    tSIndexSignature: function() {
        return tsIndexSignature;
    },
    tSIndexedAccessType: function() {
        return tsIndexedAccessType;
    },
    tSInferType: function() {
        return tsInferType;
    },
    tSInstantiationExpression: function() {
        return tsInstantiationExpression;
    },
    tSInterfaceBody: function() {
        return tsInterfaceBody;
    },
    tSInterfaceDeclaration: function() {
        return tsInterfaceDeclaration;
    },
    tSIntersectionType: function() {
        return tsIntersectionType;
    },
    tSIntrinsicKeyword: function() {
        return tsIntrinsicKeyword;
    },
    tSLiteralType: function() {
        return tsLiteralType;
    },
    tSMappedType: function() {
        return tsMappedType;
    },
    tSMethodSignature: function() {
        return tsMethodSignature;
    },
    tSModuleBlock: function() {
        return tsModuleBlock;
    },
    tSModuleDeclaration: function() {
        return tsModuleDeclaration;
    },
    tSNamedTupleMember: function() {
        return tsNamedTupleMember;
    },
    tSNamespaceExportDeclaration: function() {
        return tsNamespaceExportDeclaration;
    },
    tSNeverKeyword: function() {
        return tsNeverKeyword;
    },
    tSNonNullExpression: function() {
        return tsNonNullExpression;
    },
    tSNullKeyword: function() {
        return tsNullKeyword;
    },
    tSNumberKeyword: function() {
        return tsNumberKeyword;
    },
    tSObjectKeyword: function() {
        return tsObjectKeyword;
    },
    tSOptionalType: function() {
        return tsOptionalType;
    },
    tSParameterProperty: function() {
        return tsParameterProperty;
    },
    tSParenthesizedType: function() {
        return tsParenthesizedType;
    },
    tSPropertySignature: function() {
        return tsPropertySignature;
    },
    tSQualifiedName: function() {
        return tsQualifiedName;
    },
    tSRestType: function() {
        return tsRestType;
    },
    tSSatisfiesExpression: function() {
        return tsSatisfiesExpression;
    },
    tSStringKeyword: function() {
        return tsStringKeyword;
    },
    tSSymbolKeyword: function() {
        return tsSymbolKeyword;
    },
    tSThisType: function() {
        return tsThisType;
    },
    tSTupleType: function() {
        return tsTupleType;
    },
    tSTypeAliasDeclaration: function() {
        return tsTypeAliasDeclaration;
    },
    tSTypeAnnotation: function() {
        return tsTypeAnnotation;
    },
    tSTypeAssertion: function() {
        return tsTypeAssertion;
    },
    tSTypeLiteral: function() {
        return tsTypeLiteral;
    },
    tSTypeOperator: function() {
        return tsTypeOperator;
    },
    tSTypeParameter: function() {
        return tsTypeParameter;
    },
    tSTypeParameterDeclaration: function() {
        return tsTypeParameterDeclaration;
    },
    tSTypeParameterInstantiation: function() {
        return tsTypeParameterInstantiation;
    },
    tSTypePredicate: function() {
        return tsTypePredicate;
    },
    tSTypeQuery: function() {
        return tsTypeQuery;
    },
    tSTypeReference: function() {
        return tsTypeReference;
    },
    tSUndefinedKeyword: function() {
        return tsUndefinedKeyword;
    },
    tSUnionType: function() {
        return tsUnionType;
    },
    tSUnknownKeyword: function() {
        return tsUnknownKeyword;
    },
    tSVoidKeyword: function() {
        return tsVoidKeyword;
    },
    taggedTemplateExpression: function() {
        return taggedTemplateExpression;
    },
    templateElement: function() {
        return templateElement;
    },
    templateLiteral: function() {
        return templateLiteral;
    },
    thisExpression: function() {
        return thisExpression;
    },
    thisTypeAnnotation: function() {
        return thisTypeAnnotation;
    },
    throwStatement: function() {
        return throwStatement;
    },
    toBindingIdentifierName: function() {
        return toBindingIdentifierName;
    },
    toBlock: function() {
        return toBlock;
    },
    toComputedKey: function() {
        return toComputedKey;
    },
    toExpression: function() {
        return toExpression;
    },
    toIdentifier: function() {
        return toIdentifier;
    },
    toKeyAlias: function() {
        return toKeyAlias;
    },
    toStatement: function() {
        return toStatement;
    },
    topicReference: function() {
        return topicReference;
    },
    traverse: function() {
        return traverse;
    },
    traverseFast: function() {
        return traverseFast;
    },
    tryStatement: function() {
        return tryStatement;
    },
    tsAnyKeyword: function() {
        return tsAnyKeyword;
    },
    tsArrayType: function() {
        return tsArrayType;
    },
    tsAsExpression: function() {
        return tsAsExpression;
    },
    tsBigIntKeyword: function() {
        return tsBigIntKeyword;
    },
    tsBooleanKeyword: function() {
        return tsBooleanKeyword;
    },
    tsCallSignatureDeclaration: function() {
        return tsCallSignatureDeclaration;
    },
    tsConditionalType: function() {
        return tsConditionalType;
    },
    tsConstructSignatureDeclaration: function() {
        return tsConstructSignatureDeclaration;
    },
    tsConstructorType: function() {
        return tsConstructorType;
    },
    tsDeclareFunction: function() {
        return tsDeclareFunction;
    },
    tsDeclareMethod: function() {
        return tsDeclareMethod;
    },
    tsEnumDeclaration: function() {
        return tsEnumDeclaration;
    },
    tsEnumMember: function() {
        return tsEnumMember;
    },
    tsExportAssignment: function() {
        return tsExportAssignment;
    },
    tsExpressionWithTypeArguments: function() {
        return tsExpressionWithTypeArguments;
    },
    tsExternalModuleReference: function() {
        return tsExternalModuleReference;
    },
    tsFunctionType: function() {
        return tsFunctionType;
    },
    tsImportEqualsDeclaration: function() {
        return tsImportEqualsDeclaration;
    },
    tsImportType: function() {
        return tsImportType;
    },
    tsIndexSignature: function() {
        return tsIndexSignature;
    },
    tsIndexedAccessType: function() {
        return tsIndexedAccessType;
    },
    tsInferType: function() {
        return tsInferType;
    },
    tsInstantiationExpression: function() {
        return tsInstantiationExpression;
    },
    tsInterfaceBody: function() {
        return tsInterfaceBody;
    },
    tsInterfaceDeclaration: function() {
        return tsInterfaceDeclaration;
    },
    tsIntersectionType: function() {
        return tsIntersectionType;
    },
    tsIntrinsicKeyword: function() {
        return tsIntrinsicKeyword;
    },
    tsLiteralType: function() {
        return tsLiteralType;
    },
    tsMappedType: function() {
        return tsMappedType;
    },
    tsMethodSignature: function() {
        return tsMethodSignature;
    },
    tsModuleBlock: function() {
        return tsModuleBlock;
    },
    tsModuleDeclaration: function() {
        return tsModuleDeclaration;
    },
    tsNamedTupleMember: function() {
        return tsNamedTupleMember;
    },
    tsNamespaceExportDeclaration: function() {
        return tsNamespaceExportDeclaration;
    },
    tsNeverKeyword: function() {
        return tsNeverKeyword;
    },
    tsNonNullExpression: function() {
        return tsNonNullExpression;
    },
    tsNullKeyword: function() {
        return tsNullKeyword;
    },
    tsNumberKeyword: function() {
        return tsNumberKeyword;
    },
    tsObjectKeyword: function() {
        return tsObjectKeyword;
    },
    tsOptionalType: function() {
        return tsOptionalType;
    },
    tsParameterProperty: function() {
        return tsParameterProperty;
    },
    tsParenthesizedType: function() {
        return tsParenthesizedType;
    },
    tsPropertySignature: function() {
        return tsPropertySignature;
    },
    tsQualifiedName: function() {
        return tsQualifiedName;
    },
    tsRestType: function() {
        return tsRestType;
    },
    tsSatisfiesExpression: function() {
        return tsSatisfiesExpression;
    },
    tsStringKeyword: function() {
        return tsStringKeyword;
    },
    tsSymbolKeyword: function() {
        return tsSymbolKeyword;
    },
    tsThisType: function() {
        return tsThisType;
    },
    tsTupleType: function() {
        return tsTupleType;
    },
    tsTypeAliasDeclaration: function() {
        return tsTypeAliasDeclaration;
    },
    tsTypeAnnotation: function() {
        return tsTypeAnnotation;
    },
    tsTypeAssertion: function() {
        return tsTypeAssertion;
    },
    tsTypeLiteral: function() {
        return tsTypeLiteral;
    },
    tsTypeOperator: function() {
        return tsTypeOperator;
    },
    tsTypeParameter: function() {
        return tsTypeParameter;
    },
    tsTypeParameterDeclaration: function() {
        return tsTypeParameterDeclaration;
    },
    tsTypeParameterInstantiation: function() {
        return tsTypeParameterInstantiation;
    },
    tsTypePredicate: function() {
        return tsTypePredicate;
    },
    tsTypeQuery: function() {
        return tsTypeQuery;
    },
    tsTypeReference: function() {
        return tsTypeReference;
    },
    tsUndefinedKeyword: function() {
        return tsUndefinedKeyword;
    },
    tsUnionType: function() {
        return tsUnionType;
    },
    tsUnknownKeyword: function() {
        return tsUnknownKeyword;
    },
    tsVoidKeyword: function() {
        return tsVoidKeyword;
    },
    tupleExpression: function() {
        return tupleExpression;
    },
    tupleTypeAnnotation: function() {
        return tupleTypeAnnotation;
    },
    typeAlias: function() {
        return typeAlias;
    },
    typeAnnotation: function() {
        return typeAnnotation;
    },
    typeCastExpression: function() {
        return typeCastExpression;
    },
    typeParameter: function() {
        return typeParameter;
    },
    typeParameterDeclaration: function() {
        return typeParameterDeclaration;
    },
    typeParameterInstantiation: function() {
        return typeParameterInstantiation;
    },
    typeofTypeAnnotation: function() {
        return typeofTypeAnnotation;
    },
    unaryExpression: function() {
        return unaryExpression;
    },
    unionTypeAnnotation: function() {
        return unionTypeAnnotation;
    },
    updateExpression: function() {
        return updateExpression;
    },
    v8IntrinsicIdentifier: function() {
        return v8IntrinsicIdentifier;
    },
    validate: function() {
        return validate;
    },
    valueToNode: function() {
        return valueToNode;
    },
    variableDeclaration: function() {
        return variableDeclaration;
    },
    variableDeclarator: function() {
        return variableDeclarator;
    },
    variance: function() {
        return variance;
    },
    voidTypeAnnotation: function() {
        return voidTypeAnnotation;
    },
    whileStatement: function() {
        return whileStatement;
    },
    withStatement: function() {
        return withStatement;
    },
    yieldExpression: function() {
        return yieldExpression;
    }
});
var import_to_fast_properties = __toESM(require_to_fast_properties(), 1);
// node_modules/@babel/helper-validator-identifier/lib/index.js
var nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ";
var nonASCIIidentifierChars = "‌‍\xb7̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･";
var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
var astralIdentifierStartCodes = [
    0,
    11,
    2,
    25,
    2,
    18,
    2,
    1,
    2,
    14,
    3,
    13,
    35,
    122,
    70,
    52,
    268,
    28,
    4,
    48,
    48,
    31,
    14,
    29,
    6,
    37,
    11,
    29,
    3,
    35,
    5,
    7,
    2,
    4,
    43,
    157,
    19,
    35,
    5,
    35,
    5,
    39,
    9,
    51,
    13,
    10,
    2,
    14,
    2,
    6,
    2,
    1,
    2,
    10,
    2,
    14,
    2,
    6,
    2,
    1,
    68,
    310,
    10,
    21,
    11,
    7,
    25,
    5,
    2,
    41,
    2,
    8,
    70,
    5,
    3,
    0,
    2,
    43,
    2,
    1,
    4,
    0,
    3,
    22,
    11,
    22,
    10,
    30,
    66,
    18,
    2,
    1,
    11,
    21,
    11,
    25,
    71,
    55,
    7,
    1,
    65,
    0,
    16,
    3,
    2,
    2,
    2,
    28,
    43,
    28,
    4,
    28,
    36,
    7,
    2,
    27,
    28,
    53,
    11,
    21,
    11,
    18,
    14,
    17,
    111,
    72,
    56,
    50,
    14,
    50,
    14,
    35,
    349,
    41,
    7,
    1,
    79,
    28,
    11,
    0,
    9,
    21,
    43,
    17,
    47,
    20,
    28,
    22,
    13,
    52,
    58,
    1,
    3,
    0,
    14,
    44,
    33,
    24,
    27,
    35,
    30,
    0,
    3,
    0,
    9,
    34,
    4,
    0,
    13,
    47,
    15,
    3,
    22,
    0,
    2,
    0,
    36,
    17,
    2,
    24,
    20,
    1,
    64,
    6,
    2,
    0,
    2,
    3,
    2,
    14,
    2,
    9,
    8,
    46,
    39,
    7,
    3,
    1,
    3,
    21,
    2,
    6,
    2,
    1,
    2,
    4,
    4,
    0,
    19,
    0,
    13,
    4,
    159,
    52,
    19,
    3,
    21,
    2,
    31,
    47,
    21,
    1,
    2,
    0,
    185,
    46,
    42,
    3,
    37,
    47,
    21,
    0,
    60,
    42,
    14,
    0,
    72,
    26,
    38,
    6,
    186,
    43,
    117,
    63,
    32,
    7,
    3,
    0,
    3,
    7,
    2,
    1,
    2,
    23,
    16,
    0,
    2,
    0,
    95,
    7,
    3,
    38,
    17,
    0,
    2,
    0,
    29,
    0,
    11,
    39,
    8,
    0,
    22,
    0,
    12,
    45,
    20,
    0,
    19,
    72,
    264,
    8,
    2,
    36,
    18,
    0,
    50,
    29,
    113,
    6,
    2,
    1,
    2,
    37,
    22,
    0,
    26,
    5,
    2,
    1,
    2,
    31,
    15,
    0,
    328,
    18,
    16,
    0,
    2,
    12,
    2,
    33,
    125,
    0,
    80,
    921,
    103,
    110,
    18,
    195,
    2637,
    96,
    16,
    1071,
    18,
    5,
    4026,
    582,
    8634,
    568,
    8,
    30,
    18,
    78,
    18,
    29,
    19,
    47,
    17,
    3,
    32,
    20,
    6,
    18,
    689,
    63,
    129,
    74,
    6,
    0,
    67,
    12,
    65,
    1,
    2,
    0,
    29,
    6135,
    9,
    1237,
    43,
    8,
    8936,
    3,
    2,
    6,
    2,
    1,
    2,
    290,
    16,
    0,
    30,
    2,
    3,
    0,
    15,
    3,
    9,
    395,
    2309,
    106,
    6,
    12,
    4,
    8,
    8,
    9,
    5991,
    84,
    2,
    70,
    2,
    1,
    3,
    0,
    3,
    1,
    3,
    3,
    2,
    11,
    2,
    0,
    2,
    6,
    2,
    64,
    2,
    3,
    3,
    7,
    2,
    6,
    2,
    27,
    2,
    3,
    2,
    4,
    2,
    0,
    4,
    6,
    2,
    339,
    3,
    24,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    7,
    1845,
    30,
    7,
    5,
    262,
    61,
    147,
    44,
    11,
    6,
    17,
    0,
    322,
    29,
    19,
    43,
    485,
    27,
    757,
    6,
    2,
    3,
    2,
    1,
    2,
    14,
    2,
    196,
    60,
    67,
    8,
    0,
    1205,
    3,
    2,
    26,
    2,
    1,
    2,
    0,
    3,
    0,
    2,
    9,
    2,
    3,
    2,
    0,
    2,
    0,
    7,
    0,
    5,
    0,
    2,
    0,
    2,
    0,
    2,
    2,
    2,
    1,
    2,
    0,
    3,
    0,
    2,
    0,
    2,
    0,
    2,
    0,
    2,
    0,
    2,
    1,
    2,
    0,
    3,
    3,
    2,
    6,
    2,
    3,
    2,
    3,
    2,
    0,
    2,
    9,
    2,
    16,
    6,
    2,
    2,
    4,
    2,
    16,
    4421,
    42719,
    33,
    4153,
    7,
    221,
    3,
    5761,
    15,
    7472,
    16,
    621,
    2467,
    541,
    1507,
    4938,
    6,
    4191
];
var astralIdentifierCodes = [
    509,
    0,
    227,
    0,
    150,
    4,
    294,
    9,
    1368,
    2,
    2,
    1,
    6,
    3,
    41,
    2,
    5,
    0,
    166,
    1,
    574,
    3,
    9,
    9,
    370,
    1,
    81,
    2,
    71,
    10,
    50,
    3,
    123,
    2,
    54,
    14,
    32,
    10,
    3,
    1,
    11,
    3,
    46,
    10,
    8,
    0,
    46,
    9,
    7,
    2,
    37,
    13,
    2,
    9,
    6,
    1,
    45,
    0,
    13,
    2,
    49,
    13,
    9,
    3,
    2,
    11,
    83,
    11,
    7,
    0,
    3,
    0,
    158,
    11,
    6,
    9,
    7,
    3,
    56,
    1,
    2,
    6,
    3,
    1,
    3,
    2,
    10,
    0,
    11,
    1,
    3,
    6,
    4,
    4,
    193,
    17,
    10,
    9,
    5,
    0,
    82,
    19,
    13,
    9,
    214,
    6,
    3,
    8,
    28,
    1,
    83,
    16,
    16,
    9,
    82,
    12,
    9,
    9,
    84,
    14,
    5,
    9,
    243,
    14,
    166,
    9,
    71,
    5,
    2,
    1,
    3,
    3,
    2,
    0,
    2,
    1,
    13,
    9,
    120,
    6,
    3,
    6,
    4,
    0,
    29,
    9,
    41,
    6,
    2,
    3,
    9,
    0,
    10,
    10,
    47,
    15,
    406,
    7,
    2,
    7,
    17,
    9,
    57,
    21,
    2,
    13,
    123,
    5,
    4,
    0,
    2,
    1,
    2,
    6,
    2,
    0,
    9,
    9,
    49,
    4,
    2,
    1,
    2,
    4,
    9,
    9,
    330,
    3,
    10,
    1,
    2,
    0,
    49,
    6,
    4,
    4,
    14,
    9,
    5351,
    0,
    7,
    14,
    13835,
    9,
    87,
    9,
    39,
    4,
    60,
    6,
    26,
    9,
    1014,
    0,
    2,
    54,
    8,
    3,
    82,
    0,
    12,
    1,
    19628,
    1,
    4706,
    45,
    3,
    22,
    543,
    4,
    4,
    5,
    9,
    7,
    3,
    6,
    31,
    3,
    149,
    2,
    1418,
    49,
    513,
    54,
    5,
    49,
    9,
    0,
    15,
    0,
    23,
    4,
    2,
    14,
    1361,
    6,
    2,
    16,
    3,
    6,
    2,
    1,
    2,
    4,
    101,
    0,
    161,
    6,
    10,
    9,
    357,
    0,
    62,
    13,
    499,
    13,
    983,
    6,
    110,
    6,
    6,
    9,
    4759,
    9,
    787719,
    239
];
function isInAstralSet(code2, set) {
    var pos = 65536;
    for(var i = 0, length = set.length; i < length; i += 2){
        pos += set[i];
        if (pos > code2) return false;
        pos += set[i + 1];
        if (pos >= code2) return true;
    }
    return false;
}
function isIdentifierStart(code2) {
    if (code2 < 65) return code2 === 36;
    if (code2 <= 90) return true;
    if (code2 < 97) return code2 === 95;
    if (code2 <= 122) return true;
    if (code2 <= 65535) {
        return code2 >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code2));
    }
    return isInAstralSet(code2, astralIdentifierStartCodes);
}
function isIdentifierChar(code2) {
    if (code2 < 48) return code2 === 36;
    if (code2 < 58) return true;
    if (code2 < 65) return false;
    if (code2 <= 90) return true;
    if (code2 < 97) return code2 === 95;
    if (code2 <= 122) return true;
    if (code2 <= 65535) {
        return code2 >= 170 && nonASCIIidentifier.test(String.fromCharCode(code2));
    }
    return isInAstralSet(code2, astralIdentifierStartCodes) || isInAstralSet(code2, astralIdentifierCodes);
}
function isIdentifierName(name) {
    var isFirst = true;
    for(var i = 0; i < name.length; i++){
        var cp = name.charCodeAt(i);
        if ((cp & 64512) === 55296 && i + 1 < name.length) {
            var trail = name.charCodeAt(++i);
            if ((trail & 64512) === 56320) {
                cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
            }
        }
        if (isFirst) {
            isFirst = false;
            if (!isIdentifierStart(cp)) {
                return false;
            }
        } else if (!isIdentifierChar(cp)) {
            return false;
        }
    }
    return !isFirst;
}
var reservedWords = {
    keyword: [
        "break",
        "case",
        "catch",
        "continue",
        "debugger",
        "default",
        "do",
        "else",
        "finally",
        "for",
        "function",
        "if",
        "return",
        "switch",
        "throw",
        "try",
        "var",
        "const",
        "while",
        "with",
        "new",
        "this",
        "super",
        "class",
        "extends",
        "export",
        "import",
        "null",
        "true",
        "false",
        "in",
        "instanceof",
        "typeof",
        "void",
        "delete"
    ],
    strict: [
        "implements",
        "interface",
        "let",
        "package",
        "private",
        "protected",
        "public",
        "static",
        "yield"
    ],
    strictBind: [
        "eval",
        "arguments"
    ]
};
var keywords = new Set(reservedWords.keyword);
var reservedWordsStrictSet = new Set(reservedWords.strict);
var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
function isReservedWord(word, inModule) {
    return inModule && word === "await" || word === "enum";
}
function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
}
function isKeyword(word) {
    return keywords.has(word);
}
// node_modules/@babel/helper-string-parser/lib/index.js
var _isDigit = function isDigit(code2) {
    return code2 >= 48 && code2 <= 57;
};
var forbiddenNumericSeparatorSiblings = {
    decBinOct: /* @__PURE__ */ new Set([
        46,
        66,
        69,
        79,
        95,
        98,
        101,
        111
    ]),
    hex: /* @__PURE__ */ new Set([
        46,
        88,
        95,
        120
    ])
};
var isAllowedNumericSeparatorSibling = {
    bin: function(ch) {
        return ch === 48 || ch === 49;
    },
    oct: function(ch) {
        return ch >= 48 && ch <= 55;
    },
    dec: function(ch) {
        return ch >= 48 && ch <= 57;
    },
    hex: function(ch) {
        return ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
    }
};
function readStringContents(type, input, pos, lineStart, curLine, errors) {
    var initialPos = pos;
    var initialLineStart = lineStart;
    var initialCurLine = curLine;
    var out = "";
    var firstInvalidLoc = null;
    var chunkStart = pos;
    var length = input.length;
    for(;;){
        if (pos >= length) {
            errors.unterminated(initialPos, initialLineStart, initialCurLine);
            out += input.slice(chunkStart, pos);
            break;
        }
        var ch = input.charCodeAt(pos);
        if (isStringEnd(type, ch, input, pos)) {
            out += input.slice(chunkStart, pos);
            break;
        }
        if (ch === 92) {
            out += input.slice(chunkStart, pos);
            var res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors);
            if (res.ch === null && !firstInvalidLoc) {
                firstInvalidLoc = {
                    pos: pos,
                    lineStart: lineStart,
                    curLine: curLine
                };
            } else {
                out += res.ch;
            }
            var ref;
            ref = res, pos = ref.pos, lineStart = ref.lineStart, curLine = ref.curLine, ref;
            chunkStart = pos;
        } else if (ch === 8232 || ch === 8233) {
            ++pos;
            ++curLine;
            lineStart = pos;
        } else if (ch === 10 || ch === 13) {
            if (type === "template") {
                out += input.slice(chunkStart, pos) + "\n";
                ++pos;
                if (ch === 13 && input.charCodeAt(pos) === 10) {
                    ++pos;
                }
                ++curLine;
                chunkStart = lineStart = pos;
            } else {
                errors.unterminated(initialPos, initialLineStart, initialCurLine);
            }
        } else {
            ++pos;
        }
    }
    return {
        pos: pos,
        str: out,
        firstInvalidLoc: firstInvalidLoc,
        lineStart: lineStart,
        curLine: curLine
    };
}
function isStringEnd(type, ch, input, pos) {
    if (type === "template") {
        return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
    }
    return ch === (type === "double" ? 34 : 39);
}
function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
    var throwOnInvalid = !inTemplate;
    pos++;
    var res = function(ch2) {
        return {
            pos: pos,
            ch: ch2,
            lineStart: lineStart,
            curLine: curLine
        };
    };
    var ch = input.charCodeAt(pos++);
    switch(ch){
        case 110:
            return res("\n");
        case 114:
            return res("\r");
        case 120:
            {
                var code2;
                var ref;
                ref = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors), code2 = ref.code, pos = ref.pos, ref;
                return res(code2 === null ? null : String.fromCharCode(code2));
            }
        case 117:
            {
                var code21;
                var ref1;
                ref1 = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors), code21 = ref1.code, pos = ref1.pos, ref1;
                return res(code21 === null ? null : String.fromCodePoint(code21));
            }
        case 116:
            return res("	");
        case 98:
            return res("\b");
        case 118:
            return res("\v");
        case 102:
            return res("\f");
        case 13:
            if (input.charCodeAt(pos) === 10) {
                ++pos;
            }
        case 10:
            lineStart = pos;
            ++curLine;
        case 8232:
        case 8233:
            return res("");
        case 56:
        case 57:
            if (inTemplate) {
                return res(null);
            } else {
                errors.strictNumericEscape(pos - 1, lineStart, curLine);
            }
        default:
            if (ch >= 48 && ch <= 55) {
                var startPos = pos - 1;
                var match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
                var octalStr = match[0];
                var octal = parseInt(octalStr, 8);
                if (octal > 255) {
                    octalStr = octalStr.slice(0, -1);
                    octal = parseInt(octalStr, 8);
                }
                pos += octalStr.length - 1;
                var next = input.charCodeAt(pos);
                if (octalStr !== "0" || next === 56 || next === 57) {
                    if (inTemplate) {
                        return res(null);
                    } else {
                        errors.strictNumericEscape(startPos, lineStart, curLine);
                    }
                }
                return res(String.fromCharCode(octal));
            }
            return res(String.fromCharCode(ch));
    }
}
function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors) {
    var initialPos = pos;
    var n2;
    var ref;
    ref = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors, !throwOnInvalid), n2 = ref.n, pos = ref.pos, ref;
    if (n2 === null) {
        if (throwOnInvalid) {
            errors.invalidEscapeSequence(initialPos, lineStart, curLine);
        } else {
            pos = initialPos - 1;
        }
    }
    return {
        code: n2,
        pos: pos
    };
}
function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors, bailOnError) {
    var start = pos;
    var forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
    var isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
    var invalid = false;
    var total = 0;
    for(var i = 0, e = len == null ? Infinity : len; i < e; ++i){
        var code2 = input.charCodeAt(pos);
        var val = void 0;
        if (code2 === 95 && allowNumSeparator !== "bail") {
            var prev = input.charCodeAt(pos - 1);
            var next = input.charCodeAt(pos + 1);
            if (!allowNumSeparator) {
                if (bailOnError) return {
                    n: null,
                    pos: pos
                };
                errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
            } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
                if (bailOnError) return {
                    n: null,
                    pos: pos
                };
                errors.unexpectedNumericSeparator(pos, lineStart, curLine);
            }
            ++pos;
            continue;
        }
        if (code2 >= 97) {
            val = code2 - 97 + 10;
        } else if (code2 >= 65) {
            val = code2 - 65 + 10;
        } else if (_isDigit(code2)) {
            val = code2 - 48;
        } else {
            val = Infinity;
        }
        if (val >= radix) {
            if (val <= 9 && bailOnError) {
                return {
                    n: null,
                    pos: pos
                };
            } else if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
                val = 0;
            } else if (forceLen) {
                val = 0;
                invalid = true;
            } else {
                break;
            }
        }
        ++pos;
        total = total * radix + val;
    }
    if (pos === start || len != null && pos - start !== len || invalid) {
        return {
            n: null,
            pos: pos
        };
    }
    return {
        n: total,
        pos: pos
    };
}
function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors) {
    var ch = input.charCodeAt(pos);
    var code2;
    if (ch === 123) {
        ++pos;
        var ref;
        ref = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors), code2 = ref.code, pos = ref.pos, ref;
        ++pos;
        if (code2 !== null && code2 > 1114111) {
            if (throwOnInvalid) {
                errors.invalidCodePoint(pos, lineStart, curLine);
            } else {
                return {
                    code: null,
                    pos: pos
                };
            }
        }
    } else {
        var ref1;
        ref1 = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors), code2 = ref1.code, pos = ref1.pos, ref1;
    }
    return {
        code: code2,
        pos: pos
    };
}
// node_modules/@babel/types/lib/index.js
function shallowEqual(actual, expected) {
    var keys = Object.keys(expected);
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            if (actual[key] !== expected[key]) {
                return false;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return true;
}
var warnings = /* @__PURE__ */ new Set();
function deprecationWarning(oldName, newName) {
    var prefix2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "";
    if (warnings.has(oldName)) return;
    warnings.add(oldName);
    var _captureShortStackTrace = captureShortStackTrace(1, 2), internal = _captureShortStackTrace.internal, trace = _captureShortStackTrace.trace;
    if (internal) {
        return;
    }
    console.warn("".concat(prefix2, "`").concat(oldName, "` has been deprecated, please migrate to `").concat(newName, "`\n").concat(trace));
}
function captureShortStackTrace(skip2, length) {
    var stackTraceLimit = Error.stackTraceLimit, prepareStackTrace = Error.prepareStackTrace;
    var stackTrace;
    Error.stackTraceLimit = 1 + skip2 + length;
    Error.prepareStackTrace = function(err, stack) {
        stackTrace = stack;
    };
    new Error().stack;
    Error.stackTraceLimit = stackTraceLimit;
    Error.prepareStackTrace = prepareStackTrace;
    if (!stackTrace) return {
        internal: false,
        trace: ""
    };
    var shortStackTrace = stackTrace.slice(1 + skip2, 1 + skip2 + length);
    return {
        internal: /[\\/]@babel[\\/]/.test(shortStackTrace[1].getFileName()),
        trace: shortStackTrace.map(function(frame) {
            return "    at ".concat(frame);
        }).join("\n")
    };
}
function isArrayExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ArrayExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isAssignmentExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "AssignmentExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBinaryExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "BinaryExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isInterpreterDirective(node, opts) {
    if (!node) return false;
    if (node.type !== "InterpreterDirective") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDirective(node, opts) {
    if (!node) return false;
    if (node.type !== "Directive") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDirectiveLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "DirectiveLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBlockStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "BlockStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBreakStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "BreakStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isCallExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "CallExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isCatchClause(node, opts) {
    if (!node) return false;
    if (node.type !== "CatchClause") return false;
    return opts == null || shallowEqual(node, opts);
}
function isConditionalExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ConditionalExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isContinueStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ContinueStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDebuggerStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "DebuggerStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDoWhileStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "DoWhileStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEmptyStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "EmptyStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExpressionStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ExpressionStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isFile(node, opts) {
    if (!node) return false;
    if (node.type !== "File") return false;
    return opts == null || shallowEqual(node, opts);
}
function isForInStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ForInStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isForStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ForStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isFunctionDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "FunctionDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isFunctionExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "FunctionExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isIdentifier(node, opts) {
    if (!node) return false;
    if (node.type !== "Identifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isIfStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "IfStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isLabeledStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "LabeledStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isStringLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "StringLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNumericLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "NumericLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNullLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "NullLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBooleanLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "BooleanLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isRegExpLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "RegExpLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isLogicalExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "LogicalExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isMemberExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "MemberExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNewExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "NewExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isProgram(node, opts) {
    if (!node) return false;
    if (node.type !== "Program") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectMethod(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectMethod") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isRestElement(node, opts) {
    if (!node) return false;
    if (node.type !== "RestElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isReturnStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ReturnStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSequenceExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "SequenceExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isParenthesizedExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ParenthesizedExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSwitchCase(node, opts) {
    if (!node) return false;
    if (node.type !== "SwitchCase") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSwitchStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "SwitchStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isThisExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ThisExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isThrowStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ThrowStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTryStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "TryStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isUnaryExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "UnaryExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isUpdateExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "UpdateExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isVariableDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "VariableDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isVariableDeclarator(node, opts) {
    if (!node) return false;
    if (node.type !== "VariableDeclarator") return false;
    return opts == null || shallowEqual(node, opts);
}
function isWhileStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "WhileStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isWithStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "WithStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isAssignmentPattern(node, opts) {
    if (!node) return false;
    if (node.type !== "AssignmentPattern") return false;
    return opts == null || shallowEqual(node, opts);
}
function isArrayPattern(node, opts) {
    if (!node) return false;
    if (node.type !== "ArrayPattern") return false;
    return opts == null || shallowEqual(node, opts);
}
function isArrowFunctionExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ArrowFunctionExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassBody(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportAllDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportAllDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportDefaultDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportDefaultDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportNamedDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportNamedDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isForOfStatement(node, opts) {
    if (!node) return false;
    if (node.type !== "ForOfStatement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportDefaultSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportDefaultSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportNamespaceSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportNamespaceSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isMetaProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "MetaProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassMethod(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassMethod") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectPattern(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectPattern") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSpreadElement(node, opts) {
    if (!node) return false;
    if (node.type !== "SpreadElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSuper(node, opts) {
    if (!node) return false;
    if (node.type !== "Super") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTaggedTemplateExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TaggedTemplateExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTemplateElement(node, opts) {
    if (!node) return false;
    if (node.type !== "TemplateElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTemplateLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "TemplateLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isYieldExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "YieldExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isAwaitExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "AwaitExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImport(node, opts) {
    if (!node) return false;
    if (node.type !== "Import") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBigIntLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "BigIntLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportNamespaceSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportNamespaceSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isOptionalMemberExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "OptionalMemberExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isOptionalCallExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "OptionalCallExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassAccessorProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassAccessorProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassPrivateProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassPrivateProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassPrivateMethod(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassPrivateMethod") return false;
    return opts == null || shallowEqual(node, opts);
}
function isPrivateName(node, opts) {
    if (!node) return false;
    if (node.type !== "PrivateName") return false;
    return opts == null || shallowEqual(node, opts);
}
function isStaticBlock(node, opts) {
    if (!node) return false;
    if (node.type !== "StaticBlock") return false;
    return opts == null || shallowEqual(node, opts);
}
function isAnyTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "AnyTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isArrayTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "ArrayTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBooleanTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "BooleanTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBooleanLiteralTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "BooleanLiteralTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNullLiteralTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "NullLiteralTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isClassImplements(node, opts) {
    if (!node) return false;
    if (node.type !== "ClassImplements") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareClass(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareClass") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareFunction(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareFunction") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareInterface(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareInterface") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareModule(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareModule") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareModuleExports(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareModuleExports") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareTypeAlias(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareTypeAlias") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareOpaqueType(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareOpaqueType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareVariable(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareVariable") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareExportDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareExportDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclareExportAllDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclareExportAllDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDeclaredPredicate(node, opts) {
    if (!node) return false;
    if (node.type !== "DeclaredPredicate") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExistsTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "ExistsTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isFunctionTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "FunctionTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isFunctionTypeParam(node, opts) {
    if (!node) return false;
    if (node.type !== "FunctionTypeParam") return false;
    return opts == null || shallowEqual(node, opts);
}
function isGenericTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "GenericTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isInferredPredicate(node, opts) {
    if (!node) return false;
    if (node.type !== "InferredPredicate") return false;
    return opts == null || shallowEqual(node, opts);
}
function isInterfaceExtends(node, opts) {
    if (!node) return false;
    if (node.type !== "InterfaceExtends") return false;
    return opts == null || shallowEqual(node, opts);
}
function isInterfaceDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "InterfaceDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isInterfaceTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "InterfaceTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isIntersectionTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "IntersectionTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isMixedTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "MixedTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEmptyTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "EmptyTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNullableTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "NullableTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNumberLiteralTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "NumberLiteralTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNumberTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "NumberTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeInternalSlot(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeInternalSlot") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeCallProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeCallProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeIndexer(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeIndexer") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isObjectTypeSpreadProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "ObjectTypeSpreadProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isOpaqueType(node, opts) {
    if (!node) return false;
    if (node.type !== "OpaqueType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isQualifiedTypeIdentifier(node, opts) {
    if (!node) return false;
    if (node.type !== "QualifiedTypeIdentifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isStringLiteralTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "StringLiteralTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isStringTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "StringTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSymbolTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "SymbolTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isThisTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "ThisTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTupleTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "TupleTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeofTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeofTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeAlias(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeAlias") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeCastExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeCastExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeParameter(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeParameter") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeParameterDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeParameterDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTypeParameterInstantiation(node, opts) {
    if (!node) return false;
    if (node.type !== "TypeParameterInstantiation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isUnionTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "UnionTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isVariance(node, opts) {
    if (!node) return false;
    if (node.type !== "Variance") return false;
    return opts == null || shallowEqual(node, opts);
}
function isVoidTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "VoidTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumBooleanBody(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumBooleanBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumNumberBody(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumNumberBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumStringBody(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumStringBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumSymbolBody(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumSymbolBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumBooleanMember(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumBooleanMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumNumberMember(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumNumberMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumStringMember(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumStringMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isEnumDefaultedMember(node, opts) {
    if (!node) return false;
    if (node.type !== "EnumDefaultedMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isIndexedAccessType(node, opts) {
    if (!node) return false;
    if (node.type !== "IndexedAccessType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isOptionalIndexedAccessType(node, opts) {
    if (!node) return false;
    if (node.type !== "OptionalIndexedAccessType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXAttribute(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXAttribute") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXClosingElement(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXClosingElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXElement(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXEmptyExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXEmptyExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXExpressionContainer(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXExpressionContainer") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXSpreadChild(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXSpreadChild") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXIdentifier(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXIdentifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXMemberExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXMemberExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXNamespacedName(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXNamespacedName") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXOpeningElement(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXOpeningElement") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXSpreadAttribute(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXSpreadAttribute") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXText(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXText") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXFragment(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXFragment") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXOpeningFragment(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXOpeningFragment") return false;
    return opts == null || shallowEqual(node, opts);
}
function isJSXClosingFragment(node, opts) {
    if (!node) return false;
    if (node.type !== "JSXClosingFragment") return false;
    return opts == null || shallowEqual(node, opts);
}
function isNoop(node, opts) {
    if (!node) return false;
    if (node.type !== "Noop") return false;
    return opts == null || shallowEqual(node, opts);
}
function isPlaceholder(node, opts) {
    if (!node) return false;
    if (node.type !== "Placeholder") return false;
    return opts == null || shallowEqual(node, opts);
}
function isV8IntrinsicIdentifier(node, opts) {
    if (!node) return false;
    if (node.type !== "V8IntrinsicIdentifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isArgumentPlaceholder(node, opts) {
    if (!node) return false;
    if (node.type !== "ArgumentPlaceholder") return false;
    return opts == null || shallowEqual(node, opts);
}
function isBindExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "BindExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isImportAttribute(node, opts) {
    if (!node) return false;
    if (node.type !== "ImportAttribute") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDecorator(node, opts) {
    if (!node) return false;
    if (node.type !== "Decorator") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDoExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "DoExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isExportDefaultSpecifier(node, opts) {
    if (!node) return false;
    if (node.type !== "ExportDefaultSpecifier") return false;
    return opts == null || shallowEqual(node, opts);
}
function isRecordExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "RecordExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTupleExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TupleExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isDecimalLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "DecimalLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isModuleExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "ModuleExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTopicReference(node, opts) {
    if (!node) return false;
    if (node.type !== "TopicReference") return false;
    return opts == null || shallowEqual(node, opts);
}
function isPipelineTopicExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "PipelineTopicExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isPipelineBareFunction(node, opts) {
    if (!node) return false;
    if (node.type !== "PipelineBareFunction") return false;
    return opts == null || shallowEqual(node, opts);
}
function isPipelinePrimaryTopicReference(node, opts) {
    if (!node) return false;
    if (node.type !== "PipelinePrimaryTopicReference") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSParameterProperty(node, opts) {
    if (!node) return false;
    if (node.type !== "TSParameterProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSDeclareFunction(node, opts) {
    if (!node) return false;
    if (node.type !== "TSDeclareFunction") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSDeclareMethod(node, opts) {
    if (!node) return false;
    if (node.type !== "TSDeclareMethod") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSQualifiedName(node, opts) {
    if (!node) return false;
    if (node.type !== "TSQualifiedName") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSCallSignatureDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSCallSignatureDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSConstructSignatureDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSConstructSignatureDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSPropertySignature(node, opts) {
    if (!node) return false;
    if (node.type !== "TSPropertySignature") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSMethodSignature(node, opts) {
    if (!node) return false;
    if (node.type !== "TSMethodSignature") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSIndexSignature(node, opts) {
    if (!node) return false;
    if (node.type !== "TSIndexSignature") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSAnyKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSAnyKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSBooleanKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSBooleanKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSBigIntKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSBigIntKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSIntrinsicKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSIntrinsicKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNeverKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNeverKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNullKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNullKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNumberKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNumberKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSObjectKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSObjectKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSStringKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSStringKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSSymbolKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSSymbolKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSUndefinedKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSUndefinedKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSUnknownKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSUnknownKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSVoidKeyword(node, opts) {
    if (!node) return false;
    if (node.type !== "TSVoidKeyword") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSThisType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSThisType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSFunctionType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSFunctionType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSConstructorType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSConstructorType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeReference(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeReference") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypePredicate(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypePredicate") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeQuery(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeQuery") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeLiteral(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSArrayType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSArrayType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTupleType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTupleType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSOptionalType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSOptionalType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSRestType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSRestType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNamedTupleMember(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNamedTupleMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSUnionType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSUnionType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSIntersectionType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSIntersectionType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSConditionalType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSConditionalType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSInferType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSInferType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSParenthesizedType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSParenthesizedType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeOperator(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeOperator") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSIndexedAccessType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSIndexedAccessType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSMappedType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSMappedType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSLiteralType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSLiteralType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSExpressionWithTypeArguments(node, opts) {
    if (!node) return false;
    if (node.type !== "TSExpressionWithTypeArguments") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSInterfaceDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSInterfaceDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSInterfaceBody(node, opts) {
    if (!node) return false;
    if (node.type !== "TSInterfaceBody") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeAliasDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeAliasDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSInstantiationExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TSInstantiationExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSAsExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TSAsExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSSatisfiesExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TSSatisfiesExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeAssertion(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeAssertion") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSEnumDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSEnumDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSEnumMember(node, opts) {
    if (!node) return false;
    if (node.type !== "TSEnumMember") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSModuleDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSModuleDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSModuleBlock(node, opts) {
    if (!node) return false;
    if (node.type !== "TSModuleBlock") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSImportType(node, opts) {
    if (!node) return false;
    if (node.type !== "TSImportType") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSImportEqualsDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSImportEqualsDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSExternalModuleReference(node, opts) {
    if (!node) return false;
    if (node.type !== "TSExternalModuleReference") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNonNullExpression(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNonNullExpression") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSExportAssignment(node, opts) {
    if (!node) return false;
    if (node.type !== "TSExportAssignment") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSNamespaceExportDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSNamespaceExportDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeAnnotation(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeAnnotation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeParameterInstantiation(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeParameterInstantiation") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeParameterDeclaration(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeParameterDeclaration") return false;
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeParameter(node, opts) {
    if (!node) return false;
    if (node.type !== "TSTypeParameter") return false;
    return opts == null || shallowEqual(node, opts);
}
function isStandardized(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ArrayExpression":
        case "AssignmentExpression":
        case "BinaryExpression":
        case "InterpreterDirective":
        case "Directive":
        case "DirectiveLiteral":
        case "BlockStatement":
        case "BreakStatement":
        case "CallExpression":
        case "CatchClause":
        case "ConditionalExpression":
        case "ContinueStatement":
        case "DebuggerStatement":
        case "DoWhileStatement":
        case "EmptyStatement":
        case "ExpressionStatement":
        case "File":
        case "ForInStatement":
        case "ForStatement":
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "Identifier":
        case "IfStatement":
        case "LabeledStatement":
        case "StringLiteral":
        case "NumericLiteral":
        case "NullLiteral":
        case "BooleanLiteral":
        case "RegExpLiteral":
        case "LogicalExpression":
        case "MemberExpression":
        case "NewExpression":
        case "Program":
        case "ObjectExpression":
        case "ObjectMethod":
        case "ObjectProperty":
        case "RestElement":
        case "ReturnStatement":
        case "SequenceExpression":
        case "ParenthesizedExpression":
        case "SwitchCase":
        case "SwitchStatement":
        case "ThisExpression":
        case "ThrowStatement":
        case "TryStatement":
        case "UnaryExpression":
        case "UpdateExpression":
        case "VariableDeclaration":
        case "VariableDeclarator":
        case "WhileStatement":
        case "WithStatement":
        case "AssignmentPattern":
        case "ArrayPattern":
        case "ArrowFunctionExpression":
        case "ClassBody":
        case "ClassExpression":
        case "ClassDeclaration":
        case "ExportAllDeclaration":
        case "ExportDefaultDeclaration":
        case "ExportNamedDeclaration":
        case "ExportSpecifier":
        case "ForOfStatement":
        case "ImportDeclaration":
        case "ImportDefaultSpecifier":
        case "ImportNamespaceSpecifier":
        case "ImportSpecifier":
        case "ImportExpression":
        case "MetaProperty":
        case "ClassMethod":
        case "ObjectPattern":
        case "SpreadElement":
        case "Super":
        case "TaggedTemplateExpression":
        case "TemplateElement":
        case "TemplateLiteral":
        case "YieldExpression":
        case "AwaitExpression":
        case "Import":
        case "BigIntLiteral":
        case "ExportNamespaceSpecifier":
        case "OptionalMemberExpression":
        case "OptionalCallExpression":
        case "ClassProperty":
        case "ClassAccessorProperty":
        case "ClassPrivateProperty":
        case "ClassPrivateMethod":
        case "PrivateName":
        case "StaticBlock":
            break;
        case "Placeholder":
            switch(node.expectedNode){
                case "Identifier":
                case "StringLiteral":
                case "BlockStatement":
                case "ClassBody":
                    break;
                default:
                    return false;
            }
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isExpression(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ArrayExpression":
        case "AssignmentExpression":
        case "BinaryExpression":
        case "CallExpression":
        case "ConditionalExpression":
        case "FunctionExpression":
        case "Identifier":
        case "StringLiteral":
        case "NumericLiteral":
        case "NullLiteral":
        case "BooleanLiteral":
        case "RegExpLiteral":
        case "LogicalExpression":
        case "MemberExpression":
        case "NewExpression":
        case "ObjectExpression":
        case "SequenceExpression":
        case "ParenthesizedExpression":
        case "ThisExpression":
        case "UnaryExpression":
        case "UpdateExpression":
        case "ArrowFunctionExpression":
        case "ClassExpression":
        case "ImportExpression":
        case "MetaProperty":
        case "Super":
        case "TaggedTemplateExpression":
        case "TemplateLiteral":
        case "YieldExpression":
        case "AwaitExpression":
        case "Import":
        case "BigIntLiteral":
        case "OptionalMemberExpression":
        case "OptionalCallExpression":
        case "TypeCastExpression":
        case "JSXElement":
        case "JSXFragment":
        case "BindExpression":
        case "DoExpression":
        case "RecordExpression":
        case "TupleExpression":
        case "DecimalLiteral":
        case "ModuleExpression":
        case "TopicReference":
        case "PipelineTopicExpression":
        case "PipelineBareFunction":
        case "PipelinePrimaryTopicReference":
        case "TSInstantiationExpression":
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
        case "TSNonNullExpression":
            break;
        case "Placeholder":
            switch(node.expectedNode){
                case "Expression":
                case "Identifier":
                case "StringLiteral":
                    break;
                default:
                    return false;
            }
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isBinary(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BinaryExpression":
        case "LogicalExpression":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isScopable(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BlockStatement":
        case "CatchClause":
        case "DoWhileStatement":
        case "ForInStatement":
        case "ForStatement":
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "Program":
        case "ObjectMethod":
        case "SwitchStatement":
        case "WhileStatement":
        case "ArrowFunctionExpression":
        case "ClassExpression":
        case "ClassDeclaration":
        case "ForOfStatement":
        case "ClassMethod":
        case "ClassPrivateMethod":
        case "StaticBlock":
        case "TSModuleBlock":
            break;
        case "Placeholder":
            if (node.expectedNode === "BlockStatement") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isBlockParent(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BlockStatement":
        case "CatchClause":
        case "DoWhileStatement":
        case "ForInStatement":
        case "ForStatement":
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "Program":
        case "ObjectMethod":
        case "SwitchStatement":
        case "WhileStatement":
        case "ArrowFunctionExpression":
        case "ForOfStatement":
        case "ClassMethod":
        case "ClassPrivateMethod":
        case "StaticBlock":
        case "TSModuleBlock":
            break;
        case "Placeholder":
            if (node.expectedNode === "BlockStatement") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isBlock(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BlockStatement":
        case "Program":
        case "TSModuleBlock":
            break;
        case "Placeholder":
            if (node.expectedNode === "BlockStatement") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isStatement(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BlockStatement":
        case "BreakStatement":
        case "ContinueStatement":
        case "DebuggerStatement":
        case "DoWhileStatement":
        case "EmptyStatement":
        case "ExpressionStatement":
        case "ForInStatement":
        case "ForStatement":
        case "FunctionDeclaration":
        case "IfStatement":
        case "LabeledStatement":
        case "ReturnStatement":
        case "SwitchStatement":
        case "ThrowStatement":
        case "TryStatement":
        case "VariableDeclaration":
        case "WhileStatement":
        case "WithStatement":
        case "ClassDeclaration":
        case "ExportAllDeclaration":
        case "ExportDefaultDeclaration":
        case "ExportNamedDeclaration":
        case "ForOfStatement":
        case "ImportDeclaration":
        case "DeclareClass":
        case "DeclareFunction":
        case "DeclareInterface":
        case "DeclareModule":
        case "DeclareModuleExports":
        case "DeclareTypeAlias":
        case "DeclareOpaqueType":
        case "DeclareVariable":
        case "DeclareExportDeclaration":
        case "DeclareExportAllDeclaration":
        case "InterfaceDeclaration":
        case "OpaqueType":
        case "TypeAlias":
        case "EnumDeclaration":
        case "TSDeclareFunction":
        case "TSInterfaceDeclaration":
        case "TSTypeAliasDeclaration":
        case "TSEnumDeclaration":
        case "TSModuleDeclaration":
        case "TSImportEqualsDeclaration":
        case "TSExportAssignment":
        case "TSNamespaceExportDeclaration":
            break;
        case "Placeholder":
            switch(node.expectedNode){
                case "Statement":
                case "Declaration":
                case "BlockStatement":
                    break;
                default:
                    return false;
            }
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTerminatorless(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BreakStatement":
        case "ContinueStatement":
        case "ReturnStatement":
        case "ThrowStatement":
        case "YieldExpression":
        case "AwaitExpression":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isCompletionStatement(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "BreakStatement":
        case "ContinueStatement":
        case "ReturnStatement":
        case "ThrowStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isConditional(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ConditionalExpression":
        case "IfStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isLoop(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "DoWhileStatement":
        case "ForInStatement":
        case "ForStatement":
        case "WhileStatement":
        case "ForOfStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isWhile(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "DoWhileStatement":
        case "WhileStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isExpressionWrapper(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ExpressionStatement":
        case "ParenthesizedExpression":
        case "TypeCastExpression":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFor(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ForInStatement":
        case "ForStatement":
        case "ForOfStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isForXStatement(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ForInStatement":
        case "ForOfStatement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFunction(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "ObjectMethod":
        case "ArrowFunctionExpression":
        case "ClassMethod":
        case "ClassPrivateMethod":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFunctionParent(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "ObjectMethod":
        case "ArrowFunctionExpression":
        case "ClassMethod":
        case "ClassPrivateMethod":
        case "StaticBlock":
        case "TSModuleBlock":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isPureish(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "FunctionDeclaration":
        case "FunctionExpression":
        case "StringLiteral":
        case "NumericLiteral":
        case "NullLiteral":
        case "BooleanLiteral":
        case "RegExpLiteral":
        case "ArrowFunctionExpression":
        case "BigIntLiteral":
        case "DecimalLiteral":
            break;
        case "Placeholder":
            if (node.expectedNode === "StringLiteral") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isDeclaration(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "FunctionDeclaration":
        case "VariableDeclaration":
        case "ClassDeclaration":
        case "ExportAllDeclaration":
        case "ExportDefaultDeclaration":
        case "ExportNamedDeclaration":
        case "ImportDeclaration":
        case "DeclareClass":
        case "DeclareFunction":
        case "DeclareInterface":
        case "DeclareModule":
        case "DeclareModuleExports":
        case "DeclareTypeAlias":
        case "DeclareOpaqueType":
        case "DeclareVariable":
        case "DeclareExportDeclaration":
        case "DeclareExportAllDeclaration":
        case "InterfaceDeclaration":
        case "OpaqueType":
        case "TypeAlias":
        case "EnumDeclaration":
        case "TSDeclareFunction":
        case "TSInterfaceDeclaration":
        case "TSTypeAliasDeclaration":
        case "TSEnumDeclaration":
        case "TSModuleDeclaration":
            break;
        case "Placeholder":
            if (node.expectedNode === "Declaration") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isPatternLike(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "Identifier":
        case "RestElement":
        case "AssignmentPattern":
        case "ArrayPattern":
        case "ObjectPattern":
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
        case "TSNonNullExpression":
            break;
        case "Placeholder":
            switch(node.expectedNode){
                case "Pattern":
                case "Identifier":
                    break;
                default:
                    return false;
            }
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isLVal(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "Identifier":
        case "MemberExpression":
        case "RestElement":
        case "AssignmentPattern":
        case "ArrayPattern":
        case "ObjectPattern":
        case "TSParameterProperty":
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
        case "TSNonNullExpression":
            break;
        case "Placeholder":
            switch(node.expectedNode){
                case "Pattern":
                case "Identifier":
                    break;
                default:
                    return false;
            }
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTSEntityName(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "Identifier":
        case "TSQualifiedName":
            break;
        case "Placeholder":
            if (node.expectedNode === "Identifier") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isLiteral(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "StringLiteral":
        case "NumericLiteral":
        case "NullLiteral":
        case "BooleanLiteral":
        case "RegExpLiteral":
        case "TemplateLiteral":
        case "BigIntLiteral":
        case "DecimalLiteral":
            break;
        case "Placeholder":
            if (node.expectedNode === "StringLiteral") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isUserWhitespacable(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ObjectMethod":
        case "ObjectProperty":
        case "ObjectTypeInternalSlot":
        case "ObjectTypeCallProperty":
        case "ObjectTypeIndexer":
        case "ObjectTypeProperty":
        case "ObjectTypeSpreadProperty":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isMethod(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ObjectMethod":
        case "ClassMethod":
        case "ClassPrivateMethod":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isObjectMember(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ObjectMethod":
        case "ObjectProperty":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isProperty(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ObjectProperty":
        case "ClassProperty":
        case "ClassAccessorProperty":
        case "ClassPrivateProperty":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isUnaryLike(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "UnaryExpression":
        case "SpreadElement":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isPattern(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "AssignmentPattern":
        case "ArrayPattern":
        case "ObjectPattern":
            break;
        case "Placeholder":
            if (node.expectedNode === "Pattern") break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isClass(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ClassExpression":
        case "ClassDeclaration":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isImportOrExportDeclaration(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ExportAllDeclaration":
        case "ExportDefaultDeclaration":
        case "ExportNamedDeclaration":
        case "ImportDeclaration":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isExportDeclaration(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ExportAllDeclaration":
        case "ExportDefaultDeclaration":
        case "ExportNamedDeclaration":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isModuleSpecifier(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ExportSpecifier":
        case "ImportDefaultSpecifier":
        case "ImportNamespaceSpecifier":
        case "ImportSpecifier":
        case "ExportNamespaceSpecifier":
        case "ExportDefaultSpecifier":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isAccessor(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ClassAccessorProperty":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isPrivate(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "ClassPrivateProperty":
        case "ClassPrivateMethod":
        case "PrivateName":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFlow(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "AnyTypeAnnotation":
        case "ArrayTypeAnnotation":
        case "BooleanTypeAnnotation":
        case "BooleanLiteralTypeAnnotation":
        case "NullLiteralTypeAnnotation":
        case "ClassImplements":
        case "DeclareClass":
        case "DeclareFunction":
        case "DeclareInterface":
        case "DeclareModule":
        case "DeclareModuleExports":
        case "DeclareTypeAlias":
        case "DeclareOpaqueType":
        case "DeclareVariable":
        case "DeclareExportDeclaration":
        case "DeclareExportAllDeclaration":
        case "DeclaredPredicate":
        case "ExistsTypeAnnotation":
        case "FunctionTypeAnnotation":
        case "FunctionTypeParam":
        case "GenericTypeAnnotation":
        case "InferredPredicate":
        case "InterfaceExtends":
        case "InterfaceDeclaration":
        case "InterfaceTypeAnnotation":
        case "IntersectionTypeAnnotation":
        case "MixedTypeAnnotation":
        case "EmptyTypeAnnotation":
        case "NullableTypeAnnotation":
        case "NumberLiteralTypeAnnotation":
        case "NumberTypeAnnotation":
        case "ObjectTypeAnnotation":
        case "ObjectTypeInternalSlot":
        case "ObjectTypeCallProperty":
        case "ObjectTypeIndexer":
        case "ObjectTypeProperty":
        case "ObjectTypeSpreadProperty":
        case "OpaqueType":
        case "QualifiedTypeIdentifier":
        case "StringLiteralTypeAnnotation":
        case "StringTypeAnnotation":
        case "SymbolTypeAnnotation":
        case "ThisTypeAnnotation":
        case "TupleTypeAnnotation":
        case "TypeofTypeAnnotation":
        case "TypeAlias":
        case "TypeAnnotation":
        case "TypeCastExpression":
        case "TypeParameter":
        case "TypeParameterDeclaration":
        case "TypeParameterInstantiation":
        case "UnionTypeAnnotation":
        case "Variance":
        case "VoidTypeAnnotation":
        case "EnumDeclaration":
        case "EnumBooleanBody":
        case "EnumNumberBody":
        case "EnumStringBody":
        case "EnumSymbolBody":
        case "EnumBooleanMember":
        case "EnumNumberMember":
        case "EnumStringMember":
        case "EnumDefaultedMember":
        case "IndexedAccessType":
        case "OptionalIndexedAccessType":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFlowType(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "AnyTypeAnnotation":
        case "ArrayTypeAnnotation":
        case "BooleanTypeAnnotation":
        case "BooleanLiteralTypeAnnotation":
        case "NullLiteralTypeAnnotation":
        case "ExistsTypeAnnotation":
        case "FunctionTypeAnnotation":
        case "GenericTypeAnnotation":
        case "InterfaceTypeAnnotation":
        case "IntersectionTypeAnnotation":
        case "MixedTypeAnnotation":
        case "EmptyTypeAnnotation":
        case "NullableTypeAnnotation":
        case "NumberLiteralTypeAnnotation":
        case "NumberTypeAnnotation":
        case "ObjectTypeAnnotation":
        case "StringLiteralTypeAnnotation":
        case "StringTypeAnnotation":
        case "SymbolTypeAnnotation":
        case "ThisTypeAnnotation":
        case "TupleTypeAnnotation":
        case "TypeofTypeAnnotation":
        case "UnionTypeAnnotation":
        case "VoidTypeAnnotation":
        case "IndexedAccessType":
        case "OptionalIndexedAccessType":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFlowBaseAnnotation(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "AnyTypeAnnotation":
        case "BooleanTypeAnnotation":
        case "NullLiteralTypeAnnotation":
        case "MixedTypeAnnotation":
        case "EmptyTypeAnnotation":
        case "NumberTypeAnnotation":
        case "StringTypeAnnotation":
        case "SymbolTypeAnnotation":
        case "ThisTypeAnnotation":
        case "VoidTypeAnnotation":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFlowDeclaration(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "DeclareClass":
        case "DeclareFunction":
        case "DeclareInterface":
        case "DeclareModule":
        case "DeclareModuleExports":
        case "DeclareTypeAlias":
        case "DeclareOpaqueType":
        case "DeclareVariable":
        case "DeclareExportDeclaration":
        case "DeclareExportAllDeclaration":
        case "InterfaceDeclaration":
        case "OpaqueType":
        case "TypeAlias":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isFlowPredicate(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "DeclaredPredicate":
        case "InferredPredicate":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isEnumBody(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "EnumBooleanBody":
        case "EnumNumberBody":
        case "EnumStringBody":
        case "EnumSymbolBody":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isEnumMember(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "EnumBooleanMember":
        case "EnumNumberMember":
        case "EnumStringMember":
        case "EnumDefaultedMember":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isJSX(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "JSXAttribute":
        case "JSXClosingElement":
        case "JSXElement":
        case "JSXEmptyExpression":
        case "JSXExpressionContainer":
        case "JSXSpreadChild":
        case "JSXIdentifier":
        case "JSXMemberExpression":
        case "JSXNamespacedName":
        case "JSXOpeningElement":
        case "JSXSpreadAttribute":
        case "JSXText":
        case "JSXFragment":
        case "JSXOpeningFragment":
        case "JSXClosingFragment":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isMiscellaneous(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "Noop":
        case "Placeholder":
        case "V8IntrinsicIdentifier":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTypeScript(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "TSParameterProperty":
        case "TSDeclareFunction":
        case "TSDeclareMethod":
        case "TSQualifiedName":
        case "TSCallSignatureDeclaration":
        case "TSConstructSignatureDeclaration":
        case "TSPropertySignature":
        case "TSMethodSignature":
        case "TSIndexSignature":
        case "TSAnyKeyword":
        case "TSBooleanKeyword":
        case "TSBigIntKeyword":
        case "TSIntrinsicKeyword":
        case "TSNeverKeyword":
        case "TSNullKeyword":
        case "TSNumberKeyword":
        case "TSObjectKeyword":
        case "TSStringKeyword":
        case "TSSymbolKeyword":
        case "TSUndefinedKeyword":
        case "TSUnknownKeyword":
        case "TSVoidKeyword":
        case "TSThisType":
        case "TSFunctionType":
        case "TSConstructorType":
        case "TSTypeReference":
        case "TSTypePredicate":
        case "TSTypeQuery":
        case "TSTypeLiteral":
        case "TSArrayType":
        case "TSTupleType":
        case "TSOptionalType":
        case "TSRestType":
        case "TSNamedTupleMember":
        case "TSUnionType":
        case "TSIntersectionType":
        case "TSConditionalType":
        case "TSInferType":
        case "TSParenthesizedType":
        case "TSTypeOperator":
        case "TSIndexedAccessType":
        case "TSMappedType":
        case "TSLiteralType":
        case "TSExpressionWithTypeArguments":
        case "TSInterfaceDeclaration":
        case "TSInterfaceBody":
        case "TSTypeAliasDeclaration":
        case "TSInstantiationExpression":
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
        case "TSEnumDeclaration":
        case "TSEnumMember":
        case "TSModuleDeclaration":
        case "TSModuleBlock":
        case "TSImportType":
        case "TSImportEqualsDeclaration":
        case "TSExternalModuleReference":
        case "TSNonNullExpression":
        case "TSExportAssignment":
        case "TSNamespaceExportDeclaration":
        case "TSTypeAnnotation":
        case "TSTypeParameterInstantiation":
        case "TSTypeParameterDeclaration":
        case "TSTypeParameter":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTSTypeElement(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "TSCallSignatureDeclaration":
        case "TSConstructSignatureDeclaration":
        case "TSPropertySignature":
        case "TSMethodSignature":
        case "TSIndexSignature":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTSType(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "TSAnyKeyword":
        case "TSBooleanKeyword":
        case "TSBigIntKeyword":
        case "TSIntrinsicKeyword":
        case "TSNeverKeyword":
        case "TSNullKeyword":
        case "TSNumberKeyword":
        case "TSObjectKeyword":
        case "TSStringKeyword":
        case "TSSymbolKeyword":
        case "TSUndefinedKeyword":
        case "TSUnknownKeyword":
        case "TSVoidKeyword":
        case "TSThisType":
        case "TSFunctionType":
        case "TSConstructorType":
        case "TSTypeReference":
        case "TSTypePredicate":
        case "TSTypeQuery":
        case "TSTypeLiteral":
        case "TSArrayType":
        case "TSTupleType":
        case "TSOptionalType":
        case "TSRestType":
        case "TSUnionType":
        case "TSIntersectionType":
        case "TSConditionalType":
        case "TSInferType":
        case "TSParenthesizedType":
        case "TSTypeOperator":
        case "TSIndexedAccessType":
        case "TSMappedType":
        case "TSLiteralType":
        case "TSExpressionWithTypeArguments":
        case "TSImportType":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isTSBaseType(node, opts) {
    if (!node) return false;
    switch(node.type){
        case "TSAnyKeyword":
        case "TSBooleanKeyword":
        case "TSBigIntKeyword":
        case "TSIntrinsicKeyword":
        case "TSNeverKeyword":
        case "TSNullKeyword":
        case "TSNumberKeyword":
        case "TSObjectKeyword":
        case "TSStringKeyword":
        case "TSSymbolKeyword":
        case "TSUndefinedKeyword":
        case "TSUnknownKeyword":
        case "TSVoidKeyword":
        case "TSThisType":
        case "TSLiteralType":
            break;
        default:
            return false;
    }
    return opts == null || shallowEqual(node, opts);
}
function isNumberLiteral(node, opts) {
    deprecationWarning("isNumberLiteral", "isNumericLiteral");
    if (!node) return false;
    if (node.type !== "NumberLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isRegexLiteral(node, opts) {
    deprecationWarning("isRegexLiteral", "isRegExpLiteral");
    if (!node) return false;
    if (node.type !== "RegexLiteral") return false;
    return opts == null || shallowEqual(node, opts);
}
function isRestProperty(node, opts) {
    deprecationWarning("isRestProperty", "isRestElement");
    if (!node) return false;
    if (node.type !== "RestProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isSpreadProperty(node, opts) {
    deprecationWarning("isSpreadProperty", "isSpreadElement");
    if (!node) return false;
    if (node.type !== "SpreadProperty") return false;
    return opts == null || shallowEqual(node, opts);
}
function isModuleDeclaration(node, opts) {
    deprecationWarning("isModuleDeclaration", "isImportOrExportDeclaration");
    return isImportOrExportDeclaration(node, opts);
}
function matchesPattern(member, match, allowPartial) {
    if (!isMemberExpression(member)) return false;
    var parts = Array.isArray(match) ? match : match.split(".");
    var nodes2 = [];
    var node;
    for(node = member; isMemberExpression(node); node = node.object){
        nodes2.push(node.property);
    }
    nodes2.push(node);
    if (nodes2.length < parts.length) return false;
    if (!allowPartial && nodes2.length > parts.length) return false;
    for(var i = 0, j = nodes2.length - 1; i < parts.length; i++, j--){
        var node2 = nodes2[j];
        var value1 = void 0;
        if (isIdentifier(node2)) {
            value1 = node2.name;
        } else if (isStringLiteral(node2)) {
            value1 = node2.value;
        } else if (isThisExpression(node2)) {
            value1 = "this";
        } else {
            return false;
        }
        if (parts[i] !== value1) return false;
    }
    return true;
}
function buildMatchMemberExpression(match, allowPartial) {
    var parts = match.split(".");
    return function(member) {
        return matchesPattern(member, parts, allowPartial);
    };
}
var isReactComponent = buildMatchMemberExpression("React.Component");
function isCompatTag(tagName) {
    return !!tagName && /^[a-z]/.test(tagName);
}
function isType(nodeType, targetType) {
    if (nodeType === targetType) return true;
    if (nodeType == null) return false;
    if (ALIAS_KEYS[targetType]) return false;
    var aliases = FLIPPED_ALIAS_KEYS[targetType];
    if (aliases) {
        if (aliases[0] === nodeType) return true;
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = aliases[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var alias = _step.value;
                if (nodeType === alias) return true;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return false;
}
function isPlaceholderType(placeholderType, targetType) {
    if (placeholderType === targetType) return true;
    var aliases = PLACEHOLDERS_ALIAS[placeholderType];
    if (aliases) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = aliases[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var alias = _step.value;
                if (targetType === alias) return true;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return false;
}
function is(type, node, opts) {
    if (!node) return false;
    var matches = isType(node.type, type);
    if (!matches) {
        if (!opts && node.type === "Placeholder" && type in FLIPPED_ALIAS_KEYS) {
            return isPlaceholderType(node.expectedNode, type);
        }
        return false;
    }
    if (typeof opts === "undefined") {
        return true;
    } else {
        return shallowEqual(node, opts);
    }
}
function isValidIdentifier(name) {
    var reserved = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    if (typeof name !== "string") return false;
    if (reserved) {
        if (isKeyword(name) || isStrictReservedWord(name, true)) {
            return false;
        }
    }
    return isIdentifierName(name);
}
var STATEMENT_OR_BLOCK_KEYS = [
    "consequent",
    "body",
    "alternate"
];
var FLATTENABLE_KEYS = [
    "body",
    "expressions"
];
var FOR_INIT_KEYS = [
    "left",
    "init"
];
var COMMENT_KEYS = [
    "leadingComments",
    "trailingComments",
    "innerComments"
];
var LOGICAL_OPERATORS = [
    "||",
    "&&",
    "??"
];
var UPDATE_OPERATORS = [
    "++",
    "--"
];
var BOOLEAN_NUMBER_BINARY_OPERATORS = [
    ">",
    "<",
    ">=",
    "<="
];
var EQUALITY_BINARY_OPERATORS = [
    "==",
    "===",
    "!=",
    "!=="
];
var COMPARISON_BINARY_OPERATORS = _to_consumable_array(EQUALITY_BINARY_OPERATORS).concat([
    "in",
    "instanceof"
]);
var BOOLEAN_BINARY_OPERATORS = _to_consumable_array(COMPARISON_BINARY_OPERATORS).concat(_to_consumable_array(BOOLEAN_NUMBER_BINARY_OPERATORS));
var NUMBER_BINARY_OPERATORS = [
    "-",
    "/",
    "%",
    "*",
    "**",
    "&",
    "|",
    ">>",
    ">>>",
    "<<",
    "^"
];
var BINARY_OPERATORS = [
    "+"
].concat(_to_consumable_array(NUMBER_BINARY_OPERATORS), _to_consumable_array(BOOLEAN_BINARY_OPERATORS), [
    "|>"
]);
var ASSIGNMENT_OPERATORS = [
    "=",
    "+="
].concat(_to_consumable_array(NUMBER_BINARY_OPERATORS.map(function(op) {
    return op + "=";
})), _to_consumable_array(LOGICAL_OPERATORS.map(function(op) {
    return op + "=";
})));
var BOOLEAN_UNARY_OPERATORS = [
    "delete",
    "!"
];
var NUMBER_UNARY_OPERATORS = [
    "+",
    "-",
    "~"
];
var STRING_UNARY_OPERATORS = [
    "typeof"
];
var UNARY_OPERATORS = [
    "void",
    "throw"
].concat(_to_consumable_array(BOOLEAN_UNARY_OPERATORS), _to_consumable_array(NUMBER_UNARY_OPERATORS), _to_consumable_array(STRING_UNARY_OPERATORS));
var INHERIT_KEYS = {
    optional: [
        "typeAnnotation",
        "typeParameters",
        "returnType"
    ],
    force: [
        "start",
        "loc",
        "end"
    ]
};
var BLOCK_SCOPED_SYMBOL = Symbol.for("var used to be block scoped");
var NOT_LOCAL_BINDING = Symbol.for("should not be considered a local binding");
var VISITOR_KEYS = {};
var ALIAS_KEYS = {};
var FLIPPED_ALIAS_KEYS = {};
var NODE_FIELDS = {};
var BUILDER_KEYS = {};
var DEPRECATED_KEYS = {};
var NODE_PARENT_VALIDATIONS = {};
function getType(val) {
    if (Array.isArray(val)) {
        return "array";
    } else if (val === null) {
        return "null";
    } else {
        return typeof val === "undefined" ? "undefined" : _type_of(val);
    }
}
function validate$1(validate4) {
    return {
        validate: validate4
    };
}
function typeIs(typeName) {
    return typeof typeName === "string" ? assertNodeType(typeName) : assertNodeType.apply(void 0, _to_consumable_array(typeName));
}
function validateType(typeName) {
    return validate$1(typeIs(typeName));
}
function validateOptional(validate4) {
    return {
        validate: validate4,
        optional: true
    };
}
function validateOptionalType(typeName) {
    return {
        validate: typeIs(typeName),
        optional: true
    };
}
function arrayOf(elementType) {
    return chain(assertValueType("array"), assertEach(elementType));
}
function arrayOfType(typeName) {
    return arrayOf(typeIs(typeName));
}
function validateArrayOfType(typeName) {
    return validate$1(arrayOfType(typeName));
}
function assertEach(callback) {
    function validator(node, key, val) {
        if (!Array.isArray(val)) return;
        for(var i = 0; i < val.length; i++){
            var subkey = "".concat(key, "[").concat(i, "]");
            var v = val[i];
            callback(node, subkey, v);
            if (process.env.BABEL_TYPES_8_BREAKING) validateChild(node, subkey, v);
        }
    }
    validator.each = callback;
    return validator;
}
function assertOneOf() {
    for(var _len = arguments.length, values = new Array(_len), _key = 0; _key < _len; _key++){
        values[_key] = arguments[_key];
    }
    function validate4(node, key, val) {
        if (values.indexOf(val) < 0) {
            throw new TypeError("Property ".concat(key, " expected value to be one of ").concat(JSON.stringify(values), " but got ").concat(JSON.stringify(val)));
        }
    }
    validate4.oneOf = values;
    return validate4;
}
function assertNodeType() {
    for(var _len = arguments.length, types2 = new Array(_len), _key = 0; _key < _len; _key++){
        types2[_key] = arguments[_key];
    }
    function validate4(node, key, val) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = types2[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var type = _step.value;
                if (is(type, val)) {
                    validateChild(node, key, val);
                    return;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        throw new TypeError("Property ".concat(key, " of ").concat(node.type, " expected node to be of a type ").concat(JSON.stringify(types2), " but instead got ").concat(JSON.stringify(val === null || val === void 0 ? void 0 : val.type)));
    }
    validate4.oneOfNodeTypes = types2;
    return validate4;
}
function assertNodeOrValueType() {
    for(var _len = arguments.length, types2 = new Array(_len), _key = 0; _key < _len; _key++){
        types2[_key] = arguments[_key];
    }
    function validate4(node, key, val) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = types2[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var type = _step.value;
                if (getType(val) === type || is(type, val)) {
                    validateChild(node, key, val);
                    return;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        throw new TypeError("Property ".concat(key, " of ").concat(node.type, " expected node to be of a type ").concat(JSON.stringify(types2), " but instead got ").concat(JSON.stringify(val === null || val === void 0 ? void 0 : val.type)));
    }
    validate4.oneOfNodeOrValueTypes = types2;
    return validate4;
}
function assertValueType(type) {
    function validate4(node, key, val) {
        var valid = getType(val) === type;
        if (!valid) {
            throw new TypeError("Property ".concat(key, " expected type of ").concat(type, " but got ").concat(getType(val)));
        }
    }
    validate4.type = type;
    return validate4;
}
function assertShape(shape) {
    function validate4(node, key, val) {
        var errors = [];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = Object.keys(shape)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var property = _step.value;
                try {
                    validateField(node, property, val[property], shape[property]);
                } catch (error) {
                    if (_instanceof(error, TypeError)) {
                        errors.push(error.message);
                        continue;
                    }
                    throw error;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        if (errors.length) {
            throw new TypeError("Property ".concat(key, " of ").concat(node.type, " expected to have the following:\n").concat(errors.join("\n")));
        }
    }
    validate4.shapeOf = shape;
    return validate4;
}
function assertOptionalChainStart() {
    function validate4(node) {
        var current = node;
        while(node){
            var type = current.type;
            if (type === "OptionalCallExpression") {
                if (current.optional) return;
                current = current.callee;
                continue;
            }
            if (type === "OptionalMemberExpression") {
                if (current.optional) return;
                current = current.object;
                continue;
            }
            break;
        }
        throw new TypeError("Non-optional ".concat(node.type, " must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from ").concat(current === null || current === void 0 ? void 0 : current.type));
    }
    return validate4;
}
function chain() {
    for(var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++){
        fns[_key] = arguments[_key];
    }
    function validate4() {
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
            args[_key] = arguments[_key];
        }
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = fns[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var fn = _step.value;
                fn.apply(void 0, _to_consumable_array(args));
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    validate4.chainOf = fns;
    if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
        throw new Error('An assertValueType("array") validator can only be followed by an assertEach(...) validator.');
    }
    return validate4;
}
var validTypeOpts = [
    "aliases",
    "builder",
    "deprecatedAlias",
    "fields",
    "inherits",
    "visitor",
    "validate"
];
var validFieldKeys = [
    "default",
    "optional",
    "deprecated",
    "validate"
];
var store = {};
function defineAliasedType() {
    for(var _len = arguments.length, aliases = new Array(_len), _key = 0; _key < _len; _key++){
        aliases[_key] = arguments[_key];
    }
    return function(type) {
        var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var _defined;
        var defined = opts.aliases;
        if (!defined) {
            var _store_opts_inherits_aliases;
            if (opts.inherits) defined = (_store_opts_inherits_aliases = store[opts.inherits].aliases) === null || _store_opts_inherits_aliases === void 0 ? void 0 : _store_opts_inherits_aliases.slice();
            defined !== null && defined !== void 0 ? defined : defined = [];
            opts.aliases = defined;
        }
        var additional = aliases.filter(function(a) {
            return !defined.includes(a);
        });
        (_defined = defined).unshift.apply(_defined, _to_consumable_array(additional));
        defineType$5(type, opts);
    };
}
function defineType$5(type) {
    var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var inherits2 = opts.inherits && store[opts.inherits] || {};
    var fields = opts.fields;
    if (!fields) {
        fields = {};
        if (inherits2.fields) {
            var keys = Object.getOwnPropertyNames(inherits2.fields);
            var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
            try {
                for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                    var key = _step.value;
                    var field = inherits2.fields[key];
                    var def = field.default;
                    if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
                        throw new Error("field defaults can only be primitives or empty arrays currently");
                    }
                    fields[key] = {
                        default: Array.isArray(def) ? [] : def,
                        optional: field.optional,
                        deprecated: field.deprecated,
                        validate: field.validate
                    };
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                } finally{
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }
    var visitor4 = opts.visitor || inherits2.visitor || [];
    var aliases = opts.aliases || inherits2.aliases || [];
    var builder = opts.builder || inherits2.builder || opts.visitor || [];
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = Object.keys(opts)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var k = _step1.value;
            if (validTypeOpts.indexOf(k) === -1) {
                throw new Error('Unknown type option "'.concat(k, '" on ').concat(type));
            }
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    if (opts.deprecatedAlias) {
        DEPRECATED_KEYS[opts.deprecatedAlias] = type;
    }
    var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
    try {
        for(var _iterator2 = visitor4.concat(builder)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
            var key1 = _step2.value;
            fields[key1] = fields[key1] || {};
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                _iterator2.return();
            }
        } finally{
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }
    var _iteratorNormalCompletion3 = true, _didIteratorError3 = false, _iteratorError3 = undefined;
    try {
        for(var _iterator3 = Object.keys(fields)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true){
            var key2 = _step3.value;
            var field1 = fields[key2];
            if (field1.default !== void 0 && builder.indexOf(key2) === -1) {
                field1.optional = true;
            }
            if (field1.default === void 0) {
                field1.default = null;
            } else if (!field1.validate && field1.default != null) {
                field1.validate = assertValueType(getType(field1.default));
            }
            var _iteratorNormalCompletion4 = true, _didIteratorError4 = false, _iteratorError4 = undefined;
            try {
                for(var _iterator4 = Object.keys(field1)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true){
                    var k1 = _step4.value;
                    if (validFieldKeys.indexOf(k1) === -1) {
                        throw new Error('Unknown field key "'.concat(k1, '" on ').concat(type, ".").concat(key2));
                    }
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
                        _iterator4.return();
                    }
                } finally{
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                _iterator3.return();
            }
        } finally{
            if (_didIteratorError3) {
                throw _iteratorError3;
            }
        }
    }
    VISITOR_KEYS[type] = opts.visitor = visitor4;
    BUILDER_KEYS[type] = opts.builder = builder;
    NODE_FIELDS[type] = opts.fields = fields;
    ALIAS_KEYS[type] = opts.aliases = aliases;
    aliases.forEach(function(alias) {
        FLIPPED_ALIAS_KEYS[alias] = FLIPPED_ALIAS_KEYS[alias] || [];
        FLIPPED_ALIAS_KEYS[alias].push(type);
    });
    if (opts.validate) {
        NODE_PARENT_VALIDATIONS[type] = opts.validate;
    }
    store[type] = opts;
}
var defineType$4 = defineAliasedType("Standardized");
defineType$4("ArrayExpression", {
    fields: {
        elements: {
            validate: chain(assertValueType("array"), assertEach(assertNodeOrValueType("null", "Expression", "SpreadElement"))),
            default: !process.env.BABEL_TYPES_8_BREAKING ? [] : void 0
        }
    },
    visitor: [
        "elements"
    ],
    aliases: [
        "Expression"
    ]
});
defineType$4("AssignmentExpression", {
    fields: {
        operator: {
            validate: function() {
                if (!process.env.BABEL_TYPES_8_BREAKING) {
                    return assertValueType("string");
                }
                var identifier7 = assertOneOf.apply(void 0, _to_consumable_array(ASSIGNMENT_OPERATORS));
                var pattern = assertOneOf("=");
                return function(node, key, val) {
                    var validator = is("Pattern", node.left) ? pattern : identifier7;
                    validator(node, key, val);
                };
            }()
        },
        left: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal", "OptionalMemberExpression") : assertNodeType("Identifier", "MemberExpression", "OptionalMemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
        },
        right: {
            validate: assertNodeType("Expression")
        }
    },
    builder: [
        "operator",
        "left",
        "right"
    ],
    visitor: [
        "left",
        "right"
    ],
    aliases: [
        "Expression"
    ]
});
defineType$4("BinaryExpression", {
    builder: [
        "operator",
        "left",
        "right"
    ],
    fields: {
        operator: {
            validate: assertOneOf.apply(void 0, _to_consumable_array(BINARY_OPERATORS))
        },
        left: {
            validate: function() {
                var expression2 = assertNodeType("Expression");
                var inOp = assertNodeType("Expression", "PrivateName");
                var validator = Object.assign(function(node, key, val) {
                    var validator2 = node.operator === "in" ? inOp : expression2;
                    validator2(node, key, val);
                }, {
                    oneOfNodeTypes: [
                        "Expression",
                        "PrivateName"
                    ]
                });
                return validator;
            }()
        },
        right: {
            validate: assertNodeType("Expression")
        }
    },
    visitor: [
        "left",
        "right"
    ],
    aliases: [
        "Binary",
        "Expression"
    ]
});
defineType$4("InterpreterDirective", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    }
});
defineType$4("Directive", {
    visitor: [
        "value"
    ],
    fields: {
        value: {
            validate: assertNodeType("DirectiveLiteral")
        }
    }
});
defineType$4("DirectiveLiteral", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    }
});
defineType$4("BlockStatement", {
    builder: [
        "body",
        "directives"
    ],
    visitor: [
        "directives",
        "body"
    ],
    fields: {
        directives: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Directive"))),
            default: []
        },
        body: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
    },
    aliases: [
        "Scopable",
        "BlockParent",
        "Block",
        "Statement"
    ]
});
defineType$4("BreakStatement", {
    visitor: [
        "label"
    ],
    fields: {
        label: {
            validate: assertNodeType("Identifier"),
            optional: true
        }
    },
    aliases: [
        "Statement",
        "Terminatorless",
        "CompletionStatement"
    ]
});
defineType$4("CallExpression", {
    visitor: [
        "callee",
        "arguments",
        "typeParameters",
        "typeArguments"
    ],
    builder: [
        "callee",
        "arguments"
    ],
    aliases: [
        "Expression"
    ],
    fields: Object.assign({
        callee: {
            validate: assertNodeType("Expression", "Super", "V8IntrinsicIdentifier")
        },
        arguments: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
        }
    }, !process.env.BABEL_TYPES_8_BREAKING ? {
        optional: {
            validate: assertOneOf(true, false),
            optional: true
        }
    } : {}, {
        typeArguments: {
            validate: assertNodeType("TypeParameterInstantiation"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TSTypeParameterInstantiation"),
            optional: true
        }
    })
});
defineType$4("CatchClause", {
    visitor: [
        "param",
        "body"
    ],
    fields: {
        param: {
            validate: assertNodeType("Identifier", "ArrayPattern", "ObjectPattern"),
            optional: true
        },
        body: {
            validate: assertNodeType("BlockStatement")
        }
    },
    aliases: [
        "Scopable",
        "BlockParent"
    ]
});
defineType$4("ConditionalExpression", {
    visitor: [
        "test",
        "consequent",
        "alternate"
    ],
    fields: {
        test: {
            validate: assertNodeType("Expression")
        },
        consequent: {
            validate: assertNodeType("Expression")
        },
        alternate: {
            validate: assertNodeType("Expression")
        }
    },
    aliases: [
        "Expression",
        "Conditional"
    ]
});
defineType$4("ContinueStatement", {
    visitor: [
        "label"
    ],
    fields: {
        label: {
            validate: assertNodeType("Identifier"),
            optional: true
        }
    },
    aliases: [
        "Statement",
        "Terminatorless",
        "CompletionStatement"
    ]
});
defineType$4("DebuggerStatement", {
    aliases: [
        "Statement"
    ]
});
defineType$4("DoWhileStatement", {
    visitor: [
        "test",
        "body"
    ],
    fields: {
        test: {
            validate: assertNodeType("Expression")
        },
        body: {
            validate: assertNodeType("Statement")
        }
    },
    aliases: [
        "Statement",
        "BlockParent",
        "Loop",
        "While",
        "Scopable"
    ]
});
defineType$4("EmptyStatement", {
    aliases: [
        "Statement"
    ]
});
defineType$4("ExpressionStatement", {
    visitor: [
        "expression"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression")
        }
    },
    aliases: [
        "Statement",
        "ExpressionWrapper"
    ]
});
defineType$4("File", {
    builder: [
        "program",
        "comments",
        "tokens"
    ],
    visitor: [
        "program"
    ],
    fields: {
        program: {
            validate: assertNodeType("Program")
        },
        comments: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? Object.assign(function() {}, {
                each: {
                    oneOfNodeTypes: [
                        "CommentBlock",
                        "CommentLine"
                    ]
                }
            }) : assertEach(assertNodeType("CommentBlock", "CommentLine")),
            optional: true
        },
        tokens: {
            validate: assertEach(Object.assign(function() {}, {
                type: "any"
            })),
            optional: true
        }
    }
});
defineType$4("ForInStatement", {
    visitor: [
        "left",
        "right",
        "body"
    ],
    aliases: [
        "Scopable",
        "Statement",
        "For",
        "BlockParent",
        "Loop",
        "ForXStatement"
    ],
    fields: {
        left: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertNodeType("VariableDeclaration", "LVal") : assertNodeType("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
        },
        right: {
            validate: assertNodeType("Expression")
        },
        body: {
            validate: assertNodeType("Statement")
        }
    }
});
defineType$4("ForStatement", {
    visitor: [
        "init",
        "test",
        "update",
        "body"
    ],
    aliases: [
        "Scopable",
        "Statement",
        "For",
        "BlockParent",
        "Loop"
    ],
    fields: {
        init: {
            validate: assertNodeType("VariableDeclaration", "Expression"),
            optional: true
        },
        test: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        update: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        body: {
            validate: assertNodeType("Statement")
        }
    }
});
var functionCommon = function() {
    return {
        params: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement")))
        },
        generator: {
            default: false
        },
        async: {
            default: false
        }
    };
};
var functionTypeAnnotationCommon = function() {
    return {
        returnType: {
            validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration"),
            optional: true
        }
    };
};
var functionDeclarationCommon = function() {
    return Object.assign({}, functionCommon(), {
        declare: {
            validate: assertValueType("boolean"),
            optional: true
        },
        id: {
            validate: assertNodeType("Identifier"),
            optional: true
        }
    });
};
defineType$4("FunctionDeclaration", {
    builder: [
        "id",
        "params",
        "body",
        "generator",
        "async"
    ],
    visitor: [
        "id",
        "params",
        "body",
        "returnType",
        "typeParameters"
    ],
    fields: Object.assign({}, functionDeclarationCommon(), functionTypeAnnotationCommon(), {
        body: {
            validate: assertNodeType("BlockStatement")
        },
        predicate: {
            validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
            optional: true
        }
    }),
    aliases: [
        "Scopable",
        "Function",
        "BlockParent",
        "FunctionParent",
        "Statement",
        "Pureish",
        "Declaration"
    ],
    validate: function() {
        if (!process.env.BABEL_TYPES_8_BREAKING) return function() {};
        var identifier7 = assertNodeType("Identifier");
        return function(parent, key, node) {
            if (!is("ExportDefaultDeclaration", parent)) {
                identifier7(node, "id", node.id);
            }
        };
    }()
});
defineType$4("FunctionExpression", {
    inherits: "FunctionDeclaration",
    aliases: [
        "Scopable",
        "Function",
        "BlockParent",
        "FunctionParent",
        "Expression",
        "Pureish"
    ],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
        id: {
            validate: assertNodeType("Identifier"),
            optional: true
        },
        body: {
            validate: assertNodeType("BlockStatement")
        },
        predicate: {
            validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
            optional: true
        }
    })
});
var patternLikeCommon = function() {
    return {
        typeAnnotation: {
            validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation"),
            optional: true
        },
        optional: {
            validate: assertValueType("boolean"),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        }
    };
};
defineType$4("Identifier", {
    builder: [
        "name"
    ],
    visitor: [
        "typeAnnotation",
        "decorators"
    ],
    aliases: [
        "Expression",
        "PatternLike",
        "LVal",
        "TSEntityName"
    ],
    fields: Object.assign({}, patternLikeCommon(), {
        name: {
            validate: chain(assertValueType("string"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (!isValidIdentifier(val, false)) {
                    throw new TypeError('"'.concat(val, '" is not a valid identifier name'));
                }
            }, {
                type: "string"
            }))
        }
    }),
    validate: function validate(parent, key, node) {
        if (!process.env.BABEL_TYPES_8_BREAKING) return;
        var match = /\.(\w+)$/.exec(key);
        if (!match) return;
        var _match = _sliced_to_array(match, 2), parentKey = _match[1];
        var nonComp = {
            computed: false
        };
        if (parentKey === "property") {
            if (is("MemberExpression", parent, nonComp)) return;
            if (is("OptionalMemberExpression", parent, nonComp)) return;
        } else if (parentKey === "key") {
            if (is("Property", parent, nonComp)) return;
            if (is("Method", parent, nonComp)) return;
        } else if (parentKey === "exported") {
            if (is("ExportSpecifier", parent)) return;
        } else if (parentKey === "imported") {
            if (is("ImportSpecifier", parent, {
                imported: node
            })) return;
        } else if (parentKey === "meta") {
            if (is("MetaProperty", parent, {
                meta: node
            })) return;
        }
        if ((isKeyword(node.name) || isReservedWord(node.name, false)) && node.name !== "this") {
            throw new TypeError('"'.concat(node.name, '" is not a valid identifier'));
        }
    }
});
defineType$4("IfStatement", {
    visitor: [
        "test",
        "consequent",
        "alternate"
    ],
    aliases: [
        "Statement",
        "Conditional"
    ],
    fields: {
        test: {
            validate: assertNodeType("Expression")
        },
        consequent: {
            validate: assertNodeType("Statement")
        },
        alternate: {
            optional: true,
            validate: assertNodeType("Statement")
        }
    }
});
defineType$4("LabeledStatement", {
    visitor: [
        "label",
        "body"
    ],
    aliases: [
        "Statement"
    ],
    fields: {
        label: {
            validate: assertNodeType("Identifier")
        },
        body: {
            validate: assertNodeType("Statement")
        }
    }
});
defineType$4("StringLiteral", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    },
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$4("NumericLiteral", {
    builder: [
        "value"
    ],
    deprecatedAlias: "NumberLiteral",
    fields: {
        value: {
            validate: chain(assertValueType("number"), Object.assign(function(node, key, val) {
                if (1 / val < 0 || !Number.isFinite(val)) {
                    var error = new Error("NumericLiterals must be non-negative finite numbers. You can use t.valueToNode(".concat(val, ") instead."));
                    {
                        {
                            if (!new Error().stack.includes("regenerator")) {
                                throw error;
                            }
                        }
                    }
                }
            }, {
                type: "number"
            }))
        }
    },
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$4("NullLiteral", {
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$4("BooleanLiteral", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("boolean")
        }
    },
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$4("RegExpLiteral", {
    builder: [
        "pattern",
        "flags"
    ],
    deprecatedAlias: "RegexLiteral",
    aliases: [
        "Expression",
        "Pureish",
        "Literal"
    ],
    fields: {
        pattern: {
            validate: assertValueType("string")
        },
        flags: {
            validate: chain(assertValueType("string"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                var invalid = /[^gimsuy]/.exec(val);
                if (invalid) {
                    throw new TypeError('"'.concat(invalid[0], '" is not a valid RegExp flag'));
                }
            }, {
                type: "string"
            })),
            default: ""
        }
    }
});
defineType$4("LogicalExpression", {
    builder: [
        "operator",
        "left",
        "right"
    ],
    visitor: [
        "left",
        "right"
    ],
    aliases: [
        "Binary",
        "Expression"
    ],
    fields: {
        operator: {
            validate: assertOneOf.apply(void 0, _to_consumable_array(LOGICAL_OPERATORS))
        },
        left: {
            validate: assertNodeType("Expression")
        },
        right: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("MemberExpression", {
    builder: [
        "object",
        "property",
        "computed"
    ].concat(_to_consumable_array(!process.env.BABEL_TYPES_8_BREAKING ? [
        "optional"
    ] : [])),
    visitor: [
        "object",
        "property"
    ],
    aliases: [
        "Expression",
        "LVal"
    ],
    fields: Object.assign({
        object: {
            validate: assertNodeType("Expression", "Super")
        },
        property: {
            validate: function() {
                var normal = assertNodeType("Identifier", "PrivateName");
                var computed = assertNodeType("Expression");
                var validator = function validator(node, key, val) {
                    var validator2 = node.computed ? computed : normal;
                    validator2(node, key, val);
                };
                validator.oneOfNodeTypes = [
                    "Expression",
                    "Identifier",
                    "PrivateName"
                ];
                return validator;
            }()
        },
        computed: {
            default: false
        }
    }, !process.env.BABEL_TYPES_8_BREAKING ? {
        optional: {
            validate: assertOneOf(true, false),
            optional: true
        }
    } : {})
});
defineType$4("NewExpression", {
    inherits: "CallExpression"
});
defineType$4("Program", {
    visitor: [
        "directives",
        "body"
    ],
    builder: [
        "body",
        "directives",
        "sourceType",
        "interpreter"
    ],
    fields: {
        sourceType: {
            validate: assertOneOf("script", "module"),
            default: "script"
        },
        interpreter: {
            validate: assertNodeType("InterpreterDirective"),
            default: null,
            optional: true
        },
        directives: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Directive"))),
            default: []
        },
        body: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
    },
    aliases: [
        "Scopable",
        "BlockParent",
        "Block"
    ]
});
defineType$4("ObjectExpression", {
    visitor: [
        "properties"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        properties: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ObjectMethod", "ObjectProperty", "SpreadElement")))
        }
    }
});
defineType$4("ObjectMethod", {
    builder: [
        "kind",
        "key",
        "params",
        "body",
        "computed",
        "generator",
        "async"
    ],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
        kind: Object.assign({
            validate: assertOneOf("method", "get", "set")
        }, !process.env.BABEL_TYPES_8_BREAKING ? {
            default: "method"
        } : {}),
        computed: {
            default: false
        },
        key: {
            validate: function() {
                var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
                var computed = assertNodeType("Expression");
                var validator = function validator(node, key, val) {
                    var validator2 = node.computed ? computed : normal;
                    validator2(node, key, val);
                };
                validator.oneOfNodeTypes = [
                    "Expression",
                    "Identifier",
                    "StringLiteral",
                    "NumericLiteral",
                    "BigIntLiteral"
                ];
                return validator;
            }()
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        body: {
            validate: assertNodeType("BlockStatement")
        }
    }),
    visitor: [
        "key",
        "params",
        "body",
        "decorators",
        "returnType",
        "typeParameters"
    ],
    aliases: [
        "UserWhitespacable",
        "Function",
        "Scopable",
        "BlockParent",
        "FunctionParent",
        "Method",
        "ObjectMember"
    ]
});
defineType$4("ObjectProperty", {
    builder: [
        "key",
        "value",
        "computed",
        "shorthand"
    ].concat(_to_consumable_array(!process.env.BABEL_TYPES_8_BREAKING ? [
        "decorators"
    ] : [])),
    fields: {
        computed: {
            default: false
        },
        key: {
            validate: function() {
                var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName");
                var computed = assertNodeType("Expression");
                var validator = Object.assign(function(node, key, val) {
                    var validator2 = node.computed ? computed : normal;
                    validator2(node, key, val);
                }, {
                    oneOfNodeTypes: [
                        "Expression",
                        "Identifier",
                        "StringLiteral",
                        "NumericLiteral",
                        "BigIntLiteral",
                        "DecimalLiteral",
                        "PrivateName"
                    ]
                });
                return validator;
            }()
        },
        value: {
            validate: assertNodeType("Expression", "PatternLike")
        },
        shorthand: {
            validate: chain(assertValueType("boolean"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (val && node.computed) {
                    throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
                }
            }, {
                type: "boolean"
            }), function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (val && !is("Identifier", node.key)) {
                    throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
                }
            }),
            default: false
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        }
    },
    visitor: [
        "key",
        "value",
        "decorators"
    ],
    aliases: [
        "UserWhitespacable",
        "Property",
        "ObjectMember"
    ],
    validate: function() {
        var pattern = assertNodeType("Identifier", "Pattern", "TSAsExpression", "TSSatisfiesExpression", "TSNonNullExpression", "TSTypeAssertion");
        var expression2 = assertNodeType("Expression");
        return function(parent, key, node) {
            if (!process.env.BABEL_TYPES_8_BREAKING) return;
            var validator = is("ObjectPattern", parent) ? pattern : expression2;
            validator(node, "value", node.value);
        };
    }()
});
defineType$4("RestElement", {
    visitor: [
        "argument",
        "typeAnnotation"
    ],
    builder: [
        "argument"
    ],
    aliases: [
        "LVal",
        "PatternLike"
    ],
    deprecatedAlias: "RestProperty",
    fields: Object.assign({}, patternLikeCommon(), {
        argument: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
        }
    }),
    validate: function validate(parent, key) {
        if (!process.env.BABEL_TYPES_8_BREAKING) return;
        var match = /(\w+)\[(\d+)\]/.exec(key);
        if (!match) throw new Error("Internal Babel error: malformed key.");
        var _match = _sliced_to_array(match, 3), listKey = _match[1], index3 = _match[2];
        if (parent[listKey].length > +index3 + 1) {
            throw new TypeError("RestElement must be last element of ".concat(listKey));
        }
    }
});
defineType$4("ReturnStatement", {
    visitor: [
        "argument"
    ],
    aliases: [
        "Statement",
        "Terminatorless",
        "CompletionStatement"
    ],
    fields: {
        argument: {
            validate: assertNodeType("Expression"),
            optional: true
        }
    }
});
defineType$4("SequenceExpression", {
    visitor: [
        "expressions"
    ],
    fields: {
        expressions: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Expression")))
        }
    },
    aliases: [
        "Expression"
    ]
});
defineType$4("ParenthesizedExpression", {
    visitor: [
        "expression"
    ],
    aliases: [
        "Expression",
        "ExpressionWrapper"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("SwitchCase", {
    visitor: [
        "test",
        "consequent"
    ],
    fields: {
        test: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        consequent: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
    }
});
defineType$4("SwitchStatement", {
    visitor: [
        "discriminant",
        "cases"
    ],
    aliases: [
        "Statement",
        "BlockParent",
        "Scopable"
    ],
    fields: {
        discriminant: {
            validate: assertNodeType("Expression")
        },
        cases: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("SwitchCase")))
        }
    }
});
defineType$4("ThisExpression", {
    aliases: [
        "Expression"
    ]
});
defineType$4("ThrowStatement", {
    visitor: [
        "argument"
    ],
    aliases: [
        "Statement",
        "Terminatorless",
        "CompletionStatement"
    ],
    fields: {
        argument: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("TryStatement", {
    visitor: [
        "block",
        "handler",
        "finalizer"
    ],
    aliases: [
        "Statement"
    ],
    fields: {
        block: {
            validate: chain(assertNodeType("BlockStatement"), Object.assign(function(node) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (!node.handler && !node.finalizer) {
                    throw new TypeError("TryStatement expects either a handler or finalizer, or both");
                }
            }, {
                oneOfNodeTypes: [
                    "BlockStatement"
                ]
            }))
        },
        handler: {
            optional: true,
            validate: assertNodeType("CatchClause")
        },
        finalizer: {
            optional: true,
            validate: assertNodeType("BlockStatement")
        }
    }
});
defineType$4("UnaryExpression", {
    builder: [
        "operator",
        "argument",
        "prefix"
    ],
    fields: {
        prefix: {
            default: true
        },
        argument: {
            validate: assertNodeType("Expression")
        },
        operator: {
            validate: assertOneOf.apply(void 0, _to_consumable_array(UNARY_OPERATORS))
        }
    },
    visitor: [
        "argument"
    ],
    aliases: [
        "UnaryLike",
        "Expression"
    ]
});
defineType$4("UpdateExpression", {
    builder: [
        "operator",
        "argument",
        "prefix"
    ],
    fields: {
        prefix: {
            default: false
        },
        argument: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertNodeType("Expression") : assertNodeType("Identifier", "MemberExpression")
        },
        operator: {
            validate: assertOneOf.apply(void 0, _to_consumable_array(UPDATE_OPERATORS))
        }
    },
    visitor: [
        "argument"
    ],
    aliases: [
        "Expression"
    ]
});
defineType$4("VariableDeclaration", {
    builder: [
        "kind",
        "declarations"
    ],
    visitor: [
        "declarations"
    ],
    aliases: [
        "Statement",
        "Declaration"
    ],
    fields: {
        declare: {
            validate: assertValueType("boolean"),
            optional: true
        },
        kind: {
            validate: assertOneOf("var", "let", "const", "using", "await using")
        },
        declarations: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("VariableDeclarator")))
        }
    },
    validate: function validate(parent, key, node) {
        if (!process.env.BABEL_TYPES_8_BREAKING) return;
        if (!is("ForXStatement", parent, {
            left: node
        })) return;
        if (node.declarations.length !== 1) {
            throw new TypeError("Exactly one VariableDeclarator is required in the VariableDeclaration of a ".concat(parent.type));
        }
    }
});
defineType$4("VariableDeclarator", {
    visitor: [
        "id",
        "init"
    ],
    fields: {
        id: {
            validate: function() {
                if (!process.env.BABEL_TYPES_8_BREAKING) {
                    return assertNodeType("LVal");
                }
                var normal = assertNodeType("Identifier", "ArrayPattern", "ObjectPattern");
                var without = assertNodeType("Identifier");
                return function(node, key, val) {
                    var validator = node.init ? normal : without;
                    validator(node, key, val);
                };
            }()
        },
        definite: {
            optional: true,
            validate: assertValueType("boolean")
        },
        init: {
            optional: true,
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("WhileStatement", {
    visitor: [
        "test",
        "body"
    ],
    aliases: [
        "Statement",
        "BlockParent",
        "Loop",
        "While",
        "Scopable"
    ],
    fields: {
        test: {
            validate: assertNodeType("Expression")
        },
        body: {
            validate: assertNodeType("Statement")
        }
    }
});
defineType$4("WithStatement", {
    visitor: [
        "object",
        "body"
    ],
    aliases: [
        "Statement"
    ],
    fields: {
        object: {
            validate: assertNodeType("Expression")
        },
        body: {
            validate: assertNodeType("Statement")
        }
    }
});
defineType$4("AssignmentPattern", {
    visitor: [
        "left",
        "right",
        "decorators"
    ],
    builder: [
        "left",
        "right"
    ],
    aliases: [
        "Pattern",
        "PatternLike",
        "LVal"
    ],
    fields: Object.assign({}, patternLikeCommon(), {
        left: {
            validate: assertNodeType("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
        },
        right: {
            validate: assertNodeType("Expression")
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        }
    })
});
defineType$4("ArrayPattern", {
    visitor: [
        "elements",
        "typeAnnotation"
    ],
    builder: [
        "elements"
    ],
    aliases: [
        "Pattern",
        "PatternLike",
        "LVal"
    ],
    fields: Object.assign({}, patternLikeCommon(), {
        elements: {
            validate: chain(assertValueType("array"), assertEach(assertNodeOrValueType("null", "PatternLike", "LVal")))
        }
    })
});
defineType$4("ArrowFunctionExpression", {
    builder: [
        "params",
        "body",
        "async"
    ],
    visitor: [
        "params",
        "body",
        "returnType",
        "typeParameters"
    ],
    aliases: [
        "Scopable",
        "Function",
        "BlockParent",
        "FunctionParent",
        "Expression",
        "Pureish"
    ],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
        expression: {
            validate: assertValueType("boolean")
        },
        body: {
            validate: assertNodeType("BlockStatement", "Expression")
        },
        predicate: {
            validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
            optional: true
        }
    })
});
defineType$4("ClassBody", {
    visitor: [
        "body"
    ],
    fields: {
        body: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")))
        }
    }
});
defineType$4("ClassExpression", {
    builder: [
        "id",
        "superClass",
        "body",
        "decorators"
    ],
    visitor: [
        "id",
        "body",
        "superClass",
        "mixins",
        "typeParameters",
        "superTypeParameters",
        "implements",
        "decorators"
    ],
    aliases: [
        "Scopable",
        "Class",
        "Expression"
    ],
    fields: {
        id: {
            validate: assertNodeType("Identifier"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration"),
            optional: true
        },
        body: {
            validate: assertNodeType("ClassBody")
        },
        superClass: {
            optional: true,
            validate: assertNodeType("Expression")
        },
        superTypeParameters: {
            validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
            optional: true
        },
        implements: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        mixins: {
            validate: assertNodeType("InterfaceExtends"),
            optional: true
        }
    }
});
defineType$4("ClassDeclaration", {
    inherits: "ClassExpression",
    aliases: [
        "Scopable",
        "Class",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: {
            validate: assertNodeType("Identifier"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration"),
            optional: true
        },
        body: {
            validate: assertNodeType("ClassBody")
        },
        superClass: {
            optional: true,
            validate: assertNodeType("Expression")
        },
        superTypeParameters: {
            validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
            optional: true
        },
        implements: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        mixins: {
            validate: assertNodeType("InterfaceExtends"),
            optional: true
        },
        declare: {
            validate: assertValueType("boolean"),
            optional: true
        },
        abstract: {
            validate: assertValueType("boolean"),
            optional: true
        }
    },
    validate: function() {
        var identifier7 = assertNodeType("Identifier");
        return function(parent, key, node) {
            if (!process.env.BABEL_TYPES_8_BREAKING) return;
            if (!is("ExportDefaultDeclaration", parent)) {
                identifier7(node, "id", node.id);
            }
        };
    }()
});
defineType$4("ExportAllDeclaration", {
    builder: [
        "source"
    ],
    visitor: [
        "source",
        "attributes",
        "assertions"
    ],
    aliases: [
        "Statement",
        "Declaration",
        "ImportOrExportDeclaration",
        "ExportDeclaration"
    ],
    fields: {
        source: {
            validate: assertNodeType("StringLiteral")
        },
        exportKind: validateOptional(assertOneOf("type", "value")),
        attributes: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        assertions: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        }
    }
});
defineType$4("ExportDefaultDeclaration", {
    visitor: [
        "declaration"
    ],
    aliases: [
        "Statement",
        "Declaration",
        "ImportOrExportDeclaration",
        "ExportDeclaration"
    ],
    fields: {
        declaration: {
            validate: assertNodeType("TSDeclareFunction", "FunctionDeclaration", "ClassDeclaration", "Expression")
        },
        exportKind: validateOptional(assertOneOf("value"))
    }
});
defineType$4("ExportNamedDeclaration", {
    builder: [
        "declaration",
        "specifiers",
        "source"
    ],
    visitor: [
        "declaration",
        "specifiers",
        "source",
        "attributes",
        "assertions"
    ],
    aliases: [
        "Statement",
        "Declaration",
        "ImportOrExportDeclaration",
        "ExportDeclaration"
    ],
    fields: {
        declaration: {
            optional: true,
            validate: chain(assertNodeType("Declaration"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (val && node.specifiers.length) {
                    throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
                }
            }, {
                oneOfNodeTypes: [
                    "Declaration"
                ]
            }), function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (val && node.source) {
                    throw new TypeError("Cannot export a declaration from a source");
                }
            })
        },
        attributes: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        assertions: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        specifiers: {
            default: [],
            validate: chain(assertValueType("array"), assertEach(function() {
                var sourced = assertNodeType("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
                var sourceless = assertNodeType("ExportSpecifier");
                if (!process.env.BABEL_TYPES_8_BREAKING) return sourced;
                return function(node, key, val) {
                    var validator = node.source ? sourced : sourceless;
                    validator(node, key, val);
                };
            }()))
        },
        source: {
            validate: assertNodeType("StringLiteral"),
            optional: true
        },
        exportKind: validateOptional(assertOneOf("type", "value"))
    }
});
defineType$4("ExportSpecifier", {
    visitor: [
        "local",
        "exported"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        local: {
            validate: assertNodeType("Identifier")
        },
        exported: {
            validate: assertNodeType("Identifier", "StringLiteral")
        },
        exportKind: {
            validate: assertOneOf("type", "value"),
            optional: true
        }
    }
});
defineType$4("ForOfStatement", {
    visitor: [
        "left",
        "right",
        "body"
    ],
    builder: [
        "left",
        "right",
        "body",
        "await"
    ],
    aliases: [
        "Scopable",
        "Statement",
        "For",
        "BlockParent",
        "Loop",
        "ForXStatement"
    ],
    fields: {
        left: {
            validate: function() {
                if (!process.env.BABEL_TYPES_8_BREAKING) {
                    return assertNodeType("VariableDeclaration", "LVal");
                }
                var declaration = assertNodeType("VariableDeclaration");
                var lval = assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression");
                return function(node, key, val) {
                    if (is("VariableDeclaration", val)) {
                        declaration(node, key, val);
                    } else {
                        lval(node, key, val);
                    }
                };
            }()
        },
        right: {
            validate: assertNodeType("Expression")
        },
        body: {
            validate: assertNodeType("Statement")
        },
        await: {
            default: false
        }
    }
});
defineType$4("ImportDeclaration", {
    builder: [
        "specifiers",
        "source"
    ],
    visitor: [
        "specifiers",
        "source",
        "attributes",
        "assertions"
    ],
    aliases: [
        "Statement",
        "Declaration",
        "ImportOrExportDeclaration"
    ],
    fields: {
        attributes: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        assertions: {
            optional: true,
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
        },
        module: {
            optional: true,
            validate: assertValueType("boolean")
        },
        phase: {
            default: null,
            validate: assertOneOf("source", "defer")
        },
        specifiers: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier")))
        },
        source: {
            validate: assertNodeType("StringLiteral")
        },
        importKind: {
            validate: assertOneOf("type", "typeof", "value"),
            optional: true
        }
    }
});
defineType$4("ImportDefaultSpecifier", {
    visitor: [
        "local"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        local: {
            validate: assertNodeType("Identifier")
        }
    }
});
defineType$4("ImportNamespaceSpecifier", {
    visitor: [
        "local"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        local: {
            validate: assertNodeType("Identifier")
        }
    }
});
defineType$4("ImportSpecifier", {
    visitor: [
        "local",
        "imported"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        local: {
            validate: assertNodeType("Identifier")
        },
        imported: {
            validate: assertNodeType("Identifier", "StringLiteral")
        },
        importKind: {
            validate: assertOneOf("type", "typeof", "value"),
            optional: true
        }
    }
});
defineType$4("ImportExpression", {
    visitor: [
        "source",
        "options"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        phase: {
            default: null,
            validate: assertOneOf("source", "defer")
        },
        source: {
            validate: assertNodeType("Expression")
        },
        options: {
            validate: assertNodeType("Expression"),
            optional: true
        }
    }
});
defineType$4("MetaProperty", {
    visitor: [
        "meta",
        "property"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        meta: {
            validate: chain(assertNodeType("Identifier"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                var property;
                switch(val.name){
                    case "function":
                        property = "sent";
                        break;
                    case "new":
                        property = "target";
                        break;
                    case "import":
                        property = "meta";
                        break;
                }
                if (!is("Identifier", node.property, {
                    name: property
                })) {
                    throw new TypeError("Unrecognised MetaProperty");
                }
            }, {
                oneOfNodeTypes: [
                    "Identifier"
                ]
            }))
        },
        property: {
            validate: assertNodeType("Identifier")
        }
    }
});
var classMethodOrPropertyCommon = function() {
    return {
        abstract: {
            validate: assertValueType("boolean"),
            optional: true
        },
        accessibility: {
            validate: assertOneOf("public", "private", "protected"),
            optional: true
        },
        static: {
            default: false
        },
        override: {
            default: false
        },
        computed: {
            default: false
        },
        optional: {
            validate: assertValueType("boolean"),
            optional: true
        },
        key: {
            validate: chain(function() {
                var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
                var computed = assertNodeType("Expression");
                return function(node, key, val) {
                    var validator = node.computed ? computed : normal;
                    validator(node, key, val);
                };
            }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression"))
        }
    };
};
var classMethodOrDeclareMethodCommon = function() {
    return Object.assign({}, functionCommon(), classMethodOrPropertyCommon(), {
        params: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement", "TSParameterProperty")))
        },
        kind: {
            validate: assertOneOf("get", "set", "method", "constructor"),
            default: "method"
        },
        access: {
            validate: chain(assertValueType("string"), assertOneOf("public", "private", "protected")),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        }
    });
};
defineType$4("ClassMethod", {
    aliases: [
        "Function",
        "Scopable",
        "BlockParent",
        "FunctionParent",
        "Method"
    ],
    builder: [
        "kind",
        "key",
        "params",
        "body",
        "computed",
        "static",
        "generator",
        "async"
    ],
    visitor: [
        "key",
        "params",
        "body",
        "decorators",
        "returnType",
        "typeParameters"
    ],
    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
        body: {
            validate: assertNodeType("BlockStatement")
        }
    })
});
defineType$4("ObjectPattern", {
    visitor: [
        "properties",
        "typeAnnotation",
        "decorators"
    ],
    builder: [
        "properties"
    ],
    aliases: [
        "Pattern",
        "PatternLike",
        "LVal"
    ],
    fields: Object.assign({}, patternLikeCommon(), {
        properties: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("RestElement", "ObjectProperty")))
        }
    })
});
defineType$4("SpreadElement", {
    visitor: [
        "argument"
    ],
    aliases: [
        "UnaryLike"
    ],
    deprecatedAlias: "SpreadProperty",
    fields: {
        argument: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("Super", void 0);
defineType$4("TaggedTemplateExpression", {
    visitor: [
        "tag",
        "quasi",
        "typeParameters"
    ],
    builder: [
        "tag",
        "quasi"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        tag: {
            validate: assertNodeType("Expression")
        },
        quasi: {
            validate: assertNodeType("TemplateLiteral")
        },
        typeParameters: {
            validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
            optional: true
        }
    }
});
defineType$4("TemplateElement", {
    builder: [
        "value",
        "tail"
    ],
    fields: {
        value: {
            validate: chain(assertShape({
                raw: {
                    validate: assertValueType("string")
                },
                cooked: {
                    validate: assertValueType("string"),
                    optional: true
                }
            }), function templateElementCookedValidator(node) {
                var raw = node.value.raw;
                var unterminatedCalled = false;
                var error = function() {
                    throw new Error("Internal @babel/types error.");
                };
                var _readStringContents = readStringContents("template", raw, 0, 0, 0, {
                    unterminated: function unterminated() {
                        unterminatedCalled = true;
                    },
                    strictNumericEscape: error,
                    invalidEscapeSequence: error,
                    numericSeparatorInEscapeSequence: error,
                    unexpectedNumericSeparator: error,
                    invalidDigit: error,
                    invalidCodePoint: error
                }), str = _readStringContents.str, firstInvalidLoc = _readStringContents.firstInvalidLoc;
                if (!unterminatedCalled) throw new Error("Invalid raw");
                node.value.cooked = firstInvalidLoc ? null : str;
            })
        },
        tail: {
            default: false
        }
    }
});
defineType$4("TemplateLiteral", {
    visitor: [
        "quasis",
        "expressions"
    ],
    aliases: [
        "Expression",
        "Literal"
    ],
    fields: {
        quasis: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("TemplateElement")))
        },
        expressions: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Expression", "TSType")), function(node, key, val) {
                if (node.quasis.length !== val.length + 1) {
                    throw new TypeError("Number of ".concat(node.type, " quasis should be exactly one more than the number of expressions.\nExpected ").concat(val.length + 1, " quasis but got ").concat(node.quasis.length));
                }
            })
        }
    }
});
defineType$4("YieldExpression", {
    builder: [
        "argument",
        "delegate"
    ],
    visitor: [
        "argument"
    ],
    aliases: [
        "Expression",
        "Terminatorless"
    ],
    fields: {
        delegate: {
            validate: chain(assertValueType("boolean"), Object.assign(function(node, key, val) {
                if (!process.env.BABEL_TYPES_8_BREAKING) return;
                if (val && !node.argument) {
                    throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
                }
            }, {
                type: "boolean"
            })),
            default: false
        },
        argument: {
            optional: true,
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("AwaitExpression", {
    builder: [
        "argument"
    ],
    visitor: [
        "argument"
    ],
    aliases: [
        "Expression",
        "Terminatorless"
    ],
    fields: {
        argument: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$4("Import", {
    aliases: [
        "Expression"
    ]
});
defineType$4("BigIntLiteral", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    },
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$4("ExportNamespaceSpecifier", {
    visitor: [
        "exported"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        exported: {
            validate: assertNodeType("Identifier")
        }
    }
});
defineType$4("OptionalMemberExpression", {
    builder: [
        "object",
        "property",
        "computed",
        "optional"
    ],
    visitor: [
        "object",
        "property"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        object: {
            validate: assertNodeType("Expression")
        },
        property: {
            validate: function() {
                var normal = assertNodeType("Identifier");
                var computed = assertNodeType("Expression");
                var validator = Object.assign(function(node, key, val) {
                    var validator2 = node.computed ? computed : normal;
                    validator2(node, key, val);
                }, {
                    oneOfNodeTypes: [
                        "Expression",
                        "Identifier"
                    ]
                });
                return validator;
            }()
        },
        computed: {
            default: false
        },
        optional: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain(assertValueType("boolean"), assertOptionalChainStart())
        }
    }
});
defineType$4("OptionalCallExpression", {
    visitor: [
        "callee",
        "arguments",
        "typeParameters",
        "typeArguments"
    ],
    builder: [
        "callee",
        "arguments",
        "optional"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        callee: {
            validate: assertNodeType("Expression")
        },
        arguments: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "JSXNamespacedName", "ArgumentPlaceholder")))
        },
        optional: {
            validate: !process.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain(assertValueType("boolean"), assertOptionalChainStart())
        },
        typeArguments: {
            validate: assertNodeType("TypeParameterInstantiation"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TSTypeParameterInstantiation"),
            optional: true
        }
    }
});
defineType$4("ClassProperty", {
    visitor: [
        "key",
        "value",
        "typeAnnotation",
        "decorators"
    ],
    builder: [
        "key",
        "value",
        "typeAnnotation",
        "decorators",
        "computed",
        "static"
    ],
    aliases: [
        "Property"
    ],
    fields: Object.assign({}, classMethodOrPropertyCommon(), {
        value: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        definite: {
            validate: assertValueType("boolean"),
            optional: true
        },
        typeAnnotation: {
            validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation"),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        readonly: {
            validate: assertValueType("boolean"),
            optional: true
        },
        declare: {
            validate: assertValueType("boolean"),
            optional: true
        },
        variance: {
            validate: assertNodeType("Variance"),
            optional: true
        }
    })
});
defineType$4("ClassAccessorProperty", {
    visitor: [
        "key",
        "value",
        "typeAnnotation",
        "decorators"
    ],
    builder: [
        "key",
        "value",
        "typeAnnotation",
        "decorators",
        "computed",
        "static"
    ],
    aliases: [
        "Property",
        "Accessor"
    ],
    fields: Object.assign({}, classMethodOrPropertyCommon(), {
        key: {
            validate: chain(function() {
                var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "PrivateName");
                var computed = assertNodeType("Expression");
                return function(node, key, val) {
                    var validator = node.computed ? computed : normal;
                    validator(node, key, val);
                };
            }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression", "PrivateName"))
        },
        value: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        definite: {
            validate: assertValueType("boolean"),
            optional: true
        },
        typeAnnotation: {
            validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation"),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        readonly: {
            validate: assertValueType("boolean"),
            optional: true
        },
        declare: {
            validate: assertValueType("boolean"),
            optional: true
        },
        variance: {
            validate: assertNodeType("Variance"),
            optional: true
        }
    })
});
defineType$4("ClassPrivateProperty", {
    visitor: [
        "key",
        "value",
        "decorators",
        "typeAnnotation"
    ],
    builder: [
        "key",
        "value",
        "decorators",
        "static"
    ],
    aliases: [
        "Property",
        "Private"
    ],
    fields: {
        key: {
            validate: assertNodeType("PrivateName")
        },
        value: {
            validate: assertNodeType("Expression"),
            optional: true
        },
        typeAnnotation: {
            validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation"),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        },
        static: {
            validate: assertValueType("boolean"),
            default: false
        },
        readonly: {
            validate: assertValueType("boolean"),
            optional: true
        },
        definite: {
            validate: assertValueType("boolean"),
            optional: true
        },
        variance: {
            validate: assertNodeType("Variance"),
            optional: true
        }
    }
});
defineType$4("ClassPrivateMethod", {
    builder: [
        "kind",
        "key",
        "params",
        "body",
        "static"
    ],
    visitor: [
        "key",
        "params",
        "body",
        "decorators",
        "returnType",
        "typeParameters"
    ],
    aliases: [
        "Function",
        "Scopable",
        "BlockParent",
        "FunctionParent",
        "Method",
        "Private"
    ],
    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
        kind: {
            validate: assertOneOf("get", "set", "method"),
            default: "method"
        },
        key: {
            validate: assertNodeType("PrivateName")
        },
        body: {
            validate: assertNodeType("BlockStatement")
        }
    })
});
defineType$4("PrivateName", {
    visitor: [
        "id"
    ],
    aliases: [
        "Private"
    ],
    fields: {
        id: {
            validate: assertNodeType("Identifier")
        }
    }
});
defineType$4("StaticBlock", {
    visitor: [
        "body"
    ],
    fields: {
        body: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Statement")))
        }
    },
    aliases: [
        "Scopable",
        "BlockParent",
        "FunctionParent"
    ]
});
var defineType$3 = defineAliasedType("Flow");
var defineInterfaceishType = function(name) {
    var isDeclareClass2 = name === "DeclareClass";
    defineType$3(name, {
        builder: [
            "id",
            "typeParameters",
            "extends",
            "body"
        ],
        visitor: [
            "id",
            "typeParameters",
            "extends"
        ].concat(_to_consumable_array(isDeclareClass2 ? [
            "mixins",
            "implements"
        ] : []), [
            "body"
        ]),
        aliases: [
            "FlowDeclaration",
            "Statement",
            "Declaration"
        ],
        fields: Object.assign({
            id: validateType("Identifier"),
            typeParameters: validateOptionalType("TypeParameterDeclaration"),
            extends: validateOptional(arrayOfType("InterfaceExtends"))
        }, isDeclareClass2 ? {
            mixins: validateOptional(arrayOfType("InterfaceExtends")),
            implements: validateOptional(arrayOfType("ClassImplements"))
        } : {}, {
            body: validateType("ObjectTypeAnnotation")
        })
    });
};
defineType$3("AnyTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("ArrayTypeAnnotation", {
    visitor: [
        "elementType"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        elementType: validateType("FlowType")
    }
});
defineType$3("BooleanTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("BooleanLiteralTypeAnnotation", {
    builder: [
        "value"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        value: validate$1(assertValueType("boolean"))
    }
});
defineType$3("NullLiteralTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("ClassImplements", {
    visitor: [
        "id",
        "typeParameters"
    ],
    fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
    }
});
defineInterfaceishType("DeclareClass");
defineType$3("DeclareFunction", {
    visitor: [
        "id"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier"),
        predicate: validateOptionalType("DeclaredPredicate")
    }
});
defineInterfaceishType("DeclareInterface");
defineType$3("DeclareModule", {
    builder: [
        "id",
        "body",
        "kind"
    ],
    visitor: [
        "id",
        "body"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType([
            "Identifier",
            "StringLiteral"
        ]),
        body: validateType("BlockStatement"),
        kind: validateOptional(assertOneOf("CommonJS", "ES"))
    }
});
defineType$3("DeclareModuleExports", {
    visitor: [
        "typeAnnotation"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        typeAnnotation: validateType("TypeAnnotation")
    }
});
defineType$3("DeclareTypeAlias", {
    visitor: [
        "id",
        "typeParameters",
        "right"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        right: validateType("FlowType")
    }
});
defineType$3("DeclareOpaqueType", {
    visitor: [
        "id",
        "typeParameters",
        "supertype"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        supertype: validateOptionalType("FlowType"),
        impltype: validateOptionalType("FlowType")
    }
});
defineType$3("DeclareVariable", {
    visitor: [
        "id"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier")
    }
});
defineType$3("DeclareExportDeclaration", {
    visitor: [
        "declaration",
        "specifiers",
        "source"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        declaration: validateOptionalType("Flow"),
        specifiers: validateOptional(arrayOfType([
            "ExportSpecifier",
            "ExportNamespaceSpecifier"
        ])),
        source: validateOptionalType("StringLiteral"),
        default: validateOptional(assertValueType("boolean"))
    }
});
defineType$3("DeclareExportAllDeclaration", {
    visitor: [
        "source"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        source: validateType("StringLiteral"),
        exportKind: validateOptional(assertOneOf("type", "value"))
    }
});
defineType$3("DeclaredPredicate", {
    visitor: [
        "value"
    ],
    aliases: [
        "FlowPredicate"
    ],
    fields: {
        value: validateType("Flow")
    }
});
defineType$3("ExistsTypeAnnotation", {
    aliases: [
        "FlowType"
    ]
});
defineType$3("FunctionTypeAnnotation", {
    visitor: [
        "typeParameters",
        "params",
        "rest",
        "returnType"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        params: validate$1(arrayOfType("FunctionTypeParam")),
        rest: validateOptionalType("FunctionTypeParam"),
        this: validateOptionalType("FunctionTypeParam"),
        returnType: validateType("FlowType")
    }
});
defineType$3("FunctionTypeParam", {
    visitor: [
        "name",
        "typeAnnotation"
    ],
    fields: {
        name: validateOptionalType("Identifier"),
        typeAnnotation: validateType("FlowType"),
        optional: validateOptional(assertValueType("boolean"))
    }
});
defineType$3("GenericTypeAnnotation", {
    visitor: [
        "id",
        "typeParameters"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        id: validateType([
            "Identifier",
            "QualifiedTypeIdentifier"
        ]),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
    }
});
defineType$3("InferredPredicate", {
    aliases: [
        "FlowPredicate"
    ]
});
defineType$3("InterfaceExtends", {
    visitor: [
        "id",
        "typeParameters"
    ],
    fields: {
        id: validateType([
            "Identifier",
            "QualifiedTypeIdentifier"
        ]),
        typeParameters: validateOptionalType("TypeParameterInstantiation")
    }
});
defineInterfaceishType("InterfaceDeclaration");
defineType$3("InterfaceTypeAnnotation", {
    visitor: [
        "extends",
        "body"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        extends: validateOptional(arrayOfType("InterfaceExtends")),
        body: validateType("ObjectTypeAnnotation")
    }
});
defineType$3("IntersectionTypeAnnotation", {
    visitor: [
        "types"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        types: validate$1(arrayOfType("FlowType"))
    }
});
defineType$3("MixedTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("EmptyTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("NullableTypeAnnotation", {
    visitor: [
        "typeAnnotation"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        typeAnnotation: validateType("FlowType")
    }
});
defineType$3("NumberLiteralTypeAnnotation", {
    builder: [
        "value"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        value: validate$1(assertValueType("number"))
    }
});
defineType$3("NumberTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("ObjectTypeAnnotation", {
    visitor: [
        "properties",
        "indexers",
        "callProperties",
        "internalSlots"
    ],
    aliases: [
        "FlowType"
    ],
    builder: [
        "properties",
        "indexers",
        "callProperties",
        "internalSlots",
        "exact"
    ],
    fields: {
        properties: validate$1(arrayOfType([
            "ObjectTypeProperty",
            "ObjectTypeSpreadProperty"
        ])),
        indexers: {
            validate: arrayOfType("ObjectTypeIndexer"),
            optional: false,
            default: []
        },
        callProperties: {
            validate: arrayOfType("ObjectTypeCallProperty"),
            optional: false,
            default: []
        },
        internalSlots: {
            validate: arrayOfType("ObjectTypeInternalSlot"),
            optional: false,
            default: []
        },
        exact: {
            validate: assertValueType("boolean"),
            default: false
        },
        inexact: validateOptional(assertValueType("boolean"))
    }
});
defineType$3("ObjectTypeInternalSlot", {
    visitor: [
        "id",
        "value",
        "optional",
        "static",
        "method"
    ],
    aliases: [
        "UserWhitespacable"
    ],
    fields: {
        id: validateType("Identifier"),
        value: validateType("FlowType"),
        optional: validate$1(assertValueType("boolean")),
        static: validate$1(assertValueType("boolean")),
        method: validate$1(assertValueType("boolean"))
    }
});
defineType$3("ObjectTypeCallProperty", {
    visitor: [
        "value"
    ],
    aliases: [
        "UserWhitespacable"
    ],
    fields: {
        value: validateType("FlowType"),
        static: validate$1(assertValueType("boolean"))
    }
});
defineType$3("ObjectTypeIndexer", {
    visitor: [
        "id",
        "key",
        "value",
        "variance"
    ],
    aliases: [
        "UserWhitespacable"
    ],
    fields: {
        id: validateOptionalType("Identifier"),
        key: validateType("FlowType"),
        value: validateType("FlowType"),
        static: validate$1(assertValueType("boolean")),
        variance: validateOptionalType("Variance")
    }
});
defineType$3("ObjectTypeProperty", {
    visitor: [
        "key",
        "value",
        "variance"
    ],
    aliases: [
        "UserWhitespacable"
    ],
    fields: {
        key: validateType([
            "Identifier",
            "StringLiteral"
        ]),
        value: validateType("FlowType"),
        kind: validate$1(assertOneOf("init", "get", "set")),
        static: validate$1(assertValueType("boolean")),
        proto: validate$1(assertValueType("boolean")),
        optional: validate$1(assertValueType("boolean")),
        variance: validateOptionalType("Variance"),
        method: validate$1(assertValueType("boolean"))
    }
});
defineType$3("ObjectTypeSpreadProperty", {
    visitor: [
        "argument"
    ],
    aliases: [
        "UserWhitespacable"
    ],
    fields: {
        argument: validateType("FlowType")
    }
});
defineType$3("OpaqueType", {
    visitor: [
        "id",
        "typeParameters",
        "supertype",
        "impltype"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        supertype: validateOptionalType("FlowType"),
        impltype: validateType("FlowType")
    }
});
defineType$3("QualifiedTypeIdentifier", {
    visitor: [
        "id",
        "qualification"
    ],
    fields: {
        id: validateType("Identifier"),
        qualification: validateType([
            "Identifier",
            "QualifiedTypeIdentifier"
        ])
    }
});
defineType$3("StringLiteralTypeAnnotation", {
    builder: [
        "value"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        value: validate$1(assertValueType("string"))
    }
});
defineType$3("StringTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("SymbolTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("ThisTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("TupleTypeAnnotation", {
    visitor: [
        "types"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        types: validate$1(arrayOfType("FlowType"))
    }
});
defineType$3("TypeofTypeAnnotation", {
    visitor: [
        "argument"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        argument: validateType("FlowType")
    }
});
defineType$3("TypeAlias", {
    visitor: [
        "id",
        "typeParameters",
        "right"
    ],
    aliases: [
        "FlowDeclaration",
        "Statement",
        "Declaration"
    ],
    fields: {
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TypeParameterDeclaration"),
        right: validateType("FlowType")
    }
});
defineType$3("TypeAnnotation", {
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        typeAnnotation: validateType("FlowType")
    }
});
defineType$3("TypeCastExpression", {
    visitor: [
        "expression",
        "typeAnnotation"
    ],
    aliases: [
        "ExpressionWrapper",
        "Expression"
    ],
    fields: {
        expression: validateType("Expression"),
        typeAnnotation: validateType("TypeAnnotation")
    }
});
defineType$3("TypeParameter", {
    visitor: [
        "bound",
        "default",
        "variance"
    ],
    fields: {
        name: validate$1(assertValueType("string")),
        bound: validateOptionalType("TypeAnnotation"),
        default: validateOptionalType("FlowType"),
        variance: validateOptionalType("Variance")
    }
});
defineType$3("TypeParameterDeclaration", {
    visitor: [
        "params"
    ],
    fields: {
        params: validate$1(arrayOfType("TypeParameter"))
    }
});
defineType$3("TypeParameterInstantiation", {
    visitor: [
        "params"
    ],
    fields: {
        params: validate$1(arrayOfType("FlowType"))
    }
});
defineType$3("UnionTypeAnnotation", {
    visitor: [
        "types"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        types: validate$1(arrayOfType("FlowType"))
    }
});
defineType$3("Variance", {
    builder: [
        "kind"
    ],
    fields: {
        kind: validate$1(assertOneOf("minus", "plus"))
    }
});
defineType$3("VoidTypeAnnotation", {
    aliases: [
        "FlowType",
        "FlowBaseAnnotation"
    ]
});
defineType$3("EnumDeclaration", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "body"
    ],
    fields: {
        id: validateType("Identifier"),
        body: validateType([
            "EnumBooleanBody",
            "EnumNumberBody",
            "EnumStringBody",
            "EnumSymbolBody"
        ])
    }
});
defineType$3("EnumBooleanBody", {
    aliases: [
        "EnumBody"
    ],
    visitor: [
        "members"
    ],
    fields: {
        explicitType: validate$1(assertValueType("boolean")),
        members: validateArrayOfType("EnumBooleanMember"),
        hasUnknownMembers: validate$1(assertValueType("boolean"))
    }
});
defineType$3("EnumNumberBody", {
    aliases: [
        "EnumBody"
    ],
    visitor: [
        "members"
    ],
    fields: {
        explicitType: validate$1(assertValueType("boolean")),
        members: validateArrayOfType("EnumNumberMember"),
        hasUnknownMembers: validate$1(assertValueType("boolean"))
    }
});
defineType$3("EnumStringBody", {
    aliases: [
        "EnumBody"
    ],
    visitor: [
        "members"
    ],
    fields: {
        explicitType: validate$1(assertValueType("boolean")),
        members: validateArrayOfType([
            "EnumStringMember",
            "EnumDefaultedMember"
        ]),
        hasUnknownMembers: validate$1(assertValueType("boolean"))
    }
});
defineType$3("EnumSymbolBody", {
    aliases: [
        "EnumBody"
    ],
    visitor: [
        "members"
    ],
    fields: {
        members: validateArrayOfType("EnumDefaultedMember"),
        hasUnknownMembers: validate$1(assertValueType("boolean"))
    }
});
defineType$3("EnumBooleanMember", {
    aliases: [
        "EnumMember"
    ],
    visitor: [
        "id"
    ],
    fields: {
        id: validateType("Identifier"),
        init: validateType("BooleanLiteral")
    }
});
defineType$3("EnumNumberMember", {
    aliases: [
        "EnumMember"
    ],
    visitor: [
        "id",
        "init"
    ],
    fields: {
        id: validateType("Identifier"),
        init: validateType("NumericLiteral")
    }
});
defineType$3("EnumStringMember", {
    aliases: [
        "EnumMember"
    ],
    visitor: [
        "id",
        "init"
    ],
    fields: {
        id: validateType("Identifier"),
        init: validateType("StringLiteral")
    }
});
defineType$3("EnumDefaultedMember", {
    aliases: [
        "EnumMember"
    ],
    visitor: [
        "id"
    ],
    fields: {
        id: validateType("Identifier")
    }
});
defineType$3("IndexedAccessType", {
    visitor: [
        "objectType",
        "indexType"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        objectType: validateType("FlowType"),
        indexType: validateType("FlowType")
    }
});
defineType$3("OptionalIndexedAccessType", {
    visitor: [
        "objectType",
        "indexType"
    ],
    aliases: [
        "FlowType"
    ],
    fields: {
        objectType: validateType("FlowType"),
        indexType: validateType("FlowType"),
        optional: validate$1(assertValueType("boolean"))
    }
});
var defineType$2 = defineAliasedType("JSX");
defineType$2("JSXAttribute", {
    visitor: [
        "name",
        "value"
    ],
    aliases: [
        "Immutable"
    ],
    fields: {
        name: {
            validate: assertNodeType("JSXIdentifier", "JSXNamespacedName")
        },
        value: {
            optional: true,
            validate: assertNodeType("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
        }
    }
});
defineType$2("JSXClosingElement", {
    visitor: [
        "name"
    ],
    aliases: [
        "Immutable"
    ],
    fields: {
        name: {
            validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
        }
    }
});
defineType$2("JSXElement", {
    builder: [
        "openingElement",
        "closingElement",
        "children"
    ],
    visitor: [
        "openingElement",
        "children",
        "closingElement"
    ],
    aliases: [
        "Immutable",
        "Expression"
    ],
    fields: Object.assign({
        openingElement: {
            validate: assertNodeType("JSXOpeningElement")
        },
        closingElement: {
            optional: true,
            validate: assertNodeType("JSXClosingElement")
        },
        children: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
        }
    }, {})
});
defineType$2("JSXEmptyExpression", {});
defineType$2("JSXExpressionContainer", {
    visitor: [
        "expression"
    ],
    aliases: [
        "Immutable"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression", "JSXEmptyExpression")
        }
    }
});
defineType$2("JSXSpreadChild", {
    visitor: [
        "expression"
    ],
    aliases: [
        "Immutable"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$2("JSXIdentifier", {
    builder: [
        "name"
    ],
    fields: {
        name: {
            validate: assertValueType("string")
        }
    }
});
defineType$2("JSXMemberExpression", {
    visitor: [
        "object",
        "property"
    ],
    fields: {
        object: {
            validate: assertNodeType("JSXMemberExpression", "JSXIdentifier")
        },
        property: {
            validate: assertNodeType("JSXIdentifier")
        }
    }
});
defineType$2("JSXNamespacedName", {
    visitor: [
        "namespace",
        "name"
    ],
    fields: {
        namespace: {
            validate: assertNodeType("JSXIdentifier")
        },
        name: {
            validate: assertNodeType("JSXIdentifier")
        }
    }
});
defineType$2("JSXOpeningElement", {
    builder: [
        "name",
        "attributes",
        "selfClosing"
    ],
    visitor: [
        "name",
        "attributes"
    ],
    aliases: [
        "Immutable"
    ],
    fields: {
        name: {
            validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
        },
        selfClosing: {
            default: false
        },
        attributes: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("JSXAttribute", "JSXSpreadAttribute")))
        },
        typeParameters: {
            validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
            optional: true
        }
    }
});
defineType$2("JSXSpreadAttribute", {
    visitor: [
        "argument"
    ],
    fields: {
        argument: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$2("JSXText", {
    aliases: [
        "Immutable"
    ],
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    }
});
defineType$2("JSXFragment", {
    builder: [
        "openingFragment",
        "closingFragment",
        "children"
    ],
    visitor: [
        "openingFragment",
        "children",
        "closingFragment"
    ],
    aliases: [
        "Immutable",
        "Expression"
    ],
    fields: {
        openingFragment: {
            validate: assertNodeType("JSXOpeningFragment")
        },
        closingFragment: {
            validate: assertNodeType("JSXClosingFragment")
        },
        children: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
        }
    }
});
defineType$2("JSXOpeningFragment", {
    aliases: [
        "Immutable"
    ]
});
defineType$2("JSXClosingFragment", {
    aliases: [
        "Immutable"
    ]
});
var PLACEHOLDERS = [
    "Identifier",
    "StringLiteral",
    "Expression",
    "Statement",
    "Declaration",
    "BlockStatement",
    "ClassBody",
    "Pattern"
];
var PLACEHOLDERS_ALIAS = {
    Declaration: [
        "Statement"
    ],
    Pattern: [
        "PatternLike",
        "LVal"
    ]
};
var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
try {
    for(var _iterator = PLACEHOLDERS[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
        var type = _step.value;
        var alias = ALIAS_KEYS[type];
        if (alias === null || alias === void 0 ? void 0 : alias.length) PLACEHOLDERS_ALIAS[type] = alias;
    }
} catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
} finally{
    try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
        }
    } finally{
        if (_didIteratorError) {
            throw _iteratorError;
        }
    }
}
var PLACEHOLDERS_FLIPPED_ALIAS = {};
Object.keys(PLACEHOLDERS_ALIAS).forEach(function(type) {
    PLACEHOLDERS_ALIAS[type].forEach(function(alias) {
        if (!Object.hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias)) {
            PLACEHOLDERS_FLIPPED_ALIAS[alias] = [];
        }
        PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);
    });
});
var defineType$1 = defineAliasedType("Miscellaneous");
defineType$1("Placeholder", {
    visitor: [],
    builder: [
        "expectedNode",
        "name"
    ],
    fields: {
        name: {
            validate: assertNodeType("Identifier")
        },
        expectedNode: {
            validate: assertOneOf.apply(void 0, _to_consumable_array(PLACEHOLDERS))
        }
    }
});
defineType$1("V8IntrinsicIdentifier", {
    builder: [
        "name"
    ],
    fields: {
        name: {
            validate: assertValueType("string")
        }
    }
});
defineType$5("ArgumentPlaceholder", {});
defineType$5("BindExpression", {
    visitor: [
        "object",
        "callee"
    ],
    aliases: [
        "Expression"
    ],
    fields: !process.env.BABEL_TYPES_8_BREAKING ? {
        object: {
            validate: Object.assign(function() {}, {
                oneOfNodeTypes: [
                    "Expression"
                ]
            })
        },
        callee: {
            validate: Object.assign(function() {}, {
                oneOfNodeTypes: [
                    "Expression"
                ]
            })
        }
    } : {
        object: {
            validate: assertNodeType("Expression")
        },
        callee: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$5("ImportAttribute", {
    visitor: [
        "key",
        "value"
    ],
    fields: {
        key: {
            validate: assertNodeType("Identifier", "StringLiteral")
        },
        value: {
            validate: assertNodeType("StringLiteral")
        }
    }
});
defineType$5("Decorator", {
    visitor: [
        "expression"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression")
        }
    }
});
defineType$5("DoExpression", {
    visitor: [
        "body"
    ],
    builder: [
        "body",
        "async"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        body: {
            validate: assertNodeType("BlockStatement")
        },
        async: {
            validate: assertValueType("boolean"),
            default: false
        }
    }
});
defineType$5("ExportDefaultSpecifier", {
    visitor: [
        "exported"
    ],
    aliases: [
        "ModuleSpecifier"
    ],
    fields: {
        exported: {
            validate: assertNodeType("Identifier")
        }
    }
});
defineType$5("RecordExpression", {
    visitor: [
        "properties"
    ],
    aliases: [
        "Expression"
    ],
    fields: {
        properties: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("ObjectProperty", "SpreadElement")))
        }
    }
});
defineType$5("TupleExpression", {
    fields: {
        elements: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement"))),
            default: []
        }
    },
    visitor: [
        "elements"
    ],
    aliases: [
        "Expression"
    ]
});
defineType$5("DecimalLiteral", {
    builder: [
        "value"
    ],
    fields: {
        value: {
            validate: assertValueType("string")
        }
    },
    aliases: [
        "Expression",
        "Pureish",
        "Literal",
        "Immutable"
    ]
});
defineType$5("ModuleExpression", {
    visitor: [
        "body"
    ],
    fields: {
        body: {
            validate: assertNodeType("Program")
        }
    },
    aliases: [
        "Expression"
    ]
});
defineType$5("TopicReference", {
    aliases: [
        "Expression"
    ]
});
defineType$5("PipelineTopicExpression", {
    builder: [
        "expression"
    ],
    visitor: [
        "expression"
    ],
    fields: {
        expression: {
            validate: assertNodeType("Expression")
        }
    },
    aliases: [
        "Expression"
    ]
});
defineType$5("PipelineBareFunction", {
    builder: [
        "callee"
    ],
    visitor: [
        "callee"
    ],
    fields: {
        callee: {
            validate: assertNodeType("Expression")
        }
    },
    aliases: [
        "Expression"
    ]
});
defineType$5("PipelinePrimaryTopicReference", {
    aliases: [
        "Expression"
    ]
});
var defineType = defineAliasedType("TypeScript");
var bool = assertValueType("boolean");
var tSFunctionTypeAnnotationCommon = function() {
    return {
        returnType: {
            validate: assertNodeType("TSTypeAnnotation"),
            optional: true
        },
        typeParameters: {
            validate: assertNodeType("TSTypeParameterDeclaration"),
            optional: true
        }
    };
};
defineType("TSParameterProperty", {
    aliases: [
        "LVal"
    ],
    visitor: [
        "parameter"
    ],
    fields: {
        accessibility: {
            validate: assertOneOf("public", "private", "protected"),
            optional: true
        },
        readonly: {
            validate: assertValueType("boolean"),
            optional: true
        },
        parameter: {
            validate: assertNodeType("Identifier", "AssignmentPattern")
        },
        override: {
            validate: assertValueType("boolean"),
            optional: true
        },
        decorators: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
            optional: true
        }
    }
});
defineType("TSDeclareFunction", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "typeParameters",
        "params",
        "returnType"
    ],
    fields: Object.assign({}, functionDeclarationCommon(), tSFunctionTypeAnnotationCommon())
});
defineType("TSDeclareMethod", {
    visitor: [
        "decorators",
        "key",
        "typeParameters",
        "params",
        "returnType"
    ],
    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), tSFunctionTypeAnnotationCommon())
});
defineType("TSQualifiedName", {
    aliases: [
        "TSEntityName"
    ],
    visitor: [
        "left",
        "right"
    ],
    fields: {
        left: validateType("TSEntityName"),
        right: validateType("Identifier")
    }
});
var signatureDeclarationCommon = function() {
    var _obj;
    return _obj = {
        typeParameters: validateOptionalType("TSTypeParameterDeclaration")
    }, _define_property(_obj, "params", validateArrayOfType([
        "ArrayPattern",
        "Identifier",
        "ObjectPattern",
        "RestElement"
    ])), _define_property(_obj, "returnType", validateOptionalType("TSTypeAnnotation")), _obj;
};
var callConstructSignatureDeclaration = {
    aliases: [
        "TSTypeElement"
    ],
    visitor: [
        "typeParameters",
        "params",
        "returnType"
    ],
    fields: signatureDeclarationCommon()
};
defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
var namedTypeElementCommon = function() {
    return {
        key: validateType("Expression"),
        computed: {
            default: false
        },
        optional: validateOptional(bool)
    };
};
defineType("TSPropertySignature", {
    aliases: [
        "TSTypeElement"
    ],
    visitor: [
        "key",
        "typeAnnotation"
    ],
    fields: Object.assign({}, namedTypeElementCommon(), {
        readonly: validateOptional(bool),
        typeAnnotation: validateOptionalType("TSTypeAnnotation"),
        kind: {
            validate: assertOneOf("get", "set")
        }
    })
});
defineType("TSMethodSignature", {
    aliases: [
        "TSTypeElement"
    ],
    visitor: [
        "key",
        "typeParameters",
        "params",
        "returnType"
    ],
    fields: Object.assign({}, signatureDeclarationCommon(), namedTypeElementCommon(), {
        kind: {
            validate: assertOneOf("method", "get", "set")
        }
    })
});
defineType("TSIndexSignature", {
    aliases: [
        "TSTypeElement"
    ],
    visitor: [
        "parameters",
        "typeAnnotation"
    ],
    fields: {
        readonly: validateOptional(bool),
        static: validateOptional(bool),
        parameters: validateArrayOfType("Identifier"),
        typeAnnotation: validateOptionalType("TSTypeAnnotation")
    }
});
var tsKeywordTypes = [
    "TSAnyKeyword",
    "TSBooleanKeyword",
    "TSBigIntKeyword",
    "TSIntrinsicKeyword",
    "TSNeverKeyword",
    "TSNullKeyword",
    "TSNumberKeyword",
    "TSObjectKeyword",
    "TSStringKeyword",
    "TSSymbolKeyword",
    "TSUndefinedKeyword",
    "TSUnknownKeyword",
    "TSVoidKeyword"
];
var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
try {
    for(var _iterator1 = tsKeywordTypes[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
        var type1 = _step1.value;
        defineType(type1, {
            aliases: [
                "TSType",
                "TSBaseType"
            ],
            visitor: [],
            fields: {}
        });
    }
} catch (err) {
    _didIteratorError1 = true;
    _iteratorError1 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
            _iterator1.return();
        }
    } finally{
        if (_didIteratorError1) {
            throw _iteratorError1;
        }
    }
}
defineType("TSThisType", {
    aliases: [
        "TSType",
        "TSBaseType"
    ],
    visitor: [],
    fields: {}
});
var fnOrCtrBase = {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeParameters",
        "params",
        "returnType"
    ]
};
defineType("TSFunctionType", Object.assign({}, fnOrCtrBase, {
    fields: signatureDeclarationCommon()
}));
defineType("TSConstructorType", Object.assign({}, fnOrCtrBase, {
    fields: Object.assign({}, signatureDeclarationCommon(), {
        abstract: validateOptional(bool)
    })
}));
defineType("TSTypeReference", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeName",
        "typeParameters"
    ],
    fields: {
        typeName: validateType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
    }
});
defineType("TSTypePredicate", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "parameterName",
        "typeAnnotation"
    ],
    builder: [
        "parameterName",
        "typeAnnotation",
        "asserts"
    ],
    fields: {
        parameterName: validateType([
            "Identifier",
            "TSThisType"
        ]),
        typeAnnotation: validateOptionalType("TSTypeAnnotation"),
        asserts: validateOptional(bool)
    }
});
defineType("TSTypeQuery", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "exprName",
        "typeParameters"
    ],
    fields: {
        exprName: validateType([
            "TSEntityName",
            "TSImportType"
        ]),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
    }
});
defineType("TSTypeLiteral", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "members"
    ],
    fields: {
        members: validateArrayOfType("TSTypeElement")
    }
});
defineType("TSArrayType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "elementType"
    ],
    fields: {
        elementType: validateType("TSType")
    }
});
defineType("TSTupleType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "elementTypes"
    ],
    fields: {
        elementTypes: validateArrayOfType([
            "TSType",
            "TSNamedTupleMember"
        ])
    }
});
defineType("TSOptionalType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        typeAnnotation: validateType("TSType")
    }
});
defineType("TSRestType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        typeAnnotation: validateType("TSType")
    }
});
defineType("TSNamedTupleMember", {
    visitor: [
        "label",
        "elementType"
    ],
    builder: [
        "label",
        "elementType",
        "optional"
    ],
    fields: {
        label: validateType("Identifier"),
        optional: {
            validate: bool,
            default: false
        },
        elementType: validateType("TSType")
    }
});
var unionOrIntersection = {
    aliases: [
        "TSType"
    ],
    visitor: [
        "types"
    ],
    fields: {
        types: validateArrayOfType("TSType")
    }
};
defineType("TSUnionType", unionOrIntersection);
defineType("TSIntersectionType", unionOrIntersection);
defineType("TSConditionalType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "checkType",
        "extendsType",
        "trueType",
        "falseType"
    ],
    fields: {
        checkType: validateType("TSType"),
        extendsType: validateType("TSType"),
        trueType: validateType("TSType"),
        falseType: validateType("TSType")
    }
});
defineType("TSInferType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeParameter"
    ],
    fields: {
        typeParameter: validateType("TSTypeParameter")
    }
});
defineType("TSParenthesizedType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        typeAnnotation: validateType("TSType")
    }
});
defineType("TSTypeOperator", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        operator: validate$1(assertValueType("string")),
        typeAnnotation: validateType("TSType")
    }
});
defineType("TSIndexedAccessType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "objectType",
        "indexType"
    ],
    fields: {
        objectType: validateType("TSType"),
        indexType: validateType("TSType")
    }
});
defineType("TSMappedType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "typeParameter",
        "typeAnnotation",
        "nameType"
    ],
    fields: {
        readonly: validateOptional(assertOneOf(true, false, "+", "-")),
        typeParameter: validateType("TSTypeParameter"),
        optional: validateOptional(assertOneOf(true, false, "+", "-")),
        typeAnnotation: validateOptionalType("TSType"),
        nameType: validateOptionalType("TSType")
    }
});
defineType("TSLiteralType", {
    aliases: [
        "TSType",
        "TSBaseType"
    ],
    visitor: [
        "literal"
    ],
    fields: {
        literal: {
            validate: function() {
                var unaryExpression3 = assertNodeType("NumericLiteral", "BigIntLiteral");
                var unaryOperator = assertOneOf("-");
                var literal = assertNodeType("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral");
                function validator(parent, key, node) {
                    if (is("UnaryExpression", node)) {
                        unaryOperator(node, "operator", node.operator);
                        unaryExpression3(node, "argument", node.argument);
                    } else {
                        literal(parent, key, node);
                    }
                }
                validator.oneOfNodeTypes = [
                    "NumericLiteral",
                    "StringLiteral",
                    "BooleanLiteral",
                    "BigIntLiteral",
                    "TemplateLiteral",
                    "UnaryExpression"
                ];
                return validator;
            }()
        }
    }
});
defineType("TSExpressionWithTypeArguments", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "expression",
        "typeParameters"
    ],
    fields: {
        expression: validateType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
    }
});
defineType("TSInterfaceDeclaration", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "typeParameters",
        "extends",
        "body"
    ],
    fields: {
        declare: validateOptional(bool),
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
        extends: validateOptional(arrayOfType("TSExpressionWithTypeArguments")),
        body: validateType("TSInterfaceBody")
    }
});
defineType("TSInterfaceBody", {
    visitor: [
        "body"
    ],
    fields: {
        body: validateArrayOfType("TSTypeElement")
    }
});
defineType("TSTypeAliasDeclaration", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "typeParameters",
        "typeAnnotation"
    ],
    fields: {
        declare: validateOptional(bool),
        id: validateType("Identifier"),
        typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
        typeAnnotation: validateType("TSType")
    }
});
defineType("TSInstantiationExpression", {
    aliases: [
        "Expression"
    ],
    visitor: [
        "expression",
        "typeParameters"
    ],
    fields: {
        expression: validateType("Expression"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
    }
});
var TSTypeExpression = {
    aliases: [
        "Expression",
        "LVal",
        "PatternLike"
    ],
    visitor: [
        "expression",
        "typeAnnotation"
    ],
    fields: {
        expression: validateType("Expression"),
        typeAnnotation: validateType("TSType")
    }
};
defineType("TSAsExpression", TSTypeExpression);
defineType("TSSatisfiesExpression", TSTypeExpression);
defineType("TSTypeAssertion", {
    aliases: [
        "Expression",
        "LVal",
        "PatternLike"
    ],
    visitor: [
        "typeAnnotation",
        "expression"
    ],
    fields: {
        typeAnnotation: validateType("TSType"),
        expression: validateType("Expression")
    }
});
defineType("TSEnumDeclaration", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "members"
    ],
    fields: {
        declare: validateOptional(bool),
        const: validateOptional(bool),
        id: validateType("Identifier"),
        members: validateArrayOfType("TSEnumMember"),
        initializer: validateOptionalType("Expression")
    }
});
defineType("TSEnumMember", {
    visitor: [
        "id",
        "initializer"
    ],
    fields: {
        id: validateType([
            "Identifier",
            "StringLiteral"
        ]),
        initializer: validateOptionalType("Expression")
    }
});
defineType("TSModuleDeclaration", {
    aliases: [
        "Statement",
        "Declaration"
    ],
    visitor: [
        "id",
        "body"
    ],
    fields: {
        declare: validateOptional(bool),
        global: validateOptional(bool),
        id: validateType([
            "Identifier",
            "StringLiteral"
        ]),
        body: validateType([
            "TSModuleBlock",
            "TSModuleDeclaration"
        ])
    }
});
defineType("TSModuleBlock", {
    aliases: [
        "Scopable",
        "Block",
        "BlockParent",
        "FunctionParent"
    ],
    visitor: [
        "body"
    ],
    fields: {
        body: validateArrayOfType("Statement")
    }
});
defineType("TSImportType", {
    aliases: [
        "TSType"
    ],
    visitor: [
        "argument",
        "qualifier",
        "typeParameters"
    ],
    fields: {
        argument: validateType("StringLiteral"),
        qualifier: validateOptionalType("TSEntityName"),
        typeParameters: validateOptionalType("TSTypeParameterInstantiation")
    }
});
defineType("TSImportEqualsDeclaration", {
    aliases: [
        "Statement"
    ],
    visitor: [
        "id",
        "moduleReference"
    ],
    fields: {
        isExport: validate$1(bool),
        id: validateType("Identifier"),
        moduleReference: validateType([
            "TSEntityName",
            "TSExternalModuleReference"
        ]),
        importKind: {
            validate: assertOneOf("type", "value"),
            optional: true
        }
    }
});
defineType("TSExternalModuleReference", {
    visitor: [
        "expression"
    ],
    fields: {
        expression: validateType("StringLiteral")
    }
});
defineType("TSNonNullExpression", {
    aliases: [
        "Expression",
        "LVal",
        "PatternLike"
    ],
    visitor: [
        "expression"
    ],
    fields: {
        expression: validateType("Expression")
    }
});
defineType("TSExportAssignment", {
    aliases: [
        "Statement"
    ],
    visitor: [
        "expression"
    ],
    fields: {
        expression: validateType("Expression")
    }
});
defineType("TSNamespaceExportDeclaration", {
    aliases: [
        "Statement"
    ],
    visitor: [
        "id"
    ],
    fields: {
        id: validateType("Identifier")
    }
});
defineType("TSTypeAnnotation", {
    visitor: [
        "typeAnnotation"
    ],
    fields: {
        typeAnnotation: {
            validate: assertNodeType("TSType")
        }
    }
});
defineType("TSTypeParameterInstantiation", {
    visitor: [
        "params"
    ],
    fields: {
        params: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("TSType")))
        }
    }
});
defineType("TSTypeParameterDeclaration", {
    visitor: [
        "params"
    ],
    fields: {
        params: {
            validate: chain(assertValueType("array"), assertEach(assertNodeType("TSTypeParameter")))
        }
    }
});
defineType("TSTypeParameter", {
    builder: [
        "constraint",
        "default",
        "name"
    ],
    visitor: [
        "constraint",
        "default"
    ],
    fields: {
        name: {
            validate: assertNodeType("Identifier")
        },
        in: {
            validate: assertValueType("boolean"),
            optional: true
        },
        out: {
            validate: assertValueType("boolean"),
            optional: true
        },
        const: {
            validate: assertValueType("boolean"),
            optional: true
        },
        constraint: {
            validate: assertNodeType("TSType"),
            optional: true
        },
        default: {
            validate: assertNodeType("TSType"),
            optional: true
        }
    }
});
var DEPRECATED_ALIASES = {
    ModuleDeclaration: "ImportOrExportDeclaration"
};
Object.keys(DEPRECATED_ALIASES).forEach(function(deprecatedAlias) {
    FLIPPED_ALIAS_KEYS[deprecatedAlias] = FLIPPED_ALIAS_KEYS[DEPRECATED_ALIASES[deprecatedAlias]];
});
(0, import_to_fast_properties.default)(VISITOR_KEYS);
(0, import_to_fast_properties.default)(ALIAS_KEYS);
(0, import_to_fast_properties.default)(FLIPPED_ALIAS_KEYS);
(0, import_to_fast_properties.default)(NODE_FIELDS);
(0, import_to_fast_properties.default)(BUILDER_KEYS);
(0, import_to_fast_properties.default)(DEPRECATED_KEYS);
(0, import_to_fast_properties.default)(PLACEHOLDERS_ALIAS);
(0, import_to_fast_properties.default)(PLACEHOLDERS_FLIPPED_ALIAS);
var TYPES = [].concat(Object.keys(VISITOR_KEYS), Object.keys(FLIPPED_ALIAS_KEYS), Object.keys(DEPRECATED_KEYS));
function validate(node, key, val) {
    if (!node) return;
    var fields = NODE_FIELDS[node.type];
    if (!fields) return;
    var field = fields[key];
    validateField(node, key, val, field);
    validateChild(node, key, val);
}
function validateField(node, key, val, field) {
    if (!(field === null || field === void 0 ? void 0 : field.validate)) return;
    if (field.optional && val == null) return;
    field.validate(node, key, val);
}
function validateChild(node, key, val) {
    if (val == null) return;
    var validate4 = NODE_PARENT_VALIDATIONS[val.type];
    if (!validate4) return;
    validate4(node, key, val);
}
function validateNode(node) {
    var keys = BUILDER_KEYS[node.type];
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            validate(node, key, node[key]);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return node;
}
function arrayExpression() {
    var elements = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
    return validateNode({
        type: "ArrayExpression",
        elements: elements
    });
}
function assignmentExpression(operator, left, right) {
    return validateNode({
        type: "AssignmentExpression",
        operator: operator,
        left: left,
        right: right
    });
}
function binaryExpression(operator, left, right) {
    return validateNode({
        type: "BinaryExpression",
        operator: operator,
        left: left,
        right: right
    });
}
function interpreterDirective(value1) {
    return validateNode({
        type: "InterpreterDirective",
        value: value1
    });
}
function directive(value1) {
    return validateNode({
        type: "Directive",
        value: value1
    });
}
function directiveLiteral(value1) {
    return validateNode({
        type: "DirectiveLiteral",
        value: value1
    });
}
function blockStatement(body) {
    var directives = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
    return validateNode({
        type: "BlockStatement",
        body: body,
        directives: directives
    });
}
function breakStatement() {
    var label = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
    return validateNode({
        type: "BreakStatement",
        label: label
    });
}
function callExpression(callee, _arguments) {
    return validateNode({
        type: "CallExpression",
        callee: callee,
        arguments: _arguments
    });
}
function catchClause() {
    var param = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, body = arguments.length > 1 ? arguments[1] : void 0;
    return validateNode({
        type: "CatchClause",
        param: param,
        body: body
    });
}
function conditionalExpression(test, consequent, alternate) {
    return validateNode({
        type: "ConditionalExpression",
        test: test,
        consequent: consequent,
        alternate: alternate
    });
}
function continueStatement() {
    var label = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
    return validateNode({
        type: "ContinueStatement",
        label: label
    });
}
function debuggerStatement() {
    return {
        type: "DebuggerStatement"
    };
}
function doWhileStatement(test, body) {
    return validateNode({
        type: "DoWhileStatement",
        test: test,
        body: body
    });
}
function emptyStatement() {
    return {
        type: "EmptyStatement"
    };
}
function expressionStatement(expression2) {
    return validateNode({
        type: "ExpressionStatement",
        expression: expression2
    });
}
function file(program3) {
    var comments = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, tokens = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "File",
        program: program3,
        comments: comments,
        tokens: tokens
    });
}
function forInStatement(left, right, body) {
    return validateNode({
        type: "ForInStatement",
        left: left,
        right: right,
        body: body
    });
}
function forStatement() {
    var init = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, test = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, update = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, body = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "ForStatement",
        init: init,
        test: test,
        update: update,
        body: body
    });
}
function functionDeclaration() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, params = arguments.length > 1 ? arguments[1] : void 0, body = arguments.length > 2 ? arguments[2] : void 0, generator = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, async = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
    return validateNode({
        type: "FunctionDeclaration",
        id: id,
        params: params,
        body: body,
        generator: generator,
        async: async
    });
}
function functionExpression() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, params = arguments.length > 1 ? arguments[1] : void 0, body = arguments.length > 2 ? arguments[2] : void 0, generator = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, async = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
    return validateNode({
        type: "FunctionExpression",
        id: id,
        params: params,
        body: body,
        generator: generator,
        async: async
    });
}
function identifier(name) {
    return validateNode({
        type: "Identifier",
        name: name
    });
}
function ifStatement(test, consequent) {
    var alternate = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "IfStatement",
        test: test,
        consequent: consequent,
        alternate: alternate
    });
}
function labeledStatement(label, body) {
    return validateNode({
        type: "LabeledStatement",
        label: label,
        body: body
    });
}
function stringLiteral(value1) {
    return validateNode({
        type: "StringLiteral",
        value: value1
    });
}
function numericLiteral(value1) {
    return validateNode({
        type: "NumericLiteral",
        value: value1
    });
}
function nullLiteral() {
    return {
        type: "NullLiteral"
    };
}
function booleanLiteral(value1) {
    return validateNode({
        type: "BooleanLiteral",
        value: value1
    });
}
function regExpLiteral(pattern) {
    var flags = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "";
    return validateNode({
        type: "RegExpLiteral",
        pattern: pattern,
        flags: flags
    });
}
function logicalExpression(operator, left, right) {
    return validateNode({
        type: "LogicalExpression",
        operator: operator,
        left: left,
        right: right
    });
}
function memberExpression(object, property) {
    var computed = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, optional = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "MemberExpression",
        object: object,
        property: property,
        computed: computed,
        optional: optional
    });
}
function newExpression(callee, _arguments) {
    return validateNode({
        type: "NewExpression",
        callee: callee,
        arguments: _arguments
    });
}
function program(body) {
    var directives = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], sourceType = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "script", interpreter = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "Program",
        body: body,
        directives: directives,
        sourceType: sourceType,
        interpreter: interpreter
    });
}
function objectExpression(properties) {
    return validateNode({
        type: "ObjectExpression",
        properties: properties
    });
}
function objectMethod() {
    var kind = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "method", key = arguments.length > 1 ? arguments[1] : void 0, params = arguments.length > 2 ? arguments[2] : void 0, body = arguments.length > 3 ? arguments[3] : void 0, computed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false, generator = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : false, async = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false;
    return validateNode({
        type: "ObjectMethod",
        kind: kind,
        key: key,
        params: params,
        body: body,
        computed: computed,
        generator: generator,
        async: async
    });
}
function objectProperty(key, value1) {
    var computed = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, shorthand = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, decorators = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null;
    return validateNode({
        type: "ObjectProperty",
        key: key,
        value: value1,
        computed: computed,
        shorthand: shorthand,
        decorators: decorators
    });
}
function restElement(argument) {
    return validateNode({
        type: "RestElement",
        argument: argument
    });
}
function returnStatement() {
    var argument = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
    return validateNode({
        type: "ReturnStatement",
        argument: argument
    });
}
function sequenceExpression(expressions) {
    return validateNode({
        type: "SequenceExpression",
        expressions: expressions
    });
}
function parenthesizedExpression(expression2) {
    return validateNode({
        type: "ParenthesizedExpression",
        expression: expression2
    });
}
function switchCase() {
    var test = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, consequent = arguments.length > 1 ? arguments[1] : void 0;
    return validateNode({
        type: "SwitchCase",
        test: test,
        consequent: consequent
    });
}
function switchStatement(discriminant, cases) {
    return validateNode({
        type: "SwitchStatement",
        discriminant: discriminant,
        cases: cases
    });
}
function thisExpression() {
    return {
        type: "ThisExpression"
    };
}
function throwStatement(argument) {
    return validateNode({
        type: "ThrowStatement",
        argument: argument
    });
}
function tryStatement(block) {
    var handler = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, finalizer = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TryStatement",
        block: block,
        handler: handler,
        finalizer: finalizer
    });
}
function unaryExpression(operator, argument) {
    var prefix2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    return validateNode({
        type: "UnaryExpression",
        operator: operator,
        argument: argument,
        prefix: prefix2
    });
}
function updateExpression(operator, argument) {
    var prefix2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    return validateNode({
        type: "UpdateExpression",
        operator: operator,
        argument: argument,
        prefix: prefix2
    });
}
function variableDeclaration(kind, declarations) {
    return validateNode({
        type: "VariableDeclaration",
        kind: kind,
        declarations: declarations
    });
}
function variableDeclarator(id) {
    var init = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "VariableDeclarator",
        id: id,
        init: init
    });
}
function whileStatement(test, body) {
    return validateNode({
        type: "WhileStatement",
        test: test,
        body: body
    });
}
function withStatement(object, body) {
    return validateNode({
        type: "WithStatement",
        object: object,
        body: body
    });
}
function assignmentPattern(left, right) {
    return validateNode({
        type: "AssignmentPattern",
        left: left,
        right: right
    });
}
function arrayPattern(elements) {
    return validateNode({
        type: "ArrayPattern",
        elements: elements
    });
}
function arrowFunctionExpression(params, body) {
    var async = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    return validateNode({
        type: "ArrowFunctionExpression",
        params: params,
        body: body,
        async: async,
        expression: null
    });
}
function classBody(body) {
    return validateNode({
        type: "ClassBody",
        body: body
    });
}
function classExpression() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, superClass = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, body = arguments.length > 2 ? arguments[2] : void 0, decorators = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "ClassExpression",
        id: id,
        superClass: superClass,
        body: body,
        decorators: decorators
    });
}
function classDeclaration() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, superClass = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, body = arguments.length > 2 ? arguments[2] : void 0, decorators = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "ClassDeclaration",
        id: id,
        superClass: superClass,
        body: body,
        decorators: decorators
    });
}
function exportAllDeclaration(source) {
    return validateNode({
        type: "ExportAllDeclaration",
        source: source
    });
}
function exportDefaultDeclaration(declaration) {
    return validateNode({
        type: "ExportDefaultDeclaration",
        declaration: declaration
    });
}
function exportNamedDeclaration() {
    var declaration = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, specifiers = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], source = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "ExportNamedDeclaration",
        declaration: declaration,
        specifiers: specifiers,
        source: source
    });
}
function exportSpecifier(local, exported) {
    return validateNode({
        type: "ExportSpecifier",
        local: local,
        exported: exported
    });
}
function forOfStatement(left, right, body) {
    var _await = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return validateNode({
        type: "ForOfStatement",
        left: left,
        right: right,
        body: body,
        await: _await
    });
}
function importDeclaration(specifiers, source) {
    return validateNode({
        type: "ImportDeclaration",
        specifiers: specifiers,
        source: source
    });
}
function importDefaultSpecifier(local) {
    return validateNode({
        type: "ImportDefaultSpecifier",
        local: local
    });
}
function importNamespaceSpecifier(local) {
    return validateNode({
        type: "ImportNamespaceSpecifier",
        local: local
    });
}
function importSpecifier(local, imported) {
    return validateNode({
        type: "ImportSpecifier",
        local: local,
        imported: imported
    });
}
function importExpression(source) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "ImportExpression",
        source: source,
        options: options
    });
}
function metaProperty(meta, property) {
    return validateNode({
        type: "MetaProperty",
        meta: meta,
        property: property
    });
}
function classMethod() {
    var kind = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "method", key = arguments.length > 1 ? arguments[1] : void 0, params = arguments.length > 2 ? arguments[2] : void 0, body = arguments.length > 3 ? arguments[3] : void 0, computed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false, _static = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : false, generator = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false, async = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : false;
    return validateNode({
        type: "ClassMethod",
        kind: kind,
        key: key,
        params: params,
        body: body,
        computed: computed,
        static: _static,
        generator: generator,
        async: async
    });
}
function objectPattern(properties) {
    return validateNode({
        type: "ObjectPattern",
        properties: properties
    });
}
function spreadElement(argument) {
    return validateNode({
        type: "SpreadElement",
        argument: argument
    });
}
function _super() {
    return {
        type: "Super"
    };
}
function taggedTemplateExpression(tag, quasi) {
    return validateNode({
        type: "TaggedTemplateExpression",
        tag: tag,
        quasi: quasi
    });
}
function templateElement(value1) {
    var tail = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
    return validateNode({
        type: "TemplateElement",
        value: value1,
        tail: tail
    });
}
function templateLiteral(quasis, expressions) {
    return validateNode({
        type: "TemplateLiteral",
        quasis: quasis,
        expressions: expressions
    });
}
function yieldExpression() {
    var argument = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, delegate = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
    return validateNode({
        type: "YieldExpression",
        argument: argument,
        delegate: delegate
    });
}
function awaitExpression(argument) {
    return validateNode({
        type: "AwaitExpression",
        argument: argument
    });
}
function _import() {
    return {
        type: "Import"
    };
}
function bigIntLiteral(value1) {
    return validateNode({
        type: "BigIntLiteral",
        value: value1
    });
}
function exportNamespaceSpecifier(exported) {
    return validateNode({
        type: "ExportNamespaceSpecifier",
        exported: exported
    });
}
function optionalMemberExpression(object, property) {
    var computed = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, optional = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "OptionalMemberExpression",
        object: object,
        property: property,
        computed: computed,
        optional: optional
    });
}
function optionalCallExpression(callee, _arguments, optional) {
    return validateNode({
        type: "OptionalCallExpression",
        callee: callee,
        arguments: _arguments,
        optional: optional
    });
}
function classProperty(key) {
    var value1 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, decorators = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null, computed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false, _static = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : false;
    return validateNode({
        type: "ClassProperty",
        key: key,
        value: value1,
        typeAnnotation: typeAnnotation2,
        decorators: decorators,
        computed: computed,
        static: _static
    });
}
function classAccessorProperty(key) {
    var value1 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, decorators = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null, computed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false, _static = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : false;
    return validateNode({
        type: "ClassAccessorProperty",
        key: key,
        value: value1,
        typeAnnotation: typeAnnotation2,
        decorators: decorators,
        computed: computed,
        static: _static
    });
}
function classPrivateProperty(key) {
    var value1 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, decorators = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, _static = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return validateNode({
        type: "ClassPrivateProperty",
        key: key,
        value: value1,
        decorators: decorators,
        static: _static
    });
}
function classPrivateMethod() {
    var kind = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "method", key = arguments.length > 1 ? arguments[1] : void 0, params = arguments.length > 2 ? arguments[2] : void 0, body = arguments.length > 3 ? arguments[3] : void 0, _static = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
    return validateNode({
        type: "ClassPrivateMethod",
        kind: kind,
        key: key,
        params: params,
        body: body,
        static: _static
    });
}
function privateName(id) {
    return validateNode({
        type: "PrivateName",
        id: id
    });
}
function staticBlock(body) {
    return validateNode({
        type: "StaticBlock",
        body: body
    });
}
function anyTypeAnnotation() {
    return {
        type: "AnyTypeAnnotation"
    };
}
function arrayTypeAnnotation(elementType) {
    return validateNode({
        type: "ArrayTypeAnnotation",
        elementType: elementType
    });
}
function booleanTypeAnnotation() {
    return {
        type: "BooleanTypeAnnotation"
    };
}
function booleanLiteralTypeAnnotation(value1) {
    return validateNode({
        type: "BooleanLiteralTypeAnnotation",
        value: value1
    });
}
function nullLiteralTypeAnnotation() {
    return {
        type: "NullLiteralTypeAnnotation"
    };
}
function classImplements(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "ClassImplements",
        id: id,
        typeParameters: typeParameters
    });
}
function declareClass(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, _extends = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, body = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "DeclareClass",
        id: id,
        typeParameters: typeParameters,
        extends: _extends,
        body: body
    });
}
function declareFunction(id) {
    return validateNode({
        type: "DeclareFunction",
        id: id
    });
}
function declareInterface(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, _extends = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, body = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "DeclareInterface",
        id: id,
        typeParameters: typeParameters,
        extends: _extends,
        body: body
    });
}
function declareModule(id, body) {
    var kind = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "DeclareModule",
        id: id,
        body: body,
        kind: kind
    });
}
function declareModuleExports(typeAnnotation2) {
    return validateNode({
        type: "DeclareModuleExports",
        typeAnnotation: typeAnnotation2
    });
}
function declareTypeAlias(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, right = arguments.length > 2 ? arguments[2] : void 0;
    return validateNode({
        type: "DeclareTypeAlias",
        id: id,
        typeParameters: typeParameters,
        right: right
    });
}
function declareOpaqueType(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, supertype = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "DeclareOpaqueType",
        id: id,
        typeParameters: typeParameters,
        supertype: supertype
    });
}
function declareVariable(id) {
    return validateNode({
        type: "DeclareVariable",
        id: id
    });
}
function declareExportDeclaration() {
    var declaration = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, specifiers = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, source = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "DeclareExportDeclaration",
        declaration: declaration,
        specifiers: specifiers,
        source: source
    });
}
function declareExportAllDeclaration(source) {
    return validateNode({
        type: "DeclareExportAllDeclaration",
        source: source
    });
}
function declaredPredicate(value1) {
    return validateNode({
        type: "DeclaredPredicate",
        value: value1
    });
}
function existsTypeAnnotation() {
    return {
        type: "ExistsTypeAnnotation"
    };
}
function functionTypeAnnotation() {
    var typeParameters = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, params = arguments.length > 1 ? arguments[1] : void 0, rest = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, returnType = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "FunctionTypeAnnotation",
        typeParameters: typeParameters,
        params: params,
        rest: rest,
        returnType: returnType
    });
}
function functionTypeParam() {
    var name = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, typeAnnotation2 = arguments.length > 1 ? arguments[1] : void 0;
    return validateNode({
        type: "FunctionTypeParam",
        name: name,
        typeAnnotation: typeAnnotation2
    });
}
function genericTypeAnnotation(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "GenericTypeAnnotation",
        id: id,
        typeParameters: typeParameters
    });
}
function inferredPredicate() {
    return {
        type: "InferredPredicate"
    };
}
function interfaceExtends(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "InterfaceExtends",
        id: id,
        typeParameters: typeParameters
    });
}
function interfaceDeclaration(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, _extends = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, body = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "InterfaceDeclaration",
        id: id,
        typeParameters: typeParameters,
        extends: _extends,
        body: body
    });
}
function interfaceTypeAnnotation() {
    var _extends = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, body = arguments.length > 1 ? arguments[1] : void 0;
    return validateNode({
        type: "InterfaceTypeAnnotation",
        extends: _extends,
        body: body
    });
}
function intersectionTypeAnnotation(types2) {
    return validateNode({
        type: "IntersectionTypeAnnotation",
        types: types2
    });
}
function mixedTypeAnnotation() {
    return {
        type: "MixedTypeAnnotation"
    };
}
function emptyTypeAnnotation() {
    return {
        type: "EmptyTypeAnnotation"
    };
}
function nullableTypeAnnotation(typeAnnotation2) {
    return validateNode({
        type: "NullableTypeAnnotation",
        typeAnnotation: typeAnnotation2
    });
}
function numberLiteralTypeAnnotation(value1) {
    return validateNode({
        type: "NumberLiteralTypeAnnotation",
        value: value1
    });
}
function numberTypeAnnotation() {
    return {
        type: "NumberTypeAnnotation"
    };
}
function objectTypeAnnotation(properties) {
    var indexers = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], callProperties = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [], internalSlots = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : [], exact = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
    return validateNode({
        type: "ObjectTypeAnnotation",
        properties: properties,
        indexers: indexers,
        callProperties: callProperties,
        internalSlots: internalSlots,
        exact: exact
    });
}
function objectTypeInternalSlot(id, value1, optional, _static, method) {
    return validateNode({
        type: "ObjectTypeInternalSlot",
        id: id,
        value: value1,
        optional: optional,
        static: _static,
        method: method
    });
}
function objectTypeCallProperty(value1) {
    return validateNode({
        type: "ObjectTypeCallProperty",
        value: value1,
        static: null
    });
}
function objectTypeIndexer() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, key = arguments.length > 1 ? arguments[1] : void 0, value1 = arguments.length > 2 ? arguments[2] : void 0, variance2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "ObjectTypeIndexer",
        id: id,
        key: key,
        value: value1,
        variance: variance2,
        static: null
    });
}
function objectTypeProperty(key, value1) {
    var variance2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "ObjectTypeProperty",
        key: key,
        value: value1,
        variance: variance2,
        kind: null,
        method: null,
        optional: null,
        proto: null,
        static: null
    });
}
function objectTypeSpreadProperty(argument) {
    return validateNode({
        type: "ObjectTypeSpreadProperty",
        argument: argument
    });
}
function opaqueType(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, supertype = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, impltype = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "OpaqueType",
        id: id,
        typeParameters: typeParameters,
        supertype: supertype,
        impltype: impltype
    });
}
function qualifiedTypeIdentifier(id, qualification) {
    return validateNode({
        type: "QualifiedTypeIdentifier",
        id: id,
        qualification: qualification
    });
}
function stringLiteralTypeAnnotation(value1) {
    return validateNode({
        type: "StringLiteralTypeAnnotation",
        value: value1
    });
}
function stringTypeAnnotation() {
    return {
        type: "StringTypeAnnotation"
    };
}
function symbolTypeAnnotation() {
    return {
        type: "SymbolTypeAnnotation"
    };
}
function thisTypeAnnotation() {
    return {
        type: "ThisTypeAnnotation"
    };
}
function tupleTypeAnnotation(types2) {
    return validateNode({
        type: "TupleTypeAnnotation",
        types: types2
    });
}
function typeofTypeAnnotation(argument) {
    return validateNode({
        type: "TypeofTypeAnnotation",
        argument: argument
    });
}
function typeAlias(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, right = arguments.length > 2 ? arguments[2] : void 0;
    return validateNode({
        type: "TypeAlias",
        id: id,
        typeParameters: typeParameters,
        right: right
    });
}
function typeAnnotation(typeAnnotation2) {
    return validateNode({
        type: "TypeAnnotation",
        typeAnnotation: typeAnnotation2
    });
}
function typeCastExpression(expression2, typeAnnotation2) {
    return validateNode({
        type: "TypeCastExpression",
        expression: expression2,
        typeAnnotation: typeAnnotation2
    });
}
function typeParameter() {
    var bound = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, _default = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, variance2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TypeParameter",
        bound: bound,
        default: _default,
        variance: variance2,
        name: null
    });
}
function typeParameterDeclaration(params) {
    return validateNode({
        type: "TypeParameterDeclaration",
        params: params
    });
}
function typeParameterInstantiation(params) {
    return validateNode({
        type: "TypeParameterInstantiation",
        params: params
    });
}
function unionTypeAnnotation(types2) {
    return validateNode({
        type: "UnionTypeAnnotation",
        types: types2
    });
}
function variance(kind) {
    return validateNode({
        type: "Variance",
        kind: kind
    });
}
function voidTypeAnnotation() {
    return {
        type: "VoidTypeAnnotation"
    };
}
function enumDeclaration(id, body) {
    return validateNode({
        type: "EnumDeclaration",
        id: id,
        body: body
    });
}
function enumBooleanBody(members) {
    return validateNode({
        type: "EnumBooleanBody",
        members: members,
        explicitType: null,
        hasUnknownMembers: null
    });
}
function enumNumberBody(members) {
    return validateNode({
        type: "EnumNumberBody",
        members: members,
        explicitType: null,
        hasUnknownMembers: null
    });
}
function enumStringBody(members) {
    return validateNode({
        type: "EnumStringBody",
        members: members,
        explicitType: null,
        hasUnknownMembers: null
    });
}
function enumSymbolBody(members) {
    return validateNode({
        type: "EnumSymbolBody",
        members: members,
        hasUnknownMembers: null
    });
}
function enumBooleanMember(id) {
    return validateNode({
        type: "EnumBooleanMember",
        id: id,
        init: null
    });
}
function enumNumberMember(id, init) {
    return validateNode({
        type: "EnumNumberMember",
        id: id,
        init: init
    });
}
function enumStringMember(id, init) {
    return validateNode({
        type: "EnumStringMember",
        id: id,
        init: init
    });
}
function enumDefaultedMember(id) {
    return validateNode({
        type: "EnumDefaultedMember",
        id: id
    });
}
function indexedAccessType(objectType, indexType) {
    return validateNode({
        type: "IndexedAccessType",
        objectType: objectType,
        indexType: indexType
    });
}
function optionalIndexedAccessType(objectType, indexType) {
    return validateNode({
        type: "OptionalIndexedAccessType",
        objectType: objectType,
        indexType: indexType,
        optional: null
    });
}
function jsxAttribute(name) {
    var value1 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "JSXAttribute",
        name: name,
        value: value1
    });
}
function jsxClosingElement(name) {
    return validateNode({
        type: "JSXClosingElement",
        name: name
    });
}
function jsxElement(openingElement) {
    var closingElement = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, children = arguments.length > 2 ? arguments[2] : void 0, selfClosing = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "JSXElement",
        openingElement: openingElement,
        closingElement: closingElement,
        children: children,
        selfClosing: selfClosing
    });
}
function jsxEmptyExpression() {
    return {
        type: "JSXEmptyExpression"
    };
}
function jsxExpressionContainer(expression2) {
    return validateNode({
        type: "JSXExpressionContainer",
        expression: expression2
    });
}
function jsxSpreadChild(expression2) {
    return validateNode({
        type: "JSXSpreadChild",
        expression: expression2
    });
}
function jsxIdentifier(name) {
    return validateNode({
        type: "JSXIdentifier",
        name: name
    });
}
function jsxMemberExpression(object, property) {
    return validateNode({
        type: "JSXMemberExpression",
        object: object,
        property: property
    });
}
function jsxNamespacedName(namespace, name) {
    return validateNode({
        type: "JSXNamespacedName",
        namespace: namespace,
        name: name
    });
}
function jsxOpeningElement(name, attributes) {
    var selfClosing = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    return validateNode({
        type: "JSXOpeningElement",
        name: name,
        attributes: attributes,
        selfClosing: selfClosing
    });
}
function jsxSpreadAttribute(argument) {
    return validateNode({
        type: "JSXSpreadAttribute",
        argument: argument
    });
}
function jsxText(value1) {
    return validateNode({
        type: "JSXText",
        value: value1
    });
}
function jsxFragment(openingFragment, closingFragment, children) {
    return validateNode({
        type: "JSXFragment",
        openingFragment: openingFragment,
        closingFragment: closingFragment,
        children: children
    });
}
function jsxOpeningFragment() {
    return {
        type: "JSXOpeningFragment"
    };
}
function jsxClosingFragment() {
    return {
        type: "JSXClosingFragment"
    };
}
function noop() {
    return {
        type: "Noop"
    };
}
function placeholder(expectedNode, name) {
    return validateNode({
        type: "Placeholder",
        expectedNode: expectedNode,
        name: name
    });
}
function v8IntrinsicIdentifier(name) {
    return validateNode({
        type: "V8IntrinsicIdentifier",
        name: name
    });
}
function argumentPlaceholder() {
    return {
        type: "ArgumentPlaceholder"
    };
}
function bindExpression(object, callee) {
    return validateNode({
        type: "BindExpression",
        object: object,
        callee: callee
    });
}
function importAttribute(key, value1) {
    return validateNode({
        type: "ImportAttribute",
        key: key,
        value: value1
    });
}
function decorator(expression2) {
    return validateNode({
        type: "Decorator",
        expression: expression2
    });
}
function doExpression(body) {
    var async = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
    return validateNode({
        type: "DoExpression",
        body: body,
        async: async
    });
}
function exportDefaultSpecifier(exported) {
    return validateNode({
        type: "ExportDefaultSpecifier",
        exported: exported
    });
}
function recordExpression(properties) {
    return validateNode({
        type: "RecordExpression",
        properties: properties
    });
}
function tupleExpression() {
    var elements = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
    return validateNode({
        type: "TupleExpression",
        elements: elements
    });
}
function decimalLiteral(value1) {
    return validateNode({
        type: "DecimalLiteral",
        value: value1
    });
}
function moduleExpression(body) {
    return validateNode({
        type: "ModuleExpression",
        body: body
    });
}
function topicReference() {
    return {
        type: "TopicReference"
    };
}
function pipelineTopicExpression(expression2) {
    return validateNode({
        type: "PipelineTopicExpression",
        expression: expression2
    });
}
function pipelineBareFunction(callee) {
    return validateNode({
        type: "PipelineBareFunction",
        callee: callee
    });
}
function pipelinePrimaryTopicReference() {
    return {
        type: "PipelinePrimaryTopicReference"
    };
}
function tsParameterProperty(parameter) {
    return validateNode({
        type: "TSParameterProperty",
        parameter: parameter
    });
}
function tsDeclareFunction() {
    var id = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, params = arguments.length > 2 ? arguments[2] : void 0, returnType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "TSDeclareFunction",
        id: id,
        typeParameters: typeParameters,
        params: params,
        returnType: returnType
    });
}
function tsDeclareMethod() {
    var decorators = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, key = arguments.length > 1 ? arguments[1] : void 0, typeParameters = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, params = arguments.length > 3 ? arguments[3] : void 0, returnType = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null;
    return validateNode({
        type: "TSDeclareMethod",
        decorators: decorators,
        key: key,
        typeParameters: typeParameters,
        params: params,
        returnType: returnType
    });
}
function tsQualifiedName(left, right) {
    return validateNode({
        type: "TSQualifiedName",
        left: left,
        right: right
    });
}
function tsCallSignatureDeclaration() {
    var typeParameters = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, parameters = arguments.length > 1 ? arguments[1] : void 0, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSCallSignatureDeclaration",
        typeParameters: typeParameters,
        parameters: parameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsConstructSignatureDeclaration() {
    var typeParameters = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, parameters = arguments.length > 1 ? arguments[1] : void 0, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSConstructSignatureDeclaration",
        typeParameters: typeParameters,
        parameters: parameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsPropertySignature(key) {
    var typeAnnotation2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSPropertySignature",
        key: key,
        typeAnnotation: typeAnnotation2,
        kind: null
    });
}
function tsMethodSignature(key) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, parameters = arguments.length > 2 ? arguments[2] : void 0, typeAnnotation2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    return validateNode({
        type: "TSMethodSignature",
        key: key,
        typeParameters: typeParameters,
        parameters: parameters,
        typeAnnotation: typeAnnotation2,
        kind: null
    });
}
function tsIndexSignature(parameters) {
    var typeAnnotation2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSIndexSignature",
        parameters: parameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsAnyKeyword() {
    return {
        type: "TSAnyKeyword"
    };
}
function tsBooleanKeyword() {
    return {
        type: "TSBooleanKeyword"
    };
}
function tsBigIntKeyword() {
    return {
        type: "TSBigIntKeyword"
    };
}
function tsIntrinsicKeyword() {
    return {
        type: "TSIntrinsicKeyword"
    };
}
function tsNeverKeyword() {
    return {
        type: "TSNeverKeyword"
    };
}
function tsNullKeyword() {
    return {
        type: "TSNullKeyword"
    };
}
function tsNumberKeyword() {
    return {
        type: "TSNumberKeyword"
    };
}
function tsObjectKeyword() {
    return {
        type: "TSObjectKeyword"
    };
}
function tsStringKeyword() {
    return {
        type: "TSStringKeyword"
    };
}
function tsSymbolKeyword() {
    return {
        type: "TSSymbolKeyword"
    };
}
function tsUndefinedKeyword() {
    return {
        type: "TSUndefinedKeyword"
    };
}
function tsUnknownKeyword() {
    return {
        type: "TSUnknownKeyword"
    };
}
function tsVoidKeyword() {
    return {
        type: "TSVoidKeyword"
    };
}
function tsThisType() {
    return {
        type: "TSThisType"
    };
}
function tsFunctionType() {
    var typeParameters = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, parameters = arguments.length > 1 ? arguments[1] : void 0, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSFunctionType",
        typeParameters: typeParameters,
        parameters: parameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsConstructorType() {
    var typeParameters = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, parameters = arguments.length > 1 ? arguments[1] : void 0, typeAnnotation2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSConstructorType",
        typeParameters: typeParameters,
        parameters: parameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsTypeReference(typeName) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSTypeReference",
        typeName: typeName,
        typeParameters: typeParameters
    });
}
function tsTypePredicate(parameterName) {
    var typeAnnotation2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, asserts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSTypePredicate",
        parameterName: parameterName,
        typeAnnotation: typeAnnotation2,
        asserts: asserts
    });
}
function tsTypeQuery(exprName) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSTypeQuery",
        exprName: exprName,
        typeParameters: typeParameters
    });
}
function tsTypeLiteral(members) {
    return validateNode({
        type: "TSTypeLiteral",
        members: members
    });
}
function tsArrayType(elementType) {
    return validateNode({
        type: "TSArrayType",
        elementType: elementType
    });
}
function tsTupleType(elementTypes) {
    return validateNode({
        type: "TSTupleType",
        elementTypes: elementTypes
    });
}
function tsOptionalType(typeAnnotation2) {
    return validateNode({
        type: "TSOptionalType",
        typeAnnotation: typeAnnotation2
    });
}
function tsRestType(typeAnnotation2) {
    return validateNode({
        type: "TSRestType",
        typeAnnotation: typeAnnotation2
    });
}
function tsNamedTupleMember(label, elementType) {
    var optional = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    return validateNode({
        type: "TSNamedTupleMember",
        label: label,
        elementType: elementType,
        optional: optional
    });
}
function tsUnionType(types2) {
    return validateNode({
        type: "TSUnionType",
        types: types2
    });
}
function tsIntersectionType(types2) {
    return validateNode({
        type: "TSIntersectionType",
        types: types2
    });
}
function tsConditionalType(checkType, extendsType, trueType, falseType) {
    return validateNode({
        type: "TSConditionalType",
        checkType: checkType,
        extendsType: extendsType,
        trueType: trueType,
        falseType: falseType
    });
}
function tsInferType(typeParameter2) {
    return validateNode({
        type: "TSInferType",
        typeParameter: typeParameter2
    });
}
function tsParenthesizedType(typeAnnotation2) {
    return validateNode({
        type: "TSParenthesizedType",
        typeAnnotation: typeAnnotation2
    });
}
function tsTypeOperator(typeAnnotation2) {
    return validateNode({
        type: "TSTypeOperator",
        typeAnnotation: typeAnnotation2,
        operator: null
    });
}
function tsIndexedAccessType(objectType, indexType) {
    return validateNode({
        type: "TSIndexedAccessType",
        objectType: objectType,
        indexType: indexType
    });
}
function tsMappedType(typeParameter2) {
    var typeAnnotation2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, nameType = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSMappedType",
        typeParameter: typeParameter2,
        typeAnnotation: typeAnnotation2,
        nameType: nameType
    });
}
function tsLiteralType(literal) {
    return validateNode({
        type: "TSLiteralType",
        literal: literal
    });
}
function tsExpressionWithTypeArguments(expression2) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSExpressionWithTypeArguments",
        expression: expression2,
        typeParameters: typeParameters
    });
}
function tsInterfaceDeclaration(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, _extends = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, body = arguments.length > 3 ? arguments[3] : void 0;
    return validateNode({
        type: "TSInterfaceDeclaration",
        id: id,
        typeParameters: typeParameters,
        extends: _extends,
        body: body
    });
}
function tsInterfaceBody(body) {
    return validateNode({
        type: "TSInterfaceBody",
        body: body
    });
}
function tsTypeAliasDeclaration(id) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, typeAnnotation2 = arguments.length > 2 ? arguments[2] : void 0;
    return validateNode({
        type: "TSTypeAliasDeclaration",
        id: id,
        typeParameters: typeParameters,
        typeAnnotation: typeAnnotation2
    });
}
function tsInstantiationExpression(expression2) {
    var typeParameters = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSInstantiationExpression",
        expression: expression2,
        typeParameters: typeParameters
    });
}
function tsAsExpression(expression2, typeAnnotation2) {
    return validateNode({
        type: "TSAsExpression",
        expression: expression2,
        typeAnnotation: typeAnnotation2
    });
}
function tsSatisfiesExpression(expression2, typeAnnotation2) {
    return validateNode({
        type: "TSSatisfiesExpression",
        expression: expression2,
        typeAnnotation: typeAnnotation2
    });
}
function tsTypeAssertion(typeAnnotation2, expression2) {
    return validateNode({
        type: "TSTypeAssertion",
        typeAnnotation: typeAnnotation2,
        expression: expression2
    });
}
function tsEnumDeclaration(id, members) {
    return validateNode({
        type: "TSEnumDeclaration",
        id: id,
        members: members
    });
}
function tsEnumMember(id) {
    var initializer = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    return validateNode({
        type: "TSEnumMember",
        id: id,
        initializer: initializer
    });
}
function tsModuleDeclaration(id, body) {
    return validateNode({
        type: "TSModuleDeclaration",
        id: id,
        body: body
    });
}
function tsModuleBlock(body) {
    return validateNode({
        type: "TSModuleBlock",
        body: body
    });
}
function tsImportType(argument) {
    var qualifier = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, typeParameters = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    return validateNode({
        type: "TSImportType",
        argument: argument,
        qualifier: qualifier,
        typeParameters: typeParameters
    });
}
function tsImportEqualsDeclaration(id, moduleReference) {
    return validateNode({
        type: "TSImportEqualsDeclaration",
        id: id,
        moduleReference: moduleReference,
        isExport: null
    });
}
function tsExternalModuleReference(expression2) {
    return validateNode({
        type: "TSExternalModuleReference",
        expression: expression2
    });
}
function tsNonNullExpression(expression2) {
    return validateNode({
        type: "TSNonNullExpression",
        expression: expression2
    });
}
function tsExportAssignment(expression2) {
    return validateNode({
        type: "TSExportAssignment",
        expression: expression2
    });
}
function tsNamespaceExportDeclaration(id) {
    return validateNode({
        type: "TSNamespaceExportDeclaration",
        id: id
    });
}
function tsTypeAnnotation(typeAnnotation2) {
    return validateNode({
        type: "TSTypeAnnotation",
        typeAnnotation: typeAnnotation2
    });
}
function tsTypeParameterInstantiation(params) {
    return validateNode({
        type: "TSTypeParameterInstantiation",
        params: params
    });
}
function tsTypeParameterDeclaration(params) {
    return validateNode({
        type: "TSTypeParameterDeclaration",
        params: params
    });
}
function tsTypeParameter() {
    var constraint = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null, _default = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, name = arguments.length > 2 ? arguments[2] : void 0;
    return validateNode({
        type: "TSTypeParameter",
        constraint: constraint,
        default: _default,
        name: name
    });
}
function NumberLiteral(value1) {
    deprecationWarning("NumberLiteral", "NumericLiteral", "The node type ");
    return numericLiteral(value1);
}
function RegexLiteral(pattern) {
    var flags = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "";
    deprecationWarning("RegexLiteral", "RegExpLiteral", "The node type ");
    return regExpLiteral(pattern, flags);
}
function RestProperty(argument) {
    deprecationWarning("RestProperty", "RestElement", "The node type ");
    return restElement(argument);
}
function SpreadProperty(argument) {
    deprecationWarning("SpreadProperty", "SpreadElement", "The node type ");
    return spreadElement(argument);
}
function cleanJSXElementLiteralChild(child, args) {
    var lines = child.value.split(/\r\n|\n|\r/);
    var lastNonEmptyLine = 0;
    for(var i = 0; i < lines.length; i++){
        if (lines[i].match(/[^ \t]/)) {
            lastNonEmptyLine = i;
        }
    }
    var str = "";
    for(var i1 = 0; i1 < lines.length; i1++){
        var line = lines[i1];
        var isFirstLine = i1 === 0;
        var isLastLine = i1 === lines.length - 1;
        var isLastNonEmptyLine = i1 === lastNonEmptyLine;
        var trimmedLine = line.replace(/\t/g, " ");
        if (!isFirstLine) {
            trimmedLine = trimmedLine.replace(/^[ ]+/, "");
        }
        if (!isLastLine) {
            trimmedLine = trimmedLine.replace(/[ ]+$/, "");
        }
        if (trimmedLine) {
            if (!isLastNonEmptyLine) {
                trimmedLine += " ";
            }
            str += trimmedLine;
        }
    }
    if (str) args.push(inherits(stringLiteral(str), child));
}
function buildChildren(node) {
    var elements = [];
    for(var i = 0; i < node.children.length; i++){
        var child = node.children[i];
        if (isJSXText(child)) {
            cleanJSXElementLiteralChild(child, elements);
            continue;
        }
        if (isJSXExpressionContainer(child)) child = child.expression;
        if (isJSXEmptyExpression(child)) continue;
        elements.push(child);
    }
    return elements;
}
function isNode(node) {
    return !!(node && VISITOR_KEYS[node.type]);
}
function assertNode(node) {
    if (!isNode(node)) {
        var _node_type;
        var type = (_node_type = node === null || node === void 0 ? void 0 : node.type) !== null && _node_type !== void 0 ? _node_type : JSON.stringify(node);
        throw new TypeError('Not a valid node of type "'.concat(type, '"'));
    }
}
function assert(type, node, opts) {
    if (!is(type, node, opts)) {
        throw new Error('Expected type "'.concat(type, '" with option ').concat(JSON.stringify(opts), ', but instead got "').concat(node.type, '".'));
    }
}
function assertArrayExpression(node, opts) {
    assert("ArrayExpression", node, opts);
}
function assertAssignmentExpression(node, opts) {
    assert("AssignmentExpression", node, opts);
}
function assertBinaryExpression(node, opts) {
    assert("BinaryExpression", node, opts);
}
function assertInterpreterDirective(node, opts) {
    assert("InterpreterDirective", node, opts);
}
function assertDirective(node, opts) {
    assert("Directive", node, opts);
}
function assertDirectiveLiteral(node, opts) {
    assert("DirectiveLiteral", node, opts);
}
function assertBlockStatement(node, opts) {
    assert("BlockStatement", node, opts);
}
function assertBreakStatement(node, opts) {
    assert("BreakStatement", node, opts);
}
function assertCallExpression(node, opts) {
    assert("CallExpression", node, opts);
}
function assertCatchClause(node, opts) {
    assert("CatchClause", node, opts);
}
function assertConditionalExpression(node, opts) {
    assert("ConditionalExpression", node, opts);
}
function assertContinueStatement(node, opts) {
    assert("ContinueStatement", node, opts);
}
function assertDebuggerStatement(node, opts) {
    assert("DebuggerStatement", node, opts);
}
function assertDoWhileStatement(node, opts) {
    assert("DoWhileStatement", node, opts);
}
function assertEmptyStatement(node, opts) {
    assert("EmptyStatement", node, opts);
}
function assertExpressionStatement(node, opts) {
    assert("ExpressionStatement", node, opts);
}
function assertFile(node, opts) {
    assert("File", node, opts);
}
function assertForInStatement(node, opts) {
    assert("ForInStatement", node, opts);
}
function assertForStatement(node, opts) {
    assert("ForStatement", node, opts);
}
function assertFunctionDeclaration(node, opts) {
    assert("FunctionDeclaration", node, opts);
}
function assertFunctionExpression(node, opts) {
    assert("FunctionExpression", node, opts);
}
function assertIdentifier(node, opts) {
    assert("Identifier", node, opts);
}
function assertIfStatement(node, opts) {
    assert("IfStatement", node, opts);
}
function assertLabeledStatement(node, opts) {
    assert("LabeledStatement", node, opts);
}
function assertStringLiteral(node, opts) {
    assert("StringLiteral", node, opts);
}
function assertNumericLiteral(node, opts) {
    assert("NumericLiteral", node, opts);
}
function assertNullLiteral(node, opts) {
    assert("NullLiteral", node, opts);
}
function assertBooleanLiteral(node, opts) {
    assert("BooleanLiteral", node, opts);
}
function assertRegExpLiteral(node, opts) {
    assert("RegExpLiteral", node, opts);
}
function assertLogicalExpression(node, opts) {
    assert("LogicalExpression", node, opts);
}
function assertMemberExpression(node, opts) {
    assert("MemberExpression", node, opts);
}
function assertNewExpression(node, opts) {
    assert("NewExpression", node, opts);
}
function assertProgram(node, opts) {
    assert("Program", node, opts);
}
function assertObjectExpression(node, opts) {
    assert("ObjectExpression", node, opts);
}
function assertObjectMethod(node, opts) {
    assert("ObjectMethod", node, opts);
}
function assertObjectProperty(node, opts) {
    assert("ObjectProperty", node, opts);
}
function assertRestElement(node, opts) {
    assert("RestElement", node, opts);
}
function assertReturnStatement(node, opts) {
    assert("ReturnStatement", node, opts);
}
function assertSequenceExpression(node, opts) {
    assert("SequenceExpression", node, opts);
}
function assertParenthesizedExpression(node, opts) {
    assert("ParenthesizedExpression", node, opts);
}
function assertSwitchCase(node, opts) {
    assert("SwitchCase", node, opts);
}
function assertSwitchStatement(node, opts) {
    assert("SwitchStatement", node, opts);
}
function assertThisExpression(node, opts) {
    assert("ThisExpression", node, opts);
}
function assertThrowStatement(node, opts) {
    assert("ThrowStatement", node, opts);
}
function assertTryStatement(node, opts) {
    assert("TryStatement", node, opts);
}
function assertUnaryExpression(node, opts) {
    assert("UnaryExpression", node, opts);
}
function assertUpdateExpression(node, opts) {
    assert("UpdateExpression", node, opts);
}
function assertVariableDeclaration(node, opts) {
    assert("VariableDeclaration", node, opts);
}
function assertVariableDeclarator(node, opts) {
    assert("VariableDeclarator", node, opts);
}
function assertWhileStatement(node, opts) {
    assert("WhileStatement", node, opts);
}
function assertWithStatement(node, opts) {
    assert("WithStatement", node, opts);
}
function assertAssignmentPattern(node, opts) {
    assert("AssignmentPattern", node, opts);
}
function assertArrayPattern(node, opts) {
    assert("ArrayPattern", node, opts);
}
function assertArrowFunctionExpression(node, opts) {
    assert("ArrowFunctionExpression", node, opts);
}
function assertClassBody(node, opts) {
    assert("ClassBody", node, opts);
}
function assertClassExpression(node, opts) {
    assert("ClassExpression", node, opts);
}
function assertClassDeclaration(node, opts) {
    assert("ClassDeclaration", node, opts);
}
function assertExportAllDeclaration(node, opts) {
    assert("ExportAllDeclaration", node, opts);
}
function assertExportDefaultDeclaration(node, opts) {
    assert("ExportDefaultDeclaration", node, opts);
}
function assertExportNamedDeclaration(node, opts) {
    assert("ExportNamedDeclaration", node, opts);
}
function assertExportSpecifier(node, opts) {
    assert("ExportSpecifier", node, opts);
}
function assertForOfStatement(node, opts) {
    assert("ForOfStatement", node, opts);
}
function assertImportDeclaration(node, opts) {
    assert("ImportDeclaration", node, opts);
}
function assertImportDefaultSpecifier(node, opts) {
    assert("ImportDefaultSpecifier", node, opts);
}
function assertImportNamespaceSpecifier(node, opts) {
    assert("ImportNamespaceSpecifier", node, opts);
}
function assertImportSpecifier(node, opts) {
    assert("ImportSpecifier", node, opts);
}
function assertImportExpression(node, opts) {
    assert("ImportExpression", node, opts);
}
function assertMetaProperty(node, opts) {
    assert("MetaProperty", node, opts);
}
function assertClassMethod(node, opts) {
    assert("ClassMethod", node, opts);
}
function assertObjectPattern(node, opts) {
    assert("ObjectPattern", node, opts);
}
function assertSpreadElement(node, opts) {
    assert("SpreadElement", node, opts);
}
function assertSuper(node, opts) {
    assert("Super", node, opts);
}
function assertTaggedTemplateExpression(node, opts) {
    assert("TaggedTemplateExpression", node, opts);
}
function assertTemplateElement(node, opts) {
    assert("TemplateElement", node, opts);
}
function assertTemplateLiteral(node, opts) {
    assert("TemplateLiteral", node, opts);
}
function assertYieldExpression(node, opts) {
    assert("YieldExpression", node, opts);
}
function assertAwaitExpression(node, opts) {
    assert("AwaitExpression", node, opts);
}
function assertImport(node, opts) {
    assert("Import", node, opts);
}
function assertBigIntLiteral(node, opts) {
    assert("BigIntLiteral", node, opts);
}
function assertExportNamespaceSpecifier(node, opts) {
    assert("ExportNamespaceSpecifier", node, opts);
}
function assertOptionalMemberExpression(node, opts) {
    assert("OptionalMemberExpression", node, opts);
}
function assertOptionalCallExpression(node, opts) {
    assert("OptionalCallExpression", node, opts);
}
function assertClassProperty(node, opts) {
    assert("ClassProperty", node, opts);
}
function assertClassAccessorProperty(node, opts) {
    assert("ClassAccessorProperty", node, opts);
}
function assertClassPrivateProperty(node, opts) {
    assert("ClassPrivateProperty", node, opts);
}
function assertClassPrivateMethod(node, opts) {
    assert("ClassPrivateMethod", node, opts);
}
function assertPrivateName(node, opts) {
    assert("PrivateName", node, opts);
}
function assertStaticBlock(node, opts) {
    assert("StaticBlock", node, opts);
}
function assertAnyTypeAnnotation(node, opts) {
    assert("AnyTypeAnnotation", node, opts);
}
function assertArrayTypeAnnotation(node, opts) {
    assert("ArrayTypeAnnotation", node, opts);
}
function assertBooleanTypeAnnotation(node, opts) {
    assert("BooleanTypeAnnotation", node, opts);
}
function assertBooleanLiteralTypeAnnotation(node, opts) {
    assert("BooleanLiteralTypeAnnotation", node, opts);
}
function assertNullLiteralTypeAnnotation(node, opts) {
    assert("NullLiteralTypeAnnotation", node, opts);
}
function assertClassImplements(node, opts) {
    assert("ClassImplements", node, opts);
}
function assertDeclareClass(node, opts) {
    assert("DeclareClass", node, opts);
}
function assertDeclareFunction(node, opts) {
    assert("DeclareFunction", node, opts);
}
function assertDeclareInterface(node, opts) {
    assert("DeclareInterface", node, opts);
}
function assertDeclareModule(node, opts) {
    assert("DeclareModule", node, opts);
}
function assertDeclareModuleExports(node, opts) {
    assert("DeclareModuleExports", node, opts);
}
function assertDeclareTypeAlias(node, opts) {
    assert("DeclareTypeAlias", node, opts);
}
function assertDeclareOpaqueType(node, opts) {
    assert("DeclareOpaqueType", node, opts);
}
function assertDeclareVariable(node, opts) {
    assert("DeclareVariable", node, opts);
}
function assertDeclareExportDeclaration(node, opts) {
    assert("DeclareExportDeclaration", node, opts);
}
function assertDeclareExportAllDeclaration(node, opts) {
    assert("DeclareExportAllDeclaration", node, opts);
}
function assertDeclaredPredicate(node, opts) {
    assert("DeclaredPredicate", node, opts);
}
function assertExistsTypeAnnotation(node, opts) {
    assert("ExistsTypeAnnotation", node, opts);
}
function assertFunctionTypeAnnotation(node, opts) {
    assert("FunctionTypeAnnotation", node, opts);
}
function assertFunctionTypeParam(node, opts) {
    assert("FunctionTypeParam", node, opts);
}
function assertGenericTypeAnnotation(node, opts) {
    assert("GenericTypeAnnotation", node, opts);
}
function assertInferredPredicate(node, opts) {
    assert("InferredPredicate", node, opts);
}
function assertInterfaceExtends(node, opts) {
    assert("InterfaceExtends", node, opts);
}
function assertInterfaceDeclaration(node, opts) {
    assert("InterfaceDeclaration", node, opts);
}
function assertInterfaceTypeAnnotation(node, opts) {
    assert("InterfaceTypeAnnotation", node, opts);
}
function assertIntersectionTypeAnnotation(node, opts) {
    assert("IntersectionTypeAnnotation", node, opts);
}
function assertMixedTypeAnnotation(node, opts) {
    assert("MixedTypeAnnotation", node, opts);
}
function assertEmptyTypeAnnotation(node, opts) {
    assert("EmptyTypeAnnotation", node, opts);
}
function assertNullableTypeAnnotation(node, opts) {
    assert("NullableTypeAnnotation", node, opts);
}
function assertNumberLiteralTypeAnnotation(node, opts) {
    assert("NumberLiteralTypeAnnotation", node, opts);
}
function assertNumberTypeAnnotation(node, opts) {
    assert("NumberTypeAnnotation", node, opts);
}
function assertObjectTypeAnnotation(node, opts) {
    assert("ObjectTypeAnnotation", node, opts);
}
function assertObjectTypeInternalSlot(node, opts) {
    assert("ObjectTypeInternalSlot", node, opts);
}
function assertObjectTypeCallProperty(node, opts) {
    assert("ObjectTypeCallProperty", node, opts);
}
function assertObjectTypeIndexer(node, opts) {
    assert("ObjectTypeIndexer", node, opts);
}
function assertObjectTypeProperty(node, opts) {
    assert("ObjectTypeProperty", node, opts);
}
function assertObjectTypeSpreadProperty(node, opts) {
    assert("ObjectTypeSpreadProperty", node, opts);
}
function assertOpaqueType(node, opts) {
    assert("OpaqueType", node, opts);
}
function assertQualifiedTypeIdentifier(node, opts) {
    assert("QualifiedTypeIdentifier", node, opts);
}
function assertStringLiteralTypeAnnotation(node, opts) {
    assert("StringLiteralTypeAnnotation", node, opts);
}
function assertStringTypeAnnotation(node, opts) {
    assert("StringTypeAnnotation", node, opts);
}
function assertSymbolTypeAnnotation(node, opts) {
    assert("SymbolTypeAnnotation", node, opts);
}
function assertThisTypeAnnotation(node, opts) {
    assert("ThisTypeAnnotation", node, opts);
}
function assertTupleTypeAnnotation(node, opts) {
    assert("TupleTypeAnnotation", node, opts);
}
function assertTypeofTypeAnnotation(node, opts) {
    assert("TypeofTypeAnnotation", node, opts);
}
function assertTypeAlias(node, opts) {
    assert("TypeAlias", node, opts);
}
function assertTypeAnnotation(node, opts) {
    assert("TypeAnnotation", node, opts);
}
function assertTypeCastExpression(node, opts) {
    assert("TypeCastExpression", node, opts);
}
function assertTypeParameter(node, opts) {
    assert("TypeParameter", node, opts);
}
function assertTypeParameterDeclaration(node, opts) {
    assert("TypeParameterDeclaration", node, opts);
}
function assertTypeParameterInstantiation(node, opts) {
    assert("TypeParameterInstantiation", node, opts);
}
function assertUnionTypeAnnotation(node, opts) {
    assert("UnionTypeAnnotation", node, opts);
}
function assertVariance(node, opts) {
    assert("Variance", node, opts);
}
function assertVoidTypeAnnotation(node, opts) {
    assert("VoidTypeAnnotation", node, opts);
}
function assertEnumDeclaration(node, opts) {
    assert("EnumDeclaration", node, opts);
}
function assertEnumBooleanBody(node, opts) {
    assert("EnumBooleanBody", node, opts);
}
function assertEnumNumberBody(node, opts) {
    assert("EnumNumberBody", node, opts);
}
function assertEnumStringBody(node, opts) {
    assert("EnumStringBody", node, opts);
}
function assertEnumSymbolBody(node, opts) {
    assert("EnumSymbolBody", node, opts);
}
function assertEnumBooleanMember(node, opts) {
    assert("EnumBooleanMember", node, opts);
}
function assertEnumNumberMember(node, opts) {
    assert("EnumNumberMember", node, opts);
}
function assertEnumStringMember(node, opts) {
    assert("EnumStringMember", node, opts);
}
function assertEnumDefaultedMember(node, opts) {
    assert("EnumDefaultedMember", node, opts);
}
function assertIndexedAccessType(node, opts) {
    assert("IndexedAccessType", node, opts);
}
function assertOptionalIndexedAccessType(node, opts) {
    assert("OptionalIndexedAccessType", node, opts);
}
function assertJSXAttribute(node, opts) {
    assert("JSXAttribute", node, opts);
}
function assertJSXClosingElement(node, opts) {
    assert("JSXClosingElement", node, opts);
}
function assertJSXElement(node, opts) {
    assert("JSXElement", node, opts);
}
function assertJSXEmptyExpression(node, opts) {
    assert("JSXEmptyExpression", node, opts);
}
function assertJSXExpressionContainer(node, opts) {
    assert("JSXExpressionContainer", node, opts);
}
function assertJSXSpreadChild(node, opts) {
    assert("JSXSpreadChild", node, opts);
}
function assertJSXIdentifier(node, opts) {
    assert("JSXIdentifier", node, opts);
}
function assertJSXMemberExpression(node, opts) {
    assert("JSXMemberExpression", node, opts);
}
function assertJSXNamespacedName(node, opts) {
    assert("JSXNamespacedName", node, opts);
}
function assertJSXOpeningElement(node, opts) {
    assert("JSXOpeningElement", node, opts);
}
function assertJSXSpreadAttribute(node, opts) {
    assert("JSXSpreadAttribute", node, opts);
}
function assertJSXText(node, opts) {
    assert("JSXText", node, opts);
}
function assertJSXFragment(node, opts) {
    assert("JSXFragment", node, opts);
}
function assertJSXOpeningFragment(node, opts) {
    assert("JSXOpeningFragment", node, opts);
}
function assertJSXClosingFragment(node, opts) {
    assert("JSXClosingFragment", node, opts);
}
function assertNoop(node, opts) {
    assert("Noop", node, opts);
}
function assertPlaceholder(node, opts) {
    assert("Placeholder", node, opts);
}
function assertV8IntrinsicIdentifier(node, opts) {
    assert("V8IntrinsicIdentifier", node, opts);
}
function assertArgumentPlaceholder(node, opts) {
    assert("ArgumentPlaceholder", node, opts);
}
function assertBindExpression(node, opts) {
    assert("BindExpression", node, opts);
}
function assertImportAttribute(node, opts) {
    assert("ImportAttribute", node, opts);
}
function assertDecorator(node, opts) {
    assert("Decorator", node, opts);
}
function assertDoExpression(node, opts) {
    assert("DoExpression", node, opts);
}
function assertExportDefaultSpecifier(node, opts) {
    assert("ExportDefaultSpecifier", node, opts);
}
function assertRecordExpression(node, opts) {
    assert("RecordExpression", node, opts);
}
function assertTupleExpression(node, opts) {
    assert("TupleExpression", node, opts);
}
function assertDecimalLiteral(node, opts) {
    assert("DecimalLiteral", node, opts);
}
function assertModuleExpression(node, opts) {
    assert("ModuleExpression", node, opts);
}
function assertTopicReference(node, opts) {
    assert("TopicReference", node, opts);
}
function assertPipelineTopicExpression(node, opts) {
    assert("PipelineTopicExpression", node, opts);
}
function assertPipelineBareFunction(node, opts) {
    assert("PipelineBareFunction", node, opts);
}
function assertPipelinePrimaryTopicReference(node, opts) {
    assert("PipelinePrimaryTopicReference", node, opts);
}
function assertTSParameterProperty(node, opts) {
    assert("TSParameterProperty", node, opts);
}
function assertTSDeclareFunction(node, opts) {
    assert("TSDeclareFunction", node, opts);
}
function assertTSDeclareMethod(node, opts) {
    assert("TSDeclareMethod", node, opts);
}
function assertTSQualifiedName(node, opts) {
    assert("TSQualifiedName", node, opts);
}
function assertTSCallSignatureDeclaration(node, opts) {
    assert("TSCallSignatureDeclaration", node, opts);
}
function assertTSConstructSignatureDeclaration(node, opts) {
    assert("TSConstructSignatureDeclaration", node, opts);
}
function assertTSPropertySignature(node, opts) {
    assert("TSPropertySignature", node, opts);
}
function assertTSMethodSignature(node, opts) {
    assert("TSMethodSignature", node, opts);
}
function assertTSIndexSignature(node, opts) {
    assert("TSIndexSignature", node, opts);
}
function assertTSAnyKeyword(node, opts) {
    assert("TSAnyKeyword", node, opts);
}
function assertTSBooleanKeyword(node, opts) {
    assert("TSBooleanKeyword", node, opts);
}
function assertTSBigIntKeyword(node, opts) {
    assert("TSBigIntKeyword", node, opts);
}
function assertTSIntrinsicKeyword(node, opts) {
    assert("TSIntrinsicKeyword", node, opts);
}
function assertTSNeverKeyword(node, opts) {
    assert("TSNeverKeyword", node, opts);
}
function assertTSNullKeyword(node, opts) {
    assert("TSNullKeyword", node, opts);
}
function assertTSNumberKeyword(node, opts) {
    assert("TSNumberKeyword", node, opts);
}
function assertTSObjectKeyword(node, opts) {
    assert("TSObjectKeyword", node, opts);
}
function assertTSStringKeyword(node, opts) {
    assert("TSStringKeyword", node, opts);
}
function assertTSSymbolKeyword(node, opts) {
    assert("TSSymbolKeyword", node, opts);
}
function assertTSUndefinedKeyword(node, opts) {
    assert("TSUndefinedKeyword", node, opts);
}
function assertTSUnknownKeyword(node, opts) {
    assert("TSUnknownKeyword", node, opts);
}
function assertTSVoidKeyword(node, opts) {
    assert("TSVoidKeyword", node, opts);
}
function assertTSThisType(node, opts) {
    assert("TSThisType", node, opts);
}
function assertTSFunctionType(node, opts) {
    assert("TSFunctionType", node, opts);
}
function assertTSConstructorType(node, opts) {
    assert("TSConstructorType", node, opts);
}
function assertTSTypeReference(node, opts) {
    assert("TSTypeReference", node, opts);
}
function assertTSTypePredicate(node, opts) {
    assert("TSTypePredicate", node, opts);
}
function assertTSTypeQuery(node, opts) {
    assert("TSTypeQuery", node, opts);
}
function assertTSTypeLiteral(node, opts) {
    assert("TSTypeLiteral", node, opts);
}
function assertTSArrayType(node, opts) {
    assert("TSArrayType", node, opts);
}
function assertTSTupleType(node, opts) {
    assert("TSTupleType", node, opts);
}
function assertTSOptionalType(node, opts) {
    assert("TSOptionalType", node, opts);
}
function assertTSRestType(node, opts) {
    assert("TSRestType", node, opts);
}
function assertTSNamedTupleMember(node, opts) {
    assert("TSNamedTupleMember", node, opts);
}
function assertTSUnionType(node, opts) {
    assert("TSUnionType", node, opts);
}
function assertTSIntersectionType(node, opts) {
    assert("TSIntersectionType", node, opts);
}
function assertTSConditionalType(node, opts) {
    assert("TSConditionalType", node, opts);
}
function assertTSInferType(node, opts) {
    assert("TSInferType", node, opts);
}
function assertTSParenthesizedType(node, opts) {
    assert("TSParenthesizedType", node, opts);
}
function assertTSTypeOperator(node, opts) {
    assert("TSTypeOperator", node, opts);
}
function assertTSIndexedAccessType(node, opts) {
    assert("TSIndexedAccessType", node, opts);
}
function assertTSMappedType(node, opts) {
    assert("TSMappedType", node, opts);
}
function assertTSLiteralType(node, opts) {
    assert("TSLiteralType", node, opts);
}
function assertTSExpressionWithTypeArguments(node, opts) {
    assert("TSExpressionWithTypeArguments", node, opts);
}
function assertTSInterfaceDeclaration(node, opts) {
    assert("TSInterfaceDeclaration", node, opts);
}
function assertTSInterfaceBody(node, opts) {
    assert("TSInterfaceBody", node, opts);
}
function assertTSTypeAliasDeclaration(node, opts) {
    assert("TSTypeAliasDeclaration", node, opts);
}
function assertTSInstantiationExpression(node, opts) {
    assert("TSInstantiationExpression", node, opts);
}
function assertTSAsExpression(node, opts) {
    assert("TSAsExpression", node, opts);
}
function assertTSSatisfiesExpression(node, opts) {
    assert("TSSatisfiesExpression", node, opts);
}
function assertTSTypeAssertion(node, opts) {
    assert("TSTypeAssertion", node, opts);
}
function assertTSEnumDeclaration(node, opts) {
    assert("TSEnumDeclaration", node, opts);
}
function assertTSEnumMember(node, opts) {
    assert("TSEnumMember", node, opts);
}
function assertTSModuleDeclaration(node, opts) {
    assert("TSModuleDeclaration", node, opts);
}
function assertTSModuleBlock(node, opts) {
    assert("TSModuleBlock", node, opts);
}
function assertTSImportType(node, opts) {
    assert("TSImportType", node, opts);
}
function assertTSImportEqualsDeclaration(node, opts) {
    assert("TSImportEqualsDeclaration", node, opts);
}
function assertTSExternalModuleReference(node, opts) {
    assert("TSExternalModuleReference", node, opts);
}
function assertTSNonNullExpression(node, opts) {
    assert("TSNonNullExpression", node, opts);
}
function assertTSExportAssignment(node, opts) {
    assert("TSExportAssignment", node, opts);
}
function assertTSNamespaceExportDeclaration(node, opts) {
    assert("TSNamespaceExportDeclaration", node, opts);
}
function assertTSTypeAnnotation(node, opts) {
    assert("TSTypeAnnotation", node, opts);
}
function assertTSTypeParameterInstantiation(node, opts) {
    assert("TSTypeParameterInstantiation", node, opts);
}
function assertTSTypeParameterDeclaration(node, opts) {
    assert("TSTypeParameterDeclaration", node, opts);
}
function assertTSTypeParameter(node, opts) {
    assert("TSTypeParameter", node, opts);
}
function assertStandardized(node, opts) {
    assert("Standardized", node, opts);
}
function assertExpression(node, opts) {
    assert("Expression", node, opts);
}
function assertBinary(node, opts) {
    assert("Binary", node, opts);
}
function assertScopable(node, opts) {
    assert("Scopable", node, opts);
}
function assertBlockParent(node, opts) {
    assert("BlockParent", node, opts);
}
function assertBlock(node, opts) {
    assert("Block", node, opts);
}
function assertStatement(node, opts) {
    assert("Statement", node, opts);
}
function assertTerminatorless(node, opts) {
    assert("Terminatorless", node, opts);
}
function assertCompletionStatement(node, opts) {
    assert("CompletionStatement", node, opts);
}
function assertConditional(node, opts) {
    assert("Conditional", node, opts);
}
function assertLoop(node, opts) {
    assert("Loop", node, opts);
}
function assertWhile(node, opts) {
    assert("While", node, opts);
}
function assertExpressionWrapper(node, opts) {
    assert("ExpressionWrapper", node, opts);
}
function assertFor(node, opts) {
    assert("For", node, opts);
}
function assertForXStatement(node, opts) {
    assert("ForXStatement", node, opts);
}
function assertFunction(node, opts) {
    assert("Function", node, opts);
}
function assertFunctionParent(node, opts) {
    assert("FunctionParent", node, opts);
}
function assertPureish(node, opts) {
    assert("Pureish", node, opts);
}
function assertDeclaration(node, opts) {
    assert("Declaration", node, opts);
}
function assertPatternLike(node, opts) {
    assert("PatternLike", node, opts);
}
function assertLVal(node, opts) {
    assert("LVal", node, opts);
}
function assertTSEntityName(node, opts) {
    assert("TSEntityName", node, opts);
}
function assertLiteral(node, opts) {
    assert("Literal", node, opts);
}
function assertImmutable(node, opts) {
    assert("Immutable", node, opts);
}
function assertUserWhitespacable(node, opts) {
    assert("UserWhitespacable", node, opts);
}
function assertMethod(node, opts) {
    assert("Method", node, opts);
}
function assertObjectMember(node, opts) {
    assert("ObjectMember", node, opts);
}
function assertProperty(node, opts) {
    assert("Property", node, opts);
}
function assertUnaryLike(node, opts) {
    assert("UnaryLike", node, opts);
}
function assertPattern(node, opts) {
    assert("Pattern", node, opts);
}
function assertClass(node, opts) {
    assert("Class", node, opts);
}
function assertImportOrExportDeclaration(node, opts) {
    assert("ImportOrExportDeclaration", node, opts);
}
function assertExportDeclaration(node, opts) {
    assert("ExportDeclaration", node, opts);
}
function assertModuleSpecifier(node, opts) {
    assert("ModuleSpecifier", node, opts);
}
function assertAccessor(node, opts) {
    assert("Accessor", node, opts);
}
function assertPrivate(node, opts) {
    assert("Private", node, opts);
}
function assertFlow(node, opts) {
    assert("Flow", node, opts);
}
function assertFlowType(node, opts) {
    assert("FlowType", node, opts);
}
function assertFlowBaseAnnotation(node, opts) {
    assert("FlowBaseAnnotation", node, opts);
}
function assertFlowDeclaration(node, opts) {
    assert("FlowDeclaration", node, opts);
}
function assertFlowPredicate(node, opts) {
    assert("FlowPredicate", node, opts);
}
function assertEnumBody(node, opts) {
    assert("EnumBody", node, opts);
}
function assertEnumMember(node, opts) {
    assert("EnumMember", node, opts);
}
function assertJSX(node, opts) {
    assert("JSX", node, opts);
}
function assertMiscellaneous(node, opts) {
    assert("Miscellaneous", node, opts);
}
function assertTypeScript(node, opts) {
    assert("TypeScript", node, opts);
}
function assertTSTypeElement(node, opts) {
    assert("TSTypeElement", node, opts);
}
function assertTSType(node, opts) {
    assert("TSType", node, opts);
}
function assertTSBaseType(node, opts) {
    assert("TSBaseType", node, opts);
}
function assertNumberLiteral(node, opts) {
    deprecationWarning("assertNumberLiteral", "assertNumericLiteral");
    assert("NumberLiteral", node, opts);
}
function assertRegexLiteral(node, opts) {
    deprecationWarning("assertRegexLiteral", "assertRegExpLiteral");
    assert("RegexLiteral", node, opts);
}
function assertRestProperty(node, opts) {
    deprecationWarning("assertRestProperty", "assertRestElement");
    assert("RestProperty", node, opts);
}
function assertSpreadProperty(node, opts) {
    deprecationWarning("assertSpreadProperty", "assertSpreadElement");
    assert("SpreadProperty", node, opts);
}
function assertModuleDeclaration(node, opts) {
    deprecationWarning("assertModuleDeclaration", "assertImportOrExportDeclaration");
    assert("ModuleDeclaration", node, opts);
}
function createTypeAnnotationBasedOnTypeof(type) {
    switch(type){
        case "string":
            return stringTypeAnnotation();
        case "number":
            return numberTypeAnnotation();
        case "undefined":
            return voidTypeAnnotation();
        case "boolean":
            return booleanTypeAnnotation();
        case "function":
            return genericTypeAnnotation(identifier("Function"));
        case "object":
            return genericTypeAnnotation(identifier("Object"));
        case "symbol":
            return genericTypeAnnotation(identifier("Symbol"));
        case "bigint":
            return anyTypeAnnotation();
    }
    throw new Error("Invalid typeof value: " + type);
}
function getQualifiedName$1(node) {
    return isIdentifier(node) ? node.name : "".concat(node.id.name, ".").concat(getQualifiedName$1(node.qualification));
}
function removeTypeDuplicates$1(nodesIn) {
    var nodes2 = Array.from(nodesIn);
    var generics = /* @__PURE__ */ new Map();
    var bases = /* @__PURE__ */ new Map();
    var typeGroups = /* @__PURE__ */ new Set();
    var types2 = [];
    for(var i = 0; i < nodes2.length; i++){
        var node = nodes2[i];
        if (!node) continue;
        if (types2.indexOf(node) >= 0) {
            continue;
        }
        if (isAnyTypeAnnotation(node)) {
            return [
                node
            ];
        }
        if (isFlowBaseAnnotation(node)) {
            bases.set(node.type, node);
            continue;
        }
        if (isUnionTypeAnnotation(node)) {
            if (!typeGroups.has(node.types)) {
                var _nodes2;
                (_nodes2 = nodes2).push.apply(_nodes2, _to_consumable_array(node.types));
                typeGroups.add(node.types);
            }
            continue;
        }
        if (isGenericTypeAnnotation(node)) {
            var name = getQualifiedName$1(node.id);
            if (generics.has(name)) {
                var existing = generics.get(name);
                if (existing.typeParameters) {
                    if (node.typeParameters) {
                        var _existing_typeParameters_params;
                        (_existing_typeParameters_params = existing.typeParameters.params).push.apply(_existing_typeParameters_params, _to_consumable_array(node.typeParameters.params));
                        existing.typeParameters.params = removeTypeDuplicates$1(existing.typeParameters.params);
                    }
                } else {
                    existing = node.typeParameters;
                }
            } else {
                generics.set(name, node);
            }
            continue;
        }
        types2.push(node);
    }
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = bases[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var _step_value = _sliced_to_array(_step.value, 2), baseType = _step_value[1];
            types2.push(baseType);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = generics[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var _step_value1 = _sliced_to_array(_step1.value, 2), genericName = _step_value1[1];
            types2.push(genericName);
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    return types2;
}
function createFlowUnionType(types2) {
    var flattened = removeTypeDuplicates$1(types2);
    if (flattened.length === 1) {
        return flattened[0];
    } else {
        return unionTypeAnnotation(flattened);
    }
}
function getQualifiedName(node) {
    return isIdentifier(node) ? node.name : "".concat(node.right.name, ".").concat(getQualifiedName(node.left));
}
function removeTypeDuplicates(nodesIn) {
    var nodes2 = Array.from(nodesIn);
    var generics = /* @__PURE__ */ new Map();
    var bases = /* @__PURE__ */ new Map();
    var typeGroups = /* @__PURE__ */ new Set();
    var types2 = [];
    for(var i = 0; i < nodes2.length; i++){
        var node = nodes2[i];
        if (!node) continue;
        if (types2.indexOf(node) >= 0) {
            continue;
        }
        if (isTSAnyKeyword(node)) {
            return [
                node
            ];
        }
        if (isTSBaseType(node)) {
            bases.set(node.type, node);
            continue;
        }
        if (isTSUnionType(node)) {
            if (!typeGroups.has(node.types)) {
                var _nodes2;
                (_nodes2 = nodes2).push.apply(_nodes2, _to_consumable_array(node.types));
                typeGroups.add(node.types);
            }
            continue;
        }
        if (isTSTypeReference(node) && node.typeParameters) {
            var name = getQualifiedName(node.typeName);
            if (generics.has(name)) {
                var existing = generics.get(name);
                if (existing.typeParameters) {
                    if (node.typeParameters) {
                        var _existing_typeParameters_params;
                        (_existing_typeParameters_params = existing.typeParameters.params).push.apply(_existing_typeParameters_params, _to_consumable_array(node.typeParameters.params));
                        existing.typeParameters.params = removeTypeDuplicates(existing.typeParameters.params);
                    }
                } else {
                    existing = node.typeParameters;
                }
            } else {
                generics.set(name, node);
            }
            continue;
        }
        types2.push(node);
    }
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = bases[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var _step_value = _sliced_to_array(_step.value, 2), baseType = _step_value[1];
            types2.push(baseType);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = generics[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var _step_value1 = _sliced_to_array(_step1.value, 2), genericName = _step_value1[1];
            types2.push(genericName);
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    return types2;
}
function createTSUnionType(typeAnnotations) {
    var types2 = typeAnnotations.map(function(type) {
        return isTSTypeAnnotation(type) ? type.typeAnnotation : type;
    });
    var flattened = removeTypeDuplicates(types2);
    if (flattened.length === 1) {
        return flattened[0];
    } else {
        return tsUnionType(flattened);
    }
}
function buildUndefinedNode() {
    return unaryExpression("void", numericLiteral(0), true);
}
var has = Function.call.bind(Object.prototype.hasOwnProperty);
function cloneIfNode(obj, deep, withoutLoc, commentsCache) {
    if (obj && typeof obj.type === "string") {
        return cloneNodeInternal(obj, deep, withoutLoc, commentsCache);
    }
    return obj;
}
function cloneIfNodeOrArray(obj, deep, withoutLoc, commentsCache) {
    if (Array.isArray(obj)) {
        return obj.map(function(node) {
            return cloneIfNode(node, deep, withoutLoc, commentsCache);
        });
    }
    return cloneIfNode(obj, deep, withoutLoc, commentsCache);
}
function cloneNode(node) {
    var deep = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, withoutLoc = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    return cloneNodeInternal(node, deep, withoutLoc, /* @__PURE__ */ new Map());
}
function cloneNodeInternal(node) {
    var deep = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, withoutLoc = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, commentsCache = arguments.length > 3 ? arguments[3] : void 0;
    if (!node) return node;
    var type = node.type;
    var newNode = {
        type: node.type
    };
    if (isIdentifier(node)) {
        newNode.name = node.name;
        if (has(node, "optional") && typeof node.optional === "boolean") {
            newNode.optional = node.optional;
        }
        if (has(node, "typeAnnotation")) {
            newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node.typeAnnotation, true, withoutLoc, commentsCache) : node.typeAnnotation;
        }
    } else if (!has(NODE_FIELDS, type)) {
        throw new Error('Unknown node type: "'.concat(type, '"'));
    } else {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = Object.keys(NODE_FIELDS[type])[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var field = _step.value;
                if (has(node, field)) {
                    if (deep) {
                        newNode[field] = isFile(node) && field === "comments" ? maybeCloneComments(node.comments, deep, withoutLoc, commentsCache) : cloneIfNodeOrArray(node[field], true, withoutLoc, commentsCache);
                    } else {
                        newNode[field] = node[field];
                    }
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    if (has(node, "loc")) {
        if (withoutLoc) {
            newNode.loc = null;
        } else {
            newNode.loc = node.loc;
        }
    }
    if (has(node, "leadingComments")) {
        newNode.leadingComments = maybeCloneComments(node.leadingComments, deep, withoutLoc, commentsCache);
    }
    if (has(node, "innerComments")) {
        newNode.innerComments = maybeCloneComments(node.innerComments, deep, withoutLoc, commentsCache);
    }
    if (has(node, "trailingComments")) {
        newNode.trailingComments = maybeCloneComments(node.trailingComments, deep, withoutLoc, commentsCache);
    }
    if (has(node, "extra")) {
        newNode.extra = Object.assign({}, node.extra);
    }
    return newNode;
}
function maybeCloneComments(comments, deep, withoutLoc, commentsCache) {
    if (!comments || !deep) {
        return comments;
    }
    return comments.map(function(comment) {
        var cache2 = commentsCache.get(comment);
        if (cache2) return cache2;
        var type = comment.type, value1 = comment.value, loc = comment.loc;
        var ret = {
            type: type,
            value: value1,
            loc: loc
        };
        if (withoutLoc) {
            ret.loc = null;
        }
        commentsCache.set(comment, ret);
        return ret;
    });
}
function clone(node) {
    return cloneNode(node, false);
}
function cloneDeep(node) {
    return cloneNode(node);
}
function cloneDeepWithoutLoc(node) {
    return cloneNode(node, true, true);
}
function cloneWithoutLoc(node) {
    return cloneNode(node, false, true);
}
function addComments(node, type, comments) {
    if (!comments || !node) return node;
    var key = "".concat(type, "Comments");
    if (node[key]) {
        if (type === "leading") {
            node[key] = comments.concat(node[key]);
        } else {
            var _node_key;
            (_node_key = node[key]).push.apply(_node_key, _to_consumable_array(comments));
        }
    } else {
        node[key] = comments;
    }
    return node;
}
function addComment(node, type, content, line) {
    return addComments(node, type, [
        {
            type: line ? "CommentLine" : "CommentBlock",
            value: content
        }
    ]);
}
function inherit(key, child, parent) {
    if (child && parent) {
        child[key] = Array.from(new Set([].concat(child[key], parent[key]).filter(Boolean)));
    }
}
function inheritInnerComments(child, parent) {
    inherit("innerComments", child, parent);
}
function inheritLeadingComments(child, parent) {
    inherit("leadingComments", child, parent);
}
function inheritTrailingComments(child, parent) {
    inherit("trailingComments", child, parent);
}
function inheritsComments(child, parent) {
    inheritTrailingComments(child, parent);
    inheritLeadingComments(child, parent);
    inheritInnerComments(child, parent);
    return child;
}
function removeComments(node) {
    COMMENT_KEYS.forEach(function(key) {
        node[key] = null;
    });
    return node;
}
var STANDARDIZED_TYPES = FLIPPED_ALIAS_KEYS["Standardized"];
var EXPRESSION_TYPES = FLIPPED_ALIAS_KEYS["Expression"];
var BINARY_TYPES = FLIPPED_ALIAS_KEYS["Binary"];
var SCOPABLE_TYPES = FLIPPED_ALIAS_KEYS["Scopable"];
var BLOCKPARENT_TYPES = FLIPPED_ALIAS_KEYS["BlockParent"];
var BLOCK_TYPES = FLIPPED_ALIAS_KEYS["Block"];
var STATEMENT_TYPES = FLIPPED_ALIAS_KEYS["Statement"];
var TERMINATORLESS_TYPES = FLIPPED_ALIAS_KEYS["Terminatorless"];
var COMPLETIONSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS["CompletionStatement"];
var CONDITIONAL_TYPES = FLIPPED_ALIAS_KEYS["Conditional"];
var LOOP_TYPES = FLIPPED_ALIAS_KEYS["Loop"];
var WHILE_TYPES = FLIPPED_ALIAS_KEYS["While"];
var EXPRESSIONWRAPPER_TYPES = FLIPPED_ALIAS_KEYS["ExpressionWrapper"];
var FOR_TYPES = FLIPPED_ALIAS_KEYS["For"];
var FORXSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS["ForXStatement"];
var FUNCTION_TYPES = FLIPPED_ALIAS_KEYS["Function"];
var FUNCTIONPARENT_TYPES = FLIPPED_ALIAS_KEYS["FunctionParent"];
var PUREISH_TYPES = FLIPPED_ALIAS_KEYS["Pureish"];
var DECLARATION_TYPES = FLIPPED_ALIAS_KEYS["Declaration"];
var PATTERNLIKE_TYPES = FLIPPED_ALIAS_KEYS["PatternLike"];
var LVAL_TYPES = FLIPPED_ALIAS_KEYS["LVal"];
var TSENTITYNAME_TYPES = FLIPPED_ALIAS_KEYS["TSEntityName"];
var LITERAL_TYPES = FLIPPED_ALIAS_KEYS["Literal"];
var IMMUTABLE_TYPES = FLIPPED_ALIAS_KEYS["Immutable"];
var USERWHITESPACABLE_TYPES = FLIPPED_ALIAS_KEYS["UserWhitespacable"];
var METHOD_TYPES = FLIPPED_ALIAS_KEYS["Method"];
var OBJECTMEMBER_TYPES = FLIPPED_ALIAS_KEYS["ObjectMember"];
var PROPERTY_TYPES = FLIPPED_ALIAS_KEYS["Property"];
var UNARYLIKE_TYPES = FLIPPED_ALIAS_KEYS["UnaryLike"];
var PATTERN_TYPES = FLIPPED_ALIAS_KEYS["Pattern"];
var CLASS_TYPES = FLIPPED_ALIAS_KEYS["Class"];
var IMPORTOREXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS["ImportOrExportDeclaration"];
var EXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS["ExportDeclaration"];
var MODULESPECIFIER_TYPES = FLIPPED_ALIAS_KEYS["ModuleSpecifier"];
var ACCESSOR_TYPES = FLIPPED_ALIAS_KEYS["Accessor"];
var PRIVATE_TYPES = FLIPPED_ALIAS_KEYS["Private"];
var FLOW_TYPES = FLIPPED_ALIAS_KEYS["Flow"];
var FLOWTYPE_TYPES = FLIPPED_ALIAS_KEYS["FlowType"];
var FLOWBASEANNOTATION_TYPES = FLIPPED_ALIAS_KEYS["FlowBaseAnnotation"];
var FLOWDECLARATION_TYPES = FLIPPED_ALIAS_KEYS["FlowDeclaration"];
var FLOWPREDICATE_TYPES = FLIPPED_ALIAS_KEYS["FlowPredicate"];
var ENUMBODY_TYPES = FLIPPED_ALIAS_KEYS["EnumBody"];
var ENUMMEMBER_TYPES = FLIPPED_ALIAS_KEYS["EnumMember"];
var JSX_TYPES = FLIPPED_ALIAS_KEYS["JSX"];
var MISCELLANEOUS_TYPES = FLIPPED_ALIAS_KEYS["Miscellaneous"];
var TYPESCRIPT_TYPES = FLIPPED_ALIAS_KEYS["TypeScript"];
var TSTYPEELEMENT_TYPES = FLIPPED_ALIAS_KEYS["TSTypeElement"];
var TSTYPE_TYPES = FLIPPED_ALIAS_KEYS["TSType"];
var TSBASETYPE_TYPES = FLIPPED_ALIAS_KEYS["TSBaseType"];
var MODULEDECLARATION_TYPES = IMPORTOREXPORTDECLARATION_TYPES;
function toBlock(node, parent) {
    if (isBlockStatement(node)) {
        return node;
    }
    var blockNodes = [];
    if (isEmptyStatement(node)) {
        blockNodes = [];
    } else {
        if (!isStatement(node)) {
            if (isFunction(parent)) {
                node = returnStatement(node);
            } else {
                node = expressionStatement(node);
            }
        }
        blockNodes = [
            node
        ];
    }
    return blockStatement(blockNodes);
}
function ensureBlock(node) {
    var key = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "body";
    var result = toBlock(node[key], node);
    node[key] = result;
    return result;
}
function toIdentifier(input) {
    input = input + "";
    var name = "";
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var c = _step.value;
            name += isIdentifierChar(c.codePointAt(0)) ? c : "-";
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    name = name.replace(/^[-0-9]+/, "");
    name = name.replace(/[-\s]+(.)?/g, function(match, c) {
        return c ? c.toUpperCase() : "";
    });
    if (!isValidIdentifier(name)) {
        name = "_".concat(name);
    }
    return name || "_";
}
function toBindingIdentifierName(name) {
    name = toIdentifier(name);
    if (name === "eval" || name === "arguments") name = "_" + name;
    return name;
}
function toComputedKey(node) {
    var key = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : node.key || node.property;
    if (!node.computed && isIdentifier(key)) key = stringLiteral(key.name);
    return key;
}
function toExpression(node) {
    if (isExpressionStatement(node)) {
        node = node.expression;
    }
    if (isExpression(node)) {
        return node;
    }
    if (isClass(node)) {
        node.type = "ClassExpression";
    } else if (isFunction(node)) {
        node.type = "FunctionExpression";
    }
    if (!isExpression(node)) {
        throw new Error("cannot turn ".concat(node.type, " to an expression"));
    }
    return node;
}
function traverseFast(node, enter, opts) {
    if (!node) return;
    var keys = VISITOR_KEYS[node.type];
    if (!keys) return;
    opts = opts || {};
    enter(node, opts);
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            var subNode = node[key];
            if (Array.isArray(subNode)) {
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = subNode[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var node2 = _step1.value;
                        traverseFast(node2, enter, opts);
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            } else {
                traverseFast(subNode, enter, opts);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}
var CLEAR_KEYS = [
    "tokens",
    "start",
    "end",
    "loc",
    "raw",
    "rawValue"
];
var CLEAR_KEYS_PLUS_COMMENTS = _to_consumable_array(COMMENT_KEYS).concat([
    "comments"
], _to_consumable_array(CLEAR_KEYS));
function removeProperties(node) {
    var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var map = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = map[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            if (node[key] != null) node[key] = void 0;
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = Object.keys(node)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var key1 = _step1.value;
            if (key1[0] === "_" && node[key1] != null) node[key1] = void 0;
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    var symbols = Object.getOwnPropertySymbols(node);
    var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
    try {
        for(var _iterator2 = symbols[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
            var sym = _step2.value;
            node[sym] = null;
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                _iterator2.return();
            }
        } finally{
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }
}
function removePropertiesDeep(tree, opts) {
    traverseFast(tree, removeProperties, opts);
    return tree;
}
function toKeyAlias(node) {
    var key = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : node.key;
    var alias;
    if (node.kind === "method") {
        return toKeyAlias.increment() + "";
    } else if (isIdentifier(key)) {
        alias = key.name;
    } else if (isStringLiteral(key)) {
        alias = JSON.stringify(key.value);
    } else {
        alias = JSON.stringify(removePropertiesDeep(cloneNode(key)));
    }
    if (node.computed) {
        alias = "[".concat(alias, "]");
    }
    if (node.static) {
        alias = "static:".concat(alias);
    }
    return alias;
}
toKeyAlias.uid = 0;
toKeyAlias.increment = function() {
    if (toKeyAlias.uid >= Number.MAX_SAFE_INTEGER) {
        return toKeyAlias.uid = 0;
    } else {
        return toKeyAlias.uid++;
    }
};
function toStatement(node, ignore) {
    if (isStatement(node)) {
        return node;
    }
    var mustHaveId = false;
    var newType;
    if (isClass(node)) {
        mustHaveId = true;
        newType = "ClassDeclaration";
    } else if (isFunction(node)) {
        mustHaveId = true;
        newType = "FunctionDeclaration";
    } else if (isAssignmentExpression(node)) {
        return expressionStatement(node);
    }
    if (mustHaveId && !node.id) {
        newType = false;
    }
    if (!newType) {
        if (ignore) {
            return false;
        } else {
            throw new Error("cannot turn ".concat(node.type, " to a statement"));
        }
    }
    node.type = newType;
    return node;
}
var objectToString = Function.call.bind(Object.prototype.toString);
function isRegExp(value1) {
    return objectToString(value1) === "[object RegExp]";
}
function isPlainObject(value1) {
    if (typeof value1 !== "object" || value1 === null || Object.prototype.toString.call(value1) !== "[object Object]") {
        return false;
    }
    var proto3 = Object.getPrototypeOf(value1);
    return proto3 === null || Object.getPrototypeOf(proto3) === null;
}
function valueToNode(value1) {
    if (value1 === void 0) {
        return identifier("undefined");
    }
    if (value1 === true || value1 === false) {
        return booleanLiteral(value1);
    }
    if (value1 === null) {
        return nullLiteral();
    }
    if (typeof value1 === "string") {
        return stringLiteral(value1);
    }
    if (typeof value1 === "number") {
        var result;
        if (Number.isFinite(value1)) {
            result = numericLiteral(Math.abs(value1));
        } else {
            var numerator;
            if (Number.isNaN(value1)) {
                numerator = numericLiteral(0);
            } else {
                numerator = numericLiteral(1);
            }
            result = binaryExpression("/", numerator, numericLiteral(0));
        }
        if (value1 < 0 || Object.is(value1, -0)) {
            result = unaryExpression("-", result);
        }
        return result;
    }
    if (isRegExp(value1)) {
        var pattern = value1.source;
        var flags = value1.toString().match(/\/([a-z]+|)$/)[1];
        return regExpLiteral(pattern, flags);
    }
    if (Array.isArray(value1)) {
        return arrayExpression(value1.map(valueToNode));
    }
    if (isPlainObject(value1)) {
        var props = [];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = Object.keys(value1)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var key = _step.value;
                var nodeKey = void 0;
                if (isValidIdentifier(key)) {
                    nodeKey = identifier(key);
                } else {
                    nodeKey = stringLiteral(key);
                }
                props.push(objectProperty(nodeKey, valueToNode(value1[key])));
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return objectExpression(props);
    }
    throw new Error("don't know how to turn this value into a node");
}
function appendToMemberExpression(member, append) {
    var computed = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    member.object = memberExpression(member.object, member.property, member.computed);
    member.property = append;
    member.computed = !!computed;
    return member;
}
function inherits(child, parent) {
    if (!child || !parent) return child;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = INHERIT_KEYS.optional[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            if (child[key] == null) {
                child[key] = parent[key];
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = Object.keys(parent)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var key1 = _step1.value;
            if (key1[0] === "_" && key1 !== "__clone") {
                child[key1] = parent[key1];
            }
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
    try {
        for(var _iterator2 = INHERIT_KEYS.force[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
            var key2 = _step2.value;
            child[key2] = parent[key2];
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                _iterator2.return();
            }
        } finally{
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }
    inheritsComments(child, parent);
    return child;
}
function prependToMemberExpression(member, prepend) {
    if (isSuper(member.object)) {
        throw new Error("Cannot prepend node to super property access (`super.foo`).");
    }
    member.object = memberExpression(prepend, member.object);
    return member;
}
function getBindingIdentifiers(node, duplicates, outerOnly, newBindingsOnly) {
    var search = [].concat(node);
    var ids = /* @__PURE__ */ Object.create(null);
    while(search.length){
        var id = search.shift();
        if (!id) continue;
        if (newBindingsOnly && (isAssignmentExpression(id) || isUnaryExpression(id))) {
            continue;
        }
        var keys = getBindingIdentifiers.keys[id.type];
        if (isIdentifier(id)) {
            if (duplicates) {
                var _ids = ids[id.name] = ids[id.name] || [];
                _ids.push(id);
            } else {
                ids[id.name] = id;
            }
            continue;
        }
        if (isExportDeclaration(id) && !isExportAllDeclaration(id)) {
            if (isDeclaration(id.declaration)) {
                search.push(id.declaration);
            }
            continue;
        }
        if (outerOnly) {
            if (isFunctionDeclaration(id)) {
                search.push(id.id);
                continue;
            }
            if (isFunctionExpression(id)) {
                continue;
            }
        }
        if (keys) {
            for(var i = 0; i < keys.length; i++){
                var key = keys[i];
                var nodes2 = id[key];
                if (nodes2) {
                    var _search;
                    Array.isArray(nodes2) ? (_search = search).push.apply(_search, _to_consumable_array(nodes2)) : search.push(nodes2);
                }
            }
        }
    }
    return ids;
}
getBindingIdentifiers.keys = {
    DeclareClass: [
        "id"
    ],
    DeclareFunction: [
        "id"
    ],
    DeclareModule: [
        "id"
    ],
    DeclareVariable: [
        "id"
    ],
    DeclareInterface: [
        "id"
    ],
    DeclareTypeAlias: [
        "id"
    ],
    DeclareOpaqueType: [
        "id"
    ],
    InterfaceDeclaration: [
        "id"
    ],
    TypeAlias: [
        "id"
    ],
    OpaqueType: [
        "id"
    ],
    CatchClause: [
        "param"
    ],
    LabeledStatement: [
        "label"
    ],
    UnaryExpression: [
        "argument"
    ],
    AssignmentExpression: [
        "left"
    ],
    ImportSpecifier: [
        "local"
    ],
    ImportNamespaceSpecifier: [
        "local"
    ],
    ImportDefaultSpecifier: [
        "local"
    ],
    ImportDeclaration: [
        "specifiers"
    ],
    ExportSpecifier: [
        "exported"
    ],
    ExportNamespaceSpecifier: [
        "exported"
    ],
    ExportDefaultSpecifier: [
        "exported"
    ],
    FunctionDeclaration: [
        "id",
        "params"
    ],
    FunctionExpression: [
        "id",
        "params"
    ],
    ArrowFunctionExpression: [
        "params"
    ],
    ObjectMethod: [
        "params"
    ],
    ClassMethod: [
        "params"
    ],
    ClassPrivateMethod: [
        "params"
    ],
    ForInStatement: [
        "left"
    ],
    ForOfStatement: [
        "left"
    ],
    ClassDeclaration: [
        "id"
    ],
    ClassExpression: [
        "id"
    ],
    RestElement: [
        "argument"
    ],
    UpdateExpression: [
        "argument"
    ],
    ObjectProperty: [
        "value"
    ],
    AssignmentPattern: [
        "left"
    ],
    ArrayPattern: [
        "elements"
    ],
    ObjectPattern: [
        "properties"
    ],
    VariableDeclaration: [
        "declarations"
    ],
    VariableDeclarator: [
        "id"
    ]
};
function getOuterBindingIdentifiers(node, duplicates) {
    return getBindingIdentifiers(node, duplicates, true);
}
function traverse(node, handlers, state) {
    if (typeof handlers === "function") {
        handlers = {
            enter: handlers
        };
    }
    var enter = handlers.enter, exit = handlers.exit;
    traverseSimpleImpl(node, enter, exit, state, []);
}
function traverseSimpleImpl(node, enter, exit, state, ancestors) {
    var keys = VISITOR_KEYS[node.type];
    if (!keys) return;
    if (enter) enter(node, ancestors, state);
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            var subNode = node[key];
            if (Array.isArray(subNode)) {
                for(var i = 0; i < subNode.length; i++){
                    var child = subNode[i];
                    if (!child) continue;
                    ancestors.push({
                        node: node,
                        key: key,
                        index: i
                    });
                    traverseSimpleImpl(child, enter, exit, state, ancestors);
                    ancestors.pop();
                }
            } else if (subNode) {
                ancestors.push({
                    node: node,
                    key: key
                });
                traverseSimpleImpl(subNode, enter, exit, state, ancestors);
                ancestors.pop();
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    if (exit) exit(node, ancestors, state);
}
function isBinding(node, parent, grandparent) {
    if (grandparent && node.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
        return false;
    }
    var keys = getBindingIdentifiers.keys[parent.type];
    if (keys) {
        for(var i = 0; i < keys.length; i++){
            var key = keys[i];
            var val = parent[key];
            if (Array.isArray(val)) {
                if (val.indexOf(node) >= 0) return true;
            } else {
                if (val === node) return true;
            }
        }
    }
    return false;
}
function isLet(node) {
    return isVariableDeclaration(node) && (node.kind !== "var" || node[BLOCK_SCOPED_SYMBOL]);
}
function isBlockScoped(node) {
    return isFunctionDeclaration(node) || isClassDeclaration(node) || isLet(node);
}
function isImmutable(node) {
    if (isType(node.type, "Immutable")) return true;
    if (isIdentifier(node)) {
        if (node.name === "undefined") {
            return true;
        } else {
            return false;
        }
    }
    return false;
}
function isNodesEquivalent(a, b) {
    if (typeof a !== "object" || typeof b !== "object" || a == null || b == null) {
        return a === b;
    }
    if (a.type !== b.type) {
        return false;
    }
    var fields = Object.keys(NODE_FIELDS[a.type] || a.type);
    var visitorKeys = VISITOR_KEYS[a.type];
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var field = _step.value;
            var val_a = a[field];
            var val_b = b[field];
            if ((typeof val_a === "undefined" ? "undefined" : _type_of(val_a)) !== (typeof val_b === "undefined" ? "undefined" : _type_of(val_b))) {
                return false;
            }
            if (val_a == null && val_b == null) {
                continue;
            } else if (val_a == null || val_b == null) {
                return false;
            }
            if (Array.isArray(val_a)) {
                if (!Array.isArray(val_b)) {
                    return false;
                }
                if (val_a.length !== val_b.length) {
                    return false;
                }
                for(var i = 0; i < val_a.length; i++){
                    if (!isNodesEquivalent(val_a[i], val_b[i])) {
                        return false;
                    }
                }
                continue;
            }
            if (typeof val_a === "object" && !(visitorKeys === null || visitorKeys === void 0 ? void 0 : visitorKeys.includes(field))) {
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = Object.keys(val_a)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var key = _step1.value;
                        if (val_a[key] !== val_b[key]) {
                            return false;
                        }
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
                continue;
            }
            if (!isNodesEquivalent(val_a, val_b)) {
                return false;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return true;
}
function isReferenced(node, parent, grandparent) {
    switch(parent.type){
        case "MemberExpression":
        case "OptionalMemberExpression":
            if (parent.property === node) {
                return !!parent.computed;
            }
            return parent.object === node;
        case "JSXMemberExpression":
            return parent.object === node;
        case "VariableDeclarator":
            return parent.init === node;
        case "ArrowFunctionExpression":
            return parent.body === node;
        case "PrivateName":
            return false;
        case "ClassMethod":
        case "ClassPrivateMethod":
        case "ObjectMethod":
            if (parent.key === node) {
                return !!parent.computed;
            }
            return false;
        case "ObjectProperty":
            if (parent.key === node) {
                return !!parent.computed;
            }
            return !grandparent || grandparent.type !== "ObjectPattern";
        case "ClassProperty":
        case "ClassAccessorProperty":
            if (parent.key === node) {
                return !!parent.computed;
            }
            return true;
        case "ClassPrivateProperty":
            return parent.key !== node;
        case "ClassDeclaration":
        case "ClassExpression":
            return parent.superClass === node;
        case "AssignmentExpression":
            return parent.right === node;
        case "AssignmentPattern":
            return parent.right === node;
        case "LabeledStatement":
            return false;
        case "CatchClause":
            return false;
        case "RestElement":
            return false;
        case "BreakStatement":
        case "ContinueStatement":
            return false;
        case "FunctionDeclaration":
        case "FunctionExpression":
            return false;
        case "ExportNamespaceSpecifier":
        case "ExportDefaultSpecifier":
            return false;
        case "ExportSpecifier":
            if (grandparent === null || grandparent === void 0 ? void 0 : grandparent.source) {
                return false;
            }
            return parent.local === node;
        case "ImportDefaultSpecifier":
        case "ImportNamespaceSpecifier":
        case "ImportSpecifier":
            return false;
        case "ImportAttribute":
            return false;
        case "JSXAttribute":
            return false;
        case "ObjectPattern":
        case "ArrayPattern":
            return false;
        case "MetaProperty":
            return false;
        case "ObjectTypeProperty":
            return parent.key !== node;
        case "TSEnumMember":
            return parent.id !== node;
        case "TSPropertySignature":
            if (parent.key === node) {
                return !!parent.computed;
            }
            return true;
    }
    return true;
}
function isScope(node, parent) {
    if (isBlockStatement(node) && (isFunction(parent) || isCatchClause(parent))) {
        return false;
    }
    if (isPattern(node) && (isFunction(parent) || isCatchClause(parent))) {
        return true;
    }
    return isScopable(node);
}
function isSpecifierDefault(specifier) {
    return isImportDefaultSpecifier(specifier) || isIdentifier(specifier.imported || specifier.exported, {
        name: "default"
    });
}
var RESERVED_WORDS_ES3_ONLY = /* @__PURE__ */ new Set([
    "abstract",
    "boolean",
    "byte",
    "char",
    "double",
    "enum",
    "final",
    "float",
    "goto",
    "implements",
    "int",
    "interface",
    "long",
    "native",
    "package",
    "private",
    "protected",
    "public",
    "short",
    "static",
    "synchronized",
    "throws",
    "transient",
    "volatile"
]);
function isValidES3Identifier(name) {
    return isValidIdentifier(name) && !RESERVED_WORDS_ES3_ONLY.has(name);
}
function isVar(node) {
    return isVariableDeclaration(node, {
        kind: "var"
    }) && !node[BLOCK_SCOPED_SYMBOL];
}
var react = {
    isReactComponent: isReactComponent,
    isCompatTag: isCompatTag,
    buildChildren: buildChildren
};
// node_modules/@babel/parser/lib/index.js
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var Position = function Position(line, col, index3) {
    "use strict";
    _class_call_check(this, Position);
    __publicField(this, "line");
    __publicField(this, "column");
    __publicField(this, "index");
    this.line = line;
    this.column = col;
    this.index = index3;
};
var SourceLocation = function SourceLocation(start, end) {
    "use strict";
    _class_call_check(this, SourceLocation);
    __publicField(this, "start");
    __publicField(this, "end");
    __publicField(this, "filename");
    __publicField(this, "identifierName");
    this.start = start;
    this.end = end;
};
function createPositionWithColumnOffset(position, columnOffset) {
    var line = position.line, column = position.column, index3 = position.index;
    return new Position(line, column + columnOffset, index3 + columnOffset);
}
var code = "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED";
var ModuleErrors = {
    ImportMetaOutsideModule: {
        message: "import.meta may appear only with 'sourceType: \"module\"'",
        code: code
    },
    ImportOutsideModule: {
        message: "'import' and 'export' may appear only with 'sourceType: \"module\"'",
        code: code
    }
};
var NodeDescriptions = {
    ArrayPattern: "array destructuring pattern",
    AssignmentExpression: "assignment expression",
    AssignmentPattern: "assignment expression",
    ArrowFunctionExpression: "arrow function expression",
    ConditionalExpression: "conditional expression",
    CatchClause: "catch clause",
    ForOfStatement: "for-of statement",
    ForInStatement: "for-in statement",
    ForStatement: "for-loop",
    FormalParameters: "function parameter list",
    Identifier: "identifier",
    ImportSpecifier: "import specifier",
    ImportDefaultSpecifier: "import default specifier",
    ImportNamespaceSpecifier: "import namespace specifier",
    ObjectPattern: "object destructuring pattern",
    ParenthesizedExpression: "parenthesized expression",
    RestElement: "rest element",
    UpdateExpression: {
        true: "prefix operation",
        false: "postfix operation"
    },
    VariableDeclarator: "variable declaration",
    YieldExpression: "yield expression"
};
var toNodeDescription = function(param) {
    var type = param.type, prefix2 = param.prefix;
    return type === "UpdateExpression" ? NodeDescriptions.UpdateExpression[String(prefix2)] : NodeDescriptions[type];
};
var StandardErrors = {
    AccessorIsGenerator: function(param) {
        var kind = param.kind;
        return "A ".concat(kind, "ter cannot be a generator.");
    },
    ArgumentsInClass: "'arguments' is only allowed in functions and class methods.",
    AsyncFunctionInSingleStatementContext: "Async functions can only be declared at the top level or inside a block.",
    AwaitBindingIdentifier: "Can not use 'await' as identifier inside an async function.",
    AwaitBindingIdentifierInStaticBlock: "Can not use 'await' as identifier inside a static block.",
    AwaitExpressionFormalParameter: "'await' is not allowed in async function parameters.",
    AwaitUsingNotInAsyncContext: "'await using' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncContext: "'await' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
    BadSetterRestParameter: "A 'set' accessor function argument must not be a rest parameter.",
    ConstructorClassField: "Classes may not have a field named 'constructor'.",
    ConstructorClassPrivateField: "Classes may not have a private field named '#constructor'.",
    ConstructorIsAccessor: "Class constructor may not be an accessor.",
    ConstructorIsAsync: "Constructor can't be an async function.",
    ConstructorIsGenerator: "Constructor can't be a generator.",
    DeclarationMissingInitializer: function(param) {
        var kind = param.kind;
        return "Missing initializer in ".concat(kind, " declaration.");
    },
    DecoratorArgumentsOutsideParentheses: "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
    DecoratorBeforeExport: "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
    DecoratorsBeforeAfterExport: "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
    DecoratorConstructor: "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
    DecoratorExportClass: "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
    DecoratorSemicolon: "Decorators must not be followed by a semicolon.",
    DecoratorStaticBlock: "Decorators can't be used with a static block.",
    DeferImportRequiresNamespace: 'Only `import defer * as x from "./module"` is valid.',
    DeletePrivateField: "Deleting a private field is not allowed.",
    DestructureNamedImport: "ES2015 named imports do not destructure. Use another statement for destructuring after the import.",
    DuplicateConstructor: "Duplicate constructor in the same class.",
    DuplicateDefaultExport: "Only one default export allowed per module.",
    DuplicateExport: function(param) {
        var exportName = param.exportName;
        return "`".concat(exportName, "` has already been exported. Exported identifiers must be unique.");
    },
    DuplicateProto: "Redefinition of __proto__ property.",
    DuplicateRegExpFlags: "Duplicate regular expression flag.",
    DynamicImportPhaseRequiresImportExpressions: function(param) {
        var phase = param.phase;
        return "'import.".concat(phase, "(...)' can only be parsed when using the 'createImportExpressions' option.");
    },
    ElementAfterRest: "Rest element must be last element.",
    EscapedCharNotAnIdentifier: "Invalid Unicode escape.",
    ExportBindingIsString: function(param) {
        var localName = param.localName, exportName = param.exportName;
        return "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '".concat(localName, "' as '").concat(exportName, "' } from 'some-module'`?");
    },
    ExportDefaultFromAsIdentifier: "'from' is not allowed as an identifier after 'export default'.",
    ForInOfLoopInitializer: function(param) {
        var type = param.type;
        return "'".concat(type === "ForInStatement" ? "for-in" : "for-of", "' loop variable declaration may not have an initializer.");
    },
    ForInUsing: "For-in loop may not start with 'using' declaration.",
    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
    GeneratorInSingleStatementContext: "Generators can only be declared at the top level or inside a block.",
    IllegalBreakContinue: function(param) {
        var type = param.type;
        return "Unsyntactic ".concat(type === "BreakStatement" ? "break" : "continue", ".");
    },
    IllegalLanguageModeDirective: "Illegal 'use strict' directive in function with non-simple parameter list.",
    IllegalReturn: "'return' outside of function.",
    ImportAttributesUseAssert: "The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedAssertSyntax: true` option in the import attributes plugin to suppress this error.",
    ImportBindingIsString: function(param) {
        var importName = param.importName;
        return 'A string literal cannot be used as an imported binding.\n- Did you mean `import { "'.concat(importName, '" as foo }`?');
    },
    ImportCallArgumentTrailingComma: "Trailing comma is disallowed inside import(...) arguments.",
    ImportCallArity: function(param) {
        var maxArgumentCount = param.maxArgumentCount;
        return "`import()` requires exactly ".concat(maxArgumentCount === 1 ? "one argument" : "one or two arguments", ".");
    },
    ImportCallNotNewExpression: "Cannot use new with import(...).",
    ImportCallSpreadArgument: "`...` is not allowed in `import()`.",
    ImportJSONBindingNotDefault: "A JSON module can only be imported with `default`.",
    ImportReflectionHasAssertion: "`import module x` cannot have assertions.",
    ImportReflectionNotBinding: 'Only `import module x from "./module"` is valid.',
    IncompatibleRegExpUVFlags: "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
    InvalidBigIntLiteral: "Invalid BigIntLiteral.",
    InvalidCodePoint: "Code point out of bounds.",
    InvalidCoverInitializedName: "Invalid shorthand property initializer.",
    InvalidDecimal: "Invalid decimal.",
    InvalidDigit: function(param) {
        var radix = param.radix;
        return "Expected number in radix ".concat(radix, ".");
    },
    InvalidEscapeSequence: "Bad character escape sequence.",
    InvalidEscapeSequenceTemplate: "Invalid escape sequence in template.",
    InvalidEscapedReservedWord: function(param) {
        var reservedWord = param.reservedWord;
        return "Escape sequence in keyword ".concat(reservedWord, ".");
    },
    InvalidIdentifier: function(param) {
        var identifierName = param.identifierName;
        return "Invalid identifier ".concat(identifierName, ".");
    },
    InvalidLhs: function(param) {
        var ancestor = param.ancestor;
        return "Invalid left-hand side in ".concat(toNodeDescription(ancestor), ".");
    },
    InvalidLhsBinding: function(param) {
        var ancestor = param.ancestor;
        return "Binding invalid left-hand side in ".concat(toNodeDescription(ancestor), ".");
    },
    InvalidLhsOptionalChaining: function(param) {
        var ancestor = param.ancestor;
        return "Invalid optional chaining in the left-hand side of ".concat(toNodeDescription(ancestor), ".");
    },
    InvalidNumber: "Invalid number.",
    InvalidOrMissingExponent: "Floating-point numbers require a valid exponent after the 'e'.",
    InvalidOrUnexpectedToken: function(param) {
        var unexpected = param.unexpected;
        return "Unexpected character '".concat(unexpected, "'.");
    },
    InvalidParenthesizedAssignment: "Invalid parenthesized assignment pattern.",
    InvalidPrivateFieldResolution: function(param) {
        var identifierName = param.identifierName;
        return "Private name #".concat(identifierName, " is not defined.");
    },
    InvalidPropertyBindingPattern: "Binding member expression.",
    InvalidRecordProperty: "Only properties and spread elements are allowed in record definitions.",
    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
    LabelRedeclaration: function(param) {
        var labelName = param.labelName;
        return "Label '".concat(labelName, "' is already declared.");
    },
    LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
    MalformedRegExpFlags: "Invalid regular expression flag.",
    MissingClassName: "A class name is required.",
    MissingEqInAssignment: "Only '=' operator can be used for specifying default value.",
    MissingSemicolon: "Missing semicolon.",
    MissingPlugin: function(param) {
        var missingPlugin = param.missingPlugin;
        return "This experimental syntax requires enabling the parser plugin: ".concat(missingPlugin.map(function(name) {
            return JSON.stringify(name);
        }).join(", "), ".");
    },
    MissingOneOfPlugins: function(param) {
        var missingPlugin = param.missingPlugin;
        return "This experimental syntax requires enabling one of the following parser plugin(s): ".concat(missingPlugin.map(function(name) {
            return JSON.stringify(name);
        }).join(", "), ".");
    },
    MissingUnicodeEscape: "Expecting Unicode escape sequence \\uXXXX.",
    MixingCoalesceWithLogical: "Nullish coalescing operator(??) requires parens when mixing with logical operators.",
    ModuleAttributeDifferentFromType: "The only accepted module attribute is `type`.",
    ModuleAttributeInvalidValue: "Only string literals are allowed as module attribute values.",
    ModuleAttributesWithDuplicateKeys: function(param) {
        var key = param.key;
        return 'Duplicate key "'.concat(key, '" is not allowed in module attributes.');
    },
    ModuleExportNameHasLoneSurrogate: function(param) {
        var surrogateCharCode = param.surrogateCharCode;
        return "An export name cannot include a lone surrogate, found '\\u".concat(surrogateCharCode.toString(16), "'.");
    },
    ModuleExportUndefined: function(param) {
        var localName = param.localName;
        return "Export '".concat(localName, "' is not defined.");
    },
    MultipleDefaultsInSwitch: "Multiple default clauses.",
    NewlineAfterThrow: "Illegal newline after throw.",
    NoCatchOrFinally: "Missing catch or finally clause.",
    NumberIdentifier: "Identifier directly after number.",
    NumericSeparatorInEscapeSequence: "Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.",
    ObsoleteAwaitStar: "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
    OptionalChainingNoNew: "Constructors in/after an Optional Chain are not allowed.",
    OptionalChainingNoTemplate: "Tagged Template Literals are not allowed in optionalChain.",
    OverrideOnConstructor: "'override' modifier cannot appear on a constructor declaration.",
    ParamDupe: "Argument name clash.",
    PatternHasAccessor: "Object pattern can't contain getter or setter.",
    PatternHasMethod: "Object pattern can't contain methods.",
    PrivateInExpectedIn: function(param) {
        var identifierName = param.identifierName;
        return "Private names are only allowed in property accesses (`obj.#".concat(identifierName, "`) or in `in` expressions (`#").concat(identifierName, " in obj`).");
    },
    PrivateNameRedeclaration: function(param) {
        var identifierName = param.identifierName;
        return "Duplicate private name #".concat(identifierName, ".");
    },
    RecordExpressionBarIncorrectEndSyntaxType: "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionBarIncorrectStartSyntaxType: "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionHashIncorrectStartSyntaxType: "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
    RestTrailingComma: "Unexpected trailing comma after rest element.",
    SloppyFunction: "In non-strict mode code, functions can only be declared at top level or inside a block.",
    SloppyFunctionAnnexB: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.",
    SourcePhaseImportRequiresDefault: 'Only `import source x from "./module"` is valid.',
    StaticPrototype: "Classes may not have static property named prototype.",
    SuperNotAllowed: "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
    SuperPrivateField: "Private fields can't be accessed on super.",
    TrailingDecorator: "Decorators must be attached to a class element.",
    TupleExpressionBarIncorrectEndSyntaxType: "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionBarIncorrectStartSyntaxType: "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionHashIncorrectStartSyntaxType: "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    UnexpectedArgumentPlaceholder: "Unexpected argument placeholder.",
    UnexpectedAwaitAfterPipelineBody: 'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
    UnexpectedDigitAfterHash: "Unexpected digit after hash token.",
    UnexpectedImportExport: "'import' and 'export' may only appear at the top level.",
    UnexpectedKeyword: function(param) {
        var keyword = param.keyword;
        return "Unexpected keyword '".concat(keyword, "'.");
    },
    UnexpectedLeadingDecorator: "Leading decorators must be attached to a class declaration.",
    UnexpectedLexicalDeclaration: "Lexical declaration cannot appear in a single-statement context.",
    UnexpectedNewTarget: "`new.target` can only be used in functions or class properties.",
    UnexpectedNumericSeparator: "A numeric separator is only allowed between two digits.",
    UnexpectedPrivateField: "Unexpected private name.",
    UnexpectedReservedWord: function(param) {
        var reservedWord = param.reservedWord;
        return "Unexpected reserved word '".concat(reservedWord, "'.");
    },
    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
    UnexpectedToken: function(param) {
        var expected = param.expected, unexpected = param.unexpected;
        return "Unexpected token".concat(unexpected ? " '".concat(unexpected, "'.") : "").concat(expected ? ', expected "'.concat(expected, '"') : "");
    },
    UnexpectedTokenUnaryExponentiation: "Illegal expression. Wrap left hand side or entire exponentiation in parentheses.",
    UnexpectedUsingDeclaration: "Using declaration cannot appear in the top level when source type is `script`.",
    UnsupportedBind: "Binding should be performed on object property.",
    UnsupportedDecoratorExport: "A decorated export must export a class declaration.",
    UnsupportedDefaultExport: "Only expressions, functions or classes are allowed as the `default` export.",
    UnsupportedImport: "`import` can only be used in `import()` or `import.meta`.",
    UnsupportedMetaProperty: function(param) {
        var target = param.target, onlyValidPropertyName = param.onlyValidPropertyName;
        return "The only valid meta property for ".concat(target, " is ").concat(target, ".").concat(onlyValidPropertyName, ".");
    },
    UnsupportedParameterDecorator: "Decorators cannot be used to decorate parameters.",
    UnsupportedPropertyDecorator: "Decorators cannot be used to decorate object literal properties.",
    UnsupportedSuper: "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
    UnterminatedComment: "Unterminated comment.",
    UnterminatedRegExp: "Unterminated regular expression.",
    UnterminatedString: "Unterminated string constant.",
    UnterminatedTemplate: "Unterminated template.",
    UsingDeclarationHasBindingPattern: "Using declaration cannot have destructuring patterns.",
    VarRedeclaration: function(param) {
        var identifierName = param.identifierName;
        return "Identifier '".concat(identifierName, "' has already been declared.");
    },
    YieldBindingIdentifier: "Can not use 'yield' as identifier inside a generator.",
    YieldInParameter: "Yield expression is not allowed in formal parameters.",
    ZeroDigitNumericSeparator: "Numeric separator can not be used after leading 0."
};
var StrictModeErrors = {
    StrictDelete: "Deleting local variable in strict mode.",
    StrictEvalArguments: function(param) {
        var referenceName = param.referenceName;
        return "Assigning to '".concat(referenceName, "' in strict mode.");
    },
    StrictEvalArgumentsBinding: function(param) {
        var bindingName = param.bindingName;
        return "Binding '".concat(bindingName, "' in strict mode.");
    },
    StrictFunction: "In strict mode code, functions can only be declared at top level or inside a block.",
    StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
    StrictOctalLiteral: "Legacy octal literals are not allowed in strict mode.",
    StrictWith: "'with' in strict mode."
};
var UnparenthesizedPipeBodyDescriptions = /* @__PURE__ */ new Set([
    "ArrowFunctionExpression",
    "AssignmentExpression",
    "ConditionalExpression",
    "YieldExpression"
]);
var PipelineOperatorErrors = {
    PipeBodyIsTighter: "Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.",
    PipeTopicRequiresHackPipes: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
    PipeTopicUnbound: "Topic reference is unbound; it must be inside a pipe body.",
    PipeTopicUnconfiguredToken: function(param) {
        var token = param.token;
        return "Invalid topic token ".concat(token, ". In order to use ").concat(token, ' as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "').concat(token, '" }.');
    },
    PipeTopicUnused: "Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.",
    PipeUnparenthesizedBody: function(param) {
        var type = param.type;
        return "Hack-style pipe body cannot be an unparenthesized ".concat(toNodeDescription({
            type: type
        }), "; please wrap it in parentheses.");
    },
    PipelineBodyNoArrow: 'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
    PipelineBodySequenceExpression: "Pipeline body may not be a comma-separated sequence expression.",
    PipelineHeadSequenceExpression: "Pipeline head should not be a comma-separated sequence expression.",
    PipelineTopicUnused: "Pipeline is in topic style but does not use topic reference.",
    PrimaryTopicNotAllowed: "Topic reference was used in a lexical context without topic binding.",
    PrimaryTopicRequiresSmartPipeline: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'
};
var _excluded = [
    "toMessage"
];
var _excluded2 = [
    "message"
];
function defineHidden(obj, key, value1) {
    Object.defineProperty(obj, key, {
        enumerable: false,
        configurable: true,
        value: value1
    });
}
function toParseErrorConstructor(_ref) {
    var toMessage = _ref.toMessage, properties = _objectWithoutPropertiesLoose(_ref, _excluded);
    return function constructor(loc, details) {
        var error = new SyntaxError();
        Object.assign(error, properties, {
            loc: loc,
            pos: loc.index
        });
        if ("missingPlugin" in details) {
            Object.assign(error, {
                missingPlugin: details.missingPlugin
            });
        }
        defineHidden(error, "clone", function clone3() {
            var overrides = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            var _overrides_loc;
            var _$_ref = (_overrides_loc = overrides.loc) !== null && _overrides_loc !== void 0 ? _overrides_loc : loc, line = _$_ref.line, column = _$_ref.column, index3 = _$_ref.index;
            return constructor(new Position(line, column, index3), Object.assign({}, details, overrides.details));
        });
        defineHidden(error, "details", details);
        Object.defineProperty(error, "message", {
            configurable: true,
            get: function get() {
                var message = "".concat(toMessage(details), " (").concat(loc.line, ":").concat(loc.column, ")");
                this.message = message;
                return message;
            },
            set: function set(value1) {
                Object.defineProperty(this, "message", {
                    value: value1,
                    writable: true
                });
            }
        });
        return error;
    };
}
function ParseErrorEnum(argument, syntaxPlugin) {
    if (Array.isArray(argument)) {
        return function(parseErrorTemplates) {
            return ParseErrorEnum(parseErrorTemplates, argument[0]);
        };
    }
    var ParseErrorConstructors = {};
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        var _loop = function() {
            var reasonCode = _step.value;
            var _$template = argument[reasonCode];
            var _ref2 = typeof _$template === "string" ? {
                message: function() {
                    return _$template;
                }
            } : typeof _$template === "function" ? {
                message: _$template
            } : _$template, message = _ref2.message, rest = _objectWithoutPropertiesLoose(_ref2, _excluded2);
            var toMessage = typeof message === "string" ? function() {
                return message;
            } : message;
            ParseErrorConstructors[reasonCode] = toParseErrorConstructor(Object.assign({
                code: "BABEL_PARSER_SYNTAX_ERROR",
                reasonCode: reasonCode,
                toMessage: toMessage
            }, syntaxPlugin ? {
                syntaxPlugin: syntaxPlugin
            } : {}, rest));
        };
        for(var _iterator = Object.keys(argument)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return ParseErrorConstructors;
}
var Errors = Object.assign({}, ParseErrorEnum(ModuleErrors), ParseErrorEnum(StandardErrors), ParseErrorEnum(StrictModeErrors), ParseErrorEnum(_templateObject())(PipelineOperatorErrors));
var defineProperty = Object.defineProperty;
var toUnenumerable = function(object, key) {
    return defineProperty(object, key, {
        enumerable: false,
        value: object[key]
    });
};
function toESTreeLocation(node) {
    node.loc.start && toUnenumerable(node.loc.start, "index");
    node.loc.end && toUnenumerable(node.loc.end, "index");
    return node;
}
var estree = function(superClass) {
    var ESTreeParserMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(ESTreeParserMixin, superClass);
        var _super = _create_super(ESTreeParserMixin);
        function ESTreeParserMixin() {
            _class_call_check(this, ESTreeParserMixin);
            return _super.apply(this, arguments);
        }
        _create_class(ESTreeParserMixin, [
            {
                key: "parse",
                value: function parse() {
                    var file2 = toESTreeLocation(_get(_get_prototype_of(ESTreeParserMixin.prototype), "parse", this).call(this));
                    if (this.options.tokens) {
                        file2.tokens = file2.tokens.map(toESTreeLocation);
                    }
                    return file2;
                }
            },
            {
                key: "parseRegExpLiteral",
                value: function parseRegExpLiteral(param) {
                    var pattern = param.pattern, flags = param.flags;
                    var regex = null;
                    try {
                        regex = new RegExp(pattern, flags);
                    } catch (e) {}
                    var node = this.estreeParseLiteral(regex);
                    node.regex = {
                        pattern: pattern,
                        flags: flags
                    };
                    return node;
                }
            },
            {
                key: "parseBigIntLiteral",
                value: function parseBigIntLiteral(value1) {
                    var bigInt;
                    try {
                        bigInt = BigInt(value1);
                    } catch (e) {
                        bigInt = null;
                    }
                    var node = this.estreeParseLiteral(bigInt);
                    node.bigint = String(node.value || value1);
                    return node;
                }
            },
            {
                key: "parseDecimalLiteral",
                value: function parseDecimalLiteral(value1) {
                    var decimal = null;
                    var node = this.estreeParseLiteral(decimal);
                    node.decimal = String(node.value || value1);
                    return node;
                }
            },
            {
                key: "estreeParseLiteral",
                value: function estreeParseLiteral(value1) {
                    return this.parseLiteral(value1, "Literal");
                }
            },
            {
                key: "parseStringLiteral",
                value: function parseStringLiteral(value1) {
                    return this.estreeParseLiteral(value1);
                }
            },
            {
                key: "parseNumericLiteral",
                value: function parseNumericLiteral(value1) {
                    return this.estreeParseLiteral(value1);
                }
            },
            {
                key: "parseNullLiteral",
                value: function parseNullLiteral() {
                    return this.estreeParseLiteral(null);
                }
            },
            {
                key: "parseBooleanLiteral",
                value: function parseBooleanLiteral(value1) {
                    return this.estreeParseLiteral(value1);
                }
            },
            {
                key: "directiveToStmt",
                value: function directiveToStmt(directive2) {
                    var expression2 = directive2.value;
                    delete directive2.value;
                    expression2.type = "Literal";
                    expression2.raw = expression2.extra.raw;
                    expression2.value = expression2.extra.expressionValue;
                    var stmt = directive2;
                    stmt.type = "ExpressionStatement";
                    stmt.expression = expression2;
                    stmt.directive = expression2.extra.rawValue;
                    delete expression2.extra;
                    return stmt;
                }
            },
            {
                key: "initFunction",
                value: function initFunction(node, isAsync) {
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "initFunction", this).call(this, node, isAsync);
                    node.expression = false;
                }
            },
            {
                key: "checkDeclaration",
                value: function checkDeclaration(node) {
                    if (node != null && this.isObjectProperty(node)) {
                        this.checkDeclaration(node.value);
                    } else {
                        _get(_get_prototype_of(ESTreeParserMixin.prototype), "checkDeclaration", this).call(this, node);
                    }
                }
            },
            {
                key: "getObjectOrClassMethodParams",
                value: function getObjectOrClassMethodParams(method) {
                    return method.value.params;
                }
            },
            {
                key: "isValidDirective",
                value: function isValidDirective(stmt) {
                    var _stmt_expression_extra;
                    return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !((_stmt_expression_extra = stmt.expression.extra) === null || _stmt_expression_extra === void 0 ? void 0 : _stmt_expression_extra.parenthesized);
                }
            },
            {
                key: "parseBlockBody",
                value: function parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
                    var _this = this;
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseBlockBody", this).call(this, node, allowDirectives, topLevel, end, afterBlockParse);
                    var directiveStatements = node.directives.map(function(d) {
                        return _this.directiveToStmt(d);
                    });
                    node.body = directiveStatements.concat(node.body);
                    delete node.directives;
                }
            },
            {
                key: "pushClassMethod",
                value: function pushClassMethod(classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
                    this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true);
                    if (method.typeParameters) {
                        method.value.typeParameters = method.typeParameters;
                        delete method.typeParameters;
                    }
                    classBody2.body.push(method);
                }
            },
            {
                key: "parsePrivateName",
                value: function parsePrivateName() {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parsePrivateName", this).call(this);
                    return this.convertPrivateNameToPrivateIdentifier(node);
                }
            },
            {
                key: "convertPrivateNameToPrivateIdentifier",
                value: function convertPrivateNameToPrivateIdentifier(node) {
                    var name = _get(_get_prototype_of(ESTreeParserMixin.prototype), "getPrivateNameSV", this).call(this, node);
                    node = node;
                    delete node.id;
                    node.name = name;
                    node.type = "PrivateIdentifier";
                    return node;
                }
            },
            {
                key: "isPrivateName",
                value: function isPrivateName(node) {
                    return node.type === "PrivateIdentifier";
                }
            },
            {
                key: "getPrivateNameSV",
                value: function getPrivateNameSV(node) {
                    return node.name;
                }
            },
            {
                key: "parseLiteral",
                value: function parseLiteral(value1, type) {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseLiteral", this).call(this, value1, type);
                    node.raw = node.extra.raw;
                    delete node.extra;
                    return node;
                }
            },
            {
                key: "parseFunctionBody",
                value: function parseFunctionBody(node, allowExpression) {
                    var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseFunctionBody", this).call(this, node, allowExpression, isMethod3);
                    node.expression = node.body.type !== "BlockStatement";
                }
            },
            {
                key: "parseMethod",
                value: function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type) {
                    var inClassScope = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false;
                    var funcNode = this.startNode();
                    funcNode.kind = node.kind;
                    funcNode = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseMethod", this).call(this, funcNode, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
                    funcNode.type = "FunctionExpression";
                    delete funcNode.kind;
                    node.value = funcNode;
                    if (type === "ClassPrivateMethod") {
                        node.computed = false;
                    }
                    return this.finishNode(node, "MethodDefinition");
                }
            },
            {
                key: "parseClassProperty",
                value: function parseClassProperty() {
                    for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                        args[_key] = arguments[_key];
                    }
                    var _$_get;
                    var propertyNode = (_$_get = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseClassProperty", this)).call.apply(_$_get, [
                        this
                    ].concat(_to_consumable_array(args)));
                    propertyNode.type = "PropertyDefinition";
                    return propertyNode;
                }
            },
            {
                key: "parseClassPrivateProperty",
                value: function parseClassPrivateProperty() {
                    for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                        args[_key] = arguments[_key];
                    }
                    var _$_get;
                    var propertyNode = (_$_get = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseClassPrivateProperty", this)).call.apply(_$_get, [
                        this
                    ].concat(_to_consumable_array(args)));
                    propertyNode.type = "PropertyDefinition";
                    propertyNode.computed = false;
                    return propertyNode;
                }
            },
            {
                key: "parseObjectMethod",
                value: function parseObjectMethod(prop, isGenerator, isAsync, isPattern2, isAccessor2) {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseObjectMethod", this).call(this, prop, isGenerator, isAsync, isPattern2, isAccessor2);
                    if (node) {
                        node.type = "Property";
                        if (node.kind === "method") {
                            node.kind = "init";
                        }
                        node.shorthand = false;
                    }
                    return node;
                }
            },
            {
                key: "parseObjectProperty",
                value: function parseObjectProperty(prop, startLoc, isPattern2, refExpressionErrors) {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseObjectProperty", this).call(this, prop, startLoc, isPattern2, refExpressionErrors);
                    if (node) {
                        node.kind = "init";
                        node.type = "Property";
                    }
                    return node;
                }
            },
            {
                key: "isValidLVal",
                value: function isValidLVal(type, isUnparenthesizedInAssign, binding) {
                    return type === "Property" ? "value" : _get(_get_prototype_of(ESTreeParserMixin.prototype), "isValidLVal", this).call(this, type, isUnparenthesizedInAssign, binding);
                }
            },
            {
                key: "isAssignable",
                value: function isAssignable(node, isBinding3) {
                    if (node != null && this.isObjectProperty(node)) {
                        return this.isAssignable(node.value, isBinding3);
                    }
                    return _get(_get_prototype_of(ESTreeParserMixin.prototype), "isAssignable", this).call(this, node, isBinding3);
                }
            },
            {
                key: "toAssignable",
                value: function toAssignable(node) {
                    var isLHS = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                    if (node != null && this.isObjectProperty(node)) {
                        var key = node.key, value1 = node.value;
                        if (this.isPrivateName(key)) {
                            this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
                        }
                        this.toAssignable(value1, isLHS);
                    } else {
                        _get(_get_prototype_of(ESTreeParserMixin.prototype), "toAssignable", this).call(this, node, isLHS);
                    }
                }
            },
            {
                key: "toAssignableObjectExpressionProp",
                value: function toAssignableObjectExpressionProp(prop, isLast, isLHS) {
                    if (prop.kind === "get" || prop.kind === "set") {
                        this.raise(Errors.PatternHasAccessor, prop.key);
                    } else if (prop.method) {
                        this.raise(Errors.PatternHasMethod, prop.key);
                    } else {
                        _get(_get_prototype_of(ESTreeParserMixin.prototype), "toAssignableObjectExpressionProp", this).call(this, prop, isLast, isLHS);
                    }
                }
            },
            {
                key: "finishCallExpression",
                value: function finishCallExpression(unfinished, optional) {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "finishCallExpression", this).call(this, unfinished, optional);
                    if (node.callee.type === "Import") {
                        node.type = "ImportExpression";
                        node.source = node.arguments[0];
                        if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
                            var _node_arguments_;
                            node.options = (_node_arguments_ = node.arguments[1]) !== null && _node_arguments_ !== void 0 ? _node_arguments_ : null;
                            var _node_arguments_1;
                            node.attributes = (_node_arguments_1 = node.arguments[1]) !== null && _node_arguments_1 !== void 0 ? _node_arguments_1 : null;
                        }
                        delete node.arguments;
                        delete node.callee;
                    }
                    return node;
                }
            },
            {
                key: "toReferencedArguments",
                value: function toReferencedArguments(node) {
                    if (node.type === "ImportExpression") {
                        return;
                    }
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "toReferencedArguments", this).call(this, node);
                }
            },
            {
                key: "parseExport",
                value: function parseExport(unfinished, decorators) {
                    var exportStartLoc = this.state.lastTokStartLoc;
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseExport", this).call(this, unfinished, decorators);
                    switch(node.type){
                        case "ExportAllDeclaration":
                            node.exported = null;
                            break;
                        case "ExportNamedDeclaration":
                            if (node.specifiers.length === 1 && node.specifiers[0].type === "ExportNamespaceSpecifier") {
                                node.type = "ExportAllDeclaration";
                                node.exported = node.specifiers[0].exported;
                                delete node.specifiers;
                            }
                        case "ExportDefaultDeclaration":
                            {
                                var _declaration_decorators;
                                var declaration = node.declaration;
                                if ((declaration === null || declaration === void 0 ? void 0 : declaration.type) === "ClassDeclaration" && ((_declaration_decorators = declaration.decorators) === null || _declaration_decorators === void 0 ? void 0 : _declaration_decorators.length) > 0 && declaration.start === node.start) {
                                    this.resetStartLocation(node, exportStartLoc);
                                }
                            }
                            break;
                    }
                    return node;
                }
            },
            {
                key: "parseSubscript",
                value: function parseSubscript(base, startLoc, noCalls, state) {
                    var node = _get(_get_prototype_of(ESTreeParserMixin.prototype), "parseSubscript", this).call(this, base, startLoc, noCalls, state);
                    if (state.optionalChainMember) {
                        if (node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression") {
                            node.type = node.type.substring(8);
                        }
                        if (state.stop) {
                            var chain2 = this.startNodeAtNode(node);
                            chain2.expression = node;
                            return this.finishNode(chain2, "ChainExpression");
                        }
                    } else if (node.type === "MemberExpression" || node.type === "CallExpression") {
                        node.optional = false;
                    }
                    return node;
                }
            },
            {
                key: "isOptionalMemberExpression",
                value: function isOptionalMemberExpression(node) {
                    if (node.type === "ChainExpression") {
                        return node.expression.type === "MemberExpression";
                    }
                    return _get(_get_prototype_of(ESTreeParserMixin.prototype), "isOptionalMemberExpression", this).call(this, node);
                }
            },
            {
                key: "hasPropertyAsPrivateName",
                value: function hasPropertyAsPrivateName(node) {
                    if (node.type === "ChainExpression") {
                        node = node.expression;
                    }
                    return _get(_get_prototype_of(ESTreeParserMixin.prototype), "hasPropertyAsPrivateName", this).call(this, node);
                }
            },
            {
                key: "isObjectProperty",
                value: function isObjectProperty(node) {
                    return node.type === "Property" && node.kind === "init" && !node.method;
                }
            },
            {
                key: "isObjectMethod",
                value: function isObjectMethod(node) {
                    return node.method || node.kind === "get" || node.kind === "set";
                }
            },
            {
                key: "finishNodeAt",
                value: function finishNodeAt(node, type, endLoc) {
                    return toESTreeLocation(_get(_get_prototype_of(ESTreeParserMixin.prototype), "finishNodeAt", this).call(this, node, type, endLoc));
                }
            },
            {
                key: "resetStartLocation",
                value: function resetStartLocation(node, startLoc) {
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "resetStartLocation", this).call(this, node, startLoc);
                    toESTreeLocation(node);
                }
            },
            {
                key: "resetEndLocation",
                value: function resetEndLocation(node) {
                    var endLoc = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
                    _get(_get_prototype_of(ESTreeParserMixin.prototype), "resetEndLocation", this).call(this, node, endLoc);
                    toESTreeLocation(node);
                }
            }
        ]);
        return ESTreeParserMixin;
    }(superClass);
    return ESTreeParserMixin;
};
var TokContext = function TokContext(token, preserveSpace) {
    "use strict";
    _class_call_check(this, TokContext);
    __publicField(this, "token");
    __publicField(this, "preserveSpace");
    this.token = token;
    this.preserveSpace = !!preserveSpace;
};
var types = {
    brace: new TokContext("{"),
    j_oTag: new TokContext("<tag"),
    j_cTag: new TokContext("</tag"),
    j_expr: new TokContext("<tag>...</tag>", true)
};
var beforeExpr = true;
var startsExpr = true;
var isLoop2 = true;
var isAssign = true;
var prefix = true;
var postfix = true;
var ExportedTokenType = function ExportedTokenType(label) {
    "use strict";
    var conf = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    _class_call_check(this, ExportedTokenType);
    __publicField(this, "label");
    __publicField(this, "keyword");
    __publicField(this, "beforeExpr");
    __publicField(this, "startsExpr");
    __publicField(this, "rightAssociative");
    __publicField(this, "isLoop");
    __publicField(this, "isAssign");
    __publicField(this, "prefix");
    __publicField(this, "postfix");
    __publicField(this, "binop");
    this.label = label;
    this.keyword = conf.keyword;
    this.beforeExpr = !!conf.beforeExpr;
    this.startsExpr = !!conf.startsExpr;
    this.rightAssociative = !!conf.rightAssociative;
    this.isLoop = !!conf.isLoop;
    this.isAssign = !!conf.isAssign;
    this.prefix = !!conf.prefix;
    this.postfix = !!conf.postfix;
    this.binop = conf.binop != null ? conf.binop : null;
};
var keywords$1 = /* @__PURE__ */ new Map();
function createKeyword(name) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    options.keyword = name;
    var token = createToken(name, options);
    keywords$1.set(name, token);
    return token;
}
function createBinop(name, binop) {
    return createToken(name, {
        beforeExpr: beforeExpr,
        binop: binop
    });
}
var tokenTypeCounter = -1;
var tokenTypes = [];
var tokenLabels = [];
var tokenBinops = [];
var tokenBeforeExprs = [];
var tokenStartsExprs = [];
var tokenPrefixes = [];
function createToken(name) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    ++tokenTypeCounter;
    tokenLabels.push(name);
    var _options_binop;
    tokenBinops.push((_options_binop = options.binop) !== null && _options_binop !== void 0 ? _options_binop : -1);
    var _options_beforeExpr;
    tokenBeforeExprs.push((_options_beforeExpr = options.beforeExpr) !== null && _options_beforeExpr !== void 0 ? _options_beforeExpr : false);
    var _options_startsExpr;
    tokenStartsExprs.push((_options_startsExpr = options.startsExpr) !== null && _options_startsExpr !== void 0 ? _options_startsExpr : false);
    var _options_prefix;
    tokenPrefixes.push((_options_prefix = options.prefix) !== null && _options_prefix !== void 0 ? _options_prefix : false);
    tokenTypes.push(new ExportedTokenType(name, options));
    return tokenTypeCounter;
}
function createKeywordLike(name) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    ++tokenTypeCounter;
    keywords$1.set(name, tokenTypeCounter);
    tokenLabels.push(name);
    var _options_binop;
    tokenBinops.push((_options_binop = options.binop) !== null && _options_binop !== void 0 ? _options_binop : -1);
    var _options_beforeExpr;
    tokenBeforeExprs.push((_options_beforeExpr = options.beforeExpr) !== null && _options_beforeExpr !== void 0 ? _options_beforeExpr : false);
    var _options_startsExpr;
    tokenStartsExprs.push((_options_startsExpr = options.startsExpr) !== null && _options_startsExpr !== void 0 ? _options_startsExpr : false);
    var _options_prefix;
    tokenPrefixes.push((_options_prefix = options.prefix) !== null && _options_prefix !== void 0 ? _options_prefix : false);
    tokenTypes.push(new ExportedTokenType("name", options));
    return tokenTypeCounter;
}
var tt = {
    bracketL: createToken("[", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    bracketHashL: createToken("#[", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    bracketBarL: createToken("[|", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    bracketR: createToken("]"),
    bracketBarR: createToken("|]"),
    braceL: createToken("{", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    braceBarL: createToken("{|", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    braceHashL: createToken("#{", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    braceR: createToken("}"),
    braceBarR: createToken("|}"),
    parenL: createToken("(", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    parenR: createToken(")"),
    comma: createToken(",", {
        beforeExpr: beforeExpr
    }),
    semi: createToken(";", {
        beforeExpr: beforeExpr
    }),
    colon: createToken(":", {
        beforeExpr: beforeExpr
    }),
    doubleColon: createToken("::", {
        beforeExpr: beforeExpr
    }),
    dot: createToken("."),
    question: createToken("?", {
        beforeExpr: beforeExpr
    }),
    questionDot: createToken("?."),
    arrow: createToken("=>", {
        beforeExpr: beforeExpr
    }),
    template: createToken("template"),
    ellipsis: createToken("...", {
        beforeExpr: beforeExpr
    }),
    backQuote: createToken("`", {
        startsExpr: startsExpr
    }),
    dollarBraceL: createToken("${", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    templateTail: createToken("...`", {
        startsExpr: startsExpr
    }),
    templateNonTail: createToken("...${", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    at: createToken("@"),
    hash: createToken("#", {
        startsExpr: startsExpr
    }),
    interpreterDirective: createToken("#!..."),
    eq: createToken("=", {
        beforeExpr: beforeExpr,
        isAssign: isAssign
    }),
    assign: createToken("_=", {
        beforeExpr: beforeExpr,
        isAssign: isAssign
    }),
    slashAssign: createToken("_=", {
        beforeExpr: beforeExpr,
        isAssign: isAssign
    }),
    xorAssign: createToken("_=", {
        beforeExpr: beforeExpr,
        isAssign: isAssign
    }),
    moduloAssign: createToken("_=", {
        beforeExpr: beforeExpr,
        isAssign: isAssign
    }),
    incDec: createToken("++/--", {
        prefix: prefix,
        postfix: postfix,
        startsExpr: startsExpr
    }),
    bang: createToken("!", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    tilde: createToken("~", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    doubleCaret: createToken("^^", {
        startsExpr: startsExpr
    }),
    doubleAt: createToken("@@", {
        startsExpr: startsExpr
    }),
    pipeline: createBinop("|>", 0),
    nullishCoalescing: createBinop("??", 1),
    logicalOR: createBinop("||", 1),
    logicalAND: createBinop("&&", 2),
    bitwiseOR: createBinop("|", 3),
    bitwiseXOR: createBinop("^", 4),
    bitwiseAND: createBinop("&", 5),
    equality: createBinop("==/!=/===/!==", 6),
    lt: createBinop("</>/<=/>=", 7),
    gt: createBinop("</>/<=/>=", 7),
    relational: createBinop("</>/<=/>=", 7),
    bitShift: createBinop("<</>>/>>>", 8),
    bitShiftL: createBinop("<</>>/>>>", 8),
    bitShiftR: createBinop("<</>>/>>>", 8),
    plusMin: createToken("+/-", {
        beforeExpr: beforeExpr,
        binop: 9,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    modulo: createToken("%", {
        binop: 10,
        startsExpr: startsExpr
    }),
    star: createToken("*", {
        binop: 10
    }),
    slash: createBinop("/", 10),
    exponent: createToken("**", {
        beforeExpr: beforeExpr,
        binop: 11,
        rightAssociative: true
    }),
    _in: createKeyword("in", {
        beforeExpr: beforeExpr,
        binop: 7
    }),
    _instanceof: createKeyword("instanceof", {
        beforeExpr: beforeExpr,
        binop: 7
    }),
    _break: createKeyword("break"),
    _case: createKeyword("case", {
        beforeExpr: beforeExpr
    }),
    _catch: createKeyword("catch"),
    _continue: createKeyword("continue"),
    _debugger: createKeyword("debugger"),
    _default: createKeyword("default", {
        beforeExpr: beforeExpr
    }),
    _else: createKeyword("else", {
        beforeExpr: beforeExpr
    }),
    _finally: createKeyword("finally"),
    _function: createKeyword("function", {
        startsExpr: startsExpr
    }),
    _if: createKeyword("if"),
    _return: createKeyword("return", {
        beforeExpr: beforeExpr
    }),
    _switch: createKeyword("switch"),
    _throw: createKeyword("throw", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    _try: createKeyword("try"),
    _var: createKeyword("var"),
    _const: createKeyword("const"),
    _with: createKeyword("with"),
    _new: createKeyword("new", {
        beforeExpr: beforeExpr,
        startsExpr: startsExpr
    }),
    _this: createKeyword("this", {
        startsExpr: startsExpr
    }),
    _super: createKeyword("super", {
        startsExpr: startsExpr
    }),
    _class: createKeyword("class", {
        startsExpr: startsExpr
    }),
    _extends: createKeyword("extends", {
        beforeExpr: beforeExpr
    }),
    _export: createKeyword("export"),
    _import: createKeyword("import", {
        startsExpr: startsExpr
    }),
    _null: createKeyword("null", {
        startsExpr: startsExpr
    }),
    _true: createKeyword("true", {
        startsExpr: startsExpr
    }),
    _false: createKeyword("false", {
        startsExpr: startsExpr
    }),
    _typeof: createKeyword("typeof", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    _void: createKeyword("void", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    _delete: createKeyword("delete", {
        beforeExpr: beforeExpr,
        prefix: prefix,
        startsExpr: startsExpr
    }),
    _do: createKeyword("do", {
        isLoop: isLoop2,
        beforeExpr: beforeExpr
    }),
    _for: createKeyword("for", {
        isLoop: isLoop2
    }),
    _while: createKeyword("while", {
        isLoop: isLoop2
    }),
    _as: createKeywordLike("as", {
        startsExpr: startsExpr
    }),
    _assert: createKeywordLike("assert", {
        startsExpr: startsExpr
    }),
    _async: createKeywordLike("async", {
        startsExpr: startsExpr
    }),
    _await: createKeywordLike("await", {
        startsExpr: startsExpr
    }),
    _defer: createKeywordLike("defer", {
        startsExpr: startsExpr
    }),
    _from: createKeywordLike("from", {
        startsExpr: startsExpr
    }),
    _get: createKeywordLike("get", {
        startsExpr: startsExpr
    }),
    _let: createKeywordLike("let", {
        startsExpr: startsExpr
    }),
    _meta: createKeywordLike("meta", {
        startsExpr: startsExpr
    }),
    _of: createKeywordLike("of", {
        startsExpr: startsExpr
    }),
    _sent: createKeywordLike("sent", {
        startsExpr: startsExpr
    }),
    _set: createKeywordLike("set", {
        startsExpr: startsExpr
    }),
    _source: createKeywordLike("source", {
        startsExpr: startsExpr
    }),
    _static: createKeywordLike("static", {
        startsExpr: startsExpr
    }),
    _using: createKeywordLike("using", {
        startsExpr: startsExpr
    }),
    _yield: createKeywordLike("yield", {
        startsExpr: startsExpr
    }),
    _asserts: createKeywordLike("asserts", {
        startsExpr: startsExpr
    }),
    _checks: createKeywordLike("checks", {
        startsExpr: startsExpr
    }),
    _exports: createKeywordLike("exports", {
        startsExpr: startsExpr
    }),
    _global: createKeywordLike("global", {
        startsExpr: startsExpr
    }),
    _implements: createKeywordLike("implements", {
        startsExpr: startsExpr
    }),
    _intrinsic: createKeywordLike("intrinsic", {
        startsExpr: startsExpr
    }),
    _infer: createKeywordLike("infer", {
        startsExpr: startsExpr
    }),
    _is: createKeywordLike("is", {
        startsExpr: startsExpr
    }),
    _mixins: createKeywordLike("mixins", {
        startsExpr: startsExpr
    }),
    _proto: createKeywordLike("proto", {
        startsExpr: startsExpr
    }),
    _require: createKeywordLike("require", {
        startsExpr: startsExpr
    }),
    _satisfies: createKeywordLike("satisfies", {
        startsExpr: startsExpr
    }),
    _keyof: createKeywordLike("keyof", {
        startsExpr: startsExpr
    }),
    _readonly: createKeywordLike("readonly", {
        startsExpr: startsExpr
    }),
    _unique: createKeywordLike("unique", {
        startsExpr: startsExpr
    }),
    _abstract: createKeywordLike("abstract", {
        startsExpr: startsExpr
    }),
    _declare: createKeywordLike("declare", {
        startsExpr: startsExpr
    }),
    _enum: createKeywordLike("enum", {
        startsExpr: startsExpr
    }),
    _module: createKeywordLike("module", {
        startsExpr: startsExpr
    }),
    _namespace: createKeywordLike("namespace", {
        startsExpr: startsExpr
    }),
    _interface: createKeywordLike("interface", {
        startsExpr: startsExpr
    }),
    _type: createKeywordLike("type", {
        startsExpr: startsExpr
    }),
    _opaque: createKeywordLike("opaque", {
        startsExpr: startsExpr
    }),
    name: createToken("name", {
        startsExpr: startsExpr
    }),
    string: createToken("string", {
        startsExpr: startsExpr
    }),
    num: createToken("num", {
        startsExpr: startsExpr
    }),
    bigint: createToken("bigint", {
        startsExpr: startsExpr
    }),
    decimal: createToken("decimal", {
        startsExpr: startsExpr
    }),
    regexp: createToken("regexp", {
        startsExpr: startsExpr
    }),
    privateName: createToken("#name", {
        startsExpr: startsExpr
    }),
    eof: createToken("eof"),
    jsxName: createToken("jsxName"),
    jsxText: createToken("jsxText", {
        beforeExpr: true
    }),
    jsxTagStart: createToken("jsxTagStart", {
        startsExpr: true
    }),
    jsxTagEnd: createToken("jsxTagEnd"),
    placeholder: createToken("%%", {
        startsExpr: true
    })
};
function tokenIsIdentifier(token) {
    return token >= 93 && token <= 132;
}
function tokenKeywordOrIdentifierIsKeyword(token) {
    return token <= 92;
}
function tokenIsKeywordOrIdentifier(token) {
    return token >= 58 && token <= 132;
}
function tokenIsLiteralPropertyName(token) {
    return token >= 58 && token <= 136;
}
function tokenComesBeforeExpression(token) {
    return tokenBeforeExprs[token];
}
function tokenCanStartExpression(token) {
    return tokenStartsExprs[token];
}
function tokenIsAssignment(token) {
    return token >= 29 && token <= 33;
}
function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
    return token >= 129 && token <= 131;
}
function tokenIsLoop(token) {
    return token >= 90 && token <= 92;
}
function tokenIsKeyword(token) {
    return token >= 58 && token <= 92;
}
function tokenIsOperator(token) {
    return token >= 39 && token <= 59;
}
function tokenIsPostfix(token) {
    return token === 34;
}
function tokenIsPrefix(token) {
    return tokenPrefixes[token];
}
function tokenIsTSTypeOperator(token) {
    return token >= 121 && token <= 123;
}
function tokenIsTSDeclarationStart(token) {
    return token >= 124 && token <= 130;
}
function tokenLabelName(token) {
    return tokenLabels[token];
}
function tokenOperatorPrecedence(token) {
    return tokenBinops[token];
}
function tokenIsRightAssociative(token) {
    return token === 57;
}
function tokenIsTemplate(token) {
    return token >= 24 && token <= 25;
}
function getExportedToken(token) {
    return tokenTypes[token];
}
var nonASCIIidentifierStartChars2 = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ";
var nonASCIIidentifierChars2 = "‌‍\xb7̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･";
var nonASCIIidentifierStart2 = new RegExp("[" + nonASCIIidentifierStartChars2 + "]");
var nonASCIIidentifier2 = new RegExp("[" + nonASCIIidentifierStartChars2 + nonASCIIidentifierChars2 + "]");
nonASCIIidentifierStartChars2 = nonASCIIidentifierChars2 = null;
var astralIdentifierStartCodes2 = [
    0,
    11,
    2,
    25,
    2,
    18,
    2,
    1,
    2,
    14,
    3,
    13,
    35,
    122,
    70,
    52,
    268,
    28,
    4,
    48,
    48,
    31,
    14,
    29,
    6,
    37,
    11,
    29,
    3,
    35,
    5,
    7,
    2,
    4,
    43,
    157,
    19,
    35,
    5,
    35,
    5,
    39,
    9,
    51,
    13,
    10,
    2,
    14,
    2,
    6,
    2,
    1,
    2,
    10,
    2,
    14,
    2,
    6,
    2,
    1,
    68,
    310,
    10,
    21,
    11,
    7,
    25,
    5,
    2,
    41,
    2,
    8,
    70,
    5,
    3,
    0,
    2,
    43,
    2,
    1,
    4,
    0,
    3,
    22,
    11,
    22,
    10,
    30,
    66,
    18,
    2,
    1,
    11,
    21,
    11,
    25,
    71,
    55,
    7,
    1,
    65,
    0,
    16,
    3,
    2,
    2,
    2,
    28,
    43,
    28,
    4,
    28,
    36,
    7,
    2,
    27,
    28,
    53,
    11,
    21,
    11,
    18,
    14,
    17,
    111,
    72,
    56,
    50,
    14,
    50,
    14,
    35,
    349,
    41,
    7,
    1,
    79,
    28,
    11,
    0,
    9,
    21,
    43,
    17,
    47,
    20,
    28,
    22,
    13,
    52,
    58,
    1,
    3,
    0,
    14,
    44,
    33,
    24,
    27,
    35,
    30,
    0,
    3,
    0,
    9,
    34,
    4,
    0,
    13,
    47,
    15,
    3,
    22,
    0,
    2,
    0,
    36,
    17,
    2,
    24,
    20,
    1,
    64,
    6,
    2,
    0,
    2,
    3,
    2,
    14,
    2,
    9,
    8,
    46,
    39,
    7,
    3,
    1,
    3,
    21,
    2,
    6,
    2,
    1,
    2,
    4,
    4,
    0,
    19,
    0,
    13,
    4,
    159,
    52,
    19,
    3,
    21,
    2,
    31,
    47,
    21,
    1,
    2,
    0,
    185,
    46,
    42,
    3,
    37,
    47,
    21,
    0,
    60,
    42,
    14,
    0,
    72,
    26,
    38,
    6,
    186,
    43,
    117,
    63,
    32,
    7,
    3,
    0,
    3,
    7,
    2,
    1,
    2,
    23,
    16,
    0,
    2,
    0,
    95,
    7,
    3,
    38,
    17,
    0,
    2,
    0,
    29,
    0,
    11,
    39,
    8,
    0,
    22,
    0,
    12,
    45,
    20,
    0,
    19,
    72,
    264,
    8,
    2,
    36,
    18,
    0,
    50,
    29,
    113,
    6,
    2,
    1,
    2,
    37,
    22,
    0,
    26,
    5,
    2,
    1,
    2,
    31,
    15,
    0,
    328,
    18,
    16,
    0,
    2,
    12,
    2,
    33,
    125,
    0,
    80,
    921,
    103,
    110,
    18,
    195,
    2637,
    96,
    16,
    1071,
    18,
    5,
    4026,
    582,
    8634,
    568,
    8,
    30,
    18,
    78,
    18,
    29,
    19,
    47,
    17,
    3,
    32,
    20,
    6,
    18,
    689,
    63,
    129,
    74,
    6,
    0,
    67,
    12,
    65,
    1,
    2,
    0,
    29,
    6135,
    9,
    1237,
    43,
    8,
    8936,
    3,
    2,
    6,
    2,
    1,
    2,
    290,
    16,
    0,
    30,
    2,
    3,
    0,
    15,
    3,
    9,
    395,
    2309,
    106,
    6,
    12,
    4,
    8,
    8,
    9,
    5991,
    84,
    2,
    70,
    2,
    1,
    3,
    0,
    3,
    1,
    3,
    3,
    2,
    11,
    2,
    0,
    2,
    6,
    2,
    64,
    2,
    3,
    3,
    7,
    2,
    6,
    2,
    27,
    2,
    3,
    2,
    4,
    2,
    0,
    4,
    6,
    2,
    339,
    3,
    24,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    30,
    2,
    24,
    2,
    7,
    1845,
    30,
    7,
    5,
    262,
    61,
    147,
    44,
    11,
    6,
    17,
    0,
    322,
    29,
    19,
    43,
    485,
    27,
    757,
    6,
    2,
    3,
    2,
    1,
    2,
    14,
    2,
    196,
    60,
    67,
    8,
    0,
    1205,
    3,
    2,
    26,
    2,
    1,
    2,
    0,
    3,
    0,
    2,
    9,
    2,
    3,
    2,
    0,
    2,
    0,
    7,
    0,
    5,
    0,
    2,
    0,
    2,
    0,
    2,
    2,
    2,
    1,
    2,
    0,
    3,
    0,
    2,
    0,
    2,
    0,
    2,
    0,
    2,
    0,
    2,
    1,
    2,
    0,
    3,
    3,
    2,
    6,
    2,
    3,
    2,
    3,
    2,
    0,
    2,
    9,
    2,
    16,
    6,
    2,
    2,
    4,
    2,
    16,
    4421,
    42719,
    33,
    4153,
    7,
    221,
    3,
    5761,
    15,
    7472,
    16,
    621,
    2467,
    541,
    1507,
    4938,
    6,
    4191
];
var astralIdentifierCodes2 = [
    509,
    0,
    227,
    0,
    150,
    4,
    294,
    9,
    1368,
    2,
    2,
    1,
    6,
    3,
    41,
    2,
    5,
    0,
    166,
    1,
    574,
    3,
    9,
    9,
    370,
    1,
    81,
    2,
    71,
    10,
    50,
    3,
    123,
    2,
    54,
    14,
    32,
    10,
    3,
    1,
    11,
    3,
    46,
    10,
    8,
    0,
    46,
    9,
    7,
    2,
    37,
    13,
    2,
    9,
    6,
    1,
    45,
    0,
    13,
    2,
    49,
    13,
    9,
    3,
    2,
    11,
    83,
    11,
    7,
    0,
    3,
    0,
    158,
    11,
    6,
    9,
    7,
    3,
    56,
    1,
    2,
    6,
    3,
    1,
    3,
    2,
    10,
    0,
    11,
    1,
    3,
    6,
    4,
    4,
    193,
    17,
    10,
    9,
    5,
    0,
    82,
    19,
    13,
    9,
    214,
    6,
    3,
    8,
    28,
    1,
    83,
    16,
    16,
    9,
    82,
    12,
    9,
    9,
    84,
    14,
    5,
    9,
    243,
    14,
    166,
    9,
    71,
    5,
    2,
    1,
    3,
    3,
    2,
    0,
    2,
    1,
    13,
    9,
    120,
    6,
    3,
    6,
    4,
    0,
    29,
    9,
    41,
    6,
    2,
    3,
    9,
    0,
    10,
    10,
    47,
    15,
    406,
    7,
    2,
    7,
    17,
    9,
    57,
    21,
    2,
    13,
    123,
    5,
    4,
    0,
    2,
    1,
    2,
    6,
    2,
    0,
    9,
    9,
    49,
    4,
    2,
    1,
    2,
    4,
    9,
    9,
    330,
    3,
    10,
    1,
    2,
    0,
    49,
    6,
    4,
    4,
    14,
    9,
    5351,
    0,
    7,
    14,
    13835,
    9,
    87,
    9,
    39,
    4,
    60,
    6,
    26,
    9,
    1014,
    0,
    2,
    54,
    8,
    3,
    82,
    0,
    12,
    1,
    19628,
    1,
    4706,
    45,
    3,
    22,
    543,
    4,
    4,
    5,
    9,
    7,
    3,
    6,
    31,
    3,
    149,
    2,
    1418,
    49,
    513,
    54,
    5,
    49,
    9,
    0,
    15,
    0,
    23,
    4,
    2,
    14,
    1361,
    6,
    2,
    16,
    3,
    6,
    2,
    1,
    2,
    4,
    101,
    0,
    161,
    6,
    10,
    9,
    357,
    0,
    62,
    13,
    499,
    13,
    983,
    6,
    110,
    6,
    6,
    9,
    4759,
    9,
    787719,
    239
];
function isInAstralSet2(code2, set) {
    var pos = 65536;
    for(var i = 0, length = set.length; i < length; i += 2){
        pos += set[i];
        if (pos > code2) return false;
        pos += set[i + 1];
        if (pos >= code2) return true;
    }
    return false;
}
function isIdentifierStart2(code2) {
    if (code2 < 65) return code2 === 36;
    if (code2 <= 90) return true;
    if (code2 < 97) return code2 === 95;
    if (code2 <= 122) return true;
    if (code2 <= 65535) {
        return code2 >= 170 && nonASCIIidentifierStart2.test(String.fromCharCode(code2));
    }
    return isInAstralSet2(code2, astralIdentifierStartCodes2);
}
function isIdentifierChar2(code2) {
    if (code2 < 48) return code2 === 36;
    if (code2 < 58) return true;
    if (code2 < 65) return false;
    if (code2 <= 90) return true;
    if (code2 < 97) return code2 === 95;
    if (code2 <= 122) return true;
    if (code2 <= 65535) {
        return code2 >= 170 && nonASCIIidentifier2.test(String.fromCharCode(code2));
    }
    return isInAstralSet2(code2, astralIdentifierStartCodes2) || isInAstralSet2(code2, astralIdentifierCodes2);
}
var reservedWords2 = {
    keyword: [
        "break",
        "case",
        "catch",
        "continue",
        "debugger",
        "default",
        "do",
        "else",
        "finally",
        "for",
        "function",
        "if",
        "return",
        "switch",
        "throw",
        "try",
        "var",
        "const",
        "while",
        "with",
        "new",
        "this",
        "super",
        "class",
        "extends",
        "export",
        "import",
        "null",
        "true",
        "false",
        "in",
        "instanceof",
        "typeof",
        "void",
        "delete"
    ],
    strict: [
        "implements",
        "interface",
        "let",
        "package",
        "private",
        "protected",
        "public",
        "static",
        "yield"
    ],
    strictBind: [
        "eval",
        "arguments"
    ]
};
var keywords2 = new Set(reservedWords2.keyword);
var reservedWordsStrictSet2 = new Set(reservedWords2.strict);
var reservedWordsStrictBindSet2 = new Set(reservedWords2.strictBind);
function isReservedWord2(word, inModule) {
    return inModule && word === "await" || word === "enum";
}
function isStrictReservedWord2(word, inModule) {
    return isReservedWord2(word, inModule) || reservedWordsStrictSet2.has(word);
}
function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet2.has(word);
}
function isStrictBindReservedWord(word, inModule) {
    return isStrictReservedWord2(word, inModule) || isStrictBindOnlyReservedWord(word);
}
function isKeyword2(word) {
    return keywords2.has(word);
}
function isIteratorStart(current, next, next2) {
    return current === 64 && next === 64 && isIdentifierStart2(next2);
}
var reservedWordLikeSet = /* @__PURE__ */ new Set([
    "break",
    "case",
    "catch",
    "continue",
    "debugger",
    "default",
    "do",
    "else",
    "finally",
    "for",
    "function",
    "if",
    "return",
    "switch",
    "throw",
    "try",
    "var",
    "const",
    "while",
    "with",
    "new",
    "this",
    "super",
    "class",
    "extends",
    "export",
    "import",
    "null",
    "true",
    "false",
    "in",
    "instanceof",
    "typeof",
    "void",
    "delete",
    "implements",
    "interface",
    "let",
    "package",
    "private",
    "protected",
    "public",
    "static",
    "yield",
    "eval",
    "arguments",
    "enum",
    "await"
]);
function canBeReservedWord(word) {
    return reservedWordLikeSet.has(word);
}
var Scope = function Scope(flags) {
    "use strict";
    _class_call_check(this, Scope);
    __publicField(this, "flags", 0);
    __publicField(this, "names", /* @__PURE__ */ new Map());
    __publicField(this, "firstLexicalName", "");
    this.flags = flags;
};
var ScopeHandler = /*#__PURE__*/ function() {
    "use strict";
    function ScopeHandler(parser, inModule) {
        _class_call_check(this, ScopeHandler);
        __publicField(this, "parser");
        __publicField(this, "scopeStack", []);
        __publicField(this, "inModule");
        __publicField(this, "undefinedExports", /* @__PURE__ */ new Map());
        this.parser = parser;
        this.inModule = inModule;
    }
    _create_class(ScopeHandler, [
        {
            key: "inTopLevel",
            get: function get() {
                return (this.currentScope().flags & 1) > 0;
            }
        },
        {
            key: "inFunction",
            get: function get() {
                return (this.currentVarScopeFlags() & 2) > 0;
            }
        },
        {
            key: "allowSuper",
            get: function get() {
                return (this.currentThisScopeFlags() & 16) > 0;
            }
        },
        {
            key: "allowDirectSuper",
            get: function get() {
                return (this.currentThisScopeFlags() & 32) > 0;
            }
        },
        {
            key: "inClass",
            get: function get() {
                return (this.currentThisScopeFlags() & 64) > 0;
            }
        },
        {
            key: "inClassAndNotInNonArrowFunction",
            get: function get() {
                var flags = this.currentThisScopeFlags();
                return (flags & 64) > 0 && (flags & 2) === 0;
            }
        },
        {
            key: "inStaticBlock",
            get: function get() {
                for(var i = this.scopeStack.length - 1;; i--){
                    var flags = this.scopeStack[i].flags;
                    if (flags & 128) {
                        return true;
                    }
                    if (flags & (387 | 64)) {
                        return false;
                    }
                }
            }
        },
        {
            key: "inNonArrowFunction",
            get: function get() {
                return (this.currentThisScopeFlags() & 2) > 0;
            }
        },
        {
            key: "treatFunctionsAsVar",
            get: function get() {
                return this.treatFunctionsAsVarInScope(this.currentScope());
            }
        },
        {
            key: "createScope",
            value: function createScope(flags) {
                return new Scope(flags);
            }
        },
        {
            key: "enter",
            value: function enter(flags) {
                this.scopeStack.push(this.createScope(flags));
            }
        },
        {
            key: "exit",
            value: function exit() {
                var scope2 = this.scopeStack.pop();
                return scope2.flags;
            }
        },
        {
            key: "treatFunctionsAsVarInScope",
            value: function treatFunctionsAsVarInScope(scope2) {
                return !!(scope2.flags & (2 | 128) || !this.parser.inModule && scope2.flags & 1);
            }
        },
        {
            key: "declareName",
            value: function declareName(name, bindingType, loc) {
                var scope2 = this.currentScope();
                if (bindingType & 8 || bindingType & 16) {
                    this.checkRedeclarationInScope(scope2, name, bindingType, loc);
                    var type = scope2.names.get(name) || 0;
                    if (bindingType & 16) {
                        type = type | 4;
                    } else {
                        if (!scope2.firstLexicalName) {
                            scope2.firstLexicalName = name;
                        }
                        type = type | 2;
                    }
                    scope2.names.set(name, type);
                    if (bindingType & 8) {
                        this.maybeExportDefined(scope2, name);
                    }
                } else if (bindingType & 4) {
                    for(var i = this.scopeStack.length - 1; i >= 0; --i){
                        scope2 = this.scopeStack[i];
                        this.checkRedeclarationInScope(scope2, name, bindingType, loc);
                        scope2.names.set(name, (scope2.names.get(name) || 0) | 1);
                        this.maybeExportDefined(scope2, name);
                        if (scope2.flags & 387) break;
                    }
                }
                if (this.parser.inModule && scope2.flags & 1) {
                    this.undefinedExports.delete(name);
                }
            }
        },
        {
            key: "maybeExportDefined",
            value: function maybeExportDefined(scope2, name) {
                if (this.parser.inModule && scope2.flags & 1) {
                    this.undefinedExports.delete(name);
                }
            }
        },
        {
            key: "checkRedeclarationInScope",
            value: function checkRedeclarationInScope(scope2, name, bindingType, loc) {
                if (this.isRedeclaredInScope(scope2, name, bindingType)) {
                    this.parser.raise(Errors.VarRedeclaration, loc, {
                        identifierName: name
                    });
                }
            }
        },
        {
            key: "isRedeclaredInScope",
            value: function isRedeclaredInScope(scope2, name, bindingType) {
                if (!(bindingType & 1)) return false;
                if (bindingType & 8) {
                    return scope2.names.has(name);
                }
                var type = scope2.names.get(name);
                if (bindingType & 16) {
                    return (type & 2) > 0 || !this.treatFunctionsAsVarInScope(scope2) && (type & 1) > 0;
                }
                return (type & 2) > 0 && !(scope2.flags & 8 && scope2.firstLexicalName === name) || !this.treatFunctionsAsVarInScope(scope2) && (type & 4) > 0;
            }
        },
        {
            key: "checkLocalExport",
            value: function checkLocalExport(id) {
                var name = id.name;
                var topLevelScope = this.scopeStack[0];
                if (!topLevelScope.names.has(name)) {
                    this.undefinedExports.set(name, id.loc.start);
                }
            }
        },
        {
            key: "currentScope",
            value: function currentScope() {
                return this.scopeStack[this.scopeStack.length - 1];
            }
        },
        {
            key: "currentVarScopeFlags",
            value: function currentVarScopeFlags() {
                for(var i = this.scopeStack.length - 1;; i--){
                    var flags = this.scopeStack[i].flags;
                    if (flags & 387) {
                        return flags;
                    }
                }
            }
        },
        {
            key: "currentThisScopeFlags",
            value: function currentThisScopeFlags() {
                for(var i = this.scopeStack.length - 1;; i--){
                    var flags = this.scopeStack[i].flags;
                    if (flags & (387 | 64) && !(flags & 4)) {
                        return flags;
                    }
                }
            }
        }
    ]);
    return ScopeHandler;
}();
var FlowScope = /*#__PURE__*/ function(Scope) {
    "use strict";
    _inherits(FlowScope, Scope);
    var _super = _create_super(FlowScope);
    function FlowScope() {
        _class_call_check(this, FlowScope);
        var _this;
        _this = _super.call.apply(_super, [
            this
        ].concat(Array.prototype.slice.call(arguments)));
        __publicField(_assert_this_initialized(_this), "declareFunctions", /* @__PURE__ */ new Set());
        return _this;
    }
    return FlowScope;
}(Scope);
var FlowScopeHandler = /*#__PURE__*/ function(ScopeHandler) {
    "use strict";
    _inherits(FlowScopeHandler, ScopeHandler);
    var _super = _create_super(FlowScopeHandler);
    function FlowScopeHandler() {
        _class_call_check(this, FlowScopeHandler);
        return _super.apply(this, arguments);
    }
    _create_class(FlowScopeHandler, [
        {
            key: "createScope",
            value: function createScope(flags) {
                return new FlowScope(flags);
            }
        },
        {
            key: "declareName",
            value: function declareName(name, bindingType, loc) {
                var scope2 = this.currentScope();
                if (bindingType & 2048) {
                    this.checkRedeclarationInScope(scope2, name, bindingType, loc);
                    this.maybeExportDefined(scope2, name);
                    scope2.declareFunctions.add(name);
                    return;
                }
                _get(_get_prototype_of(FlowScopeHandler.prototype), "declareName", this).call(this, name, bindingType, loc);
            }
        },
        {
            key: "isRedeclaredInScope",
            value: function isRedeclaredInScope(scope2, name, bindingType) {
                if (_get(_get_prototype_of(FlowScopeHandler.prototype), "isRedeclaredInScope", this).call(this, scope2, name, bindingType)) return true;
                if (bindingType & 2048 && !scope2.declareFunctions.has(name)) {
                    var type = scope2.names.get(name);
                    return (type & 4) > 0 || (type & 2) > 0;
                }
                return false;
            }
        },
        {
            key: "checkLocalExport",
            value: function checkLocalExport(id) {
                if (!this.scopeStack[0].declareFunctions.has(id.name)) {
                    _get(_get_prototype_of(FlowScopeHandler.prototype), "checkLocalExport", this).call(this, id);
                }
            }
        }
    ]);
    return FlowScopeHandler;
}(ScopeHandler);
var BaseParser = /*#__PURE__*/ function() {
    "use strict";
    function BaseParser() {
        _class_call_check(this, BaseParser);
        __publicField(this, "sawUnambiguousESM", false);
        __publicField(this, "ambiguousScriptDifferentAst", false);
    }
    _create_class(BaseParser, [
        {
            key: "hasPlugin",
            value: function hasPlugin(pluginConfig) {
                if (typeof pluginConfig === "string") {
                    return this.plugins.has(pluginConfig);
                } else {
                    var _pluginConfig = _sliced_to_array(pluginConfig, 2), pluginName = _pluginConfig[0], pluginOptions = _pluginConfig[1];
                    if (!this.hasPlugin(pluginName)) {
                        return false;
                    }
                    var actualOptions = this.plugins.get(pluginName);
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = Object.keys(pluginOptions)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var key = _step.value;
                            if ((actualOptions === null || actualOptions === void 0 ? void 0 : actualOptions[key]) !== pluginOptions[key]) {
                                return false;
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return true;
                }
            }
        },
        {
            key: "getPluginOption",
            value: function getPluginOption(plugin, name) {
                var _this_plugins_get;
                return (_this_plugins_get = this.plugins.get(plugin)) === null || _this_plugins_get === void 0 ? void 0 : _this_plugins_get[name];
            }
        }
    ]);
    return BaseParser;
}();
function setTrailingComments(node, comments) {
    if (node.trailingComments === void 0) {
        node.trailingComments = comments;
    } else {
        var _node_trailingComments;
        (_node_trailingComments = node.trailingComments).unshift.apply(_node_trailingComments, _to_consumable_array(comments));
    }
}
function setLeadingComments(node, comments) {
    if (node.leadingComments === void 0) {
        node.leadingComments = comments;
    } else {
        var _node_leadingComments;
        (_node_leadingComments = node.leadingComments).unshift.apply(_node_leadingComments, _to_consumable_array(comments));
    }
}
function setInnerComments(node, comments) {
    if (node.innerComments === void 0) {
        node.innerComments = comments;
    } else {
        var _node_innerComments;
        (_node_innerComments = node.innerComments).unshift.apply(_node_innerComments, _to_consumable_array(comments));
    }
}
function adjustInnerComments(node, elements, commentWS) {
    var lastElement = null;
    var i = elements.length;
    while(lastElement === null && i > 0){
        lastElement = elements[--i];
    }
    if (lastElement === null || lastElement.start > commentWS.start) {
        setInnerComments(node, commentWS.comments);
    } else {
        setTrailingComments(lastElement, commentWS.comments);
    }
}
var CommentsParser = /*#__PURE__*/ function(BaseParser) {
    "use strict";
    _inherits(CommentsParser, BaseParser);
    var _super = _create_super(CommentsParser);
    function CommentsParser() {
        _class_call_check(this, CommentsParser);
        return _super.apply(this, arguments);
    }
    _create_class(CommentsParser, [
        {
            key: "addComment",
            value: function addComment(comment) {
                if (this.filename) comment.loc.filename = this.filename;
                var commentsLen = this.state.commentsLen;
                if (this.comments.length != commentsLen) this.comments.length = commentsLen;
                this.comments.push(comment);
                this.state.commentsLen++;
            }
        },
        {
            key: "processComment",
            value: function processComment(node) {
                var commentStack = this.state.commentStack;
                var commentStackLength = commentStack.length;
                if (commentStackLength === 0) return;
                var i = commentStackLength - 1;
                var lastCommentWS = commentStack[i];
                if (lastCommentWS.start === node.end) {
                    lastCommentWS.leadingNode = node;
                    i--;
                }
                var nodeStart = node.start;
                for(; i >= 0; i--){
                    var commentWS = commentStack[i];
                    var commentEnd = commentWS.end;
                    if (commentEnd > nodeStart) {
                        commentWS.containingNode = node;
                        this.finalizeComment(commentWS);
                        commentStack.splice(i, 1);
                    } else {
                        if (commentEnd === nodeStart) {
                            commentWS.trailingNode = node;
                        }
                        break;
                    }
                }
            }
        },
        {
            key: "finalizeComment",
            value: function finalizeComment(commentWS) {
                var comments = commentWS.comments;
                if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
                    if (commentWS.leadingNode !== null) {
                        setTrailingComments(commentWS.leadingNode, comments);
                    }
                    if (commentWS.trailingNode !== null) {
                        setLeadingComments(commentWS.trailingNode, comments);
                    }
                } else {
                    var node = commentWS.containingNode, commentStart = commentWS.start;
                    if (this.input.charCodeAt(commentStart - 1) === 44) {
                        switch(node.type){
                            case "ObjectExpression":
                            case "ObjectPattern":
                            case "RecordExpression":
                                adjustInnerComments(node, node.properties, commentWS);
                                break;
                            case "CallExpression":
                            case "OptionalCallExpression":
                                adjustInnerComments(node, node.arguments, commentWS);
                                break;
                            case "FunctionDeclaration":
                            case "FunctionExpression":
                            case "ArrowFunctionExpression":
                            case "ObjectMethod":
                            case "ClassMethod":
                            case "ClassPrivateMethod":
                                adjustInnerComments(node, node.params, commentWS);
                                break;
                            case "ArrayExpression":
                            case "ArrayPattern":
                            case "TupleExpression":
                                adjustInnerComments(node, node.elements, commentWS);
                                break;
                            case "ExportNamedDeclaration":
                            case "ImportDeclaration":
                                adjustInnerComments(node, node.specifiers, commentWS);
                                break;
                            default:
                                {
                                    setInnerComments(node, comments);
                                }
                        }
                    } else {
                        setInnerComments(node, comments);
                    }
                }
            }
        },
        {
            key: "finalizeRemainingComments",
            value: function finalizeRemainingComments() {
                var commentStack = this.state.commentStack;
                for(var i = commentStack.length - 1; i >= 0; i--){
                    this.finalizeComment(commentStack[i]);
                }
                this.state.commentStack = [];
            }
        },
        {
            key: "resetPreviousNodeTrailingComments",
            value: function resetPreviousNodeTrailingComments(node) {
                var commentStack = this.state.commentStack;
                var length = commentStack.length;
                if (length === 0) return;
                var commentWS = commentStack[length - 1];
                if (commentWS.leadingNode === node) {
                    commentWS.leadingNode = null;
                }
            }
        },
        {
            key: "resetPreviousIdentifierLeadingComments",
            value: function resetPreviousIdentifierLeadingComments(node) {
                var commentStack = this.state.commentStack;
                var length = commentStack.length;
                if (length === 0) return;
                if (commentStack[length - 1].trailingNode === node) {
                    commentStack[length - 1].trailingNode = null;
                } else if (length >= 2 && commentStack[length - 2].trailingNode === node) {
                    commentStack[length - 2].trailingNode = null;
                }
            }
        },
        {
            key: "takeSurroundingComments",
            value: function takeSurroundingComments(node, start, end) {
                var commentStack = this.state.commentStack;
                var commentStackLength = commentStack.length;
                if (commentStackLength === 0) return;
                var i = commentStackLength - 1;
                for(; i >= 0; i--){
                    var commentWS = commentStack[i];
                    var commentEnd = commentWS.end;
                    var commentStart = commentWS.start;
                    if (commentStart === end) {
                        commentWS.leadingNode = node;
                    } else if (commentEnd === start) {
                        commentWS.trailingNode = node;
                    } else if (commentEnd < start) {
                        break;
                    }
                }
            }
        }
    ]);
    return CommentsParser;
}(BaseParser);
var lineBreak = /\r\n?|[\n\u2028\u2029]/;
var lineBreakG = new RegExp(lineBreak.source, "g");
function isNewLine(code2) {
    switch(code2){
        case 10:
        case 13:
        case 8232:
        case 8233:
            return true;
        default:
            return false;
    }
}
var skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
var skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
var skipWhiteSpaceToLineBreak = new RegExp("(?=(" + skipWhiteSpaceInLine.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
function isWhitespace(code2) {
    switch(code2){
        case 9:
        case 11:
        case 12:
        case 32:
        case 160:
        case 5760:
        case 8192:
        case 8193:
        case 8194:
        case 8195:
        case 8196:
        case 8197:
        case 8198:
        case 8199:
        case 8200:
        case 8201:
        case 8202:
        case 8239:
        case 8287:
        case 12288:
        case 65279:
            return true;
        default:
            return false;
    }
}
var State = /*#__PURE__*/ function() {
    "use strict";
    function _State() {
        _class_call_check(this, _State);
        __publicField(this, "flags", 1024);
        __publicField(this, "curLine");
        __publicField(this, "lineStart");
        __publicField(this, "startLoc");
        __publicField(this, "endLoc");
        __publicField(this, "errors", []);
        __publicField(this, "potentialArrowAt", -1);
        __publicField(this, "noArrowAt", []);
        __publicField(this, "noArrowParamsConversionAt", []);
        __publicField(this, "topicContext", {
            maxNumOfResolvableTopics: 0,
            maxTopicIndex: null
        });
        __publicField(this, "labels", []);
        __publicField(this, "commentsLen", 0);
        __publicField(this, "commentStack", []);
        __publicField(this, "pos", 0);
        __publicField(this, "type", 139);
        __publicField(this, "value", null);
        __publicField(this, "start", 0);
        __publicField(this, "end", 0);
        __publicField(this, "lastTokEndLoc", null);
        __publicField(this, "lastTokStartLoc", null);
        __publicField(this, "context", [
            types.brace
        ]);
        __publicField(this, "firstInvalidTemplateEscapePos", null);
        __publicField(this, "strictErrors", /* @__PURE__ */ new Map());
        __publicField(this, "tokensLength", 0);
    }
    _create_class(_State, [
        {
            key: "strict",
            get: function get() {
                return (this.flags & 1) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 1;
                } else {
                    this.flags &= ~1;
                }
            }
        },
        {
            key: "init",
            value: function init(param) {
                var strictMode = param.strictMode, sourceType = param.sourceType, startLine = param.startLine, startColumn = param.startColumn;
                this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
                this.curLine = startLine;
                this.lineStart = -startColumn;
                this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
            }
        },
        {
            key: "maybeInArrowParameters",
            get: function get() {
                return (this.flags & 2) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 2;
                } else {
                    this.flags &= ~2;
                }
            }
        },
        {
            key: "inType",
            get: function get() {
                return (this.flags & 4) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 4;
                } else {
                    this.flags &= ~4;
                }
            }
        },
        {
            key: "noAnonFunctionType",
            get: function get() {
                return (this.flags & 8) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 8;
                } else {
                    this.flags &= ~8;
                }
            }
        },
        {
            key: "hasFlowComment",
            get: function get() {
                return (this.flags & 16) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 16;
                } else {
                    this.flags &= ~16;
                }
            }
        },
        {
            key: "isAmbientContext",
            get: function get() {
                return (this.flags & 32) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 32;
                } else {
                    this.flags &= ~32;
                }
            }
        },
        {
            key: "inAbstractClass",
            get: function get() {
                return (this.flags & 64) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 64;
                } else {
                    this.flags &= ~64;
                }
            }
        },
        {
            key: "inDisallowConditionalTypesContext",
            get: function get() {
                return (this.flags & 128) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 128;
                } else {
                    this.flags &= ~128;
                }
            }
        },
        {
            key: "soloAwait",
            get: function get() {
                return (this.flags & 256) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 256;
                } else {
                    this.flags &= ~256;
                }
            }
        },
        {
            key: "inFSharpPipelineDirectBody",
            get: function get() {
                return (this.flags & 512) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 512;
                } else {
                    this.flags &= ~512;
                }
            }
        },
        {
            key: "canStartJSXElement",
            get: function get() {
                return (this.flags & 1024) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 1024;
                } else {
                    this.flags &= ~1024;
                }
            }
        },
        {
            key: "containsEsc",
            get: function get() {
                return (this.flags & 2048) > 0;
            },
            set: function set(value1) {
                if (value1) {
                    this.flags |= 2048;
                } else {
                    this.flags &= ~2048;
                }
            }
        },
        {
            key: "curPosition",
            value: function curPosition() {
                return new Position(this.curLine, this.pos - this.lineStart, this.pos);
            }
        },
        {
            key: "clone",
            value: function clone() {
                var state = new _State();
                state.flags = this.flags;
                state.curLine = this.curLine;
                state.lineStart = this.lineStart;
                state.startLoc = this.startLoc;
                state.endLoc = this.endLoc;
                state.errors = this.errors.slice();
                state.potentialArrowAt = this.potentialArrowAt;
                state.noArrowAt = this.noArrowAt.slice();
                state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
                state.topicContext = this.topicContext;
                state.labels = this.labels.slice();
                state.commentsLen = this.commentsLen;
                state.commentStack = this.commentStack.slice();
                state.pos = this.pos;
                state.type = this.type;
                state.value = this.value;
                state.start = this.start;
                state.end = this.end;
                state.lastTokEndLoc = this.lastTokEndLoc;
                state.lastTokStartLoc = this.lastTokStartLoc;
                state.context = this.context.slice();
                state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
                state.strictErrors = this.strictErrors;
                state.tokensLength = this.tokensLength;
                return state;
            }
        }
    ]);
    return _State;
}();
var _isDigit2 = function isDigit2(code2) {
    return code2 >= 48 && code2 <= 57;
};
var forbiddenNumericSeparatorSiblings2 = {
    decBinOct: /* @__PURE__ */ new Set([
        46,
        66,
        69,
        79,
        95,
        98,
        101,
        111
    ]),
    hex: /* @__PURE__ */ new Set([
        46,
        88,
        95,
        120
    ])
};
var isAllowedNumericSeparatorSibling2 = {
    bin: function(ch) {
        return ch === 48 || ch === 49;
    },
    oct: function(ch) {
        return ch >= 48 && ch <= 55;
    },
    dec: function(ch) {
        return ch >= 48 && ch <= 57;
    },
    hex: function(ch) {
        return ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
    }
};
function readStringContents2(type, input, pos, lineStart, curLine, errors) {
    var initialPos = pos;
    var initialLineStart = lineStart;
    var initialCurLine = curLine;
    var out = "";
    var firstInvalidLoc = null;
    var chunkStart = pos;
    var length = input.length;
    for(;;){
        if (pos >= length) {
            errors.unterminated(initialPos, initialLineStart, initialCurLine);
            out += input.slice(chunkStart, pos);
            break;
        }
        var ch = input.charCodeAt(pos);
        if (isStringEnd2(type, ch, input, pos)) {
            out += input.slice(chunkStart, pos);
            break;
        }
        if (ch === 92) {
            out += input.slice(chunkStart, pos);
            var res = readEscapedChar2(input, pos, lineStart, curLine, type === "template", errors);
            if (res.ch === null && !firstInvalidLoc) {
                firstInvalidLoc = {
                    pos: pos,
                    lineStart: lineStart,
                    curLine: curLine
                };
            } else {
                out += res.ch;
            }
            var ref;
            ref = res, pos = ref.pos, lineStart = ref.lineStart, curLine = ref.curLine, ref;
            chunkStart = pos;
        } else if (ch === 8232 || ch === 8233) {
            ++pos;
            ++curLine;
            lineStart = pos;
        } else if (ch === 10 || ch === 13) {
            if (type === "template") {
                out += input.slice(chunkStart, pos) + "\n";
                ++pos;
                if (ch === 13 && input.charCodeAt(pos) === 10) {
                    ++pos;
                }
                ++curLine;
                chunkStart = lineStart = pos;
            } else {
                errors.unterminated(initialPos, initialLineStart, initialCurLine);
            }
        } else {
            ++pos;
        }
    }
    return {
        pos: pos,
        str: out,
        firstInvalidLoc: firstInvalidLoc,
        lineStart: lineStart,
        curLine: curLine
    };
}
function isStringEnd2(type, ch, input, pos) {
    if (type === "template") {
        return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
    }
    return ch === (type === "double" ? 34 : 39);
}
function readEscapedChar2(input, pos, lineStart, curLine, inTemplate, errors) {
    var throwOnInvalid = !inTemplate;
    pos++;
    var res = function(ch2) {
        return {
            pos: pos,
            ch: ch2,
            lineStart: lineStart,
            curLine: curLine
        };
    };
    var ch = input.charCodeAt(pos++);
    switch(ch){
        case 110:
            return res("\n");
        case 114:
            return res("\r");
        case 120:
            {
                var code2;
                var ref;
                ref = readHexChar2(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors), code2 = ref.code, pos = ref.pos, ref;
                return res(code2 === null ? null : String.fromCharCode(code2));
            }
        case 117:
            {
                var code21;
                var ref1;
                ref1 = readCodePoint2(input, pos, lineStart, curLine, throwOnInvalid, errors), code21 = ref1.code, pos = ref1.pos, ref1;
                return res(code21 === null ? null : String.fromCodePoint(code21));
            }
        case 116:
            return res("	");
        case 98:
            return res("\b");
        case 118:
            return res("\v");
        case 102:
            return res("\f");
        case 13:
            if (input.charCodeAt(pos) === 10) {
                ++pos;
            }
        case 10:
            lineStart = pos;
            ++curLine;
        case 8232:
        case 8233:
            return res("");
        case 56:
        case 57:
            if (inTemplate) {
                return res(null);
            } else {
                errors.strictNumericEscape(pos - 1, lineStart, curLine);
            }
        default:
            if (ch >= 48 && ch <= 55) {
                var startPos = pos - 1;
                var match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
                var octalStr = match[0];
                var octal = parseInt(octalStr, 8);
                if (octal > 255) {
                    octalStr = octalStr.slice(0, -1);
                    octal = parseInt(octalStr, 8);
                }
                pos += octalStr.length - 1;
                var next = input.charCodeAt(pos);
                if (octalStr !== "0" || next === 56 || next === 57) {
                    if (inTemplate) {
                        return res(null);
                    } else {
                        errors.strictNumericEscape(startPos, lineStart, curLine);
                    }
                }
                return res(String.fromCharCode(octal));
            }
            return res(String.fromCharCode(ch));
    }
}
function readHexChar2(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors) {
    var initialPos = pos;
    var n2;
    var ref;
    ref = readInt2(input, pos, lineStart, curLine, 16, len, forceLen, false, errors, !throwOnInvalid), n2 = ref.n, pos = ref.pos, ref;
    if (n2 === null) {
        if (throwOnInvalid) {
            errors.invalidEscapeSequence(initialPos, lineStart, curLine);
        } else {
            pos = initialPos - 1;
        }
    }
    return {
        code: n2,
        pos: pos
    };
}
function readInt2(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors, bailOnError) {
    var start = pos;
    var forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings2.hex : forbiddenNumericSeparatorSiblings2.decBinOct;
    var isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling2.hex : radix === 10 ? isAllowedNumericSeparatorSibling2.dec : radix === 8 ? isAllowedNumericSeparatorSibling2.oct : isAllowedNumericSeparatorSibling2.bin;
    var invalid = false;
    var total = 0;
    for(var i = 0, e = len == null ? Infinity : len; i < e; ++i){
        var code2 = input.charCodeAt(pos);
        var val = void 0;
        if (code2 === 95 && allowNumSeparator !== "bail") {
            var prev = input.charCodeAt(pos - 1);
            var next = input.charCodeAt(pos + 1);
            if (!allowNumSeparator) {
                if (bailOnError) return {
                    n: null,
                    pos: pos
                };
                errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
            } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
                if (bailOnError) return {
                    n: null,
                    pos: pos
                };
                errors.unexpectedNumericSeparator(pos, lineStart, curLine);
            }
            ++pos;
            continue;
        }
        if (code2 >= 97) {
            val = code2 - 97 + 10;
        } else if (code2 >= 65) {
            val = code2 - 65 + 10;
        } else if (_isDigit2(code2)) {
            val = code2 - 48;
        } else {
            val = Infinity;
        }
        if (val >= radix) {
            if (val <= 9 && bailOnError) {
                return {
                    n: null,
                    pos: pos
                };
            } else if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
                val = 0;
            } else if (forceLen) {
                val = 0;
                invalid = true;
            } else {
                break;
            }
        }
        ++pos;
        total = total * radix + val;
    }
    if (pos === start || len != null && pos - start !== len || invalid) {
        return {
            n: null,
            pos: pos
        };
    }
    return {
        n: total,
        pos: pos
    };
}
function readCodePoint2(input, pos, lineStart, curLine, throwOnInvalid, errors) {
    var ch = input.charCodeAt(pos);
    var code2;
    if (ch === 123) {
        ++pos;
        var ref;
        ref = readHexChar2(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors), code2 = ref.code, pos = ref.pos, ref;
        ++pos;
        if (code2 !== null && code2 > 1114111) {
            if (throwOnInvalid) {
                errors.invalidCodePoint(pos, lineStart, curLine);
            } else {
                return {
                    code: null,
                    pos: pos
                };
            }
        }
    } else {
        var ref1;
        ref1 = readHexChar2(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors), code2 = ref1.code, pos = ref1.pos, ref1;
    }
    return {
        code: code2,
        pos: pos
    };
}
function buildPosition(pos, lineStart, curLine) {
    return new Position(curLine, pos - lineStart, pos);
}
var VALID_REGEX_FLAGS = /* @__PURE__ */ new Set([
    103,
    109,
    115,
    105,
    121,
    117,
    100,
    118
]);
var Token = function Token(state) {
    "use strict";
    _class_call_check(this, Token);
    this.type = state.type;
    this.value = state.value;
    this.start = state.start;
    this.end = state.end;
    this.loc = new SourceLocation(state.startLoc, state.endLoc);
};
var Tokenizer = /*#__PURE__*/ function(CommentsParser) {
    "use strict";
    _inherits(Tokenizer, CommentsParser);
    var _super = _create_super(Tokenizer);
    function Tokenizer(options, input) {
        _class_call_check(this, Tokenizer);
        var _this;
        _this = _super.call(this);
        __publicField(_assert_this_initialized(_this), "isLookahead");
        __publicField(_assert_this_initialized(_this), "tokens", []);
        __publicField(_assert_this_initialized(_this), "errorHandlers_readInt", {
            invalidDigit: function(pos, lineStart, curLine, radix) {
                if (!_this.options.errorRecovery) return false;
                _this.raise(Errors.InvalidDigit, buildPosition(pos, lineStart, curLine), {
                    radix: radix
                });
                return true;
            },
            numericSeparatorInEscapeSequence: _this.errorBuilder(Errors.NumericSeparatorInEscapeSequence),
            unexpectedNumericSeparator: _this.errorBuilder(Errors.UnexpectedNumericSeparator)
        });
        __publicField(_assert_this_initialized(_this), "errorHandlers_readCodePoint", Object.assign({}, _this.errorHandlers_readInt, {
            invalidEscapeSequence: _this.errorBuilder(Errors.InvalidEscapeSequence),
            invalidCodePoint: _this.errorBuilder(Errors.InvalidCodePoint)
        }));
        __publicField(_assert_this_initialized(_this), "errorHandlers_readStringContents_string", Object.assign({}, _this.errorHandlers_readCodePoint, {
            strictNumericEscape: function(pos, lineStart, curLine) {
                _this.recordStrictModeErrors(Errors.StrictNumericEscape, buildPosition(pos, lineStart, curLine));
            },
            unterminated: function(pos, lineStart, curLine) {
                throw _this.raise(Errors.UnterminatedString, buildPosition(pos - 1, lineStart, curLine));
            }
        }));
        __publicField(_assert_this_initialized(_this), "errorHandlers_readStringContents_template", Object.assign({}, _this.errorHandlers_readCodePoint, {
            strictNumericEscape: _this.errorBuilder(Errors.StrictNumericEscape),
            unterminated: function(pos, lineStart, curLine) {
                throw _this.raise(Errors.UnterminatedTemplate, buildPosition(pos, lineStart, curLine));
            }
        }));
        _this.state = new State();
        _this.state.init(options);
        _this.input = input;
        _this.length = input.length;
        _this.comments = [];
        _this.isLookahead = false;
        return _this;
    }
    _create_class(Tokenizer, [
        {
            key: "pushToken",
            value: function pushToken(token) {
                this.tokens.length = this.state.tokensLength;
                this.tokens.push(token);
                ++this.state.tokensLength;
            }
        },
        {
            key: "next",
            value: function next() {
                this.checkKeywordEscapes();
                if (this.options.tokens) {
                    this.pushToken(new Token(this.state));
                }
                this.state.lastTokEndLoc = this.state.endLoc;
                this.state.lastTokStartLoc = this.state.startLoc;
                this.nextToken();
            }
        },
        {
            key: "eat",
            value: function eat(type) {
                if (this.match(type)) {
                    this.next();
                    return true;
                } else {
                    return false;
                }
            }
        },
        {
            key: "match",
            value: function match(type) {
                return this.state.type === type;
            }
        },
        {
            key: "createLookaheadState",
            value: function createLookaheadState(state) {
                return {
                    pos: state.pos,
                    value: null,
                    type: state.type,
                    start: state.start,
                    end: state.end,
                    context: [
                        this.curContext()
                    ],
                    inType: state.inType,
                    startLoc: state.startLoc,
                    lastTokEndLoc: state.lastTokEndLoc,
                    curLine: state.curLine,
                    lineStart: state.lineStart,
                    curPosition: state.curPosition
                };
            }
        },
        {
            key: "lookahead",
            value: function lookahead() {
                var old = this.state;
                this.state = this.createLookaheadState(old);
                this.isLookahead = true;
                this.nextToken();
                this.isLookahead = false;
                var curr = this.state;
                this.state = old;
                return curr;
            }
        },
        {
            key: "nextTokenStart",
            value: function nextTokenStart() {
                return this.nextTokenStartSince(this.state.pos);
            }
        },
        {
            key: "nextTokenStartSince",
            value: function nextTokenStartSince(pos) {
                skipWhiteSpace.lastIndex = pos;
                return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
            }
        },
        {
            key: "lookaheadCharCode",
            value: function lookaheadCharCode() {
                return this.input.charCodeAt(this.nextTokenStart());
            }
        },
        {
            key: "nextTokenInLineStart",
            value: function nextTokenInLineStart() {
                return this.nextTokenInLineStartSince(this.state.pos);
            }
        },
        {
            key: "nextTokenInLineStartSince",
            value: function nextTokenInLineStartSince(pos) {
                skipWhiteSpaceInLine.lastIndex = pos;
                return skipWhiteSpaceInLine.test(this.input) ? skipWhiteSpaceInLine.lastIndex : pos;
            }
        },
        {
            key: "lookaheadInLineCharCode",
            value: function lookaheadInLineCharCode() {
                return this.input.charCodeAt(this.nextTokenInLineStart());
            }
        },
        {
            key: "codePointAtPos",
            value: function codePointAtPos(pos) {
                var cp = this.input.charCodeAt(pos);
                if ((cp & 64512) === 55296 && ++pos < this.input.length) {
                    var trail = this.input.charCodeAt(pos);
                    if ((trail & 64512) === 56320) {
                        cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
                    }
                }
                return cp;
            }
        },
        {
            key: "setStrict",
            value: function setStrict(strict) {
                var _this = this;
                this.state.strict = strict;
                if (strict) {
                    this.state.strictErrors.forEach(function(param) {
                        var _$_param = _sliced_to_array(param, 2), toParseError = _$_param[0], at = _$_param[1];
                        return _this.raise(toParseError, at);
                    });
                    this.state.strictErrors.clear();
                }
            }
        },
        {
            key: "curContext",
            value: function curContext() {
                return this.state.context[this.state.context.length - 1];
            }
        },
        {
            key: "nextToken",
            value: function nextToken() {
                this.skipSpace();
                this.state.start = this.state.pos;
                if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
                if (this.state.pos >= this.length) {
                    this.finishToken(139);
                    return;
                }
                this.getTokenFromCode(this.codePointAtPos(this.state.pos));
            }
        },
        {
            key: "skipBlockComment",
            value: function skipBlockComment(commentEnd) {
                var startLoc;
                if (!this.isLookahead) startLoc = this.state.curPosition();
                var start = this.state.pos;
                var end = this.input.indexOf(commentEnd, start + 2);
                if (end === -1) {
                    throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
                }
                this.state.pos = end + commentEnd.length;
                lineBreakG.lastIndex = start + 2;
                while(lineBreakG.test(this.input) && lineBreakG.lastIndex <= end){
                    ++this.state.curLine;
                    this.state.lineStart = lineBreakG.lastIndex;
                }
                if (this.isLookahead) return;
                var comment = {
                    type: "CommentBlock",
                    value: this.input.slice(start + 2, end),
                    start: start,
                    end: end + commentEnd.length,
                    loc: new SourceLocation(startLoc, this.state.curPosition())
                };
                if (this.options.tokens) this.pushToken(comment);
                return comment;
            }
        },
        {
            key: "skipLineComment",
            value: function skipLineComment(startSkip) {
                var start = this.state.pos;
                var startLoc;
                if (!this.isLookahead) startLoc = this.state.curPosition();
                var ch = this.input.charCodeAt(this.state.pos += startSkip);
                if (this.state.pos < this.length) {
                    while(!isNewLine(ch) && ++this.state.pos < this.length){
                        ch = this.input.charCodeAt(this.state.pos);
                    }
                }
                if (this.isLookahead) return;
                var end = this.state.pos;
                var value1 = this.input.slice(start + startSkip, end);
                var comment = {
                    type: "CommentLine",
                    value: value1,
                    start: start,
                    end: end,
                    loc: new SourceLocation(startLoc, this.state.curPosition())
                };
                if (this.options.tokens) this.pushToken(comment);
                return comment;
            }
        },
        {
            key: "skipSpace",
            value: function skipSpace() {
                var spaceStart = this.state.pos;
                var comments = [];
                loop: while(this.state.pos < this.length){
                    var ch = this.input.charCodeAt(this.state.pos);
                    switch(ch){
                        case 32:
                        case 160:
                        case 9:
                            ++this.state.pos;
                            break;
                        case 13:
                            if (this.input.charCodeAt(this.state.pos + 1) === 10) {
                                ++this.state.pos;
                            }
                        case 10:
                        case 8232:
                        case 8233:
                            ++this.state.pos;
                            ++this.state.curLine;
                            this.state.lineStart = this.state.pos;
                            break;
                        case 47:
                            switch(this.input.charCodeAt(this.state.pos + 1)){
                                case 42:
                                    {
                                        var comment = this.skipBlockComment("*/");
                                        if (comment !== void 0) {
                                            this.addComment(comment);
                                            if (this.options.attachComment) comments.push(comment);
                                        }
                                        break;
                                    }
                                case 47:
                                    {
                                        var comment1 = this.skipLineComment(2);
                                        if (comment1 !== void 0) {
                                            this.addComment(comment1);
                                            if (this.options.attachComment) comments.push(comment1);
                                        }
                                        break;
                                    }
                                default:
                                    break loop;
                            }
                            break;
                        default:
                            if (isWhitespace(ch)) {
                                ++this.state.pos;
                            } else if (ch === 45 && !this.inModule && this.options.annexB) {
                                var pos = this.state.pos;
                                if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
                                    var comment2 = this.skipLineComment(3);
                                    if (comment2 !== void 0) {
                                        this.addComment(comment2);
                                        if (this.options.attachComment) comments.push(comment2);
                                    }
                                } else {
                                    break loop;
                                }
                            } else if (ch === 60 && !this.inModule && this.options.annexB) {
                                var pos1 = this.state.pos;
                                if (this.input.charCodeAt(pos1 + 1) === 33 && this.input.charCodeAt(pos1 + 2) === 45 && this.input.charCodeAt(pos1 + 3) === 45) {
                                    var comment3 = this.skipLineComment(4);
                                    if (comment3 !== void 0) {
                                        this.addComment(comment3);
                                        if (this.options.attachComment) comments.push(comment3);
                                    }
                                } else {
                                    break loop;
                                }
                            } else {
                                break loop;
                            }
                    }
                }
                if (comments.length > 0) {
                    var end = this.state.pos;
                    var commentWhitespace = {
                        start: spaceStart,
                        end: end,
                        comments: comments,
                        leadingNode: null,
                        trailingNode: null,
                        containingNode: null
                    };
                    this.state.commentStack.push(commentWhitespace);
                }
            }
        },
        {
            key: "finishToken",
            value: function finishToken(type, val) {
                this.state.end = this.state.pos;
                this.state.endLoc = this.state.curPosition();
                var prevType = this.state.type;
                this.state.type = type;
                this.state.value = val;
                if (!this.isLookahead) {
                    this.updateContext(prevType);
                }
            }
        },
        {
            key: "replaceToken",
            value: function replaceToken(type) {
                this.state.type = type;
                this.updateContext();
            }
        },
        {
            key: "readToken_numberSign",
            value: function readToken_numberSign() {
                if (this.state.pos === 0 && this.readToken_interpreter()) {
                    return;
                }
                var nextPos = this.state.pos + 1;
                var next = this.codePointAtPos(nextPos);
                if (next >= 48 && next <= 57) {
                    throw this.raise(Errors.UnexpectedDigitAfterHash, this.state.curPosition());
                }
                if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
                    this.expectPlugin("recordAndTuple");
                    if (this.getPluginOption("recordAndTuple", "syntaxType") === "bar") {
                        throw this.raise(next === 123 ? Errors.RecordExpressionHashIncorrectStartSyntaxType : Errors.TupleExpressionHashIncorrectStartSyntaxType, this.state.curPosition());
                    }
                    this.state.pos += 2;
                    if (next === 123) {
                        this.finishToken(7);
                    } else {
                        this.finishToken(1);
                    }
                } else if (isIdentifierStart2(next)) {
                    ++this.state.pos;
                    this.finishToken(138, this.readWord1(next));
                } else if (next === 92) {
                    ++this.state.pos;
                    this.finishToken(138, this.readWord1());
                } else {
                    this.finishOp(27, 1);
                }
            }
        },
        {
            key: "readToken_dot",
            value: function readToken_dot() {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next >= 48 && next <= 57) {
                    this.readNumber(true);
                    return;
                }
                if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
                    this.state.pos += 3;
                    this.finishToken(21);
                } else {
                    ++this.state.pos;
                    this.finishToken(16);
                }
            }
        },
        {
            key: "readToken_slash",
            value: function readToken_slash() {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === 61) {
                    this.finishOp(31, 2);
                } else {
                    this.finishOp(56, 1);
                }
            }
        },
        {
            key: "readToken_interpreter",
            value: function readToken_interpreter() {
                if (this.state.pos !== 0 || this.length < 2) return false;
                var ch = this.input.charCodeAt(this.state.pos + 1);
                if (ch !== 33) return false;
                var start = this.state.pos;
                this.state.pos += 1;
                while(!isNewLine(ch) && ++this.state.pos < this.length){
                    ch = this.input.charCodeAt(this.state.pos);
                }
                var value1 = this.input.slice(start + 2, this.state.pos);
                this.finishToken(28, value1);
                return true;
            }
        },
        {
            key: "readToken_mult_modulo",
            value: function readToken_mult_modulo(code2) {
                var type = code2 === 42 ? 55 : 54;
                var width = 1;
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (code2 === 42 && next === 42) {
                    width++;
                    next = this.input.charCodeAt(this.state.pos + 2);
                    type = 57;
                }
                if (next === 61 && !this.state.inType) {
                    width++;
                    type = code2 === 37 ? 33 : 30;
                }
                this.finishOp(type, width);
            }
        },
        {
            key: "readToken_pipe_amp",
            value: function readToken_pipe_amp(code2) {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === code2) {
                    if (this.input.charCodeAt(this.state.pos + 2) === 61) {
                        this.finishOp(30, 3);
                    } else {
                        this.finishOp(code2 === 124 ? 41 : 42, 2);
                    }
                    return;
                }
                if (code2 === 124) {
                    if (next === 62) {
                        this.finishOp(39, 2);
                        return;
                    }
                    if (this.hasPlugin("recordAndTuple") && next === 125) {
                        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                            throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
                        }
                        this.state.pos += 2;
                        this.finishToken(9);
                        return;
                    }
                    if (this.hasPlugin("recordAndTuple") && next === 93) {
                        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                            throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
                        }
                        this.state.pos += 2;
                        this.finishToken(4);
                        return;
                    }
                }
                if (next === 61) {
                    this.finishOp(30, 2);
                    return;
                }
                this.finishOp(code2 === 124 ? 43 : 45, 1);
            }
        },
        {
            key: "readToken_caret",
            value: function readToken_caret() {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === 61 && !this.state.inType) {
                    this.finishOp(32, 2);
                } else if (next === 94 && this.hasPlugin([
                    "pipelineOperator",
                    {
                        proposal: "hack",
                        topicToken: "^^"
                    }
                ])) {
                    this.finishOp(37, 2);
                    var lookaheadCh = this.input.codePointAt(this.state.pos);
                    if (lookaheadCh === 94) {
                        this.unexpected();
                    }
                } else {
                    this.finishOp(44, 1);
                }
            }
        },
        {
            key: "readToken_atSign",
            value: function readToken_atSign() {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === 64 && this.hasPlugin([
                    "pipelineOperator",
                    {
                        proposal: "hack",
                        topicToken: "@@"
                    }
                ])) {
                    this.finishOp(38, 2);
                } else {
                    this.finishOp(26, 1);
                }
            }
        },
        {
            key: "readToken_plus_min",
            value: function readToken_plus_min(code2) {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === code2) {
                    this.finishOp(34, 2);
                    return;
                }
                if (next === 61) {
                    this.finishOp(30, 2);
                } else {
                    this.finishOp(53, 1);
                }
            }
        },
        {
            key: "readToken_lt",
            value: function readToken_lt() {
                var pos = this.state.pos;
                var next = this.input.charCodeAt(pos + 1);
                if (next === 60) {
                    if (this.input.charCodeAt(pos + 2) === 61) {
                        this.finishOp(30, 3);
                        return;
                    }
                    this.finishOp(51, 2);
                    return;
                }
                if (next === 61) {
                    this.finishOp(49, 2);
                    return;
                }
                this.finishOp(47, 1);
            }
        },
        {
            key: "readToken_gt",
            value: function readToken_gt() {
                var pos = this.state.pos;
                var next = this.input.charCodeAt(pos + 1);
                if (next === 62) {
                    var size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
                    if (this.input.charCodeAt(pos + size) === 61) {
                        this.finishOp(30, size + 1);
                        return;
                    }
                    this.finishOp(52, size);
                    return;
                }
                if (next === 61) {
                    this.finishOp(49, 2);
                    return;
                }
                this.finishOp(48, 1);
            }
        },
        {
            key: "readToken_eq_excl",
            value: function readToken_eq_excl(code2) {
                var next = this.input.charCodeAt(this.state.pos + 1);
                if (next === 61) {
                    this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
                    return;
                }
                if (code2 === 61 && next === 62) {
                    this.state.pos += 2;
                    this.finishToken(19);
                    return;
                }
                this.finishOp(code2 === 61 ? 29 : 35, 1);
            }
        },
        {
            key: "readToken_question",
            value: function readToken_question() {
                var next = this.input.charCodeAt(this.state.pos + 1);
                var next2 = this.input.charCodeAt(this.state.pos + 2);
                if (next === 63) {
                    if (next2 === 61) {
                        this.finishOp(30, 3);
                    } else {
                        this.finishOp(40, 2);
                    }
                } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
                    this.state.pos += 2;
                    this.finishToken(18);
                } else {
                    ++this.state.pos;
                    this.finishToken(17);
                }
            }
        },
        {
            key: "getTokenFromCode",
            value: function getTokenFromCode(code2) {
                switch(code2){
                    case 46:
                        this.readToken_dot();
                        return;
                    case 40:
                        ++this.state.pos;
                        this.finishToken(10);
                        return;
                    case 41:
                        ++this.state.pos;
                        this.finishToken(11);
                        return;
                    case 59:
                        ++this.state.pos;
                        this.finishToken(13);
                        return;
                    case 44:
                        ++this.state.pos;
                        this.finishToken(12);
                        return;
                    case 91:
                        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                                throw this.raise(Errors.TupleExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
                            }
                            this.state.pos += 2;
                            this.finishToken(2);
                        } else {
                            ++this.state.pos;
                            this.finishToken(0);
                        }
                        return;
                    case 93:
                        ++this.state.pos;
                        this.finishToken(3);
                        return;
                    case 123:
                        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
                                throw this.raise(Errors.RecordExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
                            }
                            this.state.pos += 2;
                            this.finishToken(6);
                        } else {
                            ++this.state.pos;
                            this.finishToken(5);
                        }
                        return;
                    case 125:
                        ++this.state.pos;
                        this.finishToken(8);
                        return;
                    case 58:
                        if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
                            this.finishOp(15, 2);
                        } else {
                            ++this.state.pos;
                            this.finishToken(14);
                        }
                        return;
                    case 63:
                        this.readToken_question();
                        return;
                    case 96:
                        this.readTemplateToken();
                        return;
                    case 48:
                        {
                            var next = this.input.charCodeAt(this.state.pos + 1);
                            if (next === 120 || next === 88) {
                                this.readRadixNumber(16);
                                return;
                            }
                            if (next === 111 || next === 79) {
                                this.readRadixNumber(8);
                                return;
                            }
                            if (next === 98 || next === 66) {
                                this.readRadixNumber(2);
                                return;
                            }
                        }
                    case 49:
                    case 50:
                    case 51:
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                        this.readNumber(false);
                        return;
                    case 34:
                    case 39:
                        this.readString(code2);
                        return;
                    case 47:
                        this.readToken_slash();
                        return;
                    case 37:
                    case 42:
                        this.readToken_mult_modulo(code2);
                        return;
                    case 124:
                    case 38:
                        this.readToken_pipe_amp(code2);
                        return;
                    case 94:
                        this.readToken_caret();
                        return;
                    case 43:
                    case 45:
                        this.readToken_plus_min(code2);
                        return;
                    case 60:
                        this.readToken_lt();
                        return;
                    case 62:
                        this.readToken_gt();
                        return;
                    case 61:
                    case 33:
                        this.readToken_eq_excl(code2);
                        return;
                    case 126:
                        this.finishOp(36, 1);
                        return;
                    case 64:
                        this.readToken_atSign();
                        return;
                    case 35:
                        this.readToken_numberSign();
                        return;
                    case 92:
                        this.readWord();
                        return;
                    default:
                        if (isIdentifierStart2(code2)) {
                            this.readWord(code2);
                            return;
                        }
                }
                throw this.raise(Errors.InvalidOrUnexpectedToken, this.state.curPosition(), {
                    unexpected: String.fromCodePoint(code2)
                });
            }
        },
        {
            key: "finishOp",
            value: function finishOp(type, size) {
                var str = this.input.slice(this.state.pos, this.state.pos + size);
                this.state.pos += size;
                this.finishToken(type, str);
            }
        },
        {
            key: "readRegexp",
            value: function readRegexp() {
                var startLoc = this.state.startLoc;
                var start = this.state.start + 1;
                var escaped, inClass;
                var pos = this.state.pos;
                for(;; ++pos){
                    if (pos >= this.length) {
                        throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
                    }
                    var ch = this.input.charCodeAt(pos);
                    if (isNewLine(ch)) {
                        throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
                    }
                    if (escaped) {
                        escaped = false;
                    } else {
                        if (ch === 91) {
                            inClass = true;
                        } else if (ch === 93 && inClass) {
                            inClass = false;
                        } else if (ch === 47 && !inClass) {
                            break;
                        }
                        escaped = ch === 92;
                    }
                }
                var content = this.input.slice(start, pos);
                ++pos;
                var mods = "";
                var nextPos = function() {
                    return createPositionWithColumnOffset(startLoc, pos + 2 - start);
                };
                while(pos < this.length){
                    var cp = this.codePointAtPos(pos);
                    var char = String.fromCharCode(cp);
                    if (VALID_REGEX_FLAGS.has(cp)) {
                        if (cp === 118) {
                            if (mods.includes("u")) {
                                this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
                            }
                        } else if (cp === 117) {
                            if (mods.includes("v")) {
                                this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
                            }
                        }
                        if (mods.includes(char)) {
                            this.raise(Errors.DuplicateRegExpFlags, nextPos());
                        }
                    } else if (isIdentifierChar2(cp) || cp === 92) {
                        this.raise(Errors.MalformedRegExpFlags, nextPos());
                    } else {
                        break;
                    }
                    ++pos;
                    mods += char;
                }
                this.state.pos = pos;
                this.finishToken(137, {
                    pattern: content,
                    flags: mods
                });
            }
        },
        {
            key: "readInt",
            value: function readInt(radix, len) {
                var forceLen = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, allowNumSeparator = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
                var _readInt2 = readInt2(this.input, this.state.pos, this.state.lineStart, this.state.curLine, radix, len, forceLen, allowNumSeparator, this.errorHandlers_readInt, false), n2 = _readInt2.n, pos = _readInt2.pos;
                this.state.pos = pos;
                return n2;
            }
        },
        {
            key: "readRadixNumber",
            value: function readRadixNumber(radix) {
                var startLoc = this.state.curPosition();
                var isBigInt = false;
                this.state.pos += 2;
                var val = this.readInt(radix);
                if (val == null) {
                    this.raise(Errors.InvalidDigit, createPositionWithColumnOffset(startLoc, 2), {
                        radix: radix
                    });
                }
                var next = this.input.charCodeAt(this.state.pos);
                if (next === 110) {
                    ++this.state.pos;
                    isBigInt = true;
                } else if (next === 109) {
                    throw this.raise(Errors.InvalidDecimal, startLoc);
                }
                if (isIdentifierStart2(this.codePointAtPos(this.state.pos))) {
                    throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
                }
                if (isBigInt) {
                    var str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
                    this.finishToken(135, str);
                    return;
                }
                this.finishToken(134, val);
            }
        },
        {
            key: "readNumber",
            value: function readNumber(startsWithDot) {
                var start = this.state.pos;
                var startLoc = this.state.curPosition();
                var isFloat = false;
                var isBigInt = false;
                var isDecimal = false;
                var hasExponent = false;
                var isOctal = false;
                if (!startsWithDot && this.readInt(10) === null) {
                    this.raise(Errors.InvalidNumber, this.state.curPosition());
                }
                var hasLeadingZero = this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
                if (hasLeadingZero) {
                    var integer = this.input.slice(start, this.state.pos);
                    this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
                    if (!this.state.strict) {
                        var underscorePos = integer.indexOf("_");
                        if (underscorePos > 0) {
                            this.raise(Errors.ZeroDigitNumericSeparator, createPositionWithColumnOffset(startLoc, underscorePos));
                        }
                    }
                    isOctal = hasLeadingZero && !/[89]/.test(integer);
                }
                var next = this.input.charCodeAt(this.state.pos);
                if (next === 46 && !isOctal) {
                    ++this.state.pos;
                    this.readInt(10);
                    isFloat = true;
                    next = this.input.charCodeAt(this.state.pos);
                }
                if ((next === 69 || next === 101) && !isOctal) {
                    next = this.input.charCodeAt(++this.state.pos);
                    if (next === 43 || next === 45) {
                        ++this.state.pos;
                    }
                    if (this.readInt(10) === null) {
                        this.raise(Errors.InvalidOrMissingExponent, startLoc);
                    }
                    isFloat = true;
                    hasExponent = true;
                    next = this.input.charCodeAt(this.state.pos);
                }
                if (next === 110) {
                    if (isFloat || hasLeadingZero) {
                        this.raise(Errors.InvalidBigIntLiteral, startLoc);
                    }
                    ++this.state.pos;
                    isBigInt = true;
                }
                if (next === 109) {
                    this.expectPlugin("decimal", this.state.curPosition());
                    if (hasExponent || hasLeadingZero) {
                        this.raise(Errors.InvalidDecimal, startLoc);
                    }
                    ++this.state.pos;
                    isDecimal = true;
                }
                if (isIdentifierStart2(this.codePointAtPos(this.state.pos))) {
                    throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
                }
                var str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, "");
                if (isBigInt) {
                    this.finishToken(135, str);
                    return;
                }
                if (isDecimal) {
                    this.finishToken(136, str);
                    return;
                }
                var val = isOctal ? parseInt(str, 8) : parseFloat(str);
                this.finishToken(134, val);
            }
        },
        {
            key: "readCodePoint",
            value: function readCodePoint(throwOnInvalid) {
                var _readCodePoint2 = readCodePoint2(this.input, this.state.pos, this.state.lineStart, this.state.curLine, throwOnInvalid, this.errorHandlers_readCodePoint), code2 = _readCodePoint2.code, pos = _readCodePoint2.pos;
                this.state.pos = pos;
                return code2;
            }
        },
        {
            key: "readString",
            value: function readString(quote) {
                var _readStringContents2 = readStringContents2(quote === 34 ? "double" : "single", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_string), str = _readStringContents2.str, pos = _readStringContents2.pos, curLine = _readStringContents2.curLine, lineStart = _readStringContents2.lineStart;
                this.state.pos = pos + 1;
                this.state.lineStart = lineStart;
                this.state.curLine = curLine;
                this.finishToken(133, str);
            }
        },
        {
            key: "readTemplateContinuation",
            value: function readTemplateContinuation() {
                if (!this.match(8)) {
                    this.unexpected(null, 8);
                }
                this.state.pos--;
                this.readTemplateToken();
            }
        },
        {
            key: "readTemplateToken",
            value: function readTemplateToken() {
                var opening = this.input[this.state.pos];
                var _readStringContents2 = readStringContents2("template", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_template), str = _readStringContents2.str, firstInvalidLoc = _readStringContents2.firstInvalidLoc, pos = _readStringContents2.pos, curLine = _readStringContents2.curLine, lineStart = _readStringContents2.lineStart;
                this.state.pos = pos + 1;
                this.state.lineStart = lineStart;
                this.state.curLine = curLine;
                if (firstInvalidLoc) {
                    this.state.firstInvalidTemplateEscapePos = new Position(firstInvalidLoc.curLine, firstInvalidLoc.pos - firstInvalidLoc.lineStart, firstInvalidLoc.pos);
                }
                if (this.input.codePointAt(pos) === 96) {
                    this.finishToken(24, firstInvalidLoc ? null : opening + str + "`");
                } else {
                    this.state.pos++;
                    this.finishToken(25, firstInvalidLoc ? null : opening + str + "${");
                }
            }
        },
        {
            key: "recordStrictModeErrors",
            value: function recordStrictModeErrors(toParseError, at) {
                var index3 = at.index;
                if (this.state.strict && !this.state.strictErrors.has(index3)) {
                    this.raise(toParseError, at);
                } else {
                    this.state.strictErrors.set(index3, [
                        toParseError,
                        at
                    ]);
                }
            }
        },
        {
            key: "readWord1",
            value: function readWord1(firstCode) {
                this.state.containsEsc = false;
                var word = "";
                var start = this.state.pos;
                var chunkStart = this.state.pos;
                if (firstCode !== void 0) {
                    this.state.pos += firstCode <= 65535 ? 1 : 2;
                }
                while(this.state.pos < this.length){
                    var ch = this.codePointAtPos(this.state.pos);
                    if (isIdentifierChar2(ch)) {
                        this.state.pos += ch <= 65535 ? 1 : 2;
                    } else if (ch === 92) {
                        this.state.containsEsc = true;
                        word += this.input.slice(chunkStart, this.state.pos);
                        var escStart = this.state.curPosition();
                        var identifierCheck = this.state.pos === start ? isIdentifierStart2 : isIdentifierChar2;
                        if (this.input.charCodeAt(++this.state.pos) !== 117) {
                            this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
                            chunkStart = this.state.pos - 1;
                            continue;
                        }
                        ++this.state.pos;
                        var esc = this.readCodePoint(true);
                        if (esc !== null) {
                            if (!identifierCheck(esc)) {
                                this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
                            }
                            word += String.fromCodePoint(esc);
                        }
                        chunkStart = this.state.pos;
                    } else {
                        break;
                    }
                }
                return word + this.input.slice(chunkStart, this.state.pos);
            }
        },
        {
            key: "readWord",
            value: function readWord(firstCode) {
                var word = this.readWord1(firstCode);
                var type = keywords$1.get(word);
                if (type !== void 0) {
                    this.finishToken(type, tokenLabelName(type));
                } else {
                    this.finishToken(132, word);
                }
            }
        },
        {
            key: "checkKeywordEscapes",
            value: function checkKeywordEscapes() {
                var type = this.state.type;
                if (tokenIsKeyword(type) && this.state.containsEsc) {
                    this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
                        reservedWord: tokenLabelName(type)
                    });
                }
            }
        },
        {
            key: "raise",
            value: function raise(toParseError, at) {
                var details = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                var loc = _instanceof(at, Position) ? at : at.loc.start;
                var error = toParseError(loc, details);
                if (!this.options.errorRecovery) throw error;
                if (!this.isLookahead) this.state.errors.push(error);
                return error;
            }
        },
        {
            key: "raiseOverwrite",
            value: function raiseOverwrite(toParseError, at) {
                var details = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                var loc = _instanceof(at, Position) ? at : at.loc.start;
                var pos = loc.index;
                var errors = this.state.errors;
                for(var i = errors.length - 1; i >= 0; i--){
                    var error = errors[i];
                    if (error.loc.index === pos) {
                        return errors[i] = toParseError(loc, details);
                    }
                    if (error.loc.index < pos) break;
                }
                return this.raise(toParseError, at, details);
            }
        },
        {
            key: "updateContext",
            value: function updateContext(prevType) {}
        },
        {
            key: "unexpected",
            value: function unexpected(loc, type) {
                throw this.raise(Errors.UnexpectedToken, loc != null ? loc : this.state.startLoc, {
                    expected: type ? tokenLabelName(type) : null
                });
            }
        },
        {
            key: "expectPlugin",
            value: function expectPlugin(pluginName, loc) {
                if (this.hasPlugin(pluginName)) {
                    return true;
                }
                throw this.raise(Errors.MissingPlugin, loc != null ? loc : this.state.startLoc, {
                    missingPlugin: [
                        pluginName
                    ]
                });
            }
        },
        {
            key: "expectOnePlugin",
            value: function expectOnePlugin(pluginNames) {
                var _this = this;
                if (!pluginNames.some(function(name) {
                    return _this.hasPlugin(name);
                })) {
                    throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
                        missingPlugin: pluginNames
                    });
                }
            }
        },
        {
            key: "errorBuilder",
            value: function errorBuilder(error) {
                var _this = this;
                return function(pos, lineStart, curLine) {
                    _this.raise(error, buildPosition(pos, lineStart, curLine));
                };
            }
        }
    ]);
    return Tokenizer;
}(CommentsParser);
var ClassScope = function ClassScope() {
    "use strict";
    _class_call_check(this, ClassScope);
    __publicField(this, "privateNames", /* @__PURE__ */ new Set());
    __publicField(this, "loneAccessors", /* @__PURE__ */ new Map());
    __publicField(this, "undefinedPrivateNames", /* @__PURE__ */ new Map());
};
var ClassScopeHandler = /*#__PURE__*/ function() {
    "use strict";
    function ClassScopeHandler(parser) {
        _class_call_check(this, ClassScopeHandler);
        __publicField(this, "parser");
        __publicField(this, "stack", []);
        __publicField(this, "undefinedPrivateNames", /* @__PURE__ */ new Map());
        this.parser = parser;
    }
    _create_class(ClassScopeHandler, [
        {
            key: "current",
            value: function current() {
                return this.stack[this.stack.length - 1];
            }
        },
        {
            key: "enter",
            value: function enter() {
                this.stack.push(new ClassScope());
            }
        },
        {
            key: "exit",
            value: function exit() {
                var oldClassScope = this.stack.pop();
                var current = this.current();
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = Array.from(oldClassScope.undefinedPrivateNames)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var _step_value = _sliced_to_array(_step.value, 2), name = _step_value[0], loc = _step_value[1];
                        if (current) {
                            if (!current.undefinedPrivateNames.has(name)) {
                                current.undefinedPrivateNames.set(name, loc);
                            }
                        } else {
                            this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
                                identifierName: name
                            });
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        },
        {
            key: "declarePrivateName",
            value: function declarePrivateName(name, elementType, loc) {
                var _this_current = this.current(), privateNames = _this_current.privateNames, loneAccessors = _this_current.loneAccessors, undefinedPrivateNames = _this_current.undefinedPrivateNames;
                var redefined = privateNames.has(name);
                if (elementType & 3) {
                    var accessor = redefined && loneAccessors.get(name);
                    if (accessor) {
                        var oldStatic = accessor & 4;
                        var newStatic = elementType & 4;
                        var oldKind = accessor & 3;
                        var newKind = elementType & 3;
                        redefined = oldKind === newKind || oldStatic !== newStatic;
                        if (!redefined) loneAccessors.delete(name);
                    } else if (!redefined) {
                        loneAccessors.set(name, elementType);
                    }
                }
                if (redefined) {
                    this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
                        identifierName: name
                    });
                }
                privateNames.add(name);
                undefinedPrivateNames.delete(name);
            }
        },
        {
            key: "usePrivateName",
            value: function usePrivateName(name, loc) {
                var classScope;
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = this.stack[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        classScope = _step.value;
                        if (classScope.privateNames.has(name)) return;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                if (classScope) {
                    classScope.undefinedPrivateNames.set(name, loc);
                } else {
                    this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
                        identifierName: name
                    });
                }
            }
        }
    ]);
    return ClassScopeHandler;
}();
var ExpressionScope = /*#__PURE__*/ function() {
    "use strict";
    function ExpressionScope() {
        var type = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
        _class_call_check(this, ExpressionScope);
        this.type = type;
    }
    _create_class(ExpressionScope, [
        {
            key: "canBeArrowParameterDeclaration",
            value: function canBeArrowParameterDeclaration() {
                return this.type === 2 || this.type === 1;
            }
        },
        {
            key: "isCertainlyParameterDeclaration",
            value: function isCertainlyParameterDeclaration() {
                return this.type === 3;
            }
        }
    ]);
    return ExpressionScope;
}();
var ArrowHeadParsingScope = /*#__PURE__*/ function(ExpressionScope) {
    "use strict";
    _inherits(ArrowHeadParsingScope, ExpressionScope);
    var _super = _create_super(ArrowHeadParsingScope);
    function ArrowHeadParsingScope(type) {
        _class_call_check(this, ArrowHeadParsingScope);
        var _this;
        _this = _super.call(this, type);
        __publicField(_assert_this_initialized(_this), "declarationErrors", /* @__PURE__ */ new Map());
        return _this;
    }
    _create_class(ArrowHeadParsingScope, [
        {
            key: "recordDeclarationError",
            value: function recordDeclarationError(ParsingErrorClass, at) {
                var index3 = at.index;
                this.declarationErrors.set(index3, [
                    ParsingErrorClass,
                    at
                ]);
            }
        },
        {
            key: "clearDeclarationError",
            value: function clearDeclarationError(index3) {
                this.declarationErrors.delete(index3);
            }
        },
        {
            key: "iterateErrors",
            value: function iterateErrors(iterator) {
                this.declarationErrors.forEach(iterator);
            }
        }
    ]);
    return ArrowHeadParsingScope;
}(ExpressionScope);
var ExpressionScopeHandler = /*#__PURE__*/ function() {
    "use strict";
    function ExpressionScopeHandler(parser) {
        _class_call_check(this, ExpressionScopeHandler);
        __publicField(this, "parser");
        __publicField(this, "stack", [
            new ExpressionScope()
        ]);
        this.parser = parser;
    }
    _create_class(ExpressionScopeHandler, [
        {
            key: "enter",
            value: function enter(scope2) {
                this.stack.push(scope2);
            }
        },
        {
            key: "exit",
            value: function exit() {
                this.stack.pop();
            }
        },
        {
            key: "recordParameterInitializerError",
            value: function recordParameterInitializerError(toParseError, node) {
                var origin = node.loc.start;
                var stack = this.stack;
                var i = stack.length - 1;
                var scope2 = stack[i];
                while(!scope2.isCertainlyParameterDeclaration()){
                    if (scope2.canBeArrowParameterDeclaration()) {
                        scope2.recordDeclarationError(toParseError, origin);
                    } else {
                        return;
                    }
                    scope2 = stack[--i];
                }
                this.parser.raise(toParseError, origin);
            }
        },
        {
            key: "recordArrowParameterBindingError",
            value: function recordArrowParameterBindingError(error, node) {
                var stack = this.stack;
                var scope2 = stack[stack.length - 1];
                var origin = node.loc.start;
                if (scope2.isCertainlyParameterDeclaration()) {
                    this.parser.raise(error, origin);
                } else if (scope2.canBeArrowParameterDeclaration()) {
                    scope2.recordDeclarationError(error, origin);
                } else {
                    return;
                }
            }
        },
        {
            key: "recordAsyncArrowParametersError",
            value: function recordAsyncArrowParametersError(at) {
                var stack = this.stack;
                var i = stack.length - 1;
                var scope2 = stack[i];
                while(scope2.canBeArrowParameterDeclaration()){
                    if (scope2.type === 2) {
                        scope2.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
                    }
                    scope2 = stack[--i];
                }
            }
        },
        {
            key: "validateAsPattern",
            value: function validateAsPattern() {
                var _this = this;
                var stack = this.stack;
                var currentScope = stack[stack.length - 1];
                if (!currentScope.canBeArrowParameterDeclaration()) return;
                currentScope.iterateErrors(function(param) {
                    var _$_param = _sliced_to_array(param, 2), toParseError = _$_param[0], loc = _$_param[1];
                    _this.parser.raise(toParseError, loc);
                    var i = stack.length - 2;
                    var scope2 = stack[i];
                    while(scope2.canBeArrowParameterDeclaration()){
                        scope2.clearDeclarationError(loc.index);
                        scope2 = stack[--i];
                    }
                });
            }
        }
    ]);
    return ExpressionScopeHandler;
}();
function newParameterDeclarationScope() {
    return new ExpressionScope(3);
}
function newArrowHeadScope() {
    return new ArrowHeadParsingScope(1);
}
function newAsyncArrowScope() {
    return new ArrowHeadParsingScope(2);
}
function newExpressionScope() {
    return new ExpressionScope();
}
var ProductionParameterHandler = /*#__PURE__*/ function() {
    "use strict";
    function ProductionParameterHandler() {
        _class_call_check(this, ProductionParameterHandler);
        __publicField(this, "stacks", []);
    }
    _create_class(ProductionParameterHandler, [
        {
            key: "enter",
            value: function enter(flags) {
                this.stacks.push(flags);
            }
        },
        {
            key: "exit",
            value: function exit() {
                this.stacks.pop();
            }
        },
        {
            key: "currentFlags",
            value: function currentFlags() {
                return this.stacks[this.stacks.length - 1];
            }
        },
        {
            key: "hasAwait",
            get: function get() {
                return (this.currentFlags() & 2) > 0;
            }
        },
        {
            key: "hasYield",
            get: function get() {
                return (this.currentFlags() & 1) > 0;
            }
        },
        {
            key: "hasReturn",
            get: function get() {
                return (this.currentFlags() & 4) > 0;
            }
        },
        {
            key: "hasIn",
            get: function get() {
                return (this.currentFlags() & 8) > 0;
            }
        }
    ]);
    return ProductionParameterHandler;
}();
function functionFlags(isAsync, isGenerator) {
    return (isAsync ? 2 : 0) | (isGenerator ? 1 : 0);
}
var UtilParser = /*#__PURE__*/ function(Tokenizer) {
    "use strict";
    _inherits(UtilParser, Tokenizer);
    var _super = _create_super(UtilParser);
    function UtilParser() {
        _class_call_check(this, UtilParser);
        return _super.apply(this, arguments);
    }
    _create_class(UtilParser, [
        {
            key: "addExtra",
            value: function addExtra(node, key, value1) {
                var enumerable = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
                if (!node) return;
                var extra = node.extra = node.extra || {};
                if (enumerable) {
                    extra[key] = value1;
                } else {
                    Object.defineProperty(extra, key, {
                        enumerable: enumerable,
                        value: value1
                    });
                }
            }
        },
        {
            key: "isContextual",
            value: function isContextual(token) {
                return this.state.type === token && !this.state.containsEsc;
            }
        },
        {
            key: "isUnparsedContextual",
            value: function isUnparsedContextual(nameStart, name) {
                var nameEnd = nameStart + name.length;
                if (this.input.slice(nameStart, nameEnd) === name) {
                    var nextCh = this.input.charCodeAt(nameEnd);
                    return !(isIdentifierChar2(nextCh) || (nextCh & 64512) === 55296);
                }
                return false;
            }
        },
        {
            key: "isLookaheadContextual",
            value: function isLookaheadContextual(name) {
                var next = this.nextTokenStart();
                return this.isUnparsedContextual(next, name);
            }
        },
        {
            key: "eatContextual",
            value: function eatContextual(token) {
                if (this.isContextual(token)) {
                    this.next();
                    return true;
                }
                return false;
            }
        },
        {
            key: "expectContextual",
            value: function expectContextual(token, toParseError) {
                if (!this.eatContextual(token)) {
                    if (toParseError != null) {
                        throw this.raise(toParseError, this.state.startLoc);
                    }
                    this.unexpected(null, token);
                }
            }
        },
        {
            key: "canInsertSemicolon",
            value: function canInsertSemicolon() {
                return this.match(139) || this.match(8) || this.hasPrecedingLineBreak();
            }
        },
        {
            key: "hasPrecedingLineBreak",
            value: function hasPrecedingLineBreak() {
                return lineBreak.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
            }
        },
        {
            key: "hasFollowingLineBreak",
            value: function hasFollowingLineBreak() {
                skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
                return skipWhiteSpaceToLineBreak.test(this.input);
            }
        },
        {
            key: "isLineTerminator",
            value: function isLineTerminator() {
                return this.eat(13) || this.canInsertSemicolon();
            }
        },
        {
            key: "semicolon",
            value: function semicolon() {
                var allowAsi = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
                if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
                this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
            }
        },
        {
            key: "expect",
            value: function expect(type, loc) {
                this.eat(type) || this.unexpected(loc, type);
            }
        },
        {
            key: "tryParse",
            value: function tryParse(fn) {
                var oldState = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.clone();
                var abortSignal = {
                    node: null
                };
                try {
                    var node = fn(function() {
                        var node2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
                        abortSignal.node = node2;
                        throw abortSignal;
                    });
                    if (this.state.errors.length > oldState.errors.length) {
                        var failState = this.state;
                        this.state = oldState;
                        this.state.tokensLength = failState.tokensLength;
                        return {
                            node: node,
                            error: failState.errors[oldState.errors.length],
                            thrown: false,
                            aborted: false,
                            failState: failState
                        };
                    }
                    return {
                        node: node,
                        error: null,
                        thrown: false,
                        aborted: false,
                        failState: null
                    };
                } catch (error) {
                    var failState1 = this.state;
                    this.state = oldState;
                    if (_instanceof(error, SyntaxError)) {
                        return {
                            node: null,
                            error: error,
                            thrown: true,
                            aborted: false,
                            failState: failState1
                        };
                    }
                    if (error === abortSignal) {
                        return {
                            node: abortSignal.node,
                            error: null,
                            thrown: false,
                            aborted: true,
                            failState: failState1
                        };
                    }
                    throw error;
                }
            }
        },
        {
            key: "checkExpressionErrors",
            value: function checkExpressionErrors(refExpressionErrors, andThrow) {
                if (!refExpressionErrors) return false;
                var shorthandAssignLoc = refExpressionErrors.shorthandAssignLoc, doubleProtoLoc = refExpressionErrors.doubleProtoLoc, privateKeyLoc = refExpressionErrors.privateKeyLoc, optionalParametersLoc = refExpressionErrors.optionalParametersLoc;
                var hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;
                if (!andThrow) {
                    return hasErrors;
                }
                if (shorthandAssignLoc != null) {
                    this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
                }
                if (doubleProtoLoc != null) {
                    this.raise(Errors.DuplicateProto, doubleProtoLoc);
                }
                if (privateKeyLoc != null) {
                    this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
                }
                if (optionalParametersLoc != null) {
                    this.unexpected(optionalParametersLoc);
                }
            }
        },
        {
            key: "isLiteralPropertyName",
            value: function isLiteralPropertyName() {
                return tokenIsLiteralPropertyName(this.state.type);
            }
        },
        {
            key: "isPrivateName",
            value: function isPrivateName(node) {
                return node.type === "PrivateName";
            }
        },
        {
            key: "getPrivateNameSV",
            value: function getPrivateNameSV(node) {
                return node.id.name;
            }
        },
        {
            key: "hasPropertyAsPrivateName",
            value: function hasPropertyAsPrivateName(node) {
                return (node.type === "MemberExpression" || node.type === "OptionalMemberExpression") && this.isPrivateName(node.property);
            }
        },
        {
            key: "isObjectProperty",
            value: function isObjectProperty(node) {
                return node.type === "ObjectProperty";
            }
        },
        {
            key: "isObjectMethod",
            value: function isObjectMethod(node) {
                return node.type === "ObjectMethod";
            }
        },
        {
            key: "initializeScopes",
            value: function initializeScopes() {
                var _this = this;
                var inModule = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.options.sourceType === "module";
                var oldLabels = this.state.labels;
                this.state.labels = [];
                var oldExportedIdentifiers = this.exportedIdentifiers;
                this.exportedIdentifiers = /* @__PURE__ */ new Set();
                var oldInModule = this.inModule;
                this.inModule = inModule;
                var oldScope = this.scope;
                var ScopeHandler2 = this.getScopeHandler();
                this.scope = new ScopeHandler2(this, inModule);
                var oldProdParam = this.prodParam;
                this.prodParam = new ProductionParameterHandler();
                var oldClassScope = this.classScope;
                this.classScope = new ClassScopeHandler(this);
                var oldExpressionScope = this.expressionScope;
                this.expressionScope = new ExpressionScopeHandler(this);
                return function() {
                    _this.state.labels = oldLabels;
                    _this.exportedIdentifiers = oldExportedIdentifiers;
                    _this.inModule = oldInModule;
                    _this.scope = oldScope;
                    _this.prodParam = oldProdParam;
                    _this.classScope = oldClassScope;
                    _this.expressionScope = oldExpressionScope;
                };
            }
        },
        {
            key: "enterInitialScopes",
            value: function enterInitialScopes() {
                var paramFlags = 0;
                if (this.inModule) {
                    paramFlags |= 2;
                }
                this.scope.enter(1);
                this.prodParam.enter(paramFlags);
            }
        },
        {
            key: "checkDestructuringPrivate",
            value: function checkDestructuringPrivate(refExpressionErrors) {
                var privateKeyLoc = refExpressionErrors.privateKeyLoc;
                if (privateKeyLoc !== null) {
                    this.expectPlugin("destructuringPrivate", privateKeyLoc);
                }
            }
        }
    ]);
    return UtilParser;
}(Tokenizer);
var ExpressionErrors = function ExpressionErrors() {
    "use strict";
    _class_call_check(this, ExpressionErrors);
    __publicField(this, "shorthandAssignLoc", null);
    __publicField(this, "doubleProtoLoc", null);
    __publicField(this, "privateKeyLoc", null);
    __publicField(this, "optionalParametersLoc", null);
};
var Node = function Node(parser, pos, loc) {
    "use strict";
    _class_call_check(this, Node);
    __publicField(this, "type", "");
    this.start = pos;
    this.end = 0;
    this.loc = new SourceLocation(loc);
    if (parser === null || parser === void 0 ? void 0 : parser.options.ranges) this.range = [
        pos,
        0
    ];
    if (parser === null || parser === void 0 ? void 0 : parser.filename) this.loc.filename = parser.filename;
};
var NodePrototype = Node.prototype;
function clonePlaceholder(node) {
    return cloneIdentifier(node);
}
function cloneIdentifier(node) {
    var type = node.type, start = node.start, end = node.end, loc = node.loc, range = node.range, extra = node.extra, name = node.name;
    var cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    cloned.extra = extra;
    cloned.name = name;
    if (type === "Placeholder") {
        cloned.expectedNode = node.expectedNode;
    }
    return cloned;
}
function cloneStringLiteral(node) {
    var type = node.type, start = node.start, end = node.end, loc = node.loc, range = node.range, extra = node.extra;
    if (type === "Placeholder") {
        return clonePlaceholder(node);
    }
    var cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    if (node.raw !== void 0) {
        cloned.raw = node.raw;
    } else {
        cloned.extra = extra;
    }
    cloned.value = node.value;
    return cloned;
}
var NodeUtils = /*#__PURE__*/ function(UtilParser) {
    "use strict";
    _inherits(NodeUtils, UtilParser);
    var _super = _create_super(NodeUtils);
    function NodeUtils() {
        _class_call_check(this, NodeUtils);
        return _super.apply(this, arguments);
    }
    _create_class(NodeUtils, [
        {
            key: "startNode",
            value: function startNode() {
                var loc = this.state.startLoc;
                return new Node(this, loc.index, loc);
            }
        },
        {
            key: "startNodeAt",
            value: function startNodeAt(loc) {
                return new Node(this, loc.index, loc);
            }
        },
        {
            key: "startNodeAtNode",
            value: function startNodeAtNode(type) {
                return this.startNodeAt(type.loc.start);
            }
        },
        {
            key: "finishNode",
            value: function finishNode(node, type) {
                return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
            }
        },
        {
            key: "finishNodeAt",
            value: function finishNodeAt(node, type, endLoc) {
                node.type = type;
                node.end = endLoc.index;
                node.loc.end = endLoc;
                if (this.options.ranges) node.range[1] = endLoc.index;
                if (this.options.attachComment) this.processComment(node);
                return node;
            }
        },
        {
            key: "resetStartLocation",
            value: function resetStartLocation(node, startLoc) {
                node.start = startLoc.index;
                node.loc.start = startLoc;
                if (this.options.ranges) node.range[0] = startLoc.index;
            }
        },
        {
            key: "resetEndLocation",
            value: function resetEndLocation(node) {
                var endLoc = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
                node.end = endLoc.index;
                node.loc.end = endLoc;
                if (this.options.ranges) node.range[1] = endLoc.index;
            }
        },
        {
            key: "resetStartLocationFromNode",
            value: function resetStartLocationFromNode(node, locationNode) {
                this.resetStartLocation(node, locationNode.loc.start);
            }
        }
    ]);
    return NodeUtils;
}(UtilParser);
var reservedTypes = /* @__PURE__ */ new Set([
    "_",
    "any",
    "bool",
    "boolean",
    "empty",
    "extends",
    "false",
    "interface",
    "mixed",
    "null",
    "number",
    "static",
    "string",
    "true",
    "typeof",
    "void"
]);
var FlowErrors = ParseErrorEnum(_templateObject1())({
    AmbiguousConditionalArrow: "Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.",
    AmbiguousDeclareModuleKind: "Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.",
    AssignReservedType: function(param) {
        var reservedType = param.reservedType;
        return "Cannot overwrite reserved type ".concat(reservedType, ".");
    },
    DeclareClassElement: "The `declare` modifier can only appear on class fields.",
    DeclareClassFieldInitializer: "Initializers are not allowed in fields with the `declare` modifier.",
    DuplicateDeclareModuleExports: "Duplicate `declare module.exports` statement.",
    EnumBooleanMemberNotInitialized: function(param) {
        var memberName = param.memberName, enumName = param.enumName;
        return "Boolean enum members need to be initialized. Use either `".concat(memberName, " = true,` or `").concat(memberName, " = false,` in enum `").concat(enumName, "`.");
    },
    EnumDuplicateMemberName: function(param) {
        var memberName = param.memberName, enumName = param.enumName;
        return "Enum member names need to be unique, but the name `".concat(memberName, "` has already been used before in enum `").concat(enumName, "`.");
    },
    EnumInconsistentMemberValues: function(param) {
        var enumName = param.enumName;
        return "Enum `".concat(enumName, "` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.");
    },
    EnumInvalidExplicitType: function(param) {
        var invalidEnumType = param.invalidEnumType, enumName = param.enumName;
        return "Enum type `".concat(invalidEnumType, "` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `").concat(enumName, "`.");
    },
    EnumInvalidExplicitTypeUnknownSupplied: function(param) {
        var enumName = param.enumName;
        return "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `".concat(enumName, "`.");
    },
    EnumInvalidMemberInitializerPrimaryType: function(param) {
        var enumName = param.enumName, memberName = param.memberName, explicitType = param.explicitType;
        return "Enum `".concat(enumName, "` has type `").concat(explicitType, "`, so the initializer of `").concat(memberName, "` needs to be a ").concat(explicitType, " literal.");
    },
    EnumInvalidMemberInitializerSymbolType: function(param) {
        var enumName = param.enumName, memberName = param.memberName;
        return "Symbol enum members cannot be initialized. Use `".concat(memberName, ",` in enum `").concat(enumName, "`.");
    },
    EnumInvalidMemberInitializerUnknownType: function(param) {
        var enumName = param.enumName, memberName = param.memberName;
        return "The enum member initializer for `".concat(memberName, "` needs to be a literal (either a boolean, number, or string) in enum `").concat(enumName, "`.");
    },
    EnumInvalidMemberName: function(param) {
        var enumName = param.enumName, memberName = param.memberName, suggestion = param.suggestion;
        return "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `".concat(memberName, "`, consider using `").concat(suggestion, "`, in enum `").concat(enumName, "`.");
    },
    EnumNumberMemberNotInitialized: function(param) {
        var enumName = param.enumName, memberName = param.memberName;
        return "Number enum members need to be initialized, e.g. `".concat(memberName, " = 1` in enum `").concat(enumName, "`.");
    },
    EnumStringMemberInconsistentlyInitialized: function(param) {
        var enumName = param.enumName;
        return "String enum members need to consistently either all use initializers, or use no initializers, in enum `".concat(enumName, "`.");
    },
    GetterMayNotHaveThisParam: "A getter cannot have a `this` parameter.",
    ImportReflectionHasImportType: "An `import module` declaration can not use `type` or `typeof` keyword.",
    ImportTypeShorthandOnlyInPureImport: "The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.",
    InexactInsideExact: "Explicit inexact syntax cannot appear inside an explicit exact object type.",
    InexactInsideNonObject: "Explicit inexact syntax cannot appear in class or interface definitions.",
    InexactVariance: "Explicit inexact syntax cannot have variance.",
    InvalidNonTypeImportInDeclareModule: "Imports within a `declare module` body must always be `import type` or `import typeof`.",
    MissingTypeParamDefault: "Type parameter declaration needs a default, since a preceding type parameter declaration has a default.",
    NestedDeclareModule: "`declare module` cannot be used inside another `declare module`.",
    NestedFlowComment: "Cannot have a flow comment inside another flow comment.",
    PatternIsOptional: Object.assign({
        message: "A binding pattern parameter cannot be optional in an implementation signature."
    }, {}),
    SetterMayNotHaveThisParam: "A setter cannot have a `this` parameter.",
    SpreadVariance: "Spread properties cannot have variance.",
    ThisParamAnnotationRequired: "A type annotation is required for the `this` parameter.",
    ThisParamBannedInConstructor: "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
    ThisParamMayNotBeOptional: "The `this` parameter cannot be optional.",
    ThisParamMustBeFirst: "The `this` parameter must be the first function parameter.",
    ThisParamNoDefault: "The `this` parameter may not have a default value.",
    TypeBeforeInitializer: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
    TypeCastInPattern: "The type cast expression is expected to be wrapped with parenthesis.",
    UnexpectedExplicitInexactInObject: "Explicit inexact syntax must appear at the end of an inexact object.",
    UnexpectedReservedType: function(param) {
        var reservedType = param.reservedType;
        return "Unexpected reserved type ".concat(reservedType, ".");
    },
    UnexpectedReservedUnderscore: "`_` is only allowed as a type argument to call or new.",
    UnexpectedSpaceBetweenModuloChecks: "Spaces between `%` and `checks` are not allowed here.",
    UnexpectedSpreadType: "Spread operator cannot appear in class or interface definitions.",
    UnexpectedSubtractionOperand: 'Unexpected token, expected "number" or "bigint".',
    UnexpectedTokenAfterTypeParameter: "Expected an arrow function after this type parameter declaration.",
    UnexpectedTypeParameterBeforeAsyncArrowFunction: "Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.",
    UnsupportedDeclareExportKind: function(param) {
        var unsupportedExportKind = param.unsupportedExportKind, suggestion = param.suggestion;
        return "`declare export ".concat(unsupportedExportKind, "` is not supported. Use `").concat(suggestion, "` instead.");
    },
    UnsupportedStatementInDeclareModule: "Only declares and type imports are allowed inside declare module.",
    UnterminatedFlowComment: "Unterminated flow-comment."
});
function isEsModuleType(bodyElement) {
    return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
}
function hasTypeImportKind(node) {
    return node.importKind === "type" || node.importKind === "typeof";
}
var exportSuggestions = {
    const: "declare export var",
    let: "declare export var",
    type: "export type",
    interface: "export interface"
};
function partition(list, test) {
    var list1 = [];
    var list2 = [];
    for(var i = 0; i < list.length; i++){
        (test(list[i], i, list) ? list1 : list2).push(list[i]);
    }
    return [
        list1,
        list2
    ];
}
var FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
var flow = function(superClass) {
    var FlowParserMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(FlowParserMixin, superClass);
        var _super = _create_super(FlowParserMixin);
        function FlowParserMixin() {
            _class_call_check(this, FlowParserMixin);
            var _this;
            _this = _super.call.apply(_super, [
                this
            ].concat(Array.prototype.slice.call(arguments)));
            __publicField(_assert_this_initialized(_this), "flowPragma");
            return _this;
        }
        _create_class(FlowParserMixin, [
            {
                key: "getScopeHandler",
                value: function getScopeHandler() {
                    return FlowScopeHandler;
                }
            },
            {
                key: "shouldParseTypes",
                value: function shouldParseTypes() {
                    return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
                }
            },
            {
                key: "shouldParseEnums",
                value: function shouldParseEnums() {
                    return !!this.getPluginOption("flow", "enums");
                }
            },
            {
                key: "finishToken",
                value: function finishToken(type, val) {
                    if (type !== 133 && type !== 13 && type !== 28) {
                        if (this.flowPragma === void 0) {
                            this.flowPragma = null;
                        }
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "finishToken", this).call(this, type, val);
                }
            },
            {
                key: "addComment",
                value: function addComment(comment) {
                    if (this.flowPragma === void 0) {
                        var matches = FLOW_PRAGMA_REGEX.exec(comment.value);
                        if (!matches) ;
                        else if (matches[1] === "flow") {
                            this.flowPragma = "flow";
                        } else if (matches[1] === "noflow") {
                            this.flowPragma = "noflow";
                        } else {
                            throw new Error("Unexpected flow pragma");
                        }
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "addComment", this).call(this, comment);
                }
            },
            {
                key: "flowParseTypeInitialiser",
                value: function flowParseTypeInitialiser(tok) {
                    var oldInType = this.state.inType;
                    this.state.inType = true;
                    this.expect(tok || 14);
                    var type = this.flowParseType();
                    this.state.inType = oldInType;
                    return type;
                }
            },
            {
                key: "flowParsePredicate",
                value: function flowParsePredicate() {
                    var node = this.startNode();
                    var moduloLoc = this.state.startLoc;
                    this.next();
                    this.expectContextual(110);
                    if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
                        this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
                    }
                    if (this.eat(10)) {
                        node.value = _get(_get_prototype_of(FlowParserMixin.prototype), "parseExpression", this).call(this);
                        this.expect(11);
                        return this.finishNode(node, "DeclaredPredicate");
                    } else {
                        return this.finishNode(node, "InferredPredicate");
                    }
                }
            },
            {
                key: "flowParseTypeAndPredicateInitialiser",
                value: function flowParseTypeAndPredicateInitialiser() {
                    var oldInType = this.state.inType;
                    this.state.inType = true;
                    this.expect(14);
                    var type = null;
                    var predicate = null;
                    if (this.match(54)) {
                        this.state.inType = oldInType;
                        predicate = this.flowParsePredicate();
                    } else {
                        type = this.flowParseType();
                        this.state.inType = oldInType;
                        if (this.match(54)) {
                            predicate = this.flowParsePredicate();
                        }
                    }
                    return [
                        type,
                        predicate
                    ];
                }
            },
            {
                key: "flowParseDeclareClass",
                value: function flowParseDeclareClass(node) {
                    this.next();
                    this.flowParseInterfaceish(node, true);
                    return this.finishNode(node, "DeclareClass");
                }
            },
            {
                key: "flowParseDeclareFunction",
                value: function flowParseDeclareFunction(node) {
                    this.next();
                    var id = node.id = this.parseIdentifier();
                    var typeNode = this.startNode();
                    var typeContainer = this.startNode();
                    if (this.match(47)) {
                        typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
                    } else {
                        typeNode.typeParameters = null;
                    }
                    this.expect(10);
                    var tmp = this.flowParseFunctionTypeParams();
                    typeNode.params = tmp.params;
                    typeNode.rest = tmp.rest;
                    typeNode.this = tmp._this;
                    this.expect(11);
                    var ref;
                    ref = _sliced_to_array(this.flowParseTypeAndPredicateInitialiser(), 2), typeNode.returnType = ref[0], node.predicate = ref[1], ref;
                    typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
                    id.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
                    this.resetEndLocation(id);
                    this.semicolon();
                    this.scope.declareName(node.id.name, 2048, node.id.loc.start);
                    return this.finishNode(node, "DeclareFunction");
                }
            },
            {
                key: "flowParseDeclare",
                value: function flowParseDeclare(node, insideModule) {
                    if (this.match(80)) {
                        return this.flowParseDeclareClass(node);
                    } else if (this.match(68)) {
                        return this.flowParseDeclareFunction(node);
                    } else if (this.match(74)) {
                        return this.flowParseDeclareVariable(node);
                    } else if (this.eatContextual(127)) {
                        if (this.match(16)) {
                            return this.flowParseDeclareModuleExports(node);
                        } else {
                            if (insideModule) {
                                this.raise(FlowErrors.NestedDeclareModule, this.state.lastTokStartLoc);
                            }
                            return this.flowParseDeclareModule(node);
                        }
                    } else if (this.isContextual(130)) {
                        return this.flowParseDeclareTypeAlias(node);
                    } else if (this.isContextual(131)) {
                        return this.flowParseDeclareOpaqueType(node);
                    } else if (this.isContextual(129)) {
                        return this.flowParseDeclareInterface(node);
                    } else if (this.match(82)) {
                        return this.flowParseDeclareExportDeclaration(node, insideModule);
                    } else {
                        this.unexpected();
                    }
                }
            },
            {
                key: "flowParseDeclareVariable",
                value: function flowParseDeclareVariable(node) {
                    this.next();
                    node.id = this.flowParseTypeAnnotatableIdentifier(true);
                    this.scope.declareName(node.id.name, 5, node.id.loc.start);
                    this.semicolon();
                    return this.finishNode(node, "DeclareVariable");
                }
            },
            {
                key: "flowParseDeclareModule",
                value: function flowParseDeclareModule(node) {
                    var _this = this;
                    this.scope.enter(0);
                    if (this.match(133)) {
                        node.id = _get(_get_prototype_of(FlowParserMixin.prototype), "parseExprAtom", this).call(this);
                    } else {
                        node.id = this.parseIdentifier();
                    }
                    var bodyNode = node.body = this.startNode();
                    var body = bodyNode.body = [];
                    this.expect(5);
                    while(!this.match(8)){
                        var bodyNode2 = this.startNode();
                        if (this.match(83)) {
                            this.next();
                            if (!this.isContextual(130) && !this.match(87)) {
                                this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, this.state.lastTokStartLoc);
                            }
                            _get(_get_prototype_of(FlowParserMixin.prototype), "parseImport", this).call(this, bodyNode2);
                        } else {
                            this.expectContextual(125, FlowErrors.UnsupportedStatementInDeclareModule);
                            bodyNode2 = this.flowParseDeclare(bodyNode2, true);
                        }
                        body.push(bodyNode2);
                    }
                    this.scope.exit();
                    this.expect(8);
                    this.finishNode(bodyNode, "BlockStatement");
                    var kind = null;
                    var hasModuleExport = false;
                    body.forEach(function(bodyElement) {
                        if (isEsModuleType(bodyElement)) {
                            if (kind === "CommonJS") {
                                _this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
                            }
                            kind = "ES";
                        } else if (bodyElement.type === "DeclareModuleExports") {
                            if (hasModuleExport) {
                                _this.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
                            }
                            if (kind === "ES") {
                                _this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
                            }
                            kind = "CommonJS";
                            hasModuleExport = true;
                        }
                    });
                    node.kind = kind || "CommonJS";
                    return this.finishNode(node, "DeclareModule");
                }
            },
            {
                key: "flowParseDeclareExportDeclaration",
                value: function flowParseDeclareExportDeclaration(node, insideModule) {
                    this.expect(82);
                    if (this.eat(65)) {
                        if (this.match(68) || this.match(80)) {
                            node.declaration = this.flowParseDeclare(this.startNode());
                        } else {
                            node.declaration = this.flowParseType();
                            this.semicolon();
                        }
                        node.default = true;
                        return this.finishNode(node, "DeclareExportDeclaration");
                    } else {
                        if (this.match(75) || this.isLet() || (this.isContextual(130) || this.isContextual(129)) && !insideModule) {
                            var label = this.state.value;
                            throw this.raise(FlowErrors.UnsupportedDeclareExportKind, this.state.startLoc, {
                                unsupportedExportKind: label,
                                suggestion: exportSuggestions[label]
                            });
                        }
                        if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(131)) {
                            node.declaration = this.flowParseDeclare(this.startNode());
                            node.default = false;
                            return this.finishNode(node, "DeclareExportDeclaration");
                        } else if (this.match(55) || this.match(5) || this.isContextual(129) || this.isContextual(130) || this.isContextual(131)) {
                            node = this.parseExport(node, null);
                            if (node.type === "ExportNamedDeclaration") {
                                node.type = "ExportDeclaration";
                                node.default = false;
                                delete node.exportKind;
                            }
                            node.type = "Declare" + node.type;
                            return node;
                        }
                    }
                    this.unexpected();
                }
            },
            {
                key: "flowParseDeclareModuleExports",
                value: function flowParseDeclareModuleExports(node) {
                    this.next();
                    this.expectContextual(111);
                    node.typeAnnotation = this.flowParseTypeAnnotation();
                    this.semicolon();
                    return this.finishNode(node, "DeclareModuleExports");
                }
            },
            {
                key: "flowParseDeclareTypeAlias",
                value: function flowParseDeclareTypeAlias(node) {
                    this.next();
                    var finished = this.flowParseTypeAlias(node);
                    finished.type = "DeclareTypeAlias";
                    return finished;
                }
            },
            {
                key: "flowParseDeclareOpaqueType",
                value: function flowParseDeclareOpaqueType(node) {
                    this.next();
                    var finished = this.flowParseOpaqueType(node, true);
                    finished.type = "DeclareOpaqueType";
                    return finished;
                }
            },
            {
                key: "flowParseDeclareInterface",
                value: function flowParseDeclareInterface(node) {
                    this.next();
                    this.flowParseInterfaceish(node, false);
                    return this.finishNode(node, "DeclareInterface");
                }
            },
            {
                key: "flowParseInterfaceish",
                value: function flowParseInterfaceish(node, isClass3) {
                    node.id = this.flowParseRestrictedIdentifier(!isClass3, true);
                    this.scope.declareName(node.id.name, isClass3 ? 17 : 8201, node.id.loc.start);
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    } else {
                        node.typeParameters = null;
                    }
                    node.extends = [];
                    if (this.eat(81)) {
                        do {
                            node.extends.push(this.flowParseInterfaceExtends());
                        }while (!isClass3 && this.eat(12));
                    }
                    if (isClass3) {
                        node.implements = [];
                        node.mixins = [];
                        if (this.eatContextual(117)) {
                            do {
                                node.mixins.push(this.flowParseInterfaceExtends());
                            }while (this.eat(12));
                        }
                        if (this.eatContextual(113)) {
                            do {
                                node.implements.push(this.flowParseInterfaceExtends());
                            }while (this.eat(12));
                        }
                    }
                    node.body = this.flowParseObjectType({
                        allowStatic: isClass3,
                        allowExact: false,
                        allowSpread: false,
                        allowProto: isClass3,
                        allowInexact: false
                    });
                }
            },
            {
                key: "flowParseInterfaceExtends",
                value: function flowParseInterfaceExtends() {
                    var node = this.startNode();
                    node.id = this.flowParseQualifiedTypeIdentifier();
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterInstantiation();
                    } else {
                        node.typeParameters = null;
                    }
                    return this.finishNode(node, "InterfaceExtends");
                }
            },
            {
                key: "flowParseInterface",
                value: function flowParseInterface(node) {
                    this.flowParseInterfaceish(node, false);
                    return this.finishNode(node, "InterfaceDeclaration");
                }
            },
            {
                key: "checkNotUnderscore",
                value: function checkNotUnderscore(word) {
                    if (word === "_") {
                        this.raise(FlowErrors.UnexpectedReservedUnderscore, this.state.startLoc);
                    }
                }
            },
            {
                key: "checkReservedType",
                value: function checkReservedType(word, startLoc, declaration) {
                    if (!reservedTypes.has(word)) return;
                    this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, startLoc, {
                        reservedType: word
                    });
                }
            },
            {
                key: "flowParseRestrictedIdentifier",
                value: function flowParseRestrictedIdentifier(liberal, declaration) {
                    this.checkReservedType(this.state.value, this.state.startLoc, declaration);
                    return this.parseIdentifier(liberal);
                }
            },
            {
                key: "flowParseTypeAlias",
                value: function flowParseTypeAlias(node) {
                    node.id = this.flowParseRestrictedIdentifier(false, true);
                    this.scope.declareName(node.id.name, 8201, node.id.loc.start);
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    } else {
                        node.typeParameters = null;
                    }
                    node.right = this.flowParseTypeInitialiser(29);
                    this.semicolon();
                    return this.finishNode(node, "TypeAlias");
                }
            },
            {
                key: "flowParseOpaqueType",
                value: function flowParseOpaqueType(node, declare) {
                    this.expectContextual(130);
                    node.id = this.flowParseRestrictedIdentifier(true, true);
                    this.scope.declareName(node.id.name, 8201, node.id.loc.start);
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    } else {
                        node.typeParameters = null;
                    }
                    node.supertype = null;
                    if (this.match(14)) {
                        node.supertype = this.flowParseTypeInitialiser(14);
                    }
                    node.impltype = null;
                    if (!declare) {
                        node.impltype = this.flowParseTypeInitialiser(29);
                    }
                    this.semicolon();
                    return this.finishNode(node, "OpaqueType");
                }
            },
            {
                key: "flowParseTypeParameter",
                value: function flowParseTypeParameter() {
                    var requireDefault = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
                    var nodeStartLoc = this.state.startLoc;
                    var node = this.startNode();
                    var variance2 = this.flowParseVariance();
                    var ident = this.flowParseTypeAnnotatableIdentifier();
                    node.name = ident.name;
                    node.variance = variance2;
                    node.bound = ident.typeAnnotation;
                    if (this.match(29)) {
                        this.eat(29);
                        node.default = this.flowParseType();
                    } else {
                        if (requireDefault) {
                            this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
                        }
                    }
                    return this.finishNode(node, "TypeParameter");
                }
            },
            {
                key: "flowParseTypeParameterDeclaration",
                value: function flowParseTypeParameterDeclaration() {
                    var oldInType = this.state.inType;
                    var node = this.startNode();
                    node.params = [];
                    this.state.inType = true;
                    if (this.match(47) || this.match(142)) {
                        this.next();
                    } else {
                        this.unexpected();
                    }
                    var defaultRequired = false;
                    do {
                        var typeParameter2 = this.flowParseTypeParameter(defaultRequired);
                        node.params.push(typeParameter2);
                        if (typeParameter2.default) {
                            defaultRequired = true;
                        }
                        if (!this.match(48)) {
                            this.expect(12);
                        }
                    }while (!this.match(48));
                    this.expect(48);
                    this.state.inType = oldInType;
                    return this.finishNode(node, "TypeParameterDeclaration");
                }
            },
            {
                key: "flowParseTypeParameterInstantiation",
                value: function flowParseTypeParameterInstantiation() {
                    var node = this.startNode();
                    var oldInType = this.state.inType;
                    node.params = [];
                    this.state.inType = true;
                    this.expect(47);
                    var oldNoAnonFunctionType = this.state.noAnonFunctionType;
                    this.state.noAnonFunctionType = false;
                    while(!this.match(48)){
                        node.params.push(this.flowParseType());
                        if (!this.match(48)) {
                            this.expect(12);
                        }
                    }
                    this.state.noAnonFunctionType = oldNoAnonFunctionType;
                    this.expect(48);
                    this.state.inType = oldInType;
                    return this.finishNode(node, "TypeParameterInstantiation");
                }
            },
            {
                key: "flowParseTypeParameterInstantiationCallOrNew",
                value: function flowParseTypeParameterInstantiationCallOrNew() {
                    var node = this.startNode();
                    var oldInType = this.state.inType;
                    node.params = [];
                    this.state.inType = true;
                    this.expect(47);
                    while(!this.match(48)){
                        node.params.push(this.flowParseTypeOrImplicitInstantiation());
                        if (!this.match(48)) {
                            this.expect(12);
                        }
                    }
                    this.expect(48);
                    this.state.inType = oldInType;
                    return this.finishNode(node, "TypeParameterInstantiation");
                }
            },
            {
                key: "flowParseInterfaceType",
                value: function flowParseInterfaceType() {
                    var node = this.startNode();
                    this.expectContextual(129);
                    node.extends = [];
                    if (this.eat(81)) {
                        do {
                            node.extends.push(this.flowParseInterfaceExtends());
                        }while (this.eat(12));
                    }
                    node.body = this.flowParseObjectType({
                        allowStatic: false,
                        allowExact: false,
                        allowSpread: false,
                        allowProto: false,
                        allowInexact: false
                    });
                    return this.finishNode(node, "InterfaceTypeAnnotation");
                }
            },
            {
                key: "flowParseObjectPropertyKey",
                value: function flowParseObjectPropertyKey() {
                    return this.match(134) || this.match(133) ? _get(_get_prototype_of(FlowParserMixin.prototype), "parseExprAtom", this).call(this) : this.parseIdentifier(true);
                }
            },
            {
                key: "flowParseObjectTypeIndexer",
                value: function flowParseObjectTypeIndexer(node, isStatic2, variance2) {
                    node.static = isStatic2;
                    if (this.lookahead().type === 14) {
                        node.id = this.flowParseObjectPropertyKey();
                        node.key = this.flowParseTypeInitialiser();
                    } else {
                        node.id = null;
                        node.key = this.flowParseType();
                    }
                    this.expect(3);
                    node.value = this.flowParseTypeInitialiser();
                    node.variance = variance2;
                    return this.finishNode(node, "ObjectTypeIndexer");
                }
            },
            {
                key: "flowParseObjectTypeInternalSlot",
                value: function flowParseObjectTypeInternalSlot(node, isStatic2) {
                    node.static = isStatic2;
                    node.id = this.flowParseObjectPropertyKey();
                    this.expect(3);
                    this.expect(3);
                    if (this.match(47) || this.match(10)) {
                        node.method = true;
                        node.optional = false;
                        node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
                    } else {
                        node.method = false;
                        if (this.eat(17)) {
                            node.optional = true;
                        }
                        node.value = this.flowParseTypeInitialiser();
                    }
                    return this.finishNode(node, "ObjectTypeInternalSlot");
                }
            },
            {
                key: "flowParseObjectTypeMethodish",
                value: function flowParseObjectTypeMethodish(node) {
                    node.params = [];
                    node.rest = null;
                    node.typeParameters = null;
                    node.this = null;
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    }
                    this.expect(10);
                    if (this.match(78)) {
                        node.this = this.flowParseFunctionTypeParam(true);
                        node.this.name = null;
                        if (!this.match(11)) {
                            this.expect(12);
                        }
                    }
                    while(!this.match(11) && !this.match(21)){
                        node.params.push(this.flowParseFunctionTypeParam(false));
                        if (!this.match(11)) {
                            this.expect(12);
                        }
                    }
                    if (this.eat(21)) {
                        node.rest = this.flowParseFunctionTypeParam(false);
                    }
                    this.expect(11);
                    node.returnType = this.flowParseTypeInitialiser();
                    return this.finishNode(node, "FunctionTypeAnnotation");
                }
            },
            {
                key: "flowParseObjectTypeCallProperty",
                value: function flowParseObjectTypeCallProperty(node, isStatic2) {
                    var valueNode = this.startNode();
                    node.static = isStatic2;
                    node.value = this.flowParseObjectTypeMethodish(valueNode);
                    return this.finishNode(node, "ObjectTypeCallProperty");
                }
            },
            {
                key: "flowParseObjectType",
                value: function flowParseObjectType(param) {
                    var allowStatic = param.allowStatic, allowExact = param.allowExact, allowSpread = param.allowSpread, allowProto = param.allowProto, allowInexact = param.allowInexact;
                    var oldInType = this.state.inType;
                    this.state.inType = true;
                    var nodeStart = this.startNode();
                    nodeStart.callProperties = [];
                    nodeStart.properties = [];
                    nodeStart.indexers = [];
                    nodeStart.internalSlots = [];
                    var endDelim;
                    var exact;
                    var inexact = false;
                    if (allowExact && this.match(6)) {
                        this.expect(6);
                        endDelim = 9;
                        exact = true;
                    } else {
                        this.expect(5);
                        endDelim = 8;
                        exact = false;
                    }
                    nodeStart.exact = exact;
                    while(!this.match(endDelim)){
                        var isStatic2 = false;
                        var protoStartLoc = null;
                        var inexactStartLoc = null;
                        var node = this.startNode();
                        if (allowProto && this.isContextual(118)) {
                            var lookahead = this.lookahead();
                            if (lookahead.type !== 14 && lookahead.type !== 17) {
                                this.next();
                                protoStartLoc = this.state.startLoc;
                                allowStatic = false;
                            }
                        }
                        if (allowStatic && this.isContextual(106)) {
                            var lookahead1 = this.lookahead();
                            if (lookahead1.type !== 14 && lookahead1.type !== 17) {
                                this.next();
                                isStatic2 = true;
                            }
                        }
                        var variance2 = this.flowParseVariance();
                        if (this.eat(0)) {
                            if (protoStartLoc != null) {
                                this.unexpected(protoStartLoc);
                            }
                            if (this.eat(0)) {
                                if (variance2) {
                                    this.unexpected(variance2.loc.start);
                                }
                                nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node, isStatic2));
                            } else {
                                nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node, isStatic2, variance2));
                            }
                        } else if (this.match(10) || this.match(47)) {
                            if (protoStartLoc != null) {
                                this.unexpected(protoStartLoc);
                            }
                            if (variance2) {
                                this.unexpected(variance2.loc.start);
                            }
                            nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node, isStatic2));
                        } else {
                            var kind = "init";
                            if (this.isContextual(99) || this.isContextual(104)) {
                                var lookahead2 = this.lookahead();
                                if (tokenIsLiteralPropertyName(lookahead2.type)) {
                                    kind = this.state.value;
                                    this.next();
                                }
                            }
                            var propOrInexact = this.flowParseObjectTypeProperty(node, isStatic2, protoStartLoc, variance2, kind, allowSpread, allowInexact !== null && allowInexact !== void 0 ? allowInexact : !exact);
                            if (propOrInexact === null) {
                                inexact = true;
                                inexactStartLoc = this.state.lastTokStartLoc;
                            } else {
                                nodeStart.properties.push(propOrInexact);
                            }
                        }
                        this.flowObjectTypeSemicolon();
                        if (inexactStartLoc && !this.match(8) && !this.match(9)) {
                            this.raise(FlowErrors.UnexpectedExplicitInexactInObject, inexactStartLoc);
                        }
                    }
                    this.expect(endDelim);
                    if (allowSpread) {
                        nodeStart.inexact = inexact;
                    }
                    var out = this.finishNode(nodeStart, "ObjectTypeAnnotation");
                    this.state.inType = oldInType;
                    return out;
                }
            },
            {
                key: "flowParseObjectTypeProperty",
                value: function flowParseObjectTypeProperty(node, isStatic2, protoStartLoc, variance2, kind, allowSpread, allowInexact) {
                    if (this.eat(21)) {
                        var isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);
                        if (isInexactToken) {
                            if (!allowSpread) {
                                this.raise(FlowErrors.InexactInsideNonObject, this.state.lastTokStartLoc);
                            } else if (!allowInexact) {
                                this.raise(FlowErrors.InexactInsideExact, this.state.lastTokStartLoc);
                            }
                            if (variance2) {
                                this.raise(FlowErrors.InexactVariance, variance2);
                            }
                            return null;
                        }
                        if (!allowSpread) {
                            this.raise(FlowErrors.UnexpectedSpreadType, this.state.lastTokStartLoc);
                        }
                        if (protoStartLoc != null) {
                            this.unexpected(protoStartLoc);
                        }
                        if (variance2) {
                            this.raise(FlowErrors.SpreadVariance, variance2);
                        }
                        node.argument = this.flowParseType();
                        return this.finishNode(node, "ObjectTypeSpreadProperty");
                    } else {
                        node.key = this.flowParseObjectPropertyKey();
                        node.static = isStatic2;
                        node.proto = protoStartLoc != null;
                        node.kind = kind;
                        var optional = false;
                        if (this.match(47) || this.match(10)) {
                            node.method = true;
                            if (protoStartLoc != null) {
                                this.unexpected(protoStartLoc);
                            }
                            if (variance2) {
                                this.unexpected(variance2.loc.start);
                            }
                            node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
                            if (kind === "get" || kind === "set") {
                                this.flowCheckGetterSetterParams(node);
                            }
                            if (!allowSpread && node.key.name === "constructor" && node.value.this) {
                                this.raise(FlowErrors.ThisParamBannedInConstructor, node.value.this);
                            }
                        } else {
                            if (kind !== "init") this.unexpected();
                            node.method = false;
                            if (this.eat(17)) {
                                optional = true;
                            }
                            node.value = this.flowParseTypeInitialiser();
                            node.variance = variance2;
                        }
                        node.optional = optional;
                        return this.finishNode(node, "ObjectTypeProperty");
                    }
                }
            },
            {
                key: "flowCheckGetterSetterParams",
                value: function flowCheckGetterSetterParams(property) {
                    var paramCount = property.kind === "get" ? 0 : 1;
                    var length = property.value.params.length + (property.value.rest ? 1 : 0);
                    if (property.value.this) {
                        this.raise(property.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, property.value.this);
                    }
                    if (length !== paramCount) {
                        this.raise(property.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, property);
                    }
                    if (property.kind === "set" && property.value.rest) {
                        this.raise(Errors.BadSetterRestParameter, property);
                    }
                }
            },
            {
                key: "flowObjectTypeSemicolon",
                value: function flowObjectTypeSemicolon() {
                    if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
                        this.unexpected();
                    }
                }
            },
            {
                key: "flowParseQualifiedTypeIdentifier",
                value: function flowParseQualifiedTypeIdentifier(startLoc, id) {
                    startLoc !== null && startLoc !== void 0 ? startLoc : startLoc = this.state.startLoc;
                    var node = id || this.flowParseRestrictedIdentifier(true);
                    while(this.eat(16)){
                        var node2 = this.startNodeAt(startLoc);
                        node2.qualification = node;
                        node2.id = this.flowParseRestrictedIdentifier(true);
                        node = this.finishNode(node2, "QualifiedTypeIdentifier");
                    }
                    return node;
                }
            },
            {
                key: "flowParseGenericType",
                value: function flowParseGenericType(startLoc, id) {
                    var node = this.startNodeAt(startLoc);
                    node.typeParameters = null;
                    node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterInstantiation();
                    }
                    return this.finishNode(node, "GenericTypeAnnotation");
                }
            },
            {
                key: "flowParseTypeofType",
                value: function flowParseTypeofType() {
                    var node = this.startNode();
                    this.expect(87);
                    node.argument = this.flowParsePrimaryType();
                    return this.finishNode(node, "TypeofTypeAnnotation");
                }
            },
            {
                key: "flowParseTupleType",
                value: function flowParseTupleType() {
                    var node = this.startNode();
                    node.types = [];
                    this.expect(0);
                    while(this.state.pos < this.length && !this.match(3)){
                        node.types.push(this.flowParseType());
                        if (this.match(3)) break;
                        this.expect(12);
                    }
                    this.expect(3);
                    return this.finishNode(node, "TupleTypeAnnotation");
                }
            },
            {
                key: "flowParseFunctionTypeParam",
                value: function flowParseFunctionTypeParam(first) {
                    var name = null;
                    var optional = false;
                    var typeAnnotation2 = null;
                    var node = this.startNode();
                    var lh = this.lookahead();
                    var isThis = this.state.type === 78;
                    if (lh.type === 14 || lh.type === 17) {
                        if (isThis && !first) {
                            this.raise(FlowErrors.ThisParamMustBeFirst, node);
                        }
                        name = this.parseIdentifier(isThis);
                        if (this.eat(17)) {
                            optional = true;
                            if (isThis) {
                                this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
                            }
                        }
                        typeAnnotation2 = this.flowParseTypeInitialiser();
                    } else {
                        typeAnnotation2 = this.flowParseType();
                    }
                    node.name = name;
                    node.optional = optional;
                    node.typeAnnotation = typeAnnotation2;
                    return this.finishNode(node, "FunctionTypeParam");
                }
            },
            {
                key: "reinterpretTypeAsFunctionTypeParam",
                value: function reinterpretTypeAsFunctionTypeParam(type) {
                    var node = this.startNodeAt(type.loc.start);
                    node.name = null;
                    node.optional = false;
                    node.typeAnnotation = type;
                    return this.finishNode(node, "FunctionTypeParam");
                }
            },
            {
                key: "flowParseFunctionTypeParams",
                value: function flowParseFunctionTypeParams() {
                    var params = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
                    var rest = null;
                    var _this = null;
                    if (this.match(78)) {
                        _this = this.flowParseFunctionTypeParam(true);
                        _this.name = null;
                        if (!this.match(11)) {
                            this.expect(12);
                        }
                    }
                    while(!this.match(11) && !this.match(21)){
                        params.push(this.flowParseFunctionTypeParam(false));
                        if (!this.match(11)) {
                            this.expect(12);
                        }
                    }
                    if (this.eat(21)) {
                        rest = this.flowParseFunctionTypeParam(false);
                    }
                    return {
                        params: params,
                        rest: rest,
                        _this: _this
                    };
                }
            },
            {
                key: "flowIdentToTypeAnnotation",
                value: function flowIdentToTypeAnnotation(startLoc, node, id) {
                    switch(id.name){
                        case "any":
                            return this.finishNode(node, "AnyTypeAnnotation");
                        case "bool":
                        case "boolean":
                            return this.finishNode(node, "BooleanTypeAnnotation");
                        case "mixed":
                            return this.finishNode(node, "MixedTypeAnnotation");
                        case "empty":
                            return this.finishNode(node, "EmptyTypeAnnotation");
                        case "number":
                            return this.finishNode(node, "NumberTypeAnnotation");
                        case "string":
                            return this.finishNode(node, "StringTypeAnnotation");
                        case "symbol":
                            return this.finishNode(node, "SymbolTypeAnnotation");
                        default:
                            this.checkNotUnderscore(id.name);
                            return this.flowParseGenericType(startLoc, id);
                    }
                }
            },
            {
                key: "flowParsePrimaryType",
                value: function flowParsePrimaryType() {
                    var startLoc = this.state.startLoc;
                    var node = this.startNode();
                    var tmp;
                    var type;
                    var isGroupedType = false;
                    var oldNoAnonFunctionType = this.state.noAnonFunctionType;
                    switch(this.state.type){
                        case 5:
                            return this.flowParseObjectType({
                                allowStatic: false,
                                allowExact: false,
                                allowSpread: true,
                                allowProto: false,
                                allowInexact: true
                            });
                        case 6:
                            return this.flowParseObjectType({
                                allowStatic: false,
                                allowExact: true,
                                allowSpread: true,
                                allowProto: false,
                                allowInexact: false
                            });
                        case 0:
                            this.state.noAnonFunctionType = false;
                            type = this.flowParseTupleType();
                            this.state.noAnonFunctionType = oldNoAnonFunctionType;
                            return type;
                        case 47:
                            node.typeParameters = this.flowParseTypeParameterDeclaration();
                            this.expect(10);
                            tmp = this.flowParseFunctionTypeParams();
                            node.params = tmp.params;
                            node.rest = tmp.rest;
                            node.this = tmp._this;
                            this.expect(11);
                            this.expect(19);
                            node.returnType = this.flowParseType();
                            return this.finishNode(node, "FunctionTypeAnnotation");
                        case 10:
                            this.next();
                            if (!this.match(11) && !this.match(21)) {
                                if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                                    var token = this.lookahead().type;
                                    isGroupedType = token !== 17 && token !== 14;
                                } else {
                                    isGroupedType = true;
                                }
                            }
                            if (isGroupedType) {
                                this.state.noAnonFunctionType = false;
                                type = this.flowParseType();
                                this.state.noAnonFunctionType = oldNoAnonFunctionType;
                                if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
                                    this.expect(11);
                                    return type;
                                } else {
                                    this.eat(12);
                                }
                            }
                            if (type) {
                                tmp = this.flowParseFunctionTypeParams([
                                    this.reinterpretTypeAsFunctionTypeParam(type)
                                ]);
                            } else {
                                tmp = this.flowParseFunctionTypeParams();
                            }
                            node.params = tmp.params;
                            node.rest = tmp.rest;
                            node.this = tmp._this;
                            this.expect(11);
                            this.expect(19);
                            node.returnType = this.flowParseType();
                            node.typeParameters = null;
                            return this.finishNode(node, "FunctionTypeAnnotation");
                        case 133:
                            return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
                        case 85:
                        case 86:
                            node.value = this.match(85);
                            this.next();
                            return this.finishNode(node, "BooleanLiteralTypeAnnotation");
                        case 53:
                            if (this.state.value === "-") {
                                this.next();
                                if (this.match(134)) {
                                    return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node);
                                }
                                if (this.match(135)) {
                                    return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node);
                                }
                                throw this.raise(FlowErrors.UnexpectedSubtractionOperand, this.state.startLoc);
                            }
                            this.unexpected();
                            return;
                        case 134:
                            return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
                        case 135:
                            return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
                        case 88:
                            this.next();
                            return this.finishNode(node, "VoidTypeAnnotation");
                        case 84:
                            this.next();
                            return this.finishNode(node, "NullLiteralTypeAnnotation");
                        case 78:
                            this.next();
                            return this.finishNode(node, "ThisTypeAnnotation");
                        case 55:
                            this.next();
                            return this.finishNode(node, "ExistsTypeAnnotation");
                        case 87:
                            return this.flowParseTypeofType();
                        default:
                            if (tokenIsKeyword(this.state.type)) {
                                var label = tokenLabelName(this.state.type);
                                this.next();
                                return _get(_get_prototype_of(FlowParserMixin.prototype), "createIdentifier", this).call(this, node, label);
                            } else if (tokenIsIdentifier(this.state.type)) {
                                if (this.isContextual(129)) {
                                    return this.flowParseInterfaceType();
                                }
                                return this.flowIdentToTypeAnnotation(startLoc, node, this.parseIdentifier());
                            }
                    }
                    this.unexpected();
                }
            },
            {
                key: "flowParsePostfixType",
                value: function flowParsePostfixType() {
                    var startLoc = this.state.startLoc;
                    var type = this.flowParsePrimaryType();
                    var seenOptionalIndexedAccess = false;
                    while((this.match(0) || this.match(18)) && !this.canInsertSemicolon()){
                        var node = this.startNodeAt(startLoc);
                        var optional = this.eat(18);
                        seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
                        this.expect(0);
                        if (!optional && this.match(3)) {
                            node.elementType = type;
                            this.next();
                            type = this.finishNode(node, "ArrayTypeAnnotation");
                        } else {
                            node.objectType = type;
                            node.indexType = this.flowParseType();
                            this.expect(3);
                            if (seenOptionalIndexedAccess) {
                                node.optional = optional;
                                type = this.finishNode(node, "OptionalIndexedAccessType");
                            } else {
                                type = this.finishNode(node, "IndexedAccessType");
                            }
                        }
                    }
                    return type;
                }
            },
            {
                key: "flowParsePrefixType",
                value: function flowParsePrefixType() {
                    var node = this.startNode();
                    if (this.eat(17)) {
                        node.typeAnnotation = this.flowParsePrefixType();
                        return this.finishNode(node, "NullableTypeAnnotation");
                    } else {
                        return this.flowParsePostfixType();
                    }
                }
            },
            {
                key: "flowParseAnonFunctionWithoutParens",
                value: function flowParseAnonFunctionWithoutParens() {
                    var param = this.flowParsePrefixType();
                    if (!this.state.noAnonFunctionType && this.eat(19)) {
                        var node = this.startNodeAt(param.loc.start);
                        node.params = [
                            this.reinterpretTypeAsFunctionTypeParam(param)
                        ];
                        node.rest = null;
                        node.this = null;
                        node.returnType = this.flowParseType();
                        node.typeParameters = null;
                        return this.finishNode(node, "FunctionTypeAnnotation");
                    }
                    return param;
                }
            },
            {
                key: "flowParseIntersectionType",
                value: function flowParseIntersectionType() {
                    var node = this.startNode();
                    this.eat(45);
                    var type = this.flowParseAnonFunctionWithoutParens();
                    node.types = [
                        type
                    ];
                    while(this.eat(45)){
                        node.types.push(this.flowParseAnonFunctionWithoutParens());
                    }
                    return node.types.length === 1 ? type : this.finishNode(node, "IntersectionTypeAnnotation");
                }
            },
            {
                key: "flowParseUnionType",
                value: function flowParseUnionType() {
                    var node = this.startNode();
                    this.eat(43);
                    var type = this.flowParseIntersectionType();
                    node.types = [
                        type
                    ];
                    while(this.eat(43)){
                        node.types.push(this.flowParseIntersectionType());
                    }
                    return node.types.length === 1 ? type : this.finishNode(node, "UnionTypeAnnotation");
                }
            },
            {
                key: "flowParseType",
                value: function flowParseType() {
                    var oldInType = this.state.inType;
                    this.state.inType = true;
                    var type = this.flowParseUnionType();
                    this.state.inType = oldInType;
                    return type;
                }
            },
            {
                key: "flowParseTypeOrImplicitInstantiation",
                value: function flowParseTypeOrImplicitInstantiation() {
                    if (this.state.type === 132 && this.state.value === "_") {
                        var startLoc = this.state.startLoc;
                        var node = this.parseIdentifier();
                        return this.flowParseGenericType(startLoc, node);
                    } else {
                        return this.flowParseType();
                    }
                }
            },
            {
                key: "flowParseTypeAnnotation",
                value: function flowParseTypeAnnotation() {
                    var node = this.startNode();
                    node.typeAnnotation = this.flowParseTypeInitialiser();
                    return this.finishNode(node, "TypeAnnotation");
                }
            },
            {
                key: "flowParseTypeAnnotatableIdentifier",
                value: function flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
                    var ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
                    if (this.match(14)) {
                        ident.typeAnnotation = this.flowParseTypeAnnotation();
                        this.resetEndLocation(ident);
                    }
                    return ident;
                }
            },
            {
                key: "typeCastToParameter",
                value: function typeCastToParameter(node) {
                    node.expression.typeAnnotation = node.typeAnnotation;
                    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
                    return node.expression;
                }
            },
            {
                key: "flowParseVariance",
                value: function flowParseVariance() {
                    var variance2 = null;
                    if (this.match(53)) {
                        variance2 = this.startNode();
                        if (this.state.value === "+") {
                            variance2.kind = "plus";
                        } else {
                            variance2.kind = "minus";
                        }
                        this.next();
                        return this.finishNode(variance2, "Variance");
                    }
                    return variance2;
                }
            },
            {
                key: "parseFunctionBody",
                value: function parseFunctionBody(node, allowExpressionBody) {
                    var _this = this;
                    var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                    if (allowExpressionBody) {
                        this.forwardNoArrowParamsConversionAt(node, function() {
                            return _get(_get_prototype_of(FlowParserMixin.prototype), "parseFunctionBody", _this).call(_this, node, true, isMethod3);
                        });
                        return;
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseFunctionBody", this).call(this, node, false, isMethod3);
                }
            },
            {
                key: "parseFunctionBodyAndFinish",
                value: function parseFunctionBodyAndFinish(node, type) {
                    var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                    if (this.match(14)) {
                        var typeNode = this.startNode();
                        var ref;
                        ref = _sliced_to_array(this.flowParseTypeAndPredicateInitialiser(), 2), typeNode.typeAnnotation = ref[0], node.predicate = ref[1], ref;
                        node.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseFunctionBodyAndFinish", this).call(this, node, type, isMethod3);
                }
            },
            {
                key: "parseStatementLike",
                value: function parseStatementLike(flags) {
                    if (this.state.strict && this.isContextual(129)) {
                        var lookahead = this.lookahead();
                        if (tokenIsKeywordOrIdentifier(lookahead.type)) {
                            var node = this.startNode();
                            this.next();
                            return this.flowParseInterface(node);
                        }
                    } else if (this.shouldParseEnums() && this.isContextual(126)) {
                        var node1 = this.startNode();
                        this.next();
                        return this.flowParseEnumDeclaration(node1);
                    }
                    var stmt = _get(_get_prototype_of(FlowParserMixin.prototype), "parseStatementLike", this).call(this, flags);
                    if (this.flowPragma === void 0 && !this.isValidDirective(stmt)) {
                        this.flowPragma = null;
                    }
                    return stmt;
                }
            },
            {
                key: "parseExpressionStatement",
                value: function parseExpressionStatement(node, expr, decorators) {
                    if (expr.type === "Identifier") {
                        if (expr.name === "declare") {
                            if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
                                return this.flowParseDeclare(node);
                            }
                        } else if (tokenIsIdentifier(this.state.type)) {
                            if (expr.name === "interface") {
                                return this.flowParseInterface(node);
                            } else if (expr.name === "type") {
                                return this.flowParseTypeAlias(node);
                            } else if (expr.name === "opaque") {
                                return this.flowParseOpaqueType(node, false);
                            }
                        }
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseExpressionStatement", this).call(this, node, expr, decorators);
                }
            },
            {
                key: "shouldParseExportDeclaration",
                value: function shouldParseExportDeclaration() {
                    var type = this.state.type;
                    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
                        return !this.state.containsEsc;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "shouldParseExportDeclaration", this).call(this);
                }
            },
            {
                key: "isExportDefaultSpecifier",
                value: function isExportDefaultSpecifier() {
                    var type = this.state.type;
                    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
                        return this.state.containsEsc;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "isExportDefaultSpecifier", this).call(this);
                }
            },
            {
                key: "parseExportDefaultExpression",
                value: function parseExportDefaultExpression() {
                    if (this.shouldParseEnums() && this.isContextual(126)) {
                        var node = this.startNode();
                        this.next();
                        return this.flowParseEnumDeclaration(node);
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseExportDefaultExpression", this).call(this);
                }
            },
            {
                key: "parseConditional",
                value: function parseConditional(expr, startLoc, refExpressionErrors) {
                    var _this = this;
                    if (!this.match(17)) return expr;
                    if (this.state.maybeInArrowParameters) {
                        var nextCh = this.lookaheadCharCode();
                        if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
                            this.setOptionalParametersError(refExpressionErrors);
                            return expr;
                        }
                    }
                    this.expect(17);
                    var state = this.state.clone();
                    var originalNoArrowAt = this.state.noArrowAt;
                    var node = this.startNodeAt(startLoc);
                    var _this_tryParseConditionalConsequent = this.tryParseConditionalConsequent(), consequent = _this_tryParseConditionalConsequent.consequent, failed = _this_tryParseConditionalConsequent.failed;
                    var _this_getArrowLikeExpressions = _sliced_to_array(this.getArrowLikeExpressions(consequent), 2), valid = _this_getArrowLikeExpressions[0], invalid = _this_getArrowLikeExpressions[1];
                    if (failed || invalid.length > 0) {
                        var noArrowAt = _to_consumable_array(originalNoArrowAt);
                        if (invalid.length > 0) {
                            this.state = state;
                            this.state.noArrowAt = noArrowAt;
                            for(var i = 0; i < invalid.length; i++){
                                noArrowAt.push(invalid[i].start);
                            }
                            var ref;
                            ref = this.tryParseConditionalConsequent(), consequent = ref.consequent, failed = ref.failed, ref;
                            var ref1;
                            ref1 = _sliced_to_array(this.getArrowLikeExpressions(consequent), 2), valid = ref1[0], invalid = ref1[1], ref1;
                        }
                        if (failed && valid.length > 1) {
                            this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
                        }
                        if (failed && valid.length === 1) {
                            this.state = state;
                            noArrowAt.push(valid[0].start);
                            this.state.noArrowAt = noArrowAt;
                            var ref2;
                            ref2 = this.tryParseConditionalConsequent(), consequent = ref2.consequent, failed = ref2.failed, ref2;
                        }
                    }
                    this.getArrowLikeExpressions(consequent, true);
                    this.state.noArrowAt = originalNoArrowAt;
                    this.expect(14);
                    node.test = expr;
                    node.consequent = consequent;
                    node.alternate = this.forwardNoArrowParamsConversionAt(node, function() {
                        return _this.parseMaybeAssign(void 0, void 0);
                    });
                    return this.finishNode(node, "ConditionalExpression");
                }
            },
            {
                key: "tryParseConditionalConsequent",
                value: function tryParseConditionalConsequent() {
                    this.state.noArrowParamsConversionAt.push(this.state.start);
                    var consequent = this.parseMaybeAssignAllowIn();
                    var failed = !this.match(14);
                    this.state.noArrowParamsConversionAt.pop();
                    return {
                        consequent: consequent,
                        failed: failed
                    };
                }
            },
            {
                key: "getArrowLikeExpressions",
                value: function getArrowLikeExpressions(node, disallowInvalid) {
                    var _this = this;
                    var stack = [
                        node
                    ];
                    var arrows = [];
                    while(stack.length !== 0){
                        var node2 = stack.pop();
                        if (node2.type === "ArrowFunctionExpression") {
                            if (node2.typeParameters || !node2.returnType) {
                                this.finishArrowValidation(node2);
                            } else {
                                arrows.push(node2);
                            }
                            stack.push(node2.body);
                        } else if (node2.type === "ConditionalExpression") {
                            stack.push(node2.consequent);
                            stack.push(node2.alternate);
                        }
                    }
                    if (disallowInvalid) {
                        arrows.forEach(function(node2) {
                            return _this.finishArrowValidation(node2);
                        });
                        return [
                            arrows,
                            []
                        ];
                    }
                    return partition(arrows, function(node2) {
                        return node2.params.every(function(param) {
                            return _this.isAssignable(param, true);
                        });
                    });
                }
            },
            {
                key: "finishArrowValidation",
                value: function finishArrowValidation(node) {
                    var _node_extra;
                    this.toAssignableList(node.params, (_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.trailingCommaLoc, false);
                    this.scope.enter(2 | 4);
                    _get(_get_prototype_of(FlowParserMixin.prototype), "checkParams", this).call(this, node, false, true);
                    this.scope.exit();
                }
            },
            {
                key: "forwardNoArrowParamsConversionAt",
                value: function forwardNoArrowParamsConversionAt(node, parse2) {
                    var result;
                    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
                        this.state.noArrowParamsConversionAt.push(this.state.start);
                        result = parse2();
                        this.state.noArrowParamsConversionAt.pop();
                    } else {
                        result = parse2();
                    }
                    return result;
                }
            },
            {
                key: "parseParenItem",
                value: function parseParenItem(node, startLoc) {
                    node = _get(_get_prototype_of(FlowParserMixin.prototype), "parseParenItem", this).call(this, node, startLoc);
                    if (this.eat(17)) {
                        node.optional = true;
                        this.resetEndLocation(node);
                    }
                    if (this.match(14)) {
                        var typeCastNode = this.startNodeAt(startLoc);
                        typeCastNode.expression = node;
                        typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
                        return this.finishNode(typeCastNode, "TypeCastExpression");
                    }
                    return node;
                }
            },
            {
                key: "assertModuleNodeAllowed",
                value: function assertModuleNodeAllowed(node) {
                    if (node.type === "ImportDeclaration" && (node.importKind === "type" || node.importKind === "typeof") || node.type === "ExportNamedDeclaration" && node.exportKind === "type" || node.type === "ExportAllDeclaration" && node.exportKind === "type") {
                        return;
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "assertModuleNodeAllowed", this).call(this, node);
                }
            },
            {
                key: "parseExportDeclaration",
                value: function parseExportDeclaration(node) {
                    if (this.isContextual(130)) {
                        node.exportKind = "type";
                        var declarationNode = this.startNode();
                        this.next();
                        if (this.match(5)) {
                            node.specifiers = this.parseExportSpecifiers(true);
                            _get(_get_prototype_of(FlowParserMixin.prototype), "parseExportFrom", this).call(this, node);
                            return null;
                        } else {
                            return this.flowParseTypeAlias(declarationNode);
                        }
                    } else if (this.isContextual(131)) {
                        node.exportKind = "type";
                        var declarationNode1 = this.startNode();
                        this.next();
                        return this.flowParseOpaqueType(declarationNode1, false);
                    } else if (this.isContextual(129)) {
                        node.exportKind = "type";
                        var declarationNode2 = this.startNode();
                        this.next();
                        return this.flowParseInterface(declarationNode2);
                    } else if (this.shouldParseEnums() && this.isContextual(126)) {
                        node.exportKind = "value";
                        var declarationNode3 = this.startNode();
                        this.next();
                        return this.flowParseEnumDeclaration(declarationNode3);
                    } else {
                        return _get(_get_prototype_of(FlowParserMixin.prototype), "parseExportDeclaration", this).call(this, node);
                    }
                }
            },
            {
                key: "eatExportStar",
                value: function eatExportStar(node) {
                    if (_get(_get_prototype_of(FlowParserMixin.prototype), "eatExportStar", this).call(this, node)) return true;
                    if (this.isContextual(130) && this.lookahead().type === 55) {
                        node.exportKind = "type";
                        this.next();
                        this.next();
                        return true;
                    }
                    return false;
                }
            },
            {
                key: "maybeParseExportNamespaceSpecifier",
                value: function maybeParseExportNamespaceSpecifier(node) {
                    var startLoc = this.state.startLoc;
                    var hasNamespace = _get(_get_prototype_of(FlowParserMixin.prototype), "maybeParseExportNamespaceSpecifier", this).call(this, node);
                    if (hasNamespace && node.exportKind === "type") {
                        this.unexpected(startLoc);
                    }
                    return hasNamespace;
                }
            },
            {
                key: "parseClassId",
                value: function parseClassId(node, isStatement5, optionalId) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseClassId", this).call(this, node, isStatement5, optionalId);
                    if (this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    }
                }
            },
            {
                key: "parseClassMember",
                value: function parseClassMember(classBody2, member, state) {
                    var startLoc = this.state.startLoc;
                    if (this.isContextual(125)) {
                        if (_get(_get_prototype_of(FlowParserMixin.prototype), "parseClassMemberFromModifier", this).call(this, classBody2, member)) {
                            return;
                        }
                        member.declare = true;
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseClassMember", this).call(this, classBody2, member, state);
                    if (member.declare) {
                        if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
                            this.raise(FlowErrors.DeclareClassElement, startLoc);
                        } else if (member.value) {
                            this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
                        }
                    }
                }
            },
            {
                key: "isIterator",
                value: function isIterator(word) {
                    return word === "iterator" || word === "asyncIterator";
                }
            },
            {
                key: "readIterator",
                value: function readIterator() {
                    var word = _get(_get_prototype_of(FlowParserMixin.prototype), "readWord1", this).call(this);
                    var fullWord = "@@" + word;
                    if (!this.isIterator(word) || !this.state.inType) {
                        this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
                            identifierName: fullWord
                        });
                    }
                    this.finishToken(132, fullWord);
                }
            },
            {
                key: "getTokenFromCode",
                value: function getTokenFromCode(code2) {
                    var next = this.input.charCodeAt(this.state.pos + 1);
                    if (code2 === 123 && next === 124) {
                        this.finishOp(6, 2);
                    } else if (this.state.inType && (code2 === 62 || code2 === 60)) {
                        this.finishOp(code2 === 62 ? 48 : 47, 1);
                    } else if (this.state.inType && code2 === 63) {
                        if (next === 46) {
                            this.finishOp(18, 2);
                        } else {
                            this.finishOp(17, 1);
                        }
                    } else if (isIteratorStart(code2, next, this.input.charCodeAt(this.state.pos + 2))) {
                        this.state.pos += 2;
                        this.readIterator();
                    } else {
                        _get(_get_prototype_of(FlowParserMixin.prototype), "getTokenFromCode", this).call(this, code2);
                    }
                }
            },
            {
                key: "isAssignable",
                value: function isAssignable(node, isBinding3) {
                    if (node.type === "TypeCastExpression") {
                        return this.isAssignable(node.expression, isBinding3);
                    } else {
                        return _get(_get_prototype_of(FlowParserMixin.prototype), "isAssignable", this).call(this, node, isBinding3);
                    }
                }
            },
            {
                key: "toAssignable",
                value: function toAssignable(node) {
                    var isLHS = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                    if (!isLHS && node.type === "AssignmentExpression" && node.left.type === "TypeCastExpression") {
                        node.left = this.typeCastToParameter(node.left);
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "toAssignable", this).call(this, node, isLHS);
                }
            },
            {
                key: "toAssignableList",
                value: function toAssignableList(exprList, trailingCommaLoc, isLHS) {
                    for(var i = 0; i < exprList.length; i++){
                        var expr = exprList[i];
                        if ((expr === null || expr === void 0 ? void 0 : expr.type) === "TypeCastExpression") {
                            exprList[i] = this.typeCastToParameter(expr);
                        }
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "toAssignableList", this).call(this, exprList, trailingCommaLoc, isLHS);
                }
            },
            {
                key: "toReferencedList",
                value: function toReferencedList(exprList, isParenthesizedExpr) {
                    for(var i = 0; i < exprList.length; i++){
                        var _expr_extra;
                        var expr = exprList[i];
                        if (expr && expr.type === "TypeCastExpression" && !((_expr_extra = expr.extra) === null || _expr_extra === void 0 ? void 0 : _expr_extra.parenthesized) && (exprList.length > 1 || !isParenthesizedExpr)) {
                            this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
                        }
                    }
                    return exprList;
                }
            },
            {
                key: "parseArrayLike",
                value: function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
                    var node = _get(_get_prototype_of(FlowParserMixin.prototype), "parseArrayLike", this).call(this, close, canBePattern, isTuple, refExpressionErrors);
                    if (canBePattern && !this.state.maybeInArrowParameters) {
                        this.toReferencedList(node.elements);
                    }
                    return node;
                }
            },
            {
                key: "isValidLVal",
                value: function isValidLVal(type, isParenthesized, binding) {
                    return type === "TypeCastExpression" || _get(_get_prototype_of(FlowParserMixin.prototype), "isValidLVal", this).call(this, type, isParenthesized, binding);
                }
            },
            {
                key: "parseClassProperty",
                value: function parseClassProperty(node) {
                    if (this.match(14)) {
                        node.typeAnnotation = this.flowParseTypeAnnotation();
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseClassProperty", this).call(this, node);
                }
            },
            {
                key: "parseClassPrivateProperty",
                value: function parseClassPrivateProperty(node) {
                    if (this.match(14)) {
                        node.typeAnnotation = this.flowParseTypeAnnotation();
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseClassPrivateProperty", this).call(this, node);
                }
            },
            {
                key: "isClassMethod",
                value: function isClassMethod() {
                    return this.match(47) || _get(_get_prototype_of(FlowParserMixin.prototype), "isClassMethod", this).call(this);
                }
            },
            {
                key: "isClassProperty",
                value: function isClassProperty() {
                    return this.match(14) || _get(_get_prototype_of(FlowParserMixin.prototype), "isClassProperty", this).call(this);
                }
            },
            {
                key: "isNonstaticConstructor",
                value: function isNonstaticConstructor(method) {
                    return !this.match(14) && _get(_get_prototype_of(FlowParserMixin.prototype), "isNonstaticConstructor", this).call(this, method);
                }
            },
            {
                key: "pushClassMethod",
                value: function pushClassMethod(classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
                    if (method.variance) {
                        this.unexpected(method.variance.loc.start);
                    }
                    delete method.variance;
                    if (this.match(47)) {
                        method.typeParameters = this.flowParseTypeParameterDeclaration();
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "pushClassMethod", this).call(this, classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
                    if (method.params && isConstructor) {
                        var params = method.params;
                        if (params.length > 0 && this.isThisParam(params[0])) {
                            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
                        }
                    } else if (method.type === "MethodDefinition" && isConstructor && method.value.params) {
                        var params1 = method.value.params;
                        if (params1.length > 0 && this.isThisParam(params1[0])) {
                            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
                        }
                    }
                }
            },
            {
                key: "pushClassPrivateMethod",
                value: function pushClassPrivateMethod(classBody2, method, isGenerator, isAsync) {
                    if (method.variance) {
                        this.unexpected(method.variance.loc.start);
                    }
                    delete method.variance;
                    if (this.match(47)) {
                        method.typeParameters = this.flowParseTypeParameterDeclaration();
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "pushClassPrivateMethod", this).call(this, classBody2, method, isGenerator, isAsync);
                }
            },
            {
                key: "parseClassSuper",
                value: function parseClassSuper(node) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseClassSuper", this).call(this, node);
                    if (node.superClass && this.match(47)) {
                        node.superTypeParameters = this.flowParseTypeParameterInstantiation();
                    }
                    if (this.isContextual(113)) {
                        this.next();
                        var implemented = node.implements = [];
                        do {
                            var node2 = this.startNode();
                            node2.id = this.flowParseRestrictedIdentifier(true);
                            if (this.match(47)) {
                                node2.typeParameters = this.flowParseTypeParameterInstantiation();
                            } else {
                                node2.typeParameters = null;
                            }
                            implemented.push(this.finishNode(node2, "ClassImplements"));
                        }while (this.eat(12));
                    }
                }
            },
            {
                key: "checkGetterSetterParams",
                value: function checkGetterSetterParams(method) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "checkGetterSetterParams", this).call(this, method);
                    var params = this.getObjectOrClassMethodParams(method);
                    if (params.length > 0) {
                        var param = params[0];
                        if (this.isThisParam(param) && method.kind === "get") {
                            this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
                        } else if (this.isThisParam(param)) {
                            this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
                        }
                    }
                }
            },
            {
                key: "parsePropertyNamePrefixOperator",
                value: function parsePropertyNamePrefixOperator(node) {
                    node.variance = this.flowParseVariance();
                }
            },
            {
                key: "parseObjPropValue",
                value: function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern2, isAccessor2, refExpressionErrors) {
                    if (prop.variance) {
                        this.unexpected(prop.variance.loc.start);
                    }
                    delete prop.variance;
                    var typeParameters;
                    if (this.match(47) && !isAccessor2) {
                        typeParameters = this.flowParseTypeParameterDeclaration();
                        if (!this.match(10)) this.unexpected();
                    }
                    var result = _get(_get_prototype_of(FlowParserMixin.prototype), "parseObjPropValue", this).call(this, prop, startLoc, isGenerator, isAsync, isPattern2, isAccessor2, refExpressionErrors);
                    if (typeParameters) {
                        (result.value || result).typeParameters = typeParameters;
                    }
                    return result;
                }
            },
            {
                key: "parseAssignableListItemTypes",
                value: function parseAssignableListItemTypes(param) {
                    if (this.eat(17)) {
                        if (param.type !== "Identifier") {
                            this.raise(FlowErrors.PatternIsOptional, param);
                        }
                        if (this.isThisParam(param)) {
                            this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
                        }
                        param.optional = true;
                    }
                    if (this.match(14)) {
                        param.typeAnnotation = this.flowParseTypeAnnotation();
                    } else if (this.isThisParam(param)) {
                        this.raise(FlowErrors.ThisParamAnnotationRequired, param);
                    }
                    if (this.match(29) && this.isThisParam(param)) {
                        this.raise(FlowErrors.ThisParamNoDefault, param);
                    }
                    this.resetEndLocation(param);
                    return param;
                }
            },
            {
                key: "parseMaybeDefault",
                value: function parseMaybeDefault(startLoc, left) {
                    var node = _get(_get_prototype_of(FlowParserMixin.prototype), "parseMaybeDefault", this).call(this, startLoc, left);
                    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
                        this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
                    }
                    return node;
                }
            },
            {
                key: "checkImportReflection",
                value: function checkImportReflection(node) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "checkImportReflection", this).call(this, node);
                    if (node.module && node.importKind !== "value") {
                        this.raise(FlowErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
                    }
                }
            },
            {
                key: "parseImportSpecifierLocal",
                value: function parseImportSpecifierLocal(node, specifier, type) {
                    specifier.local = hasTypeImportKind(node) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
                    node.specifiers.push(this.finishImportSpecifier(specifier, type));
                }
            },
            {
                key: "isPotentialImportPhase",
                value: function isPotentialImportPhase(isExport) {
                    if (_get(_get_prototype_of(FlowParserMixin.prototype), "isPotentialImportPhase", this).call(this, isExport)) return true;
                    if (this.isContextual(130)) {
                        if (!isExport) return true;
                        var ch = this.lookaheadCharCode();
                        return ch === 123 || ch === 42;
                    }
                    return !isExport && this.isContextual(87);
                }
            },
            {
                key: "applyImportPhase",
                value: function applyImportPhase(node, isExport, phase, loc) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "applyImportPhase", this).call(this, node, isExport, phase, loc);
                    if (isExport) {
                        if (!phase && this.match(65)) {
                            return;
                        }
                        node.exportKind = phase === "type" ? phase : "value";
                    } else {
                        if (phase === "type" && this.match(55)) this.unexpected();
                        node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
                    }
                }
            },
            {
                key: "parseImportSpecifier",
                value: function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
                    var firstIdent = specifier.imported;
                    var specifierTypeKind = null;
                    if (firstIdent.type === "Identifier") {
                        if (firstIdent.name === "type") {
                            specifierTypeKind = "type";
                        } else if (firstIdent.name === "typeof") {
                            specifierTypeKind = "typeof";
                        }
                    }
                    var isBinding3 = false;
                    if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
                        var as_ident = this.parseIdentifier(true);
                        if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
                            specifier.imported = as_ident;
                            specifier.importKind = specifierTypeKind;
                            specifier.local = cloneIdentifier(as_ident);
                        } else {
                            specifier.imported = firstIdent;
                            specifier.importKind = null;
                            specifier.local = this.parseIdentifier();
                        }
                    } else {
                        if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
                            specifier.imported = this.parseIdentifier(true);
                            specifier.importKind = specifierTypeKind;
                        } else {
                            if (importedIsString) {
                                throw this.raise(Errors.ImportBindingIsString, specifier, {
                                    importName: firstIdent.value
                                });
                            }
                            specifier.imported = firstIdent;
                            specifier.importKind = null;
                        }
                        if (this.eatContextual(93)) {
                            specifier.local = this.parseIdentifier();
                        } else {
                            isBinding3 = true;
                            specifier.local = cloneIdentifier(specifier.imported);
                        }
                    }
                    var specifierIsTypeImport = hasTypeImportKind(specifier);
                    if (isInTypeOnlyImport && specifierIsTypeImport) {
                        this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
                    }
                    if (isInTypeOnlyImport || specifierIsTypeImport) {
                        this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
                    }
                    if (isBinding3 && !isInTypeOnlyImport && !specifierIsTypeImport) {
                        this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
                    }
                    return this.finishImportSpecifier(specifier, "ImportSpecifier");
                }
            },
            {
                key: "parseBindingAtom",
                value: function parseBindingAtom() {
                    switch(this.state.type){
                        case 78:
                            return this.parseIdentifier(true);
                        default:
                            return _get(_get_prototype_of(FlowParserMixin.prototype), "parseBindingAtom", this).call(this);
                    }
                }
            },
            {
                key: "parseFunctionParams",
                value: function parseFunctionParams(node, isConstructor) {
                    var kind = node.kind;
                    if (kind !== "get" && kind !== "set" && this.match(47)) {
                        node.typeParameters = this.flowParseTypeParameterDeclaration();
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseFunctionParams", this).call(this, node, isConstructor);
                }
            },
            {
                key: "parseVarId",
                value: function parseVarId(decl, kind) {
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseVarId", this).call(this, decl, kind);
                    if (this.match(14)) {
                        decl.id.typeAnnotation = this.flowParseTypeAnnotation();
                        this.resetEndLocation(decl.id);
                    }
                }
            },
            {
                key: "parseAsyncArrowFromCallExpression",
                value: function parseAsyncArrowFromCallExpression(node, call2) {
                    if (this.match(14)) {
                        var oldNoAnonFunctionType = this.state.noAnonFunctionType;
                        this.state.noAnonFunctionType = true;
                        node.returnType = this.flowParseTypeAnnotation();
                        this.state.noAnonFunctionType = oldNoAnonFunctionType;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseAsyncArrowFromCallExpression", this).call(this, node, call2);
                }
            },
            {
                key: "shouldParseAsyncArrow",
                value: function shouldParseAsyncArrow() {
                    return this.match(14) || _get(_get_prototype_of(FlowParserMixin.prototype), "shouldParseAsyncArrow", this).call(this);
                }
            },
            {
                key: "parseMaybeAssign",
                value: function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
                    var _this = this;
                    var state = null;
                    var jsx2;
                    if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
                        state = this.state.clone();
                        jsx2 = this.tryParse(function() {
                            return _get(_get_prototype_of(FlowParserMixin.prototype), "parseMaybeAssign", _this).call(_this, refExpressionErrors, afterLeftParse);
                        }, state);
                        if (!jsx2.error) return jsx2.node;
                        var context = this.state.context;
                        var currentContext = context[context.length - 1];
                        if (currentContext === types.j_oTag || currentContext === types.j_expr) {
                            context.pop();
                        }
                    }
                    if ((jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.error) || this.match(47)) {
                        state = state || this.state.clone();
                        var typeParameters;
                        var arrow = this.tryParse(function(abort) {
                            var _arrowExpression2_extra;
                            typeParameters = _this.flowParseTypeParameterDeclaration();
                            var arrowExpression2 = _this.forwardNoArrowParamsConversionAt(typeParameters, function() {
                                var result = _get(_get_prototype_of(FlowParserMixin.prototype), "parseMaybeAssign", _this).call(_this, refExpressionErrors, afterLeftParse);
                                _this.resetStartLocationFromNode(result, typeParameters);
                                return result;
                            });
                            if ((_arrowExpression2_extra = arrowExpression2.extra) === null || _arrowExpression2_extra === void 0 ? void 0 : _arrowExpression2_extra.parenthesized) abort();
                            var expr = _this.maybeUnwrapTypeCastExpression(arrowExpression2);
                            if (expr.type !== "ArrowFunctionExpression") abort();
                            expr.typeParameters = typeParameters;
                            _this.resetStartLocationFromNode(expr, typeParameters);
                            return arrowExpression2;
                        }, state);
                        var arrowExpression = null;
                        if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
                            if (!arrow.error && !arrow.aborted) {
                                if (arrow.node.async) {
                                    this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, typeParameters);
                                }
                                return arrow.node;
                            }
                            arrowExpression = arrow.node;
                        }
                        if (jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.node) {
                            this.state = jsx2.failState;
                            return jsx2.node;
                        }
                        if (arrowExpression) {
                            this.state = arrow.failState;
                            return arrowExpression;
                        }
                        if (jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.thrown) throw jsx2.error;
                        if (arrow.thrown) throw arrow.error;
                        throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, typeParameters);
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseMaybeAssign", this).call(this, refExpressionErrors, afterLeftParse);
                }
            },
            {
                key: "parseArrow",
                value: function parseArrow(node) {
                    var _this = this;
                    if (this.match(14)) {
                        var result = this.tryParse(function() {
                            var oldNoAnonFunctionType = _this.state.noAnonFunctionType;
                            _this.state.noAnonFunctionType = true;
                            var typeNode = _this.startNode();
                            var ref;
                            ref = _sliced_to_array(_this.flowParseTypeAndPredicateInitialiser(), 2), typeNode.typeAnnotation = ref[0], node.predicate = ref[1], ref;
                            _this.state.noAnonFunctionType = oldNoAnonFunctionType;
                            if (_this.canInsertSemicolon()) _this.unexpected();
                            if (!_this.match(19)) _this.unexpected();
                            return typeNode;
                        });
                        if (result.thrown) return null;
                        if (result.error) this.state = result.failState;
                        node.returnType = result.node.typeAnnotation ? this.finishNode(result.node, "TypeAnnotation") : null;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseArrow", this).call(this, node);
                }
            },
            {
                key: "shouldParseArrow",
                value: function shouldParseArrow(params) {
                    return this.match(14) || _get(_get_prototype_of(FlowParserMixin.prototype), "shouldParseArrow", this).call(this, params);
                }
            },
            {
                key: "setArrowFunctionParameters",
                value: function setArrowFunctionParameters(node, params) {
                    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
                        node.params = params;
                    } else {
                        _get(_get_prototype_of(FlowParserMixin.prototype), "setArrowFunctionParameters", this).call(this, node, params);
                    }
                }
            },
            {
                key: "checkParams",
                value: function checkParams(node, allowDuplicates, isArrowFunction) {
                    var strictModeChanged = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
                    if (isArrowFunction && this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
                        return;
                    }
                    for(var i = 0; i < node.params.length; i++){
                        if (this.isThisParam(node.params[i]) && i > 0) {
                            this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
                        }
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "checkParams", this).call(this, node, allowDuplicates, isArrowFunction, strictModeChanged);
                }
            },
            {
                key: "parseParenAndDistinguishExpression",
                value: function parseParenAndDistinguishExpression(canBeArrow) {
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseParenAndDistinguishExpression", this).call(this, canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1);
                }
            },
            {
                key: "parseSubscripts",
                value: function parseSubscripts(base, startLoc, noCalls) {
                    var _this = this;
                    if (base.type === "Identifier" && base.name === "async" && this.state.noArrowAt.indexOf(startLoc.index) !== -1) {
                        this.next();
                        var node = this.startNodeAt(startLoc);
                        node.callee = base;
                        node.arguments = _get(_get_prototype_of(FlowParserMixin.prototype), "parseCallExpressionArguments", this).call(this, 11, false);
                        base = this.finishNode(node, "CallExpression");
                    } else if (base.type === "Identifier" && base.name === "async" && this.match(47)) {
                        var state = this.state.clone();
                        var arrow = this.tryParse(function(abort) {
                            return _this.parseAsyncArrowWithTypeParameters(startLoc) || abort();
                        }, state);
                        if (!arrow.error && !arrow.aborted) return arrow.node;
                        var result = this.tryParse(function() {
                            return _get(_get_prototype_of(FlowParserMixin.prototype), "parseSubscripts", _this).call(_this, base, startLoc, noCalls);
                        }, state);
                        if (result.node && !result.error) return result.node;
                        if (arrow.node) {
                            this.state = arrow.failState;
                            return arrow.node;
                        }
                        if (result.node) {
                            this.state = result.failState;
                            return result.node;
                        }
                        throw arrow.error || result.error;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseSubscripts", this).call(this, base, startLoc, noCalls);
                }
            },
            {
                key: "parseSubscript",
                value: function parseSubscript(base, startLoc, noCalls, subscriptState) {
                    var _this = this;
                    if (this.match(18) && this.isLookaheadToken_lt()) {
                        subscriptState.optionalChainMember = true;
                        if (noCalls) {
                            subscriptState.stop = true;
                            return base;
                        }
                        this.next();
                        var node = this.startNodeAt(startLoc);
                        node.callee = base;
                        node.typeArguments = this.flowParseTypeParameterInstantiation();
                        this.expect(10);
                        node.arguments = this.parseCallExpressionArguments(11, false);
                        node.optional = true;
                        return this.finishCallExpression(node, true);
                    } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
                        var node1 = this.startNodeAt(startLoc);
                        node1.callee = base;
                        var result = this.tryParse(function() {
                            node1.typeArguments = _this.flowParseTypeParameterInstantiationCallOrNew();
                            _this.expect(10);
                            node1.arguments = _get(_get_prototype_of(FlowParserMixin.prototype), "parseCallExpressionArguments", _this).call(_this, 11, false);
                            if (subscriptState.optionalChainMember) {
                                node1.optional = false;
                            }
                            return _this.finishCallExpression(node1, subscriptState.optionalChainMember);
                        });
                        if (result.node) {
                            if (result.error) this.state = result.failState;
                            return result.node;
                        }
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseSubscript", this).call(this, base, startLoc, noCalls, subscriptState);
                }
            },
            {
                key: "parseNewCallee",
                value: function parseNewCallee(node) {
                    var _this = this;
                    _get(_get_prototype_of(FlowParserMixin.prototype), "parseNewCallee", this).call(this, node);
                    var targs = null;
                    if (this.shouldParseTypes() && this.match(47)) {
                        targs = this.tryParse(function() {
                            return _this.flowParseTypeParameterInstantiationCallOrNew();
                        }).node;
                    }
                    node.typeArguments = targs;
                }
            },
            {
                key: "parseAsyncArrowWithTypeParameters",
                value: function parseAsyncArrowWithTypeParameters(startLoc) {
                    var node = this.startNodeAt(startLoc);
                    this.parseFunctionParams(node, false);
                    if (!this.parseArrow(node)) return;
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "parseArrowExpression", this).call(this, node, void 0, true);
                }
            },
            {
                key: "readToken_mult_modulo",
                value: function readToken_mult_modulo(code2) {
                    var next = this.input.charCodeAt(this.state.pos + 1);
                    if (code2 === 42 && next === 47 && this.state.hasFlowComment) {
                        this.state.hasFlowComment = false;
                        this.state.pos += 2;
                        this.nextToken();
                        return;
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "readToken_mult_modulo", this).call(this, code2);
                }
            },
            {
                key: "readToken_pipe_amp",
                value: function readToken_pipe_amp(code2) {
                    var next = this.input.charCodeAt(this.state.pos + 1);
                    if (code2 === 124 && next === 125) {
                        this.finishOp(9, 2);
                        return;
                    }
                    _get(_get_prototype_of(FlowParserMixin.prototype), "readToken_pipe_amp", this).call(this, code2);
                }
            },
            {
                key: "parseTopLevel",
                value: function parseTopLevel(file2, program3) {
                    var fileNode = _get(_get_prototype_of(FlowParserMixin.prototype), "parseTopLevel", this).call(this, file2, program3);
                    if (this.state.hasFlowComment) {
                        this.raise(FlowErrors.UnterminatedFlowComment, this.state.curPosition());
                    }
                    return fileNode;
                }
            },
            {
                key: "skipBlockComment",
                value: function skipBlockComment() {
                    if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
                        if (this.state.hasFlowComment) {
                            throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
                        }
                        this.hasFlowCommentCompletion();
                        var commentSkip = this.skipFlowComment();
                        if (commentSkip) {
                            this.state.pos += commentSkip;
                            this.state.hasFlowComment = true;
                        }
                        return;
                    }
                    return _get(_get_prototype_of(FlowParserMixin.prototype), "skipBlockComment", this).call(this, this.state.hasFlowComment ? "*-/" : "*/");
                }
            },
            {
                key: "skipFlowComment",
                value: function skipFlowComment() {
                    var pos = this.state.pos;
                    var shiftToFirstNonWhiteSpace = 2;
                    while([
                        32,
                        9
                    ].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))){
                        shiftToFirstNonWhiteSpace++;
                    }
                    var ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
                    var ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
                    if (ch2 === 58 && ch3 === 58) {
                        return shiftToFirstNonWhiteSpace + 2;
                    }
                    if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
                        return shiftToFirstNonWhiteSpace + 12;
                    }
                    if (ch2 === 58 && ch3 !== 58) {
                        return shiftToFirstNonWhiteSpace;
                    }
                    return false;
                }
            },
            {
                key: "hasFlowCommentCompletion",
                value: function hasFlowCommentCompletion() {
                    var end = this.input.indexOf("*/", this.state.pos);
                    if (end === -1) {
                        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
                    }
                }
            },
            {
                key: "flowEnumErrorBooleanMemberNotInitialized",
                value: function flowEnumErrorBooleanMemberNotInitialized(loc, param) {
                    var enumName = param.enumName, memberName = param.memberName;
                    this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
                        memberName: memberName,
                        enumName: enumName
                    });
                }
            },
            {
                key: "flowEnumErrorInvalidMemberInitializer",
                value: function flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
                    return this.raise(!enumContext.explicitType ? FlowErrors.EnumInvalidMemberInitializerUnknownType : enumContext.explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerPrimaryType, loc, enumContext);
                }
            },
            {
                key: "flowEnumErrorNumberMemberNotInitialized",
                value: function flowEnumErrorNumberMemberNotInitialized(loc, details) {
                    this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
                }
            },
            {
                key: "flowEnumErrorStringMemberInconsistentlyInitialized",
                value: function flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
                    this.raise(FlowErrors.EnumStringMemberInconsistentlyInitialized, node, details);
                }
            },
            {
                key: "flowEnumMemberInit",
                value: function flowEnumMemberInit() {
                    var _this = this;
                    var startLoc = this.state.startLoc;
                    var endOfInit = function() {
                        return _this.match(12) || _this.match(8);
                    };
                    switch(this.state.type){
                        case 134:
                            {
                                var literal = this.parseNumericLiteral(this.state.value);
                                if (endOfInit()) {
                                    return {
                                        type: "number",
                                        loc: literal.loc.start,
                                        value: literal
                                    };
                                }
                                return {
                                    type: "invalid",
                                    loc: startLoc
                                };
                            }
                        case 133:
                            {
                                var literal1 = this.parseStringLiteral(this.state.value);
                                if (endOfInit()) {
                                    return {
                                        type: "string",
                                        loc: literal1.loc.start,
                                        value: literal1
                                    };
                                }
                                return {
                                    type: "invalid",
                                    loc: startLoc
                                };
                            }
                        case 85:
                        case 86:
                            {
                                var literal2 = this.parseBooleanLiteral(this.match(85));
                                if (endOfInit()) {
                                    return {
                                        type: "boolean",
                                        loc: literal2.loc.start,
                                        value: literal2
                                    };
                                }
                                return {
                                    type: "invalid",
                                    loc: startLoc
                                };
                            }
                        default:
                            return {
                                type: "invalid",
                                loc: startLoc
                            };
                    }
                }
            },
            {
                key: "flowEnumMemberRaw",
                value: function flowEnumMemberRaw() {
                    var loc = this.state.startLoc;
                    var id = this.parseIdentifier(true);
                    var init = this.eat(29) ? this.flowEnumMemberInit() : {
                        type: "none",
                        loc: loc
                    };
                    return {
                        id: id,
                        init: init
                    };
                }
            },
            {
                key: "flowEnumCheckExplicitTypeMismatch",
                value: function flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
                    var explicitType = context.explicitType;
                    if (explicitType === null) {
                        return;
                    }
                    if (explicitType !== expectedType) {
                        this.flowEnumErrorInvalidMemberInitializer(loc, context);
                    }
                }
            },
            {
                key: "flowEnumMembers",
                value: function flowEnumMembers(param) {
                    var enumName = param.enumName, explicitType = param.explicitType;
                    var seenNames = /* @__PURE__ */ new Set();
                    var members = {
                        booleanMembers: [],
                        numberMembers: [],
                        stringMembers: [],
                        defaultedMembers: []
                    };
                    var hasUnknownMembers = false;
                    while(!this.match(8)){
                        if (this.eat(21)) {
                            hasUnknownMembers = true;
                            break;
                        }
                        var memberNode = this.startNode();
                        var _this_flowEnumMemberRaw = this.flowEnumMemberRaw(), id = _this_flowEnumMemberRaw.id, init = _this_flowEnumMemberRaw.init;
                        var memberName = id.name;
                        if (memberName === "") {
                            continue;
                        }
                        if (/^[a-z]/.test(memberName)) {
                            this.raise(FlowErrors.EnumInvalidMemberName, id, {
                                memberName: memberName,
                                suggestion: memberName[0].toUpperCase() + memberName.slice(1),
                                enumName: enumName
                            });
                        }
                        if (seenNames.has(memberName)) {
                            this.raise(FlowErrors.EnumDuplicateMemberName, id, {
                                memberName: memberName,
                                enumName: enumName
                            });
                        }
                        seenNames.add(memberName);
                        var context = {
                            enumName: enumName,
                            explicitType: explicitType,
                            memberName: memberName
                        };
                        memberNode.id = id;
                        switch(init.type){
                            case "boolean":
                                {
                                    this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "boolean");
                                    memberNode.init = init.value;
                                    members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
                                    break;
                                }
                            case "number":
                                {
                                    this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "number");
                                    memberNode.init = init.value;
                                    members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
                                    break;
                                }
                            case "string":
                                {
                                    this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "string");
                                    memberNode.init = init.value;
                                    members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
                                    break;
                                }
                            case "invalid":
                                {
                                    throw this.flowEnumErrorInvalidMemberInitializer(init.loc, context);
                                }
                            case "none":
                                {
                                    switch(explicitType){
                                        case "boolean":
                                            this.flowEnumErrorBooleanMemberNotInitialized(init.loc, context);
                                            break;
                                        case "number":
                                            this.flowEnumErrorNumberMemberNotInitialized(init.loc, context);
                                            break;
                                        default:
                                            members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
                                    }
                                }
                        }
                        if (!this.match(8)) {
                            this.expect(12);
                        }
                    }
                    return {
                        members: members,
                        hasUnknownMembers: hasUnknownMembers
                    };
                }
            },
            {
                key: "flowEnumStringMembers",
                value: function flowEnumStringMembers(initializedMembers, defaultedMembers, param) {
                    var enumName = param.enumName;
                    if (initializedMembers.length === 0) {
                        return defaultedMembers;
                    } else if (defaultedMembers.length === 0) {
                        return initializedMembers;
                    } else if (defaultedMembers.length > initializedMembers.length) {
                        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                        try {
                            for(var _iterator = initializedMembers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                var member = _step.value;
                                this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
                                    enumName: enumName
                                });
                            }
                        } catch (err) {
                            _didIteratorError = true;
                            _iteratorError = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion && _iterator.return != null) {
                                    _iterator.return();
                                }
                            } finally{
                                if (_didIteratorError) {
                                    throw _iteratorError;
                                }
                            }
                        }
                        return defaultedMembers;
                    } else {
                        var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                        try {
                            for(var _iterator1 = defaultedMembers[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                var member1 = _step1.value;
                                this.flowEnumErrorStringMemberInconsistentlyInitialized(member1, {
                                    enumName: enumName
                                });
                            }
                        } catch (err) {
                            _didIteratorError1 = true;
                            _iteratorError1 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                    _iterator1.return();
                                }
                            } finally{
                                if (_didIteratorError1) {
                                    throw _iteratorError1;
                                }
                            }
                        }
                        return initializedMembers;
                    }
                }
            },
            {
                key: "flowEnumParseExplicitType",
                value: function flowEnumParseExplicitType(param) {
                    var enumName = param.enumName;
                    if (!this.eatContextual(102)) return null;
                    if (!tokenIsIdentifier(this.state.type)) {
                        throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, this.state.startLoc, {
                            enumName: enumName
                        });
                    }
                    var value1 = this.state.value;
                    this.next();
                    if (value1 !== "boolean" && value1 !== "number" && value1 !== "string" && value1 !== "symbol") {
                        this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
                            enumName: enumName,
                            invalidEnumType: value1
                        });
                    }
                    return value1;
                }
            },
            {
                key: "flowEnumBody",
                value: function flowEnumBody(node, id) {
                    var _this = this;
                    var enumName = id.name;
                    var nameLoc = id.loc.start;
                    var explicitType = this.flowEnumParseExplicitType({
                        enumName: enumName
                    });
                    this.expect(5);
                    var _this_flowEnumMembers = this.flowEnumMembers({
                        enumName: enumName,
                        explicitType: explicitType
                    }), members = _this_flowEnumMembers.members, hasUnknownMembers = _this_flowEnumMembers.hasUnknownMembers;
                    node.hasUnknownMembers = hasUnknownMembers;
                    switch(explicitType){
                        case "boolean":
                            node.explicitType = true;
                            node.members = members.booleanMembers;
                            this.expect(8);
                            return this.finishNode(node, "EnumBooleanBody");
                        case "number":
                            node.explicitType = true;
                            node.members = members.numberMembers;
                            this.expect(8);
                            return this.finishNode(node, "EnumNumberBody");
                        case "string":
                            node.explicitType = true;
                            node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
                                enumName: enumName
                            });
                            this.expect(8);
                            return this.finishNode(node, "EnumStringBody");
                        case "symbol":
                            node.members = members.defaultedMembers;
                            this.expect(8);
                            return this.finishNode(node, "EnumSymbolBody");
                        default:
                            {
                                var empty = function() {
                                    node.members = [];
                                    _this.expect(8);
                                    return _this.finishNode(node, "EnumStringBody");
                                };
                                node.explicitType = false;
                                var boolsLen = members.booleanMembers.length;
                                var numsLen = members.numberMembers.length;
                                var strsLen = members.stringMembers.length;
                                var defaultedLen = members.defaultedMembers.length;
                                if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
                                    return empty();
                                } else if (!boolsLen && !numsLen) {
                                    node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
                                        enumName: enumName
                                    });
                                    this.expect(8);
                                    return this.finishNode(node, "EnumStringBody");
                                } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
                                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                                    try {
                                        for(var _iterator = members.defaultedMembers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                            var member = _step.value;
                                            this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
                                                enumName: enumName,
                                                memberName: member.id.name
                                            });
                                        }
                                    } catch (err) {
                                        _didIteratorError = true;
                                        _iteratorError = err;
                                    } finally{
                                        try {
                                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                                _iterator.return();
                                            }
                                        } finally{
                                            if (_didIteratorError) {
                                                throw _iteratorError;
                                            }
                                        }
                                    }
                                    node.members = members.booleanMembers;
                                    this.expect(8);
                                    return this.finishNode(node, "EnumBooleanBody");
                                } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
                                    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                                    try {
                                        for(var _iterator1 = members.defaultedMembers[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                            var member1 = _step1.value;
                                            this.flowEnumErrorNumberMemberNotInitialized(member1.loc.start, {
                                                enumName: enumName,
                                                memberName: member1.id.name
                                            });
                                        }
                                    } catch (err) {
                                        _didIteratorError1 = true;
                                        _iteratorError1 = err;
                                    } finally{
                                        try {
                                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                                _iterator1.return();
                                            }
                                        } finally{
                                            if (_didIteratorError1) {
                                                throw _iteratorError1;
                                            }
                                        }
                                    }
                                    node.members = members.numberMembers;
                                    this.expect(8);
                                    return this.finishNode(node, "EnumNumberBody");
                                } else {
                                    this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
                                        enumName: enumName
                                    });
                                    return empty();
                                }
                            }
                    }
                }
            },
            {
                key: "flowParseEnumDeclaration",
                value: function flowParseEnumDeclaration(node) {
                    var id = this.parseIdentifier();
                    node.id = id;
                    node.body = this.flowEnumBody(this.startNode(), id);
                    return this.finishNode(node, "EnumDeclaration");
                }
            },
            {
                key: "isLookaheadToken_lt",
                value: function isLookaheadToken_lt() {
                    var next = this.nextTokenStart();
                    if (this.input.charCodeAt(next) === 60) {
                        var afterNext = this.input.charCodeAt(next + 1);
                        return afterNext !== 60 && afterNext !== 61;
                    }
                    return false;
                }
            },
            {
                key: "maybeUnwrapTypeCastExpression",
                value: function maybeUnwrapTypeCastExpression(node) {
                    return node.type === "TypeCastExpression" ? node.expression : node;
                }
            }
        ]);
        return FlowParserMixin;
    }(superClass);
    return FlowParserMixin;
};
var entities = {
    __proto__: null,
    quot: '"',
    amp: "&",
    apos: "'",
    lt: "<",
    gt: ">",
    nbsp: "\xa0",
    iexcl: "\xa1",
    cent: "\xa2",
    pound: "\xa3",
    curren: "\xa4",
    yen: "\xa5",
    brvbar: "\xa6",
    sect: "\xa7",
    uml: "\xa8",
    copy: "\xa9",
    ordf: "\xaa",
    laquo: "\xab",
    not: "\xac",
    shy: "\xad",
    reg: "\xae",
    macr: "\xaf",
    deg: "\xb0",
    plusmn: "\xb1",
    sup2: "\xb2",
    sup3: "\xb3",
    acute: "\xb4",
    micro: "\xb5",
    para: "\xb6",
    middot: "\xb7",
    cedil: "\xb8",
    sup1: "\xb9",
    ordm: "\xba",
    raquo: "\xbb",
    frac14: "\xbc",
    frac12: "\xbd",
    frac34: "\xbe",
    iquest: "\xbf",
    Agrave: "\xc0",
    Aacute: "\xc1",
    Acirc: "\xc2",
    Atilde: "\xc3",
    Auml: "\xc4",
    Aring: "\xc5",
    AElig: "\xc6",
    Ccedil: "\xc7",
    Egrave: "\xc8",
    Eacute: "\xc9",
    Ecirc: "\xca",
    Euml: "\xcb",
    Igrave: "\xcc",
    Iacute: "\xcd",
    Icirc: "\xce",
    Iuml: "\xcf",
    ETH: "\xd0",
    Ntilde: "\xd1",
    Ograve: "\xd2",
    Oacute: "\xd3",
    Ocirc: "\xd4",
    Otilde: "\xd5",
    Ouml: "\xd6",
    times: "\xd7",
    Oslash: "\xd8",
    Ugrave: "\xd9",
    Uacute: "\xda",
    Ucirc: "\xdb",
    Uuml: "\xdc",
    Yacute: "\xdd",
    THORN: "\xde",
    szlig: "\xdf",
    agrave: "\xe0",
    aacute: "\xe1",
    acirc: "\xe2",
    atilde: "\xe3",
    auml: "\xe4",
    aring: "\xe5",
    aelig: "\xe6",
    ccedil: "\xe7",
    egrave: "\xe8",
    eacute: "\xe9",
    ecirc: "\xea",
    euml: "\xeb",
    igrave: "\xec",
    iacute: "\xed",
    icirc: "\xee",
    iuml: "\xef",
    eth: "\xf0",
    ntilde: "\xf1",
    ograve: "\xf2",
    oacute: "\xf3",
    ocirc: "\xf4",
    otilde: "\xf5",
    ouml: "\xf6",
    divide: "\xf7",
    oslash: "\xf8",
    ugrave: "\xf9",
    uacute: "\xfa",
    ucirc: "\xfb",
    uuml: "\xfc",
    yacute: "\xfd",
    thorn: "\xfe",
    yuml: "\xff",
    OElig: "Œ",
    oelig: "œ",
    Scaron: "Š",
    scaron: "š",
    Yuml: "Ÿ",
    fnof: "ƒ",
    circ: "ˆ",
    tilde: "˜",
    Alpha: "Α",
    Beta: "Β",
    Gamma: "Γ",
    Delta: "Δ",
    Epsilon: "Ε",
    Zeta: "Ζ",
    Eta: "Η",
    Theta: "Θ",
    Iota: "Ι",
    Kappa: "Κ",
    Lambda: "Λ",
    Mu: "Μ",
    Nu: "Ν",
    Xi: "Ξ",
    Omicron: "Ο",
    Pi: "Π",
    Rho: "Ρ",
    Sigma: "Σ",
    Tau: "Τ",
    Upsilon: "Υ",
    Phi: "Φ",
    Chi: "Χ",
    Psi: "Ψ",
    Omega: "Ω",
    alpha: "α",
    beta: "β",
    gamma: "γ",
    delta: "δ",
    epsilon: "ε",
    zeta: "ζ",
    eta: "η",
    theta: "θ",
    iota: "ι",
    kappa: "κ",
    lambda: "λ",
    mu: "μ",
    nu: "ν",
    xi: "ξ",
    omicron: "ο",
    pi: "π",
    rho: "ρ",
    sigmaf: "ς",
    sigma: "σ",
    tau: "τ",
    upsilon: "υ",
    phi: "φ",
    chi: "χ",
    psi: "ψ",
    omega: "ω",
    thetasym: "ϑ",
    upsih: "ϒ",
    piv: "ϖ",
    ensp: " ",
    emsp: " ",
    thinsp: " ",
    zwnj: "‌",
    zwj: "‍",
    lrm: "‎",
    rlm: "‏",
    ndash: "–",
    mdash: "—",
    lsquo: "‘",
    rsquo: "’",
    sbquo: "‚",
    ldquo: "“",
    rdquo: "”",
    bdquo: "„",
    dagger: "†",
    Dagger: "‡",
    bull: "•",
    hellip: "…",
    permil: "‰",
    prime: "′",
    Prime: "″",
    lsaquo: "‹",
    rsaquo: "›",
    oline: "‾",
    frasl: "⁄",
    euro: "€",
    image: "ℑ",
    weierp: "℘",
    real: "ℜ",
    trade: "™",
    alefsym: "ℵ",
    larr: "←",
    uarr: "↑",
    rarr: "→",
    darr: "↓",
    harr: "↔",
    crarr: "↵",
    lArr: "⇐",
    uArr: "⇑",
    rArr: "⇒",
    dArr: "⇓",
    hArr: "⇔",
    forall: "∀",
    part: "∂",
    exist: "∃",
    empty: "∅",
    nabla: "∇",
    isin: "∈",
    notin: "∉",
    ni: "∋",
    prod: "∏",
    sum: "∑",
    minus: "−",
    lowast: "∗",
    radic: "√",
    prop: "∝",
    infin: "∞",
    ang: "∠",
    and: "∧",
    or: "∨",
    cap: "∩",
    cup: "∪",
    int: "∫",
    there4: "∴",
    sim: "∼",
    cong: "≅",
    asymp: "≈",
    ne: "≠",
    equiv: "≡",
    le: "≤",
    ge: "≥",
    sub: "⊂",
    sup: "⊃",
    nsub: "⊄",
    sube: "⊆",
    supe: "⊇",
    oplus: "⊕",
    otimes: "⊗",
    perp: "⊥",
    sdot: "⋅",
    lceil: "⌈",
    rceil: "⌉",
    lfloor: "⌊",
    rfloor: "⌋",
    lang: "〈",
    rang: "〉",
    loz: "◊",
    spades: "♠",
    clubs: "♣",
    hearts: "♥",
    diams: "♦"
};
var JsxErrors = ParseErrorEnum(_templateObject2())({
    AttributeIsEmpty: "JSX attributes must only be assigned a non-empty expression.",
    MissingClosingTagElement: function(param) {
        var openingTagName = param.openingTagName;
        return "Expected corresponding JSX closing tag for <".concat(openingTagName, ">.");
    },
    MissingClosingTagFragment: "Expected corresponding JSX closing tag for <>.",
    UnexpectedSequenceExpression: "Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?",
    UnexpectedToken: function(param) {
        var unexpected = param.unexpected, HTMLEntity = param.HTMLEntity;
        return "Unexpected token `".concat(unexpected, "`. Did you mean `").concat(HTMLEntity, "` or `{'").concat(unexpected, "'}`?");
    },
    UnsupportedJsxValue: "JSX value should be either an expression or a quoted JSX text.",
    UnterminatedJsxContent: "Unterminated JSX contents.",
    UnwrappedAdjacentJSXElements: "Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?"
});
function isFragment(object) {
    return object ? object.type === "JSXOpeningFragment" || object.type === "JSXClosingFragment" : false;
}
function getQualifiedJSXName(object) {
    if (object.type === "JSXIdentifier") {
        return object.name;
    }
    if (object.type === "JSXNamespacedName") {
        return object.namespace.name + ":" + object.name.name;
    }
    if (object.type === "JSXMemberExpression") {
        return getQualifiedJSXName(object.object) + "." + getQualifiedJSXName(object.property);
    }
    throw new Error("Node had unexpected type: " + object.type);
}
var jsx = function(superClass) {
    var JSXParserMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(JSXParserMixin, superClass);
        var _super = _create_super(JSXParserMixin);
        function JSXParserMixin() {
            _class_call_check(this, JSXParserMixin);
            return _super.apply(this, arguments);
        }
        _create_class(JSXParserMixin, [
            {
                key: "jsxReadToken",
                value: function jsxReadToken() {
                    var out = "";
                    var chunkStart = this.state.pos;
                    for(;;){
                        if (this.state.pos >= this.length) {
                            throw this.raise(JsxErrors.UnterminatedJsxContent, this.state.startLoc);
                        }
                        var ch = this.input.charCodeAt(this.state.pos);
                        switch(ch){
                            case 60:
                            case 123:
                                if (this.state.pos === this.state.start) {
                                    if (ch === 60 && this.state.canStartJSXElement) {
                                        ++this.state.pos;
                                        this.finishToken(142);
                                    } else {
                                        _get(_get_prototype_of(JSXParserMixin.prototype), "getTokenFromCode", this).call(this, ch);
                                    }
                                    return;
                                }
                                out += this.input.slice(chunkStart, this.state.pos);
                                this.finishToken(141, out);
                                return;
                            case 38:
                                out += this.input.slice(chunkStart, this.state.pos);
                                out += this.jsxReadEntity();
                                chunkStart = this.state.pos;
                                break;
                            case 62:
                            case 125:
                                {
                                    this.raise(JsxErrors.UnexpectedToken, this.state.curPosition(), {
                                        unexpected: this.input[this.state.pos],
                                        HTMLEntity: ch === 125 ? "&rbrace;" : "&gt;"
                                    });
                                }
                            default:
                                if (isNewLine(ch)) {
                                    out += this.input.slice(chunkStart, this.state.pos);
                                    out += this.jsxReadNewLine(true);
                                    chunkStart = this.state.pos;
                                } else {
                                    ++this.state.pos;
                                }
                        }
                    }
                }
            },
            {
                key: "jsxReadNewLine",
                value: function jsxReadNewLine(normalizeCRLF) {
                    var ch = this.input.charCodeAt(this.state.pos);
                    var out;
                    ++this.state.pos;
                    if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
                        ++this.state.pos;
                        out = normalizeCRLF ? "\n" : "\r\n";
                    } else {
                        out = String.fromCharCode(ch);
                    }
                    ++this.state.curLine;
                    this.state.lineStart = this.state.pos;
                    return out;
                }
            },
            {
                key: "jsxReadString",
                value: function jsxReadString(quote) {
                    var out = "";
                    var chunkStart = ++this.state.pos;
                    for(;;){
                        if (this.state.pos >= this.length) {
                            throw this.raise(Errors.UnterminatedString, this.state.startLoc);
                        }
                        var ch = this.input.charCodeAt(this.state.pos);
                        if (ch === quote) break;
                        if (ch === 38) {
                            out += this.input.slice(chunkStart, this.state.pos);
                            out += this.jsxReadEntity();
                            chunkStart = this.state.pos;
                        } else if (isNewLine(ch)) {
                            out += this.input.slice(chunkStart, this.state.pos);
                            out += this.jsxReadNewLine(false);
                            chunkStart = this.state.pos;
                        } else {
                            ++this.state.pos;
                        }
                    }
                    out += this.input.slice(chunkStart, this.state.pos++);
                    this.finishToken(133, out);
                }
            },
            {
                key: "jsxReadEntity",
                value: function jsxReadEntity() {
                    var startPos = ++this.state.pos;
                    if (this.codePointAtPos(this.state.pos) === 35) {
                        ++this.state.pos;
                        var radix = 10;
                        if (this.codePointAtPos(this.state.pos) === 120) {
                            radix = 16;
                            ++this.state.pos;
                        }
                        var codePoint = this.readInt(radix, void 0, false, "bail");
                        if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
                            ++this.state.pos;
                            return String.fromCodePoint(codePoint);
                        }
                    } else {
                        var count = 0;
                        var semi = false;
                        while(count++ < 10 && this.state.pos < this.length && !(semi = this.codePointAtPos(this.state.pos) == 59)){
                            ++this.state.pos;
                        }
                        if (semi) {
                            var desc = this.input.slice(startPos, this.state.pos);
                            var entity = entities[desc];
                            ++this.state.pos;
                            if (entity) {
                                return entity;
                            }
                        }
                    }
                    this.state.pos = startPos;
                    return "&";
                }
            },
            {
                key: "jsxReadWord",
                value: function jsxReadWord() {
                    var ch;
                    var start = this.state.pos;
                    do {
                        ch = this.input.charCodeAt(++this.state.pos);
                    }while (isIdentifierChar2(ch) || ch === 45);
                    this.finishToken(140, this.input.slice(start, this.state.pos));
                }
            },
            {
                key: "jsxParseIdentifier",
                value: function jsxParseIdentifier() {
                    var node = this.startNode();
                    if (this.match(140)) {
                        node.name = this.state.value;
                    } else if (tokenIsKeyword(this.state.type)) {
                        node.name = tokenLabelName(this.state.type);
                    } else {
                        this.unexpected();
                    }
                    this.next();
                    return this.finishNode(node, "JSXIdentifier");
                }
            },
            {
                key: "jsxParseNamespacedName",
                value: function jsxParseNamespacedName() {
                    var startLoc = this.state.startLoc;
                    var name = this.jsxParseIdentifier();
                    if (!this.eat(14)) return name;
                    var node = this.startNodeAt(startLoc);
                    node.namespace = name;
                    node.name = this.jsxParseIdentifier();
                    return this.finishNode(node, "JSXNamespacedName");
                }
            },
            {
                key: "jsxParseElementName",
                value: function jsxParseElementName() {
                    var startLoc = this.state.startLoc;
                    var node = this.jsxParseNamespacedName();
                    if (node.type === "JSXNamespacedName") {
                        return node;
                    }
                    while(this.eat(16)){
                        var newNode = this.startNodeAt(startLoc);
                        newNode.object = node;
                        newNode.property = this.jsxParseIdentifier();
                        node = this.finishNode(newNode, "JSXMemberExpression");
                    }
                    return node;
                }
            },
            {
                key: "jsxParseAttributeValue",
                value: function jsxParseAttributeValue() {
                    var node;
                    switch(this.state.type){
                        case 5:
                            node = this.startNode();
                            this.setContext(types.brace);
                            this.next();
                            node = this.jsxParseExpressionContainer(node, types.j_oTag);
                            if (node.expression.type === "JSXEmptyExpression") {
                                this.raise(JsxErrors.AttributeIsEmpty, node);
                            }
                            return node;
                        case 142:
                        case 133:
                            return this.parseExprAtom();
                        default:
                            throw this.raise(JsxErrors.UnsupportedJsxValue, this.state.startLoc);
                    }
                }
            },
            {
                key: "jsxParseEmptyExpression",
                value: function jsxParseEmptyExpression() {
                    var node = this.startNodeAt(this.state.lastTokEndLoc);
                    return this.finishNodeAt(node, "JSXEmptyExpression", this.state.startLoc);
                }
            },
            {
                key: "jsxParseSpreadChild",
                value: function jsxParseSpreadChild(node) {
                    this.next();
                    node.expression = this.parseExpression();
                    this.setContext(types.j_expr);
                    this.state.canStartJSXElement = true;
                    this.expect(8);
                    return this.finishNode(node, "JSXSpreadChild");
                }
            },
            {
                key: "jsxParseExpressionContainer",
                value: function jsxParseExpressionContainer(node, previousContext) {
                    if (this.match(8)) {
                        node.expression = this.jsxParseEmptyExpression();
                    } else {
                        var expression2 = this.parseExpression();
                        {
                            var _expression2_extra;
                            if (expression2.type === "SequenceExpression" && !((_expression2_extra = expression2.extra) === null || _expression2_extra === void 0 ? void 0 : _expression2_extra.parenthesized)) {
                                this.raise(JsxErrors.UnexpectedSequenceExpression, expression2.expressions[1]);
                            }
                        }
                        node.expression = expression2;
                    }
                    this.setContext(previousContext);
                    this.state.canStartJSXElement = true;
                    this.expect(8);
                    return this.finishNode(node, "JSXExpressionContainer");
                }
            },
            {
                key: "jsxParseAttribute",
                value: function jsxParseAttribute() {
                    var node = this.startNode();
                    if (this.match(5)) {
                        this.setContext(types.brace);
                        this.next();
                        this.expect(21);
                        node.argument = this.parseMaybeAssignAllowIn();
                        this.setContext(types.j_oTag);
                        this.state.canStartJSXElement = true;
                        this.expect(8);
                        return this.finishNode(node, "JSXSpreadAttribute");
                    }
                    node.name = this.jsxParseNamespacedName();
                    node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
                    return this.finishNode(node, "JSXAttribute");
                }
            },
            {
                key: "jsxParseOpeningElementAt",
                value: function jsxParseOpeningElementAt(startLoc) {
                    var node = this.startNodeAt(startLoc);
                    if (this.eat(143)) {
                        return this.finishNode(node, "JSXOpeningFragment");
                    }
                    node.name = this.jsxParseElementName();
                    return this.jsxParseOpeningElementAfterName(node);
                }
            },
            {
                key: "jsxParseOpeningElementAfterName",
                value: function jsxParseOpeningElementAfterName(node) {
                    var attributes = [];
                    while(!this.match(56) && !this.match(143)){
                        attributes.push(this.jsxParseAttribute());
                    }
                    node.attributes = attributes;
                    node.selfClosing = this.eat(56);
                    this.expect(143);
                    return this.finishNode(node, "JSXOpeningElement");
                }
            },
            {
                key: "jsxParseClosingElementAt",
                value: function jsxParseClosingElementAt(startLoc) {
                    var node = this.startNodeAt(startLoc);
                    if (this.eat(143)) {
                        return this.finishNode(node, "JSXClosingFragment");
                    }
                    node.name = this.jsxParseElementName();
                    this.expect(143);
                    return this.finishNode(node, "JSXClosingElement");
                }
            },
            {
                key: "jsxParseElementAt",
                value: function jsxParseElementAt(startLoc) {
                    var node = this.startNodeAt(startLoc);
                    var children = [];
                    var openingElement = this.jsxParseOpeningElementAt(startLoc);
                    var closingElement = null;
                    if (!openingElement.selfClosing) {
                        contents: for(;;){
                            switch(this.state.type){
                                case 142:
                                    startLoc = this.state.startLoc;
                                    this.next();
                                    if (this.eat(56)) {
                                        closingElement = this.jsxParseClosingElementAt(startLoc);
                                        break contents;
                                    }
                                    children.push(this.jsxParseElementAt(startLoc));
                                    break;
                                case 141:
                                    children.push(this.parseExprAtom());
                                    break;
                                case 5:
                                    {
                                        var node2 = this.startNode();
                                        this.setContext(types.brace);
                                        this.next();
                                        if (this.match(21)) {
                                            children.push(this.jsxParseSpreadChild(node2));
                                        } else {
                                            children.push(this.jsxParseExpressionContainer(node2, types.j_expr));
                                        }
                                        break;
                                    }
                                default:
                                    this.unexpected();
                            }
                        }
                        if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
                            this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
                        } else if (!isFragment(openingElement) && isFragment(closingElement)) {
                            this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
                                openingTagName: getQualifiedJSXName(openingElement.name)
                            });
                        } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
                            if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
                                this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
                                    openingTagName: getQualifiedJSXName(openingElement.name)
                                });
                            }
                        }
                    }
                    if (isFragment(openingElement)) {
                        node.openingFragment = openingElement;
                        node.closingFragment = closingElement;
                    } else {
                        node.openingElement = openingElement;
                        node.closingElement = closingElement;
                    }
                    node.children = children;
                    if (this.match(47)) {
                        throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, this.state.startLoc);
                    }
                    return isFragment(openingElement) ? this.finishNode(node, "JSXFragment") : this.finishNode(node, "JSXElement");
                }
            },
            {
                key: "jsxParseElement",
                value: function jsxParseElement() {
                    var startLoc = this.state.startLoc;
                    this.next();
                    return this.jsxParseElementAt(startLoc);
                }
            },
            {
                key: "setContext",
                value: function setContext(newContext) {
                    var context = this.state.context;
                    context[context.length - 1] = newContext;
                }
            },
            {
                key: "parseExprAtom",
                value: function parseExprAtom(refExpressionErrors) {
                    if (this.match(141)) {
                        return this.parseLiteral(this.state.value, "JSXText");
                    } else if (this.match(142)) {
                        return this.jsxParseElement();
                    } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
                        this.replaceToken(142);
                        return this.jsxParseElement();
                    } else {
                        return _get(_get_prototype_of(JSXParserMixin.prototype), "parseExprAtom", this).call(this, refExpressionErrors);
                    }
                }
            },
            {
                key: "skipSpace",
                value: function skipSpace() {
                    var curContext = this.curContext();
                    if (!curContext.preserveSpace) _get(_get_prototype_of(JSXParserMixin.prototype), "skipSpace", this).call(this);
                }
            },
            {
                key: "getTokenFromCode",
                value: function getTokenFromCode(code2) {
                    var context = this.curContext();
                    if (context === types.j_expr) {
                        this.jsxReadToken();
                        return;
                    }
                    if (context === types.j_oTag || context === types.j_cTag) {
                        if (isIdentifierStart2(code2)) {
                            this.jsxReadWord();
                            return;
                        }
                        if (code2 === 62) {
                            ++this.state.pos;
                            this.finishToken(143);
                            return;
                        }
                        if ((code2 === 34 || code2 === 39) && context === types.j_oTag) {
                            this.jsxReadString(code2);
                            return;
                        }
                    }
                    if (code2 === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
                        ++this.state.pos;
                        this.finishToken(142);
                        return;
                    }
                    _get(_get_prototype_of(JSXParserMixin.prototype), "getTokenFromCode", this).call(this, code2);
                }
            },
            {
                key: "updateContext",
                value: function updateContext(prevType) {
                    var _this_state = this.state, context = _this_state.context, type = _this_state.type;
                    if (type === 56 && prevType === 142) {
                        context.splice(-2, 2, types.j_cTag);
                        this.state.canStartJSXElement = false;
                    } else if (type === 142) {
                        context.push(types.j_oTag);
                    } else if (type === 143) {
                        var out = context[context.length - 1];
                        if (out === types.j_oTag && prevType === 56 || out === types.j_cTag) {
                            context.pop();
                            this.state.canStartJSXElement = context[context.length - 1] === types.j_expr;
                        } else {
                            this.setContext(types.j_expr);
                            this.state.canStartJSXElement = true;
                        }
                    } else {
                        this.state.canStartJSXElement = tokenComesBeforeExpression(type);
                    }
                }
            }
        ]);
        return JSXParserMixin;
    }(superClass);
    return JSXParserMixin;
};
var TypeScriptScope = /*#__PURE__*/ function(Scope) {
    "use strict";
    _inherits(TypeScriptScope, Scope);
    var _super = _create_super(TypeScriptScope);
    function TypeScriptScope() {
        _class_call_check(this, TypeScriptScope);
        var _this;
        _this = _super.call.apply(_super, [
            this
        ].concat(Array.prototype.slice.call(arguments)));
        __publicField(_assert_this_initialized(_this), "tsNames", /* @__PURE__ */ new Map());
        return _this;
    }
    return TypeScriptScope;
}(Scope);
var TypeScriptScopeHandler = /*#__PURE__*/ function(ScopeHandler) {
    "use strict";
    _inherits(TypeScriptScopeHandler, ScopeHandler);
    var _super = _create_super(TypeScriptScopeHandler);
    function TypeScriptScopeHandler() {
        _class_call_check(this, TypeScriptScopeHandler);
        var _this;
        _this = _super.call.apply(_super, [
            this
        ].concat(Array.prototype.slice.call(arguments)));
        __publicField(_assert_this_initialized(_this), "importsStack", []);
        return _this;
    }
    _create_class(TypeScriptScopeHandler, [
        {
            key: "createScope",
            value: function createScope(flags) {
                this.importsStack.push(/* @__PURE__ */ new Set());
                return new TypeScriptScope(flags);
            }
        },
        {
            key: "enter",
            value: function enter(flags) {
                if (flags == 256) {
                    this.importsStack.push(/* @__PURE__ */ new Set());
                }
                _get(_get_prototype_of(TypeScriptScopeHandler.prototype), "enter", this).call(this, flags);
            }
        },
        {
            key: "exit",
            value: function exit() {
                var flags = _get(_get_prototype_of(TypeScriptScopeHandler.prototype), "exit", this).call(this);
                if (flags == 256) {
                    this.importsStack.pop();
                }
                return flags;
            }
        },
        {
            key: "hasImport",
            value: function hasImport(name, allowShadow) {
                var len = this.importsStack.length;
                if (this.importsStack[len - 1].has(name)) {
                    return true;
                }
                if (!allowShadow && len > 1) {
                    for(var i = 0; i < len - 1; i++){
                        if (this.importsStack[i].has(name)) return true;
                    }
                }
                return false;
            }
        },
        {
            key: "declareName",
            value: function declareName(name, bindingType, loc) {
                if (bindingType & 4096) {
                    if (this.hasImport(name, true)) {
                        this.parser.raise(Errors.VarRedeclaration, loc, {
                            identifierName: name
                        });
                    }
                    this.importsStack[this.importsStack.length - 1].add(name);
                    return;
                }
                var scope2 = this.currentScope();
                var type = scope2.tsNames.get(name) || 0;
                if (bindingType & 1024) {
                    this.maybeExportDefined(scope2, name);
                    scope2.tsNames.set(name, type | 16);
                    return;
                }
                _get(_get_prototype_of(TypeScriptScopeHandler.prototype), "declareName", this).call(this, name, bindingType, loc);
                if (bindingType & 2) {
                    if (!(bindingType & 1)) {
                        this.checkRedeclarationInScope(scope2, name, bindingType, loc);
                        this.maybeExportDefined(scope2, name);
                    }
                    type = type | 1;
                }
                if (bindingType & 256) {
                    type = type | 2;
                }
                if (bindingType & 512) {
                    type = type | 4;
                }
                if (bindingType & 128) {
                    type = type | 8;
                }
                if (type) scope2.tsNames.set(name, type);
            }
        },
        {
            key: "isRedeclaredInScope",
            value: function isRedeclaredInScope(scope2, name, bindingType) {
                var type = scope2.tsNames.get(name);
                if ((type & 2) > 0) {
                    if (bindingType & 256) {
                        var isConst = !!(bindingType & 512);
                        var wasConst = (type & 4) > 0;
                        return isConst !== wasConst;
                    }
                    return true;
                }
                if (bindingType & 128 && (type & 8) > 0) {
                    if (scope2.names.get(name) & 2) {
                        return !!(bindingType & 1);
                    } else {
                        return false;
                    }
                }
                if (bindingType & 2 && (type & 1) > 0) {
                    return true;
                }
                return _get(_get_prototype_of(TypeScriptScopeHandler.prototype), "isRedeclaredInScope", this).call(this, scope2, name, bindingType);
            }
        },
        {
            key: "checkLocalExport",
            value: function checkLocalExport(id) {
                var name = id.name;
                if (this.hasImport(name)) return;
                var len = this.scopeStack.length;
                for(var i = len - 1; i >= 0; i--){
                    var scope2 = this.scopeStack[i];
                    var type = scope2.tsNames.get(name);
                    if ((type & 1) > 0 || (type & 16) > 0) {
                        return;
                    }
                }
                _get(_get_prototype_of(TypeScriptScopeHandler.prototype), "checkLocalExport", this).call(this, id);
            }
        }
    ]);
    return TypeScriptScopeHandler;
}(ScopeHandler);
var getOwn$1 = function(object, key) {
    return Object.hasOwnProperty.call(object, key) && object[key];
};
var unwrapParenthesizedExpression = function(node) {
    return node.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression(node.expression) : node;
};
var LValParser = /*#__PURE__*/ function(NodeUtils) {
    "use strict";
    _inherits(LValParser, NodeUtils);
    var _super = _create_super(LValParser);
    function LValParser() {
        _class_call_check(this, LValParser);
        return _super.apply(this, arguments);
    }
    _create_class(LValParser, [
        {
            key: "toAssignable",
            value: function toAssignable(node) {
                var isLHS = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                var _node_extra;
                var parenthesized = void 0;
                if (node.type === "ParenthesizedExpression" || ((_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.parenthesized)) {
                    parenthesized = unwrapParenthesizedExpression(node);
                    if (isLHS) {
                        if (parenthesized.type === "Identifier") {
                            this.expressionScope.recordArrowParameterBindingError(Errors.InvalidParenthesizedAssignment, node);
                        } else if (parenthesized.type !== "MemberExpression" && !this.isOptionalMemberExpression(parenthesized)) {
                            this.raise(Errors.InvalidParenthesizedAssignment, node);
                        }
                    } else {
                        this.raise(Errors.InvalidParenthesizedAssignment, node);
                    }
                }
                switch(node.type){
                    case "Identifier":
                    case "ObjectPattern":
                    case "ArrayPattern":
                    case "AssignmentPattern":
                    case "RestElement":
                        break;
                    case "ObjectExpression":
                        node.type = "ObjectPattern";
                        for(var i = 0, length = node.properties.length, last2 = length - 1; i < length; i++){
                            var _node_extra1;
                            var prop = node.properties[i];
                            var isLast = i === last2;
                            this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
                            if (isLast && prop.type === "RestElement" && ((_node_extra1 = node.extra) === null || _node_extra1 === void 0 ? void 0 : _node_extra1.trailingCommaLoc)) {
                                this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
                            }
                        }
                        break;
                    case "ObjectProperty":
                        {
                            var key = node.key, value1 = node.value;
                            if (this.isPrivateName(key)) {
                                this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
                            }
                            this.toAssignable(value1, isLHS);
                            break;
                        }
                    case "SpreadElement":
                        {
                            throw new Error("Internal @babel/parser error (this is a bug, please report it). SpreadElement should be converted by .toAssignable's caller.");
                        }
                    case "ArrayExpression":
                        var _node_extra2;
                        node.type = "ArrayPattern";
                        this.toAssignableList(node.elements, (_node_extra2 = node.extra) === null || _node_extra2 === void 0 ? void 0 : _node_extra2.trailingCommaLoc, isLHS);
                        break;
                    case "AssignmentExpression":
                        if (node.operator !== "=") {
                            this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
                        }
                        node.type = "AssignmentPattern";
                        delete node.operator;
                        this.toAssignable(node.left, isLHS);
                        break;
                    case "ParenthesizedExpression":
                        this.toAssignable(parenthesized, isLHS);
                        break;
                }
            }
        },
        {
            key: "toAssignableObjectExpressionProp",
            value: function toAssignableObjectExpressionProp(prop, isLast, isLHS) {
                if (prop.type === "ObjectMethod") {
                    this.raise(prop.kind === "get" || prop.kind === "set" ? Errors.PatternHasAccessor : Errors.PatternHasMethod, prop.key);
                } else if (prop.type === "SpreadElement") {
                    prop.type = "RestElement";
                    var arg = prop.argument;
                    this.checkToRestConversion(arg, false);
                    this.toAssignable(arg, isLHS);
                    if (!isLast) {
                        this.raise(Errors.RestTrailingComma, prop);
                    }
                } else {
                    this.toAssignable(prop, isLHS);
                }
            }
        },
        {
            key: "toAssignableList",
            value: function toAssignableList(exprList, trailingCommaLoc, isLHS) {
                var end = exprList.length - 1;
                for(var i = 0; i <= end; i++){
                    var elt = exprList[i];
                    if (!elt) continue;
                    if (elt.type === "SpreadElement") {
                        elt.type = "RestElement";
                        var arg = elt.argument;
                        this.checkToRestConversion(arg, true);
                        this.toAssignable(arg, isLHS);
                    } else {
                        this.toAssignable(elt, isLHS);
                    }
                    if (elt.type === "RestElement") {
                        if (i < end) {
                            this.raise(Errors.RestTrailingComma, elt);
                        } else if (trailingCommaLoc) {
                            this.raise(Errors.RestTrailingComma, trailingCommaLoc);
                        }
                    }
                }
            }
        },
        {
            key: "isAssignable",
            value: function isAssignable(node, isBinding3) {
                var _this = this;
                switch(node.type){
                    case "Identifier":
                    case "ObjectPattern":
                    case "ArrayPattern":
                    case "AssignmentPattern":
                    case "RestElement":
                        return true;
                    case "ObjectExpression":
                        {
                            var last2 = node.properties.length - 1;
                            return node.properties.every(function(prop, i) {
                                return prop.type !== "ObjectMethod" && (i === last2 || prop.type !== "SpreadElement") && _this.isAssignable(prop);
                            });
                        }
                    case "ObjectProperty":
                        return this.isAssignable(node.value);
                    case "SpreadElement":
                        return this.isAssignable(node.argument);
                    case "ArrayExpression":
                        return node.elements.every(function(element) {
                            return element === null || _this.isAssignable(element);
                        });
                    case "AssignmentExpression":
                        return node.operator === "=";
                    case "ParenthesizedExpression":
                        return this.isAssignable(node.expression);
                    case "MemberExpression":
                    case "OptionalMemberExpression":
                        return !isBinding3;
                    default:
                        return false;
                }
            }
        },
        {
            key: "toReferencedList",
            value: function toReferencedList(exprList, isParenthesizedExpr) {
                return exprList;
            }
        },
        {
            key: "toReferencedListDeep",
            value: function toReferencedListDeep(exprList, isParenthesizedExpr) {
                this.toReferencedList(exprList, isParenthesizedExpr);
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = exprList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var expr = _step.value;
                        if ((expr === null || expr === void 0 ? void 0 : expr.type) === "ArrayExpression") {
                            this.toReferencedListDeep(expr.elements);
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        },
        {
            key: "parseSpread",
            value: function parseSpread(refExpressionErrors) {
                var node = this.startNode();
                this.next();
                node.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, void 0);
                return this.finishNode(node, "SpreadElement");
            }
        },
        {
            key: "parseRestBinding",
            value: function parseRestBinding() {
                var node = this.startNode();
                this.next();
                node.argument = this.parseBindingAtom();
                return this.finishNode(node, "RestElement");
            }
        },
        {
            key: "parseBindingAtom",
            value: function parseBindingAtom() {
                switch(this.state.type){
                    case 0:
                        {
                            var node = this.startNode();
                            this.next();
                            node.elements = this.parseBindingList(3, 93, 1);
                            return this.finishNode(node, "ArrayPattern");
                        }
                    case 5:
                        return this.parseObjectLike(8, true);
                }
                return this.parseIdentifier();
            }
        },
        {
            key: "parseBindingList",
            value: function parseBindingList(close, closeCharCode, flags) {
                var allowEmpty = flags & 1;
                var elts = [];
                var first = true;
                while(!this.eat(close)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12);
                    }
                    if (allowEmpty && this.match(12)) {
                        elts.push(null);
                    } else if (this.eat(close)) {
                        break;
                    } else if (this.match(21)) {
                        elts.push(this.parseAssignableListItemTypes(this.parseRestBinding(), flags));
                        if (!this.checkCommaAfterRest(closeCharCode)) {
                            this.expect(close);
                            break;
                        }
                    } else {
                        var decorators = [];
                        if (this.match(26) && this.hasPlugin("decorators")) {
                            this.raise(Errors.UnsupportedParameterDecorator, this.state.startLoc);
                        }
                        while(this.match(26)){
                            decorators.push(this.parseDecorator());
                        }
                        elts.push(this.parseAssignableListItem(flags, decorators));
                    }
                }
                return elts;
            }
        },
        {
            key: "parseBindingRestProperty",
            value: function parseBindingRestProperty(prop) {
                this.next();
                prop.argument = this.parseIdentifier();
                this.checkCommaAfterRest(125);
                return this.finishNode(prop, "RestElement");
            }
        },
        {
            key: "parseBindingProperty",
            value: function parseBindingProperty() {
                var prop = this.startNode();
                var _this_state = this.state, type = _this_state.type, startLoc = _this_state.startLoc;
                if (type === 21) {
                    return this.parseBindingRestProperty(prop);
                } else if (type === 138) {
                    this.expectPlugin("destructuringPrivate", startLoc);
                    this.classScope.usePrivateName(this.state.value, startLoc);
                    prop.key = this.parsePrivateName();
                } else {
                    this.parsePropertyName(prop);
                }
                prop.method = false;
                return this.parseObjPropValue(prop, startLoc, false, false, true, false);
            }
        },
        {
            key: "parseAssignableListItem",
            value: function parseAssignableListItem(flags, decorators) {
                var left = this.parseMaybeDefault();
                this.parseAssignableListItemTypes(left, flags);
                var elt = this.parseMaybeDefault(left.loc.start, left);
                if (decorators.length) {
                    left.decorators = decorators;
                }
                return elt;
            }
        },
        {
            key: "parseAssignableListItemTypes",
            value: function parseAssignableListItemTypes(param, flags) {
                return param;
            }
        },
        {
            key: "parseMaybeDefault",
            value: function parseMaybeDefault(startLoc, left) {
                startLoc !== null && startLoc !== void 0 ? startLoc : startLoc = this.state.startLoc;
                left = left !== null && left !== void 0 ? left : this.parseBindingAtom();
                if (!this.eat(29)) return left;
                var node = this.startNodeAt(startLoc);
                node.left = left;
                node.right = this.parseMaybeAssignAllowIn();
                return this.finishNode(node, "AssignmentPattern");
            }
        },
        {
            key: "isValidLVal",
            value: function isValidLVal(type, isUnparenthesizedInAssign, binding) {
                return getOwn$1({
                    AssignmentPattern: "left",
                    RestElement: "argument",
                    ObjectProperty: "value",
                    ParenthesizedExpression: "expression",
                    ArrayPattern: "elements",
                    ObjectPattern: "properties"
                }, type);
            }
        },
        {
            key: "isOptionalMemberExpression",
            value: function isOptionalMemberExpression(expression2) {
                return expression2.type === "OptionalMemberExpression";
            }
        },
        {
            key: "checkLVal",
            value: function checkLVal(expression2, param) {
                var ancestor = param.in, _param_binding = param.binding, binding = _param_binding === void 0 ? 64 : _param_binding, _param_checkClashes = param.checkClashes, checkClashes = _param_checkClashes === void 0 ? false : _param_checkClashes, _param_strictModeChanged = param.strictModeChanged, strictModeChanged = _param_strictModeChanged === void 0 ? false : _param_strictModeChanged, _param_hasParenthesizedAncestor = param.hasParenthesizedAncestor, hasParenthesizedAncestor = _param_hasParenthesizedAncestor === void 0 ? false : _param_hasParenthesizedAncestor;
                var _expression2_extra;
                var type = expression2.type;
                if (this.isObjectMethod(expression2)) return;
                var isOptionalMemberExpression3 = this.isOptionalMemberExpression(expression2);
                if (isOptionalMemberExpression3 || type === "MemberExpression") {
                    if (isOptionalMemberExpression3) {
                        this.expectPlugin("optionalChainingAssign", expression2.loc.start);
                        if (ancestor.type !== "AssignmentExpression") {
                            this.raise(Errors.InvalidLhsOptionalChaining, expression2, {
                                ancestor: ancestor
                            });
                        }
                    }
                    if (binding !== 64) {
                        this.raise(Errors.InvalidPropertyBindingPattern, expression2);
                    }
                    return;
                }
                if (type === "Identifier") {
                    this.checkIdentifier(expression2, binding, strictModeChanged);
                    var name = expression2.name;
                    if (checkClashes) {
                        if (checkClashes.has(name)) {
                            this.raise(Errors.ParamDupe, expression2);
                        } else {
                            checkClashes.add(name);
                        }
                    }
                    return;
                }
                var validity = this.isValidLVal(type, !(hasParenthesizedAncestor || ((_expression2_extra = expression2.extra) === null || _expression2_extra === void 0 ? void 0 : _expression2_extra.parenthesized)) && ancestor.type === "AssignmentExpression", binding);
                if (validity === true) return;
                if (validity === false) {
                    var ParseErrorClass = binding === 64 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
                    this.raise(ParseErrorClass, expression2, {
                        ancestor: ancestor
                    });
                    return;
                }
                var _ref = _sliced_to_array(Array.isArray(validity) ? validity : [
                    validity,
                    type === "ParenthesizedExpression"
                ], 2), key = _ref[0], isParenthesizedExpression2 = _ref[1];
                var nextAncestor = type === "ArrayPattern" || type === "ObjectPattern" ? {
                    type: type
                } : ancestor;
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = [].concat(expression2[key])[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var child = _step.value;
                        if (child) {
                            this.checkLVal(child, {
                                in: nextAncestor,
                                binding: binding,
                                checkClashes: checkClashes,
                                strictModeChanged: strictModeChanged,
                                hasParenthesizedAncestor: isParenthesizedExpression2
                            });
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        },
        {
            key: "checkIdentifier",
            value: function checkIdentifier(at, bindingType) {
                var strictModeChanged = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(at.name, this.inModule) : isStrictBindOnlyReservedWord(at.name))) {
                    if (bindingType === 64) {
                        this.raise(Errors.StrictEvalArguments, at, {
                            referenceName: at.name
                        });
                    } else {
                        this.raise(Errors.StrictEvalArgumentsBinding, at, {
                            bindingName: at.name
                        });
                    }
                }
                if (bindingType & 8192 && at.name === "let") {
                    this.raise(Errors.LetInLexicalBinding, at);
                }
                if (!(bindingType & 64)) {
                    this.declareNameFromIdentifier(at, bindingType);
                }
            }
        },
        {
            key: "declareNameFromIdentifier",
            value: function declareNameFromIdentifier(identifier7, binding) {
                this.scope.declareName(identifier7.name, binding, identifier7.loc.start);
            }
        },
        {
            key: "checkToRestConversion",
            value: function checkToRestConversion(node, allowPattern) {
                switch(node.type){
                    case "ParenthesizedExpression":
                        this.checkToRestConversion(node.expression, allowPattern);
                        break;
                    case "Identifier":
                    case "MemberExpression":
                        break;
                    case "ArrayExpression":
                    case "ObjectExpression":
                        if (allowPattern) break;
                    default:
                        this.raise(Errors.InvalidRestAssignmentPattern, node);
                }
            }
        },
        {
            key: "checkCommaAfterRest",
            value: function checkCommaAfterRest(close) {
                if (!this.match(12)) {
                    return false;
                }
                this.raise(this.lookaheadCharCode() === close ? Errors.RestTrailingComma : Errors.ElementAfterRest, this.state.startLoc);
                return true;
            }
        }
    ]);
    return LValParser;
}(NodeUtils);
var getOwn = function(object, key) {
    return Object.hasOwnProperty.call(object, key) && object[key];
};
function nonNull(x) {
    if (x == null) {
        throw new Error("Unexpected ".concat(x, " value."));
    }
    return x;
}
function assert2(x) {
    if (!x) {
        throw new Error("Assert fail");
    }
}
var TSErrors = ParseErrorEnum(_templateObject3())({
    AbstractMethodHasImplementation: function(param) {
        var methodName = param.methodName;
        return "Method '".concat(methodName, "' cannot have an implementation because it is marked abstract.");
    },
    AbstractPropertyHasInitializer: function(param) {
        var propertyName = param.propertyName;
        return "Property '".concat(propertyName, "' cannot have an initializer because it is marked abstract.");
    },
    AccesorCannotDeclareThisParameter: "'get' and 'set' accessors cannot declare 'this' parameters.",
    AccesorCannotHaveTypeParameters: "An accessor cannot have type parameters.",
    AccessorCannotBeOptional: "An 'accessor' property cannot be declared optional.",
    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
    ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
    ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
    ConstructorHasTypeParameters: "Type parameters cannot appear on a constructor declaration.",
    DeclareAccessor: function(param) {
        var kind = param.kind;
        return "'declare' is not allowed in ".concat(kind, "ters.");
    },
    DeclareClassFieldHasInitializer: "Initializers are not allowed in ambient contexts.",
    DeclareFunctionHasImplementation: "An implementation cannot be declared in ambient contexts.",
    DuplicateAccessibilityModifier: function(param) {
        var modifier = param.modifier;
        return "Accessibility modifier already seen.";
    },
    DuplicateModifier: function(param) {
        var modifier = param.modifier;
        return "Duplicate modifier: '".concat(modifier, "'.");
    },
    EmptyHeritageClauseType: function(param) {
        var token = param.token;
        return "'".concat(token, "' list cannot be empty.");
    },
    EmptyTypeArguments: "Type argument list cannot be empty.",
    EmptyTypeParameters: "Type parameter list cannot be empty.",
    ExpectedAmbientAfterExportDeclare: "'export declare' must be followed by an ambient declaration.",
    ImportAliasHasImportType: "An import alias can not use 'import type'.",
    ImportReflectionHasImportType: "An `import module` declaration can not use `type` modifier",
    IncompatibleModifiers: function(param) {
        var modifiers = param.modifiers;
        return "'".concat(modifiers[0], "' modifier cannot be used with '").concat(modifiers[1], "' modifier.");
    },
    IndexSignatureHasAbstract: "Index signatures cannot have the 'abstract' modifier.",
    IndexSignatureHasAccessibility: function(param) {
        var modifier = param.modifier;
        return "Index signatures cannot have an accessibility modifier ('".concat(modifier, "').");
    },
    IndexSignatureHasDeclare: "Index signatures cannot have the 'declare' modifier.",
    IndexSignatureHasOverride: "'override' modifier cannot appear on an index signature.",
    IndexSignatureHasStatic: "Index signatures cannot have the 'static' modifier.",
    InitializerNotAllowedInAmbientContext: "Initializers are not allowed in ambient contexts.",
    InvalidModifierOnTypeMember: function(param) {
        var modifier = param.modifier;
        return "'".concat(modifier, "' modifier cannot appear on a type member.");
    },
    InvalidModifierOnTypeParameter: function(param) {
        var modifier = param.modifier;
        return "'".concat(modifier, "' modifier cannot appear on a type parameter.");
    },
    InvalidModifierOnTypeParameterPositions: function(param) {
        var modifier = param.modifier;
        return "'".concat(modifier, "' modifier can only appear on a type parameter of a class, interface or type alias.");
    },
    InvalidModifiersOrder: function(param) {
        var orderedModifiers = param.orderedModifiers;
        return "'".concat(orderedModifiers[0], "' modifier must precede '").concat(orderedModifiers[1], "' modifier.");
    },
    InvalidPropertyAccessAfterInstantiationExpression: "Invalid property access after an instantiation expression. You can either wrap the instantiation expression in parentheses, or delete the type arguments.",
    InvalidTupleMemberLabel: "Tuple members must be labeled with a simple identifier.",
    MissingInterfaceName: "'interface' declarations must be followed by an identifier.",
    NonAbstractClassHasAbstractMethod: "Abstract methods can only appear within an abstract class.",
    NonClassMethodPropertyHasAbstractModifer: "'abstract' modifier can only appear on a class, method, or property declaration.",
    OptionalTypeBeforeRequired: "A required element cannot follow an optional element.",
    OverrideNotInSubClass: "This member cannot have an 'override' modifier because its containing class does not extend another class.",
    PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
    PrivateElementHasAbstract: "Private elements cannot have the 'abstract' modifier.",
    PrivateElementHasAccessibility: function(param) {
        var modifier = param.modifier;
        return "Private elements cannot have an accessibility modifier ('".concat(modifier, "').");
    },
    ReadonlyForMethodSignature: "'readonly' modifier can only appear on a property declaration or index signature.",
    ReservedArrowTypeParam: "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.",
    ReservedTypeAssertion: "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.",
    SetAccesorCannotHaveOptionalParameter: "A 'set' accessor cannot have an optional parameter.",
    SetAccesorCannotHaveRestParameter: "A 'set' accessor cannot have rest parameter.",
    SetAccesorCannotHaveReturnType: "A 'set' accessor cannot have a return type annotation.",
    SingleTypeParameterWithoutTrailingComma: function(param) {
        var typeParameterName = param.typeParameterName;
        return "Single type parameter ".concat(typeParameterName, " should have a trailing comma. Example usage: <").concat(typeParameterName, ",>.");
    },
    StaticBlockCannotHaveModifier: "Static class blocks cannot have any modifier.",
    TupleOptionalAfterType: "A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).",
    TypeAnnotationAfterAssign: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
    TypeImportCannotSpecifyDefaultAndNamed: "A type-only import can specify a default import or named bindings, but not both.",
    TypeModifierIsUsedInTypeExports: "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
    TypeModifierIsUsedInTypeImports: "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
    UnexpectedParameterModifier: "A parameter property is only allowed in a constructor implementation.",
    UnexpectedReadonly: "'readonly' type modifier is only permitted on array and tuple literal types.",
    UnexpectedTypeAnnotation: "Did not expect a type annotation here.",
    UnexpectedTypeCastInParameter: "Unexpected type cast in parameter position.",
    UnsupportedImportTypeArgument: "Argument in a type import must be a string literal.",
    UnsupportedParameterPropertyKind: "A parameter property may not be declared using a binding pattern.",
    UnsupportedSignatureParameterKind: function(param) {
        var type = param.type;
        return "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ".concat(type, ".");
    }
});
function keywordTypeFromName(value1) {
    switch(value1){
        case "any":
            return "TSAnyKeyword";
        case "boolean":
            return "TSBooleanKeyword";
        case "bigint":
            return "TSBigIntKeyword";
        case "never":
            return "TSNeverKeyword";
        case "number":
            return "TSNumberKeyword";
        case "object":
            return "TSObjectKeyword";
        case "string":
            return "TSStringKeyword";
        case "symbol":
            return "TSSymbolKeyword";
        case "undefined":
            return "TSUndefinedKeyword";
        case "unknown":
            return "TSUnknownKeyword";
        default:
            return void 0;
    }
}
function tsIsAccessModifier(modifier) {
    return modifier === "private" || modifier === "public" || modifier === "protected";
}
function tsIsVarianceAnnotations(modifier) {
    return modifier === "in" || modifier === "out";
}
var typescript = function(superClass) {
    var TypeScriptParserMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(TypeScriptParserMixin, superClass);
        var _super = _create_super(TypeScriptParserMixin);
        function TypeScriptParserMixin() {
            _class_call_check(this, TypeScriptParserMixin);
            var _this;
            _this = _super.call.apply(_super, [
                this
            ].concat(Array.prototype.slice.call(arguments)));
            __publicField(_assert_this_initialized(_this), "tsParseInOutModifiers", _this.tsParseModifiers.bind(_assert_this_initialized(_this), {
                allowedModifiers: [
                    "in",
                    "out"
                ],
                disallowedModifiers: [
                    "const",
                    "public",
                    "private",
                    "protected",
                    "readonly",
                    "declare",
                    "abstract",
                    "override"
                ],
                errorTemplate: TSErrors.InvalidModifierOnTypeParameter
            }));
            __publicField(_assert_this_initialized(_this), "tsParseConstModifier", _this.tsParseModifiers.bind(_assert_this_initialized(_this), {
                allowedModifiers: [
                    "const"
                ],
                disallowedModifiers: [
                    "in",
                    "out"
                ],
                errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
            }));
            __publicField(_assert_this_initialized(_this), "tsParseInOutConstModifiers", _this.tsParseModifiers.bind(_assert_this_initialized(_this), {
                allowedModifiers: [
                    "in",
                    "out",
                    "const"
                ],
                disallowedModifiers: [
                    "public",
                    "private",
                    "protected",
                    "readonly",
                    "declare",
                    "abstract",
                    "override"
                ],
                errorTemplate: TSErrors.InvalidModifierOnTypeParameter
            }));
            return _this;
        }
        _create_class(TypeScriptParserMixin, [
            {
                key: "getScopeHandler",
                value: function getScopeHandler() {
                    return TypeScriptScopeHandler;
                }
            },
            {
                key: "tsIsIdentifier",
                value: function tsIsIdentifier() {
                    return tokenIsIdentifier(this.state.type);
                }
            },
            {
                key: "tsTokenCanFollowModifier",
                value: function tsTokenCanFollowModifier() {
                    return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(138) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
                }
            },
            {
                key: "tsNextTokenCanFollowModifier",
                value: function tsNextTokenCanFollowModifier() {
                    this.next();
                    return this.tsTokenCanFollowModifier();
                }
            },
            {
                key: "tsParseModifier",
                value: function tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
                    if (!tokenIsIdentifier(this.state.type) && this.state.type !== 58 && this.state.type !== 75) {
                        return void 0;
                    }
                    var modifier = this.state.value;
                    if (allowedModifiers.indexOf(modifier) !== -1) {
                        if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
                            return void 0;
                        }
                        if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
                            return modifier;
                        }
                    }
                    return void 0;
                }
            },
            {
                key: "tsParseModifiers",
                value: function tsParseModifiers(param, modified) {
                    var _this = this;
                    var allowedModifiers = param.allowedModifiers, disallowedModifiers = param.disallowedModifiers, stopOnStartOfClassStaticBlock = param.stopOnStartOfClassStaticBlock, _param_errorTemplate = param.errorTemplate, errorTemplate = _param_errorTemplate === void 0 ? TSErrors.InvalidModifierOnTypeMember : _param_errorTemplate;
                    var enforceOrder = function(loc, modifier, before, after) {
                        if (modifier === before && modified[after]) {
                            _this.raise(TSErrors.InvalidModifiersOrder, loc, {
                                orderedModifiers: [
                                    before,
                                    after
                                ]
                            });
                        }
                    };
                    var incompatible = function(loc, modifier, mod1, mod2) {
                        if (modified[mod1] && modifier === mod2 || modified[mod2] && modifier === mod1) {
                            _this.raise(TSErrors.IncompatibleModifiers, loc, {
                                modifiers: [
                                    mod1,
                                    mod2
                                ]
                            });
                        }
                    };
                    for(;;){
                        var startLoc = this.state.startLoc;
                        var modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers !== null && disallowedModifiers !== void 0 ? disallowedModifiers : []), stopOnStartOfClassStaticBlock);
                        if (!modifier) break;
                        if (tsIsAccessModifier(modifier)) {
                            if (modified.accessibility) {
                                this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
                                    modifier: modifier
                                });
                            } else {
                                enforceOrder(startLoc, modifier, modifier, "override");
                                enforceOrder(startLoc, modifier, modifier, "static");
                                enforceOrder(startLoc, modifier, modifier, "readonly");
                                modified.accessibility = modifier;
                            }
                        } else if (tsIsVarianceAnnotations(modifier)) {
                            if (modified[modifier]) {
                                this.raise(TSErrors.DuplicateModifier, startLoc, {
                                    modifier: modifier
                                });
                            }
                            modified[modifier] = true;
                            enforceOrder(startLoc, modifier, "in", "out");
                        } else {
                            if (Object.hasOwnProperty.call(modified, modifier)) {
                                this.raise(TSErrors.DuplicateModifier, startLoc, {
                                    modifier: modifier
                                });
                            } else {
                                enforceOrder(startLoc, modifier, "static", "readonly");
                                enforceOrder(startLoc, modifier, "static", "override");
                                enforceOrder(startLoc, modifier, "override", "readonly");
                                enforceOrder(startLoc, modifier, "abstract", "override");
                                incompatible(startLoc, modifier, "declare", "override");
                                incompatible(startLoc, modifier, "static", "abstract");
                            }
                            modified[modifier] = true;
                        }
                        if (disallowedModifiers === null || disallowedModifiers === void 0 ? void 0 : disallowedModifiers.includes(modifier)) {
                            this.raise(errorTemplate, startLoc, {
                                modifier: modifier
                            });
                        }
                    }
                }
            },
            {
                key: "tsIsListTerminator",
                value: function tsIsListTerminator(kind) {
                    switch(kind){
                        case "EnumMembers":
                        case "TypeMembers":
                            return this.match(8);
                        case "HeritageClauseElement":
                            return this.match(5);
                        case "TupleElementTypes":
                            return this.match(3);
                        case "TypeParametersOrArguments":
                            return this.match(48);
                    }
                }
            },
            {
                key: "tsParseList",
                value: function tsParseList(kind, parseElement) {
                    var result = [];
                    while(!this.tsIsListTerminator(kind)){
                        result.push(parseElement());
                    }
                    return result;
                }
            },
            {
                key: "tsParseDelimitedList",
                value: function tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
                    return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
                }
            },
            {
                key: "tsParseDelimitedListWorker",
                value: function tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
                    var result = [];
                    var trailingCommaPos = -1;
                    for(;;){
                        if (this.tsIsListTerminator(kind)) {
                            break;
                        }
                        trailingCommaPos = -1;
                        var element = parseElement();
                        if (element == null) {
                            return void 0;
                        }
                        result.push(element);
                        if (this.eat(12)) {
                            trailingCommaPos = this.state.lastTokStartLoc.index;
                            continue;
                        }
                        if (this.tsIsListTerminator(kind)) {
                            break;
                        }
                        if (expectSuccess) {
                            this.expect(12);
                        }
                        return void 0;
                    }
                    if (refTrailingCommaPos) {
                        refTrailingCommaPos.value = trailingCommaPos;
                    }
                    return result;
                }
            },
            {
                key: "tsParseBracketedList",
                value: function tsParseBracketedList(kind, parseElement, bracket, skipFirstToken, refTrailingCommaPos) {
                    if (!skipFirstToken) {
                        if (bracket) {
                            this.expect(0);
                        } else {
                            this.expect(47);
                        }
                    }
                    var result = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);
                    if (bracket) {
                        this.expect(3);
                    } else {
                        this.expect(48);
                    }
                    return result;
                }
            },
            {
                key: "tsParseImportType",
                value: function tsParseImportType() {
                    var node = this.startNode();
                    this.expect(83);
                    this.expect(10);
                    if (!this.match(133)) {
                        this.raise(TSErrors.UnsupportedImportTypeArgument, this.state.startLoc);
                    }
                    node.argument = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExprAtom", this).call(this);
                    this.expect(11);
                    if (this.eat(16)) {
                        node.qualifier = this.tsParseEntityName();
                    }
                    if (this.match(47)) {
                        node.typeParameters = this.tsParseTypeArguments();
                    }
                    return this.finishNode(node, "TSImportType");
                }
            },
            {
                key: "tsParseEntityName",
                value: function tsParseEntityName() {
                    var allowReservedWords = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
                    var entity = this.parseIdentifier(allowReservedWords);
                    while(this.eat(16)){
                        var node = this.startNodeAtNode(entity);
                        node.left = entity;
                        node.right = this.parseIdentifier(allowReservedWords);
                        entity = this.finishNode(node, "TSQualifiedName");
                    }
                    return entity;
                }
            },
            {
                key: "tsParseTypeReference",
                value: function tsParseTypeReference() {
                    var node = this.startNode();
                    node.typeName = this.tsParseEntityName();
                    if (!this.hasPrecedingLineBreak() && this.match(47)) {
                        node.typeParameters = this.tsParseTypeArguments();
                    }
                    return this.finishNode(node, "TSTypeReference");
                }
            },
            {
                key: "tsParseThisTypePredicate",
                value: function tsParseThisTypePredicate(lhs) {
                    this.next();
                    var node = this.startNodeAtNode(lhs);
                    node.parameterName = lhs;
                    node.typeAnnotation = this.tsParseTypeAnnotation(false);
                    node.asserts = false;
                    return this.finishNode(node, "TSTypePredicate");
                }
            },
            {
                key: "tsParseThisTypeNode",
                value: function tsParseThisTypeNode() {
                    var node = this.startNode();
                    this.next();
                    return this.finishNode(node, "TSThisType");
                }
            },
            {
                key: "tsParseTypeQuery",
                value: function tsParseTypeQuery() {
                    var node = this.startNode();
                    this.expect(87);
                    if (this.match(83)) {
                        node.exprName = this.tsParseImportType();
                    } else {
                        node.exprName = this.tsParseEntityName();
                    }
                    if (!this.hasPrecedingLineBreak() && this.match(47)) {
                        node.typeParameters = this.tsParseTypeArguments();
                    }
                    return this.finishNode(node, "TSTypeQuery");
                }
            },
            {
                key: "tsParseTypeParameter",
                value: function tsParseTypeParameter(parseModifiers) {
                    var node = this.startNode();
                    parseModifiers(node);
                    node.name = this.tsParseTypeParameterName();
                    node.constraint = this.tsEatThenParseType(81);
                    node.default = this.tsEatThenParseType(29);
                    return this.finishNode(node, "TSTypeParameter");
                }
            },
            {
                key: "tsTryParseTypeParameters",
                value: function tsTryParseTypeParameters(parseModifiers) {
                    if (this.match(47)) {
                        return this.tsParseTypeParameters(parseModifiers);
                    }
                }
            },
            {
                key: "tsParseTypeParameters",
                value: function tsParseTypeParameters(parseModifiers) {
                    var node = this.startNode();
                    if (this.match(47) || this.match(142)) {
                        this.next();
                    } else {
                        this.unexpected();
                    }
                    var refTrailingCommaPos = {
                        value: -1
                    };
                    node.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, parseModifiers), false, true, refTrailingCommaPos);
                    if (node.params.length === 0) {
                        this.raise(TSErrors.EmptyTypeParameters, node);
                    }
                    if (refTrailingCommaPos.value !== -1) {
                        this.addExtra(node, "trailingComma", refTrailingCommaPos.value);
                    }
                    return this.finishNode(node, "TSTypeParameterDeclaration");
                }
            },
            {
                key: "tsFillSignature",
                value: function tsFillSignature(returnToken, signature) {
                    var returnTokenRequired = returnToken === 19;
                    var paramsKey = "params";
                    var returnTypeKey = "returnType";
                    signature.typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
                    this.expect(10);
                    signature[paramsKey] = this.tsParseBindingListForSignature();
                    if (returnTokenRequired) {
                        signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
                    } else if (this.match(returnToken)) {
                        signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
                    }
                }
            },
            {
                key: "tsParseBindingListForSignature",
                value: function tsParseBindingListForSignature() {
                    var list = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseBindingList", this).call(this, 11, 41, 2);
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = list[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var pattern = _step.value;
                            var type = pattern.type;
                            if (type === "AssignmentPattern" || type === "TSParameterProperty") {
                                this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
                                    type: type
                                });
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return list;
                }
            },
            {
                key: "tsParseTypeMemberSemicolon",
                value: function tsParseTypeMemberSemicolon() {
                    if (!this.eat(12) && !this.isLineTerminator()) {
                        this.expect(13);
                    }
                }
            },
            {
                key: "tsParseSignatureMember",
                value: function tsParseSignatureMember(kind, node) {
                    this.tsFillSignature(14, node);
                    this.tsParseTypeMemberSemicolon();
                    return this.finishNode(node, kind);
                }
            },
            {
                key: "tsIsUnambiguouslyIndexSignature",
                value: function tsIsUnambiguouslyIndexSignature() {
                    this.next();
                    if (tokenIsIdentifier(this.state.type)) {
                        this.next();
                        return this.match(14);
                    }
                    return false;
                }
            },
            {
                key: "tsTryParseIndexSignature",
                value: function tsTryParseIndexSignature(node) {
                    if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
                        return;
                    }
                    this.expect(0);
                    var id = this.parseIdentifier();
                    id.typeAnnotation = this.tsParseTypeAnnotation();
                    this.resetEndLocation(id);
                    this.expect(3);
                    node.parameters = [
                        id
                    ];
                    var type = this.tsTryParseTypeAnnotation();
                    if (type) node.typeAnnotation = type;
                    this.tsParseTypeMemberSemicolon();
                    return this.finishNode(node, "TSIndexSignature");
                }
            },
            {
                key: "tsParsePropertyOrMethodSignature",
                value: function tsParsePropertyOrMethodSignature(node, readonly) {
                    if (this.eat(17)) node.optional = true;
                    var nodeAny = node;
                    if (this.match(10) || this.match(47)) {
                        if (readonly) {
                            this.raise(TSErrors.ReadonlyForMethodSignature, node);
                        }
                        var method = nodeAny;
                        if (method.kind && this.match(47)) {
                            this.raise(TSErrors.AccesorCannotHaveTypeParameters, this.state.curPosition());
                        }
                        this.tsFillSignature(14, method);
                        this.tsParseTypeMemberSemicolon();
                        var paramsKey = "params";
                        var returnTypeKey = "returnType";
                        if (method.kind === "get") {
                            if (method[paramsKey].length > 0) {
                                this.raise(Errors.BadGetterArity, this.state.curPosition());
                                if (this.isThisParam(method[paramsKey][0])) {
                                    this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
                                }
                            }
                        } else if (method.kind === "set") {
                            if (method[paramsKey].length !== 1) {
                                this.raise(Errors.BadSetterArity, this.state.curPosition());
                            } else {
                                var firstParameter = method[paramsKey][0];
                                if (this.isThisParam(firstParameter)) {
                                    this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
                                }
                                if (firstParameter.type === "Identifier" && firstParameter.optional) {
                                    this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, this.state.curPosition());
                                }
                                if (firstParameter.type === "RestElement") {
                                    this.raise(TSErrors.SetAccesorCannotHaveRestParameter, this.state.curPosition());
                                }
                            }
                            if (method[returnTypeKey]) {
                                this.raise(TSErrors.SetAccesorCannotHaveReturnType, method[returnTypeKey]);
                            }
                        } else {
                            method.kind = "method";
                        }
                        return this.finishNode(method, "TSMethodSignature");
                    } else {
                        var property = nodeAny;
                        if (readonly) property.readonly = true;
                        var type = this.tsTryParseTypeAnnotation();
                        if (type) property.typeAnnotation = type;
                        this.tsParseTypeMemberSemicolon();
                        return this.finishNode(property, "TSPropertySignature");
                    }
                }
            },
            {
                key: "tsParseTypeMember",
                value: function tsParseTypeMember() {
                    var node = this.startNode();
                    if (this.match(10) || this.match(47)) {
                        return this.tsParseSignatureMember("TSCallSignatureDeclaration", node);
                    }
                    if (this.match(77)) {
                        var id = this.startNode();
                        this.next();
                        if (this.match(10) || this.match(47)) {
                            return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node);
                        } else {
                            node.key = this.createIdentifier(id, "new");
                            return this.tsParsePropertyOrMethodSignature(node, false);
                        }
                    }
                    this.tsParseModifiers({
                        allowedModifiers: [
                            "readonly"
                        ],
                        disallowedModifiers: [
                            "declare",
                            "abstract",
                            "private",
                            "protected",
                            "public",
                            "static",
                            "override"
                        ]
                    }, node);
                    var idx = this.tsTryParseIndexSignature(node);
                    if (idx) {
                        return idx;
                    }
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parsePropertyName", this).call(this, node);
                    if (!node.computed && node.key.type === "Identifier" && (node.key.name === "get" || node.key.name === "set") && this.tsTokenCanFollowModifier()) {
                        node.kind = node.key.name;
                        _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parsePropertyName", this).call(this, node);
                    }
                    return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
                }
            },
            {
                key: "tsParseTypeLiteral",
                value: function tsParseTypeLiteral() {
                    var node = this.startNode();
                    node.members = this.tsParseObjectTypeMembers();
                    return this.finishNode(node, "TSTypeLiteral");
                }
            },
            {
                key: "tsParseObjectTypeMembers",
                value: function tsParseObjectTypeMembers() {
                    this.expect(5);
                    var members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
                    this.expect(8);
                    return members;
                }
            },
            {
                key: "tsIsStartOfMappedType",
                value: function tsIsStartOfMappedType() {
                    this.next();
                    if (this.eat(53)) {
                        return this.isContextual(122);
                    }
                    if (this.isContextual(122)) {
                        this.next();
                    }
                    if (!this.match(0)) {
                        return false;
                    }
                    this.next();
                    if (!this.tsIsIdentifier()) {
                        return false;
                    }
                    this.next();
                    return this.match(58);
                }
            },
            {
                key: "tsParseMappedTypeParameter",
                value: function tsParseMappedTypeParameter() {
                    var node = this.startNode();
                    node.name = this.tsParseTypeParameterName();
                    node.constraint = this.tsExpectThenParseType(58);
                    return this.finishNode(node, "TSTypeParameter");
                }
            },
            {
                key: "tsParseMappedType",
                value: function tsParseMappedType() {
                    var node = this.startNode();
                    this.expect(5);
                    if (this.match(53)) {
                        node.readonly = this.state.value;
                        this.next();
                        this.expectContextual(122);
                    } else if (this.eatContextual(122)) {
                        node.readonly = true;
                    }
                    this.expect(0);
                    node.typeParameter = this.tsParseMappedTypeParameter();
                    node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
                    this.expect(3);
                    if (this.match(53)) {
                        node.optional = this.state.value;
                        this.next();
                        this.expect(17);
                    } else if (this.eat(17)) {
                        node.optional = true;
                    }
                    node.typeAnnotation = this.tsTryParseType();
                    this.semicolon();
                    this.expect(8);
                    return this.finishNode(node, "TSMappedType");
                }
            },
            {
                key: "tsParseTupleType",
                value: function tsParseTupleType() {
                    var _this = this;
                    var node = this.startNode();
                    node.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
                    var seenOptionalElement = false;
                    node.elementTypes.forEach(function(elementNode) {
                        var type = elementNode.type;
                        if (seenOptionalElement && type !== "TSRestType" && type !== "TSOptionalType" && !(type === "TSNamedTupleMember" && elementNode.optional)) {
                            _this.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
                        }
                        seenOptionalElement || (seenOptionalElement = type === "TSNamedTupleMember" && elementNode.optional || type === "TSOptionalType");
                    });
                    return this.finishNode(node, "TSTupleType");
                }
            },
            {
                key: "tsParseTupleElementType",
                value: function tsParseTupleElementType() {
                    var startLoc = this.state.startLoc;
                    var rest = this.eat(21);
                    var labeled;
                    var label;
                    var optional;
                    var type;
                    var isWord = tokenIsKeywordOrIdentifier(this.state.type);
                    var chAfterWord = isWord ? this.lookaheadCharCode() : null;
                    if (chAfterWord === 58) {
                        labeled = true;
                        optional = false;
                        label = this.parseIdentifier(true);
                        this.expect(14);
                        type = this.tsParseType();
                    } else if (chAfterWord === 63) {
                        optional = true;
                        var startLoc2 = this.state.startLoc;
                        var wordName = this.state.value;
                        var typeOrLabel = this.tsParseNonArrayType();
                        if (this.lookaheadCharCode() === 58) {
                            labeled = true;
                            label = this.createIdentifier(this.startNodeAt(startLoc2), wordName);
                            this.expect(17);
                            this.expect(14);
                            type = this.tsParseType();
                        } else {
                            labeled = false;
                            type = typeOrLabel;
                            this.expect(17);
                        }
                    } else {
                        type = this.tsParseType();
                        optional = this.eat(17);
                        labeled = this.eat(14);
                    }
                    if (labeled) {
                        var labeledNode;
                        if (label) {
                            labeledNode = this.startNodeAtNode(label);
                            labeledNode.optional = optional;
                            labeledNode.label = label;
                            labeledNode.elementType = type;
                            if (this.eat(17)) {
                                labeledNode.optional = true;
                                this.raise(TSErrors.TupleOptionalAfterType, this.state.lastTokStartLoc);
                            }
                        } else {
                            labeledNode = this.startNodeAtNode(type);
                            labeledNode.optional = optional;
                            this.raise(TSErrors.InvalidTupleMemberLabel, type);
                            labeledNode.label = type;
                            labeledNode.elementType = this.tsParseType();
                        }
                        type = this.finishNode(labeledNode, "TSNamedTupleMember");
                    } else if (optional) {
                        var optionalTypeNode = this.startNodeAtNode(type);
                        optionalTypeNode.typeAnnotation = type;
                        type = this.finishNode(optionalTypeNode, "TSOptionalType");
                    }
                    if (rest) {
                        var restNode = this.startNodeAt(startLoc);
                        restNode.typeAnnotation = type;
                        type = this.finishNode(restNode, "TSRestType");
                    }
                    return type;
                }
            },
            {
                key: "tsParseParenthesizedType",
                value: function tsParseParenthesizedType() {
                    var node = this.startNode();
                    this.expect(10);
                    node.typeAnnotation = this.tsParseType();
                    this.expect(11);
                    return this.finishNode(node, "TSParenthesizedType");
                }
            },
            {
                key: "tsParseFunctionOrConstructorType",
                value: function tsParseFunctionOrConstructorType(type, abstract) {
                    var _this = this;
                    var node = this.startNode();
                    if (type === "TSConstructorType") {
                        node.abstract = !!abstract;
                        if (abstract) this.next();
                        this.next();
                    }
                    this.tsInAllowConditionalTypesContext(function() {
                        return _this.tsFillSignature(19, node);
                    });
                    return this.finishNode(node, type);
                }
            },
            {
                key: "tsParseLiteralTypeNode",
                value: function tsParseLiteralTypeNode() {
                    var node = this.startNode();
                    switch(this.state.type){
                        case 134:
                        case 135:
                        case 133:
                        case 85:
                        case 86:
                            node.literal = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExprAtom", this).call(this);
                            break;
                        default:
                            this.unexpected();
                    }
                    return this.finishNode(node, "TSLiteralType");
                }
            },
            {
                key: "tsParseTemplateLiteralType",
                value: function tsParseTemplateLiteralType() {
                    var node = this.startNode();
                    node.literal = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseTemplate", this).call(this, false);
                    return this.finishNode(node, "TSLiteralType");
                }
            },
            {
                key: "parseTemplateSubstitution",
                value: function parseTemplateSubstitution() {
                    if (this.state.inType) return this.tsParseType();
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseTemplateSubstitution", this).call(this);
                }
            },
            {
                key: "tsParseThisTypeOrThisTypePredicate",
                value: function tsParseThisTypeOrThisTypePredicate() {
                    var thisKeyword = this.tsParseThisTypeNode();
                    if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
                        return this.tsParseThisTypePredicate(thisKeyword);
                    } else {
                        return thisKeyword;
                    }
                }
            },
            {
                key: "tsParseNonArrayType",
                value: function tsParseNonArrayType() {
                    switch(this.state.type){
                        case 133:
                        case 134:
                        case 135:
                        case 85:
                        case 86:
                            return this.tsParseLiteralTypeNode();
                        case 53:
                            if (this.state.value === "-") {
                                var node = this.startNode();
                                var nextToken = this.lookahead();
                                if (nextToken.type !== 134 && nextToken.type !== 135) {
                                    this.unexpected();
                                }
                                node.literal = this.parseMaybeUnary();
                                return this.finishNode(node, "TSLiteralType");
                            }
                            break;
                        case 78:
                            return this.tsParseThisTypeOrThisTypePredicate();
                        case 87:
                            return this.tsParseTypeQuery();
                        case 83:
                            return this.tsParseImportType();
                        case 5:
                            return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
                        case 0:
                            return this.tsParseTupleType();
                        case 10:
                            {
                                if (!this.options.createParenthesizedExpressions) {
                                    var startLoc = this.state.startLoc;
                                    this.next();
                                    var type = this.tsParseType();
                                    this.expect(11);
                                    this.addExtra(type, "parenthesized", true);
                                    this.addExtra(type, "parenStart", startLoc.index);
                                    return type;
                                }
                            }
                            return this.tsParseParenthesizedType();
                        case 25:
                        case 24:
                            return this.tsParseTemplateLiteralType();
                        default:
                            {
                                var type1 = this.state.type;
                                if (tokenIsIdentifier(type1) || type1 === 88 || type1 === 84) {
                                    var nodeType = type1 === 88 ? "TSVoidKeyword" : type1 === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);
                                    if (nodeType !== void 0 && this.lookaheadCharCode() !== 46) {
                                        var node1 = this.startNode();
                                        this.next();
                                        return this.finishNode(node1, nodeType);
                                    }
                                    return this.tsParseTypeReference();
                                }
                            }
                    }
                    this.unexpected();
                }
            },
            {
                key: "tsParseArrayTypeOrHigher",
                value: function tsParseArrayTypeOrHigher() {
                    var type = this.tsParseNonArrayType();
                    while(!this.hasPrecedingLineBreak() && this.eat(0)){
                        if (this.match(3)) {
                            var node = this.startNodeAtNode(type);
                            node.elementType = type;
                            this.expect(3);
                            type = this.finishNode(node, "TSArrayType");
                        } else {
                            var node1 = this.startNodeAtNode(type);
                            node1.objectType = type;
                            node1.indexType = this.tsParseType();
                            this.expect(3);
                            type = this.finishNode(node1, "TSIndexedAccessType");
                        }
                    }
                    return type;
                }
            },
            {
                key: "tsParseTypeOperator",
                value: function tsParseTypeOperator() {
                    var node = this.startNode();
                    var operator = this.state.value;
                    this.next();
                    node.operator = operator;
                    node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
                    if (operator === "readonly") {
                        this.tsCheckTypeAnnotationForReadOnly(node);
                    }
                    return this.finishNode(node, "TSTypeOperator");
                }
            },
            {
                key: "tsCheckTypeAnnotationForReadOnly",
                value: function tsCheckTypeAnnotationForReadOnly(node) {
                    switch(node.typeAnnotation.type){
                        case "TSTupleType":
                        case "TSArrayType":
                            return;
                        default:
                            this.raise(TSErrors.UnexpectedReadonly, node);
                    }
                }
            },
            {
                key: "tsParseInferType",
                value: function tsParseInferType() {
                    var _this = this;
                    var node = this.startNode();
                    this.expectContextual(115);
                    var typeParameter2 = this.startNode();
                    typeParameter2.name = this.tsParseTypeParameterName();
                    typeParameter2.constraint = this.tsTryParse(function() {
                        return _this.tsParseConstraintForInferType();
                    });
                    node.typeParameter = this.finishNode(typeParameter2, "TSTypeParameter");
                    return this.finishNode(node, "TSInferType");
                }
            },
            {
                key: "tsParseConstraintForInferType",
                value: function tsParseConstraintForInferType() {
                    var _this = this;
                    if (this.eat(81)) {
                        var constraint = this.tsInDisallowConditionalTypesContext(function() {
                            return _this.tsParseType();
                        });
                        if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
                            return constraint;
                        }
                    }
                }
            },
            {
                key: "tsParseTypeOperatorOrHigher",
                value: function tsParseTypeOperatorOrHigher() {
                    var _this = this;
                    var isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
                    return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(115) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(function() {
                        return _this.tsParseArrayTypeOrHigher();
                    });
                }
            },
            {
                key: "tsParseUnionOrIntersectionType",
                value: function tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
                    var node = this.startNode();
                    var hasLeadingOperator = this.eat(operator);
                    var types2 = [];
                    do {
                        types2.push(parseConstituentType());
                    }while (this.eat(operator));
                    if (types2.length === 1 && !hasLeadingOperator) {
                        return types2[0];
                    }
                    node.types = types2;
                    return this.finishNode(node, kind);
                }
            },
            {
                key: "tsParseIntersectionTypeOrHigher",
                value: function tsParseIntersectionTypeOrHigher() {
                    return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
                }
            },
            {
                key: "tsParseUnionTypeOrHigher",
                value: function tsParseUnionTypeOrHigher() {
                    return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
                }
            },
            {
                key: "tsIsStartOfFunctionType",
                value: function tsIsStartOfFunctionType() {
                    if (this.match(47)) {
                        return true;
                    }
                    return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
                }
            },
            {
                key: "tsSkipParameterStart",
                value: function tsSkipParameterStart() {
                    if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                        this.next();
                        return true;
                    }
                    if (this.match(5)) {
                        var errors = this.state.errors;
                        var previousErrorCount = errors.length;
                        try {
                            this.parseObjectLike(8, true);
                            return errors.length === previousErrorCount;
                        } catch (e) {
                            return false;
                        }
                    }
                    if (this.match(0)) {
                        this.next();
                        var errors1 = this.state.errors;
                        var previousErrorCount1 = errors1.length;
                        try {
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseBindingList", this).call(this, 3, 93, 1);
                            return errors1.length === previousErrorCount1;
                        } catch (e) {
                            return false;
                        }
                    }
                    return false;
                }
            },
            {
                key: "tsIsUnambiguouslyStartOfFunctionType",
                value: function tsIsUnambiguouslyStartOfFunctionType() {
                    this.next();
                    if (this.match(11) || this.match(21)) {
                        return true;
                    }
                    if (this.tsSkipParameterStart()) {
                        if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
                            return true;
                        }
                        if (this.match(11)) {
                            this.next();
                            if (this.match(19)) {
                                return true;
                            }
                        }
                    }
                    return false;
                }
            },
            {
                key: "tsParseTypeOrTypePredicateAnnotation",
                value: function tsParseTypeOrTypePredicateAnnotation(returnToken) {
                    var _this = this;
                    return this.tsInType(function() {
                        var t = _this.startNode();
                        _this.expect(returnToken);
                        var node = _this.startNode();
                        var asserts = !!_this.tsTryParse(_this.tsParseTypePredicateAsserts.bind(_this));
                        if (asserts && _this.match(78)) {
                            var thisTypePredicate = _this.tsParseThisTypeOrThisTypePredicate();
                            if (thisTypePredicate.type === "TSThisType") {
                                node.parameterName = thisTypePredicate;
                                node.asserts = true;
                                node.typeAnnotation = null;
                                thisTypePredicate = _this.finishNode(node, "TSTypePredicate");
                            } else {
                                _this.resetStartLocationFromNode(thisTypePredicate, node);
                                thisTypePredicate.asserts = true;
                            }
                            t.typeAnnotation = thisTypePredicate;
                            return _this.finishNode(t, "TSTypeAnnotation");
                        }
                        var typePredicateVariable = _this.tsIsIdentifier() && _this.tsTryParse(_this.tsParseTypePredicatePrefix.bind(_this));
                        if (!typePredicateVariable) {
                            if (!asserts) {
                                return _this.tsParseTypeAnnotation(false, t);
                            }
                            node.parameterName = _this.parseIdentifier();
                            node.asserts = asserts;
                            node.typeAnnotation = null;
                            t.typeAnnotation = _this.finishNode(node, "TSTypePredicate");
                            return _this.finishNode(t, "TSTypeAnnotation");
                        }
                        var type = _this.tsParseTypeAnnotation(false);
                        node.parameterName = typePredicateVariable;
                        node.typeAnnotation = type;
                        node.asserts = asserts;
                        t.typeAnnotation = _this.finishNode(node, "TSTypePredicate");
                        return _this.finishNode(t, "TSTypeAnnotation");
                    });
                }
            },
            {
                key: "tsTryParseTypeOrTypePredicateAnnotation",
                value: function tsTryParseTypeOrTypePredicateAnnotation() {
                    if (this.match(14)) {
                        return this.tsParseTypeOrTypePredicateAnnotation(14);
                    }
                }
            },
            {
                key: "tsTryParseTypeAnnotation",
                value: function tsTryParseTypeAnnotation() {
                    if (this.match(14)) {
                        return this.tsParseTypeAnnotation();
                    }
                }
            },
            {
                key: "tsTryParseType",
                value: function tsTryParseType() {
                    return this.tsEatThenParseType(14);
                }
            },
            {
                key: "tsParseTypePredicatePrefix",
                value: function tsParseTypePredicatePrefix() {
                    var id = this.parseIdentifier();
                    if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
                        this.next();
                        return id;
                    }
                }
            },
            {
                key: "tsParseTypePredicateAsserts",
                value: function tsParseTypePredicateAsserts() {
                    if (this.state.type !== 109) {
                        return false;
                    }
                    var containsEsc = this.state.containsEsc;
                    this.next();
                    if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
                        return false;
                    }
                    if (containsEsc) {
                        this.raise(Errors.InvalidEscapedReservedWord, this.state.lastTokStartLoc, {
                            reservedWord: "asserts"
                        });
                    }
                    return true;
                }
            },
            {
                key: "tsParseTypeAnnotation",
                value: function tsParseTypeAnnotation() {
                    var _this = this;
                    var eatColon = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true, t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.startNode();
                    this.tsInType(function() {
                        if (eatColon) _this.expect(14);
                        t.typeAnnotation = _this.tsParseType();
                    });
                    return this.finishNode(t, "TSTypeAnnotation");
                }
            },
            {
                key: "tsParseType",
                value: function tsParseType() {
                    var _this = this;
                    assert2(this.state.inType);
                    var type = this.tsParseNonConditionalType();
                    if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81)) {
                        return type;
                    }
                    var node = this.startNodeAtNode(type);
                    node.checkType = type;
                    node.extendsType = this.tsInDisallowConditionalTypesContext(function() {
                        return _this.tsParseNonConditionalType();
                    });
                    this.expect(17);
                    node.trueType = this.tsInAllowConditionalTypesContext(function() {
                        return _this.tsParseType();
                    });
                    this.expect(14);
                    node.falseType = this.tsInAllowConditionalTypesContext(function() {
                        return _this.tsParseType();
                    });
                    return this.finishNode(node, "TSConditionalType");
                }
            },
            {
                key: "isAbstractConstructorSignature",
                value: function isAbstractConstructorSignature() {
                    return this.isContextual(124) && this.lookahead().type === 77;
                }
            },
            {
                key: "tsParseNonConditionalType",
                value: function tsParseNonConditionalType() {
                    if (this.tsIsStartOfFunctionType()) {
                        return this.tsParseFunctionOrConstructorType("TSFunctionType");
                    }
                    if (this.match(77)) {
                        return this.tsParseFunctionOrConstructorType("TSConstructorType");
                    } else if (this.isAbstractConstructorSignature()) {
                        return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
                    }
                    return this.tsParseUnionTypeOrHigher();
                }
            },
            {
                key: "tsParseTypeAssertion",
                value: function tsParseTypeAssertion() {
                    var _this = this;
                    if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
                        this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
                    }
                    var node = this.startNode();
                    node.typeAnnotation = this.tsInType(function() {
                        _this.next();
                        return _this.match(75) ? _this.tsParseTypeReference() : _this.tsParseType();
                    });
                    this.expect(48);
                    node.expression = this.parseMaybeUnary();
                    return this.finishNode(node, "TSTypeAssertion");
                }
            },
            {
                key: "tsParseHeritageClause",
                value: function tsParseHeritageClause(token) {
                    var _this = this;
                    var originalStartLoc = this.state.startLoc;
                    var delimitedList = this.tsParseDelimitedList("HeritageClauseElement", function() {
                        var node = _this.startNode();
                        node.expression = _this.tsParseEntityName();
                        if (_this.match(47)) {
                            node.typeParameters = _this.tsParseTypeArguments();
                        }
                        return _this.finishNode(node, "TSExpressionWithTypeArguments");
                    });
                    if (!delimitedList.length) {
                        this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
                            token: token
                        });
                    }
                    return delimitedList;
                }
            },
            {
                key: "tsParseInterfaceDeclaration",
                value: function tsParseInterfaceDeclaration(node) {
                    var properties = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                    if (this.hasFollowingLineBreak()) return null;
                    this.expectContextual(129);
                    if (properties.declare) node.declare = true;
                    if (tokenIsIdentifier(this.state.type)) {
                        node.id = this.parseIdentifier();
                        this.checkIdentifier(node.id, 130);
                    } else {
                        node.id = null;
                        this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
                    }
                    node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
                    if (this.eat(81)) {
                        node.extends = this.tsParseHeritageClause("extends");
                    }
                    var body = this.startNode();
                    body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
                    node.body = this.finishNode(body, "TSInterfaceBody");
                    return this.finishNode(node, "TSInterfaceDeclaration");
                }
            },
            {
                key: "tsParseTypeAliasDeclaration",
                value: function tsParseTypeAliasDeclaration(node) {
                    var _this = this;
                    node.id = this.parseIdentifier();
                    this.checkIdentifier(node.id, 2);
                    node.typeAnnotation = this.tsInType(function() {
                        node.typeParameters = _this.tsTryParseTypeParameters(_this.tsParseInOutModifiers);
                        _this.expect(29);
                        if (_this.isContextual(114) && _this.lookahead().type !== 16) {
                            var node2 = _this.startNode();
                            _this.next();
                            return _this.finishNode(node2, "TSIntrinsicKeyword");
                        }
                        return _this.tsParseType();
                    });
                    this.semicolon();
                    return this.finishNode(node, "TSTypeAliasDeclaration");
                }
            },
            {
                key: "tsInNoContext",
                value: function tsInNoContext(cb) {
                    var oldContext = this.state.context;
                    this.state.context = [
                        oldContext[0]
                    ];
                    try {
                        return cb();
                    } finally{
                        this.state.context = oldContext;
                    }
                }
            },
            {
                key: "tsInType",
                value: function tsInType(cb) {
                    var oldInType = this.state.inType;
                    this.state.inType = true;
                    try {
                        return cb();
                    } finally{
                        this.state.inType = oldInType;
                    }
                }
            },
            {
                key: "tsInDisallowConditionalTypesContext",
                value: function tsInDisallowConditionalTypesContext(cb) {
                    var oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
                    this.state.inDisallowConditionalTypesContext = true;
                    try {
                        return cb();
                    } finally{
                        this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
                    }
                }
            },
            {
                key: "tsInAllowConditionalTypesContext",
                value: function tsInAllowConditionalTypesContext(cb) {
                    var oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
                    this.state.inDisallowConditionalTypesContext = false;
                    try {
                        return cb();
                    } finally{
                        this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
                    }
                }
            },
            {
                key: "tsEatThenParseType",
                value: function tsEatThenParseType(token) {
                    if (this.match(token)) {
                        return this.tsNextThenParseType();
                    }
                }
            },
            {
                key: "tsExpectThenParseType",
                value: function tsExpectThenParseType(token) {
                    var _this = this;
                    return this.tsInType(function() {
                        _this.expect(token);
                        return _this.tsParseType();
                    });
                }
            },
            {
                key: "tsNextThenParseType",
                value: function tsNextThenParseType() {
                    var _this = this;
                    return this.tsInType(function() {
                        _this.next();
                        return _this.tsParseType();
                    });
                }
            },
            {
                key: "tsParseEnumMember",
                value: function tsParseEnumMember() {
                    var node = this.startNode();
                    node.id = this.match(133) ? _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseStringLiteral", this).call(this, this.state.value) : this.parseIdentifier(true);
                    if (this.eat(29)) {
                        node.initializer = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeAssignAllowIn", this).call(this);
                    }
                    return this.finishNode(node, "TSEnumMember");
                }
            },
            {
                key: "tsParseEnumDeclaration",
                value: function tsParseEnumDeclaration(node) {
                    var properties = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                    if (properties.const) node.const = true;
                    if (properties.declare) node.declare = true;
                    this.expectContextual(126);
                    node.id = this.parseIdentifier();
                    this.checkIdentifier(node.id, node.const ? 8971 : 8459);
                    this.expect(5);
                    node.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
                    this.expect(8);
                    return this.finishNode(node, "TSEnumDeclaration");
                }
            },
            {
                key: "tsParseModuleBlock",
                value: function tsParseModuleBlock() {
                    var node = this.startNode();
                    this.scope.enter(0);
                    this.expect(5);
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseBlockOrModuleBlockBody", this).call(this, node.body = [], void 0, true, 8);
                    this.scope.exit();
                    return this.finishNode(node, "TSModuleBlock");
                }
            },
            {
                key: "tsParseModuleOrNamespaceDeclaration",
                value: function tsParseModuleOrNamespaceDeclaration(node) {
                    var nested = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                    node.id = this.parseIdentifier();
                    if (!nested) {
                        this.checkIdentifier(node.id, 1024);
                    }
                    if (this.eat(16)) {
                        var inner = this.startNode();
                        this.tsParseModuleOrNamespaceDeclaration(inner, true);
                        node.body = inner;
                    } else {
                        this.scope.enter(256);
                        this.prodParam.enter(0);
                        node.body = this.tsParseModuleBlock();
                        this.prodParam.exit();
                        this.scope.exit();
                    }
                    return this.finishNode(node, "TSModuleDeclaration");
                }
            },
            {
                key: "tsParseAmbientExternalModuleDeclaration",
                value: function tsParseAmbientExternalModuleDeclaration(node) {
                    if (this.isContextual(112)) {
                        node.global = true;
                        node.id = this.parseIdentifier();
                    } else if (this.match(133)) {
                        node.id = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseStringLiteral", this).call(this, this.state.value);
                    } else {
                        this.unexpected();
                    }
                    if (this.match(5)) {
                        this.scope.enter(256);
                        this.prodParam.enter(0);
                        node.body = this.tsParseModuleBlock();
                        this.prodParam.exit();
                        this.scope.exit();
                    } else {
                        this.semicolon();
                    }
                    return this.finishNode(node, "TSModuleDeclaration");
                }
            },
            {
                key: "tsParseImportEqualsDeclaration",
                value: function tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
                    node.isExport = isExport || false;
                    node.id = maybeDefaultIdentifier || this.parseIdentifier();
                    this.checkIdentifier(node.id, 4096);
                    this.expect(29);
                    var moduleReference = this.tsParseModuleReference();
                    if (node.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
                        this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
                    }
                    node.moduleReference = moduleReference;
                    this.semicolon();
                    return this.finishNode(node, "TSImportEqualsDeclaration");
                }
            },
            {
                key: "tsIsExternalModuleReference",
                value: function tsIsExternalModuleReference() {
                    return this.isContextual(119) && this.lookaheadCharCode() === 40;
                }
            },
            {
                key: "tsParseModuleReference",
                value: function tsParseModuleReference() {
                    return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
                }
            },
            {
                key: "tsParseExternalModuleReference",
                value: function tsParseExternalModuleReference() {
                    var node = this.startNode();
                    this.expectContextual(119);
                    this.expect(10);
                    if (!this.match(133)) {
                        this.unexpected();
                    }
                    node.expression = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExprAtom", this).call(this);
                    this.expect(11);
                    this.sawUnambiguousESM = true;
                    return this.finishNode(node, "TSExternalModuleReference");
                }
            },
            {
                key: "tsLookAhead",
                value: function tsLookAhead(f) {
                    var state = this.state.clone();
                    var res = f();
                    this.state = state;
                    return res;
                }
            },
            {
                key: "tsTryParseAndCatch",
                value: function tsTryParseAndCatch(f) {
                    var result = this.tryParse(function(abort) {
                        return f() || abort();
                    });
                    if (result.aborted || !result.node) return;
                    if (result.error) this.state = result.failState;
                    return result.node;
                }
            },
            {
                key: "tsTryParse",
                value: function tsTryParse(f) {
                    var state = this.state.clone();
                    var result = f();
                    if (result !== void 0 && result !== false) {
                        return result;
                    }
                    this.state = state;
                }
            },
            {
                key: "tsTryParseDeclare",
                value: function tsTryParseDeclare(nany) {
                    var _this = this;
                    if (this.isLineTerminator()) {
                        return;
                    }
                    var startType = this.state.type;
                    var kind;
                    if (this.isContextual(100)) {
                        startType = 74;
                        kind = "let";
                    }
                    return this.tsInAmbientContext(function() {
                        switch(startType){
                            case 68:
                                nany.declare = true;
                                return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseFunctionStatement", _this).call(_this, nany, false, false);
                            case 80:
                                nany.declare = true;
                                return _this.parseClass(nany, true, false);
                            case 126:
                                return _this.tsParseEnumDeclaration(nany, {
                                    declare: true
                                });
                            case 112:
                                return _this.tsParseAmbientExternalModuleDeclaration(nany);
                            case 75:
                            case 74:
                                if (!_this.match(75) || !_this.isLookaheadContextual("enum")) {
                                    nany.declare = true;
                                    return _this.parseVarStatement(nany, kind || _this.state.value, true);
                                }
                                _this.expect(75);
                                return _this.tsParseEnumDeclaration(nany, {
                                    const: true,
                                    declare: true
                                });
                            case 129:
                                {
                                    var result = _this.tsParseInterfaceDeclaration(nany, {
                                        declare: true
                                    });
                                    if (result) return result;
                                }
                            default:
                                if (tokenIsIdentifier(startType)) {
                                    return _this.tsParseDeclaration(nany, _this.state.value, true, null);
                                }
                        }
                    });
                }
            },
            {
                key: "tsTryParseExportDeclaration",
                value: function tsTryParseExportDeclaration() {
                    return this.tsParseDeclaration(this.startNode(), this.state.value, true, null);
                }
            },
            {
                key: "tsParseExpressionStatement",
                value: function tsParseExpressionStatement(node, expr, decorators) {
                    switch(expr.name){
                        case "declare":
                            {
                                var declaration = this.tsTryParseDeclare(node);
                                if (declaration) {
                                    declaration.declare = true;
                                }
                                return declaration;
                            }
                        case "global":
                            if (this.match(5)) {
                                this.scope.enter(256);
                                this.prodParam.enter(0);
                                var mod = node;
                                mod.global = true;
                                mod.id = expr;
                                mod.body = this.tsParseModuleBlock();
                                this.scope.exit();
                                this.prodParam.exit();
                                return this.finishNode(mod, "TSModuleDeclaration");
                            }
                            break;
                        default:
                            return this.tsParseDeclaration(node, expr.name, false, decorators);
                    }
                }
            },
            {
                key: "tsParseDeclaration",
                value: function tsParseDeclaration(node, value1, next, decorators) {
                    switch(value1){
                        case "abstract":
                            if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
                                return this.tsParseAbstractDeclaration(node, decorators);
                            }
                            break;
                        case "module":
                            if (this.tsCheckLineTerminator(next)) {
                                if (this.match(133)) {
                                    return this.tsParseAmbientExternalModuleDeclaration(node);
                                } else if (tokenIsIdentifier(this.state.type)) {
                                    return this.tsParseModuleOrNamespaceDeclaration(node);
                                }
                            }
                            break;
                        case "namespace":
                            if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
                                return this.tsParseModuleOrNamespaceDeclaration(node);
                            }
                            break;
                        case "type":
                            if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
                                return this.tsParseTypeAliasDeclaration(node);
                            }
                            break;
                    }
                }
            },
            {
                key: "tsCheckLineTerminator",
                value: function tsCheckLineTerminator(next) {
                    if (next) {
                        if (this.hasFollowingLineBreak()) return false;
                        this.next();
                        return true;
                    }
                    return !this.isLineTerminator();
                }
            },
            {
                key: "tsTryParseGenericAsyncArrowFunction",
                value: function tsTryParseGenericAsyncArrowFunction(startLoc) {
                    var _this = this;
                    if (!this.match(47)) return;
                    var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
                    this.state.maybeInArrowParameters = true;
                    var res = this.tsTryParseAndCatch(function() {
                        var node = _this.startNodeAt(startLoc);
                        node.typeParameters = _this.tsParseTypeParameters(_this.tsParseConstModifier);
                        _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseFunctionParams", _this).call(_this, node);
                        node.returnType = _this.tsTryParseTypeOrTypePredicateAnnotation();
                        _this.expect(19);
                        return node;
                    });
                    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
                    if (!res) return;
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseArrowExpression", this).call(this, res, null, true);
                }
            },
            {
                key: "tsParseTypeArgumentsInExpression",
                value: function tsParseTypeArgumentsInExpression() {
                    if (this.reScan_lt() !== 47) return;
                    return this.tsParseTypeArguments();
                }
            },
            {
                key: "tsParseTypeArguments",
                value: function tsParseTypeArguments() {
                    var _this = this;
                    var node = this.startNode();
                    node.params = this.tsInType(function() {
                        return _this.tsInNoContext(function() {
                            _this.expect(47);
                            return _this.tsParseDelimitedList("TypeParametersOrArguments", _this.tsParseType.bind(_this));
                        });
                    });
                    if (node.params.length === 0) {
                        this.raise(TSErrors.EmptyTypeArguments, node);
                    } else if (!this.state.inType && this.curContext() === types.brace) {
                        this.reScan_lt_gt();
                    }
                    this.expect(48);
                    return this.finishNode(node, "TSTypeParameterInstantiation");
                }
            },
            {
                key: "tsIsDeclarationStart",
                value: function tsIsDeclarationStart() {
                    return tokenIsTSDeclarationStart(this.state.type);
                }
            },
            {
                key: "isExportDefaultSpecifier",
                value: function isExportDefaultSpecifier() {
                    if (this.tsIsDeclarationStart()) return false;
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isExportDefaultSpecifier", this).call(this);
                }
            },
            {
                key: "parseAssignableListItem",
                value: function parseAssignableListItem(flags, decorators) {
                    var startLoc = this.state.startLoc;
                    var modified = {};
                    this.tsParseModifiers({
                        allowedModifiers: [
                            "public",
                            "private",
                            "protected",
                            "override",
                            "readonly"
                        ]
                    }, modified);
                    var accessibility = modified.accessibility;
                    var override = modified.override;
                    var readonly = modified.readonly;
                    if (!(flags & 4) && (accessibility || readonly || override)) {
                        this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
                    }
                    var left = this.parseMaybeDefault();
                    this.parseAssignableListItemTypes(left, flags);
                    var elt = this.parseMaybeDefault(left.loc.start, left);
                    if (accessibility || readonly || override) {
                        var pp = this.startNodeAt(startLoc);
                        if (decorators.length) {
                            pp.decorators = decorators;
                        }
                        if (accessibility) pp.accessibility = accessibility;
                        if (readonly) pp.readonly = readonly;
                        if (override) pp.override = override;
                        if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
                            this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
                        }
                        pp.parameter = elt;
                        return this.finishNode(pp, "TSParameterProperty");
                    }
                    if (decorators.length) {
                        left.decorators = decorators;
                    }
                    return elt;
                }
            },
            {
                key: "isSimpleParameter",
                value: function isSimpleParameter(node) {
                    return node.type === "TSParameterProperty" && _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isSimpleParameter", this).call(this, node.parameter) || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isSimpleParameter", this).call(this, node);
                }
            },
            {
                key: "tsDisallowOptionalPattern",
                value: function tsDisallowOptionalPattern(node) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = node.params[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var param = _step.value;
                            if (param.type !== "Identifier" && param.optional && !this.state.isAmbientContext) {
                                this.raise(TSErrors.PatternIsOptional, param);
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                }
            },
            {
                key: "setArrowFunctionParameters",
                value: function setArrowFunctionParameters(node, params, trailingCommaLoc) {
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "setArrowFunctionParameters", this).call(this, node, params, trailingCommaLoc);
                    this.tsDisallowOptionalPattern(node);
                }
            },
            {
                key: "parseFunctionBodyAndFinish",
                value: function parseFunctionBodyAndFinish(node, type) {
                    var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                    if (this.match(14)) {
                        node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
                    }
                    var bodilessType = type === "FunctionDeclaration" ? "TSDeclareFunction" : type === "ClassMethod" || type === "ClassPrivateMethod" ? "TSDeclareMethod" : void 0;
                    if (bodilessType && !this.match(5) && this.isLineTerminator()) {
                        return this.finishNode(node, bodilessType);
                    }
                    if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
                        this.raise(TSErrors.DeclareFunctionHasImplementation, node);
                        if (node.declare) {
                            return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseFunctionBodyAndFinish", this).call(this, node, bodilessType, isMethod3);
                        }
                    }
                    this.tsDisallowOptionalPattern(node);
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseFunctionBodyAndFinish", this).call(this, node, type, isMethod3);
                }
            },
            {
                key: "registerFunctionStatementId",
                value: function registerFunctionStatementId(node) {
                    if (!node.body && node.id) {
                        this.checkIdentifier(node.id, 1024);
                    } else {
                        _get(_get_prototype_of(TypeScriptParserMixin.prototype), "registerFunctionStatementId", this).call(this, node);
                    }
                }
            },
            {
                key: "tsCheckForInvalidTypeCasts",
                value: function tsCheckForInvalidTypeCasts(items) {
                    var _this = this;
                    items.forEach(function(node) {
                        if ((node === null || node === void 0 ? void 0 : node.type) === "TSTypeCastExpression") {
                            _this.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
                        }
                    });
                }
            },
            {
                key: "toReferencedList",
                value: function toReferencedList(exprList, isInParens) {
                    this.tsCheckForInvalidTypeCasts(exprList);
                    return exprList;
                }
            },
            {
                key: "parseArrayLike",
                value: function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
                    var node = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseArrayLike", this).call(this, close, canBePattern, isTuple, refExpressionErrors);
                    if (node.type === "ArrayExpression") {
                        this.tsCheckForInvalidTypeCasts(node.elements);
                    }
                    return node;
                }
            },
            {
                key: "parseSubscript",
                value: function parseSubscript(base, startLoc, noCalls, state) {
                    var _this = this;
                    if (!this.hasPrecedingLineBreak() && this.match(35)) {
                        this.state.canStartJSXElement = false;
                        this.next();
                        var nonNullExpression = this.startNodeAt(startLoc);
                        nonNullExpression.expression = base;
                        return this.finishNode(nonNullExpression, "TSNonNullExpression");
                    }
                    var isOptionalCall = false;
                    if (this.match(18) && this.lookaheadCharCode() === 60) {
                        if (noCalls) {
                            state.stop = true;
                            return base;
                        }
                        state.optionalChainMember = isOptionalCall = true;
                        this.next();
                    }
                    if (this.match(47) || this.match(51)) {
                        var missingParenErrorLoc;
                        var result = this.tsTryParseAndCatch(function() {
                            if (!noCalls && _this.atPossibleAsyncArrow(base)) {
                                var asyncArrowFn = _this.tsTryParseGenericAsyncArrowFunction(startLoc);
                                if (asyncArrowFn) {
                                    return asyncArrowFn;
                                }
                            }
                            var typeArguments = _this.tsParseTypeArgumentsInExpression();
                            if (!typeArguments) return;
                            if (isOptionalCall && !_this.match(10)) {
                                missingParenErrorLoc = _this.state.curPosition();
                                return;
                            }
                            if (tokenIsTemplate(_this.state.type)) {
                                var result2 = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseTaggedTemplateExpression", _this).call(_this, base, startLoc, state);
                                result2.typeParameters = typeArguments;
                                return result2;
                            }
                            if (!noCalls && _this.eat(10)) {
                                var node2 = _this.startNodeAt(startLoc);
                                node2.callee = base;
                                node2.arguments = _this.parseCallExpressionArguments(11, false);
                                _this.tsCheckForInvalidTypeCasts(node2.arguments);
                                node2.typeParameters = typeArguments;
                                if (state.optionalChainMember) {
                                    node2.optional = isOptionalCall;
                                }
                                return _this.finishCallExpression(node2, state.optionalChainMember);
                            }
                            var tokenType = _this.state.type;
                            if (tokenType === 48 || tokenType === 52 || tokenType !== 10 && tokenCanStartExpression(tokenType) && !_this.hasPrecedingLineBreak()) {
                                return;
                            }
                            var node = _this.startNodeAt(startLoc);
                            node.expression = base;
                            node.typeParameters = typeArguments;
                            return _this.finishNode(node, "TSInstantiationExpression");
                        });
                        if (missingParenErrorLoc) {
                            this.unexpected(missingParenErrorLoc, 10);
                        }
                        if (result) {
                            if (result.type === "TSInstantiationExpression" && (this.match(16) || this.match(18) && this.lookaheadCharCode() !== 40)) {
                                this.raise(TSErrors.InvalidPropertyAccessAfterInstantiationExpression, this.state.startLoc);
                            }
                            return result;
                        }
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseSubscript", this).call(this, base, startLoc, noCalls, state);
                }
            },
            {
                key: "parseNewCallee",
                value: function parseNewCallee(node) {
                    var _callee_extra;
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseNewCallee", this).call(this, node);
                    var callee = node.callee;
                    if (callee.type === "TSInstantiationExpression" && !((_callee_extra = callee.extra) === null || _callee_extra === void 0 ? void 0 : _callee_extra.parenthesized)) {
                        node.typeParameters = callee.typeParameters;
                        node.callee = callee.expression;
                    }
                }
            },
            {
                key: "parseExprOp",
                value: function parseExprOp(left, leftStartLoc, minPrec) {
                    var _this = this;
                    var isSatisfies;
                    if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && (this.isContextual(93) || (isSatisfies = this.isContextual(120)))) {
                        var node = this.startNodeAt(leftStartLoc);
                        node.expression = left;
                        node.typeAnnotation = this.tsInType(function() {
                            _this.next();
                            if (_this.match(75)) {
                                if (isSatisfies) {
                                    _this.raise(Errors.UnexpectedKeyword, _this.state.startLoc, {
                                        keyword: "const"
                                    });
                                }
                                return _this.tsParseTypeReference();
                            }
                            return _this.tsParseType();
                        });
                        this.finishNode(node, isSatisfies ? "TSSatisfiesExpression" : "TSAsExpression");
                        this.reScan_lt_gt();
                        return this.parseExprOp(node, leftStartLoc, minPrec);
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExprOp", this).call(this, left, leftStartLoc, minPrec);
                }
            },
            {
                key: "checkReservedWord",
                value: function checkReservedWord(word, startLoc, checkKeywords, isBinding3) {
                    if (!this.state.isAmbientContext) {
                        _get(_get_prototype_of(TypeScriptParserMixin.prototype), "checkReservedWord", this).call(this, word, startLoc, checkKeywords, isBinding3);
                    }
                }
            },
            {
                key: "checkImportReflection",
                value: function checkImportReflection(node) {
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "checkImportReflection", this).call(this, node);
                    if (node.module && node.importKind !== "value") {
                        this.raise(TSErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
                    }
                }
            },
            {
                key: "checkDuplicateExports",
                value: function checkDuplicateExports() {}
            },
            {
                key: "isPotentialImportPhase",
                value: function isPotentialImportPhase(isExport) {
                    if (_get(_get_prototype_of(TypeScriptParserMixin.prototype), "isPotentialImportPhase", this).call(this, isExport)) return true;
                    if (this.isContextual(130)) {
                        var ch = this.lookaheadCharCode();
                        return isExport ? ch === 123 || ch === 42 : ch !== 61;
                    }
                    return !isExport && this.isContextual(87);
                }
            },
            {
                key: "applyImportPhase",
                value: function applyImportPhase(node, isExport, phase, loc) {
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "applyImportPhase", this).call(this, node, isExport, phase, loc);
                    if (isExport) {
                        node.exportKind = phase === "type" ? "type" : "value";
                    } else {
                        node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
                    }
                }
            },
            {
                key: "parseImport",
                value: function parseImport(node) {
                    if (this.match(133)) {
                        node.importKind = "value";
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseImport", this).call(this, node);
                    }
                    var importNode;
                    if (tokenIsIdentifier(this.state.type) && this.lookaheadCharCode() === 61) {
                        node.importKind = "value";
                        return this.tsParseImportEqualsDeclaration(node);
                    } else if (this.isContextual(130)) {
                        var maybeDefaultIdentifier = this.parseMaybeImportPhase(node, false);
                        if (this.lookaheadCharCode() === 61) {
                            return this.tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier);
                        } else {
                            importNode = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseImportSpecifiersAndAfter", this).call(this, node, maybeDefaultIdentifier);
                        }
                    } else {
                        importNode = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseImport", this).call(this, node);
                    }
                    if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
                        this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, importNode);
                    }
                    return importNode;
                }
            },
            {
                key: "parseExport",
                value: function parseExport(node, decorators) {
                    if (this.match(83)) {
                        this.next();
                        var maybeDefaultIdentifier = null;
                        if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
                            maybeDefaultIdentifier = this.parseMaybeImportPhase(node, false);
                        } else {
                            node.importKind = "value";
                        }
                        return this.tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, true);
                    } else if (this.eat(29)) {
                        var assign = node;
                        assign.expression = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExpression", this).call(this);
                        this.semicolon();
                        this.sawUnambiguousESM = true;
                        return this.finishNode(assign, "TSExportAssignment");
                    } else if (this.eatContextual(93)) {
                        var decl = node;
                        this.expectContextual(128);
                        decl.id = this.parseIdentifier();
                        this.semicolon();
                        return this.finishNode(decl, "TSNamespaceExportDeclaration");
                    } else {
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExport", this).call(this, node, decorators);
                    }
                }
            },
            {
                key: "isAbstractClass",
                value: function isAbstractClass() {
                    return this.isContextual(124) && this.lookahead().type === 80;
                }
            },
            {
                key: "parseExportDefaultExpression",
                value: function parseExportDefaultExpression() {
                    if (this.isAbstractClass()) {
                        var cls = this.startNode();
                        this.next();
                        cls.abstract = true;
                        return this.parseClass(cls, true, true);
                    }
                    if (this.match(129)) {
                        var result = this.tsParseInterfaceDeclaration(this.startNode());
                        if (result) return result;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExportDefaultExpression", this).call(this);
                }
            },
            {
                key: "parseVarStatement",
                value: function parseVarStatement(node, kind) {
                    var allowMissingInitializer = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                    var isAmbientContext = this.state.isAmbientContext;
                    var declaration = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseVarStatement", this).call(this, node, kind, allowMissingInitializer || isAmbientContext);
                    if (!isAmbientContext) return declaration;
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = declaration.declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var _step_value = _step.value, id = _step_value.id, init = _step_value.init;
                            if (!init) continue;
                            if (kind !== "const" || !!id.typeAnnotation) {
                                this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init);
                            } else if (!isValidAmbientConstInitializer(init, this.hasPlugin("estree"))) {
                                this.raise(TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, init);
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return declaration;
                }
            },
            {
                key: "parseStatementContent",
                value: function parseStatementContent(flags, decorators) {
                    if (this.match(75) && this.isLookaheadContextual("enum")) {
                        var node = this.startNode();
                        this.expect(75);
                        return this.tsParseEnumDeclaration(node, {
                            const: true
                        });
                    }
                    if (this.isContextual(126)) {
                        return this.tsParseEnumDeclaration(this.startNode());
                    }
                    if (this.isContextual(129)) {
                        var result = this.tsParseInterfaceDeclaration(this.startNode());
                        if (result) return result;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseStatementContent", this).call(this, flags, decorators);
                }
            },
            {
                key: "parseAccessModifier",
                value: function parseAccessModifier() {
                    return this.tsParseModifier([
                        "public",
                        "protected",
                        "private"
                    ]);
                }
            },
            {
                key: "tsHasSomeModifiers",
                value: function tsHasSomeModifiers(member, modifiers) {
                    return modifiers.some(function(modifier) {
                        if (tsIsAccessModifier(modifier)) {
                            return member.accessibility === modifier;
                        }
                        return !!member[modifier];
                    });
                }
            },
            {
                key: "tsIsStartOfStaticBlocks",
                value: function tsIsStartOfStaticBlocks() {
                    return this.isContextual(106) && this.lookaheadCharCode() === 123;
                }
            },
            {
                key: "parseClassMember",
                value: function parseClassMember(classBody2, member, state) {
                    var _this = this;
                    var modifiers = [
                        "declare",
                        "private",
                        "public",
                        "protected",
                        "override",
                        "abstract",
                        "readonly",
                        "static"
                    ];
                    this.tsParseModifiers({
                        allowedModifiers: modifiers,
                        disallowedModifiers: [
                            "in",
                            "out"
                        ],
                        stopOnStartOfClassStaticBlock: true,
                        errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
                    }, member);
                    var callParseClassMemberWithIsStatic = function() {
                        if (_this.tsIsStartOfStaticBlocks()) {
                            _this.next();
                            _this.next();
                            if (_this.tsHasSomeModifiers(member, modifiers)) {
                                _this.raise(TSErrors.StaticBlockCannotHaveModifier, _this.state.curPosition());
                            }
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassStaticBlock", _this).call(_this, classBody2, member);
                        } else {
                            _this.parseClassMemberWithIsStatic(classBody2, member, state, !!member.static);
                        }
                    };
                    if (member.declare) {
                        this.tsInAmbientContext(callParseClassMemberWithIsStatic);
                    } else {
                        callParseClassMemberWithIsStatic();
                    }
                }
            },
            {
                key: "parseClassMemberWithIsStatic",
                value: function parseClassMemberWithIsStatic(classBody2, member, state, isStatic2) {
                    var idx = this.tsTryParseIndexSignature(member);
                    if (idx) {
                        classBody2.body.push(idx);
                        if (member.abstract) {
                            this.raise(TSErrors.IndexSignatureHasAbstract, member);
                        }
                        if (member.accessibility) {
                            this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
                                modifier: member.accessibility
                            });
                        }
                        if (member.declare) {
                            this.raise(TSErrors.IndexSignatureHasDeclare, member);
                        }
                        if (member.override) {
                            this.raise(TSErrors.IndexSignatureHasOverride, member);
                        }
                        return;
                    }
                    if (!this.state.inAbstractClass && member.abstract) {
                        this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
                    }
                    if (member.override) {
                        if (!state.hadSuperClass) {
                            this.raise(TSErrors.OverrideNotInSubClass, member);
                        }
                    }
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassMemberWithIsStatic", this).call(this, classBody2, member, state, isStatic2);
                }
            },
            {
                key: "parsePostMemberNameModifiers",
                value: function parsePostMemberNameModifiers(methodOrProp) {
                    var optional = this.eat(17);
                    if (optional) methodOrProp.optional = true;
                    if (methodOrProp.readonly && this.match(10)) {
                        this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
                    }
                    if (methodOrProp.declare && this.match(10)) {
                        this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
                    }
                }
            },
            {
                key: "parseExpressionStatement",
                value: function parseExpressionStatement(node, expr, decorators) {
                    var decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node, expr, decorators) : void 0;
                    return decl || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExpressionStatement", this).call(this, node, expr, decorators);
                }
            },
            {
                key: "shouldParseExportDeclaration",
                value: function shouldParseExportDeclaration() {
                    if (this.tsIsDeclarationStart()) return true;
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "shouldParseExportDeclaration", this).call(this);
                }
            },
            {
                key: "parseConditional",
                value: function parseConditional(expr, startLoc, refExpressionErrors) {
                    var _this = this;
                    if (!this.state.maybeInArrowParameters || !this.match(17)) {
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseConditional", this).call(this, expr, startLoc, refExpressionErrors);
                    }
                    var result = this.tryParse(function() {
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseConditional", _this).call(_this, expr, startLoc);
                    });
                    if (!result.node) {
                        if (result.error) {
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "setOptionalParametersError", this).call(this, refExpressionErrors, result.error);
                        }
                        return expr;
                    }
                    if (result.error) this.state = result.failState;
                    return result.node;
                }
            },
            {
                key: "parseParenItem",
                value: function parseParenItem(node, startLoc) {
                    node = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseParenItem", this).call(this, node, startLoc);
                    if (this.eat(17)) {
                        node.optional = true;
                        this.resetEndLocation(node);
                    }
                    if (this.match(14)) {
                        var typeCastNode = this.startNodeAt(startLoc);
                        typeCastNode.expression = node;
                        typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
                        return this.finishNode(typeCastNode, "TSTypeCastExpression");
                    }
                    return node;
                }
            },
            {
                key: "parseExportDeclaration",
                value: function parseExportDeclaration(node) {
                    var _this = this;
                    if (!this.state.isAmbientContext && this.isContextual(125)) {
                        return this.tsInAmbientContext(function() {
                            return _this.parseExportDeclaration(node);
                        });
                    }
                    var startLoc = this.state.startLoc;
                    var isDeclare = this.eatContextual(125);
                    if (isDeclare && (this.isContextual(125) || !this.shouldParseExportDeclaration())) {
                        throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, this.state.startLoc);
                    }
                    var isIdentifier6 = tokenIsIdentifier(this.state.type);
                    var declaration = isIdentifier6 && this.tsTryParseExportDeclaration() || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExportDeclaration", this).call(this, node);
                    if (!declaration) return null;
                    if (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare) {
                        node.exportKind = "type";
                    }
                    if (isDeclare) {
                        this.resetStartLocation(declaration, startLoc);
                        declaration.declare = true;
                    }
                    return declaration;
                }
            },
            {
                key: "parseClassId",
                value: function parseClassId(node, isStatement5, optionalId, bindingType) {
                    if ((!isStatement5 || optionalId) && this.isContextual(113)) {
                        return;
                    }
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassId", this).call(this, node, isStatement5, optionalId, node.declare ? 1024 : 8331);
                    var typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
                    if (typeParameters) node.typeParameters = typeParameters;
                }
            },
            {
                key: "parseClassPropertyAnnotation",
                value: function parseClassPropertyAnnotation(node) {
                    if (!node.optional) {
                        if (this.eat(35)) {
                            node.definite = true;
                        } else if (this.eat(17)) {
                            node.optional = true;
                        }
                    }
                    var type = this.tsTryParseTypeAnnotation();
                    if (type) node.typeAnnotation = type;
                }
            },
            {
                key: "parseClassProperty",
                value: function parseClassProperty(node) {
                    this.parseClassPropertyAnnotation(node);
                    if (this.state.isAmbientContext && !(node.readonly && !node.typeAnnotation) && this.match(29)) {
                        this.raise(TSErrors.DeclareClassFieldHasInitializer, this.state.startLoc);
                    }
                    if (node.abstract && this.match(29)) {
                        var key = node.key;
                        this.raise(TSErrors.AbstractPropertyHasInitializer, this.state.startLoc, {
                            propertyName: key.type === "Identifier" && !node.computed ? key.name : "[".concat(this.input.slice(key.start, key.end), "]")
                        });
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassProperty", this).call(this, node);
                }
            },
            {
                key: "parseClassPrivateProperty",
                value: function parseClassPrivateProperty(node) {
                    if (node.abstract) {
                        this.raise(TSErrors.PrivateElementHasAbstract, node);
                    }
                    if (node.accessibility) {
                        this.raise(TSErrors.PrivateElementHasAccessibility, node, {
                            modifier: node.accessibility
                        });
                    }
                    this.parseClassPropertyAnnotation(node);
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassPrivateProperty", this).call(this, node);
                }
            },
            {
                key: "parseClassAccessorProperty",
                value: function parseClassAccessorProperty(node) {
                    this.parseClassPropertyAnnotation(node);
                    if (node.optional) {
                        this.raise(TSErrors.AccessorCannotBeOptional, node);
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassAccessorProperty", this).call(this, node);
                }
            },
            {
                key: "pushClassMethod",
                value: function pushClassMethod(classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
                    var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
                    if (typeParameters && isConstructor) {
                        this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
                    }
                    var _method_declare = method.declare, declare = _method_declare === void 0 ? false : _method_declare, kind = method.kind;
                    if (declare && (kind === "get" || kind === "set")) {
                        this.raise(TSErrors.DeclareAccessor, method, {
                            kind: kind
                        });
                    }
                    if (typeParameters) method.typeParameters = typeParameters;
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "pushClassMethod", this).call(this, classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
                }
            },
            {
                key: "pushClassPrivateMethod",
                value: function pushClassPrivateMethod(classBody2, method, isGenerator, isAsync) {
                    var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
                    if (typeParameters) method.typeParameters = typeParameters;
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "pushClassPrivateMethod", this).call(this, classBody2, method, isGenerator, isAsync);
                }
            },
            {
                key: "declareClassPrivateMethodInScope",
                value: function declareClassPrivateMethodInScope(node, kind) {
                    if (node.type === "TSDeclareMethod") return;
                    if (node.type === "MethodDefinition" && !node.value.body) return;
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "declareClassPrivateMethodInScope", this).call(this, node, kind);
                }
            },
            {
                key: "parseClassSuper",
                value: function parseClassSuper(node) {
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClassSuper", this).call(this, node);
                    if (node.superClass && (this.match(47) || this.match(51))) {
                        node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
                    }
                    if (this.eatContextual(113)) {
                        node.implements = this.tsParseHeritageClause("implements");
                    }
                }
            },
            {
                key: "parseObjPropValue",
                value: function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern2, isAccessor2, refExpressionErrors) {
                    var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
                    if (typeParameters) prop.typeParameters = typeParameters;
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseObjPropValue", this).call(this, prop, startLoc, isGenerator, isAsync, isPattern2, isAccessor2, refExpressionErrors);
                }
            },
            {
                key: "parseFunctionParams",
                value: function parseFunctionParams(node, isConstructor) {
                    var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
                    if (typeParameters) node.typeParameters = typeParameters;
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseFunctionParams", this).call(this, node, isConstructor);
                }
            },
            {
                key: "parseVarId",
                value: function parseVarId(decl, kind) {
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseVarId", this).call(this, decl, kind);
                    if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
                        decl.definite = true;
                    }
                    var type = this.tsTryParseTypeAnnotation();
                    if (type) {
                        decl.id.typeAnnotation = type;
                        this.resetEndLocation(decl.id);
                    }
                }
            },
            {
                key: "parseAsyncArrowFromCallExpression",
                value: function parseAsyncArrowFromCallExpression(node, call2) {
                    if (this.match(14)) {
                        node.returnType = this.tsParseTypeAnnotation();
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseAsyncArrowFromCallExpression", this).call(this, node, call2);
                }
            },
            {
                key: "parseMaybeAssign",
                value: function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
                    var _this = this;
                    var state;
                    var jsx2;
                    var typeCast;
                    if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
                        state = this.state.clone();
                        jsx2 = this.tryParse(function() {
                            return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeAssign", _this).call(_this, refExpressionErrors, afterLeftParse);
                        }, state);
                        if (!jsx2.error) return jsx2.node;
                        var context = this.state.context;
                        var currentContext = context[context.length - 1];
                        if (currentContext === types.j_oTag || currentContext === types.j_expr) {
                            context.pop();
                        }
                    }
                    if (!(jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.error) && !this.match(47)) {
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeAssign", this).call(this, refExpressionErrors, afterLeftParse);
                    }
                    if (!state || state === this.state) state = this.state.clone();
                    var typeParameters;
                    var arrow = this.tryParse(function(abort) {
                        var _expr_extra;
                        typeParameters = _this.tsParseTypeParameters(_this.tsParseConstModifier);
                        var expr = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeAssign", _this).call(_this, refExpressionErrors, afterLeftParse);
                        if (expr.type !== "ArrowFunctionExpression" || ((_expr_extra = expr.extra) === null || _expr_extra === void 0 ? void 0 : _expr_extra.parenthesized)) {
                            abort();
                        }
                        if ((typeParameters === null || typeParameters === void 0 ? void 0 : typeParameters.params.length) !== 0) {
                            _this.resetStartLocationFromNode(expr, typeParameters);
                        }
                        expr.typeParameters = typeParameters;
                        {
                            var _expr_typeParameters_extra;
                            if (_this.hasPlugin("jsx") && expr.typeParameters.params.length === 1 && !((_expr_typeParameters_extra = expr.typeParameters.extra) === null || _expr_typeParameters_extra === void 0 ? void 0 : _expr_typeParameters_extra.trailingComma)) {
                                var parameter = expr.typeParameters.params[0];
                                if (!parameter.constraint) {
                                    _this.raise(TSErrors.SingleTypeParameterWithoutTrailingComma, createPositionWithColumnOffset(parameter.loc.end, 1), {
                                        typeParameterName: parameter.name.name
                                    });
                                }
                            }
                        }
                        return expr;
                    }, state);
                    if (!arrow.error && !arrow.aborted) {
                        if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
                        return arrow.node;
                    }
                    if (!jsx2) {
                        assert2(!this.hasPlugin("jsx"));
                        typeCast = this.tryParse(function() {
                            return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeAssign", _this).call(_this, refExpressionErrors, afterLeftParse);
                        }, state);
                        if (!typeCast.error) return typeCast.node;
                    }
                    if (jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.node) {
                        this.state = jsx2.failState;
                        return jsx2.node;
                    }
                    if (arrow.node) {
                        this.state = arrow.failState;
                        if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
                        return arrow.node;
                    }
                    if (typeCast === null || typeCast === void 0 ? void 0 : typeCast.node) {
                        this.state = typeCast.failState;
                        return typeCast.node;
                    }
                    throw (jsx2 === null || jsx2 === void 0 ? void 0 : jsx2.error) || arrow.error || (typeCast === null || typeCast === void 0 ? void 0 : typeCast.error);
                }
            },
            {
                key: "reportReservedArrowTypeParam",
                value: function reportReservedArrowTypeParam(node) {
                    var _node_extra;
                    if (node.params.length === 1 && !node.params[0].constraint && !((_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
                        this.raise(TSErrors.ReservedArrowTypeParam, node);
                    }
                }
            },
            {
                key: "parseMaybeUnary",
                value: function parseMaybeUnary(refExpressionErrors, sawUnary) {
                    if (!this.hasPlugin("jsx") && this.match(47)) {
                        return this.tsParseTypeAssertion();
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeUnary", this).call(this, refExpressionErrors, sawUnary);
                }
            },
            {
                key: "parseArrow",
                value: function parseArrow(node) {
                    var _this = this;
                    if (this.match(14)) {
                        var result = this.tryParse(function(abort) {
                            var returnType = _this.tsParseTypeOrTypePredicateAnnotation(14);
                            if (_this.canInsertSemicolon() || !_this.match(19)) abort();
                            return returnType;
                        });
                        if (result.aborted) return;
                        if (!result.thrown) {
                            if (result.error) this.state = result.failState;
                            node.returnType = result.node;
                        }
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseArrow", this).call(this, node);
                }
            },
            {
                key: "parseAssignableListItemTypes",
                value: function parseAssignableListItemTypes(param, flags) {
                    if (!(flags & 2)) return param;
                    if (this.eat(17)) {
                        param.optional = true;
                    }
                    var type = this.tsTryParseTypeAnnotation();
                    if (type) param.typeAnnotation = type;
                    this.resetEndLocation(param);
                    return param;
                }
            },
            {
                key: "isAssignable",
                value: function isAssignable(node, isBinding3) {
                    switch(node.type){
                        case "TSTypeCastExpression":
                            return this.isAssignable(node.expression, isBinding3);
                        case "TSParameterProperty":
                            return true;
                        default:
                            return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isAssignable", this).call(this, node, isBinding3);
                    }
                }
            },
            {
                key: "toAssignable",
                value: function toAssignable(node) {
                    var isLHS = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                    switch(node.type){
                        case "ParenthesizedExpression":
                            this.toAssignableParenthesizedExpression(node, isLHS);
                            break;
                        case "TSAsExpression":
                        case "TSSatisfiesExpression":
                        case "TSNonNullExpression":
                        case "TSTypeAssertion":
                            if (isLHS) {
                                this.expressionScope.recordArrowParameterBindingError(TSErrors.UnexpectedTypeCastInParameter, node);
                            } else {
                                this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
                            }
                            this.toAssignable(node.expression, isLHS);
                            break;
                        case "AssignmentExpression":
                            if (!isLHS && node.left.type === "TSTypeCastExpression") {
                                node.left = this.typeCastToParameter(node.left);
                            }
                        default:
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "toAssignable", this).call(this, node, isLHS);
                    }
                }
            },
            {
                key: "toAssignableParenthesizedExpression",
                value: function toAssignableParenthesizedExpression(node, isLHS) {
                    switch(node.expression.type){
                        case "TSAsExpression":
                        case "TSSatisfiesExpression":
                        case "TSNonNullExpression":
                        case "TSTypeAssertion":
                        case "ParenthesizedExpression":
                            this.toAssignable(node.expression, isLHS);
                            break;
                        default:
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "toAssignable", this).call(this, node, isLHS);
                    }
                }
            },
            {
                key: "checkToRestConversion",
                value: function checkToRestConversion(node, allowPattern) {
                    switch(node.type){
                        case "TSAsExpression":
                        case "TSSatisfiesExpression":
                        case "TSTypeAssertion":
                        case "TSNonNullExpression":
                            this.checkToRestConversion(node.expression, false);
                            break;
                        default:
                            _get(_get_prototype_of(TypeScriptParserMixin.prototype), "checkToRestConversion", this).call(this, node, allowPattern);
                    }
                }
            },
            {
                key: "isValidLVal",
                value: function isValidLVal(type, isUnparenthesizedInAssign, binding) {
                    return getOwn({
                        TSTypeCastExpression: true,
                        TSParameterProperty: "parameter",
                        TSNonNullExpression: "expression",
                        TSAsExpression: (binding !== 64 || !isUnparenthesizedInAssign) && [
                            "expression",
                            true
                        ],
                        TSSatisfiesExpression: (binding !== 64 || !isUnparenthesizedInAssign) && [
                            "expression",
                            true
                        ],
                        TSTypeAssertion: (binding !== 64 || !isUnparenthesizedInAssign) && [
                            "expression",
                            true
                        ]
                    }, type) || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isValidLVal", this).call(this, type, isUnparenthesizedInAssign, binding);
                }
            },
            {
                key: "parseBindingAtom",
                value: function parseBindingAtom() {
                    if (this.state.type === 78) {
                        return this.parseIdentifier(true);
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseBindingAtom", this).call(this);
                }
            },
            {
                key: "parseMaybeDecoratorArguments",
                value: function parseMaybeDecoratorArguments(expr) {
                    if (this.match(47) || this.match(51)) {
                        var typeArguments = this.tsParseTypeArgumentsInExpression();
                        if (this.match(10)) {
                            var call2 = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeDecoratorArguments", this).call(this, expr);
                            call2.typeParameters = typeArguments;
                            return call2;
                        }
                        this.unexpected(null, 10);
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeDecoratorArguments", this).call(this, expr);
                }
            },
            {
                key: "checkCommaAfterRest",
                value: function checkCommaAfterRest(close) {
                    if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
                        this.next();
                        return false;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "checkCommaAfterRest", this).call(this, close);
                }
            },
            {
                key: "isClassMethod",
                value: function isClassMethod() {
                    return this.match(47) || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isClassMethod", this).call(this);
                }
            },
            {
                key: "isClassProperty",
                value: function isClassProperty() {
                    return this.match(35) || this.match(14) || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "isClassProperty", this).call(this);
                }
            },
            {
                key: "parseMaybeDefault",
                value: function parseMaybeDefault(startLoc, left) {
                    var node = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMaybeDefault", this).call(this, startLoc, left);
                    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
                        this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
                    }
                    return node;
                }
            },
            {
                key: "getTokenFromCode",
                value: function getTokenFromCode(code2) {
                    if (this.state.inType) {
                        if (code2 === 62) {
                            this.finishOp(48, 1);
                            return;
                        }
                        if (code2 === 60) {
                            this.finishOp(47, 1);
                            return;
                        }
                    }
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "getTokenFromCode", this).call(this, code2);
                }
            },
            {
                key: "reScan_lt_gt",
                value: function reScan_lt_gt() {
                    var type = this.state.type;
                    if (type === 47) {
                        this.state.pos -= 1;
                        this.readToken_lt();
                    } else if (type === 48) {
                        this.state.pos -= 1;
                        this.readToken_gt();
                    }
                }
            },
            {
                key: "reScan_lt",
                value: function reScan_lt() {
                    var type = this.state.type;
                    if (type === 51) {
                        this.state.pos -= 2;
                        this.finishOp(47, 1);
                        return 47;
                    }
                    return type;
                }
            },
            {
                key: "toAssignableList",
                value: function toAssignableList(exprList, trailingCommaLoc, isLHS) {
                    for(var i = 0; i < exprList.length; i++){
                        var expr = exprList[i];
                        if ((expr === null || expr === void 0 ? void 0 : expr.type) === "TSTypeCastExpression") {
                            exprList[i] = this.typeCastToParameter(expr);
                        }
                    }
                    _get(_get_prototype_of(TypeScriptParserMixin.prototype), "toAssignableList", this).call(this, exprList, trailingCommaLoc, isLHS);
                }
            },
            {
                key: "typeCastToParameter",
                value: function typeCastToParameter(node) {
                    node.expression.typeAnnotation = node.typeAnnotation;
                    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
                    return node.expression;
                }
            },
            {
                key: "shouldParseArrow",
                value: function shouldParseArrow(params) {
                    var _this = this;
                    if (this.match(14)) {
                        return params.every(function(expr) {
                            return _this.isAssignable(expr, true);
                        });
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "shouldParseArrow", this).call(this, params);
                }
            },
            {
                key: "shouldParseAsyncArrow",
                value: function shouldParseAsyncArrow() {
                    return this.match(14) || _get(_get_prototype_of(TypeScriptParserMixin.prototype), "shouldParseAsyncArrow", this).call(this);
                }
            },
            {
                key: "canHaveLeadingDecorator",
                value: function canHaveLeadingDecorator() {
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "canHaveLeadingDecorator", this).call(this) || this.isAbstractClass();
                }
            },
            {
                key: "jsxParseOpeningElementAfterName",
                value: function jsxParseOpeningElementAfterName(node) {
                    var _this = this;
                    if (this.match(47) || this.match(51)) {
                        var typeArguments = this.tsTryParseAndCatch(function() {
                            return _this.tsParseTypeArgumentsInExpression();
                        });
                        if (typeArguments) node.typeParameters = typeArguments;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "jsxParseOpeningElementAfterName", this).call(this, node);
                }
            },
            {
                key: "getGetterSetterExpectedParamCount",
                value: function getGetterSetterExpectedParamCount(method) {
                    var baseCount = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "getGetterSetterExpectedParamCount", this).call(this, method);
                    var params = this.getObjectOrClassMethodParams(method);
                    var firstParam = params[0];
                    var hasContextParam = firstParam && this.isThisParam(firstParam);
                    return hasContextParam ? baseCount + 1 : baseCount;
                }
            },
            {
                key: "parseCatchClauseParam",
                value: function parseCatchClauseParam() {
                    var param = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseCatchClauseParam", this).call(this);
                    var type = this.tsTryParseTypeAnnotation();
                    if (type) {
                        param.typeAnnotation = type;
                        this.resetEndLocation(param);
                    }
                    return param;
                }
            },
            {
                key: "tsInAmbientContext",
                value: function tsInAmbientContext(cb) {
                    var oldIsAmbientContext = this.state.isAmbientContext;
                    this.state.isAmbientContext = true;
                    try {
                        return cb();
                    } finally{
                        this.state.isAmbientContext = oldIsAmbientContext;
                    }
                }
            },
            {
                key: "parseClass",
                value: function parseClass(node, isStatement5, optionalId) {
                    var oldInAbstractClass = this.state.inAbstractClass;
                    this.state.inAbstractClass = !!node.abstract;
                    try {
                        return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseClass", this).call(this, node, isStatement5, optionalId);
                    } finally{
                        this.state.inAbstractClass = oldInAbstractClass;
                    }
                }
            },
            {
                key: "tsParseAbstractDeclaration",
                value: function tsParseAbstractDeclaration(node, decorators) {
                    if (this.match(80)) {
                        node.abstract = true;
                        return this.maybeTakeDecorators(decorators, this.parseClass(node, true, false));
                    } else if (this.isContextual(129)) {
                        if (!this.hasFollowingLineBreak()) {
                            node.abstract = true;
                            this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
                            return this.tsParseInterfaceDeclaration(node);
                        }
                    } else {
                        this.unexpected(null, 80);
                    }
                }
            },
            {
                key: "parseMethod",
                value: function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
                    var method = _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseMethod", this).call(this, node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
                    if (method.abstract) {
                        var hasBody = this.hasPlugin("estree") ? !!method.value.body : !!method.body;
                        if (hasBody) {
                            var key = method.key;
                            this.raise(TSErrors.AbstractMethodHasImplementation, method, {
                                methodName: key.type === "Identifier" && !method.computed ? key.name : "[".concat(this.input.slice(key.start, key.end), "]")
                            });
                        }
                    }
                    return method;
                }
            },
            {
                key: "tsParseTypeParameterName",
                value: function tsParseTypeParameterName() {
                    var typeName = this.parseIdentifier();
                    return typeName;
                }
            },
            {
                key: "shouldParseAsAmbientContext",
                value: function shouldParseAsAmbientContext() {
                    return !!this.getPluginOption("typescript", "dts");
                }
            },
            {
                key: "parse",
                value: function parse() {
                    if (this.shouldParseAsAmbientContext()) {
                        this.state.isAmbientContext = true;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parse", this).call(this);
                }
            },
            {
                key: "getExpression",
                value: function getExpression() {
                    if (this.shouldParseAsAmbientContext()) {
                        this.state.isAmbientContext = true;
                    }
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "getExpression", this).call(this);
                }
            },
            {
                key: "parseExportSpecifier",
                value: function parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
                    if (!isString && isMaybeTypeOnly) {
                        this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
                        return this.finishNode(node, "ExportSpecifier");
                    }
                    node.exportKind = "value";
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseExportSpecifier", this).call(this, node, isString, isInTypeExport, isMaybeTypeOnly);
                }
            },
            {
                key: "parseImportSpecifier",
                value: function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
                    if (!importedIsString && isMaybeTypeOnly) {
                        this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
                        return this.finishNode(specifier, "ImportSpecifier");
                    }
                    specifier.importKind = "value";
                    return _get(_get_prototype_of(TypeScriptParserMixin.prototype), "parseImportSpecifier", this).call(this, specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, isInTypeOnlyImport ? 4098 : 4096);
                }
            },
            {
                key: "parseTypeOnlyImportExportSpecifier",
                value: function parseTypeOnlyImportExportSpecifier(node, isImport2, isInTypeOnlyImportExport) {
                    var leftOfAsKey = isImport2 ? "imported" : "local";
                    var rightOfAsKey = isImport2 ? "local" : "exported";
                    var leftOfAs = node[leftOfAsKey];
                    var rightOfAs;
                    var hasTypeSpecifier = false;
                    var canParseAsKeyword = true;
                    var loc = leftOfAs.loc.start;
                    if (this.isContextual(93)) {
                        var firstAs = this.parseIdentifier();
                        if (this.isContextual(93)) {
                            var secondAs = this.parseIdentifier();
                            if (tokenIsKeywordOrIdentifier(this.state.type)) {
                                hasTypeSpecifier = true;
                                leftOfAs = firstAs;
                                rightOfAs = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
                                canParseAsKeyword = false;
                            } else {
                                rightOfAs = secondAs;
                                canParseAsKeyword = false;
                            }
                        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
                            canParseAsKeyword = false;
                            rightOfAs = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
                        } else {
                            hasTypeSpecifier = true;
                            leftOfAs = firstAs;
                        }
                    } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
                        hasTypeSpecifier = true;
                        if (isImport2) {
                            leftOfAs = this.parseIdentifier(true);
                            if (!this.isContextual(93)) {
                                this.checkReservedWord(leftOfAs.name, leftOfAs.loc.start, true, true);
                            }
                        } else {
                            leftOfAs = this.parseModuleExportName();
                        }
                    }
                    if (hasTypeSpecifier && isInTypeOnlyImportExport) {
                        this.raise(isImport2 ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, loc);
                    }
                    node[leftOfAsKey] = leftOfAs;
                    node[rightOfAsKey] = rightOfAs;
                    var kindKey = isImport2 ? "importKind" : "exportKind";
                    node[kindKey] = hasTypeSpecifier ? "type" : "value";
                    if (canParseAsKeyword && this.eatContextual(93)) {
                        node[rightOfAsKey] = isImport2 ? this.parseIdentifier() : this.parseModuleExportName();
                    }
                    if (!node[rightOfAsKey]) {
                        node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
                    }
                    if (isImport2) {
                        this.checkIdentifier(node[rightOfAsKey], hasTypeSpecifier ? 4098 : 4096);
                    }
                }
            }
        ]);
        return TypeScriptParserMixin;
    }(superClass);
    return TypeScriptParserMixin;
};
function isPossiblyLiteralEnum(expression2) {
    if (expression2.type !== "MemberExpression") return false;
    var computed = expression2.computed, property = expression2.property;
    if (computed && property.type !== "StringLiteral" && (property.type !== "TemplateLiteral" || property.expressions.length > 0)) {
        return false;
    }
    return isUncomputedMemberExpressionChain(expression2.object);
}
function isValidAmbientConstInitializer(expression2, estree2) {
    var _expression2_extra;
    var type = expression2.type;
    if ((_expression2_extra = expression2.extra) === null || _expression2_extra === void 0 ? void 0 : _expression2_extra.parenthesized) {
        return false;
    }
    if (estree2) {
        if (type === "Literal") {
            var value1 = expression2.value;
            if (typeof value1 === "string" || typeof value1 === "boolean") {
                return true;
            }
        }
    } else {
        if (type === "StringLiteral" || type === "BooleanLiteral") {
            return true;
        }
    }
    if (isNumber(expression2, estree2) || isNegativeNumber(expression2, estree2)) {
        return true;
    }
    if (type === "TemplateLiteral" && expression2.expressions.length === 0) {
        return true;
    }
    if (isPossiblyLiteralEnum(expression2)) {
        return true;
    }
    return false;
}
function isNumber(expression2, estree2) {
    if (estree2) {
        return expression2.type === "Literal" && (typeof expression2.value === "number" || "bigint" in expression2);
    }
    return expression2.type === "NumericLiteral" || expression2.type === "BigIntLiteral";
}
function isNegativeNumber(expression2, estree2) {
    if (expression2.type === "UnaryExpression") {
        var operator = expression2.operator, argument = expression2.argument;
        if (operator === "-" && isNumber(argument, estree2)) {
            return true;
        }
    }
    return false;
}
function isUncomputedMemberExpressionChain(expression2) {
    if (expression2.type === "Identifier") return true;
    if (expression2.type !== "MemberExpression" || expression2.computed) {
        return false;
    }
    return isUncomputedMemberExpressionChain(expression2.object);
}
var PlaceholderErrors = ParseErrorEnum(_templateObject4())({
    ClassNameIsRequired: "A class name is required.",
    UnexpectedSpace: "Unexpected space in placeholder."
});
var placeholders = function(superClass) {
    var PlaceholdersParserMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(PlaceholdersParserMixin, superClass);
        var _super = _create_super(PlaceholdersParserMixin);
        function PlaceholdersParserMixin() {
            _class_call_check(this, PlaceholdersParserMixin);
            return _super.apply(this, arguments);
        }
        _create_class(PlaceholdersParserMixin, [
            {
                key: "parsePlaceholder",
                value: function parsePlaceholder(expectedNode) {
                    if (this.match(144)) {
                        var node = this.startNode();
                        this.next();
                        this.assertNoSpace();
                        node.name = _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseIdentifier", this).call(this, true);
                        this.assertNoSpace();
                        this.expect(144);
                        return this.finishPlaceholder(node, expectedNode);
                    }
                }
            },
            {
                key: "finishPlaceholder",
                value: function finishPlaceholder(node, expectedNode) {
                    var isFinished = !!(node.expectedNode && node.type === "Placeholder");
                    node.expectedNode = expectedNode;
                    return isFinished ? node : this.finishNode(node, "Placeholder");
                }
            },
            {
                key: "getTokenFromCode",
                value: function getTokenFromCode(code2) {
                    if (code2 === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
                        this.finishOp(144, 2);
                    } else {
                        _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "getTokenFromCode", this).call(this, code2);
                    }
                }
            },
            {
                key: "parseExprAtom",
                value: function parseExprAtom(refExpressionErrors) {
                    return this.parsePlaceholder("Expression") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseExprAtom", this).call(this, refExpressionErrors);
                }
            },
            {
                key: "parseIdentifier",
                value: function parseIdentifier(liberal) {
                    return this.parsePlaceholder("Identifier") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseIdentifier", this).call(this, liberal);
                }
            },
            {
                key: "checkReservedWord",
                value: function checkReservedWord(word, startLoc, checkKeywords, isBinding3) {
                    if (word !== void 0) {
                        _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "checkReservedWord", this).call(this, word, startLoc, checkKeywords, isBinding3);
                    }
                }
            },
            {
                key: "parseBindingAtom",
                value: function parseBindingAtom() {
                    return this.parsePlaceholder("Pattern") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseBindingAtom", this).call(this);
                }
            },
            {
                key: "isValidLVal",
                value: function isValidLVal(type, isParenthesized, binding) {
                    return type === "Placeholder" || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "isValidLVal", this).call(this, type, isParenthesized, binding);
                }
            },
            {
                key: "toAssignable",
                value: function toAssignable(node, isLHS) {
                    if (node && node.type === "Placeholder" && node.expectedNode === "Expression") {
                        node.expectedNode = "Pattern";
                    } else {
                        _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "toAssignable", this).call(this, node, isLHS);
                    }
                }
            },
            {
                key: "chStartsBindingIdentifier",
                value: function chStartsBindingIdentifier(ch, pos) {
                    if (_get(_get_prototype_of(PlaceholdersParserMixin.prototype), "chStartsBindingIdentifier", this).call(this, ch, pos)) {
                        return true;
                    }
                    var nextToken = this.lookahead();
                    if (nextToken.type === 144) {
                        return true;
                    }
                    return false;
                }
            },
            {
                key: "verifyBreakContinue",
                value: function verifyBreakContinue(node, isBreak) {
                    if (node.label && node.label.type === "Placeholder") return;
                    _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "verifyBreakContinue", this).call(this, node, isBreak);
                }
            },
            {
                key: "parseExpressionStatement",
                value: function parseExpressionStatement(node, expr) {
                    var _expr_extra;
                    if (expr.type !== "Placeholder" || ((_expr_extra = expr.extra) === null || _expr_extra === void 0 ? void 0 : _expr_extra.parenthesized)) {
                        return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseExpressionStatement", this).call(this, node, expr);
                    }
                    if (this.match(14)) {
                        var stmt = node;
                        stmt.label = this.finishPlaceholder(expr, "Identifier");
                        this.next();
                        stmt.body = _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseStatementOrSloppyAnnexBFunctionDeclaration", this).call(this);
                        return this.finishNode(stmt, "LabeledStatement");
                    }
                    this.semicolon();
                    node.name = expr.name;
                    return this.finishPlaceholder(node, "Statement");
                }
            },
            {
                key: "parseBlock",
                value: function parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
                    return this.parsePlaceholder("BlockStatement") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseBlock", this).call(this, allowDirectives, createNewLexicalScope, afterBlockParse);
                }
            },
            {
                key: "parseFunctionId",
                value: function parseFunctionId(requireId) {
                    return this.parsePlaceholder("Identifier") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseFunctionId", this).call(this, requireId);
                }
            },
            {
                key: "parseClass",
                value: function parseClass(node, isStatement5, optionalId) {
                    var type = isStatement5 ? "ClassDeclaration" : "ClassExpression";
                    this.next();
                    var oldStrict = this.state.strict;
                    var placeholder2 = this.parsePlaceholder("Identifier");
                    if (placeholder2) {
                        if (this.match(81) || this.match(144) || this.match(5)) {
                            node.id = placeholder2;
                        } else if (optionalId || !isStatement5) {
                            node.id = null;
                            node.body = this.finishPlaceholder(placeholder2, "ClassBody");
                            return this.finishNode(node, type);
                        } else {
                            throw this.raise(PlaceholderErrors.ClassNameIsRequired, this.state.startLoc);
                        }
                    } else {
                        this.parseClassId(node, isStatement5, optionalId);
                    }
                    _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseClassSuper", this).call(this, node);
                    node.body = this.parsePlaceholder("ClassBody") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseClassBody", this).call(this, !!node.superClass, oldStrict);
                    return this.finishNode(node, type);
                }
            },
            {
                key: "parseExport",
                value: function parseExport(node, decorators) {
                    var placeholder2 = this.parsePlaceholder("Identifier");
                    if (!placeholder2) return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseExport", this).call(this, node, decorators);
                    if (!this.isContextual(98) && !this.match(12)) {
                        node.specifiers = [];
                        node.source = null;
                        node.declaration = this.finishPlaceholder(placeholder2, "Declaration");
                        return this.finishNode(node, "ExportNamedDeclaration");
                    }
                    this.expectPlugin("exportDefaultFrom");
                    var specifier = this.startNode();
                    specifier.exported = placeholder2;
                    node.specifiers = [
                        this.finishNode(specifier, "ExportDefaultSpecifier")
                    ];
                    return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseExport", this).call(this, node, decorators);
                }
            },
            {
                key: "isExportDefaultSpecifier",
                value: function isExportDefaultSpecifier() {
                    if (this.match(65)) {
                        var next = this.nextTokenStart();
                        if (this.isUnparsedContextual(next, "from")) {
                            if (this.input.startsWith(tokenLabelName(144), this.nextTokenStartSince(next + 4))) {
                                return true;
                            }
                        }
                    }
                    return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "isExportDefaultSpecifier", this).call(this);
                }
            },
            {
                key: "maybeParseExportDefaultSpecifier",
                value: function maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
                    var _node_specifiers;
                    if ((_node_specifiers = node.specifiers) === null || _node_specifiers === void 0 ? void 0 : _node_specifiers.length) {
                        return true;
                    }
                    return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "maybeParseExportDefaultSpecifier", this).call(this, node, maybeDefaultIdentifier);
                }
            },
            {
                key: "checkExport",
                value: function checkExport(node) {
                    var specifiers = node.specifiers;
                    if (specifiers === null || specifiers === void 0 ? void 0 : specifiers.length) {
                        node.specifiers = specifiers.filter(function(node2) {
                            return node2.exported.type === "Placeholder";
                        });
                    }
                    _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "checkExport", this).call(this, node);
                    node.specifiers = specifiers;
                }
            },
            {
                key: "parseImport",
                value: function parseImport(node) {
                    var placeholder2 = this.parsePlaceholder("Identifier");
                    if (!placeholder2) return _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseImport", this).call(this, node);
                    node.specifiers = [];
                    if (!this.isContextual(98) && !this.match(12)) {
                        node.source = this.finishPlaceholder(placeholder2, "StringLiteral");
                        this.semicolon();
                        return this.finishNode(node, "ImportDeclaration");
                    }
                    var specifier = this.startNodeAtNode(placeholder2);
                    specifier.local = placeholder2;
                    node.specifiers.push(this.finishNode(specifier, "ImportDefaultSpecifier"));
                    if (this.eat(12)) {
                        var hasStarImport = this.maybeParseStarImportSpecifier(node);
                        if (!hasStarImport) this.parseNamedImportSpecifiers(node);
                    }
                    this.expectContextual(98);
                    node.source = this.parseImportSource();
                    this.semicolon();
                    return this.finishNode(node, "ImportDeclaration");
                }
            },
            {
                key: "parseImportSource",
                value: function parseImportSource() {
                    return this.parsePlaceholder("StringLiteral") || _get(_get_prototype_of(PlaceholdersParserMixin.prototype), "parseImportSource", this).call(this);
                }
            },
            {
                key: "assertNoSpace",
                value: function assertNoSpace() {
                    if (this.state.start > this.state.lastTokEndLoc.index) {
                        this.raise(PlaceholderErrors.UnexpectedSpace, this.state.lastTokEndLoc);
                    }
                }
            }
        ]);
        return PlaceholdersParserMixin;
    }(superClass);
    return PlaceholdersParserMixin;
};
var v8intrinsic = function(superClass) {
    var V8IntrinsicMixin = /*#__PURE__*/ function(superClass) {
        "use strict";
        _inherits(V8IntrinsicMixin, superClass);
        var _super = _create_super(V8IntrinsicMixin);
        function V8IntrinsicMixin() {
            _class_call_check(this, V8IntrinsicMixin);
            return _super.apply(this, arguments);
        }
        _create_class(V8IntrinsicMixin, [
            {
                key: "parseV8Intrinsic",
                value: function parseV8Intrinsic() {
                    if (this.match(54)) {
                        var v8IntrinsicStartLoc = this.state.startLoc;
                        var node = this.startNode();
                        this.next();
                        if (tokenIsIdentifier(this.state.type)) {
                            var name = this.parseIdentifierName();
                            var identifier7 = this.createIdentifier(node, name);
                            identifier7.type = "V8IntrinsicIdentifier";
                            if (this.match(10)) {
                                return identifier7;
                            }
                        }
                        this.unexpected(v8IntrinsicStartLoc);
                    }
                }
            },
            {
                key: "parseExprAtom",
                value: function parseExprAtom(refExpressionErrors) {
                    return this.parseV8Intrinsic() || _get(_get_prototype_of(V8IntrinsicMixin.prototype), "parseExprAtom", this).call(this, refExpressionErrors);
                }
            }
        ]);
        return V8IntrinsicMixin;
    }(superClass);
    return V8IntrinsicMixin;
};
function hasPlugin(plugins, expectedConfig) {
    var _ref = _sliced_to_array(typeof expectedConfig === "string" ? [
        expectedConfig,
        {}
    ] : expectedConfig, 2), expectedName = _ref[0], expectedOptions = _ref[1];
    var expectedKeys = Object.keys(expectedOptions);
    var expectedOptionsIsEmpty = expectedKeys.length === 0;
    return plugins.some(function(p) {
        if (typeof p === "string") {
            return expectedOptionsIsEmpty && p === expectedName;
        } else {
            var _p = _sliced_to_array(p, 2), pluginName = _p[0], pluginOptions = _p[1];
            if (pluginName !== expectedName) {
                return false;
            }
            var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
            try {
                for(var _iterator = expectedKeys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                    var key = _step.value;
                    if (pluginOptions[key] !== expectedOptions[key]) {
                        return false;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                } finally{
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
            return true;
        }
    });
}
function getPluginOption(plugins, name, option) {
    var plugin = plugins.find(function(plugin2) {
        if (Array.isArray(plugin2)) {
            return plugin2[0] === name;
        } else {
            return plugin2 === name;
        }
    });
    if (plugin && Array.isArray(plugin) && plugin.length > 1) {
        return plugin[1][option];
    }
    return null;
}
var PIPELINE_PROPOSALS = [
    "minimal",
    "fsharp",
    "hack",
    "smart"
];
var TOPIC_TOKENS = [
    "^^",
    "@@",
    "^",
    "%",
    "#"
];
var RECORD_AND_TUPLE_SYNTAX_TYPES = [
    "hash",
    "bar"
];
function validatePlugins(plugins) {
    if (hasPlugin(plugins, "decorators")) {
        if (hasPlugin(plugins, "decorators-legacy")) {
            throw new Error("Cannot use the decorators and decorators-legacy plugin together");
        }
        var decoratorsBeforeExport = getPluginOption(plugins, "decorators", "decoratorsBeforeExport");
        if (decoratorsBeforeExport != null && typeof decoratorsBeforeExport !== "boolean") {
            throw new Error("'decoratorsBeforeExport' must be a boolean, if specified.");
        }
        var allowCallParenthesized = getPluginOption(plugins, "decorators", "allowCallParenthesized");
        if (allowCallParenthesized != null && typeof allowCallParenthesized !== "boolean") {
            throw new Error("'allowCallParenthesized' must be a boolean.");
        }
    }
    if (hasPlugin(plugins, "flow") && hasPlugin(plugins, "typescript")) {
        throw new Error("Cannot combine flow and typescript plugins.");
    }
    if (hasPlugin(plugins, "placeholders") && hasPlugin(plugins, "v8intrinsic")) {
        throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
    }
    if (hasPlugin(plugins, "pipelineOperator")) {
        var proposal = getPluginOption(plugins, "pipelineOperator", "proposal");
        if (!PIPELINE_PROPOSALS.includes(proposal)) {
            var proposalList = PIPELINE_PROPOSALS.map(function(p) {
                return '"'.concat(p, '"');
            }).join(", ");
            throw new Error('"pipelineOperator" requires "proposal" option whose value must be one of: '.concat(proposalList, "."));
        }
        var tupleSyntaxIsHash = hasPlugin(plugins, [
            "recordAndTuple",
            {
                syntaxType: "hash"
            }
        ]);
        if (proposal === "hack") {
            if (hasPlugin(plugins, "placeholders")) {
                throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
            }
            if (hasPlugin(plugins, "v8intrinsic")) {
                throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
            }
            var topicToken = getPluginOption(plugins, "pipelineOperator", "topicToken");
            if (!TOPIC_TOKENS.includes(topicToken)) {
                var tokenList = TOPIC_TOKENS.map(function(t) {
                    return '"'.concat(t, '"');
                }).join(", ");
                throw new Error('"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: '.concat(tokenList, "."));
            }
            if (topicToken === "#" && tupleSyntaxIsHash) {
                throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
            }
        } else if (proposal === "smart" && tupleSyntaxIsHash) {
            throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
        }
    }
    if (hasPlugin(plugins, "moduleAttributes")) {
        {
            throw new Error("`moduleAttributes` has been removed in Babel 8, please use `importAttributes` parser plugin, or `@babel/plugin-syntax-import-attributes`.");
        }
    }
    if (hasPlugin(plugins, "importAssertions") && hasPlugin(plugins, "importAttributes")) {
        throw new Error("Cannot combine importAssertions and importAttributes plugins.");
    }
    if (hasPlugin(plugins, "recordAndTuple") && getPluginOption(plugins, "recordAndTuple", "syntaxType") != null && !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(getPluginOption(plugins, "recordAndTuple", "syntaxType"))) {
        throw new Error("The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map(function(p) {
            return "'".concat(p, "'");
        }).join(", "));
    }
    if (hasPlugin(plugins, "asyncDoExpressions") && !hasPlugin(plugins, "doExpressions")) {
        var error = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
        error.missingPlugins = "doExpressions";
        throw error;
    }
    if (hasPlugin(plugins, "optionalChainingAssign") && getPluginOption(plugins, "optionalChainingAssign", "version") !== "2023-07") {
        throw new Error("The 'optionalChainingAssign' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is '2023-07'.");
    }
}
var mixinPlugins = {
    estree: estree,
    jsx: jsx,
    flow: flow,
    typescript: typescript,
    v8intrinsic: v8intrinsic,
    placeholders: placeholders
};
var mixinPluginNames = Object.keys(mixinPlugins);
var defaultOptions = {
    sourceType: "script",
    sourceFilename: void 0,
    startColumn: 0,
    startLine: 1,
    allowAwaitOutsideFunction: false,
    allowReturnOutsideFunction: false,
    allowNewTargetOutsideFunction: false,
    allowImportExportEverywhere: false,
    allowSuperOutsideMethod: false,
    allowUndeclaredExports: false,
    plugins: [],
    strictMode: null,
    ranges: false,
    tokens: false,
    createImportExpressions: true,
    createParenthesizedExpressions: false,
    errorRecovery: false,
    attachComment: true,
    annexB: true
};
function getOptions(opts) {
    if (opts == null) {
        return Object.assign({}, defaultOptions);
    }
    if (opts.annexB != null && opts.annexB !== false) {
        throw new Error("The `annexB` option can only be set to `false`.");
    }
    var options = {};
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(defaultOptions)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            var _opts_key;
            options[key] = (_opts_key = opts[key]) !== null && _opts_key !== void 0 ? _opts_key : defaultOptions[key];
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return options;
}
var ExpressionParser = /*#__PURE__*/ function(LValParser) {
    "use strict";
    _inherits(ExpressionParser, LValParser);
    var _super = _create_super(ExpressionParser);
    function ExpressionParser() {
        _class_call_check(this, ExpressionParser);
        return _super.apply(this, arguments);
    }
    _create_class(ExpressionParser, [
        {
            key: "checkProto",
            value: function checkProto(prop, isRecord, protoRef, refExpressionErrors) {
                if (prop.type === "SpreadElement" || this.isObjectMethod(prop) || prop.computed || prop.shorthand) {
                    return;
                }
                var key = prop.key;
                var name = key.type === "Identifier" ? key.name : key.value;
                if (name === "__proto__") {
                    if (isRecord) {
                        this.raise(Errors.RecordNoProto, key);
                        return;
                    }
                    if (protoRef.used) {
                        if (refExpressionErrors) {
                            if (refExpressionErrors.doubleProtoLoc === null) {
                                refExpressionErrors.doubleProtoLoc = key.loc.start;
                            }
                        } else {
                            this.raise(Errors.DuplicateProto, key);
                        }
                    }
                    protoRef.used = true;
                }
            }
        },
        {
            key: "shouldExitDescending",
            value: function shouldExitDescending(expr, potentialArrowAt) {
                return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
            }
        },
        {
            key: "getExpression",
            value: function getExpression() {
                this.enterInitialScopes();
                this.nextToken();
                var expr = this.parseExpression();
                if (!this.match(139)) {
                    this.unexpected();
                }
                this.finalizeRemainingComments();
                expr.comments = this.comments;
                expr.errors = this.state.errors;
                if (this.options.tokens) {
                    expr.tokens = this.tokens;
                }
                return expr;
            }
        },
        {
            key: "parseExpression",
            value: function parseExpression(disallowIn, refExpressionErrors) {
                var _this = this;
                if (disallowIn) {
                    return this.disallowInAnd(function() {
                        return _this.parseExpressionBase(refExpressionErrors);
                    });
                }
                return this.allowInAnd(function() {
                    return _this.parseExpressionBase(refExpressionErrors);
                });
            }
        },
        {
            key: "parseExpressionBase",
            value: function parseExpressionBase(refExpressionErrors) {
                var startLoc = this.state.startLoc;
                var expr = this.parseMaybeAssign(refExpressionErrors);
                if (this.match(12)) {
                    var node = this.startNodeAt(startLoc);
                    node.expressions = [
                        expr
                    ];
                    while(this.eat(12)){
                        node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
                    }
                    this.toReferencedList(node.expressions);
                    return this.finishNode(node, "SequenceExpression");
                }
                return expr;
            }
        },
        {
            key: "parseMaybeAssignDisallowIn",
            value: function parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
                var _this = this;
                return this.disallowInAnd(function() {
                    return _this.parseMaybeAssign(refExpressionErrors, afterLeftParse);
                });
            }
        },
        {
            key: "parseMaybeAssignAllowIn",
            value: function parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
                var _this = this;
                return this.allowInAnd(function() {
                    return _this.parseMaybeAssign(refExpressionErrors, afterLeftParse);
                });
            }
        },
        {
            key: "setOptionalParametersError",
            value: function setOptionalParametersError(refExpressionErrors, resultError) {
                var _resultError_loc;
                refExpressionErrors.optionalParametersLoc = (_resultError_loc = resultError === null || resultError === void 0 ? void 0 : resultError.loc) !== null && _resultError_loc !== void 0 ? _resultError_loc : this.state.startLoc;
            }
        },
        {
            key: "parseMaybeAssign",
            value: function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
                var startLoc = this.state.startLoc;
                if (this.isContextual(108)) {
                    if (this.prodParam.hasYield) {
                        var left2 = this.parseYield();
                        if (afterLeftParse) {
                            left2 = afterLeftParse.call(this, left2, startLoc);
                        }
                        return left2;
                    }
                }
                var ownExpressionErrors;
                if (refExpressionErrors) {
                    ownExpressionErrors = false;
                } else {
                    refExpressionErrors = new ExpressionErrors();
                    ownExpressionErrors = true;
                }
                var type = this.state.type;
                if (type === 10 || tokenIsIdentifier(type)) {
                    this.state.potentialArrowAt = this.state.start;
                }
                var left = this.parseMaybeConditional(refExpressionErrors);
                if (afterLeftParse) {
                    left = afterLeftParse.call(this, left, startLoc);
                }
                if (tokenIsAssignment(this.state.type)) {
                    var node = this.startNodeAt(startLoc);
                    var operator = this.state.value;
                    node.operator = operator;
                    if (this.match(29)) {
                        this.toAssignable(left, true);
                        node.left = left;
                        var startIndex = startLoc.index;
                        if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startIndex) {
                            refExpressionErrors.doubleProtoLoc = null;
                        }
                        if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startIndex) {
                            refExpressionErrors.shorthandAssignLoc = null;
                        }
                        if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startIndex) {
                            this.checkDestructuringPrivate(refExpressionErrors);
                            refExpressionErrors.privateKeyLoc = null;
                        }
                    } else {
                        node.left = left;
                    }
                    this.next();
                    node.right = this.parseMaybeAssign();
                    this.checkLVal(left, {
                        in: this.finishNode(node, "AssignmentExpression")
                    });
                    return node;
                } else if (ownExpressionErrors) {
                    this.checkExpressionErrors(refExpressionErrors, true);
                }
                return left;
            }
        },
        {
            key: "parseMaybeConditional",
            value: function parseMaybeConditional(refExpressionErrors) {
                var startLoc = this.state.startLoc;
                var potentialArrowAt = this.state.potentialArrowAt;
                var expr = this.parseExprOps(refExpressionErrors);
                if (this.shouldExitDescending(expr, potentialArrowAt)) {
                    return expr;
                }
                return this.parseConditional(expr, startLoc, refExpressionErrors);
            }
        },
        {
            key: "parseConditional",
            value: function parseConditional(expr, startLoc, refExpressionErrors) {
                if (this.eat(17)) {
                    var node = this.startNodeAt(startLoc);
                    node.test = expr;
                    node.consequent = this.parseMaybeAssignAllowIn();
                    this.expect(14);
                    node.alternate = this.parseMaybeAssign();
                    return this.finishNode(node, "ConditionalExpression");
                }
                return expr;
            }
        },
        {
            key: "parseMaybeUnaryOrPrivate",
            value: function parseMaybeUnaryOrPrivate(refExpressionErrors) {
                return this.match(138) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
            }
        },
        {
            key: "parseExprOps",
            value: function parseExprOps(refExpressionErrors) {
                var startLoc = this.state.startLoc;
                var potentialArrowAt = this.state.potentialArrowAt;
                var expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
                if (this.shouldExitDescending(expr, potentialArrowAt)) {
                    return expr;
                }
                return this.parseExprOp(expr, startLoc, -1);
            }
        },
        {
            key: "parseExprOp",
            value: function parseExprOp(left, leftStartLoc, minPrec) {
                if (this.isPrivateName(left)) {
                    var value1 = this.getPrivateNameSV(left);
                    if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
                        this.raise(Errors.PrivateInExpectedIn, left, {
                            identifierName: value1
                        });
                    }
                    this.classScope.usePrivateName(value1, left.loc.start);
                }
                var op = this.state.type;
                if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
                    var prec = tokenOperatorPrecedence(op);
                    if (prec > minPrec) {
                        if (op === 39) {
                            this.expectPlugin("pipelineOperator");
                            if (this.state.inFSharpPipelineDirectBody) {
                                return left;
                            }
                            this.checkPipelineAtInfixOperator(left, leftStartLoc);
                        }
                        var node = this.startNodeAt(leftStartLoc);
                        node.left = left;
                        node.operator = this.state.value;
                        var logical = op === 41 || op === 42;
                        var coalesce = op === 40;
                        if (coalesce) {
                            prec = tokenOperatorPrecedence(42);
                        }
                        this.next();
                        if (op === 39 && this.hasPlugin([
                            "pipelineOperator",
                            {
                                proposal: "minimal"
                            }
                        ])) {
                            if (this.state.type === 96 && this.prodParam.hasAwait) {
                                throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, this.state.startLoc);
                            }
                        }
                        node.right = this.parseExprOpRightExpr(op, prec);
                        var finishedNode = this.finishNode(node, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
                        var nextOp = this.state.type;
                        if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
                            throw this.raise(Errors.MixingCoalesceWithLogical, this.state.startLoc);
                        }
                        return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
                    }
                }
                return left;
            }
        },
        {
            key: "parseExprOpRightExpr",
            value: function parseExprOpRightExpr(op, prec) {
                var _this = this;
                var startLoc = this.state.startLoc;
                switch(op){
                    case 39:
                        switch(this.getPluginOption("pipelineOperator", "proposal")){
                            case "hack":
                                return this.withTopicBindingContext(function() {
                                    return _this.parseHackPipeBody();
                                });
                            case "smart":
                                return this.withTopicBindingContext(function() {
                                    if (_this.prodParam.hasYield && _this.isContextual(108)) {
                                        throw _this.raise(Errors.PipeBodyIsTighter, _this.state.startLoc);
                                    }
                                    return _this.parseSmartPipelineBodyInStyle(_this.parseExprOpBaseRightExpr(op, prec), startLoc);
                                });
                            case "fsharp":
                                return this.withSoloAwaitPermittingContext(function() {
                                    return _this.parseFSharpPipelineBody(prec);
                                });
                        }
                    default:
                        return this.parseExprOpBaseRightExpr(op, prec);
                }
            }
        },
        {
            key: "parseExprOpBaseRightExpr",
            value: function parseExprOpBaseRightExpr(op, prec) {
                var startLoc = this.state.startLoc;
                return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
            }
        },
        {
            key: "parseHackPipeBody",
            value: function parseHackPipeBody() {
                var _body_extra;
                var startLoc = this.state.startLoc;
                var body = this.parseMaybeAssign();
                var requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(body.type);
                if (requiredParentheses && !((_body_extra = body.extra) === null || _body_extra === void 0 ? void 0 : _body_extra.parenthesized)) {
                    this.raise(Errors.PipeUnparenthesizedBody, startLoc, {
                        type: body.type
                    });
                }
                if (!this.topicReferenceWasUsedInCurrentContext()) {
                    this.raise(Errors.PipeTopicUnused, startLoc);
                }
                return body;
            }
        },
        {
            key: "checkExponentialAfterUnary",
            value: function checkExponentialAfterUnary(node) {
                if (this.match(57)) {
                    this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
                }
            }
        },
        {
            key: "parseMaybeUnary",
            value: function parseMaybeUnary(refExpressionErrors, sawUnary) {
                var startLoc = this.state.startLoc;
                var isAwait = this.isContextual(96);
                if (isAwait && this.isAwaitAllowed()) {
                    this.next();
                    var expr2 = this.parseAwait(startLoc);
                    if (!sawUnary) this.checkExponentialAfterUnary(expr2);
                    return expr2;
                }
                var update = this.match(34);
                var node = this.startNode();
                if (tokenIsPrefix(this.state.type)) {
                    node.operator = this.state.value;
                    node.prefix = true;
                    if (this.match(72)) {
                        this.expectPlugin("throwExpressions");
                    }
                    var isDelete = this.match(89);
                    this.next();
                    node.argument = this.parseMaybeUnary(null, true);
                    this.checkExpressionErrors(refExpressionErrors, true);
                    if (this.state.strict && isDelete) {
                        var arg = node.argument;
                        if (arg.type === "Identifier") {
                            this.raise(Errors.StrictDelete, node);
                        } else if (this.hasPropertyAsPrivateName(arg)) {
                            this.raise(Errors.DeletePrivateField, node);
                        }
                    }
                    if (!update) {
                        if (!sawUnary) {
                            this.checkExponentialAfterUnary(node);
                        }
                        return this.finishNode(node, "UnaryExpression");
                    }
                }
                var expr = this.parseUpdate(node, update, refExpressionErrors);
                if (isAwait) {
                    var type = this.state.type;
                    var startsExpr2 = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type) : tokenCanStartExpression(type) && !this.match(54);
                    if (startsExpr2 && !this.isAmbiguousAwait()) {
                        this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
                        return this.parseAwait(startLoc);
                    }
                }
                return expr;
            }
        },
        {
            key: "parseUpdate",
            value: function parseUpdate(node, update, refExpressionErrors) {
                if (update) {
                    var updateExpressionNode = node;
                    this.checkLVal(updateExpressionNode.argument, {
                        in: this.finishNode(updateExpressionNode, "UpdateExpression")
                    });
                    return node;
                }
                var startLoc = this.state.startLoc;
                var expr = this.parseExprSubscripts(refExpressionErrors);
                if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
                while(tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()){
                    var node2 = this.startNodeAt(startLoc);
                    node2.operator = this.state.value;
                    node2.prefix = false;
                    node2.argument = expr;
                    this.next();
                    this.checkLVal(expr, {
                        in: expr = this.finishNode(node2, "UpdateExpression")
                    });
                }
                return expr;
            }
        },
        {
            key: "parseExprSubscripts",
            value: function parseExprSubscripts(refExpressionErrors) {
                var startLoc = this.state.startLoc;
                var potentialArrowAt = this.state.potentialArrowAt;
                var expr = this.parseExprAtom(refExpressionErrors);
                if (this.shouldExitDescending(expr, potentialArrowAt)) {
                    return expr;
                }
                return this.parseSubscripts(expr, startLoc);
            }
        },
        {
            key: "parseSubscripts",
            value: function parseSubscripts(base, startLoc, noCalls) {
                var state = {
                    optionalChainMember: false,
                    maybeAsyncArrow: this.atPossibleAsyncArrow(base),
                    stop: false
                };
                do {
                    base = this.parseSubscript(base, startLoc, noCalls, state);
                    state.maybeAsyncArrow = false;
                }while (!state.stop);
                return base;
            }
        },
        {
            key: "parseSubscript",
            value: function parseSubscript(base, startLoc, noCalls, state) {
                var type = this.state.type;
                if (!noCalls && type === 15) {
                    return this.parseBind(base, startLoc, noCalls, state);
                } else if (tokenIsTemplate(type)) {
                    return this.parseTaggedTemplateExpression(base, startLoc, state);
                }
                var optional = false;
                if (type === 18) {
                    if (noCalls) {
                        this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
                        if (this.lookaheadCharCode() === 40) {
                            state.stop = true;
                            return base;
                        }
                    }
                    state.optionalChainMember = optional = true;
                    this.next();
                }
                if (!noCalls && this.match(10)) {
                    return this.parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional);
                } else {
                    var computed = this.eat(0);
                    if (computed || optional || this.eat(16)) {
                        return this.parseMember(base, startLoc, state, computed, optional);
                    } else {
                        state.stop = true;
                        return base;
                    }
                }
            }
        },
        {
            key: "parseMember",
            value: function parseMember(base, startLoc, state, computed, optional) {
                var node = this.startNodeAt(startLoc);
                node.object = base;
                node.computed = computed;
                if (computed) {
                    node.property = this.parseExpression();
                    this.expect(3);
                } else if (this.match(138)) {
                    if (base.type === "Super") {
                        this.raise(Errors.SuperPrivateField, startLoc);
                    }
                    this.classScope.usePrivateName(this.state.value, this.state.startLoc);
                    node.property = this.parsePrivateName();
                } else {
                    node.property = this.parseIdentifier(true);
                }
                if (state.optionalChainMember) {
                    node.optional = optional;
                    return this.finishNode(node, "OptionalMemberExpression");
                } else {
                    return this.finishNode(node, "MemberExpression");
                }
            }
        },
        {
            key: "parseBind",
            value: function parseBind(base, startLoc, noCalls, state) {
                var node = this.startNodeAt(startLoc);
                node.object = base;
                this.next();
                node.callee = this.parseNoCallExpr();
                state.stop = true;
                return this.parseSubscripts(this.finishNode(node, "BindExpression"), startLoc, noCalls);
            }
        },
        {
            key: "parseCoverCallAndAsyncArrowHead",
            value: function parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
                var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
                var refExpressionErrors = null;
                this.state.maybeInArrowParameters = true;
                this.next();
                var node = this.startNodeAt(startLoc);
                node.callee = base;
                var maybeAsyncArrow = state.maybeAsyncArrow, optionalChainMember = state.optionalChainMember;
                if (maybeAsyncArrow) {
                    this.expressionScope.enter(newAsyncArrowScope());
                    refExpressionErrors = new ExpressionErrors();
                }
                if (optionalChainMember) {
                    node.optional = optional;
                }
                if (optional) {
                    node.arguments = this.parseCallExpressionArguments(11);
                } else {
                    node.arguments = this.parseCallExpressionArguments(11, base.type === "Import", base.type !== "Super", node, refExpressionErrors);
                }
                var finishedNode = this.finishCallExpression(node, optionalChainMember);
                if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
                    state.stop = true;
                    this.checkDestructuringPrivate(refExpressionErrors);
                    this.expressionScope.validateAsPattern();
                    this.expressionScope.exit();
                    finishedNode = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startLoc), finishedNode);
                } else {
                    if (maybeAsyncArrow) {
                        this.checkExpressionErrors(refExpressionErrors, true);
                        this.expressionScope.exit();
                    }
                    this.toReferencedArguments(finishedNode);
                }
                this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
                return finishedNode;
            }
        },
        {
            key: "toReferencedArguments",
            value: function toReferencedArguments(node, isParenthesizedExpr) {
                this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
            }
        },
        {
            key: "parseTaggedTemplateExpression",
            value: function parseTaggedTemplateExpression(base, startLoc, state) {
                var node = this.startNodeAt(startLoc);
                node.tag = base;
                node.quasi = this.parseTemplate(true);
                if (state.optionalChainMember) {
                    this.raise(Errors.OptionalChainingNoTemplate, startLoc);
                }
                return this.finishNode(node, "TaggedTemplateExpression");
            }
        },
        {
            key: "atPossibleAsyncArrow",
            value: function atPossibleAsyncArrow(base) {
                return base.type === "Identifier" && base.name === "async" && this.state.lastTokEndLoc.index === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 && base.start === this.state.potentialArrowAt;
            }
        },
        {
            key: "expectImportAttributesPlugin",
            value: function expectImportAttributesPlugin() {
                if (!this.hasPlugin("importAssertions")) {
                    this.expectPlugin("importAttributes");
                }
            }
        },
        {
            key: "finishCallExpression",
            value: function finishCallExpression(node, optional) {
                if (node.callee.type === "Import") {
                    if (node.arguments.length === 2) {
                        {
                            this.expectImportAttributesPlugin();
                        }
                    }
                    if (node.arguments.length === 0 || node.arguments.length > 2) {
                        this.raise(Errors.ImportCallArity, node, {
                            maxArgumentCount: this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1
                        });
                    } else {
                        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                        try {
                            for(var _iterator = node.arguments[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                var arg = _step.value;
                                if (arg.type === "SpreadElement") {
                                    this.raise(Errors.ImportCallSpreadArgument, arg);
                                }
                            }
                        } catch (err) {
                            _didIteratorError = true;
                            _iteratorError = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion && _iterator.return != null) {
                                    _iterator.return();
                                }
                            } finally{
                                if (_didIteratorError) {
                                    throw _iteratorError;
                                }
                            }
                        }
                    }
                }
                return this.finishNode(node, optional ? "OptionalCallExpression" : "CallExpression");
            }
        },
        {
            key: "parseCallExpressionArguments",
            value: function parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
                var elts = [];
                var first = true;
                var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
                this.state.inFSharpPipelineDirectBody = false;
                while(!this.eat(close)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12);
                        if (this.match(close)) {
                            if (dynamicImport && !this.hasPlugin("importAttributes") && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
                                this.raise(Errors.ImportCallArgumentTrailingComma, this.state.lastTokStartLoc);
                            }
                            if (nodeForExtra) {
                                this.addTrailingCommaExtraToNode(nodeForExtra);
                            }
                            this.next();
                            break;
                        }
                    }
                    elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
                }
                this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
                return elts;
            }
        },
        {
            key: "shouldParseAsyncArrow",
            value: function shouldParseAsyncArrow() {
                return this.match(19) && !this.canInsertSemicolon();
            }
        },
        {
            key: "parseAsyncArrowFromCallExpression",
            value: function parseAsyncArrowFromCallExpression(node, call2) {
                var _call2_extra;
                this.resetPreviousNodeTrailingComments(call2);
                this.expect(19);
                this.parseArrowExpression(node, call2.arguments, true, (_call2_extra = call2.extra) === null || _call2_extra === void 0 ? void 0 : _call2_extra.trailingCommaLoc);
                if (call2.innerComments) {
                    setInnerComments(node, call2.innerComments);
                }
                if (call2.callee.trailingComments) {
                    setInnerComments(node, call2.callee.trailingComments);
                }
                return node;
            }
        },
        {
            key: "parseNoCallExpr",
            value: function parseNoCallExpr() {
                var startLoc = this.state.startLoc;
                return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
            }
        },
        {
            key: "parseExprAtom",
            value: function parseExprAtom(refExpressionErrors) {
                var node;
                var decorators = null;
                var type = this.state.type;
                switch(type){
                    case 79:
                        return this.parseSuper();
                    case 83:
                        node = this.startNode();
                        this.next();
                        if (this.match(16)) {
                            return this.parseImportMetaProperty(node);
                        }
                        if (this.match(10)) {
                            if (this.options.createImportExpressions) {
                                return this.parseImportCall(node);
                            } else {
                                return this.finishNode(node, "Import");
                            }
                        } else {
                            this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
                            return this.finishNode(node, "Import");
                        }
                    case 78:
                        node = this.startNode();
                        this.next();
                        return this.finishNode(node, "ThisExpression");
                    case 90:
                        {
                            return this.parseDo(this.startNode(), false);
                        }
                    case 56:
                    case 31:
                        {
                            this.readRegexp();
                            return this.parseRegExpLiteral(this.state.value);
                        }
                    case 134:
                        return this.parseNumericLiteral(this.state.value);
                    case 135:
                        return this.parseBigIntLiteral(this.state.value);
                    case 136:
                        return this.parseDecimalLiteral(this.state.value);
                    case 133:
                        return this.parseStringLiteral(this.state.value);
                    case 84:
                        return this.parseNullLiteral();
                    case 85:
                        return this.parseBooleanLiteral(true);
                    case 86:
                        return this.parseBooleanLiteral(false);
                    case 10:
                        {
                            var canBeArrow = this.state.potentialArrowAt === this.state.start;
                            return this.parseParenAndDistinguishExpression(canBeArrow);
                        }
                    case 2:
                    case 1:
                        {
                            return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
                        }
                    case 0:
                        {
                            return this.parseArrayLike(3, true, false, refExpressionErrors);
                        }
                    case 6:
                    case 7:
                        {
                            return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
                        }
                    case 5:
                        {
                            return this.parseObjectLike(8, false, false, refExpressionErrors);
                        }
                    case 68:
                        return this.parseFunctionOrFunctionSent();
                    case 26:
                        decorators = this.parseDecorators();
                    case 80:
                        return this.parseClass(this.maybeTakeDecorators(decorators, this.startNode()), false);
                    case 77:
                        return this.parseNewOrNewTarget();
                    case 25:
                    case 24:
                        return this.parseTemplate(false);
                    case 15:
                        {
                            node = this.startNode();
                            this.next();
                            node.object = null;
                            var callee = node.callee = this.parseNoCallExpr();
                            if (callee.type === "MemberExpression") {
                                return this.finishNode(node, "BindExpression");
                            } else {
                                throw this.raise(Errors.UnsupportedBind, callee);
                            }
                        }
                    case 138:
                        {
                            this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
                                identifierName: this.state.value
                            });
                            return this.parsePrivateName();
                        }
                    case 33:
                        {
                            return this.parseTopicReferenceThenEqualsSign(54, "%");
                        }
                    case 32:
                        {
                            return this.parseTopicReferenceThenEqualsSign(44, "^");
                        }
                    case 37:
                    case 38:
                        {
                            return this.parseTopicReference("hack");
                        }
                    case 44:
                    case 54:
                    case 27:
                        {
                            var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
                            if (pipeProposal) {
                                return this.parseTopicReference(pipeProposal);
                            }
                            this.unexpected();
                            break;
                        }
                    case 47:
                        {
                            var lookaheadCh = this.input.codePointAt(this.nextTokenStart());
                            if (isIdentifierStart2(lookaheadCh) || lookaheadCh === 62) {
                                this.expectOnePlugin([
                                    "jsx",
                                    "flow",
                                    "typescript"
                                ]);
                            } else {
                                this.unexpected();
                            }
                            break;
                        }
                    default:
                        if (tokenIsIdentifier(type)) {
                            if (this.isContextual(127) && this.lookaheadInLineCharCode() === 123) {
                                return this.parseModuleExpression();
                            }
                            var canBeArrow1 = this.state.potentialArrowAt === this.state.start;
                            var containsEsc = this.state.containsEsc;
                            var id = this.parseIdentifier();
                            if (!containsEsc && id.name === "async" && !this.canInsertSemicolon()) {
                                var _this_state = this.state, type2 = _this_state.type;
                                if (type2 === 68) {
                                    this.resetPreviousNodeTrailingComments(id);
                                    this.next();
                                    return this.parseAsyncFunctionExpression(this.startNodeAtNode(id));
                                } else if (tokenIsIdentifier(type2)) {
                                    if (this.lookaheadCharCode() === 61) {
                                        return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id));
                                    } else {
                                        return id;
                                    }
                                } else if (type2 === 90) {
                                    this.resetPreviousNodeTrailingComments(id);
                                    return this.parseDo(this.startNodeAtNode(id), true);
                                }
                            }
                            if (canBeArrow1 && this.match(19) && !this.canInsertSemicolon()) {
                                this.next();
                                return this.parseArrowExpression(this.startNodeAtNode(id), [
                                    id
                                ], false);
                            }
                            return id;
                        } else {
                            this.unexpected();
                        }
                }
            }
        },
        {
            key: "parseTopicReferenceThenEqualsSign",
            value: function parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
                var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
                if (pipeProposal) {
                    this.state.type = topicTokenType;
                    this.state.value = topicTokenValue;
                    this.state.pos--;
                    this.state.end--;
                    this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
                    return this.parseTopicReference(pipeProposal);
                } else {
                    this.unexpected();
                }
            }
        },
        {
            key: "parseTopicReference",
            value: function parseTopicReference(pipeProposal) {
                var node = this.startNode();
                var startLoc = this.state.startLoc;
                var tokenType = this.state.type;
                this.next();
                return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
            }
        },
        {
            key: "finishTopicReference",
            value: function finishTopicReference(node, startLoc, pipeProposal, tokenType) {
                if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
                    var nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
                    if (!this.topicReferenceIsAllowedInCurrentContext()) {
                        this.raise(pipeProposal === "smart" ? Errors.PrimaryTopicNotAllowed : Errors.PipeTopicUnbound, startLoc);
                    }
                    this.registerTopicReference();
                    return this.finishNode(node, nodeType);
                } else {
                    throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
                        token: tokenLabelName(tokenType)
                    });
                }
            }
        },
        {
            key: "testTopicReferenceConfiguration",
            value: function testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
                switch(pipeProposal){
                    case "hack":
                        {
                            return this.hasPlugin([
                                "pipelineOperator",
                                {
                                    topicToken: tokenLabelName(tokenType)
                                }
                            ]);
                        }
                    case "smart":
                        return tokenType === 27;
                    default:
                        throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
                }
            }
        },
        {
            key: "parseAsyncArrowUnaryFunction",
            value: function parseAsyncArrowUnaryFunction(node) {
                this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
                var params = [
                    this.parseIdentifier()
                ];
                this.prodParam.exit();
                if (this.hasPrecedingLineBreak()) {
                    this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
                }
                this.expect(19);
                return this.parseArrowExpression(node, params, true);
            }
        },
        {
            key: "parseDo",
            value: function parseDo(node, isAsync) {
                this.expectPlugin("doExpressions");
                if (isAsync) {
                    this.expectPlugin("asyncDoExpressions");
                }
                node.async = isAsync;
                this.next();
                var oldLabels = this.state.labels;
                this.state.labels = [];
                if (isAsync) {
                    this.prodParam.enter(2);
                    node.body = this.parseBlock();
                    this.prodParam.exit();
                } else {
                    node.body = this.parseBlock();
                }
                this.state.labels = oldLabels;
                return this.finishNode(node, "DoExpression");
            }
        },
        {
            key: "parseSuper",
            value: function parseSuper() {
                var node = this.startNode();
                this.next();
                if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
                    this.raise(Errors.SuperNotAllowed, node);
                } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
                    this.raise(Errors.UnexpectedSuper, node);
                }
                if (!this.match(10) && !this.match(0) && !this.match(16)) {
                    this.raise(Errors.UnsupportedSuper, node);
                }
                return this.finishNode(node, "Super");
            }
        },
        {
            key: "parsePrivateName",
            value: function parsePrivateName() {
                var node = this.startNode();
                var id = this.startNodeAt(createPositionWithColumnOffset(this.state.startLoc, 1));
                var name = this.state.value;
                this.next();
                node.id = this.createIdentifier(id, name);
                return this.finishNode(node, "PrivateName");
            }
        },
        {
            key: "parseFunctionOrFunctionSent",
            value: function parseFunctionOrFunctionSent() {
                var node = this.startNode();
                this.next();
                if (this.prodParam.hasYield && this.match(16)) {
                    var meta = this.createIdentifier(this.startNodeAtNode(node), "function");
                    this.next();
                    if (this.match(103)) {
                        this.expectPlugin("functionSent");
                    } else if (!this.hasPlugin("functionSent")) {
                        this.unexpected();
                    }
                    return this.parseMetaProperty(node, meta, "sent");
                }
                return this.parseFunction(node);
            }
        },
        {
            key: "parseMetaProperty",
            value: function parseMetaProperty(node, meta, propertyName) {
                node.meta = meta;
                var containsEsc = this.state.containsEsc;
                node.property = this.parseIdentifier(true);
                if (node.property.name !== propertyName || containsEsc) {
                    this.raise(Errors.UnsupportedMetaProperty, node.property, {
                        target: meta.name,
                        onlyValidPropertyName: propertyName
                    });
                }
                return this.finishNode(node, "MetaProperty");
            }
        },
        {
            key: "parseImportMetaProperty",
            value: function parseImportMetaProperty(node) {
                var id = this.createIdentifier(this.startNodeAtNode(node), "import");
                this.next();
                if (this.isContextual(101)) {
                    if (!this.inModule) {
                        this.raise(Errors.ImportMetaOutsideModule, id);
                    }
                    this.sawUnambiguousESM = true;
                } else if (this.isContextual(105) || this.isContextual(97)) {
                    var isSource = this.isContextual(105);
                    if (!isSource) this.unexpected();
                    this.expectPlugin(isSource ? "sourcePhaseImports" : "deferredImportEvaluation");
                    if (!this.options.createImportExpressions) {
                        throw this.raise(Errors.DynamicImportPhaseRequiresImportExpressions, this.state.startLoc, {
                            phase: this.state.value
                        });
                    }
                    this.next();
                    node.phase = isSource ? "source" : "defer";
                    return this.parseImportCall(node);
                }
                return this.parseMetaProperty(node, id, "meta");
            }
        },
        {
            key: "parseLiteralAtNode",
            value: function parseLiteralAtNode(value1, type, node) {
                this.addExtra(node, "rawValue", value1);
                this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
                node.value = value1;
                this.next();
                return this.finishNode(node, type);
            }
        },
        {
            key: "parseLiteral",
            value: function parseLiteral(value1, type) {
                var node = this.startNode();
                return this.parseLiteralAtNode(value1, type, node);
            }
        },
        {
            key: "parseStringLiteral",
            value: function parseStringLiteral(value1) {
                return this.parseLiteral(value1, "StringLiteral");
            }
        },
        {
            key: "parseNumericLiteral",
            value: function parseNumericLiteral(value1) {
                return this.parseLiteral(value1, "NumericLiteral");
            }
        },
        {
            key: "parseBigIntLiteral",
            value: function parseBigIntLiteral(value1) {
                return this.parseLiteral(value1, "BigIntLiteral");
            }
        },
        {
            key: "parseDecimalLiteral",
            value: function parseDecimalLiteral(value1) {
                return this.parseLiteral(value1, "DecimalLiteral");
            }
        },
        {
            key: "parseRegExpLiteral",
            value: function parseRegExpLiteral(value1) {
                var node = this.parseLiteral(value1.value, "RegExpLiteral");
                node.pattern = value1.pattern;
                node.flags = value1.flags;
                return node;
            }
        },
        {
            key: "parseBooleanLiteral",
            value: function parseBooleanLiteral(value1) {
                var node = this.startNode();
                node.value = value1;
                this.next();
                return this.finishNode(node, "BooleanLiteral");
            }
        },
        {
            key: "parseNullLiteral",
            value: function parseNullLiteral() {
                var node = this.startNode();
                this.next();
                return this.finishNode(node, "NullLiteral");
            }
        },
        {
            key: "parseParenAndDistinguishExpression",
            value: function parseParenAndDistinguishExpression(canBeArrow) {
                var startLoc = this.state.startLoc;
                var val;
                this.next();
                this.expressionScope.enter(newArrowHeadScope());
                var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
                var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
                this.state.maybeInArrowParameters = true;
                this.state.inFSharpPipelineDirectBody = false;
                var innerStartLoc = this.state.startLoc;
                var exprList = [];
                var refExpressionErrors = new ExpressionErrors();
                var first = true;
                var spreadStartLoc;
                var optionalCommaStartLoc;
                while(!this.match(11)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);
                        if (this.match(11)) {
                            optionalCommaStartLoc = this.state.startLoc;
                            break;
                        }
                    }
                    if (this.match(21)) {
                        var spreadNodeStartLoc = this.state.startLoc;
                        spreadStartLoc = this.state.startLoc;
                        exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc));
                        if (!this.checkCommaAfterRest(41)) {
                            break;
                        }
                    } else {
                        exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
                    }
                }
                var innerEndLoc = this.state.lastTokEndLoc;
                this.expect(11);
                this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
                this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
                var arrowNode = this.startNodeAt(startLoc);
                if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
                    this.checkDestructuringPrivate(refExpressionErrors);
                    this.expressionScope.validateAsPattern();
                    this.expressionScope.exit();
                    this.parseArrowExpression(arrowNode, exprList, false);
                    return arrowNode;
                }
                this.expressionScope.exit();
                if (!exprList.length) {
                    this.unexpected(this.state.lastTokStartLoc);
                }
                if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
                if (spreadStartLoc) this.unexpected(spreadStartLoc);
                this.checkExpressionErrors(refExpressionErrors, true);
                this.toReferencedListDeep(exprList, true);
                if (exprList.length > 1) {
                    val = this.startNodeAt(innerStartLoc);
                    val.expressions = exprList;
                    this.finishNode(val, "SequenceExpression");
                    this.resetEndLocation(val, innerEndLoc);
                } else {
                    val = exprList[0];
                }
                return this.wrapParenthesis(startLoc, val);
            }
        },
        {
            key: "wrapParenthesis",
            value: function wrapParenthesis(startLoc, expression2) {
                if (!this.options.createParenthesizedExpressions) {
                    this.addExtra(expression2, "parenthesized", true);
                    this.addExtra(expression2, "parenStart", startLoc.index);
                    this.takeSurroundingComments(expression2, startLoc.index, this.state.lastTokEndLoc.index);
                    return expression2;
                }
                var parenExpression = this.startNodeAt(startLoc);
                parenExpression.expression = expression2;
                return this.finishNode(parenExpression, "ParenthesizedExpression");
            }
        },
        {
            key: "shouldParseArrow",
            value: function shouldParseArrow(params) {
                return !this.canInsertSemicolon();
            }
        },
        {
            key: "parseArrow",
            value: function parseArrow(node) {
                if (this.eat(19)) {
                    return node;
                }
            }
        },
        {
            key: "parseParenItem",
            value: function parseParenItem(node, startLoc) {
                return node;
            }
        },
        {
            key: "parseNewOrNewTarget",
            value: function parseNewOrNewTarget() {
                var node = this.startNode();
                this.next();
                if (this.match(16)) {
                    var meta = this.createIdentifier(this.startNodeAtNode(node), "new");
                    this.next();
                    var metaProp = this.parseMetaProperty(node, meta, "target");
                    if (!this.scope.inNonArrowFunction && !this.scope.inClass && !this.options.allowNewTargetOutsideFunction) {
                        this.raise(Errors.UnexpectedNewTarget, metaProp);
                    }
                    return metaProp;
                }
                return this.parseNew(node);
            }
        },
        {
            key: "parseNew",
            value: function parseNew(node) {
                this.parseNewCallee(node);
                if (this.eat(10)) {
                    var args = this.parseExprList(11);
                    this.toReferencedList(args);
                    node.arguments = args;
                } else {
                    node.arguments = [];
                }
                return this.finishNode(node, "NewExpression");
            }
        },
        {
            key: "parseNewCallee",
            value: function parseNewCallee(node) {
                var isImport2 = this.match(83);
                var callee = this.parseNoCallExpr();
                node.callee = callee;
                if (isImport2 && (callee.type === "Import" || callee.type === "ImportExpression")) {
                    this.raise(Errors.ImportCallNotNewExpression, callee);
                }
            }
        },
        {
            key: "parseTemplateElement",
            value: function parseTemplateElement(isTagged) {
                var _this_state = this.state, start = _this_state.start, startLoc = _this_state.startLoc, end = _this_state.end, value1 = _this_state.value;
                var elemStart = start + 1;
                var elem = this.startNodeAt(createPositionWithColumnOffset(startLoc, 1));
                if (value1 === null) {
                    if (!isTagged) {
                        this.raise(Errors.InvalidEscapeSequenceTemplate, createPositionWithColumnOffset(this.state.firstInvalidTemplateEscapePos, 1));
                    }
                }
                var isTail = this.match(24);
                var endOffset = isTail ? -1 : -2;
                var elemEnd = end + endOffset;
                elem.value = {
                    raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
                    cooked: value1 === null ? null : value1.slice(1, endOffset)
                };
                elem.tail = isTail;
                this.next();
                var finishedNode = this.finishNode(elem, "TemplateElement");
                this.resetEndLocation(finishedNode, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
                return finishedNode;
            }
        },
        {
            key: "parseTemplate",
            value: function parseTemplate(isTagged) {
                var node = this.startNode();
                node.expressions = [];
                var curElt = this.parseTemplateElement(isTagged);
                node.quasis = [
                    curElt
                ];
                while(!curElt.tail){
                    node.expressions.push(this.parseTemplateSubstitution());
                    this.readTemplateContinuation();
                    node.quasis.push(curElt = this.parseTemplateElement(isTagged));
                }
                return this.finishNode(node, "TemplateLiteral");
            }
        },
        {
            key: "parseTemplateSubstitution",
            value: function parseTemplateSubstitution() {
                return this.parseExpression();
            }
        },
        {
            key: "parseObjectLike",
            value: function parseObjectLike(close, isPattern2, isRecord, refExpressionErrors) {
                if (isRecord) {
                    this.expectPlugin("recordAndTuple");
                }
                var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
                this.state.inFSharpPipelineDirectBody = false;
                var propHash = /* @__PURE__ */ Object.create(null);
                var first = true;
                var node = this.startNode();
                node.properties = [];
                this.next();
                while(!this.match(close)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12);
                        if (this.match(close)) {
                            this.addTrailingCommaExtraToNode(node);
                            break;
                        }
                    }
                    var prop = void 0;
                    if (isPattern2) {
                        prop = this.parseBindingProperty();
                    } else {
                        prop = this.parsePropertyDefinition(refExpressionErrors);
                        this.checkProto(prop, isRecord, propHash, refExpressionErrors);
                    }
                    if (isRecord && !this.isObjectProperty(prop) && prop.type !== "SpreadElement") {
                        this.raise(Errors.InvalidRecordProperty, prop);
                    }
                    if (prop.shorthand) {
                        this.addExtra(prop, "shorthand", true);
                    }
                    node.properties.push(prop);
                }
                this.next();
                this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
                var type = "ObjectExpression";
                if (isPattern2) {
                    type = "ObjectPattern";
                } else if (isRecord) {
                    type = "RecordExpression";
                }
                return this.finishNode(node, type);
            }
        },
        {
            key: "addTrailingCommaExtraToNode",
            value: function addTrailingCommaExtraToNode(node) {
                this.addExtra(node, "trailingComma", this.state.lastTokStartLoc.index);
                this.addExtra(node, "trailingCommaLoc", this.state.lastTokStartLoc, false);
            }
        },
        {
            key: "maybeAsyncOrAccessorProp",
            value: function maybeAsyncOrAccessorProp(prop) {
                return !prop.computed && prop.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
            }
        },
        {
            key: "parsePropertyDefinition",
            value: function parsePropertyDefinition(refExpressionErrors) {
                var decorators = [];
                if (this.match(26)) {
                    if (this.hasPlugin("decorators")) {
                        this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
                    }
                    while(this.match(26)){
                        decorators.push(this.parseDecorator());
                    }
                }
                var prop = this.startNode();
                var isAsync = false;
                var isAccessor2 = false;
                var startLoc;
                if (this.match(21)) {
                    if (decorators.length) this.unexpected();
                    return this.parseSpread();
                }
                if (decorators.length) {
                    prop.decorators = decorators;
                    decorators = [];
                }
                prop.method = false;
                if (refExpressionErrors) {
                    startLoc = this.state.startLoc;
                }
                var isGenerator = this.eat(55);
                this.parsePropertyNamePrefixOperator(prop);
                var containsEsc = this.state.containsEsc;
                var key = this.parsePropertyName(prop, refExpressionErrors);
                if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
                    var keyName = key.name;
                    if (keyName === "async" && !this.hasPrecedingLineBreak()) {
                        isAsync = true;
                        this.resetPreviousNodeTrailingComments(key);
                        isGenerator = this.eat(55);
                        this.parsePropertyName(prop);
                    }
                    if (keyName === "get" || keyName === "set") {
                        isAccessor2 = true;
                        this.resetPreviousNodeTrailingComments(key);
                        prop.kind = keyName;
                        if (this.match(55)) {
                            isGenerator = true;
                            this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
                                kind: keyName
                            });
                            this.next();
                        }
                        this.parsePropertyName(prop);
                    }
                }
                return this.parseObjPropValue(prop, startLoc, isGenerator, isAsync, false, isAccessor2, refExpressionErrors);
            }
        },
        {
            key: "getGetterSetterExpectedParamCount",
            value: function getGetterSetterExpectedParamCount(method) {
                return method.kind === "get" ? 0 : 1;
            }
        },
        {
            key: "getObjectOrClassMethodParams",
            value: function getObjectOrClassMethodParams(method) {
                return method.params;
            }
        },
        {
            key: "checkGetterSetterParams",
            value: function checkGetterSetterParams(method) {
                var _params_;
                var paramCount = this.getGetterSetterExpectedParamCount(method);
                var params = this.getObjectOrClassMethodParams(method);
                if (params.length !== paramCount) {
                    this.raise(method.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, method);
                }
                if (method.kind === "set" && ((_params_ = params[params.length - 1]) === null || _params_ === void 0 ? void 0 : _params_.type) === "RestElement") {
                    this.raise(Errors.BadSetterRestParameter, method);
                }
            }
        },
        {
            key: "parseObjectMethod",
            value: function parseObjectMethod(prop, isGenerator, isAsync, isPattern2, isAccessor2) {
                if (isAccessor2) {
                    var finishedProp = this.parseMethod(prop, isGenerator, false, false, false, "ObjectMethod");
                    this.checkGetterSetterParams(finishedProp);
                    return finishedProp;
                }
                if (isAsync || isGenerator || this.match(10)) {
                    if (isPattern2) this.unexpected();
                    prop.kind = "method";
                    prop.method = true;
                    return this.parseMethod(prop, isGenerator, isAsync, false, false, "ObjectMethod");
                }
            }
        },
        {
            key: "parseObjectProperty",
            value: function parseObjectProperty(prop, startLoc, isPattern2, refExpressionErrors) {
                prop.shorthand = false;
                if (this.eat(14)) {
                    prop.value = isPattern2 ? this.parseMaybeDefault(this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
                    return this.finishNode(prop, "ObjectProperty");
                }
                if (!prop.computed && prop.key.type === "Identifier") {
                    this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
                    if (isPattern2) {
                        prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
                    } else if (this.match(29)) {
                        var shorthandAssignLoc = this.state.startLoc;
                        if (refExpressionErrors != null) {
                            if (refExpressionErrors.shorthandAssignLoc === null) {
                                refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
                            }
                        } else {
                            this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
                        }
                        prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
                    } else {
                        prop.value = cloneIdentifier(prop.key);
                    }
                    prop.shorthand = true;
                    return this.finishNode(prop, "ObjectProperty");
                }
            }
        },
        {
            key: "parseObjPropValue",
            value: function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern2, isAccessor2, refExpressionErrors) {
                var node = this.parseObjectMethod(prop, isGenerator, isAsync, isPattern2, isAccessor2) || this.parseObjectProperty(prop, startLoc, isPattern2, refExpressionErrors);
                if (!node) this.unexpected();
                return node;
            }
        },
        {
            key: "parsePropertyName",
            value: function parsePropertyName(prop, refExpressionErrors) {
                if (this.eat(0)) {
                    prop.computed = true;
                    prop.key = this.parseMaybeAssignAllowIn();
                    this.expect(3);
                } else {
                    var _this_state = this.state, type = _this_state.type, value1 = _this_state.value;
                    var key;
                    if (tokenIsKeywordOrIdentifier(type)) {
                        key = this.parseIdentifier(true);
                    } else {
                        switch(type){
                            case 134:
                                key = this.parseNumericLiteral(value1);
                                break;
                            case 133:
                                key = this.parseStringLiteral(value1);
                                break;
                            case 135:
                                key = this.parseBigIntLiteral(value1);
                                break;
                            case 136:
                                key = this.parseDecimalLiteral(value1);
                                break;
                            case 138:
                                {
                                    var privateKeyLoc = this.state.startLoc;
                                    if (refExpressionErrors != null) {
                                        if (refExpressionErrors.privateKeyLoc === null) {
                                            refExpressionErrors.privateKeyLoc = privateKeyLoc;
                                        }
                                    } else {
                                        this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
                                    }
                                    key = this.parsePrivateName();
                                    break;
                                }
                            default:
                                this.unexpected();
                        }
                    }
                    prop.key = key;
                    if (type !== 138) {
                        prop.computed = false;
                    }
                }
                return prop.key;
            }
        },
        {
            key: "initFunction",
            value: function initFunction(node, isAsync) {
                node.id = null;
                node.generator = false;
                node.async = isAsync;
            }
        },
        {
            key: "parseMethod",
            value: function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type) {
                var inClassScope = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false;
                this.initFunction(node, isAsync);
                node.generator = isGenerator;
                this.scope.enter(2 | 16 | (inClassScope ? 64 : 0) | (allowDirectSuper ? 32 : 0));
                this.prodParam.enter(functionFlags(isAsync, node.generator));
                this.parseFunctionParams(node, isConstructor);
                var finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
                this.prodParam.exit();
                this.scope.exit();
                return finishedNode;
            }
        },
        {
            key: "parseArrayLike",
            value: function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
                if (isTuple) {
                    this.expectPlugin("recordAndTuple");
                }
                var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
                this.state.inFSharpPipelineDirectBody = false;
                var node = this.startNode();
                this.next();
                node.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node);
                this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
                return this.finishNode(node, isTuple ? "TupleExpression" : "ArrayExpression");
            }
        },
        {
            key: "parseArrowExpression",
            value: function parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
                this.scope.enter(2 | 4);
                var flags = functionFlags(isAsync, false);
                if (!this.match(5) && this.prodParam.hasIn) {
                    flags |= 8;
                }
                this.prodParam.enter(flags);
                this.initFunction(node, isAsync);
                var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
                if (params) {
                    this.state.maybeInArrowParameters = true;
                    this.setArrowFunctionParameters(node, params, trailingCommaLoc);
                }
                this.state.maybeInArrowParameters = false;
                this.parseFunctionBody(node, true);
                this.prodParam.exit();
                this.scope.exit();
                this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
                return this.finishNode(node, "ArrowFunctionExpression");
            }
        },
        {
            key: "setArrowFunctionParameters",
            value: function setArrowFunctionParameters(node, params, trailingCommaLoc) {
                this.toAssignableList(params, trailingCommaLoc, false);
                node.params = params;
            }
        },
        {
            key: "parseFunctionBodyAndFinish",
            value: function parseFunctionBodyAndFinish(node, type) {
                var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                this.parseFunctionBody(node, false, isMethod3);
                return this.finishNode(node, type);
            }
        },
        {
            key: "parseFunctionBody",
            value: function parseFunctionBody(node, allowExpression) {
                var _this = this;
                var isMethod3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                var isExpression3 = allowExpression && !this.match(5);
                this.expressionScope.enter(newExpressionScope());
                if (isExpression3) {
                    node.body = this.parseMaybeAssign();
                    this.checkParams(node, false, allowExpression, false);
                } else {
                    var oldStrict = this.state.strict;
                    var oldLabels = this.state.labels;
                    this.state.labels = [];
                    this.prodParam.enter(this.prodParam.currentFlags() | 4);
                    node.body = this.parseBlock(true, false, function(hasStrictModeDirective) {
                        var nonSimple = !_this.isSimpleParamList(node.params);
                        if (hasStrictModeDirective && nonSimple) {
                            _this.raise(Errors.IllegalLanguageModeDirective, (node.kind === "method" || node.kind === "constructor") && !!node.key ? node.key.loc.end : node);
                        }
                        var strictModeChanged = !oldStrict && _this.state.strict;
                        _this.checkParams(node, !_this.state.strict && !allowExpression && !isMethod3 && !nonSimple, allowExpression, strictModeChanged);
                        if (_this.state.strict && node.id) {
                            _this.checkIdentifier(node.id, 65, strictModeChanged);
                        }
                    });
                    this.prodParam.exit();
                    this.state.labels = oldLabels;
                }
                this.expressionScope.exit();
            }
        },
        {
            key: "isSimpleParameter",
            value: function isSimpleParameter(node) {
                return node.type === "Identifier";
            }
        },
        {
            key: "isSimpleParamList",
            value: function isSimpleParamList(params) {
                for(var i = 0, len = params.length; i < len; i++){
                    if (!this.isSimpleParameter(params[i])) return false;
                }
                return true;
            }
        },
        {
            key: "checkParams",
            value: function checkParams(node, allowDuplicates, isArrowFunction) {
                var strictModeChanged = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
                var checkClashes = !allowDuplicates && /* @__PURE__ */ new Set();
                var formalParameters = {
                    type: "FormalParameters"
                };
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = node.params[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var param = _step.value;
                        this.checkLVal(param, {
                            in: formalParameters,
                            binding: 5,
                            checkClashes: checkClashes,
                            strictModeChanged: strictModeChanged
                        });
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        },
        {
            key: "parseExprList",
            value: function parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
                var elts = [];
                var first = true;
                while(!this.eat(close)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12);
                        if (this.match(close)) {
                            if (nodeForExtra) {
                                this.addTrailingCommaExtraToNode(nodeForExtra);
                            }
                            this.next();
                            break;
                        }
                    }
                    elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
                }
                return elts;
            }
        },
        {
            key: "parseExprListItem",
            value: function parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
                var elt;
                if (this.match(12)) {
                    if (!allowEmpty) {
                        this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
                            unexpected: ","
                        });
                    }
                    elt = null;
                } else if (this.match(21)) {
                    var spreadNodeStartLoc = this.state.startLoc;
                    elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartLoc);
                } else if (this.match(17)) {
                    this.expectPlugin("partialApplication");
                    if (!allowPlaceholder) {
                        this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
                    }
                    var node = this.startNode();
                    this.next();
                    elt = this.finishNode(node, "ArgumentPlaceholder");
                } else {
                    elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
                }
                return elt;
            }
        },
        {
            key: "parseIdentifier",
            value: function parseIdentifier(liberal) {
                var node = this.startNode();
                var name = this.parseIdentifierName(liberal);
                return this.createIdentifier(node, name);
            }
        },
        {
            key: "createIdentifier",
            value: function createIdentifier(node, name) {
                node.name = name;
                node.loc.identifierName = name;
                return this.finishNode(node, "Identifier");
            }
        },
        {
            key: "parseIdentifierName",
            value: function parseIdentifierName(liberal) {
                var name;
                var _this_state = this.state, startLoc = _this_state.startLoc, type = _this_state.type;
                if (tokenIsKeywordOrIdentifier(type)) {
                    name = this.state.value;
                } else {
                    this.unexpected();
                }
                var tokenIsKeyword2 = tokenKeywordOrIdentifierIsKeyword(type);
                if (liberal) {
                    if (tokenIsKeyword2) {
                        this.replaceToken(132);
                    }
                } else {
                    this.checkReservedWord(name, startLoc, tokenIsKeyword2, false);
                }
                this.next();
                return name;
            }
        },
        {
            key: "checkReservedWord",
            value: function checkReservedWord(word, startLoc, checkKeywords, isBinding3) {
                if (word.length > 10) {
                    return;
                }
                if (!canBeReservedWord(word)) {
                    return;
                }
                if (checkKeywords && isKeyword2(word)) {
                    this.raise(Errors.UnexpectedKeyword, startLoc, {
                        keyword: word
                    });
                    return;
                }
                var reservedTest = !this.state.strict ? isReservedWord2 : isBinding3 ? isStrictBindReservedWord : isStrictReservedWord2;
                if (reservedTest(word, this.inModule)) {
                    this.raise(Errors.UnexpectedReservedWord, startLoc, {
                        reservedWord: word
                    });
                    return;
                } else if (word === "yield") {
                    if (this.prodParam.hasYield) {
                        this.raise(Errors.YieldBindingIdentifier, startLoc);
                        return;
                    }
                } else if (word === "await") {
                    if (this.prodParam.hasAwait) {
                        this.raise(Errors.AwaitBindingIdentifier, startLoc);
                        return;
                    }
                    if (this.scope.inStaticBlock) {
                        this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
                        return;
                    }
                    this.expressionScope.recordAsyncArrowParametersError(startLoc);
                } else if (word === "arguments") {
                    if (this.scope.inClassAndNotInNonArrowFunction) {
                        this.raise(Errors.ArgumentsInClass, startLoc);
                        return;
                    }
                }
            }
        },
        {
            key: "isAwaitAllowed",
            value: function isAwaitAllowed() {
                if (this.prodParam.hasAwait) return true;
                if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
                    return true;
                }
                return false;
            }
        },
        {
            key: "parseAwait",
            value: function parseAwait(startLoc) {
                var node = this.startNodeAt(startLoc);
                this.expressionScope.recordParameterInitializerError(Errors.AwaitExpressionFormalParameter, node);
                if (this.eat(55)) {
                    this.raise(Errors.ObsoleteAwaitStar, node);
                }
                if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
                    if (this.isAmbiguousAwait()) {
                        this.ambiguousScriptDifferentAst = true;
                    } else {
                        this.sawUnambiguousESM = true;
                    }
                }
                if (!this.state.soloAwait) {
                    node.argument = this.parseMaybeUnary(null, true);
                }
                return this.finishNode(node, "AwaitExpression");
            }
        },
        {
            key: "isAmbiguousAwait",
            value: function isAmbiguousAwait() {
                if (this.hasPrecedingLineBreak()) return true;
                var type = this.state.type;
                return type === 53 || type === 10 || type === 0 || tokenIsTemplate(type) || type === 102 && !this.state.containsEsc || type === 137 || type === 56 || this.hasPlugin("v8intrinsic") && type === 54;
            }
        },
        {
            key: "parseYield",
            value: function parseYield() {
                var node = this.startNode();
                this.expressionScope.recordParameterInitializerError(Errors.YieldInParameter, node);
                this.next();
                var delegating = false;
                var argument = null;
                if (!this.hasPrecedingLineBreak()) {
                    delegating = this.eat(55);
                    switch(this.state.type){
                        case 13:
                        case 139:
                        case 8:
                        case 11:
                        case 3:
                        case 9:
                        case 14:
                        case 12:
                            if (!delegating) break;
                        default:
                            argument = this.parseMaybeAssign();
                    }
                }
                node.delegate = delegating;
                node.argument = argument;
                return this.finishNode(node, "YieldExpression");
            }
        },
        {
            key: "parseImportCall",
            value: function parseImportCall(node) {
                this.next();
                node.source = this.parseMaybeAssignAllowIn();
                if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
                    node.options = null;
                }
                if (this.eat(12)) {
                    this.expectImportAttributesPlugin();
                    if (!this.match(11)) {
                        node.options = this.parseMaybeAssignAllowIn();
                        this.eat(12);
                    }
                }
                this.expect(11);
                return this.finishNode(node, "ImportExpression");
            }
        },
        {
            key: "checkPipelineAtInfixOperator",
            value: function checkPipelineAtInfixOperator(left, leftStartLoc) {
                if (this.hasPlugin([
                    "pipelineOperator",
                    {
                        proposal: "smart"
                    }
                ])) {
                    if (left.type === "SequenceExpression") {
                        this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
                    }
                }
            }
        },
        {
            key: "parseSmartPipelineBodyInStyle",
            value: function parseSmartPipelineBodyInStyle(childExpr, startLoc) {
                if (this.isSimpleReference(childExpr)) {
                    var bodyNode = this.startNodeAt(startLoc);
                    bodyNode.callee = childExpr;
                    return this.finishNode(bodyNode, "PipelineBareFunction");
                } else {
                    var bodyNode1 = this.startNodeAt(startLoc);
                    this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
                    bodyNode1.expression = childExpr;
                    return this.finishNode(bodyNode1, "PipelineTopicExpression");
                }
            }
        },
        {
            key: "isSimpleReference",
            value: function isSimpleReference(expression2) {
                switch(expression2.type){
                    case "MemberExpression":
                        return !expression2.computed && this.isSimpleReference(expression2.object);
                    case "Identifier":
                        return true;
                    default:
                        return false;
                }
            }
        },
        {
            key: "checkSmartPipeTopicBodyEarlyErrors",
            value: function checkSmartPipeTopicBodyEarlyErrors(startLoc) {
                if (this.match(19)) {
                    throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
                }
                if (!this.topicReferenceWasUsedInCurrentContext()) {
                    this.raise(Errors.PipelineTopicUnused, startLoc);
                }
            }
        },
        {
            key: "withTopicBindingContext",
            value: function withTopicBindingContext(callback) {
                var outerContextTopicState = this.state.topicContext;
                this.state.topicContext = {
                    maxNumOfResolvableTopics: 1,
                    maxTopicIndex: null
                };
                try {
                    return callback();
                } finally{
                    this.state.topicContext = outerContextTopicState;
                }
            }
        },
        {
            key: "withSmartMixTopicForbiddingContext",
            value: function withSmartMixTopicForbiddingContext(callback) {
                if (this.hasPlugin([
                    "pipelineOperator",
                    {
                        proposal: "smart"
                    }
                ])) {
                    var outerContextTopicState = this.state.topicContext;
                    this.state.topicContext = {
                        maxNumOfResolvableTopics: 0,
                        maxTopicIndex: null
                    };
                    try {
                        return callback();
                    } finally{
                        this.state.topicContext = outerContextTopicState;
                    }
                } else {
                    return callback();
                }
            }
        },
        {
            key: "withSoloAwaitPermittingContext",
            value: function withSoloAwaitPermittingContext(callback) {
                var outerContextSoloAwaitState = this.state.soloAwait;
                this.state.soloAwait = true;
                try {
                    return callback();
                } finally{
                    this.state.soloAwait = outerContextSoloAwaitState;
                }
            }
        },
        {
            key: "allowInAnd",
            value: function allowInAnd(callback) {
                var flags = this.prodParam.currentFlags();
                var prodParamToSet = 8 & ~flags;
                if (prodParamToSet) {
                    this.prodParam.enter(flags | 8);
                    try {
                        return callback();
                    } finally{
                        this.prodParam.exit();
                    }
                }
                return callback();
            }
        },
        {
            key: "disallowInAnd",
            value: function disallowInAnd(callback) {
                var flags = this.prodParam.currentFlags();
                var prodParamToClear = 8 & flags;
                if (prodParamToClear) {
                    this.prodParam.enter(flags & ~8);
                    try {
                        return callback();
                    } finally{
                        this.prodParam.exit();
                    }
                }
                return callback();
            }
        },
        {
            key: "registerTopicReference",
            value: function registerTopicReference() {
                this.state.topicContext.maxTopicIndex = 0;
            }
        },
        {
            key: "topicReferenceIsAllowedInCurrentContext",
            value: function topicReferenceIsAllowedInCurrentContext() {
                return this.state.topicContext.maxNumOfResolvableTopics >= 1;
            }
        },
        {
            key: "topicReferenceWasUsedInCurrentContext",
            value: function topicReferenceWasUsedInCurrentContext() {
                return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
            }
        },
        {
            key: "parseFSharpPipelineBody",
            value: function parseFSharpPipelineBody(prec) {
                var startLoc = this.state.startLoc;
                this.state.potentialArrowAt = this.state.start;
                var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
                this.state.inFSharpPipelineDirectBody = true;
                var ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, prec);
                this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
                return ret;
            }
        },
        {
            key: "parseModuleExpression",
            value: function parseModuleExpression() {
                this.expectPlugin("moduleBlocks");
                var node = this.startNode();
                this.next();
                if (!this.match(5)) {
                    this.unexpected(null, 5);
                }
                var program3 = this.startNodeAt(this.state.endLoc);
                this.next();
                var revertScopes = this.initializeScopes(true);
                this.enterInitialScopes();
                try {
                    node.body = this.parseProgram(program3, 8, "module");
                } finally{
                    revertScopes();
                }
                return this.finishNode(node, "ModuleExpression");
            }
        },
        {
            key: "parsePropertyNamePrefixOperator",
            value: function parsePropertyNamePrefixOperator(prop) {}
        }
    ]);
    return ExpressionParser;
}(LValParser);
var loopLabel = {
    kind: 1
};
var switchLabel = {
    kind: 2
};
var loneSurrogate = RegExp("[\uD800-\uDFFF]", "u");
var keywordRelationalOperator = RegExp("in(?:stanceof)?", "y");
function babel7CompatTokens(tokens, input) {
    for(var i = 0; i < tokens.length; i++){
        var token = tokens[i];
        var type = token.type;
        if (typeof type === "number") {
            token.type = getExportedToken(type);
        }
    }
    return tokens;
}
var StatementParser = /*#__PURE__*/ function(ExpressionParser) {
    "use strict";
    _inherits(StatementParser, ExpressionParser);
    var _super = _create_super(StatementParser);
    function StatementParser() {
        _class_call_check(this, StatementParser);
        return _super.apply(this, arguments);
    }
    _create_class(StatementParser, [
        {
            key: "parseTopLevel",
            value: function parseTopLevel(file2, program3) {
                file2.program = this.parseProgram(program3);
                file2.comments = this.comments;
                if (this.options.tokens) {
                    file2.tokens = babel7CompatTokens(this.tokens, this.input);
                }
                return this.finishNode(file2, "File");
            }
        },
        {
            key: "parseProgram",
            value: function parseProgram(program3) {
                var end = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 139, sourceType = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.options.sourceType;
                program3.sourceType = sourceType;
                program3.interpreter = this.parseInterpreterDirective();
                this.parseBlockBody(program3, true, true, end);
                if (this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = Array.from(this.scope.undefinedExports)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var _step_value = _sliced_to_array(_step.value, 2), localName = _step_value[0], at = _step_value[1];
                            this.raise(Errors.ModuleExportUndefined, at, {
                                localName: localName
                            });
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                }
                var finishedProgram;
                if (end === 139) {
                    finishedProgram = this.finishNode(program3, "Program");
                } else {
                    finishedProgram = this.finishNodeAt(program3, "Program", createPositionWithColumnOffset(this.state.startLoc, -1));
                }
                return finishedProgram;
            }
        },
        {
            key: "stmtToDirective",
            value: function stmtToDirective(stmt) {
                var directive2 = stmt;
                directive2.type = "Directive";
                directive2.value = directive2.expression;
                delete directive2.expression;
                var directiveLiteral2 = directive2.value;
                var expressionValue = directiveLiteral2.value;
                var raw = this.input.slice(directiveLiteral2.start, directiveLiteral2.end);
                var val = directiveLiteral2.value = raw.slice(1, -1);
                this.addExtra(directiveLiteral2, "raw", raw);
                this.addExtra(directiveLiteral2, "rawValue", val);
                this.addExtra(directiveLiteral2, "expressionValue", expressionValue);
                directiveLiteral2.type = "DirectiveLiteral";
                return directive2;
            }
        },
        {
            key: "parseInterpreterDirective",
            value: function parseInterpreterDirective() {
                if (!this.match(28)) {
                    return null;
                }
                var node = this.startNode();
                node.value = this.state.value;
                this.next();
                return this.finishNode(node, "InterpreterDirective");
            }
        },
        {
            key: "isLet",
            value: function isLet() {
                if (!this.isContextual(100)) {
                    return false;
                }
                return this.hasFollowingBindingAtom();
            }
        },
        {
            key: "chStartsBindingIdentifier",
            value: function chStartsBindingIdentifier(ch, pos) {
                if (isIdentifierStart2(ch)) {
                    keywordRelationalOperator.lastIndex = pos;
                    if (keywordRelationalOperator.test(this.input)) {
                        var endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);
                        if (!isIdentifierChar2(endCh) && endCh !== 92) {
                            return false;
                        }
                    }
                    return true;
                } else if (ch === 92) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        {
            key: "chStartsBindingPattern",
            value: function chStartsBindingPattern(ch) {
                return ch === 91 || ch === 123;
            }
        },
        {
            key: "hasFollowingBindingAtom",
            value: function hasFollowingBindingAtom() {
                var next = this.nextTokenStart();
                var nextCh = this.codePointAtPos(next);
                return this.chStartsBindingPattern(nextCh) || this.chStartsBindingIdentifier(nextCh, next);
            }
        },
        {
            key: "hasInLineFollowingBindingIdentifier",
            value: function hasInLineFollowingBindingIdentifier() {
                var next = this.nextTokenInLineStart();
                var nextCh = this.codePointAtPos(next);
                return this.chStartsBindingIdentifier(nextCh, next);
            }
        },
        {
            key: "startsUsingForOf",
            value: function startsUsingForOf() {
                var _this_lookahead = this.lookahead(), type = _this_lookahead.type, containsEsc = _this_lookahead.containsEsc;
                if (type === 102 && !containsEsc) {
                    return false;
                } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
                    this.expectPlugin("explicitResourceManagement");
                    return true;
                }
            }
        },
        {
            key: "startsAwaitUsing",
            value: function startsAwaitUsing() {
                var next = this.nextTokenInLineStart();
                if (this.isUnparsedContextual(next, "using")) {
                    next = this.nextTokenInLineStartSince(next + 5);
                    var nextCh = this.codePointAtPos(next);
                    if (this.chStartsBindingIdentifier(nextCh, next)) {
                        this.expectPlugin("explicitResourceManagement");
                        return true;
                    }
                }
                return false;
            }
        },
        {
            key: "parseModuleItem",
            value: function parseModuleItem() {
                return this.parseStatementLike(1 | 2 | 4 | 8);
            }
        },
        {
            key: "parseStatementListItem",
            value: function parseStatementListItem() {
                return this.parseStatementLike(2 | 4 | (!this.options.annexB || this.state.strict ? 0 : 8));
            }
        },
        {
            key: "parseStatementOrSloppyAnnexBFunctionDeclaration",
            value: function parseStatementOrSloppyAnnexBFunctionDeclaration() {
                var allowLabeledFunction = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
                var flags = 0;
                if (this.options.annexB && !this.state.strict) {
                    flags |= 4;
                    if (allowLabeledFunction) {
                        flags |= 8;
                    }
                }
                return this.parseStatementLike(flags);
            }
        },
        {
            key: "parseStatement",
            value: function parseStatement() {
                return this.parseStatementLike(0);
            }
        },
        {
            key: "parseStatementLike",
            value: function parseStatementLike(flags) {
                var decorators = null;
                if (this.match(26)) {
                    decorators = this.parseDecorators(true);
                }
                return this.parseStatementContent(flags, decorators);
            }
        },
        {
            key: "parseStatementContent",
            value: function parseStatementContent(flags, decorators) {
                var starttype = this.state.type;
                var node = this.startNode();
                var allowDeclaration = !!(flags & 2);
                var allowFunctionDeclaration = !!(flags & 4);
                var topLevel = flags & 1;
                switch(starttype){
                    case 60:
                        return this.parseBreakContinueStatement(node, true);
                    case 63:
                        return this.parseBreakContinueStatement(node, false);
                    case 64:
                        return this.parseDebuggerStatement(node);
                    case 90:
                        return this.parseDoWhileStatement(node);
                    case 91:
                        return this.parseForStatement(node);
                    case 68:
                        if (this.lookaheadCharCode() === 46) break;
                        if (!allowFunctionDeclaration) {
                            this.raise(this.state.strict ? Errors.StrictFunction : this.options.annexB ? Errors.SloppyFunctionAnnexB : Errors.SloppyFunction, this.state.startLoc);
                        }
                        return this.parseFunctionStatement(node, false, !allowDeclaration && allowFunctionDeclaration);
                    case 80:
                        if (!allowDeclaration) this.unexpected();
                        return this.parseClass(this.maybeTakeDecorators(decorators, node), true);
                    case 69:
                        return this.parseIfStatement(node);
                    case 70:
                        return this.parseReturnStatement(node);
                    case 71:
                        return this.parseSwitchStatement(node);
                    case 72:
                        return this.parseThrowStatement(node);
                    case 73:
                        return this.parseTryStatement(node);
                    case 96:
                        if (!this.state.containsEsc && this.startsAwaitUsing()) {
                            if (!this.isAwaitAllowed()) {
                                this.raise(Errors.AwaitUsingNotInAsyncContext, node);
                            } else if (!allowDeclaration) {
                                this.raise(Errors.UnexpectedLexicalDeclaration, node);
                            }
                            this.next();
                            return this.parseVarStatement(node, "await using");
                        }
                        break;
                    case 107:
                        if (this.state.containsEsc || !this.hasInLineFollowingBindingIdentifier()) {
                            break;
                        }
                        this.expectPlugin("explicitResourceManagement");
                        if (!this.scope.inModule && this.scope.inTopLevel) {
                            this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
                        } else if (!allowDeclaration) {
                            this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
                        }
                        return this.parseVarStatement(node, "using");
                    case 100:
                        {
                            if (this.state.containsEsc) {
                                break;
                            }
                            var next = this.nextTokenStart();
                            var nextCh = this.codePointAtPos(next);
                            if (nextCh !== 91) {
                                if (!allowDeclaration && this.hasFollowingLineBreak()) break;
                                if (!this.chStartsBindingIdentifier(nextCh, next) && nextCh !== 123) {
                                    break;
                                }
                            }
                        }
                    case 75:
                        {
                            if (!allowDeclaration) {
                                this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
                            }
                        }
                    case 74:
                        {
                            var kind = this.state.value;
                            return this.parseVarStatement(node, kind);
                        }
                    case 92:
                        return this.parseWhileStatement(node);
                    case 76:
                        return this.parseWithStatement(node);
                    case 5:
                        return this.parseBlock();
                    case 13:
                        return this.parseEmptyStatement(node);
                    case 83:
                        {
                            var nextTokenCharCode = this.lookaheadCharCode();
                            if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
                                break;
                            }
                        }
                    case 82:
                        {
                            if (!this.options.allowImportExportEverywhere && !topLevel) {
                                this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
                            }
                            this.next();
                            var result;
                            if (starttype === 83) {
                                result = this.parseImport(node);
                                if (result.type === "ImportDeclaration" && (!result.importKind || result.importKind === "value")) {
                                    this.sawUnambiguousESM = true;
                                }
                            } else {
                                result = this.parseExport(node, decorators);
                                if (result.type === "ExportNamedDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportAllDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportDefaultDeclaration") {
                                    this.sawUnambiguousESM = true;
                                }
                            }
                            this.assertModuleNodeAllowed(result);
                            return result;
                        }
                    default:
                        {
                            if (this.isAsyncFunction()) {
                                if (!allowDeclaration) {
                                    this.raise(Errors.AsyncFunctionInSingleStatementContext, this.state.startLoc);
                                }
                                this.next();
                                return this.parseFunctionStatement(node, true, !allowDeclaration && allowFunctionDeclaration);
                            }
                        }
                }
                var maybeName = this.state.value;
                var expr = this.parseExpression();
                if (tokenIsIdentifier(starttype) && expr.type === "Identifier" && this.eat(14)) {
                    return this.parseLabeledStatement(node, maybeName, expr, flags);
                } else {
                    return this.parseExpressionStatement(node, expr, decorators);
                }
            }
        },
        {
            key: "assertModuleNodeAllowed",
            value: function assertModuleNodeAllowed(node) {
                if (!this.options.allowImportExportEverywhere && !this.inModule) {
                    this.raise(Errors.ImportOutsideModule, node);
                }
            }
        },
        {
            key: "decoratorsEnabledBeforeExport",
            value: function decoratorsEnabledBeforeExport() {
                if (this.hasPlugin("decorators-legacy")) return true;
                return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") !== false;
            }
        },
        {
            key: "maybeTakeDecorators",
            value: function maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
                if (maybeDecorators) {
                    if (classNode.decorators && classNode.decorators.length > 0) {
                        var _classNode_decorators;
                        if (typeof this.getPluginOption("decorators", "decoratorsBeforeExport") !== "boolean") {
                            this.raise(Errors.DecoratorsBeforeAfterExport, classNode.decorators[0]);
                        }
                        (_classNode_decorators = classNode.decorators).unshift.apply(_classNode_decorators, _to_consumable_array(maybeDecorators));
                    } else {
                        classNode.decorators = maybeDecorators;
                    }
                    this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
                    if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
                }
                return classNode;
            }
        },
        {
            key: "canHaveLeadingDecorator",
            value: function canHaveLeadingDecorator() {
                return this.match(80);
            }
        },
        {
            key: "parseDecorators",
            value: function parseDecorators(allowExport) {
                var decorators = [];
                do {
                    decorators.push(this.parseDecorator());
                }while (this.match(26));
                if (this.match(82)) {
                    if (!allowExport) {
                        this.unexpected();
                    }
                    if (!this.decoratorsEnabledBeforeExport()) {
                        this.raise(Errors.DecoratorExportClass, this.state.startLoc);
                    }
                } else if (!this.canHaveLeadingDecorator()) {
                    throw this.raise(Errors.UnexpectedLeadingDecorator, this.state.startLoc);
                }
                return decorators;
            }
        },
        {
            key: "parseDecorator",
            value: function parseDecorator() {
                this.expectOnePlugin([
                    "decorators",
                    "decorators-legacy"
                ]);
                var node = this.startNode();
                this.next();
                if (this.hasPlugin("decorators")) {
                    var startLoc = this.state.startLoc;
                    var expr;
                    if (this.match(10)) {
                        var startLoc2 = this.state.startLoc;
                        this.next();
                        expr = this.parseExpression();
                        this.expect(11);
                        expr = this.wrapParenthesis(startLoc2, expr);
                        var paramsStartLoc = this.state.startLoc;
                        node.expression = this.parseMaybeDecoratorArguments(expr);
                        if (this.getPluginOption("decorators", "allowCallParenthesized") === false && node.expression !== expr) {
                            this.raise(Errors.DecoratorArgumentsOutsideParentheses, paramsStartLoc);
                        }
                    } else {
                        expr = this.parseIdentifier(false);
                        while(this.eat(16)){
                            var node2 = this.startNodeAt(startLoc);
                            node2.object = expr;
                            if (this.match(138)) {
                                this.classScope.usePrivateName(this.state.value, this.state.startLoc);
                                node2.property = this.parsePrivateName();
                            } else {
                                node2.property = this.parseIdentifier(true);
                            }
                            node2.computed = false;
                            expr = this.finishNode(node2, "MemberExpression");
                        }
                        node.expression = this.parseMaybeDecoratorArguments(expr);
                    }
                } else {
                    node.expression = this.parseExprSubscripts();
                }
                return this.finishNode(node, "Decorator");
            }
        },
        {
            key: "parseMaybeDecoratorArguments",
            value: function parseMaybeDecoratorArguments(expr) {
                if (this.eat(10)) {
                    var node = this.startNodeAtNode(expr);
                    node.callee = expr;
                    node.arguments = this.parseCallExpressionArguments(11, false);
                    this.toReferencedList(node.arguments);
                    return this.finishNode(node, "CallExpression");
                }
                return expr;
            }
        },
        {
            key: "parseBreakContinueStatement",
            value: function parseBreakContinueStatement(node, isBreak) {
                this.next();
                if (this.isLineTerminator()) {
                    node.label = null;
                } else {
                    node.label = this.parseIdentifier();
                    this.semicolon();
                }
                this.verifyBreakContinue(node, isBreak);
                return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
            }
        },
        {
            key: "verifyBreakContinue",
            value: function verifyBreakContinue(node, isBreak) {
                var i;
                for(i = 0; i < this.state.labels.length; ++i){
                    var lab = this.state.labels[i];
                    if (node.label == null || lab.name === node.label.name) {
                        if (lab.kind != null && (isBreak || lab.kind === 1)) {
                            break;
                        }
                        if (node.label && isBreak) break;
                    }
                }
                if (i === this.state.labels.length) {
                    var type = isBreak ? "BreakStatement" : "ContinueStatement";
                    this.raise(Errors.IllegalBreakContinue, node, {
                        type: type
                    });
                }
            }
        },
        {
            key: "parseDebuggerStatement",
            value: function parseDebuggerStatement(node) {
                this.next();
                this.semicolon();
                return this.finishNode(node, "DebuggerStatement");
            }
        },
        {
            key: "parseHeaderExpression",
            value: function parseHeaderExpression() {
                this.expect(10);
                var val = this.parseExpression();
                this.expect(11);
                return val;
            }
        },
        {
            key: "parseDoWhileStatement",
            value: function parseDoWhileStatement(node) {
                var _this = this;
                this.next();
                this.state.labels.push(loopLabel);
                node.body = this.withSmartMixTopicForbiddingContext(function() {
                    return _this.parseStatement();
                });
                this.state.labels.pop();
                this.expect(92);
                node.test = this.parseHeaderExpression();
                this.eat(13);
                return this.finishNode(node, "DoWhileStatement");
            }
        },
        {
            key: "parseForStatement",
            value: function parseForStatement(node) {
                this.next();
                this.state.labels.push(loopLabel);
                var awaitAt = null;
                if (this.isAwaitAllowed() && this.eatContextual(96)) {
                    awaitAt = this.state.lastTokStartLoc;
                }
                this.scope.enter(0);
                this.expect(10);
                if (this.match(13)) {
                    if (awaitAt !== null) {
                        this.unexpected(awaitAt);
                    }
                    return this.parseFor(node, null);
                }
                var startsWithLet = this.isContextual(100);
                {
                    var startsWithAwaitUsing = this.isContextual(96) && this.startsAwaitUsing();
                    var starsWithUsingDeclaration = startsWithAwaitUsing || this.isContextual(107) && this.startsUsingForOf();
                    var isLetOrUsing = startsWithLet && this.hasFollowingBindingAtom() || starsWithUsingDeclaration;
                    if (this.match(74) || this.match(75) || isLetOrUsing) {
                        var initNode = this.startNode();
                        var kind;
                        if (startsWithAwaitUsing) {
                            kind = "await using";
                            if (!this.isAwaitAllowed()) {
                                this.raise(Errors.AwaitUsingNotInAsyncContext, this.state.startLoc);
                            }
                            this.next();
                        } else {
                            kind = this.state.value;
                        }
                        this.next();
                        this.parseVar(initNode, true, kind);
                        var init2 = this.finishNode(initNode, "VariableDeclaration");
                        var isForIn = this.match(58);
                        if (isForIn && starsWithUsingDeclaration) {
                            this.raise(Errors.ForInUsing, init2);
                        }
                        if ((isForIn || this.isContextual(102)) && init2.declarations.length === 1) {
                            return this.parseForIn(node, init2, awaitAt);
                        }
                        if (awaitAt !== null) {
                            this.unexpected(awaitAt);
                        }
                        return this.parseFor(node, init2);
                    }
                }
                var startsWithAsync = this.isContextual(95);
                var refExpressionErrors = new ExpressionErrors();
                var init = this.parseExpression(true, refExpressionErrors);
                var isForOf = this.isContextual(102);
                if (isForOf) {
                    if (startsWithLet) {
                        this.raise(Errors.ForOfLet, init);
                    }
                    if (awaitAt === null && startsWithAsync && init.type === "Identifier") {
                        this.raise(Errors.ForOfAsync, init);
                    }
                }
                if (isForOf || this.match(58)) {
                    this.checkDestructuringPrivate(refExpressionErrors);
                    this.toAssignable(init, true);
                    var type = isForOf ? "ForOfStatement" : "ForInStatement";
                    this.checkLVal(init, {
                        in: {
                            type: type
                        }
                    });
                    return this.parseForIn(node, init, awaitAt);
                } else {
                    this.checkExpressionErrors(refExpressionErrors, true);
                }
                if (awaitAt !== null) {
                    this.unexpected(awaitAt);
                }
                return this.parseFor(node, init);
            }
        },
        {
            key: "parseFunctionStatement",
            value: function parseFunctionStatement(node, isAsync, isHangingDeclaration) {
                this.next();
                return this.parseFunction(node, 1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0));
            }
        },
        {
            key: "parseIfStatement",
            value: function parseIfStatement(node) {
                this.next();
                node.test = this.parseHeaderExpression();
                node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
                node.alternate = this.eat(66) ? this.parseStatementOrSloppyAnnexBFunctionDeclaration() : null;
                return this.finishNode(node, "IfStatement");
            }
        },
        {
            key: "parseReturnStatement",
            value: function parseReturnStatement(node) {
                if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
                    this.raise(Errors.IllegalReturn, this.state.startLoc);
                }
                this.next();
                if (this.isLineTerminator()) {
                    node.argument = null;
                } else {
                    node.argument = this.parseExpression();
                    this.semicolon();
                }
                return this.finishNode(node, "ReturnStatement");
            }
        },
        {
            key: "parseSwitchStatement",
            value: function parseSwitchStatement(node) {
                this.next();
                node.discriminant = this.parseHeaderExpression();
                var cases = node.cases = [];
                this.expect(5);
                this.state.labels.push(switchLabel);
                this.scope.enter(0);
                var cur;
                for(var sawDefault; !this.match(8);){
                    if (this.match(61) || this.match(65)) {
                        var isCase = this.match(61);
                        if (cur) this.finishNode(cur, "SwitchCase");
                        cases.push(cur = this.startNode());
                        cur.consequent = [];
                        this.next();
                        if (isCase) {
                            cur.test = this.parseExpression();
                        } else {
                            if (sawDefault) {
                                this.raise(Errors.MultipleDefaultsInSwitch, this.state.lastTokStartLoc);
                            }
                            sawDefault = true;
                            cur.test = null;
                        }
                        this.expect(14);
                    } else {
                        if (cur) {
                            cur.consequent.push(this.parseStatementListItem());
                        } else {
                            this.unexpected();
                        }
                    }
                }
                this.scope.exit();
                if (cur) this.finishNode(cur, "SwitchCase");
                this.next();
                this.state.labels.pop();
                return this.finishNode(node, "SwitchStatement");
            }
        },
        {
            key: "parseThrowStatement",
            value: function parseThrowStatement(node) {
                this.next();
                if (this.hasPrecedingLineBreak()) {
                    this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
                }
                node.argument = this.parseExpression();
                this.semicolon();
                return this.finishNode(node, "ThrowStatement");
            }
        },
        {
            key: "parseCatchClauseParam",
            value: function parseCatchClauseParam() {
                var param = this.parseBindingAtom();
                this.scope.enter(this.options.annexB && param.type === "Identifier" ? 8 : 0);
                this.checkLVal(param, {
                    in: {
                        type: "CatchClause"
                    },
                    binding: 9
                });
                return param;
            }
        },
        {
            key: "parseTryStatement",
            value: function parseTryStatement(node) {
                var _this = this;
                this.next();
                node.block = this.parseBlock();
                node.handler = null;
                if (this.match(62)) {
                    var clause = this.startNode();
                    this.next();
                    if (this.match(10)) {
                        this.expect(10);
                        clause.param = this.parseCatchClauseParam();
                        this.expect(11);
                    } else {
                        clause.param = null;
                        this.scope.enter(0);
                    }
                    clause.body = this.withSmartMixTopicForbiddingContext(function() {
                        return _this.parseBlock(false, false);
                    });
                    this.scope.exit();
                    node.handler = this.finishNode(clause, "CatchClause");
                }
                node.finalizer = this.eat(67) ? this.parseBlock() : null;
                if (!node.handler && !node.finalizer) {
                    this.raise(Errors.NoCatchOrFinally, node);
                }
                return this.finishNode(node, "TryStatement");
            }
        },
        {
            key: "parseVarStatement",
            value: function parseVarStatement(node, kind) {
                var allowMissingInitializer = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
                this.next();
                this.parseVar(node, false, kind, allowMissingInitializer);
                this.semicolon();
                return this.finishNode(node, "VariableDeclaration");
            }
        },
        {
            key: "parseWhileStatement",
            value: function parseWhileStatement(node) {
                var _this = this;
                this.next();
                node.test = this.parseHeaderExpression();
                this.state.labels.push(loopLabel);
                node.body = this.withSmartMixTopicForbiddingContext(function() {
                    return _this.parseStatement();
                });
                this.state.labels.pop();
                return this.finishNode(node, "WhileStatement");
            }
        },
        {
            key: "parseWithStatement",
            value: function parseWithStatement(node) {
                var _this = this;
                if (this.state.strict) {
                    this.raise(Errors.StrictWith, this.state.startLoc);
                }
                this.next();
                node.object = this.parseHeaderExpression();
                node.body = this.withSmartMixTopicForbiddingContext(function() {
                    return _this.parseStatement();
                });
                return this.finishNode(node, "WithStatement");
            }
        },
        {
            key: "parseEmptyStatement",
            value: function parseEmptyStatement(node) {
                this.next();
                return this.finishNode(node, "EmptyStatement");
            }
        },
        {
            key: "parseLabeledStatement",
            value: function parseLabeledStatement(node, maybeName, expr, flags) {
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = this.state.labels[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var label = _step.value;
                        if (label.name === maybeName) {
                            this.raise(Errors.LabelRedeclaration, expr, {
                                labelName: maybeName
                            });
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                var kind = tokenIsLoop(this.state.type) ? 1 : this.match(71) ? 2 : null;
                for(var i = this.state.labels.length - 1; i >= 0; i--){
                    var label1 = this.state.labels[i];
                    if (label1.statementStart === node.start) {
                        label1.statementStart = this.state.start;
                        label1.kind = kind;
                    } else {
                        break;
                    }
                }
                this.state.labels.push({
                    name: maybeName,
                    kind: kind,
                    statementStart: this.state.start
                });
                node.body = flags & 8 ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true) : this.parseStatement();
                this.state.labels.pop();
                node.label = expr;
                return this.finishNode(node, "LabeledStatement");
            }
        },
        {
            key: "parseExpressionStatement",
            value: function parseExpressionStatement(node, expr, decorators) {
                node.expression = expr;
                this.semicolon();
                return this.finishNode(node, "ExpressionStatement");
            }
        },
        {
            key: "parseBlock",
            value: function parseBlock() {
                var allowDirectives = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, createNewLexicalScope = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, afterBlockParse = arguments.length > 2 ? arguments[2] : void 0;
                var node = this.startNode();
                if (allowDirectives) {
                    this.state.strictErrors.clear();
                }
                this.expect(5);
                if (createNewLexicalScope) {
                    this.scope.enter(0);
                }
                this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
                if (createNewLexicalScope) {
                    this.scope.exit();
                }
                return this.finishNode(node, "BlockStatement");
            }
        },
        {
            key: "isValidDirective",
            value: function isValidDirective(stmt) {
                return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
            }
        },
        {
            key: "parseBlockBody",
            value: function parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
                var body = node.body = [];
                var directives = node.directives = [];
                this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : void 0, topLevel, end, afterBlockParse);
            }
        },
        {
            key: "parseBlockOrModuleBlockBody",
            value: function parseBlockOrModuleBlockBody(body, directives, topLevel, end, afterBlockParse) {
                var oldStrict = this.state.strict;
                var hasStrictModeDirective = false;
                var parsedNonDirective = false;
                while(!this.match(end)){
                    var stmt = topLevel ? this.parseModuleItem() : this.parseStatementListItem();
                    if (directives && !parsedNonDirective) {
                        if (this.isValidDirective(stmt)) {
                            var directive2 = this.stmtToDirective(stmt);
                            directives.push(directive2);
                            if (!hasStrictModeDirective && directive2.value.value === "use strict") {
                                hasStrictModeDirective = true;
                                this.setStrict(true);
                            }
                            continue;
                        }
                        parsedNonDirective = true;
                        this.state.strictErrors.clear();
                    }
                    body.push(stmt);
                }
                afterBlockParse === null || afterBlockParse === void 0 ? void 0 : afterBlockParse.call(this, hasStrictModeDirective);
                if (!oldStrict) {
                    this.setStrict(false);
                }
                this.next();
            }
        },
        {
            key: "parseFor",
            value: function parseFor(node, init) {
                var _this = this;
                node.init = init;
                this.semicolon(false);
                node.test = this.match(13) ? null : this.parseExpression();
                this.semicolon(false);
                node.update = this.match(11) ? null : this.parseExpression();
                this.expect(11);
                node.body = this.withSmartMixTopicForbiddingContext(function() {
                    return _this.parseStatement();
                });
                this.scope.exit();
                this.state.labels.pop();
                return this.finishNode(node, "ForStatement");
            }
        },
        {
            key: "parseForIn",
            value: function parseForIn(node, init, awaitAt) {
                var _this = this;
                var isForIn = this.match(58);
                this.next();
                if (isForIn) {
                    if (awaitAt !== null) this.unexpected(awaitAt);
                } else {
                    node.await = awaitAt !== null;
                }
                if (init.type === "VariableDeclaration" && init.declarations[0].init != null && (!isForIn || !this.options.annexB || this.state.strict || init.kind !== "var" || init.declarations[0].id.type !== "Identifier")) {
                    this.raise(Errors.ForInOfLoopInitializer, init, {
                        type: isForIn ? "ForInStatement" : "ForOfStatement"
                    });
                }
                if (init.type === "AssignmentPattern") {
                    this.raise(Errors.InvalidLhs, init, {
                        ancestor: {
                            type: "ForStatement"
                        }
                    });
                }
                node.left = init;
                node.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
                this.expect(11);
                node.body = this.withSmartMixTopicForbiddingContext(function() {
                    return _this.parseStatement();
                });
                this.scope.exit();
                this.state.labels.pop();
                return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
            }
        },
        {
            key: "parseVar",
            value: function parseVar(node, isFor3, kind) {
                var allowMissingInitializer = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
                var declarations = node.declarations = [];
                node.kind = kind;
                for(;;){
                    var decl = this.startNode();
                    this.parseVarId(decl, kind);
                    decl.init = !this.eat(29) ? null : isFor3 ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
                    if (decl.init === null && !allowMissingInitializer) {
                        if (decl.id.type !== "Identifier" && !(isFor3 && (this.match(58) || this.isContextual(102)))) {
                            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
                                kind: "destructuring"
                            });
                        } else if (kind === "const" && !(this.match(58) || this.isContextual(102))) {
                            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
                                kind: "const"
                            });
                        }
                    }
                    declarations.push(this.finishNode(decl, "VariableDeclarator"));
                    if (!this.eat(12)) break;
                }
                return node;
            }
        },
        {
            key: "parseVarId",
            value: function parseVarId(decl, kind) {
                var id = this.parseBindingAtom();
                this.checkLVal(id, {
                    in: {
                        type: "VariableDeclarator"
                    },
                    binding: kind === "var" ? 5 : 8201
                });
                decl.id = id;
            }
        },
        {
            key: "parseAsyncFunctionExpression",
            value: function parseAsyncFunctionExpression(node) {
                return this.parseFunction(node, 8);
            }
        },
        {
            key: "parseFunction",
            value: function parseFunction(node) {
                var _this = this;
                var flags = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
                var hangingDeclaration = flags & 2;
                var isDeclaration3 = !!(flags & 1);
                var requireId = isDeclaration3 && !(flags & 4);
                var isAsync = !!(flags & 8);
                this.initFunction(node, isAsync);
                if (this.match(55)) {
                    if (hangingDeclaration) {
                        this.raise(Errors.GeneratorInSingleStatementContext, this.state.startLoc);
                    }
                    this.next();
                    node.generator = true;
                }
                if (isDeclaration3) {
                    node.id = this.parseFunctionId(requireId);
                }
                var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
                this.state.maybeInArrowParameters = false;
                this.scope.enter(2);
                this.prodParam.enter(functionFlags(isAsync, node.generator));
                if (!isDeclaration3) {
                    node.id = this.parseFunctionId();
                }
                this.parseFunctionParams(node, false);
                this.withSmartMixTopicForbiddingContext(function() {
                    _this.parseFunctionBodyAndFinish(node, isDeclaration3 ? "FunctionDeclaration" : "FunctionExpression");
                });
                this.prodParam.exit();
                this.scope.exit();
                if (isDeclaration3 && !hangingDeclaration) {
                    this.registerFunctionStatementId(node);
                }
                this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
                return node;
            }
        },
        {
            key: "parseFunctionId",
            value: function parseFunctionId(requireId) {
                return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
            }
        },
        {
            key: "parseFunctionParams",
            value: function parseFunctionParams(node, isConstructor) {
                this.expect(10);
                this.expressionScope.enter(newParameterDeclarationScope());
                node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
                this.expressionScope.exit();
            }
        },
        {
            key: "registerFunctionStatementId",
            value: function registerFunctionStatementId(node) {
                if (!node.id) return;
                this.scope.declareName(node.id.name, !this.options.annexB || this.state.strict || node.generator || node.async ? this.scope.treatFunctionsAsVar ? 5 : 8201 : 17, node.id.loc.start);
            }
        },
        {
            key: "parseClass",
            value: function parseClass(node, isStatement5, optionalId) {
                this.next();
                var oldStrict = this.state.strict;
                this.state.strict = true;
                this.parseClassId(node, isStatement5, optionalId);
                this.parseClassSuper(node);
                node.body = this.parseClassBody(!!node.superClass, oldStrict);
                return this.finishNode(node, isStatement5 ? "ClassDeclaration" : "ClassExpression");
            }
        },
        {
            key: "isClassProperty",
            value: function isClassProperty() {
                return this.match(29) || this.match(13) || this.match(8);
            }
        },
        {
            key: "isClassMethod",
            value: function isClassMethod() {
                return this.match(10);
            }
        },
        {
            key: "isNonstaticConstructor",
            value: function isNonstaticConstructor(method) {
                return !method.computed && !method.static && (method.key.name === "constructor" || method.key.value === "constructor");
            }
        },
        {
            key: "parseClassBody",
            value: function parseClassBody(hadSuperClass, oldStrict) {
                var _this = this;
                this.classScope.enter();
                var state = {
                    hadConstructor: false,
                    hadSuperClass: hadSuperClass
                };
                var decorators = [];
                var classBody2 = this.startNode();
                classBody2.body = [];
                this.expect(5);
                this.withSmartMixTopicForbiddingContext(function() {
                    while(!_this.match(8)){
                        if (_this.eat(13)) {
                            if (decorators.length > 0) {
                                throw _this.raise(Errors.DecoratorSemicolon, _this.state.lastTokEndLoc);
                            }
                            continue;
                        }
                        if (_this.match(26)) {
                            decorators.push(_this.parseDecorator());
                            continue;
                        }
                        var member = _this.startNode();
                        if (decorators.length) {
                            member.decorators = decorators;
                            _this.resetStartLocationFromNode(member, decorators[0]);
                            decorators = [];
                        }
                        _this.parseClassMember(classBody2, member, state);
                        if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
                            _this.raise(Errors.DecoratorConstructor, member);
                        }
                    }
                });
                this.state.strict = oldStrict;
                this.next();
                if (decorators.length) {
                    throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
                }
                this.classScope.exit();
                return this.finishNode(classBody2, "ClassBody");
            }
        },
        {
            key: "parseClassMemberFromModifier",
            value: function parseClassMemberFromModifier(classBody2, member) {
                var key = this.parseIdentifier(true);
                if (this.isClassMethod()) {
                    var method = member;
                    method.kind = "method";
                    method.computed = false;
                    method.key = key;
                    method.static = false;
                    this.pushClassMethod(classBody2, method, false, false, false, false);
                    return true;
                } else if (this.isClassProperty()) {
                    var prop = member;
                    prop.computed = false;
                    prop.key = key;
                    prop.static = false;
                    classBody2.body.push(this.parseClassProperty(prop));
                    return true;
                }
                this.resetPreviousNodeTrailingComments(key);
                return false;
            }
        },
        {
            key: "parseClassMember",
            value: function parseClassMember(classBody2, member, state) {
                var isStatic2 = this.isContextual(106);
                if (isStatic2) {
                    if (this.parseClassMemberFromModifier(classBody2, member)) {
                        return;
                    }
                    if (this.eat(5)) {
                        this.parseClassStaticBlock(classBody2, member);
                        return;
                    }
                }
                this.parseClassMemberWithIsStatic(classBody2, member, state, isStatic2);
            }
        },
        {
            key: "parseClassMemberWithIsStatic",
            value: function parseClassMemberWithIsStatic(classBody2, member, state, isStatic2) {
                var publicMethod = member;
                var privateMethod = member;
                var publicProp = member;
                var privateProp = member;
                var accessorProp = member;
                var method = publicMethod;
                var publicMember = publicMethod;
                member.static = isStatic2;
                this.parsePropertyNamePrefixOperator(member);
                if (this.eat(55)) {
                    method.kind = "method";
                    var isPrivateName3 = this.match(138);
                    this.parseClassElementName(method);
                    if (isPrivateName3) {
                        this.pushClassPrivateMethod(classBody2, privateMethod, true, false);
                        return;
                    }
                    if (this.isNonstaticConstructor(publicMethod)) {
                        this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
                    }
                    this.pushClassMethod(classBody2, publicMethod, true, false, false, false);
                    return;
                }
                var isContextual = tokenIsIdentifier(this.state.type) && !this.state.containsEsc;
                var isPrivate2 = this.match(138);
                var key = this.parseClassElementName(member);
                var maybeQuestionTokenStartLoc = this.state.startLoc;
                this.parsePostMemberNameModifiers(publicMember);
                if (this.isClassMethod()) {
                    method.kind = "method";
                    if (isPrivate2) {
                        this.pushClassPrivateMethod(classBody2, privateMethod, false, false);
                        return;
                    }
                    var isConstructor = this.isNonstaticConstructor(publicMethod);
                    var allowsDirectSuper = false;
                    if (isConstructor) {
                        publicMethod.kind = "constructor";
                        if (state.hadConstructor && !this.hasPlugin("typescript")) {
                            this.raise(Errors.DuplicateConstructor, key);
                        }
                        if (isConstructor && this.hasPlugin("typescript") && member.override) {
                            this.raise(Errors.OverrideOnConstructor, key);
                        }
                        state.hadConstructor = true;
                        allowsDirectSuper = state.hadSuperClass;
                    }
                    this.pushClassMethod(classBody2, publicMethod, false, false, isConstructor, allowsDirectSuper);
                } else if (this.isClassProperty()) {
                    if (isPrivate2) {
                        this.pushClassPrivateProperty(classBody2, privateProp);
                    } else {
                        this.pushClassProperty(classBody2, publicProp);
                    }
                } else if (isContextual && key.name === "async" && !this.isLineTerminator()) {
                    this.resetPreviousNodeTrailingComments(key);
                    var isGenerator = this.eat(55);
                    if (publicMember.optional) {
                        this.unexpected(maybeQuestionTokenStartLoc);
                    }
                    method.kind = "method";
                    var isPrivate3 = this.match(138);
                    this.parseClassElementName(method);
                    this.parsePostMemberNameModifiers(publicMember);
                    if (isPrivate3) {
                        this.pushClassPrivateMethod(classBody2, privateMethod, isGenerator, true);
                    } else {
                        if (this.isNonstaticConstructor(publicMethod)) {
                            this.raise(Errors.ConstructorIsAsync, publicMethod.key);
                        }
                        this.pushClassMethod(classBody2, publicMethod, isGenerator, true, false, false);
                    }
                } else if (isContextual && (key.name === "get" || key.name === "set") && !(this.match(55) && this.isLineTerminator())) {
                    this.resetPreviousNodeTrailingComments(key);
                    method.kind = key.name;
                    var isPrivate31 = this.match(138);
                    this.parseClassElementName(publicMethod);
                    if (isPrivate31) {
                        this.pushClassPrivateMethod(classBody2, privateMethod, false, false);
                    } else {
                        if (this.isNonstaticConstructor(publicMethod)) {
                            this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
                        }
                        this.pushClassMethod(classBody2, publicMethod, false, false, false, false);
                    }
                    this.checkGetterSetterParams(publicMethod);
                } else if (isContextual && key.name === "accessor" && !this.isLineTerminator()) {
                    this.expectPlugin("decoratorAutoAccessors");
                    this.resetPreviousNodeTrailingComments(key);
                    var isPrivate32 = this.match(138);
                    this.parseClassElementName(publicProp);
                    this.pushClassAccessorProperty(classBody2, accessorProp, isPrivate32);
                } else if (this.isLineTerminator()) {
                    if (isPrivate2) {
                        this.pushClassPrivateProperty(classBody2, privateProp);
                    } else {
                        this.pushClassProperty(classBody2, publicProp);
                    }
                } else {
                    this.unexpected();
                }
            }
        },
        {
            key: "parseClassElementName",
            value: function parseClassElementName(member) {
                var _this_state = this.state, type = _this_state.type, value1 = _this_state.value;
                if ((type === 132 || type === 133) && member.static && value1 === "prototype") {
                    this.raise(Errors.StaticPrototype, this.state.startLoc);
                }
                if (type === 138) {
                    if (value1 === "constructor") {
                        this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
                    }
                    var key = this.parsePrivateName();
                    member.key = key;
                    return key;
                }
                return this.parsePropertyName(member);
            }
        },
        {
            key: "parseClassStaticBlock",
            value: function parseClassStaticBlock(classBody2, member) {
                var _member_decorators;
                this.scope.enter(64 | 128 | 16);
                var oldLabels = this.state.labels;
                this.state.labels = [];
                this.prodParam.enter(0);
                var body = member.body = [];
                this.parseBlockOrModuleBlockBody(body, void 0, false, 8);
                this.prodParam.exit();
                this.scope.exit();
                this.state.labels = oldLabels;
                classBody2.body.push(this.finishNode(member, "StaticBlock"));
                if ((_member_decorators = member.decorators) === null || _member_decorators === void 0 ? void 0 : _member_decorators.length) {
                    this.raise(Errors.DecoratorStaticBlock, member);
                }
            }
        },
        {
            key: "pushClassProperty",
            value: function pushClassProperty(classBody2, prop) {
                if (!prop.computed && (prop.key.name === "constructor" || prop.key.value === "constructor")) {
                    this.raise(Errors.ConstructorClassField, prop.key);
                }
                classBody2.body.push(this.parseClassProperty(prop));
            }
        },
        {
            key: "pushClassPrivateProperty",
            value: function pushClassPrivateProperty(classBody2, prop) {
                var node = this.parseClassPrivateProperty(prop);
                classBody2.body.push(node);
                this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
            }
        },
        {
            key: "pushClassAccessorProperty",
            value: function pushClassAccessorProperty(classBody2, prop, isPrivate2) {
                if (!isPrivate2 && !prop.computed) {
                    var key = prop.key;
                    if (key.name === "constructor" || key.value === "constructor") {
                        this.raise(Errors.ConstructorClassField, key);
                    }
                }
                var node = this.parseClassAccessorProperty(prop);
                classBody2.body.push(node);
                if (isPrivate2) {
                    this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
                }
            }
        },
        {
            key: "pushClassMethod",
            value: function pushClassMethod(classBody2, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
                classBody2.body.push(this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true));
            }
        },
        {
            key: "pushClassPrivateMethod",
            value: function pushClassPrivateMethod(classBody2, method, isGenerator, isAsync) {
                var node = this.parseMethod(method, isGenerator, isAsync, false, false, "ClassPrivateMethod", true);
                classBody2.body.push(node);
                var kind = node.kind === "get" ? node.static ? 6 : 2 : node.kind === "set" ? node.static ? 5 : 1 : 0;
                this.declareClassPrivateMethodInScope(node, kind);
            }
        },
        {
            key: "declareClassPrivateMethodInScope",
            value: function declareClassPrivateMethodInScope(node, kind) {
                this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), kind, node.key.loc.start);
            }
        },
        {
            key: "parsePostMemberNameModifiers",
            value: function parsePostMemberNameModifiers(methodOrProp) {}
        },
        {
            key: "parseClassPrivateProperty",
            value: function parseClassPrivateProperty(node) {
                this.parseInitializer(node);
                this.semicolon();
                return this.finishNode(node, "ClassPrivateProperty");
            }
        },
        {
            key: "parseClassProperty",
            value: function parseClassProperty(node) {
                this.parseInitializer(node);
                this.semicolon();
                return this.finishNode(node, "ClassProperty");
            }
        },
        {
            key: "parseClassAccessorProperty",
            value: function parseClassAccessorProperty(node) {
                this.parseInitializer(node);
                this.semicolon();
                return this.finishNode(node, "ClassAccessorProperty");
            }
        },
        {
            key: "parseInitializer",
            value: function parseInitializer(node) {
                this.scope.enter(64 | 16);
                this.expressionScope.enter(newExpressionScope());
                this.prodParam.enter(0);
                node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
                this.expressionScope.exit();
                this.prodParam.exit();
                this.scope.exit();
            }
        },
        {
            key: "parseClassId",
            value: function parseClassId(node, isStatement5, optionalId) {
                var bindingType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 8331;
                if (tokenIsIdentifier(this.state.type)) {
                    node.id = this.parseIdentifier();
                    if (isStatement5) {
                        this.declareNameFromIdentifier(node.id, bindingType);
                    }
                } else {
                    if (optionalId || !isStatement5) {
                        node.id = null;
                    } else {
                        throw this.raise(Errors.MissingClassName, this.state.startLoc);
                    }
                }
            }
        },
        {
            key: "parseClassSuper",
            value: function parseClassSuper(node) {
                node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
            }
        },
        {
            key: "parseExport",
            value: function parseExport(node, decorators) {
                var maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
                var hasDefault = this.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
                var parseAfterDefault = !hasDefault || this.eat(12);
                var hasStar = parseAfterDefault && this.eatExportStar(node);
                var hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node);
                var parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
                var isFromRequired = hasDefault || hasStar;
                if (hasStar && !hasNamespace) {
                    if (hasDefault) this.unexpected();
                    if (decorators) {
                        throw this.raise(Errors.UnsupportedDecoratorExport, node);
                    }
                    this.parseExportFrom(node, true);
                    return this.finishNode(node, "ExportAllDeclaration");
                }
                var hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
                if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
                    this.unexpected(null, 5);
                }
                if (hasNamespace && parseAfterNamespace) {
                    this.unexpected(null, 98);
                }
                var hasDeclaration;
                if (isFromRequired || hasSpecifiers) {
                    hasDeclaration = false;
                    if (decorators) {
                        throw this.raise(Errors.UnsupportedDecoratorExport, node);
                    }
                    this.parseExportFrom(node, isFromRequired);
                } else {
                    hasDeclaration = this.maybeParseExportDeclaration(node);
                }
                if (isFromRequired || hasSpecifiers || hasDeclaration) {
                    var _node2_declaration;
                    var node2 = node;
                    this.checkExport(node2, true, false, !!node2.source);
                    if (((_node2_declaration = node2.declaration) === null || _node2_declaration === void 0 ? void 0 : _node2_declaration.type) === "ClassDeclaration") {
                        this.maybeTakeDecorators(decorators, node2.declaration, node2);
                    } else if (decorators) {
                        throw this.raise(Errors.UnsupportedDecoratorExport, node);
                    }
                    return this.finishNode(node2, "ExportNamedDeclaration");
                }
                if (this.eat(65)) {
                    var node21 = node;
                    var decl = this.parseExportDefaultExpression();
                    node21.declaration = decl;
                    if (decl.type === "ClassDeclaration") {
                        this.maybeTakeDecorators(decorators, decl, node21);
                    } else if (decorators) {
                        throw this.raise(Errors.UnsupportedDecoratorExport, node);
                    }
                    this.checkExport(node21, true, true);
                    return this.finishNode(node21, "ExportDefaultDeclaration");
                }
                this.unexpected(null, 5);
            }
        },
        {
            key: "eatExportStar",
            value: function eatExportStar(node) {
                return this.eat(55);
            }
        },
        {
            key: "maybeParseExportDefaultSpecifier",
            value: function maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
                if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
                    this.expectPlugin("exportDefaultFrom", maybeDefaultIdentifier === null || maybeDefaultIdentifier === void 0 ? void 0 : maybeDefaultIdentifier.loc.start);
                    var id = maybeDefaultIdentifier || this.parseIdentifier(true);
                    var specifier = this.startNodeAtNode(id);
                    specifier.exported = id;
                    node.specifiers = [
                        this.finishNode(specifier, "ExportDefaultSpecifier")
                    ];
                    return true;
                }
                return false;
            }
        },
        {
            key: "maybeParseExportNamespaceSpecifier",
            value: function maybeParseExportNamespaceSpecifier(node) {
                if (this.isContextual(93)) {
                    if (!node.specifiers) node.specifiers = [];
                    var specifier = this.startNodeAt(this.state.lastTokStartLoc);
                    this.next();
                    specifier.exported = this.parseModuleExportName();
                    node.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
                    return true;
                }
                return false;
            }
        },
        {
            key: "maybeParseExportNamedSpecifiers",
            value: function maybeParseExportNamedSpecifiers(node) {
                if (this.match(5)) {
                    var _node_specifiers;
                    if (!node.specifiers) node.specifiers = [];
                    var isTypeExport = node.exportKind === "type";
                    (_node_specifiers = node.specifiers).push.apply(_node_specifiers, _to_consumable_array(this.parseExportSpecifiers(isTypeExport)));
                    node.source = null;
                    node.declaration = null;
                    if (this.hasPlugin("importAssertions")) {
                        node.assertions = [];
                    }
                    return true;
                }
                return false;
            }
        },
        {
            key: "maybeParseExportDeclaration",
            value: function maybeParseExportDeclaration(node) {
                if (this.shouldParseExportDeclaration()) {
                    node.specifiers = [];
                    node.source = null;
                    if (this.hasPlugin("importAssertions")) {
                        node.assertions = [];
                    }
                    node.declaration = this.parseExportDeclaration(node);
                    return true;
                }
                return false;
            }
        },
        {
            key: "isAsyncFunction",
            value: function isAsyncFunction() {
                if (!this.isContextual(95)) return false;
                var next = this.nextTokenInLineStart();
                return this.isUnparsedContextual(next, "function");
            }
        },
        {
            key: "parseExportDefaultExpression",
            value: function parseExportDefaultExpression() {
                var expr = this.startNode();
                if (this.match(68)) {
                    this.next();
                    return this.parseFunction(expr, 1 | 4);
                } else if (this.isAsyncFunction()) {
                    this.next();
                    this.next();
                    return this.parseFunction(expr, 1 | 4 | 8);
                }
                if (this.match(80)) {
                    return this.parseClass(expr, true, true);
                }
                if (this.match(26)) {
                    if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
                        this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
                    }
                    return this.parseClass(this.maybeTakeDecorators(this.parseDecorators(false), this.startNode()), true, true);
                }
                if (this.match(75) || this.match(74) || this.isLet()) {
                    throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
                }
                var res = this.parseMaybeAssignAllowIn();
                this.semicolon();
                return res;
            }
        },
        {
            key: "parseExportDeclaration",
            value: function parseExportDeclaration(node) {
                if (this.match(80)) {
                    var node2 = this.parseClass(this.startNode(), true, false);
                    return node2;
                }
                return this.parseStatementListItem();
            }
        },
        {
            key: "isExportDefaultSpecifier",
            value: function isExportDefaultSpecifier() {
                var type = this.state.type;
                if (tokenIsIdentifier(type)) {
                    if (type === 95 && !this.state.containsEsc || type === 100) {
                        return false;
                    }
                    if ((type === 130 || type === 129) && !this.state.containsEsc) {
                        var _this_lookahead = this.lookahead(), nextType = _this_lookahead.type;
                        if (tokenIsIdentifier(nextType) && nextType !== 98 || nextType === 5) {
                            this.expectOnePlugin([
                                "flow",
                                "typescript"
                            ]);
                            return false;
                        }
                    }
                } else if (!this.match(65)) {
                    return false;
                }
                var next = this.nextTokenStart();
                var hasFrom = this.isUnparsedContextual(next, "from");
                if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
                    return true;
                }
                if (this.match(65) && hasFrom) {
                    var nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
                    return nextAfterFrom === 34 || nextAfterFrom === 39;
                }
                return false;
            }
        },
        {
            key: "parseExportFrom",
            value: function parseExportFrom(node, expect) {
                if (this.eatContextual(98)) {
                    node.source = this.parseImportSource();
                    this.checkExport(node);
                    this.maybeParseImportAttributes(node);
                    this.checkJSONModuleImport(node);
                } else if (expect) {
                    this.unexpected();
                }
                this.semicolon();
            }
        },
        {
            key: "shouldParseExportDeclaration",
            value: function shouldParseExportDeclaration() {
                var type = this.state.type;
                if (type === 26) {
                    this.expectOnePlugin([
                        "decorators",
                        "decorators-legacy"
                    ]);
                    if (this.hasPlugin("decorators")) {
                        if (this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
                            this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
                        }
                        return true;
                    }
                }
                return type === 74 || type === 75 || type === 68 || type === 80 || this.isLet() || this.isAsyncFunction();
            }
        },
        {
            key: "checkExport",
            value: function checkExport(node, checkNames, isDefault, isFrom) {
                if (checkNames) {
                    var _node_specifiers;
                    if (isDefault) {
                        this.checkDuplicateExports(node, "default");
                        if (this.hasPlugin("exportDefaultFrom")) {
                            var _declaration_extra;
                            var declaration = node.declaration;
                            if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !((_declaration_extra = declaration.extra) === null || _declaration_extra === void 0 ? void 0 : _declaration_extra.parenthesized)) {
                                this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
                            }
                        }
                    } else if ((_node_specifiers = node.specifiers) === null || _node_specifiers === void 0 ? void 0 : _node_specifiers.length) {
                        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                        try {
                            for(var _iterator = node.specifiers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                var specifier = _step.value;
                                var exported = specifier.exported;
                                var exportName = exported.type === "Identifier" ? exported.name : exported.value;
                                this.checkDuplicateExports(specifier, exportName);
                                if (!isFrom && specifier.local) {
                                    var local = specifier.local;
                                    if (local.type !== "Identifier") {
                                        this.raise(Errors.ExportBindingIsString, specifier, {
                                            localName: local.value,
                                            exportName: exportName
                                        });
                                    } else {
                                        this.checkReservedWord(local.name, local.loc.start, true, false);
                                        this.scope.checkLocalExport(local);
                                    }
                                }
                            }
                        } catch (err) {
                            _didIteratorError = true;
                            _iteratorError = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion && _iterator.return != null) {
                                    _iterator.return();
                                }
                            } finally{
                                if (_didIteratorError) {
                                    throw _iteratorError;
                                }
                            }
                        }
                    } else if (node.declaration) {
                        if (node.declaration.type === "FunctionDeclaration" || node.declaration.type === "ClassDeclaration") {
                            var id = node.declaration.id;
                            if (!id) throw new Error("Assertion failure");
                            this.checkDuplicateExports(node, id.name);
                        } else if (node.declaration.type === "VariableDeclaration") {
                            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                            try {
                                for(var _iterator1 = node.declaration.declarations[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                    var declaration1 = _step1.value;
                                    this.checkDeclaration(declaration1.id);
                                }
                            } catch (err) {
                                _didIteratorError1 = true;
                                _iteratorError1 = err;
                            } finally{
                                try {
                                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                        _iterator1.return();
                                    }
                                } finally{
                                    if (_didIteratorError1) {
                                        throw _iteratorError1;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },
        {
            key: "checkDeclaration",
            value: function checkDeclaration(node) {
                if (node.type === "Identifier") {
                    this.checkDuplicateExports(node, node.name);
                } else if (node.type === "ObjectPattern") {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = node.properties[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var prop = _step.value;
                            this.checkDeclaration(prop);
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                } else if (node.type === "ArrayPattern") {
                    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                    try {
                        for(var _iterator1 = node.elements[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                            var elem = _step1.value;
                            if (elem) {
                                this.checkDeclaration(elem);
                            }
                        }
                    } catch (err) {
                        _didIteratorError1 = true;
                        _iteratorError1 = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                _iterator1.return();
                            }
                        } finally{
                            if (_didIteratorError1) {
                                throw _iteratorError1;
                            }
                        }
                    }
                } else if (node.type === "ObjectProperty") {
                    this.checkDeclaration(node.value);
                } else if (node.type === "RestElement") {
                    this.checkDeclaration(node.argument);
                } else if (node.type === "AssignmentPattern") {
                    this.checkDeclaration(node.left);
                }
            }
        },
        {
            key: "checkDuplicateExports",
            value: function checkDuplicateExports(node, exportName) {
                if (this.exportedIdentifiers.has(exportName)) {
                    if (exportName === "default") {
                        this.raise(Errors.DuplicateDefaultExport, node);
                    } else {
                        this.raise(Errors.DuplicateExport, node, {
                            exportName: exportName
                        });
                    }
                }
                this.exportedIdentifiers.add(exportName);
            }
        },
        {
            key: "parseExportSpecifiers",
            value: function parseExportSpecifiers(isInTypeExport) {
                var nodes2 = [];
                var first = true;
                this.expect(5);
                while(!this.eat(8)){
                    if (first) {
                        first = false;
                    } else {
                        this.expect(12);
                        if (this.eat(8)) break;
                    }
                    var isMaybeTypeOnly = this.isContextual(130);
                    var isString = this.match(133);
                    var node = this.startNode();
                    node.local = this.parseModuleExportName();
                    nodes2.push(this.parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly));
                }
                return nodes2;
            }
        },
        {
            key: "parseExportSpecifier",
            value: function parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
                if (this.eatContextual(93)) {
                    node.exported = this.parseModuleExportName();
                } else if (isString) {
                    node.exported = cloneStringLiteral(node.local);
                } else if (!node.exported) {
                    node.exported = cloneIdentifier(node.local);
                }
                return this.finishNode(node, "ExportSpecifier");
            }
        },
        {
            key: "parseModuleExportName",
            value: function parseModuleExportName() {
                if (this.match(133)) {
                    var result = this.parseStringLiteral(this.state.value);
                    var surrogate = result.value.match(loneSurrogate);
                    if (surrogate) {
                        this.raise(Errors.ModuleExportNameHasLoneSurrogate, result, {
                            surrogateCharCode: surrogate[0].charCodeAt(0)
                        });
                    }
                    return result;
                }
                return this.parseIdentifier(true);
            }
        },
        {
            key: "isJSONModuleImport",
            value: function isJSONModuleImport(node) {
                if (node.assertions != null) {
                    return node.assertions.some(function(param) {
                        var key = param.key, value1 = param.value;
                        return value1.value === "json" && (key.type === "Identifier" ? key.name === "type" : key.value === "type");
                    });
                }
                return false;
            }
        },
        {
            key: "checkImportReflection",
            value: function checkImportReflection(node) {
                var specifiers = node.specifiers;
                var singleBindingType = specifiers.length === 1 ? specifiers[0].type : null;
                if (node.phase === "source") {
                    if (singleBindingType !== "ImportDefaultSpecifier") {
                        this.raise(Errors.SourcePhaseImportRequiresDefault, specifiers[0].loc.start);
                    }
                } else if (node.phase === "defer") {
                    if (singleBindingType !== "ImportNamespaceSpecifier") {
                        this.raise(Errors.DeferImportRequiresNamespace, specifiers[0].loc.start);
                    }
                } else if (node.module) {
                    var _node_assertions;
                    if (singleBindingType !== "ImportDefaultSpecifier") {
                        this.raise(Errors.ImportReflectionNotBinding, specifiers[0].loc.start);
                    }
                    if (((_node_assertions = node.assertions) === null || _node_assertions === void 0 ? void 0 : _node_assertions.length) > 0) {
                        this.raise(Errors.ImportReflectionHasAssertion, specifiers[0].loc.start);
                    }
                }
            }
        },
        {
            key: "checkJSONModuleImport",
            value: function checkJSONModuleImport(node) {
                if (this.isJSONModuleImport(node) && node.type !== "ExportAllDeclaration") {
                    var specifiers = node.specifiers;
                    if (specifiers != null) {
                        var nonDefaultNamedSpecifier = specifiers.find(function(specifier) {
                            var imported;
                            if (specifier.type === "ExportSpecifier") {
                                imported = specifier.local;
                            } else if (specifier.type === "ImportSpecifier") {
                                imported = specifier.imported;
                            }
                            if (imported !== void 0) {
                                return imported.type === "Identifier" ? imported.name !== "default" : imported.value !== "default";
                            }
                        });
                        if (nonDefaultNamedSpecifier !== void 0) {
                            this.raise(Errors.ImportJSONBindingNotDefault, nonDefaultNamedSpecifier.loc.start);
                        }
                    }
                }
            }
        },
        {
            key: "isPotentialImportPhase",
            value: function isPotentialImportPhase(isExport) {
                if (isExport) return false;
                return this.isContextual(105) || this.isContextual(97) || this.isContextual(127);
            }
        },
        {
            key: "applyImportPhase",
            value: function applyImportPhase(node, isExport, phase, loc) {
                if (isExport) {
                    return;
                }
                if (phase === "module") {
                    this.expectPlugin("importReflection", loc);
                    node.module = true;
                } else if (this.hasPlugin("importReflection")) {
                    node.module = false;
                }
                if (phase === "source") {
                    this.expectPlugin("sourcePhaseImports", loc);
                    node.phase = "source";
                } else if (phase === "defer") {
                    this.expectPlugin("deferredImportEvaluation", loc);
                    node.phase = "defer";
                } else if (this.hasPlugin("sourcePhaseImports")) {
                    node.phase = null;
                }
            }
        },
        {
            key: "parseMaybeImportPhase",
            value: function parseMaybeImportPhase(node, isExport) {
                if (!this.isPotentialImportPhase(isExport)) {
                    this.applyImportPhase(node, isExport, null);
                    return null;
                }
                var phaseIdentifier = this.parseIdentifier(true);
                var type = this.state.type;
                var isImportPhase = tokenIsKeywordOrIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
                if (isImportPhase) {
                    this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
                    this.applyImportPhase(node, isExport, phaseIdentifier.name, phaseIdentifier.loc.start);
                    return null;
                } else {
                    this.applyImportPhase(node, isExport, null);
                    return phaseIdentifier;
                }
            }
        },
        {
            key: "isPrecedingIdImportPhase",
            value: function isPrecedingIdImportPhase(phase) {
                var type = this.state.type;
                return tokenIsIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
            }
        },
        {
            key: "parseImport",
            value: function parseImport(node) {
                if (this.match(133)) {
                    return this.parseImportSourceAndAttributes(node);
                }
                return this.parseImportSpecifiersAndAfter(node, this.parseMaybeImportPhase(node, false));
            }
        },
        {
            key: "parseImportSpecifiersAndAfter",
            value: function parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
                node.specifiers = [];
                var hasDefault = this.maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier);
                var parseNext = !hasDefault || this.eat(12);
                var hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
                if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
                this.expectContextual(98);
                return this.parseImportSourceAndAttributes(node);
            }
        },
        {
            key: "parseImportSourceAndAttributes",
            value: function parseImportSourceAndAttributes(node) {
                var _node_specifiers;
                (_node_specifiers = node.specifiers) !== null && _node_specifiers !== void 0 ? _node_specifiers : node.specifiers = [];
                node.source = this.parseImportSource();
                this.maybeParseImportAttributes(node);
                this.checkImportReflection(node);
                this.checkJSONModuleImport(node);
                this.semicolon();
                return this.finishNode(node, "ImportDeclaration");
            }
        },
        {
            key: "parseImportSource",
            value: function parseImportSource() {
                if (!this.match(133)) this.unexpected();
                return this.parseExprAtom();
            }
        },
        {
            key: "parseImportSpecifierLocal",
            value: function parseImportSpecifierLocal(node, specifier, type) {
                specifier.local = this.parseIdentifier();
                node.specifiers.push(this.finishImportSpecifier(specifier, type));
            }
        },
        {
            key: "finishImportSpecifier",
            value: function finishImportSpecifier(specifier, type) {
                var bindingType = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 8201;
                this.checkLVal(specifier.local, {
                    in: {
                        type: type
                    },
                    binding: bindingType
                });
                return this.finishNode(specifier, type);
            }
        },
        {
            key: "parseImportAttributes",
            value: function parseImportAttributes() {
                this.expect(5);
                var attrs = [];
                var attrNames = /* @__PURE__ */ new Set();
                do {
                    if (this.match(8)) {
                        break;
                    }
                    var node = this.startNode();
                    var keyName = this.state.value;
                    if (attrNames.has(keyName)) {
                        this.raise(Errors.ModuleAttributesWithDuplicateKeys, this.state.startLoc, {
                            key: keyName
                        });
                    }
                    attrNames.add(keyName);
                    if (this.match(133)) {
                        node.key = this.parseStringLiteral(keyName);
                    } else {
                        node.key = this.parseIdentifier(true);
                    }
                    this.expect(14);
                    if (!this.match(133)) {
                        throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
                    }
                    node.value = this.parseStringLiteral(this.state.value);
                    attrs.push(this.finishNode(node, "ImportAttribute"));
                }while (this.eat(12));
                this.expect(8);
                return attrs;
            }
        },
        {
            key: "parseModuleAttributes",
            value: function parseModuleAttributes() {
                var attrs = [];
                var attributes = /* @__PURE__ */ new Set();
                do {
                    var node = this.startNode();
                    node.key = this.parseIdentifier(true);
                    if (node.key.name !== "type") {
                        this.raise(Errors.ModuleAttributeDifferentFromType, node.key);
                    }
                    if (attributes.has(node.key.name)) {
                        this.raise(Errors.ModuleAttributesWithDuplicateKeys, node.key, {
                            key: node.key.name
                        });
                    }
                    attributes.add(node.key.name);
                    this.expect(14);
                    if (!this.match(133)) {
                        throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
                    }
                    node.value = this.parseStringLiteral(this.state.value);
                    attrs.push(this.finishNode(node, "ImportAttribute"));
                }while (this.eat(12));
                return attrs;
            }
        },
        {
            key: "maybeParseImportAttributes",
            value: function maybeParseImportAttributes(node) {
                var attributes;
                var useWith = false;
                if (this.match(76)) {
                    if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
                        return;
                    }
                    this.next();
                    {
                        this.expectImportAttributesPlugin();
                        attributes = this.parseImportAttributes();
                    }
                    useWith = true;
                } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
                    if (this.hasPlugin("importAttributes")) {
                        if (this.getPluginOption("importAttributes", "deprecatedAssertSyntax") !== true) {
                            this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
                        }
                        this.addExtra(node, "deprecatedAssertSyntax", true);
                    } else {
                        this.expectOnePlugin([
                            "importAttributes",
                            "importAssertions"
                        ]);
                    }
                    this.next();
                    attributes = this.parseImportAttributes();
                } else if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
                    attributes = [];
                } else return;
                if (!useWith && this.hasPlugin("importAssertions")) {
                    node.assertions = attributes;
                } else {
                    node.attributes = attributes;
                }
            }
        },
        {
            key: "maybeParseDefaultImportSpecifier",
            value: function maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
                if (maybeDefaultIdentifier) {
                    var specifier = this.startNodeAtNode(maybeDefaultIdentifier);
                    specifier.local = maybeDefaultIdentifier;
                    node.specifiers.push(this.finishImportSpecifier(specifier, "ImportDefaultSpecifier"));
                    return true;
                } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
                    this.parseImportSpecifierLocal(node, this.startNode(), "ImportDefaultSpecifier");
                    return true;
                }
                return false;
            }
        },
        {
            key: "maybeParseStarImportSpecifier",
            value: function maybeParseStarImportSpecifier(node) {
                if (this.match(55)) {
                    var specifier = this.startNode();
                    this.next();
                    this.expectContextual(93);
                    this.parseImportSpecifierLocal(node, specifier, "ImportNamespaceSpecifier");
                    return true;
                }
                return false;
            }
        },
        {
            key: "parseNamedImportSpecifiers",
            value: function parseNamedImportSpecifiers(node) {
                var first = true;
                this.expect(5);
                while(!this.eat(8)){
                    if (first) {
                        first = false;
                    } else {
                        if (this.eat(14)) {
                            throw this.raise(Errors.DestructureNamedImport, this.state.startLoc);
                        }
                        this.expect(12);
                        if (this.eat(8)) break;
                    }
                    var specifier = this.startNode();
                    var importedIsString = this.match(133);
                    var isMaybeTypeOnly = this.isContextual(130);
                    specifier.imported = this.parseModuleExportName();
                    var importSpecifier2 = this.parseImportSpecifier(specifier, importedIsString, node.importKind === "type" || node.importKind === "typeof", isMaybeTypeOnly, void 0);
                    node.specifiers.push(importSpecifier2);
                }
            }
        },
        {
            key: "parseImportSpecifier",
            value: function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
                if (this.eatContextual(93)) {
                    specifier.local = this.parseIdentifier();
                } else {
                    var imported = specifier.imported;
                    if (importedIsString) {
                        throw this.raise(Errors.ImportBindingIsString, specifier, {
                            importName: imported.value
                        });
                    }
                    this.checkReservedWord(imported.name, specifier.loc.start, true, true);
                    if (!specifier.local) {
                        specifier.local = cloneIdentifier(imported);
                    }
                }
                return this.finishImportSpecifier(specifier, "ImportSpecifier", bindingType);
            }
        },
        {
            key: "isThisParam",
            value: function isThisParam(param) {
                return param.type === "Identifier" && param.name === "this";
            }
        }
    ]);
    return StatementParser;
}(ExpressionParser);
var Parser = /*#__PURE__*/ function(StatementParser) {
    "use strict";
    _inherits(Parser, StatementParser);
    var _super = _create_super(Parser);
    function Parser(options, input) {
        _class_call_check(this, Parser);
        var _this;
        options = getOptions(options);
        _this = _super.call(this, options, input);
        _this.options = options;
        _this.initializeScopes();
        _this.plugins = pluginsMap(_this.options.plugins);
        _this.filename = options.sourceFilename;
        return _this;
    }
    _create_class(Parser, [
        {
            key: "getScopeHandler",
            value: function getScopeHandler() {
                return ScopeHandler;
            }
        },
        {
            key: "parse",
            value: function parse() {
                this.enterInitialScopes();
                var file2 = this.startNode();
                var program3 = this.startNode();
                this.nextToken();
                file2.errors = null;
                this.parseTopLevel(file2, program3);
                file2.errors = this.state.errors;
                file2.comments.length = this.state.commentsLen;
                return file2;
            }
        }
    ]);
    return Parser;
}(StatementParser);
function pluginsMap(plugins) {
    var pluginMap = /* @__PURE__ */ new Map();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = plugins[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var plugin = _step.value;
            var _ref = _sliced_to_array(Array.isArray(plugin) ? plugin : [
                plugin,
                {}
            ], 2), name = _ref[0], options = _ref[1];
            if (!pluginMap.has(name)) pluginMap.set(name, options || {});
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return pluginMap;
}
function parse(input, options) {
    if ((options === null || options === void 0 ? void 0 : options.sourceType) === "unambiguous") {
        options = Object.assign({}, options);
        try {
            options.sourceType = "module";
            var parser = getParser(options, input);
            var ast = parser.parse();
            if (parser.sawUnambiguousESM) {
                return ast;
            }
            if (parser.ambiguousScriptDifferentAst) {
                try {
                    options.sourceType = "script";
                    return getParser(options, input).parse();
                } catch (e) {}
            } else {
                ast.program.sourceType = "script";
            }
            return ast;
        } catch (moduleError) {
            try {
                options.sourceType = "script";
                return getParser(options, input).parse();
            } catch (e) {}
            throw moduleError;
        }
    } else {
        return getParser(options, input).parse();
    }
}
function parseExpression(input, options) {
    var parser = getParser(options, input);
    if (parser.options.strictMode) {
        parser.state.strict = true;
    }
    return parser.getExpression();
}
function generateExportedTokenTypes(internalTokenTypes) {
    var tokenTypes2 = {};
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(internalTokenTypes)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var typeName = _step.value;
            tokenTypes2[typeName] = getExportedToken(internalTokenTypes[typeName]);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return tokenTypes2;
}
var tokTypes = generateExportedTokenTypes(tt);
function getParser(options, input) {
    var cls = Parser;
    if (options === null || options === void 0 ? void 0 : options.plugins) {
        validatePlugins(options.plugins);
        cls = getParserClass(options.plugins);
    }
    return new cls(options, input);
}
var parserClassCache = {};
function getParserClass(pluginsFromOptions) {
    var pluginList = mixinPluginNames.filter(function(name) {
        return hasPlugin(pluginsFromOptions, name);
    });
    var key = pluginList.join("/");
    var cls = parserClassCache[key];
    if (!cls) {
        cls = Parser;
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = pluginList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var plugin = _step.value;
                cls = mixinPlugins[plugin](cls);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        parserClassCache[key] = cls;
    }
    return cls;
}
// node_modules/@babel/highlight/lib/index.js
var import_js_tokens = __toESM(require_js_tokens(), 1);
// node_modules/@babel/highlight/node_modules/chalk/source/vendor/ansi-styles/index.js
var ANSI_BACKGROUND_OFFSET = 10;
var wrapAnsi16 = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(code2) {
        return "\x1b[".concat(code2 + offset, "m");
    };
};
var wrapAnsi256 = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(code2) {
        return "\x1b[".concat(38 + offset, ";5;").concat(code2, "m");
    };
};
var wrapAnsi16m = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(red, green, blue) {
        return "\x1b[".concat(38 + offset, ";2;").concat(red, ";").concat(green, ";").concat(blue, "m");
    };
};
var styles = {
    modifier: {
        reset: [
            0,
            0
        ],
        // 21 isn't widely supported and 22 does the same thing
        bold: [
            1,
            22
        ],
        dim: [
            2,
            22
        ],
        italic: [
            3,
            23
        ],
        underline: [
            4,
            24
        ],
        overline: [
            53,
            55
        ],
        inverse: [
            7,
            27
        ],
        hidden: [
            8,
            28
        ],
        strikethrough: [
            9,
            29
        ]
    },
    color: {
        black: [
            30,
            39
        ],
        red: [
            31,
            39
        ],
        green: [
            32,
            39
        ],
        yellow: [
            33,
            39
        ],
        blue: [
            34,
            39
        ],
        magenta: [
            35,
            39
        ],
        cyan: [
            36,
            39
        ],
        white: [
            37,
            39
        ],
        // Bright color
        blackBright: [
            90,
            39
        ],
        gray: [
            90,
            39
        ],
        // Alias of `blackBright`
        grey: [
            90,
            39
        ],
        // Alias of `blackBright`
        redBright: [
            91,
            39
        ],
        greenBright: [
            92,
            39
        ],
        yellowBright: [
            93,
            39
        ],
        blueBright: [
            94,
            39
        ],
        magentaBright: [
            95,
            39
        ],
        cyanBright: [
            96,
            39
        ],
        whiteBright: [
            97,
            39
        ]
    },
    bgColor: {
        bgBlack: [
            40,
            49
        ],
        bgRed: [
            41,
            49
        ],
        bgGreen: [
            42,
            49
        ],
        bgYellow: [
            43,
            49
        ],
        bgBlue: [
            44,
            49
        ],
        bgMagenta: [
            45,
            49
        ],
        bgCyan: [
            46,
            49
        ],
        bgWhite: [
            47,
            49
        ],
        // Bright color
        bgBlackBright: [
            100,
            49
        ],
        bgGray: [
            100,
            49
        ],
        // Alias of `bgBlackBright`
        bgGrey: [
            100,
            49
        ],
        // Alias of `bgBlackBright`
        bgRedBright: [
            101,
            49
        ],
        bgGreenBright: [
            102,
            49
        ],
        bgYellowBright: [
            103,
            49
        ],
        bgBlueBright: [
            104,
            49
        ],
        bgMagentaBright: [
            105,
            49
        ],
        bgCyanBright: [
            106,
            49
        ],
        bgWhiteBright: [
            107,
            49
        ]
    }
};
var modifierNames = Object.keys(styles.modifier);
var foregroundColorNames = Object.keys(styles.color);
var backgroundColorNames = Object.keys(styles.bgColor);
var colorNames = _to_consumable_array(foregroundColorNames).concat(_to_consumable_array(backgroundColorNames));
function assembleStyles() {
    var _styles;
    var codes = /* @__PURE__ */ new Map();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.entries(styles)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var _step_value = _sliced_to_array(_step.value, 2), groupName = _step_value[0], group = _step_value[1];
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                for(var _iterator1 = Object.entries(group)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var _step_value1 = _sliced_to_array(_step1.value, 2), styleName = _step_value1[0], style = _step_value1[1];
                    styles[styleName] = {
                        open: "\x1b[".concat(style[0], "m"),
                        close: "\x1b[".concat(style[1], "m")
                    };
                    group[styleName] = styles[styleName];
                    codes.set(style[0], style[1]);
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
            Object.defineProperty(styles, groupName, {
                value: group,
                enumerable: false
            });
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
    });
    styles.color.close = "\x1b[39m";
    styles.bgColor.close = "\x1b[49m";
    styles.color.ansi = wrapAnsi16();
    styles.color.ansi256 = wrapAnsi256();
    styles.color.ansi16m = wrapAnsi16m();
    styles.bgColor.ansi = wrapAnsi16(ANSI_BACKGROUND_OFFSET);
    styles.bgColor.ansi256 = wrapAnsi256(ANSI_BACKGROUND_OFFSET);
    styles.bgColor.ansi16m = wrapAnsi16m(ANSI_BACKGROUND_OFFSET);
    Object.defineProperties(styles, {
        rgbToAnsi256: {
            value: function value1(red, green, blue) {
                if (red === green && green === blue) {
                    if (red < 8) {
                        return 16;
                    }
                    if (red > 248) {
                        return 231;
                    }
                    return Math.round((red - 8) / 247 * 24) + 232;
                }
                return 16 + 36 * Math.round(red / 255 * 5) + 6 * Math.round(green / 255 * 5) + Math.round(blue / 255 * 5);
            },
            enumerable: false
        },
        hexToRgb: {
            value: function value1(hex) {
                var matches = /[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));
                if (!matches) {
                    return [
                        0,
                        0,
                        0
                    ];
                }
                var _matches = _sliced_to_array(matches, 1), colorString = _matches[0];
                if (colorString.length === 3) {
                    colorString = _to_consumable_array(colorString).map(function(character) {
                        return character + character;
                    }).join("");
                }
                var integer = Number.parseInt(colorString, 16);
                return [
                    /* eslint-disable no-bitwise */ integer >> 16 & 255,
                    integer >> 8 & 255,
                    integer & 255
                ];
            },
            enumerable: false
        },
        hexToAnsi256: {
            value: function(hex) {
                return (_styles = styles).rgbToAnsi256.apply(_styles, _to_consumable_array(styles.hexToRgb(hex)));
            },
            enumerable: false
        },
        ansi256ToAnsi: {
            value: function value1(code2) {
                if (code2 < 8) {
                    return 30 + code2;
                }
                if (code2 < 16) {
                    return 90 + (code2 - 8);
                }
                var red;
                var green;
                var blue;
                if (code2 >= 232) {
                    red = ((code2 - 232) * 10 + 8) / 255;
                    green = red;
                    blue = red;
                } else {
                    code2 -= 16;
                    var remainder = code2 % 36;
                    red = Math.floor(code2 / 36) / 5;
                    green = Math.floor(remainder / 6) / 5;
                    blue = remainder % 6 / 5;
                }
                var value1 = Math.max(red, green, blue) * 2;
                if (value1 === 0) {
                    return 30;
                }
                var result = 30 + (Math.round(blue) << 2 | Math.round(green) << 1 | Math.round(red));
                if (value1 === 2) {
                    result += 60;
                }
                return result;
            },
            enumerable: false
        },
        rgbToAnsi: {
            value: function(red, green, blue) {
                return styles.ansi256ToAnsi(styles.rgbToAnsi256(red, green, blue));
            },
            enumerable: false
        },
        hexToAnsi: {
            value: function(hex) {
                return styles.ansi256ToAnsi(styles.hexToAnsi256(hex));
            },
            enumerable: false
        }
    });
    return styles;
}
var ansiStyles = assembleStyles();
var ansi_styles_default = ansiStyles;
// node_modules/@babel/highlight/node_modules/chalk/source/vendor/supports-color/index.js
var import_node_process = __toESM(require("process"), 1);
var import_node_os = __toESM(require("os"), 1);
var import_node_tty = __toESM(require("tty"), 1);
function hasFlag(flag) {
    var argv = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : globalThis.Deno ? globalThis.Deno.args : import_node_process.default.argv;
    var prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
    var position = argv.indexOf(prefix2 + flag);
    var terminatorPosition = argv.indexOf("--");
    return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
}
var env = import_node_process.default.env;
var flagForceColor;
if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
    flagForceColor = 0;
} else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
    flagForceColor = 1;
}
function envForceColor() {
    if ("FORCE_COLOR" in env) {
        if (env.FORCE_COLOR === "true") {
            return 1;
        }
        if (env.FORCE_COLOR === "false") {
            return 0;
        }
        return env.FORCE_COLOR.length === 0 ? 1 : Math.min(Number.parseInt(env.FORCE_COLOR, 10), 3);
    }
}
function translateLevel(level) {
    if (level === 0) {
        return false;
    }
    return {
        level: level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
    };
}
function _supportsColor(haveStream) {
    var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, streamIsTTY = _ref.streamIsTTY, _ref_sniffFlags = _ref.sniffFlags, sniffFlags = _ref_sniffFlags === void 0 ? true : _ref_sniffFlags;
    var noFlagForceColor = envForceColor();
    if (noFlagForceColor !== void 0) {
        flagForceColor = noFlagForceColor;
    }
    var forceColor = sniffFlags ? flagForceColor : noFlagForceColor;
    if (forceColor === 0) {
        return 0;
    }
    if (sniffFlags) {
        if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
        }
        if (hasFlag("color=256")) {
            return 2;
        }
    }
    if ("TF_BUILD" in env && "AGENT_NAME" in env) {
        return 1;
    }
    if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
    }
    var min = forceColor || 0;
    if (env.TERM === "dumb") {
        return min;
    }
    if (import_node_process.default.platform === "win32") {
        var osRelease = import_node_os.default.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
            return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
    }
    if ("CI" in env) {
        if ("GITHUB_ACTIONS" in env || "GITEA_ACTIONS" in env) {
            return 3;
        }
        if ([
            "TRAVIS",
            "CIRCLECI",
            "APPVEYOR",
            "GITLAB_CI",
            "BUILDKITE",
            "DRONE"
        ].some(function(sign) {
            return sign in env;
        }) || env.CI_NAME === "codeship") {
            return 1;
        }
        return min;
    }
    if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
    }
    if (env.COLORTERM === "truecolor") {
        return 3;
    }
    if (env.TERM === "xterm-kitty") {
        return 3;
    }
    if ("TERM_PROGRAM" in env) {
        var version = Number.parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch(env.TERM_PROGRAM){
            case "iTerm.app":
                {
                    return version >= 3 ? 3 : 2;
                }
            case "Apple_Terminal":
                {
                    return 2;
                }
        }
    }
    if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
    }
    if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
    }
    if ("COLORTERM" in env) {
        return 1;
    }
    return min;
}
function createSupportsColor(stream) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var level = _supportsColor(stream, _object_spread({
        streamIsTTY: stream && stream.isTTY
    }, options));
    return translateLevel(level);
}
var supportsColor = {
    stdout: createSupportsColor({
        isTTY: import_node_tty.default.isatty(1)
    }),
    stderr: createSupportsColor({
        isTTY: import_node_tty.default.isatty(2)
    })
};
var supports_color_default = supportsColor;
// node_modules/@babel/highlight/node_modules/chalk/source/utilities.js
function stringReplaceAll(string, substring, replacer) {
    var index3 = string.indexOf(substring);
    if (index3 === -1) {
        return string;
    }
    var substringLength = substring.length;
    var endIndex = 0;
    var returnValue = "";
    do {
        returnValue += string.slice(endIndex, index3) + substring + replacer;
        endIndex = index3 + substringLength;
        index3 = string.indexOf(substring, endIndex);
    }while (index3 !== -1);
    returnValue += string.slice(endIndex);
    return returnValue;
}
function stringEncaseCRLFWithFirstIndex(string, prefix2, postfix2, index3) {
    var endIndex = 0;
    var returnValue = "";
    do {
        var gotCR = string[index3 - 1] === "\r";
        returnValue += string.slice(endIndex, gotCR ? index3 - 1 : index3) + prefix2 + (gotCR ? "\r\n" : "\n") + postfix2;
        endIndex = index3 + 1;
        index3 = string.indexOf("\n", endIndex);
    }while (index3 !== -1);
    returnValue += string.slice(endIndex);
    return returnValue;
}
// node_modules/@babel/highlight/node_modules/chalk/source/index.js
var stdoutColor = supports_color_default.stdout, stderrColor = supports_color_default.stderr;
var GENERATOR = Symbol("GENERATOR");
var STYLER = Symbol("STYLER");
var IS_EMPTY = Symbol("IS_EMPTY");
var levelMapping = [
    "ansi",
    "ansi",
    "ansi256",
    "ansi16m"
];
var styles2 = /* @__PURE__ */ Object.create(null);
var applyOptions = function(object) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
    }
    var colorLevel = stdoutColor ? stdoutColor.level : 0;
    object.level = options.level === void 0 ? colorLevel : options.level;
};
var Chalk = function Chalk(options) {
    "use strict";
    _class_call_check(this, Chalk);
    return chalkFactory(options);
};
var chalkFactory = function(options) {
    var chalk3 = function() {
        for(var _len = arguments.length, strings = new Array(_len), _key = 0; _key < _len; _key++){
            strings[_key] = arguments[_key];
        }
        return strings.join(" ");
    };
    applyOptions(chalk3, options);
    Object.setPrototypeOf(chalk3, createChalk.prototype);
    return chalk3;
};
function createChalk(options) {
    return chalkFactory(options);
}
Object.setPrototypeOf(createChalk.prototype, Function.prototype);
var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
try {
    var _loop = function() {
        var _step_value = _sliced_to_array(_step2.value, 2), styleName = _step_value[0], style = _step_value[1];
        styles2[styleName] = {
            get: function get() {
                var builder = createBuilder(this, createStyler(style.open, style.close, this[STYLER]), this[IS_EMPTY]);
                Object.defineProperty(this, styleName, {
                    value: builder
                });
                return builder;
            }
        };
    };
    for(var _iterator2 = Object.entries(ansi_styles_default)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true)_loop();
} catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
        }
    } finally{
        if (_didIteratorError2) {
            throw _iteratorError2;
        }
    }
}
styles2.visible = {
    get: function get() {
        var builder = createBuilder(this, this[STYLER], true);
        Object.defineProperty(this, "visible", {
            value: builder
        });
        return builder;
    }
};
var getModelAnsi = function(model, level, type) {
    for(var _len = arguments.length, arguments_ = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++){
        arguments_[_key - 3] = arguments[_key];
    }
    var _ansi_styles_default_type;
    if (model === "rgb") {
        var _ansi_styles_default;
        if (level === "ansi16m") {
            var _ansi_styles_default_type1;
            return (_ansi_styles_default_type1 = ansi_styles_default[type]).ansi16m.apply(_ansi_styles_default_type1, _to_consumable_array(arguments_));
        }
        if (level === "ansi256") {
            var _ansi_styles_default1;
            return ansi_styles_default[type].ansi256((_ansi_styles_default1 = ansi_styles_default).rgbToAnsi256.apply(_ansi_styles_default1, _to_consumable_array(arguments_)));
        }
        return ansi_styles_default[type].ansi((_ansi_styles_default = ansi_styles_default).rgbToAnsi.apply(_ansi_styles_default, _to_consumable_array(arguments_)));
    }
    if (model === "hex") {
        var _ansi_styles_default2;
        return getModelAnsi.apply(void 0, [
            "rgb",
            level,
            type
        ].concat(_to_consumable_array((_ansi_styles_default2 = ansi_styles_default).hexToRgb.apply(_ansi_styles_default2, _to_consumable_array(arguments_)))));
    }
    return (_ansi_styles_default_type = ansi_styles_default[type])[model].apply(_ansi_styles_default_type, _to_consumable_array(arguments_));
};
var usedModels = [
    "rgb",
    "hex",
    "ansi256"
];
var _iteratorNormalCompletion3 = true, _didIteratorError3 = false, _iteratorError3 = undefined;
try {
    var _loop1 = function() {
        var model = _step3.value;
        styles2[model] = {
            get: function get() {
                var level = this.level;
                return function() {
                    for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
                        arguments_[_key] = arguments[_key];
                    }
                    var styler = createStyler(getModelAnsi.apply(void 0, [
                        model,
                        levelMapping[level],
                        "color"
                    ].concat(_to_consumable_array(arguments_))), ansi_styles_default.color.close, this[STYLER]);
                    return createBuilder(this, styler, this[IS_EMPTY]);
                };
            }
        };
        var bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
        styles2[bgModel] = {
            get: function get() {
                var level = this.level;
                return function() {
                    for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
                        arguments_[_key] = arguments[_key];
                    }
                    var styler = createStyler(getModelAnsi.apply(void 0, [
                        model,
                        levelMapping[level],
                        "bgColor"
                    ].concat(_to_consumable_array(arguments_))), ansi_styles_default.bgColor.close, this[STYLER]);
                    return createBuilder(this, styler, this[IS_EMPTY]);
                };
            }
        };
    };
    for(var _iterator3 = usedModels[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true)_loop1();
} catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
            _iterator3.return();
        }
    } finally{
        if (_didIteratorError3) {
            throw _iteratorError3;
        }
    }
}
var proto = Object.defineProperties(function() {}, _object_spread_props(_object_spread({}, styles2), {
    level: {
        enumerable: true,
        get: function get() {
            return this[GENERATOR].level;
        },
        set: function set(level) {
            this[GENERATOR].level = level;
        }
    }
}));
var createStyler = function(open, close, parent) {
    var openAll;
    var closeAll;
    if (parent === void 0) {
        openAll = open;
        closeAll = close;
    } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
    }
    return {
        open: open,
        close: close,
        openAll: openAll,
        closeAll: closeAll,
        parent: parent
    };
};
var createBuilder = function(self, _styler, _isEmpty) {
    var builder = function() {
        for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
            arguments_[_key] = arguments[_key];
        }
        return applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
    };
    Object.setPrototypeOf(builder, proto);
    builder[GENERATOR] = self;
    builder[STYLER] = _styler;
    builder[IS_EMPTY] = _isEmpty;
    return builder;
};
var applyStyle = function(self, string) {
    if (self.level <= 0 || !string) {
        return self[IS_EMPTY] ? "" : string;
    }
    var styler = self[STYLER];
    if (styler === void 0) {
        return string;
    }
    var openAll = styler.openAll, closeAll = styler.closeAll;
    if (string.includes("\x1b")) {
        while(styler !== void 0){
            string = stringReplaceAll(string, styler.close, styler.open);
            styler = styler.parent;
        }
    }
    var lfIndex = string.indexOf("\n");
    if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
    }
    return openAll + string + closeAll;
};
Object.defineProperties(createChalk.prototype, styles2);
var chalk = createChalk();
var chalkStderr = createChalk({
    level: stderrColor ? stderrColor.level : 0
});
var source_default = chalk;
// node_modules/@babel/highlight/lib/index.js
var sometimesKeywords = /* @__PURE__ */ new Set([
    "as",
    "async",
    "from",
    "get",
    "of",
    "set"
]);
function getDefs(chalk3) {
    return {
        keyword: chalk3.cyan,
        capitalized: chalk3.yellow,
        jsxIdentifier: chalk3.yellow,
        punctuator: chalk3.yellow,
        number: chalk3.magenta,
        string: chalk3.green,
        regex: chalk3.magenta,
        comment: chalk3.grey,
        invalid: chalk3.white.bgRed.bold
    };
}
var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
var BRACKET = /^[()[\]{}]$/;
var tokenize;
{
    var getTokenType = function getTokenType(token) {
        if (token.type === "IdentifierName") {
            if (isKeyword(token.value) || isStrictReservedWord(token.value, true) || sometimesKeywords.has(token.value)) {
                return "keyword";
            }
            if (token.value[0] !== token.value[0].toLowerCase()) {
                return "capitalized";
            }
        }
        if (token.type === "Punctuator" && BRACKET.test(token.value)) {
            return "uncolored";
        }
        if (token.type === "Invalid" && token.value === "@") {
            return "punctuator";
        }
        switch(token.type){
            case "NumericLiteral":
                return "number";
            case "StringLiteral":
            case "JSXString":
            case "NoSubstitutionTemplate":
                return "string";
            case "RegularExpressionLiteral":
                return "regex";
            case "Punctuator":
            case "JSXPunctuator":
                return "punctuator";
            case "MultiLineComment":
            case "SingleLineComment":
                return "comment";
            case "Invalid":
            case "JSXInvalid":
                return "invalid";
            case "JSXIdentifier":
                return "jsxIdentifier";
            default:
                return "uncolored";
        }
    };
    tokenize = function tokenize(text) {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, token, _, err;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    _state.label = 1;
                case 1:
                    _state.trys.push([
                        1,
                        17,
                        18,
                        19
                    ]);
                    _iterator = (0, import_js_tokens.default)(text, {
                        jsx: true
                    })[Symbol.iterator]();
                    _state.label = 2;
                case 2:
                    if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done)) return [
                        3,
                        16
                    ];
                    token = _step.value;
                    _ = token.type;
                    switch(_){
                        case "TemplateHead":
                            return [
                                3,
                                3
                            ];
                        case "TemplateMiddle":
                            return [
                                3,
                                6
                            ];
                        case "TemplateTail":
                            return [
                                3,
                                10
                            ];
                    }
                    return [
                        3,
                        13
                    ];
                case 3:
                    return [
                        4,
                        {
                            type: "string",
                            value: token.value.slice(0, -2)
                        }
                    ];
                case 4:
                    _state.sent();
                    return [
                        4,
                        {
                            type: "punctuator",
                            value: "${"
                        }
                    ];
                case 5:
                    _state.sent();
                    return [
                        3,
                        15
                    ];
                case 6:
                    return [
                        4,
                        {
                            type: "punctuator",
                            value: "}"
                        }
                    ];
                case 7:
                    _state.sent();
                    return [
                        4,
                        {
                            type: "string",
                            value: token.value.slice(1, -2)
                        }
                    ];
                case 8:
                    _state.sent();
                    return [
                        4,
                        {
                            type: "punctuator",
                            value: "${"
                        }
                    ];
                case 9:
                    _state.sent();
                    return [
                        3,
                        15
                    ];
                case 10:
                    return [
                        4,
                        {
                            type: "punctuator",
                            value: "}"
                        }
                    ];
                case 11:
                    _state.sent();
                    return [
                        4,
                        {
                            type: "string",
                            value: token.value.slice(1)
                        }
                    ];
                case 12:
                    _state.sent();
                    return [
                        3,
                        15
                    ];
                case 13:
                    return [
                        4,
                        {
                            type: getTokenType(token),
                            value: token.value
                        }
                    ];
                case 14:
                    _state.sent();
                    _state.label = 15;
                case 15:
                    _iteratorNormalCompletion = true;
                    return [
                        3,
                        2
                    ];
                case 16:
                    return [
                        3,
                        19
                    ];
                case 17:
                    err = _state.sent();
                    _didIteratorError = true;
                    _iteratorError = err;
                    return [
                        3,
                        19
                    ];
                case 18:
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                    return [
                        7
                    ];
                case 19:
                    return [
                        2
                    ];
            }
        });
    };
}function highlightTokens(defs, text) {
    var highlighted = "";
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        var _loop = function() {
            var _step_value = _step.value, type = _step_value.type, value1 = _step_value.value;
            var colorize = defs[type];
            if (colorize) {
                highlighted += value1.split(NEWLINE).map(function(str) {
                    return colorize(str);
                }).join("\n");
            } else {
                highlighted += value1;
            }
        };
        for(var _iterator = tokenize(text)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return highlighted;
}
function shouldHighlight(options) {
    return source_default.level > 0 || options.forceColor;
}
var chalkWithForcedColor = void 0;
function getChalk(forceColor) {
    if (forceColor) {
        chalkWithForcedColor !== null && chalkWithForcedColor !== void 0 ? chalkWithForcedColor : chalkWithForcedColor = new Chalk({
            level: 1
        });
        return chalkWithForcedColor;
    }
    return source_default;
}
function highlight(code2) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (code2 !== "" && shouldHighlight(options)) {
        var defs = getDefs(getChalk(options.forceColor));
        return highlightTokens(defs, code2);
    } else {
        return code2;
    }
}
// node_modules/@babel/code-frame/node_modules/chalk/source/vendor/ansi-styles/index.js
var ANSI_BACKGROUND_OFFSET2 = 10;
var wrapAnsi162 = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(code2) {
        return "\x1b[".concat(code2 + offset, "m");
    };
};
var wrapAnsi2562 = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(code2) {
        return "\x1b[".concat(38 + offset, ";5;").concat(code2, "m");
    };
};
var wrapAnsi16m2 = function() {
    var offset = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
    return function(red, green, blue) {
        return "\x1b[".concat(38 + offset, ";2;").concat(red, ";").concat(green, ";").concat(blue, "m");
    };
};
var styles3 = {
    modifier: {
        reset: [
            0,
            0
        ],
        // 21 isn't widely supported and 22 does the same thing
        bold: [
            1,
            22
        ],
        dim: [
            2,
            22
        ],
        italic: [
            3,
            23
        ],
        underline: [
            4,
            24
        ],
        overline: [
            53,
            55
        ],
        inverse: [
            7,
            27
        ],
        hidden: [
            8,
            28
        ],
        strikethrough: [
            9,
            29
        ]
    },
    color: {
        black: [
            30,
            39
        ],
        red: [
            31,
            39
        ],
        green: [
            32,
            39
        ],
        yellow: [
            33,
            39
        ],
        blue: [
            34,
            39
        ],
        magenta: [
            35,
            39
        ],
        cyan: [
            36,
            39
        ],
        white: [
            37,
            39
        ],
        // Bright color
        blackBright: [
            90,
            39
        ],
        gray: [
            90,
            39
        ],
        // Alias of `blackBright`
        grey: [
            90,
            39
        ],
        // Alias of `blackBright`
        redBright: [
            91,
            39
        ],
        greenBright: [
            92,
            39
        ],
        yellowBright: [
            93,
            39
        ],
        blueBright: [
            94,
            39
        ],
        magentaBright: [
            95,
            39
        ],
        cyanBright: [
            96,
            39
        ],
        whiteBright: [
            97,
            39
        ]
    },
    bgColor: {
        bgBlack: [
            40,
            49
        ],
        bgRed: [
            41,
            49
        ],
        bgGreen: [
            42,
            49
        ],
        bgYellow: [
            43,
            49
        ],
        bgBlue: [
            44,
            49
        ],
        bgMagenta: [
            45,
            49
        ],
        bgCyan: [
            46,
            49
        ],
        bgWhite: [
            47,
            49
        ],
        // Bright color
        bgBlackBright: [
            100,
            49
        ],
        bgGray: [
            100,
            49
        ],
        // Alias of `bgBlackBright`
        bgGrey: [
            100,
            49
        ],
        // Alias of `bgBlackBright`
        bgRedBright: [
            101,
            49
        ],
        bgGreenBright: [
            102,
            49
        ],
        bgYellowBright: [
            103,
            49
        ],
        bgBlueBright: [
            104,
            49
        ],
        bgMagentaBright: [
            105,
            49
        ],
        bgCyanBright: [
            106,
            49
        ],
        bgWhiteBright: [
            107,
            49
        ]
    }
};
var modifierNames2 = Object.keys(styles3.modifier);
var foregroundColorNames2 = Object.keys(styles3.color);
var backgroundColorNames2 = Object.keys(styles3.bgColor);
var colorNames2 = _to_consumable_array(foregroundColorNames2).concat(_to_consumable_array(backgroundColorNames2));
function assembleStyles2() {
    var _styles3;
    var codes = /* @__PURE__ */ new Map();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.entries(styles3)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var _step_value = _sliced_to_array(_step.value, 2), groupName = _step_value[0], group = _step_value[1];
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                for(var _iterator1 = Object.entries(group)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var _step_value1 = _sliced_to_array(_step1.value, 2), styleName = _step_value1[0], style = _step_value1[1];
                    styles3[styleName] = {
                        open: "\x1b[".concat(style[0], "m"),
                        close: "\x1b[".concat(style[1], "m")
                    };
                    group[styleName] = styles3[styleName];
                    codes.set(style[0], style[1]);
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
            Object.defineProperty(styles3, groupName, {
                value: group,
                enumerable: false
            });
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    Object.defineProperty(styles3, "codes", {
        value: codes,
        enumerable: false
    });
    styles3.color.close = "\x1b[39m";
    styles3.bgColor.close = "\x1b[49m";
    styles3.color.ansi = wrapAnsi162();
    styles3.color.ansi256 = wrapAnsi2562();
    styles3.color.ansi16m = wrapAnsi16m2();
    styles3.bgColor.ansi = wrapAnsi162(ANSI_BACKGROUND_OFFSET2);
    styles3.bgColor.ansi256 = wrapAnsi2562(ANSI_BACKGROUND_OFFSET2);
    styles3.bgColor.ansi16m = wrapAnsi16m2(ANSI_BACKGROUND_OFFSET2);
    Object.defineProperties(styles3, {
        rgbToAnsi256: {
            value: function value1(red, green, blue) {
                if (red === green && green === blue) {
                    if (red < 8) {
                        return 16;
                    }
                    if (red > 248) {
                        return 231;
                    }
                    return Math.round((red - 8) / 247 * 24) + 232;
                }
                return 16 + 36 * Math.round(red / 255 * 5) + 6 * Math.round(green / 255 * 5) + Math.round(blue / 255 * 5);
            },
            enumerable: false
        },
        hexToRgb: {
            value: function value1(hex) {
                var matches = /[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));
                if (!matches) {
                    return [
                        0,
                        0,
                        0
                    ];
                }
                var _matches = _sliced_to_array(matches, 1), colorString = _matches[0];
                if (colorString.length === 3) {
                    colorString = _to_consumable_array(colorString).map(function(character) {
                        return character + character;
                    }).join("");
                }
                var integer = Number.parseInt(colorString, 16);
                return [
                    /* eslint-disable no-bitwise */ integer >> 16 & 255,
                    integer >> 8 & 255,
                    integer & 255
                ];
            },
            enumerable: false
        },
        hexToAnsi256: {
            value: function(hex) {
                return (_styles3 = styles3).rgbToAnsi256.apply(_styles3, _to_consumable_array(styles3.hexToRgb(hex)));
            },
            enumerable: false
        },
        ansi256ToAnsi: {
            value: function value1(code2) {
                if (code2 < 8) {
                    return 30 + code2;
                }
                if (code2 < 16) {
                    return 90 + (code2 - 8);
                }
                var red;
                var green;
                var blue;
                if (code2 >= 232) {
                    red = ((code2 - 232) * 10 + 8) / 255;
                    green = red;
                    blue = red;
                } else {
                    code2 -= 16;
                    var remainder = code2 % 36;
                    red = Math.floor(code2 / 36) / 5;
                    green = Math.floor(remainder / 6) / 5;
                    blue = remainder % 6 / 5;
                }
                var value1 = Math.max(red, green, blue) * 2;
                if (value1 === 0) {
                    return 30;
                }
                var result = 30 + (Math.round(blue) << 2 | Math.round(green) << 1 | Math.round(red));
                if (value1 === 2) {
                    result += 60;
                }
                return result;
            },
            enumerable: false
        },
        rgbToAnsi: {
            value: function(red, green, blue) {
                return styles3.ansi256ToAnsi(styles3.rgbToAnsi256(red, green, blue));
            },
            enumerable: false
        },
        hexToAnsi: {
            value: function(hex) {
                return styles3.ansi256ToAnsi(styles3.hexToAnsi256(hex));
            },
            enumerable: false
        }
    });
    return styles3;
}
var ansiStyles2 = assembleStyles2();
var ansi_styles_default2 = ansiStyles2;
// node_modules/@babel/code-frame/node_modules/chalk/source/vendor/supports-color/index.js
var import_node_process2 = __toESM(require("process"), 1);
var import_node_os2 = __toESM(require("os"), 1);
var import_node_tty2 = __toESM(require("tty"), 1);
function hasFlag2(flag) {
    var argv = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : globalThis.Deno ? globalThis.Deno.args : import_node_process2.default.argv;
    var prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
    var position = argv.indexOf(prefix2 + flag);
    var terminatorPosition = argv.indexOf("--");
    return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
}
var _import_node_process2_default = import_node_process2.default, env2 = _import_node_process2_default.env;
var flagForceColor2;
if (hasFlag2("no-color") || hasFlag2("no-colors") || hasFlag2("color=false") || hasFlag2("color=never")) {
    flagForceColor2 = 0;
} else if (hasFlag2("color") || hasFlag2("colors") || hasFlag2("color=true") || hasFlag2("color=always")) {
    flagForceColor2 = 1;
}
function envForceColor2() {
    if ("FORCE_COLOR" in env2) {
        if (env2.FORCE_COLOR === "true") {
            return 1;
        }
        if (env2.FORCE_COLOR === "false") {
            return 0;
        }
        return env2.FORCE_COLOR.length === 0 ? 1 : Math.min(Number.parseInt(env2.FORCE_COLOR, 10), 3);
    }
}
function translateLevel2(level) {
    if (level === 0) {
        return false;
    }
    return {
        level: level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
    };
}
function _supportsColor2(haveStream) {
    var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, streamIsTTY = _ref.streamIsTTY, _ref_sniffFlags = _ref.sniffFlags, sniffFlags = _ref_sniffFlags === void 0 ? true : _ref_sniffFlags;
    var noFlagForceColor = envForceColor2();
    if (noFlagForceColor !== void 0) {
        flagForceColor2 = noFlagForceColor;
    }
    var forceColor = sniffFlags ? flagForceColor2 : noFlagForceColor;
    if (forceColor === 0) {
        return 0;
    }
    if (sniffFlags) {
        if (hasFlag2("color=16m") || hasFlag2("color=full") || hasFlag2("color=truecolor")) {
            return 3;
        }
        if (hasFlag2("color=256")) {
            return 2;
        }
    }
    if ("TF_BUILD" in env2 && "AGENT_NAME" in env2) {
        return 1;
    }
    if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
    }
    var min = forceColor || 0;
    if (env2.TERM === "dumb") {
        return min;
    }
    if (import_node_process2.default.platform === "win32") {
        var osRelease = import_node_os2.default.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
            return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
    }
    if ("CI" in env2) {
        if ("GITHUB_ACTIONS" in env2 || "GITEA_ACTIONS" in env2) {
            return 3;
        }
        if ([
            "TRAVIS",
            "CIRCLECI",
            "APPVEYOR",
            "GITLAB_CI",
            "BUILDKITE",
            "DRONE"
        ].some(function(sign) {
            return sign in env2;
        }) || env2.CI_NAME === "codeship") {
            return 1;
        }
        return min;
    }
    if ("TEAMCITY_VERSION" in env2) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env2.TEAMCITY_VERSION) ? 1 : 0;
    }
    if (env2.COLORTERM === "truecolor") {
        return 3;
    }
    if (env2.TERM === "xterm-kitty") {
        return 3;
    }
    if ("TERM_PROGRAM" in env2) {
        var version = Number.parseInt((env2.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch(env2.TERM_PROGRAM){
            case "iTerm.app":
                {
                    return version >= 3 ? 3 : 2;
                }
            case "Apple_Terminal":
                {
                    return 2;
                }
        }
    }
    if (/-256(color)?$/i.test(env2.TERM)) {
        return 2;
    }
    if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env2.TERM)) {
        return 1;
    }
    if ("COLORTERM" in env2) {
        return 1;
    }
    return min;
}
function createSupportsColor2(stream) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var level = _supportsColor2(stream, _object_spread({
        streamIsTTY: stream && stream.isTTY
    }, options));
    return translateLevel2(level);
}
var supportsColor2 = {
    stdout: createSupportsColor2({
        isTTY: import_node_tty2.default.isatty(1)
    }),
    stderr: createSupportsColor2({
        isTTY: import_node_tty2.default.isatty(2)
    })
};
var supports_color_default2 = supportsColor2;
// node_modules/@babel/code-frame/node_modules/chalk/source/utilities.js
function stringReplaceAll2(string, substring, replacer) {
    var index3 = string.indexOf(substring);
    if (index3 === -1) {
        return string;
    }
    var substringLength = substring.length;
    var endIndex = 0;
    var returnValue = "";
    do {
        returnValue += string.slice(endIndex, index3) + substring + replacer;
        endIndex = index3 + substringLength;
        index3 = string.indexOf(substring, endIndex);
    }while (index3 !== -1);
    returnValue += string.slice(endIndex);
    return returnValue;
}
function stringEncaseCRLFWithFirstIndex2(string, prefix2, postfix2, index3) {
    var endIndex = 0;
    var returnValue = "";
    do {
        var gotCR = string[index3 - 1] === "\r";
        returnValue += string.slice(endIndex, gotCR ? index3 - 1 : index3) + prefix2 + (gotCR ? "\r\n" : "\n") + postfix2;
        endIndex = index3 + 1;
        index3 = string.indexOf("\n", endIndex);
    }while (index3 !== -1);
    returnValue += string.slice(endIndex);
    return returnValue;
}
// node_modules/@babel/code-frame/node_modules/chalk/source/index.js
var stdoutColor2 = supports_color_default2.stdout, stderrColor2 = supports_color_default2.stderr;
var GENERATOR2 = Symbol("GENERATOR");
var STYLER2 = Symbol("STYLER");
var IS_EMPTY2 = Symbol("IS_EMPTY");
var levelMapping2 = [
    "ansi",
    "ansi",
    "ansi256",
    "ansi16m"
];
var styles4 = /* @__PURE__ */ Object.create(null);
var applyOptions2 = function(object) {
    var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
    }
    var colorLevel = stdoutColor2 ? stdoutColor2.level : 0;
    object.level = options.level === void 0 ? colorLevel : options.level;
};
var Chalk2 = function Chalk2(options) {
    "use strict";
    _class_call_check(this, Chalk2);
    return chalkFactory2(options);
};
var chalkFactory2 = function(options) {
    var chalk3 = function() {
        for(var _len = arguments.length, strings = new Array(_len), _key = 0; _key < _len; _key++){
            strings[_key] = arguments[_key];
        }
        return strings.join(" ");
    };
    applyOptions2(chalk3, options);
    Object.setPrototypeOf(chalk3, createChalk2.prototype);
    return chalk3;
};
function createChalk2(options) {
    return chalkFactory2(options);
}
Object.setPrototypeOf(createChalk2.prototype, Function.prototype);
var _iteratorNormalCompletion4 = true, _didIteratorError4 = false, _iteratorError4 = undefined;
try {
    var _loop2 = function() {
        var _step_value = _sliced_to_array(_step4.value, 2), styleName = _step_value[0], style = _step_value[1];
        styles4[styleName] = {
            get: function get() {
                var builder = createBuilder2(this, createStyler2(style.open, style.close, this[STYLER2]), this[IS_EMPTY2]);
                Object.defineProperty(this, styleName, {
                    value: builder
                });
                return builder;
            }
        };
    };
    for(var _iterator4 = Object.entries(ansi_styles_default2)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true)_loop2();
} catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
            _iterator4.return();
        }
    } finally{
        if (_didIteratorError4) {
            throw _iteratorError4;
        }
    }
}
styles4.visible = {
    get: function get() {
        var builder = createBuilder2(this, this[STYLER2], true);
        Object.defineProperty(this, "visible", {
            value: builder
        });
        return builder;
    }
};
var getModelAnsi2 = function(model, level, type) {
    for(var _len = arguments.length, arguments_ = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++){
        arguments_[_key - 3] = arguments[_key];
    }
    var _ansi_styles_default2_type;
    if (model === "rgb") {
        var _ansi_styles_default2;
        if (level === "ansi16m") {
            var _ansi_styles_default2_type1;
            return (_ansi_styles_default2_type1 = ansi_styles_default2[type]).ansi16m.apply(_ansi_styles_default2_type1, _to_consumable_array(arguments_));
        }
        if (level === "ansi256") {
            var _ansi_styles_default21;
            return ansi_styles_default2[type].ansi256((_ansi_styles_default21 = ansi_styles_default2).rgbToAnsi256.apply(_ansi_styles_default21, _to_consumable_array(arguments_)));
        }
        return ansi_styles_default2[type].ansi((_ansi_styles_default2 = ansi_styles_default2).rgbToAnsi.apply(_ansi_styles_default2, _to_consumable_array(arguments_)));
    }
    if (model === "hex") {
        var _ansi_styles_default22;
        return getModelAnsi2.apply(void 0, [
            "rgb",
            level,
            type
        ].concat(_to_consumable_array((_ansi_styles_default22 = ansi_styles_default2).hexToRgb.apply(_ansi_styles_default22, _to_consumable_array(arguments_)))));
    }
    return (_ansi_styles_default2_type = ansi_styles_default2[type])[model].apply(_ansi_styles_default2_type, _to_consumable_array(arguments_));
};
var usedModels2 = [
    "rgb",
    "hex",
    "ansi256"
];
var _iteratorNormalCompletion5 = true, _didIteratorError5 = false, _iteratorError5 = undefined;
try {
    var _loop3 = function() {
        var model = _step5.value;
        styles4[model] = {
            get: function get() {
                var level = this.level;
                return function() {
                    for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
                        arguments_[_key] = arguments[_key];
                    }
                    var styler = createStyler2(getModelAnsi2.apply(void 0, [
                        model,
                        levelMapping2[level],
                        "color"
                    ].concat(_to_consumable_array(arguments_))), ansi_styles_default2.color.close, this[STYLER2]);
                    return createBuilder2(this, styler, this[IS_EMPTY2]);
                };
            }
        };
        var bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
        styles4[bgModel] = {
            get: function get() {
                var level = this.level;
                return function() {
                    for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
                        arguments_[_key] = arguments[_key];
                    }
                    var styler = createStyler2(getModelAnsi2.apply(void 0, [
                        model,
                        levelMapping2[level],
                        "bgColor"
                    ].concat(_to_consumable_array(arguments_))), ansi_styles_default2.bgColor.close, this[STYLER2]);
                    return createBuilder2(this, styler, this[IS_EMPTY2]);
                };
            }
        };
    };
    for(var _iterator5 = usedModels2[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true)_loop3();
} catch (err) {
    _didIteratorError5 = true;
    _iteratorError5 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
            _iterator5.return();
        }
    } finally{
        if (_didIteratorError5) {
            throw _iteratorError5;
        }
    }
}
var proto2 = Object.defineProperties(function() {}, _object_spread_props(_object_spread({}, styles4), {
    level: {
        enumerable: true,
        get: function get() {
            return this[GENERATOR2].level;
        },
        set: function set(level) {
            this[GENERATOR2].level = level;
        }
    }
}));
var createStyler2 = function(open, close, parent) {
    var openAll;
    var closeAll;
    if (parent === void 0) {
        openAll = open;
        closeAll = close;
    } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
    }
    return {
        open: open,
        close: close,
        openAll: openAll,
        closeAll: closeAll,
        parent: parent
    };
};
var createBuilder2 = function(self, _styler, _isEmpty) {
    var builder = function() {
        for(var _len = arguments.length, arguments_ = new Array(_len), _key = 0; _key < _len; _key++){
            arguments_[_key] = arguments[_key];
        }
        return applyStyle2(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
    };
    Object.setPrototypeOf(builder, proto2);
    builder[GENERATOR2] = self;
    builder[STYLER2] = _styler;
    builder[IS_EMPTY2] = _isEmpty;
    return builder;
};
var applyStyle2 = function(self, string) {
    if (self.level <= 0 || !string) {
        return self[IS_EMPTY2] ? "" : string;
    }
    var styler = self[STYLER2];
    if (styler === void 0) {
        return string;
    }
    var openAll = styler.openAll, closeAll = styler.closeAll;
    if (string.includes("\x1b")) {
        while(styler !== void 0){
            string = stringReplaceAll2(string, styler.close, styler.open);
            styler = styler.parent;
        }
    }
    var lfIndex = string.indexOf("\n");
    if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex2(string, closeAll, openAll, lfIndex);
    }
    return openAll + string + closeAll;
};
Object.defineProperties(createChalk2.prototype, styles4);
var chalk2 = createChalk2();
var chalkStderr2 = createChalk2({
    level: stderrColor2 ? stderrColor2.level : 0
});
var source_default2 = chalk2;
// node_modules/@babel/code-frame/lib/index.js
var chalkWithForcedColor2 = void 0;
function getChalk2(forceColor) {
    if (forceColor) {
        chalkWithForcedColor2 !== null && chalkWithForcedColor2 !== void 0 ? chalkWithForcedColor2 : chalkWithForcedColor2 = new Chalk2({
            level: 1
        });
        return chalkWithForcedColor2;
    }
    return source_default2;
}
function getDefs2(chalk3) {
    return {
        gutter: chalk3.grey,
        marker: chalk3.red.bold,
        message: chalk3.red.bold
    };
}
var NEWLINE2 = /\r\n|[\n\r\u2028\u2029]/;
function getMarkerLines(loc, source, opts) {
    var startLoc = Object.assign({
        column: 0,
        line: -1
    }, loc.start);
    var endLoc = Object.assign({}, startLoc, loc.end);
    var _ref = opts || {}, _ref_linesAbove = _ref.linesAbove, linesAbove = _ref_linesAbove === void 0 ? 2 : _ref_linesAbove, _ref_linesBelow = _ref.linesBelow, linesBelow = _ref_linesBelow === void 0 ? 3 : _ref_linesBelow;
    var startLine = startLoc.line;
    var startColumn = startLoc.column;
    var endLine = endLoc.line;
    var endColumn = endLoc.column;
    var start = Math.max(startLine - (linesAbove + 1), 0);
    var end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
        start = 0;
    }
    if (endLine === -1) {
        end = source.length;
    }
    var lineDiff = endLine - startLine;
    var markerLines = {};
    if (lineDiff) {
        for(var i = 0; i <= lineDiff; i++){
            var lineNumber = i + startLine;
            if (!startColumn) {
                markerLines[lineNumber] = true;
            } else if (i === 0) {
                var sourceLength = source[lineNumber - 1].length;
                markerLines[lineNumber] = [
                    startColumn,
                    sourceLength - startColumn + 1
                ];
            } else if (i === lineDiff) {
                markerLines[lineNumber] = [
                    0,
                    endColumn
                ];
            } else {
                var sourceLength1 = source[lineNumber - i].length;
                markerLines[lineNumber] = [
                    0,
                    sourceLength1
                ];
            }
        }
    } else {
        if (startColumn === endColumn) {
            if (startColumn) {
                markerLines[startLine] = [
                    startColumn,
                    0
                ];
            } else {
                markerLines[startLine] = true;
            }
        } else {
            markerLines[startLine] = [
                startColumn,
                endColumn - startColumn
            ];
        }
    }
    return {
        start: start,
        end: end,
        markerLines: markerLines
    };
}
function codeFrameColumns(rawLines, loc) {
    var opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    var highlighted = (opts.highlightCode || opts.forceColor) && shouldHighlight(opts);
    var chalk3 = getChalk2(opts.forceColor);
    var defs = getDefs2(chalk3);
    var maybeHighlight = function(chalkFn, string) {
        return highlighted ? chalkFn(string) : string;
    };
    var lines = rawLines.split(NEWLINE2);
    var _getMarkerLines = getMarkerLines(loc, lines, opts), start = _getMarkerLines.start, end = _getMarkerLines.end, markerLines = _getMarkerLines.markerLines;
    var hasColumns = loc.start && typeof loc.start.column === "number";
    var numberMaxWidth = String(end).length;
    var highlightedLines = highlighted ? highlight(rawLines, opts) : rawLines;
    var frame = highlightedLines.split(NEWLINE2, end).slice(start, end).map(function(line, index3) {
        var number = start + 1 + index3;
        var paddedNumber = " ".concat(number).slice(-numberMaxWidth);
        var gutter = " ".concat(paddedNumber, " |");
        var hasMarker = markerLines[number];
        var lastMarkerLine = !markerLines[number + 1];
        if (hasMarker) {
            var markerLine = "";
            if (Array.isArray(hasMarker)) {
                var markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
                var numberOfMarkers = hasMarker[1] || 1;
                markerLine = [
                    "\n ",
                    maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")),
                    " ",
                    markerSpacing,
                    maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)
                ].join("");
                if (lastMarkerLine && opts.message) {
                    markerLine += " " + maybeHighlight(defs.message, opts.message);
                }
            }
            return [
                maybeHighlight(defs.marker, ">"),
                maybeHighlight(defs.gutter, gutter),
                line.length > 0 ? " ".concat(line) : "",
                markerLine
            ].join("");
        } else {
            return " ".concat(maybeHighlight(defs.gutter, gutter)).concat(line.length > 0 ? " ".concat(line) : "");
        }
    }).join("\n");
    if (opts.message && !hasColumns) {
        frame = "".concat(" ".repeat(numberMaxWidth + 1)).concat(opts.message, "\n").concat(frame);
    }
    if (highlighted) {
        return chalk3.reset(frame);
    } else {
        return frame;
    }
}
// node_modules/@babel/template/lib/index.js
var assertExpressionStatement2 = lib_exports.assertExpressionStatement;
function makeStatementFormatter(fn) {
    return {
        code: function(str) {
            return "/* @babel/template */;\n".concat(str);
        },
        validate: function() {},
        unwrap: function(ast) {
            return fn(ast.program.body.slice(1));
        }
    };
}
var smart$1 = makeStatementFormatter(function(body) {
    if (body.length > 1) {
        return body;
    } else {
        return body[0];
    }
});
var statements$1 = makeStatementFormatter(function(body) {
    return body;
});
var statement$1 = makeStatementFormatter(function(body) {
    if (body.length === 0) {
        throw new Error("Found nothing to return.");
    }
    if (body.length > 1) {
        throw new Error("Found multiple statements but wanted one");
    }
    return body[0];
});
var expression$1 = {
    code: function(str) {
        return "(\n".concat(str, "\n)");
    },
    validate: function(ast) {
        if (ast.program.body.length > 1) {
            throw new Error("Found multiple statements but wanted one");
        }
        if (expression$1.unwrap(ast).start === 0) {
            throw new Error("Parse result included parens.");
        }
    },
    unwrap: function(param) {
        var program3 = param.program;
        var _program3_body = _sliced_to_array(program3.body, 1), stmt = _program3_body[0];
        assertExpressionStatement2(stmt);
        return stmt.expression;
    }
};
var program$1 = {
    code: function(str) {
        return str;
    },
    validate: function() {},
    unwrap: function(ast) {
        return ast.program;
    }
};
function _objectWithoutPropertiesLoose2(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var _excluded3 = [
    "placeholderWhitelist",
    "placeholderPattern",
    "preserveComments",
    "syntacticPlaceholders"
];
function merge(a, b) {
    var _b_placeholderWhitelist = b.placeholderWhitelist, placeholderWhitelist = _b_placeholderWhitelist === void 0 ? a.placeholderWhitelist : _b_placeholderWhitelist, _b_placeholderPattern = b.placeholderPattern, placeholderPattern = _b_placeholderPattern === void 0 ? a.placeholderPattern : _b_placeholderPattern, _b_preserveComments = b.preserveComments, preserveComments = _b_preserveComments === void 0 ? a.preserveComments : _b_preserveComments, _b_syntacticPlaceholders = b.syntacticPlaceholders, syntacticPlaceholders = _b_syntacticPlaceholders === void 0 ? a.syntacticPlaceholders : _b_syntacticPlaceholders;
    return {
        parser: Object.assign({}, a.parser, b.parser),
        placeholderWhitelist: placeholderWhitelist,
        placeholderPattern: placeholderPattern,
        preserveComments: preserveComments,
        syntacticPlaceholders: syntacticPlaceholders
    };
}
function validate$12(opts) {
    if (opts != null && typeof opts !== "object") {
        throw new Error("Unknown template options.");
    }
    var _ref = opts || {}, placeholderWhitelist = _ref.placeholderWhitelist, placeholderPattern = _ref.placeholderPattern, preserveComments = _ref.preserveComments, syntacticPlaceholders = _ref.syntacticPlaceholders, parser = _objectWithoutPropertiesLoose2(_ref, _excluded3);
    if (placeholderWhitelist != null && !_instanceof(placeholderWhitelist, Set)) {
        throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
    }
    if (placeholderPattern != null && !_instanceof(placeholderPattern, RegExp) && placeholderPattern !== false) {
        throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
    }
    if (preserveComments != null && typeof preserveComments !== "boolean") {
        throw new Error("'.preserveComments' must be a boolean, null, or undefined");
    }
    if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
        throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
    }
    if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
        throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
    }
    return {
        parser: parser,
        placeholderWhitelist: placeholderWhitelist || void 0,
        placeholderPattern: placeholderPattern == null ? void 0 : placeholderPattern,
        preserveComments: preserveComments == null ? void 0 : preserveComments,
        syntacticPlaceholders: syntacticPlaceholders == null ? void 0 : syntacticPlaceholders
    };
}
function normalizeReplacements(replacements) {
    if (Array.isArray(replacements)) {
        return replacements.reduce(function(acc, replacement, i) {
            acc["$" + i] = replacement;
            return acc;
        }, {});
    } else if (typeof replacements === "object" || replacements == null) {
        return replacements || void 0;
    }
    throw new Error("Template replacements must be an array, object, null, or undefined");
}
var isCallExpression2 = lib_exports.isCallExpression, isExpressionStatement2 = lib_exports.isExpressionStatement, isFunction2 = lib_exports.isFunction, isIdentifier2 = lib_exports.isIdentifier, isJSXIdentifier2 = lib_exports.isJSXIdentifier, isNewExpression2 = lib_exports.isNewExpression, isPlaceholder2 = lib_exports.isPlaceholder, isStatement$1 = lib_exports.isStatement, isStringLiteral$1 = lib_exports.isStringLiteral, removePropertiesDeep2 = lib_exports.removePropertiesDeep, traverse2 = lib_exports.traverse;
var PATTERN = /^[_$A-Z0-9]+$/;
function parseAndBuildMetadata(formatter, code2, opts) {
    var placeholderWhitelist = opts.placeholderWhitelist, placeholderPattern = opts.placeholderPattern, preserveComments = opts.preserveComments, syntacticPlaceholders = opts.syntacticPlaceholders;
    var ast = parseWithCodeFrame(code2, opts.parser, syntacticPlaceholders);
    removePropertiesDeep2(ast, {
        preserveComments: preserveComments
    });
    formatter.validate(ast);
    var state = {
        syntactic: {
            placeholders: [],
            placeholderNames: /* @__PURE__ */ new Set()
        },
        legacy: {
            placeholders: [],
            placeholderNames: /* @__PURE__ */ new Set()
        },
        placeholderWhitelist: placeholderWhitelist,
        placeholderPattern: placeholderPattern,
        syntacticPlaceholders: syntacticPlaceholders
    };
    traverse2(ast, placeholderVisitorHandler, state);
    return Object.assign({
        ast: ast
    }, state.syntactic.placeholders.length ? state.syntactic : state.legacy);
}
function placeholderVisitorHandler(node, ancestors, state) {
    var _state_placeholderWhitelist;
    var name;
    var hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
    if (isPlaceholder2(node)) {
        if (state.syntacticPlaceholders === false) {
            throw new Error("%%foo%%-style placeholders can't be used when '.syntacticPlaceholders' is false.");
        }
        name = node.name.name;
        hasSyntacticPlaceholders = true;
    } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
        return;
    } else if (isIdentifier2(node) || isJSXIdentifier2(node)) {
        name = node.name;
    } else if (isStringLiteral$1(node)) {
        name = node.value;
    } else {
        return;
    }
    if (hasSyntacticPlaceholders && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
        throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
    }
    if (!hasSyntacticPlaceholders && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name)) && !((_state_placeholderWhitelist = state.placeholderWhitelist) === null || _state_placeholderWhitelist === void 0 ? void 0 : _state_placeholderWhitelist.has(name))) {
        return;
    }
    ancestors = ancestors.slice();
    var _ancestors_ = ancestors[ancestors.length - 1], parent = _ancestors_.node, key = _ancestors_.key;
    var type;
    if (isStringLiteral$1(node) || isPlaceholder2(node, {
        expectedNode: "StringLiteral"
    })) {
        type = "string";
    } else if (isNewExpression2(parent) && key === "arguments" || isCallExpression2(parent) && key === "arguments" || isFunction2(parent) && key === "params") {
        type = "param";
    } else if (isExpressionStatement2(parent) && !isPlaceholder2(node)) {
        type = "statement";
        ancestors = ancestors.slice(0, -1);
    } else if (isStatement$1(node) && isPlaceholder2(node)) {
        type = "statement";
    } else {
        type = "other";
    }
    var _ref = !hasSyntacticPlaceholders ? state.legacy : state.syntactic, placeholders2 = _ref.placeholders, placeholderNames = _ref.placeholderNames;
    placeholders2.push({
        name: name,
        type: type,
        resolve: function(ast) {
            return resolveAncestors(ast, ancestors);
        },
        isDuplicate: placeholderNames.has(name)
    });
    placeholderNames.add(name);
}
function resolveAncestors(ast, ancestors) {
    var parent = ast;
    for(var i = 0; i < ancestors.length - 1; i++){
        var _ancestors_i = ancestors[i], key2 = _ancestors_i.key, index4 = _ancestors_i.index;
        if (index4 === void 0) {
            parent = parent[key2];
        } else {
            parent = parent[key2][index4];
        }
    }
    var _ancestors_ = ancestors[ancestors.length - 1], key = _ancestors_.key, index3 = _ancestors_.index;
    return {
        parent: parent,
        key: key,
        index: index3
    };
}
function parseWithCodeFrame(code2, parserOpts, syntacticPlaceholders) {
    var plugins = (parserOpts.plugins || []).slice();
    if (syntacticPlaceholders !== false) {
        plugins.push("placeholders");
    }
    parserOpts = Object.assign({
        allowReturnOutsideFunction: true,
        allowSuperOutsideMethod: true,
        sourceType: "module"
    }, parserOpts, {
        plugins: plugins
    });
    try {
        return parse(code2, parserOpts);
    } catch (err) {
        var loc = err.loc;
        if (loc) {
            err.message += "\n" + codeFrameColumns(code2, {
                start: loc
            });
            err.code = "BABEL_TEMPLATE_PARSE_ERROR";
        }
        throw err;
    }
}
var blockStatement2 = lib_exports.blockStatement, cloneNode2 = lib_exports.cloneNode, emptyStatement2 = lib_exports.emptyStatement, expressionStatement2 = lib_exports.expressionStatement, identifier2 = lib_exports.identifier, isStatement2 = lib_exports.isStatement, isStringLiteral2 = lib_exports.isStringLiteral, stringLiteral2 = lib_exports.stringLiteral, validate2 = lib_exports.validate;
function populatePlaceholders(metadata, replacements) {
    var ast = cloneNode2(metadata.ast);
    if (replacements) {
        metadata.placeholders.forEach(function(placeholder2) {
            if (!Object.prototype.hasOwnProperty.call(replacements, placeholder2.name)) {
                var placeholderName = placeholder2.name;
                throw new Error('Error: No substitution given for "'.concat(placeholderName, "\". If this is not meant to be a\n            placeholder you may want to consider passing one of the following options to @babel/template:\n            - { placeholderPattern: false, placeholderWhitelist: new Set(['").concat(placeholderName, "'])}\n            - { placeholderPattern: /^").concat(placeholderName, "$/ }"));
            }
        });
        Object.keys(replacements).forEach(function(key) {
            if (!metadata.placeholderNames.has(key)) {
                throw new Error('Unknown substitution "'.concat(key, '" given'));
            }
        });
    }
    metadata.placeholders.slice().reverse().forEach(function(placeholder2) {
        try {
            applyReplacement(placeholder2, ast, replacements && replacements[placeholder2.name] || null);
        } catch (e) {
            e.message = '@babel/template placeholder "'.concat(placeholder2.name, '": ').concat(e.message);
            throw e;
        }
    });
    return ast;
}
function applyReplacement(placeholder2, ast, replacement) {
    if (placeholder2.isDuplicate) {
        if (Array.isArray(replacement)) {
            replacement = replacement.map(function(node) {
                return cloneNode2(node);
            });
        } else if (typeof replacement === "object") {
            replacement = cloneNode2(replacement);
        }
    }
    var _placeholder2_resolve = placeholder2.resolve(ast), parent = _placeholder2_resolve.parent, key = _placeholder2_resolve.key, index3 = _placeholder2_resolve.index;
    if (placeholder2.type === "string") {
        if (typeof replacement === "string") {
            replacement = stringLiteral2(replacement);
        }
        if (!replacement || !isStringLiteral2(replacement)) {
            throw new Error("Expected string substitution");
        }
    } else if (placeholder2.type === "statement") {
        if (index3 === void 0) {
            if (!replacement) {
                replacement = emptyStatement2();
            } else if (Array.isArray(replacement)) {
                replacement = blockStatement2(replacement);
            } else if (typeof replacement === "string") {
                replacement = expressionStatement2(identifier2(replacement));
            } else if (!isStatement2(replacement)) {
                replacement = expressionStatement2(replacement);
            }
        } else {
            if (replacement && !Array.isArray(replacement)) {
                if (typeof replacement === "string") {
                    replacement = identifier2(replacement);
                }
                if (!isStatement2(replacement)) {
                    replacement = expressionStatement2(replacement);
                }
            }
        }
    } else if (placeholder2.type === "param") {
        if (typeof replacement === "string") {
            replacement = identifier2(replacement);
        }
        if (index3 === void 0) throw new Error("Assertion failure.");
    } else {
        if (typeof replacement === "string") {
            replacement = identifier2(replacement);
        }
        if (Array.isArray(replacement)) {
            throw new Error("Cannot replace single expression with an array.");
        }
    }
    if (index3 === void 0) {
        validate2(parent, key, replacement);
        parent[key] = replacement;
    } else {
        var items = parent[key].slice();
        if (placeholder2.type === "statement" || placeholder2.type === "param") {
            if (replacement == null) {
                items.splice(index3, 1);
            } else if (Array.isArray(replacement)) {
                var _items;
                (_items = items).splice.apply(_items, [
                    index3,
                    1
                ].concat(_to_consumable_array(replacement)));
            } else {
                items[index3] = replacement;
            }
        } else {
            items[index3] = replacement;
        }
        validate2(parent, key, items);
        parent[key] = items;
    }
}
function stringTemplate(formatter, code2, opts) {
    code2 = formatter.code(code2);
    var metadata;
    return function(arg) {
        var replacements = normalizeReplacements(arg);
        if (!metadata) metadata = parseAndBuildMetadata(formatter, code2, opts);
        return formatter.unwrap(populatePlaceholders(metadata, replacements));
    };
}
function literalTemplate(formatter, tpl, opts) {
    var _buildLiteralData = buildLiteralData(formatter, tpl, opts), metadata = _buildLiteralData.metadata, names = _buildLiteralData.names;
    return function(arg) {
        var defaultReplacements = {};
        arg.forEach(function(replacement, i) {
            defaultReplacements[names[i]] = replacement;
        });
        return function(arg2) {
            var replacements = normalizeReplacements(arg2);
            if (replacements) {
                Object.keys(replacements).forEach(function(key) {
                    if (Object.prototype.hasOwnProperty.call(defaultReplacements, key)) {
                        throw new Error("Unexpected replacement overlap.");
                    }
                });
            }
            return formatter.unwrap(populatePlaceholders(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
        };
    };
}
function buildLiteralData(formatter, tpl, opts) {
    var prefix2 = "BABEL_TPL$";
    var raw = tpl.join("");
    do {
        prefix2 = "$$" + prefix2;
    }while (raw.includes(prefix2));
    var _buildTemplateCode = buildTemplateCode(tpl, prefix2), names = _buildTemplateCode.names, code2 = _buildTemplateCode.code;
    var metadata = parseAndBuildMetadata(formatter, formatter.code(code2), {
        parser: opts.parser,
        placeholderWhitelist: new Set(names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
        placeholderPattern: opts.placeholderPattern,
        preserveComments: opts.preserveComments,
        syntacticPlaceholders: opts.syntacticPlaceholders
    });
    return {
        metadata: metadata,
        names: names
    };
}
function buildTemplateCode(tpl, prefix2) {
    var names = [];
    var code2 = tpl[0];
    for(var i = 1; i < tpl.length; i++){
        var value1 = "".concat(prefix2).concat(i - 1);
        names.push(value1);
        code2 += value1 + tpl[i];
    }
    return {
        names: names,
        code: code2
    };
}
var NO_PLACEHOLDER = validate$12({
    placeholderPattern: false
});
function createTemplateBuilder(formatter, defaultOpts) {
    var templateFnCache = /* @__PURE__ */ new WeakMap();
    var templateAstCache = /* @__PURE__ */ new WeakMap();
    var cachedOpts = defaultOpts || validate$12(null);
    return Object.assign(function(tpl) {
        for(var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++){
            args[_key - 1] = arguments[_key];
        }
        if (typeof tpl === "string") {
            if (args.length > 1) throw new Error("Unexpected extra params.");
            return extendedTrace(stringTemplate(formatter, tpl, merge(cachedOpts, validate$12(args[0]))));
        } else if (Array.isArray(tpl)) {
            var builder = templateFnCache.get(tpl);
            if (!builder) {
                builder = literalTemplate(formatter, tpl, cachedOpts);
                templateFnCache.set(tpl, builder);
            }
            return extendedTrace(builder(args));
        } else if (typeof tpl === "object" && tpl) {
            if (args.length > 0) throw new Error("Unexpected extra params.");
            return createTemplateBuilder(formatter, merge(cachedOpts, validate$12(tpl)));
        }
        throw new Error("Unexpected template param ".concat(typeof tpl === "undefined" ? "undefined" : _type_of(tpl)));
    }, {
        ast: function(tpl) {
            for(var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++){
                args[_key - 1] = arguments[_key];
            }
            if (typeof tpl === "string") {
                if (args.length > 1) throw new Error("Unexpected extra params.");
                return stringTemplate(formatter, tpl, merge(merge(cachedOpts, validate$12(args[0])), NO_PLACEHOLDER))();
            } else if (Array.isArray(tpl)) {
                var builder = templateAstCache.get(tpl);
                if (!builder) {
                    builder = literalTemplate(formatter, tpl, merge(cachedOpts, NO_PLACEHOLDER));
                    templateAstCache.set(tpl, builder);
                }
                return builder(args)();
            }
            throw new Error("Unexpected template param ".concat(typeof tpl === "undefined" ? "undefined" : _type_of(tpl)));
        }
    });
}
function extendedTrace(fn) {
    var rootStack = "";
    try {
        throw new Error();
    } catch (error) {
        if (error.stack) {
            rootStack = error.stack.split("\n").slice(3).join("\n");
        }
    }
    return function(arg) {
        try {
            return fn(arg);
        } catch (err) {
            err.stack += "\n    =============\n".concat(rootStack);
            throw err;
        }
    };
}
var smart = createTemplateBuilder(smart$1);
var statement = createTemplateBuilder(statement$1);
var statements = createTemplateBuilder(statements$1);
var expression = createTemplateBuilder(expression$1);
var program2 = createTemplateBuilder(program$1);
var index = Object.assign(smart.bind(void 0), {
    smart: smart,
    statement: statement,
    statements: statements,
    expression: expression,
    program: program2,
    ast: smart.ast
});
// node_modules/@jridgewell/set-array/dist/set-array.mjs
var get;
var put;
var pop;
var SetArray = function SetArray() {
    "use strict";
    _class_call_check(this, SetArray);
    this._indexes = {
        __proto__: null
    };
    this.array = [];
};
(function() {
    get = function(strarr, key) {
        return strarr._indexes[key];
    };
    put = function(strarr, key) {
        var index3 = get(strarr, key);
        if (index3 !== void 0) return index3;
        var array = strarr.array, indexes = strarr._indexes;
        return indexes[key] = array.push(key) - 1;
    };
    pop = function(strarr) {
        var array = strarr.array, indexes = strarr._indexes;
        if (array.length === 0) return;
        var last2 = array.pop();
        indexes[last2] = void 0;
    };
})();
// node_modules/@jridgewell/sourcemap-codec/dist/sourcemap-codec.mjs
var comma = ",".charCodeAt(0);
var semicolon = ";".charCodeAt(0);
var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var intToChar = new Uint8Array(64);
var charToInt = new Uint8Array(128);
for(var i = 0; i < chars.length; i++){
    var c = chars.charCodeAt(i);
    intToChar[i] = c;
    charToInt[c] = i;
}
var td = typeof TextDecoder !== "undefined" ? /* @__PURE__ */ new TextDecoder() : typeof Buffer !== "undefined" ? {
    decode: function decode(buf) {
        var out = Buffer.from(buf.buffer, buf.byteOffset, buf.byteLength);
        return out.toString();
    }
} : {
    decode: function decode(buf) {
        var out = "";
        for(var i = 0; i < buf.length; i++){
            out += String.fromCharCode(buf[i]);
        }
        return out;
    }
};
function decode(mappings) {
    var state = new Int32Array(5);
    var decoded = [];
    var index3 = 0;
    do {
        var semi = indexOf(mappings, index3);
        var line = [];
        var sorted = true;
        var lastCol = 0;
        state[0] = 0;
        for(var i = index3; i < semi; i++){
            var seg = void 0;
            i = decodeInteger(mappings, i, state, 0);
            var col = state[0];
            if (col < lastCol) sorted = false;
            lastCol = col;
            if (hasMoreVlq(mappings, i, semi)) {
                i = decodeInteger(mappings, i, state, 1);
                i = decodeInteger(mappings, i, state, 2);
                i = decodeInteger(mappings, i, state, 3);
                if (hasMoreVlq(mappings, i, semi)) {
                    i = decodeInteger(mappings, i, state, 4);
                    seg = [
                        col,
                        state[1],
                        state[2],
                        state[3],
                        state[4]
                    ];
                } else {
                    seg = [
                        col,
                        state[1],
                        state[2],
                        state[3]
                    ];
                }
            } else {
                seg = [
                    col
                ];
            }
            line.push(seg);
        }
        if (!sorted) sort(line);
        decoded.push(line);
        index3 = semi + 1;
    }while (index3 <= mappings.length);
    return decoded;
}
function indexOf(mappings, index3) {
    var idx = mappings.indexOf(";", index3);
    return idx === -1 ? mappings.length : idx;
}
function decodeInteger(mappings, pos, state, j) {
    var value1 = 0;
    var shift = 0;
    var integer = 0;
    do {
        var c = mappings.charCodeAt(pos++);
        integer = charToInt[c];
        value1 |= (integer & 31) << shift;
        shift += 5;
    }while (integer & 32);
    var shouldNegate = value1 & 1;
    value1 >>>= 1;
    if (shouldNegate) {
        value1 = -2147483648 | -value1;
    }
    state[j] += value1;
    return pos;
}
function hasMoreVlq(mappings, i, length) {
    if (i >= length) return false;
    return mappings.charCodeAt(i) !== comma;
}
function sort(line) {
    line.sort(sortComparator);
}
function sortComparator(a, b) {
    return a[0] - b[0];
}
function encode(decoded) {
    var state = new Int32Array(5);
    var bufLength = 1024 * 16;
    var subLength = bufLength - 36;
    var buf = new Uint8Array(bufLength);
    var sub = buf.subarray(0, subLength);
    var pos = 0;
    var out = "";
    for(var i = 0; i < decoded.length; i++){
        var line = decoded[i];
        if (i > 0) {
            if (pos === bufLength) {
                out += td.decode(buf);
                pos = 0;
            }
            buf[pos++] = semicolon;
        }
        if (line.length === 0) continue;
        state[0] = 0;
        for(var j = 0; j < line.length; j++){
            var segment = line[j];
            if (pos > subLength) {
                out += td.decode(sub);
                buf.copyWithin(0, subLength, pos);
                pos -= subLength;
            }
            if (j > 0) buf[pos++] = comma;
            pos = encodeInteger(buf, pos, state, segment, 0);
            if (segment.length === 1) continue;
            pos = encodeInteger(buf, pos, state, segment, 1);
            pos = encodeInteger(buf, pos, state, segment, 2);
            pos = encodeInteger(buf, pos, state, segment, 3);
            if (segment.length === 4) continue;
            pos = encodeInteger(buf, pos, state, segment, 4);
        }
    }
    return out + td.decode(buf.subarray(0, pos));
}
function encodeInteger(buf, pos, state, segment, j) {
    var next = segment[j];
    var num = next - state[j];
    state[j] = next;
    num = num < 0 ? -num << 1 | 1 : num << 1;
    do {
        var clamped = num & 31;
        num >>>= 5;
        if (num > 0) clamped |= 32;
        buf[pos++] = intToChar[clamped];
    }while (num > 0);
    return pos;
}
// node_modules/@jridgewell/resolve-uri/dist/resolve-uri.mjs
var schemeRegex = /^[\w+.-]+:\/\//;
var urlRegex = /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
var fileRegex = /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
var UrlType;
(function(UrlType2) {
    UrlType2[UrlType2["Empty"] = 1] = "Empty";
    UrlType2[UrlType2["Hash"] = 2] = "Hash";
    UrlType2[UrlType2["Query"] = 3] = "Query";
    UrlType2[UrlType2["RelativePath"] = 4] = "RelativePath";
    UrlType2[UrlType2["AbsolutePath"] = 5] = "AbsolutePath";
    UrlType2[UrlType2["SchemeRelative"] = 6] = "SchemeRelative";
    UrlType2[UrlType2["Absolute"] = 7] = "Absolute";
})(UrlType || (UrlType = {}));
function isAbsoluteUrl(input) {
    return schemeRegex.test(input);
}
function isSchemeRelativeUrl(input) {
    return input.startsWith("//");
}
function isAbsolutePath(input) {
    return input.startsWith("/");
}
function isFileUrl(input) {
    return input.startsWith("file:");
}
function isRelative(input) {
    return /^[.?#]/.test(input);
}
function parseAbsoluteUrl(input) {
    var match = urlRegex.exec(input);
    return makeUrl(match[1], match[2] || "", match[3], match[4] || "", match[5] || "/", match[6] || "", match[7] || "");
}
function parseFileUrl(input) {
    var match = fileRegex.exec(input);
    var path = match[2];
    return makeUrl("file:", "", match[1] || "", "", isAbsolutePath(path) ? path : "/" + path, match[3] || "", match[4] || "");
}
function makeUrl(scheme, user, host, port, path, query, hash) {
    return {
        scheme: scheme,
        user: user,
        host: host,
        port: port,
        path: path,
        query: query,
        hash: hash,
        type: UrlType.Absolute
    };
}
function parseUrl(input) {
    if (isSchemeRelativeUrl(input)) {
        var url2 = parseAbsoluteUrl("http:" + input);
        url2.scheme = "";
        url2.type = UrlType.SchemeRelative;
        return url2;
    }
    if (isAbsolutePath(input)) {
        var url21 = parseAbsoluteUrl("http://foo.com" + input);
        url21.scheme = "";
        url21.host = "";
        url21.type = UrlType.AbsolutePath;
        return url21;
    }
    if (isFileUrl(input)) return parseFileUrl(input);
    if (isAbsoluteUrl(input)) return parseAbsoluteUrl(input);
    var url = parseAbsoluteUrl("http://foo.com/" + input);
    url.scheme = "";
    url.host = "";
    url.type = input ? input.startsWith("?") ? UrlType.Query : input.startsWith("#") ? UrlType.Hash : UrlType.RelativePath : UrlType.Empty;
    return url;
}
function stripPathFilename(path) {
    if (path.endsWith("/..")) return path;
    var index3 = path.lastIndexOf("/");
    return path.slice(0, index3 + 1);
}
function mergePaths(url, base) {
    normalizePath(base, base.type);
    if (url.path === "/") {
        url.path = base.path;
    } else {
        url.path = stripPathFilename(base.path) + url.path;
    }
}
function normalizePath(url, type) {
    var rel = type <= UrlType.RelativePath;
    var pieces = url.path.split("/");
    var pointer = 1;
    var positive = 0;
    var addTrailingSlash = false;
    for(var i = 1; i < pieces.length; i++){
        var piece = pieces[i];
        if (!piece) {
            addTrailingSlash = true;
            continue;
        }
        addTrailingSlash = false;
        if (piece === ".") continue;
        if (piece === "..") {
            if (positive) {
                addTrailingSlash = true;
                positive--;
                pointer--;
            } else if (rel) {
                pieces[pointer++] = piece;
            }
            continue;
        }
        pieces[pointer++] = piece;
        positive++;
    }
    var path = "";
    for(var i1 = 1; i1 < pointer; i1++){
        path += "/" + pieces[i1];
    }
    if (!path || addTrailingSlash && !path.endsWith("/..")) {
        path += "/";
    }
    url.path = path;
}
function resolve(input, base) {
    if (!input && !base) return "";
    var url = parseUrl(input);
    var inputType = url.type;
    if (base && inputType !== UrlType.Absolute) {
        var baseUrl = parseUrl(base);
        var baseType = baseUrl.type;
        switch(inputType){
            case UrlType.Empty:
                url.hash = baseUrl.hash;
            case UrlType.Hash:
                url.query = baseUrl.query;
            case UrlType.Query:
            case UrlType.RelativePath:
                mergePaths(url, baseUrl);
            case UrlType.AbsolutePath:
                url.user = baseUrl.user;
                url.host = baseUrl.host;
                url.port = baseUrl.port;
            case UrlType.SchemeRelative:
                url.scheme = baseUrl.scheme;
        }
        if (baseType > inputType) inputType = baseType;
    }
    normalizePath(url, inputType);
    var queryHash = url.query + url.hash;
    switch(inputType){
        case UrlType.Hash:
        case UrlType.Query:
            return queryHash;
        case UrlType.RelativePath:
            {
                var path = url.path.slice(1);
                if (!path) return queryHash || ".";
                if (isRelative(base || input) && !isRelative(path)) {
                    return "./" + path + queryHash;
                }
                return path + queryHash;
            }
        case UrlType.AbsolutePath:
            return url.path + queryHash;
        default:
            return url.scheme + "//" + url.user + url.host + url.port + url.path + queryHash;
    }
}
// node_modules/@jridgewell/trace-mapping/dist/trace-mapping.mjs
function resolve2(input, base) {
    if (base && !base.endsWith("/")) base += "/";
    return resolve(input, base);
}
function stripFilename(path) {
    if (!path) return "";
    var index3 = path.lastIndexOf("/");
    return path.slice(0, index3 + 1);
}
var COLUMN = 0;
var SOURCES_INDEX = 1;
var SOURCE_LINE = 2;
var SOURCE_COLUMN = 3;
var NAMES_INDEX = 4;
var REV_GENERATED_LINE = 1;
var REV_GENERATED_COLUMN = 2;
function maybeSort(mappings, owned) {
    var unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
    if (unsortedIndex === mappings.length) return mappings;
    if (!owned) mappings = mappings.slice();
    for(var i = unsortedIndex; i < mappings.length; i = nextUnsortedSegmentLine(mappings, i + 1)){
        mappings[i] = sortSegments(mappings[i], owned);
    }
    return mappings;
}
function nextUnsortedSegmentLine(mappings, start) {
    for(var i = start; i < mappings.length; i++){
        if (!isSorted(mappings[i])) return i;
    }
    return mappings.length;
}
function isSorted(line) {
    for(var j = 1; j < line.length; j++){
        if (line[j][COLUMN] < line[j - 1][COLUMN]) {
            return false;
        }
    }
    return true;
}
function sortSegments(line, owned) {
    if (!owned) line = line.slice();
    return line.sort(sortComparator2);
}
function sortComparator2(a, b) {
    return a[COLUMN] - b[COLUMN];
}
var found = false;
function binarySearch(haystack, needle, low, high) {
    while(low <= high){
        var mid = low + (high - low >> 1);
        var cmp = haystack[mid][COLUMN] - needle;
        if (cmp === 0) {
            found = true;
            return mid;
        }
        if (cmp < 0) {
            low = mid + 1;
        } else {
            high = mid - 1;
        }
    }
    found = false;
    return low - 1;
}
function upperBound(haystack, needle, index3) {
    for(var i = index3 + 1; i < haystack.length; index3 = i++){
        if (haystack[i][COLUMN] !== needle) break;
    }
    return index3;
}
function lowerBound(haystack, needle, index3) {
    for(var i = index3 - 1; i >= 0; index3 = i--){
        if (haystack[i][COLUMN] !== needle) break;
    }
    return index3;
}
function memoizedState() {
    return {
        lastKey: -1,
        lastNeedle: -1,
        lastIndex: -1
    };
}
function memoizedBinarySearch(haystack, needle, state, key) {
    var lastKey = state.lastKey, lastNeedle = state.lastNeedle, lastIndex = state.lastIndex;
    var low = 0;
    var high = haystack.length - 1;
    if (key === lastKey) {
        if (needle === lastNeedle) {
            found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
            return lastIndex;
        }
        if (needle >= lastNeedle) {
            low = lastIndex === -1 ? 0 : lastIndex;
        } else {
            high = lastIndex;
        }
    }
    state.lastKey = key;
    state.lastNeedle = needle;
    return state.lastIndex = binarySearch(haystack, needle, low, high);
}
function buildBySources(decoded, memos) {
    var sources = memos.map(buildNullArray);
    for(var i = 0; i < decoded.length; i++){
        var line = decoded[i];
        for(var j = 0; j < line.length; j++){
            var seg = line[j];
            if (seg.length === 1) continue;
            var sourceIndex = seg[SOURCES_INDEX];
            var sourceLine = seg[SOURCE_LINE];
            var sourceColumn = seg[SOURCE_COLUMN];
            var originalSource = sources[sourceIndex];
            var originalLine = originalSource[sourceLine] || (originalSource[sourceLine] = []);
            var memo = memos[sourceIndex];
            var index3 = upperBound(originalLine, sourceColumn, memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine));
            insert(originalLine, memo.lastIndex = index3 + 1, [
                sourceColumn,
                i,
                seg[COLUMN]
            ]);
        }
    }
    return sources;
}
function insert(array, index3, value1) {
    for(var i = array.length; i > index3; i--){
        array[i] = array[i - 1];
    }
    array[index3] = value1;
}
function buildNullArray() {
    return {
        __proto__: null
    };
}
var LINE_GTR_ZERO = "`line` must be greater than 0 (lines start at line 1)";
var COL_GTR_EQ_ZERO = "`column` must be greater than or equal to 0 (columns start at column 0)";
var LEAST_UPPER_BOUND = -1;
var GREATEST_LOWER_BOUND = 1;
var encodedMappings;
var decodedMappings;
var traceSegment;
var originalPositionFor;
var generatedPositionFor;
var allGeneratedPositionsFor;
var eachMapping;
var sourceContentFor;
var presortedDecodedMap;
var decodedMap;
var encodedMap;
var TraceMap = function TraceMap(map, mapUrl) {
    "use strict";
    _class_call_check(this, TraceMap);
    var isString = typeof map === "string";
    if (!isString && map._decodedMemo) return map;
    var parsed = isString ? JSON.parse(map) : map;
    var version = parsed.version, file2 = parsed.file, names = parsed.names, sourceRoot = parsed.sourceRoot, sources = parsed.sources, sourcesContent = parsed.sourcesContent;
    this.version = version;
    this.file = file2;
    this.names = names || [];
    this.sourceRoot = sourceRoot;
    this.sources = sources;
    this.sourcesContent = sourcesContent;
    var from = resolve2(sourceRoot || "", stripFilename(mapUrl));
    this.resolvedSources = sources.map(function(s) {
        return resolve2(s || "", from);
    });
    var mappings = parsed.mappings;
    if (typeof mappings === "string") {
        this._encoded = mappings;
        this._decoded = void 0;
    } else {
        this._encoded = void 0;
        this._decoded = maybeSort(mappings, isString);
    }
    this._decodedMemo = memoizedState();
    this._bySources = void 0;
    this._bySourceMemos = void 0;
};
(function() {
    var generatedPosition = function generatedPosition(map, source, line, column, bias, all) {
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        var sources = map.sources, resolvedSources = map.resolvedSources;
        var sourceIndex = sources.indexOf(source);
        if (sourceIndex === -1) sourceIndex = resolvedSources.indexOf(source);
        if (sourceIndex === -1) return all ? [] : GMapping(null, null);
        var generated = map._bySources || (map._bySources = buildBySources(decodedMappings(map), map._bySourceMemos = sources.map(memoizedState)));
        var segments = generated[sourceIndex][line];
        if (segments == null) return all ? [] : GMapping(null, null);
        var memo = map._bySourceMemos[sourceIndex];
        if (all) return sliceGeneratedPositions(segments, memo, line, column, bias);
        var index3 = traceSegmentInternal(segments, memo, line, column, bias);
        if (index3 === -1) return GMapping(null, null);
        var segment = segments[index3];
        return GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]);
    };
    encodedMappings = function(map) {
        var _a;
        return (_a = map._encoded) !== null && _a !== void 0 ? _a : map._encoded = encode(map._decoded);
    };
    decodedMappings = function(map) {
        return map._decoded || (map._decoded = decode(map._encoded));
    };
    traceSegment = function(map, line, column) {
        var decoded = decodedMappings(map);
        if (line >= decoded.length) return null;
        var segments = decoded[line];
        var index3 = traceSegmentInternal(segments, map._decodedMemo, line, column, GREATEST_LOWER_BOUND);
        return index3 === -1 ? null : segments[index3];
    };
    originalPositionFor = function(map, param) {
        var line = param.line, column = param.column, bias = param.bias;
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        var decoded = decodedMappings(map);
        if (line >= decoded.length) return OMapping(null, null, null, null);
        var segments = decoded[line];
        var index3 = traceSegmentInternal(segments, map._decodedMemo, line, column, bias || GREATEST_LOWER_BOUND);
        if (index3 === -1) return OMapping(null, null, null, null);
        var segment = segments[index3];
        if (segment.length === 1) return OMapping(null, null, null, null);
        var names = map.names, resolvedSources = map.resolvedSources;
        return OMapping(resolvedSources[segment[SOURCES_INDEX]], segment[SOURCE_LINE] + 1, segment[SOURCE_COLUMN], segment.length === 5 ? names[segment[NAMES_INDEX]] : null);
    };
    allGeneratedPositionsFor = function(map, param) {
        var source = param.source, line = param.line, column = param.column, bias = param.bias;
        return generatedPosition(map, source, line, column, bias || LEAST_UPPER_BOUND, true);
    };
    generatedPositionFor = function(map, param) {
        var source = param.source, line = param.line, column = param.column, bias = param.bias;
        return generatedPosition(map, source, line, column, bias || GREATEST_LOWER_BOUND, false);
    };
    eachMapping = function(map, cb) {
        var decoded = decodedMappings(map);
        var names = map.names, resolvedSources = map.resolvedSources;
        for(var i = 0; i < decoded.length; i++){
            var line = decoded[i];
            for(var j = 0; j < line.length; j++){
                var seg = line[j];
                var generatedLine = i + 1;
                var generatedColumn = seg[0];
                var source = null;
                var originalLine = null;
                var originalColumn = null;
                var name = null;
                if (seg.length !== 1) {
                    source = resolvedSources[seg[1]];
                    originalLine = seg[2] + 1;
                    originalColumn = seg[3];
                }
                if (seg.length === 5) name = names[seg[4]];
                cb({
                    generatedLine: generatedLine,
                    generatedColumn: generatedColumn,
                    source: source,
                    originalLine: originalLine,
                    originalColumn: originalColumn,
                    name: name
                });
            }
        }
    };
    sourceContentFor = function(map, source) {
        var sources = map.sources, resolvedSources = map.resolvedSources, sourcesContent = map.sourcesContent;
        if (sourcesContent == null) return null;
        var index3 = sources.indexOf(source);
        if (index3 === -1) index3 = resolvedSources.indexOf(source);
        return index3 === -1 ? null : sourcesContent[index3];
    };
    presortedDecodedMap = function(map, mapUrl) {
        var tracer = new TraceMap(clone2(map, []), mapUrl);
        tracer._decoded = map.mappings;
        return tracer;
    };
    decodedMap = function(map) {
        return clone2(map, decodedMappings(map));
    };
    encodedMap = function(map) {
        return clone2(map, encodedMappings(map));
    };
})();
function clone2(map, mappings) {
    return {
        version: map.version,
        file: map.file,
        names: map.names,
        sourceRoot: map.sourceRoot,
        sources: map.sources,
        sourcesContent: map.sourcesContent,
        mappings: mappings
    };
}
function OMapping(source, line, column, name) {
    return {
        source: source,
        line: line,
        column: column,
        name: name
    };
}
function GMapping(line, column) {
    return {
        line: line,
        column: column
    };
}
function traceSegmentInternal(segments, memo, line, column, bias) {
    var index3 = memoizedBinarySearch(segments, column, memo, line);
    if (found) {
        index3 = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(segments, column, index3);
    } else if (bias === LEAST_UPPER_BOUND) index3++;
    if (index3 === -1 || index3 === segments.length) return -1;
    return index3;
}
function sliceGeneratedPositions(segments, memo, line, column, bias) {
    var min = traceSegmentInternal(segments, memo, line, column, GREATEST_LOWER_BOUND);
    if (!found && bias === LEAST_UPPER_BOUND) min++;
    if (min === -1 || min === segments.length) return [];
    var matchedColumn = found ? column : segments[min][COLUMN];
    if (!found) min = lowerBound(segments, matchedColumn, min);
    var max = upperBound(segments, matchedColumn, min);
    var result = [];
    for(; min <= max; min++){
        var segment = segments[min];
        result.push(GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]));
    }
    return result;
}
// node_modules/@jridgewell/gen-mapping/dist/gen-mapping.mjs
var COLUMN2 = 0;
var SOURCES_INDEX2 = 1;
var SOURCE_LINE2 = 2;
var SOURCE_COLUMN2 = 3;
var NAMES_INDEX2 = 4;
var NO_NAME = -1;
var addSegment;
var addMapping;
var maybeAddSegment;
var maybeAddMapping;
var setSourceContent;
var toDecodedMap;
var toEncodedMap;
var fromMap;
var allMappings;
var addSegmentInternal;
var GenMapping = function GenMapping() {
    "use strict";
    var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, file2 = _ref.file, sourceRoot = _ref.sourceRoot;
    _class_call_check(this, GenMapping);
    this._names = new SetArray();
    this._sources = new SetArray();
    this._sourcesContent = [];
    this._mappings = [];
    this.file = file2;
    this.sourceRoot = sourceRoot;
};
(function() {
    addSegment = function(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
        return addSegmentInternal(false, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
    };
    maybeAddSegment = function(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
        return addSegmentInternal(true, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
    };
    addMapping = function(map, mapping) {
        return addMappingInternal(false, map, mapping);
    };
    maybeAddMapping = function(map, mapping) {
        return addMappingInternal(true, map, mapping);
    };
    setSourceContent = function(map, source, content) {
        var sources = map._sources, sourcesContent = map._sourcesContent;
        sourcesContent[put(sources, source)] = content;
    };
    toDecodedMap = function(map) {
        var file2 = map.file, sourceRoot = map.sourceRoot, mappings = map._mappings, sources = map._sources, sourcesContent = map._sourcesContent, names = map._names;
        removeEmptyFinalLines(mappings);
        return {
            version: 3,
            file: file2 || void 0,
            names: names.array,
            sourceRoot: sourceRoot || void 0,
            sources: sources.array,
            sourcesContent: sourcesContent,
            mappings: mappings
        };
    };
    toEncodedMap = function(map) {
        var decoded = toDecodedMap(map);
        return Object.assign(Object.assign({}, decoded), {
            mappings: encode(decoded.mappings)
        });
    };
    allMappings = function(map) {
        var out = [];
        var mappings = map._mappings, sources = map._sources, names = map._names;
        for(var i = 0; i < mappings.length; i++){
            var line = mappings[i];
            for(var j = 0; j < line.length; j++){
                var seg = line[j];
                var generated = {
                    line: i + 1,
                    column: seg[COLUMN2]
                };
                var source = void 0;
                var original = void 0;
                var name = void 0;
                if (seg.length !== 1) {
                    source = sources.array[seg[SOURCES_INDEX2]];
                    original = {
                        line: seg[SOURCE_LINE2] + 1,
                        column: seg[SOURCE_COLUMN2]
                    };
                    if (seg.length === 5) name = names.array[seg[NAMES_INDEX2]];
                }
                out.push({
                    generated: generated,
                    source: source,
                    original: original,
                    name: name
                });
            }
        }
        return out;
    };
    fromMap = function(input) {
        var map = new TraceMap(input);
        var gen = new GenMapping({
            file: map.file,
            sourceRoot: map.sourceRoot
        });
        putAll(gen._names, map.names);
        putAll(gen._sources, map.sources);
        gen._sourcesContent = map.sourcesContent || map.sources.map(function() {
            return null;
        });
        gen._mappings = decodedMappings(map);
        return gen;
    };
    addSegmentInternal = function(skipable, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
        var mappings = map._mappings, sources = map._sources, sourcesContent = map._sourcesContent, names = map._names;
        var line = getLine(mappings, genLine);
        var index3 = getColumnIndex(line, genColumn);
        if (!source) {
            if (skipable && skipSourceless(line, index3)) return;
            return insert2(line, index3, [
                genColumn
            ]);
        }
        var sourcesIndex = put(sources, source);
        var namesIndex = name ? put(names, name) : NO_NAME;
        if (sourcesIndex === sourcesContent.length) sourcesContent[sourcesIndex] = content !== null && content !== void 0 ? content : null;
        if (skipable && skipSource(line, index3, sourcesIndex, sourceLine, sourceColumn, namesIndex)) {
            return;
        }
        return insert2(line, index3, name ? [
            genColumn,
            sourcesIndex,
            sourceLine,
            sourceColumn,
            namesIndex
        ] : [
            genColumn,
            sourcesIndex,
            sourceLine,
            sourceColumn
        ]);
    };
})();
function getLine(mappings, index3) {
    for(var i = mappings.length; i <= index3; i++){
        mappings[i] = [];
    }
    return mappings[index3];
}
function getColumnIndex(line, genColumn) {
    var index3 = line.length;
    for(var i = index3 - 1; i >= 0; index3 = i--){
        var current = line[i];
        if (genColumn >= current[COLUMN2]) break;
    }
    return index3;
}
function insert2(array, index3, value1) {
    for(var i = array.length; i > index3; i--){
        array[i] = array[i - 1];
    }
    array[index3] = value1;
}
function removeEmptyFinalLines(mappings) {
    var length = mappings.length;
    var len = length;
    for(var i = len - 1; i >= 0; len = i, i--){
        if (mappings[i].length > 0) break;
    }
    if (len < length) mappings.length = len;
}
function putAll(strarr, array) {
    for(var i = 0; i < array.length; i++)put(strarr, array[i]);
}
function skipSourceless(line, index3) {
    if (index3 === 0) return true;
    var prev = line[index3 - 1];
    return prev.length === 1;
}
function skipSource(line, index3, sourcesIndex, sourceLine, sourceColumn, namesIndex) {
    if (index3 === 0) return false;
    var prev = line[index3 - 1];
    if (prev.length === 1) return false;
    return sourcesIndex === prev[SOURCES_INDEX2] && sourceLine === prev[SOURCE_LINE2] && sourceColumn === prev[SOURCE_COLUMN2] && namesIndex === (prev.length === 5 ? prev[NAMES_INDEX2] : NO_NAME);
}
function addMappingInternal(skipable, map, mapping) {
    var generated = mapping.generated, source = mapping.source, original = mapping.original, name = mapping.name, content = mapping.content;
    if (!source) {
        return addSegmentInternal(skipable, map, generated.line - 1, generated.column, null, null, null, null, null);
    }
    var s = source;
    return addSegmentInternal(skipable, map, generated.line - 1, generated.column, s, original.line - 1, original.column, name, content);
}
// node_modules/@babel/generator/lib/index.js
var import_jsesc = __toESM(require_jsesc(), 1);
var SourceMap = /*#__PURE__*/ function() {
    "use strict";
    function SourceMap(opts, code2) {
        _class_call_check(this, SourceMap);
        var _opts_sourceFileName;
        __publicField(this, "_map");
        __publicField(this, "_rawMappings");
        __publicField(this, "_sourceFileName");
        __publicField(this, "_lastGenLine", 0);
        __publicField(this, "_lastSourceLine", 0);
        __publicField(this, "_lastSourceColumn", 0);
        __publicField(this, "_inputMap");
        var map = this._map = new GenMapping({
            sourceRoot: opts.sourceRoot
        });
        this._sourceFileName = (_opts_sourceFileName = opts.sourceFileName) === null || _opts_sourceFileName === void 0 ? void 0 : _opts_sourceFileName.replace(/\\/g, "/");
        this._rawMappings = void 0;
        if (opts.inputSourceMap) {
            this._inputMap = new TraceMap(opts.inputSourceMap);
            var resolvedSources = this._inputMap.resolvedSources;
            if (resolvedSources.length) {
                for(var i = 0; i < resolvedSources.length; i++){
                    var _this__inputMap_sourcesContent;
                    setSourceContent(map, resolvedSources[i], (_this__inputMap_sourcesContent = this._inputMap.sourcesContent) === null || _this__inputMap_sourcesContent === void 0 ? void 0 : _this__inputMap_sourcesContent[i]);
                }
            }
        }
        if (typeof code2 === "string" && !opts.inputSourceMap) {
            setSourceContent(map, this._sourceFileName, code2);
        } else if (typeof code2 === "object") {
            var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
            try {
                for(var _iterator = Object.keys(code2)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                    var sourceFileName = _step.value;
                    setSourceContent(map, sourceFileName.replace(/\\/g, "/"), code2[sourceFileName]);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                } finally{
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }
    _create_class(SourceMap, [
        {
            key: "get",
            value: function get() {
                return toEncodedMap(this._map);
            }
        },
        {
            key: "getDecoded",
            value: function getDecoded() {
                return toDecodedMap(this._map);
            }
        },
        {
            key: "getRawMappings",
            value: function getRawMappings() {
                return this._rawMappings || (this._rawMappings = allMappings(this._map));
            }
        },
        {
            key: "mark",
            value: function mark(generated, line, column, identifierName, identifierNamePos, filename) {
                this._rawMappings = void 0;
                var originalMapping;
                if (line != null) {
                    if (this._inputMap) {
                        originalMapping = originalPositionFor(this._inputMap, {
                            line: line,
                            column: column
                        });
                        if (!originalMapping.name && identifierNamePos) {
                            var originalIdentifierMapping = originalPositionFor(this._inputMap, identifierNamePos);
                            if (originalIdentifierMapping.name) {
                                identifierName = originalIdentifierMapping.name;
                            }
                        }
                    } else {
                        originalMapping = {
                            source: (filename === null || filename === void 0 ? void 0 : filename.replace(/\\/g, "/")) || this._sourceFileName,
                            line: line,
                            column: column
                        };
                    }
                }
                maybeAddMapping(this._map, {
                    name: identifierName,
                    generated: generated,
                    source: originalMapping === null || originalMapping === void 0 ? void 0 : originalMapping.source,
                    original: originalMapping
                });
            }
        }
    ]);
    return SourceMap;
}();
var Buffer2 = /*#__PURE__*/ function() {
    "use strict";
    function Buffer2(map, indentChar) {
        _class_call_check(this, Buffer2);
        __publicField(this, "_map", null);
        __publicField(this, "_buf", "");
        __publicField(this, "_str", "");
        __publicField(this, "_appendCount", 0);
        __publicField(this, "_last", 0);
        __publicField(this, "_queue", []);
        __publicField(this, "_queueCursor", 0);
        __publicField(this, "_canMarkIdName", true);
        __publicField(this, "_indentChar", "");
        __publicField(this, "_fastIndentations", []);
        __publicField(this, "_position", {
            line: 1,
            column: 0
        });
        __publicField(this, "_sourcePosition", {
            identifierName: void 0,
            identifierNamePos: void 0,
            line: void 0,
            column: void 0,
            filename: void 0
        });
        this._map = map;
        this._indentChar = indentChar;
        for(var i = 0; i < 64; i++){
            this._fastIndentations.push(indentChar.repeat(i));
        }
        this._allocQueue();
    }
    _create_class(Buffer2, [
        {
            key: "_allocQueue",
            value: function _allocQueue() {
                var queue = this._queue;
                for(var i = 0; i < 16; i++){
                    queue.push({
                        char: 0,
                        repeat: 1,
                        line: void 0,
                        column: void 0,
                        identifierName: void 0,
                        identifierNamePos: void 0,
                        filename: ""
                    });
                }
            }
        },
        {
            key: "_pushQueue",
            value: function _pushQueue(char, repeat, line, column, filename) {
                var cursor = this._queueCursor;
                if (cursor === this._queue.length) {
                    this._allocQueue();
                }
                var item = this._queue[cursor];
                item.char = char;
                item.repeat = repeat;
                item.line = line;
                item.column = column;
                item.filename = filename;
                this._queueCursor++;
            }
        },
        {
            key: "_popQueue",
            value: function _popQueue() {
                if (this._queueCursor === 0) {
                    throw new Error("Cannot pop from empty queue");
                }
                return this._queue[--this._queueCursor];
            }
        },
        {
            key: "get",
            value: function get() {
                this._flush();
                var map = this._map;
                var result = {
                    code: (this._buf + this._str).trimRight(),
                    decodedMap: map === null || map === void 0 ? void 0 : map.getDecoded(),
                    get __mergedMap () {
                        return this.map;
                    },
                    get map () {
                        var resultMap = map ? map.get() : null;
                        result.map = resultMap;
                        return resultMap;
                    },
                    set map (value){
                        Object.defineProperty(result, "map", {
                            value: value,
                            writable: true
                        });
                    },
                    get rawMappings () {
                        var mappings = map === null || map === void 0 ? void 0 : map.getRawMappings();
                        result.rawMappings = mappings;
                        return mappings;
                    },
                    set rawMappings (value){
                        Object.defineProperty(result, "rawMappings", {
                            value: value,
                            writable: true
                        });
                    }
                };
                return result;
            }
        },
        {
            key: "append",
            value: function append(str, maybeNewline) {
                this._flush();
                this._append(str, this._sourcePosition, maybeNewline);
            }
        },
        {
            key: "appendChar",
            value: function appendChar(char) {
                this._flush();
                this._appendChar(char, 1, this._sourcePosition);
            }
        },
        {
            key: "queue",
            value: function queue(char) {
                if (char === 10) {
                    while(this._queueCursor !== 0){
                        var char2 = this._queue[this._queueCursor - 1].char;
                        if (char2 !== 32 && char2 !== 9) {
                            break;
                        }
                        this._queueCursor--;
                    }
                }
                var sourcePosition = this._sourcePosition;
                this._pushQueue(char, 1, sourcePosition.line, sourcePosition.column, sourcePosition.filename);
            }
        },
        {
            key: "queueIndentation",
            value: function queueIndentation(repeat) {
                if (repeat === 0) return;
                this._pushQueue(-1, repeat, void 0, void 0, void 0);
            }
        },
        {
            key: "_flush",
            value: function _flush() {
                var queueCursor = this._queueCursor;
                var queue = this._queue;
                for(var i = 0; i < queueCursor; i++){
                    var item = queue[i];
                    this._appendChar(item.char, item.repeat, item);
                }
                this._queueCursor = 0;
            }
        },
        {
            key: "_appendChar",
            value: function _appendChar(char, repeat, sourcePos) {
                this._last = char;
                if (char === -1) {
                    var fastIndentation = this._fastIndentations[repeat];
                    if (fastIndentation !== void 0) {
                        this._str += fastIndentation;
                    } else {
                        this._str += repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
                    }
                } else {
                    this._str += repeat > 1 ? String.fromCharCode(char).repeat(repeat) : String.fromCharCode(char);
                }
                if (char !== 10) {
                    this._mark(sourcePos.line, sourcePos.column, sourcePos.identifierName, sourcePos.identifierNamePos, sourcePos.filename);
                    this._position.column += repeat;
                } else {
                    this._position.line++;
                    this._position.column = 0;
                }
                if (this._canMarkIdName) {
                    sourcePos.identifierName = void 0;
                    sourcePos.identifierNamePos = void 0;
                }
            }
        },
        {
            key: "_append",
            value: function _append(str, sourcePos, maybeNewline) {
                var len = str.length;
                var position = this._position;
                this._last = str.charCodeAt(len - 1);
                if (++this._appendCount > 4096) {
                    +this._str;
                    this._buf += this._str;
                    this._str = str;
                    this._appendCount = 0;
                } else {
                    this._str += str;
                }
                if (!maybeNewline && !this._map) {
                    position.column += len;
                    return;
                }
                var column = sourcePos.column, identifierName = sourcePos.identifierName, identifierNamePos = sourcePos.identifierNamePos, filename = sourcePos.filename;
                var line = sourcePos.line;
                if ((identifierName != null || identifierNamePos != null) && this._canMarkIdName) {
                    sourcePos.identifierName = void 0;
                    sourcePos.identifierNamePos = void 0;
                }
                var i = str.indexOf("\n");
                var last2 = 0;
                if (i !== 0) {
                    this._mark(line, column, identifierName, identifierNamePos, filename);
                }
                while(i !== -1){
                    position.line++;
                    position.column = 0;
                    last2 = i + 1;
                    if (last2 < len && line !== void 0) {
                        this._mark(++line, 0, null, null, filename);
                    }
                    i = str.indexOf("\n", last2);
                }
                position.column += len - last2;
            }
        },
        {
            key: "_mark",
            value: function _mark(line, column, identifierName, identifierNamePos, filename) {
                var _this__map;
                (_this__map = this._map) === null || _this__map === void 0 ? void 0 : _this__map.mark(this._position, line, column, identifierName, identifierNamePos, filename);
            }
        },
        {
            key: "removeTrailingNewline",
            value: function removeTrailingNewline() {
                var queueCursor = this._queueCursor;
                if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 10) {
                    this._queueCursor--;
                }
            }
        },
        {
            key: "removeLastSemicolon",
            value: function removeLastSemicolon() {
                var queueCursor = this._queueCursor;
                if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 59) {
                    this._queueCursor--;
                }
            }
        },
        {
            key: "getLastChar",
            value: function getLastChar() {
                var queueCursor = this._queueCursor;
                return queueCursor !== 0 ? this._queue[queueCursor - 1].char : this._last;
            }
        },
        {
            key: "getNewlineCount",
            value: function getNewlineCount() {
                var queueCursor = this._queueCursor;
                var count = 0;
                if (queueCursor === 0) return this._last === 10 ? 1 : 0;
                for(var i = queueCursor - 1; i >= 0; i--){
                    if (this._queue[i].char !== 10) {
                        break;
                    }
                    count++;
                }
                return count === queueCursor && this._last === 10 ? count + 1 : count;
            }
        },
        {
            key: "endsWithCharAndNewline",
            value: function endsWithCharAndNewline() {
                var queue = this._queue;
                var queueCursor = this._queueCursor;
                if (queueCursor !== 0) {
                    var lastCp = queue[queueCursor - 1].char;
                    if (lastCp !== 10) return;
                    if (queueCursor > 1) {
                        return queue[queueCursor - 2].char;
                    } else {
                        return this._last;
                    }
                }
            }
        },
        {
            key: "hasContent",
            value: function hasContent() {
                return this._queueCursor !== 0 || !!this._last;
            }
        },
        {
            key: "exactSource",
            value: function exactSource(loc, cb) {
                if (!this._map) {
                    cb();
                    return;
                }
                this.source("start", loc);
                var identifierName = loc.identifierName;
                var sourcePos = this._sourcePosition;
                if (identifierName) {
                    this._canMarkIdName = false;
                    sourcePos.identifierName = identifierName;
                }
                cb();
                if (identifierName) {
                    this._canMarkIdName = true;
                    sourcePos.identifierName = void 0;
                    sourcePos.identifierNamePos = void 0;
                }
                this.source("end", loc);
            }
        },
        {
            key: "source",
            value: function source(prop, loc) {
                if (!this._map) return;
                this._normalizePosition(prop, loc, 0);
            }
        },
        {
            key: "sourceWithOffset",
            value: function sourceWithOffset(prop, loc, columnOffset) {
                if (!this._map) return;
                this._normalizePosition(prop, loc, columnOffset);
            }
        },
        {
            key: "withSource",
            value: function withSource(prop, loc, cb) {
                if (this._map) {
                    this.source(prop, loc);
                }
                cb();
            }
        },
        {
            key: "_normalizePosition",
            value: function _normalizePosition(prop, loc, columnOffset) {
                var pos = loc[prop];
                var target = this._sourcePosition;
                if (pos) {
                    target.line = pos.line;
                    target.column = Math.max(pos.column + columnOffset, 0);
                    target.filename = loc.filename;
                }
            }
        },
        {
            key: "getCurrentColumn",
            value: function getCurrentColumn() {
                var queue = this._queue;
                var queueCursor = this._queueCursor;
                var lastIndex = -1;
                var len = 0;
                for(var i = 0; i < queueCursor; i++){
                    var item = queue[i];
                    if (item.char === 10) {
                        lastIndex = len;
                    }
                    len += item.repeat;
                }
                return lastIndex === -1 ? this._position.column + len : len - 1 - lastIndex;
            }
        },
        {
            key: "getCurrentLine",
            value: function getCurrentLine() {
                var count = 0;
                var queue = this._queue;
                for(var i = 0; i < this._queueCursor; i++){
                    if (queue[i].char === 10) {
                        count++;
                    }
                }
                return this._position.line + count;
            }
        }
    ]);
    return Buffer2;
}();
var FLIPPED_ALIAS_KEYS$1 = lib_exports.FLIPPED_ALIAS_KEYS, isArrayExpression2 = lib_exports.isArrayExpression, isAssignmentExpression2 = lib_exports.isAssignmentExpression, isBinary2 = lib_exports.isBinary, isBlockStatement2 = lib_exports.isBlockStatement, isCallExpression$3 = lib_exports.isCallExpression, isFunction$1 = lib_exports.isFunction, isIdentifier$2 = lib_exports.isIdentifier, isLiteral$1 = lib_exports.isLiteral, isMemberExpression$3 = lib_exports.isMemberExpression, isObjectExpression2 = lib_exports.isObjectExpression, isOptionalCallExpression2 = lib_exports.isOptionalCallExpression, isOptionalMemberExpression$1 = lib_exports.isOptionalMemberExpression, isStringLiteral3 = lib_exports.isStringLiteral;
function crawlInternal(node, state) {
    if (!node) return state;
    if (isMemberExpression$3(node) || isOptionalMemberExpression$1(node)) {
        crawlInternal(node.object, state);
        if (node.computed) crawlInternal(node.property, state);
    } else if (isBinary2(node) || isAssignmentExpression2(node)) {
        crawlInternal(node.left, state);
        crawlInternal(node.right, state);
    } else if (isCallExpression$3(node) || isOptionalCallExpression2(node)) {
        state.hasCall = true;
        crawlInternal(node.callee, state);
    } else if (isFunction$1(node)) {
        state.hasFunction = true;
    } else if (isIdentifier$2(node)) {
        state.hasHelper = state.hasHelper || node.callee && isHelper(node.callee);
    }
    return state;
}
function crawl(node) {
    return crawlInternal(node, {
        hasCall: false,
        hasFunction: false,
        hasHelper: false
    });
}
function isHelper(node) {
    if (!node) return false;
    if (isMemberExpression$3(node)) {
        return isHelper(node.object) || isHelper(node.property);
    } else if (isIdentifier$2(node)) {
        return node.name === "require" || node.name.charCodeAt(0) === 95;
    } else if (isCallExpression$3(node)) {
        return isHelper(node.callee);
    } else if (isBinary2(node) || isAssignmentExpression2(node)) {
        return isIdentifier$2(node.left) && isHelper(node.left) || isHelper(node.right);
    } else {
        return false;
    }
}
function isType2(node) {
    return isLiteral$1(node) || isObjectExpression2(node) || isArrayExpression2(node) || isIdentifier$2(node) || isMemberExpression$3(node);
}
var nodes = {
    AssignmentExpression: function AssignmentExpression(node) {
        var state = crawl(node.right);
        if (state.hasCall && state.hasHelper || state.hasFunction) {
            return state.hasFunction ? 1 | 2 : 2;
        }
    },
    SwitchCase: function SwitchCase(node, parent) {
        return (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) | (!node.consequent.length && parent.cases[parent.cases.length - 1] === node ? 2 : 0);
    },
    LogicalExpression: function LogicalExpression(node) {
        if (isFunction$1(node.left) || isFunction$1(node.right)) {
            return 2;
        }
    },
    Literal: function Literal(node) {
        if (isStringLiteral3(node) && node.value === "use strict") {
            return 2;
        }
    },
    CallExpression: function CallExpression(node) {
        if (isFunction$1(node.callee) || isHelper(node)) {
            return 1 | 2;
        }
    },
    OptionalCallExpression: function OptionalCallExpression(node) {
        if (isFunction$1(node.callee)) {
            return 1 | 2;
        }
    },
    VariableDeclaration: function VariableDeclaration(node) {
        for(var i = 0; i < node.declarations.length; i++){
            var declar = node.declarations[i];
            var enabled = isHelper(declar.id) && !isType2(declar.init);
            if (!enabled && declar.init) {
                var state = crawl(declar.init);
                enabled = isHelper(declar.init) && state.hasCall || state.hasFunction;
            }
            if (enabled) {
                return 1 | 2;
            }
        }
    },
    IfStatement: function IfStatement(node) {
        if (isBlockStatement2(node.consequent)) {
            return 1 | 2;
        }
    }
};
nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function(node, parent) {
    if (parent.properties[0] === node) {
        return 1;
    }
};
nodes.ObjectTypeCallProperty = function(node, parent) {
    var _parent_properties;
    if (parent.callProperties[0] === node && !((_parent_properties = parent.properties) === null || _parent_properties === void 0 ? void 0 : _parent_properties.length)) {
        return 1;
    }
};
nodes.ObjectTypeIndexer = function(node, parent) {
    var _parent_properties, _parent_callProperties;
    if (parent.indexers[0] === node && !((_parent_properties = parent.properties) === null || _parent_properties === void 0 ? void 0 : _parent_properties.length) && !((_parent_callProperties = parent.callProperties) === null || _parent_callProperties === void 0 ? void 0 : _parent_callProperties.length)) {
        return 1;
    }
};
nodes.ObjectTypeInternalSlot = function(node, parent) {
    var _parent_properties, _parent_callProperties, _parent_indexers;
    if (parent.internalSlots[0] === node && !((_parent_properties = parent.properties) === null || _parent_properties === void 0 ? void 0 : _parent_properties.length) && !((_parent_callProperties = parent.callProperties) === null || _parent_callProperties === void 0 ? void 0 : _parent_callProperties.length) && !((_parent_indexers = parent.indexers) === null || _parent_indexers === void 0 ? void 0 : _parent_indexers.length)) {
        return 1;
    }
};
[
    [
        "Function",
        true
    ],
    [
        "Class",
        true
    ],
    [
        "Loop",
        true
    ],
    [
        "LabeledStatement",
        true
    ],
    [
        "SwitchStatement",
        true
    ],
    [
        "TryStatement",
        true
    ]
].forEach(function(param) {
    var _$_param = _sliced_to_array(param, 2), type = _$_param[0], amounts = _$_param[1];
    [
        type
    ].concat(FLIPPED_ALIAS_KEYS$1[type] || []).forEach(function(type2) {
        var ret = amounts ? 1 | 2 : 0;
        nodes[type2] = function() {
            return ret;
        };
    });
});
var isArrayTypeAnnotation2 = lib_exports.isArrayTypeAnnotation, isArrowFunctionExpression2 = lib_exports.isArrowFunctionExpression, isBinaryExpression2 = lib_exports.isBinaryExpression, isCallExpression$2 = lib_exports.isCallExpression, isExportDeclaration2 = lib_exports.isExportDeclaration, isForOfStatement2 = lib_exports.isForOfStatement, isIndexedAccessType2 = lib_exports.isIndexedAccessType, isMemberExpression$2 = lib_exports.isMemberExpression, isObjectPattern2 = lib_exports.isObjectPattern, isOptionalMemberExpression2 = lib_exports.isOptionalMemberExpression, isYieldExpression2 = lib_exports.isYieldExpression;
var PRECEDENCE = /* @__PURE__ */ new Map([
    [
        "||",
        0
    ],
    [
        "??",
        0
    ],
    [
        "|>",
        0
    ],
    [
        "&&",
        1
    ],
    [
        "|",
        2
    ],
    [
        "^",
        3
    ],
    [
        "&",
        4
    ],
    [
        "==",
        5
    ],
    [
        "===",
        5
    ],
    [
        "!=",
        5
    ],
    [
        "!==",
        5
    ],
    [
        "<",
        6
    ],
    [
        ">",
        6
    ],
    [
        "<=",
        6
    ],
    [
        ">=",
        6
    ],
    [
        "in",
        6
    ],
    [
        "instanceof",
        6
    ],
    [
        ">>",
        7
    ],
    [
        "<<",
        7
    ],
    [
        ">>>",
        7
    ],
    [
        "+",
        8
    ],
    [
        "-",
        8
    ],
    [
        "*",
        9
    ],
    [
        "/",
        9
    ],
    [
        "%",
        9
    ],
    [
        "**",
        10
    ]
]);
function isTSTypeExpression(nodeType) {
    return nodeType === "TSAsExpression" || nodeType === "TSSatisfiesExpression" || nodeType === "TSTypeAssertion";
}
var isClassExtendsClause = function(node, parent) {
    var parentType = parent.type;
    return (parentType === "ClassDeclaration" || parentType === "ClassExpression") && parent.superClass === node;
};
var hasPostfixPart = function(node, parent) {
    var parentType = parent.type;
    return (parentType === "MemberExpression" || parentType === "OptionalMemberExpression") && parent.object === node || (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression") && parent.callee === node || parentType === "TaggedTemplateExpression" && parent.tag === node || parentType === "TSNonNullExpression";
};
function NullableTypeAnnotation$1(node, parent) {
    return isArrayTypeAnnotation2(parent);
}
function FunctionTypeAnnotation$1(node, parent, printStack) {
    if (printStack.length < 3) return;
    var parentType = parent.type;
    return parentType === "UnionTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "ArrayTypeAnnotation" || parentType === "TypeAnnotation" && isArrowFunctionExpression2(printStack[printStack.length - 3]);
}
function UpdateExpression$1(node, parent) {
    return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
}
function ObjectExpression$1(node, parent, printStack) {
    return isFirstInContext(printStack, 1 | 2);
}
function DoExpression$1(node, parent, printStack) {
    return !node.async && isFirstInContext(printStack, 1);
}
function Binary(node, parent) {
    var parentType = parent.type;
    if (node.operator === "**" && parentType === "BinaryExpression" && parent.operator === "**") {
        return parent.left === node;
    }
    if (isClassExtendsClause(node, parent)) {
        return true;
    }
    if (hasPostfixPart(node, parent) || parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "AwaitExpression") {
        return true;
    }
    if (parentType === "BinaryExpression" || parentType === "LogicalExpression") {
        var parentPos = PRECEDENCE.get(parent.operator);
        var nodePos = PRECEDENCE.get(node.operator);
        if (parentPos === nodePos && parent.right === node && parentType !== "LogicalExpression" || parentPos > nodePos) {
            return true;
        }
    }
    return void 0;
}
function UnionTypeAnnotation$1(node, parent) {
    var parentType = parent.type;
    return parentType === "ArrayTypeAnnotation" || parentType === "NullableTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "UnionTypeAnnotation";
}
function OptionalIndexedAccessType$1(node, parent) {
    return isIndexedAccessType2(parent) && parent.objectType === node;
}
function TSAsExpression() {
    return true;
}
function TSUnionType$1(node, parent) {
    var parentType = parent.type;
    return parentType === "TSArrayType" || parentType === "TSOptionalType" || parentType === "TSIntersectionType" || parentType === "TSUnionType" || parentType === "TSRestType";
}
function TSInferType$1(node, parent) {
    var parentType = parent.type;
    return parentType === "TSArrayType" || parentType === "TSOptionalType";
}
function TSInstantiationExpression$1(node, parent) {
    var parentType = parent.type;
    return (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression" || parentType === "TSInstantiationExpression") && !!parent.typeParameters;
}
function BinaryExpression(node, parent) {
    if (node.operator === "in") {
        var parentType = parent.type;
        return parentType === "VariableDeclarator" || parentType === "ForStatement" || parentType === "ForInStatement" || parentType === "ForOfStatement";
    }
    return false;
}
function SequenceExpression$1(node, parent) {
    var parentType = parent.type;
    if (parentType === "ForStatement" || parentType === "ThrowStatement" || parentType === "ReturnStatement" || parentType === "IfStatement" && parent.test === node || parentType === "WhileStatement" && parent.test === node || parentType === "ForInStatement" && parent.right === node || parentType === "SwitchStatement" && parent.discriminant === node || parentType === "ExpressionStatement" && parent.expression === node) {
        return false;
    }
    return true;
}
function YieldExpression$1(node, parent) {
    var parentType = parent.type;
    return parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "UnaryExpression" || parentType === "SpreadElement" || hasPostfixPart(node, parent) || parentType === "AwaitExpression" && isYieldExpression2(node) || parentType === "ConditionalExpression" && node === parent.test || isClassExtendsClause(node, parent);
}
function ClassExpression(node, parent, printStack) {
    return isFirstInContext(printStack, 1 | 4);
}
function UnaryLike(node, parent) {
    return hasPostfixPart(node, parent) || isBinaryExpression2(parent) && parent.operator === "**" && parent.left === node || isClassExtendsClause(node, parent);
}
function FunctionExpression$1(node, parent, printStack) {
    return isFirstInContext(printStack, 1 | 4);
}
function ArrowFunctionExpression$1(node, parent) {
    return isExportDeclaration2(parent) || ConditionalExpression$1(node, parent);
}
function ConditionalExpression$1(node, parent) {
    var parentType = parent.type;
    if (parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "ConditionalExpression" && parent.test === node || parentType === "AwaitExpression" || isTSTypeExpression(parentType)) {
        return true;
    }
    return UnaryLike(node, parent);
}
function OptionalMemberExpression$1(node, parent) {
    return isCallExpression$2(parent) && parent.callee === node || isMemberExpression$2(parent) && parent.object === node;
}
function AssignmentExpression$1(node, parent) {
    if (isObjectPattern2(node.left)) {
        return true;
    } else {
        return ConditionalExpression$1(node, parent);
    }
}
function LogicalExpression(node, parent) {
    var parentType = parent.type;
    if (isTSTypeExpression(parentType)) return true;
    if (parentType !== "LogicalExpression") return false;
    switch(node.operator){
        case "||":
            return parent.operator === "??" || parent.operator === "&&";
        case "&&":
            return parent.operator === "??";
        case "??":
            return parent.operator !== "??";
    }
}
function Identifier$1(node, parent, printStack) {
    var _node_extra;
    var parentType = parent.type;
    if (((_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.parenthesized) && parentType === "AssignmentExpression" && parent.left === node) {
        var rightType = parent.right.type;
        if ((rightType === "FunctionExpression" || rightType === "ClassExpression") && parent.right.id == null) {
            return true;
        }
    }
    if (node.name === "let") {
        var isFollowedByBracket = isMemberExpression$2(parent, {
            object: node,
            computed: true
        }) || isOptionalMemberExpression2(parent, {
            object: node,
            computed: true,
            optional: false
        });
        return isFirstInContext(printStack, isFollowedByBracket ? 1 | 8 | 16 | 32 : 32);
    }
    return node.name === "async" && isForOfStatement2(parent) && node === parent.left;
}
function isFirstInContext(printStack, checkParam) {
    var expressionStatement5 = checkParam & 1;
    var arrowBody = checkParam & 2;
    var exportDefault = checkParam & 4;
    var forHead = checkParam & 8;
    var forInHead = checkParam & 16;
    var forOfHead = checkParam & 32;
    var i = printStack.length - 1;
    if (i <= 0) return;
    var node = printStack[i];
    i--;
    var parent = printStack[i];
    while(i >= 0){
        var parentType = parent.type;
        if (expressionStatement5 && parentType === "ExpressionStatement" && parent.expression === node || exportDefault && parentType === "ExportDefaultDeclaration" && node === parent.declaration || arrowBody && parentType === "ArrowFunctionExpression" && parent.body === node || forHead && parentType === "ForStatement" && parent.init === node || forInHead && parentType === "ForInStatement" && parent.left === node || forOfHead && parentType === "ForOfStatement" && parent.left === node) {
            return true;
        }
        if (i > 0 && (hasPostfixPart(node, parent) && parentType !== "NewExpression" || parentType === "SequenceExpression" && parent.expressions[0] === node || parentType === "UpdateExpression" && !parent.prefix || parentType === "ConditionalExpression" && parent.test === node || (parentType === "BinaryExpression" || parentType === "LogicalExpression") && parent.left === node || parentType === "AssignmentExpression" && parent.left === node)) {
            node = parent;
            i--;
            parent = printStack[i];
        } else {
            return false;
        }
    }
    return false;
}
var parens = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    ArrowFunctionExpression: ArrowFunctionExpression$1,
    AssignmentExpression: AssignmentExpression$1,
    AwaitExpression: YieldExpression$1,
    Binary: Binary,
    BinaryExpression: BinaryExpression,
    ClassExpression: ClassExpression,
    ConditionalExpression: ConditionalExpression$1,
    DoExpression: DoExpression$1,
    FunctionExpression: FunctionExpression$1,
    FunctionTypeAnnotation: FunctionTypeAnnotation$1,
    Identifier: Identifier$1,
    IntersectionTypeAnnotation: UnionTypeAnnotation$1,
    LogicalExpression: LogicalExpression,
    NullableTypeAnnotation: NullableTypeAnnotation$1,
    ObjectExpression: ObjectExpression$1,
    OptionalCallExpression: OptionalMemberExpression$1,
    OptionalIndexedAccessType: OptionalIndexedAccessType$1,
    OptionalMemberExpression: OptionalMemberExpression$1,
    SequenceExpression: SequenceExpression$1,
    TSAsExpression: TSAsExpression,
    TSInferType: TSInferType$1,
    TSInstantiationExpression: TSInstantiationExpression$1,
    TSIntersectionType: TSUnionType$1,
    TSSatisfiesExpression: TSAsExpression,
    TSTypeAssertion: TSAsExpression,
    TSUnionType: TSUnionType$1,
    UnaryLike: UnaryLike,
    UnionTypeAnnotation: UnionTypeAnnotation$1,
    UpdateExpression: UpdateExpression$1,
    YieldExpression: YieldExpression$1
});
var FLIPPED_ALIAS_KEYS2 = lib_exports.FLIPPED_ALIAS_KEYS, isCallExpression$1 = lib_exports.isCallExpression, isExpressionStatement3 = lib_exports.isExpressionStatement, isMemberExpression$1 = lib_exports.isMemberExpression, isNewExpression$1 = lib_exports.isNewExpression;
function expandAliases(obj) {
    var map = /* @__PURE__ */ new Map();
    function add(type, func) {
        var fn = map.get(type);
        map.set(type, fn ? function(node, parent, stack) {
            var _fn;
            return (_fn = fn(node, parent, stack)) !== null && _fn !== void 0 ? _fn : func(node, parent, stack);
        } : func);
    }
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(obj)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var type = _step.value;
            var aliases = FLIPPED_ALIAS_KEYS2[type];
            if (aliases) {
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = aliases[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var alias = _step1.value;
                        add(alias, obj[type]);
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            } else {
                add(type, obj[type]);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return map;
}
var expandedParens = expandAliases(parens);
var expandedWhitespaceNodes = expandAliases(nodes);
function isOrHasCallExpression(node) {
    if (isCallExpression$1(node)) {
        return true;
    }
    return isMemberExpression$1(node) && isOrHasCallExpression(node.object);
}
function needsWhitespace(node, parent, type) {
    var _expandedWhitespaceNodes_get;
    if (!node) return false;
    if (isExpressionStatement3(node)) {
        node = node.expression;
    }
    var flag = (_expandedWhitespaceNodes_get = expandedWhitespaceNodes.get(node.type)) === null || _expandedWhitespaceNodes_get === void 0 ? void 0 : _expandedWhitespaceNodes_get(node, parent);
    if (typeof flag === "number") {
        return (flag & type) !== 0;
    }
    return false;
}
function needsWhitespaceBefore(node, parent) {
    return needsWhitespace(node, parent, 1);
}
function needsWhitespaceAfter(node, parent) {
    return needsWhitespace(node, parent, 2);
}
function needsParens$1(node, parent, printStack) {
    var _expandedParens_get;
    if (!parent) return false;
    if (isNewExpression$1(parent) && parent.callee === node) {
        if (isOrHasCallExpression(node)) return true;
    }
    return (_expandedParens_get = expandedParens.get(node.type)) === null || _expandedParens_get === void 0 ? void 0 : _expandedParens_get(node, parent, printStack);
}
var n = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    needsParens: needsParens$1,
    needsWhitespace: needsWhitespace,
    needsWhitespaceAfter: needsWhitespaceAfter,
    needsWhitespaceBefore: needsWhitespaceBefore
});
function TaggedTemplateExpression(node) {
    this.print(node.tag, node);
    this.print(node.typeParameters, node);
    this.print(node.quasi, node);
}
function TemplateElement(node, parent) {
    var isFirst = parent.quasis[0] === node;
    var isLast = parent.quasis[parent.quasis.length - 1] === node;
    var value1 = (isFirst ? "`" : "}") + node.value.raw + (isLast ? "`" : "${");
    this.token(value1, true);
}
function TemplateLiteral(node) {
    var quasis = node.quasis;
    for(var i = 0; i < quasis.length; i++){
        this.print(quasis[i], node);
        if (i + 1 < quasis.length) {
            this.print(node.expressions[i], node);
        }
    }
}
var isCallExpression3 = lib_exports.isCallExpression, isLiteral2 = lib_exports.isLiteral, isMemberExpression2 = lib_exports.isMemberExpression, isNewExpression3 = lib_exports.isNewExpression;
function UnaryExpression(node) {
    var operator = node.operator;
    if (operator === "void" || operator === "delete" || operator === "typeof" || operator === "throw") {
        this.word(operator);
        this.space();
    } else {
        this.token(operator);
    }
    this.print(node.argument, node);
}
function DoExpression(node) {
    if (node.async) {
        this.word("async", true);
        this.space();
    }
    this.word("do");
    this.space();
    this.print(node.body, node);
}
function ParenthesizedExpression(node) {
    this.tokenChar(40);
    this.print(node.expression, node);
    this.rightParens(node);
}
function UpdateExpression(node) {
    if (node.prefix) {
        this.token(node.operator);
        this.print(node.argument, node);
    } else {
        this.printTerminatorless(node.argument, node, true);
        this.token(node.operator);
    }
}
function ConditionalExpression(node) {
    this.print(node.test, node);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.consequent, node);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.alternate, node);
}
function NewExpression(node, parent) {
    this.word("new");
    this.space();
    this.print(node.callee, node);
    if (this.format.minified && node.arguments.length === 0 && !node.optional && !isCallExpression3(parent, {
        callee: node
    }) && !isMemberExpression2(parent) && !isNewExpression3(parent)) {
        return;
    }
    this.print(node.typeArguments, node);
    this.print(node.typeParameters, node);
    if (node.optional) {
        this.token("?.");
    }
    this.tokenChar(40);
    this.printList(node.arguments, node);
    this.rightParens(node);
}
function SequenceExpression(node) {
    this.printList(node.expressions, node);
}
function ThisExpression() {
    this.word("this");
}
function Super() {
    this.word("super");
}
function isDecoratorMemberExpression(node) {
    switch(node.type){
        case "Identifier":
            return true;
        case "MemberExpression":
            return !node.computed && node.property.type === "Identifier" && isDecoratorMemberExpression(node.object);
        default:
            return false;
    }
}
function shouldParenthesizeDecoratorExpression(node) {
    if (node.type === "ParenthesizedExpression") {
        return false;
    }
    return !isDecoratorMemberExpression(node.type === "CallExpression" ? node.callee : node);
}
function _shouldPrintDecoratorsBeforeExport(node) {
    if (typeof this.format.decoratorsBeforeExport === "boolean") {
        return this.format.decoratorsBeforeExport;
    }
    return typeof node.start === "number" && node.start === node.declaration.start;
}
function Decorator(node) {
    this.tokenChar(64);
    var expression2 = node.expression;
    if (shouldParenthesizeDecoratorExpression(expression2)) {
        this.tokenChar(40);
        this.print(expression2, node);
        this.tokenChar(41);
    } else {
        this.print(expression2, node);
    }
    this.newline();
}
function OptionalMemberExpression(node) {
    var computed = node.computed;
    var optional = node.optional, property = node.property;
    this.print(node.object, node);
    if (!computed && isMemberExpression2(property)) {
        throw new TypeError("Got a MemberExpression for MemberExpression property");
    }
    if (isLiteral2(property) && typeof property.value === "number") {
        computed = true;
    }
    if (optional) {
        this.token("?.");
    }
    if (computed) {
        this.tokenChar(91);
        this.print(property, node);
        this.tokenChar(93);
    } else {
        if (!optional) {
            this.tokenChar(46);
        }
        this.print(property, node);
    }
}
function OptionalCallExpression(node) {
    this.print(node.callee, node);
    this.print(node.typeParameters, node);
    if (node.optional) {
        this.token("?.");
    }
    this.print(node.typeArguments, node);
    this.tokenChar(40);
    this.printList(node.arguments, node);
    this.rightParens(node);
}
function CallExpression(node) {
    this.print(node.callee, node);
    this.print(node.typeArguments, node);
    this.print(node.typeParameters, node);
    this.tokenChar(40);
    this.printList(node.arguments, node);
    this.rightParens(node);
}
function Import() {
    this.word("import");
}
function AwaitExpression(node) {
    this.word("await");
    if (node.argument) {
        this.space();
        this.printTerminatorless(node.argument, node, false);
    }
}
function YieldExpression(node) {
    this.word("yield", true);
    if (node.delegate) {
        this.tokenChar(42);
        if (node.argument) {
            this.space();
            this.print(node.argument, node);
        }
    } else {
        if (node.argument) {
            this.space();
            this.printTerminatorless(node.argument, node, false);
        }
    }
}
function EmptyStatement() {
    this.semicolon(true);
}
function ExpressionStatement(node) {
    this.print(node.expression, node);
    this.semicolon();
}
function AssignmentPattern(node) {
    this.print(node.left, node);
    if (node.left.optional) this.tokenChar(63);
    this.print(node.left.typeAnnotation, node);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right, node);
}
function AssignmentExpression(node, parent) {
    var parens2 = this.inForStatementInitCounter && node.operator === "in" && !needsParens$1(node, parent);
    if (parens2) {
        this.tokenChar(40);
    }
    this.print(node.left, node);
    this.space();
    if (node.operator === "in" || node.operator === "instanceof") {
        this.word(node.operator);
    } else {
        this.token(node.operator);
    }
    this.space();
    this.print(node.right, node);
    if (parens2) {
        this.tokenChar(41);
    }
}
function BindExpression(node) {
    this.print(node.object, node);
    this.token("::");
    this.print(node.callee, node);
}
function MemberExpression(node) {
    this.print(node.object, node);
    if (!node.computed && isMemberExpression2(node.property)) {
        throw new TypeError("Got a MemberExpression for MemberExpression property");
    }
    var computed = node.computed;
    if (isLiteral2(node.property) && typeof node.property.value === "number") {
        computed = true;
    }
    if (computed) {
        this.tokenChar(91);
        this.print(node.property, node);
        this.tokenChar(93);
    } else {
        this.tokenChar(46);
        this.print(node.property, node);
    }
}
function MetaProperty(node) {
    this.print(node.meta, node);
    this.tokenChar(46);
    this.print(node.property, node);
}
function PrivateName(node) {
    this.tokenChar(35);
    this.print(node.id, node);
}
function V8IntrinsicIdentifier(node) {
    this.tokenChar(37);
    this.word(node.name);
}
function ModuleExpression(node) {
    this.word("module", true);
    this.space();
    this.tokenChar(123);
    this.indent();
    var body = node.body;
    if (body.body.length || body.directives.length) {
        this.newline();
    }
    this.print(body, node);
    this.dedent();
    this.rightBrace(node);
}
var isFor2 = lib_exports.isFor, isForStatement2 = lib_exports.isForStatement, isIfStatement2 = lib_exports.isIfStatement, isStatement$3 = lib_exports.isStatement;
function WithStatement(node) {
    this.word("with");
    this.space();
    this.tokenChar(40);
    this.print(node.object, node);
    this.tokenChar(41);
    this.printBlock(node);
}
function IfStatement(node) {
    this.word("if");
    this.space();
    this.tokenChar(40);
    this.print(node.test, node);
    this.tokenChar(41);
    this.space();
    var needsBlock = node.alternate && isIfStatement2(getLastStatement(node.consequent));
    if (needsBlock) {
        this.tokenChar(123);
        this.newline();
        this.indent();
    }
    this.printAndIndentOnComments(node.consequent, node);
    if (needsBlock) {
        this.dedent();
        this.newline();
        this.tokenChar(125);
    }
    if (node.alternate) {
        if (this.endsWith(125)) this.space();
        this.word("else");
        this.space();
        this.printAndIndentOnComments(node.alternate, node);
    }
}
function getLastStatement(statement2) {
    var body = statement2.body;
    if (isStatement$3(body) === false) {
        return statement2;
    }
    return getLastStatement(body);
}
function ForStatement(node) {
    this.word("for");
    this.space();
    this.tokenChar(40);
    this.inForStatementInitCounter++;
    this.print(node.init, node);
    this.inForStatementInitCounter--;
    this.tokenChar(59);
    if (node.test) {
        this.space();
        this.print(node.test, node);
    }
    this.tokenChar(59);
    if (node.update) {
        this.space();
        this.print(node.update, node);
    }
    this.tokenChar(41);
    this.printBlock(node);
}
function WhileStatement(node) {
    this.word("while");
    this.space();
    this.tokenChar(40);
    this.print(node.test, node);
    this.tokenChar(41);
    this.printBlock(node);
}
function ForXStatement(node) {
    this.word("for");
    this.space();
    var isForOf = node.type === "ForOfStatement";
    if (isForOf && node.await) {
        this.word("await");
        this.space();
    }
    this.noIndentInnerCommentsHere();
    this.tokenChar(40);
    this.print(node.left, node);
    this.space();
    this.word(isForOf ? "of" : "in");
    this.space();
    this.print(node.right, node);
    this.tokenChar(41);
    this.printBlock(node);
}
var ForInStatement = ForXStatement;
var ForOfStatement = ForXStatement;
function DoWhileStatement(node) {
    this.word("do");
    this.space();
    this.print(node.body, node);
    this.space();
    this.word("while");
    this.space();
    this.tokenChar(40);
    this.print(node.test, node);
    this.tokenChar(41);
    this.semicolon();
}
function printStatementAfterKeyword(printer, node, parent, isLabel) {
    if (node) {
        printer.space();
        printer.printTerminatorless(node, parent, isLabel);
    }
    printer.semicolon();
}
function BreakStatement(node) {
    this.word("break");
    printStatementAfterKeyword(this, node.label, node, true);
}
function ContinueStatement(node) {
    this.word("continue");
    printStatementAfterKeyword(this, node.label, node, true);
}
function ReturnStatement(node) {
    this.word("return");
    printStatementAfterKeyword(this, node.argument, node, false);
}
function ThrowStatement(node) {
    this.word("throw");
    printStatementAfterKeyword(this, node.argument, node, false);
}
function LabeledStatement(node) {
    this.print(node.label, node);
    this.tokenChar(58);
    this.space();
    this.print(node.body, node);
}
function TryStatement(node) {
    this.word("try");
    this.space();
    this.print(node.block, node);
    this.space();
    if (node.handlers) {
        this.print(node.handlers[0], node);
    } else {
        this.print(node.handler, node);
    }
    if (node.finalizer) {
        this.space();
        this.word("finally");
        this.space();
        this.print(node.finalizer, node);
    }
}
function CatchClause(node) {
    this.word("catch");
    this.space();
    if (node.param) {
        this.tokenChar(40);
        this.print(node.param, node);
        this.print(node.param.typeAnnotation, node);
        this.tokenChar(41);
        this.space();
    }
    this.print(node.body, node);
}
function SwitchStatement(node) {
    this.word("switch");
    this.space();
    this.tokenChar(40);
    this.print(node.discriminant, node);
    this.tokenChar(41);
    this.space();
    this.tokenChar(123);
    this.printSequence(node.cases, node, {
        indent: true,
        addNewlines: function addNewlines(leading, cas) {
            if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
        }
    });
    this.rightBrace(node);
}
function SwitchCase(node) {
    if (node.test) {
        this.word("case");
        this.space();
        this.print(node.test, node);
        this.tokenChar(58);
    } else {
        this.word("default");
        this.tokenChar(58);
    }
    if (node.consequent.length) {
        this.newline();
        this.printSequence(node.consequent, node, {
            indent: true
        });
    }
}
function DebuggerStatement() {
    this.word("debugger");
    this.semicolon();
}
function VariableDeclaration(node, parent) {
    if (node.declare) {
        this.word("declare");
        this.space();
    }
    var kind = node.kind;
    this.word(kind, kind === "using" || kind === "await using");
    this.space();
    var hasInits = false;
    if (!isFor2(parent)) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = node.declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var declar = _step.value;
                if (declar.init) {
                    hasInits = true;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    this.printList(node.declarations, node, {
        separator: hasInits ? function() {
            this.tokenChar(44);
            this.newline();
        } : void 0,
        indent: node.declarations.length > 1 ? true : false
    });
    if (isFor2(parent)) {
        if (isForStatement2(parent)) {
            if (parent.init === node) return;
        } else {
            if (parent.left === node) return;
        }
    }
    this.semicolon();
}
function VariableDeclarator(node) {
    this.print(node.id, node);
    if (node.definite) this.tokenChar(33);
    this.print(node.id.typeAnnotation, node);
    if (node.init) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.init, node);
    }
}
var isExportDefaultDeclaration2 = lib_exports.isExportDefaultDeclaration, isExportNamedDeclaration2 = lib_exports.isExportNamedDeclaration;
function ClassDeclaration(node, parent) {
    var inExport = isExportDefaultDeclaration2(parent) || isExportNamedDeclaration2(parent);
    if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
        this.printJoin(node.decorators, node);
    }
    if (node.declare) {
        this.word("declare");
        this.space();
    }
    if (node.abstract) {
        this.word("abstract");
        this.space();
    }
    this.word("class");
    if (node.id) {
        this.space();
        this.print(node.id, node);
    }
    this.print(node.typeParameters, node);
    if (node.superClass) {
        this.space();
        this.word("extends");
        this.space();
        this.print(node.superClass, node);
        this.print(node.superTypeParameters, node);
    }
    if (node.implements) {
        this.space();
        this.word("implements");
        this.space();
        this.printList(node.implements, node);
    }
    this.space();
    this.print(node.body, node);
}
function ClassBody(node) {
    this.tokenChar(123);
    if (node.body.length === 0) {
        this.tokenChar(125);
    } else {
        this.newline();
        this.printSequence(node.body, node, {
            indent: true
        });
        if (!this.endsWith(10)) this.newline();
        this.rightBrace(node);
    }
}
function ClassProperty(node) {
    var _node_key_loc_end, _node_key_loc;
    this.printJoin(node.decorators, node);
    var endLine = (_node_key_loc = node.key.loc) === null || _node_key_loc === void 0 ? void 0 : (_node_key_loc_end = _node_key_loc.end) === null || _node_key_loc_end === void 0 ? void 0 : _node_key_loc_end.line;
    if (endLine) this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    if (node.computed) {
        this.tokenChar(91);
        this.print(node.key, node);
        this.tokenChar(93);
    } else {
        this._variance(node);
        this.print(node.key, node);
    }
    if (node.optional) {
        this.tokenChar(63);
    }
    if (node.definite) {
        this.tokenChar(33);
    }
    this.print(node.typeAnnotation, node);
    if (node.value) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.value, node);
    }
    this.semicolon();
}
function ClassAccessorProperty(node) {
    var _node_key_loc_end, _node_key_loc;
    this.printJoin(node.decorators, node);
    var endLine = (_node_key_loc = node.key.loc) === null || _node_key_loc === void 0 ? void 0 : (_node_key_loc_end = _node_key_loc.end) === null || _node_key_loc_end === void 0 ? void 0 : _node_key_loc_end.line;
    if (endLine) this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this.word("accessor", true);
    this.space();
    if (node.computed) {
        this.tokenChar(91);
        this.print(node.key, node);
        this.tokenChar(93);
    } else {
        this._variance(node);
        this.print(node.key, node);
    }
    if (node.optional) {
        this.tokenChar(63);
    }
    if (node.definite) {
        this.tokenChar(33);
    }
    this.print(node.typeAnnotation, node);
    if (node.value) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.value, node);
    }
    this.semicolon();
}
function ClassPrivateProperty(node) {
    this.printJoin(node.decorators, node);
    if (node.static) {
        this.word("static");
        this.space();
    }
    this.print(node.key, node);
    this.print(node.typeAnnotation, node);
    if (node.value) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.value, node);
    }
    this.semicolon();
}
function ClassMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body, node);
}
function ClassPrivateMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body, node);
}
function _classMethodHead(node) {
    var _node_key_loc_end, _node_key_loc;
    this.printJoin(node.decorators, node);
    var endLine = (_node_key_loc = node.key.loc) === null || _node_key_loc === void 0 ? void 0 : (_node_key_loc_end = _node_key_loc.end) === null || _node_key_loc_end === void 0 ? void 0 : _node_key_loc_end.line;
    if (endLine) this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this._methodHead(node);
}
function StaticBlock(node) {
    this.word("static");
    this.space();
    this.tokenChar(123);
    if (node.body.length === 0) {
        this.tokenChar(125);
    } else {
        this.newline();
        this.printSequence(node.body, node, {
            indent: true
        });
        this.rightBrace(node);
    }
}
var isIdentifier$1 = lib_exports.isIdentifier;
function _params(node, idNode, parentNode) {
    this.print(node.typeParameters, node);
    var nameInfo = _getFuncIdName.call(this, idNode, parentNode);
    if (nameInfo) {
        this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
    }
    this.tokenChar(40);
    this._parameters(node.params, node);
    this.tokenChar(41);
    var noLineTerminator = node.type === "ArrowFunctionExpression";
    this.print(node.returnType, node, noLineTerminator);
    this._noLineTerminator = noLineTerminator;
}
function _parameters(parameters, parent) {
    var paramLength = parameters.length;
    for(var i = 0; i < paramLength; i++){
        this._param(parameters[i], parent);
        if (i < parameters.length - 1) {
            this.tokenChar(44);
            this.space();
        }
    }
}
function _param(parameter, parent) {
    this.printJoin(parameter.decorators, parameter);
    this.print(parameter, parent);
    if (parameter.optional) {
        this.tokenChar(63);
    }
    this.print(parameter.typeAnnotation, parameter);
}
function _methodHead(node) {
    var kind = node.kind;
    var key = node.key;
    if (kind === "get" || kind === "set") {
        this.word(kind);
        this.space();
    }
    if (node.async) {
        this.word("async", true);
        this.space();
    }
    if (kind === "method" || kind === "init") {
        if (node.generator) {
            this.tokenChar(42);
        }
    }
    if (node.computed) {
        this.tokenChar(91);
        this.print(key, node);
        this.tokenChar(93);
    } else {
        this.print(key, node);
    }
    if (node.optional) {
        this.tokenChar(63);
    }
    this._params(node, node.computed && node.key.type !== "StringLiteral" ? void 0 : node.key, void 0);
}
function _predicate(node, noLineTerminatorAfter) {
    if (node.predicate) {
        if (!node.returnType) {
            this.tokenChar(58);
        }
        this.space();
        this.print(node.predicate, node, noLineTerminatorAfter);
    }
}
function _functionHead(node, parent) {
    if (node.async) {
        this.word("async");
        this._endsWithInnerRaw = false;
        this.space();
    }
    this.word("function");
    if (node.generator) {
        this._endsWithInnerRaw = false;
        this.tokenChar(42);
    }
    this.space();
    if (node.id) {
        this.print(node.id, node);
    }
    this._params(node, node.id, parent);
    if (node.type !== "TSDeclareFunction") {
        this._predicate(node);
    }
}
function FunctionExpression(node, parent) {
    this._functionHead(node, parent);
    this.space();
    this.print(node.body, node);
}
function ArrowFunctionExpression(node, parent) {
    if (node.async) {
        this.word("async", true);
        this.space();
    }
    var firstParam;
    if (!this.format.retainLines && node.params.length === 1 && isIdentifier$1(firstParam = node.params[0]) && !hasTypesOrComments(node, firstParam)) {
        this.print(firstParam, node, true);
    } else {
        this._params(node, void 0, parent);
    }
    this._predicate(node, true);
    this.space();
    this.printInnerComments();
    this.token("=>");
    this.space();
    this.print(node.body, node);
}
function hasTypesOrComments(node, param) {
    var _param_leadingComments, _param_trailingComments;
    return !!(node.typeParameters || node.returnType || node.predicate || param.typeAnnotation || param.optional || ((_param_leadingComments = param.leadingComments) === null || _param_leadingComments === void 0 ? void 0 : _param_leadingComments.length) || ((_param_trailingComments = param.trailingComments) === null || _param_trailingComments === void 0 ? void 0 : _param_trailingComments.length));
}
function _getFuncIdName(idNode, parent) {
    var id = idNode;
    if (!id && parent) {
        var parentType = parent.type;
        if (parentType === "VariableDeclarator") {
            id = parent.id;
        } else if (parentType === "AssignmentExpression" || parentType === "AssignmentPattern") {
            id = parent.left;
        } else if (parentType === "ObjectProperty" || parentType === "ClassProperty") {
            if (!parent.computed || parent.key.type === "StringLiteral") {
                id = parent.key;
            }
        } else if (parentType === "ClassPrivateProperty" || parentType === "ClassAccessorProperty") {
            id = parent.key;
        }
    }
    if (!id) return;
    var nameInfo;
    if (id.type === "Identifier") {
        var _id_loc, _id_loc1;
        nameInfo = {
            pos: (_id_loc = id.loc) === null || _id_loc === void 0 ? void 0 : _id_loc.start,
            name: ((_id_loc1 = id.loc) === null || _id_loc1 === void 0 ? void 0 : _id_loc1.identifierName) || id.name
        };
    } else if (id.type === "PrivateName") {
        var _id_loc2;
        nameInfo = {
            pos: (_id_loc2 = id.loc) === null || _id_loc2 === void 0 ? void 0 : _id_loc2.start,
            name: "#" + id.id.name
        };
    } else if (id.type === "StringLiteral") {
        var _id_loc3;
        nameInfo = {
            pos: (_id_loc3 = id.loc) === null || _id_loc3 === void 0 ? void 0 : _id_loc3.start,
            name: id.value
        };
    }
    return nameInfo;
}
var isClassDeclaration2 = lib_exports.isClassDeclaration, isExportDefaultSpecifier2 = lib_exports.isExportDefaultSpecifier, isExportNamespaceSpecifier2 = lib_exports.isExportNamespaceSpecifier, isImportDefaultSpecifier2 = lib_exports.isImportDefaultSpecifier, isImportNamespaceSpecifier2 = lib_exports.isImportNamespaceSpecifier, isStatement$2 = lib_exports.isStatement;
function ImportSpecifier(node) {
    if (node.importKind === "type" || node.importKind === "typeof") {
        this.word(node.importKind);
        this.space();
    }
    this.print(node.imported, node);
    if (node.local && node.local.name !== node.imported.name) {
        this.space();
        this.word("as");
        this.space();
        this.print(node.local, node);
    }
}
function ImportDefaultSpecifier(node) {
    this.print(node.local, node);
}
function ExportDefaultSpecifier(node) {
    this.print(node.exported, node);
}
function ExportSpecifier(node) {
    if (node.exportKind === "type") {
        this.word("type");
        this.space();
    }
    this.print(node.local, node);
    if (node.exported && node.local.name !== node.exported.name) {
        this.space();
        this.word("as");
        this.space();
        this.print(node.exported, node);
    }
}
function ExportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word("as");
    this.space();
    this.print(node.exported, node);
}
var warningShown = false;
function _printAttributes(node) {
    var importAttributesKeyword = this.format.importAttributesKeyword;
    var attributes = node.attributes, assertions = node.assertions;
    if (attributes && !importAttributesKeyword && !warningShown) {
        warningShown = true;
        console.warn('You are using import attributes, without specifying the desired output syntax.\nPlease specify the "importAttributesKeyword" generator option, whose value can be one of:\n - "with"        : `import { a } from "b" with { type: "json" };`\n - "assert"      : `import { a } from "b" assert { type: "json" };`\n - "with-legacy" : `import { a } from "b" with type: "json";`\n');
    }
    var useAssertKeyword = importAttributesKeyword === "assert" || !importAttributesKeyword && assertions;
    this.word(useAssertKeyword ? "assert" : "with");
    this.space();
    if (!useAssertKeyword && importAttributesKeyword !== "with") {
        this.printList(attributes || assertions, node);
        return;
    }
    this.tokenChar(123);
    this.space();
    this.printList(attributes || assertions, node);
    this.space();
    this.tokenChar(125);
}
function ExportAllDeclaration(node) {
    var _node_attributes, _node_assertions;
    this.word("export");
    this.space();
    if (node.exportKind === "type") {
        this.word("type");
        this.space();
    }
    this.tokenChar(42);
    this.space();
    this.word("from");
    this.space();
    if (((_node_attributes = node.attributes) === null || _node_attributes === void 0 ? void 0 : _node_attributes.length) || ((_node_assertions = node.assertions) === null || _node_assertions === void 0 ? void 0 : _node_assertions.length)) {
        this.print(node.source, node, true);
        this.space();
        this._printAttributes(node);
    } else {
        this.print(node.source, node);
    }
    this.semicolon();
}
function maybePrintDecoratorsBeforeExport(printer, node) {
    if (isClassDeclaration2(node.declaration) && printer._shouldPrintDecoratorsBeforeExport(node)) {
        printer.printJoin(node.declaration.decorators, node);
    }
}
function ExportNamedDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word("export");
    this.space();
    if (node.declaration) {
        var declar = node.declaration;
        this.print(declar, node);
        if (!isStatement$2(declar)) this.semicolon();
    } else {
        if (node.exportKind === "type") {
            this.word("type");
            this.space();
        }
        var specifiers = node.specifiers.slice(0);
        var hasSpecial = false;
        for(;;){
            var first = specifiers[0];
            if (isExportDefaultSpecifier2(first) || isExportNamespaceSpecifier2(first)) {
                hasSpecial = true;
                this.print(specifiers.shift(), node);
                if (specifiers.length) {
                    this.tokenChar(44);
                    this.space();
                }
            } else {
                break;
            }
        }
        if (specifiers.length || !specifiers.length && !hasSpecial) {
            this.tokenChar(123);
            if (specifiers.length) {
                this.space();
                this.printList(specifiers, node);
                this.space();
            }
            this.tokenChar(125);
        }
        if (node.source) {
            var _node_attributes, _node_assertions;
            this.space();
            this.word("from");
            this.space();
            if (((_node_attributes = node.attributes) === null || _node_attributes === void 0 ? void 0 : _node_attributes.length) || ((_node_assertions = node.assertions) === null || _node_assertions === void 0 ? void 0 : _node_assertions.length)) {
                this.print(node.source, node, true);
                this.space();
                this._printAttributes(node);
            } else {
                this.print(node.source, node);
            }
        }
        this.semicolon();
    }
}
function ExportDefaultDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word("export");
    this.noIndentInnerCommentsHere();
    this.space();
    this.word("default");
    this.space();
    var declar = node.declaration;
    this.print(declar, node);
    if (!isStatement$2(declar)) this.semicolon();
}
function ImportDeclaration(node) {
    var _node_attributes, _node_assertions;
    this.word("import");
    this.space();
    var isTypeKind = node.importKind === "type" || node.importKind === "typeof";
    if (isTypeKind) {
        this.noIndentInnerCommentsHere();
        this.word(node.importKind);
        this.space();
    } else if (node.module) {
        this.noIndentInnerCommentsHere();
        this.word("module");
        this.space();
    } else if (node.phase) {
        this.noIndentInnerCommentsHere();
        this.word(node.phase);
        this.space();
    }
    var specifiers = node.specifiers.slice(0);
    var hasSpecifiers = !!specifiers.length;
    while(hasSpecifiers){
        var first = specifiers[0];
        if (isImportDefaultSpecifier2(first) || isImportNamespaceSpecifier2(first)) {
            this.print(specifiers.shift(), node);
            if (specifiers.length) {
                this.tokenChar(44);
                this.space();
            }
        } else {
            break;
        }
    }
    if (specifiers.length) {
        this.tokenChar(123);
        this.space();
        this.printList(specifiers, node);
        this.space();
        this.tokenChar(125);
    } else if (isTypeKind && !hasSpecifiers) {
        this.tokenChar(123);
        this.tokenChar(125);
    }
    if (hasSpecifiers || isTypeKind) {
        this.space();
        this.word("from");
        this.space();
    }
    if (((_node_attributes = node.attributes) === null || _node_attributes === void 0 ? void 0 : _node_attributes.length) || ((_node_assertions = node.assertions) === null || _node_assertions === void 0 ? void 0 : _node_assertions.length)) {
        this.print(node.source, node, true);
        this.space();
        this._printAttributes(node);
    } else {
        this.print(node.source, node);
    }
    this.semicolon();
}
function ImportAttribute(node) {
    this.print(node.key);
    this.tokenChar(58);
    this.space();
    this.print(node.value);
}
function ImportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word("as");
    this.space();
    this.print(node.local, node);
}
function ImportExpression(node) {
    this.word("import");
    if (node.phase) {
        this.tokenChar(46);
        this.word(node.phase);
    }
    this.tokenChar(40);
    this.print(node.source, node);
    if (node.options != null) {
        this.tokenChar(44);
        this.space();
        this.print(node.options, node);
    }
    this.tokenChar(41);
}
var isAssignmentPattern2 = lib_exports.isAssignmentPattern, isIdentifier3 = lib_exports.isIdentifier;
function Identifier(node) {
    var _node_loc;
    this.sourceIdentifierName(((_node_loc = node.loc) === null || _node_loc === void 0 ? void 0 : _node_loc.identifierName) || node.name);
    this.word(node.name);
}
function ArgumentPlaceholder() {
    this.tokenChar(63);
}
function RestElement(node) {
    this.token("...");
    this.print(node.argument, node);
}
function ObjectExpression(node) {
    var props = node.properties;
    this.tokenChar(123);
    if (props.length) {
        this.space();
        this.printList(props, node, {
            indent: true,
            statement: true
        });
        this.space();
    }
    this.sourceWithOffset("end", node.loc, -1);
    this.tokenChar(125);
}
function ObjectMethod(node) {
    this.printJoin(node.decorators, node);
    this._methodHead(node);
    this.space();
    this.print(node.body, node);
}
function ObjectProperty(node) {
    this.printJoin(node.decorators, node);
    if (node.computed) {
        this.tokenChar(91);
        this.print(node.key, node);
        this.tokenChar(93);
    } else {
        if (isAssignmentPattern2(node.value) && isIdentifier3(node.key) && node.key.name === node.value.left.name) {
            this.print(node.value, node);
            return;
        }
        this.print(node.key, node);
        if (node.shorthand && isIdentifier3(node.key) && isIdentifier3(node.value) && node.key.name === node.value.name) {
            return;
        }
    }
    this.tokenChar(58);
    this.space();
    this.print(node.value, node);
}
function ArrayExpression(node) {
    var elems = node.elements;
    var len = elems.length;
    this.tokenChar(91);
    for(var i = 0; i < elems.length; i++){
        var elem = elems[i];
        if (elem) {
            if (i > 0) this.space();
            this.print(elem, node);
            if (i < len - 1) this.tokenChar(44);
        } else {
            this.tokenChar(44);
        }
    }
    this.tokenChar(93);
}
function RecordExpression(node) {
    var props = node.properties;
    var startToken;
    var endToken;
    if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "{|";
        endToken = "|}";
    } else if (this.format.recordAndTupleSyntaxType !== "hash" && this.format.recordAndTupleSyntaxType != null) {
        throw new Error('The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" ('.concat(JSON.stringify(this.format.recordAndTupleSyntaxType), " received)."));
    } else {
        startToken = "#{";
        endToken = "}";
    }
    this.token(startToken);
    if (props.length) {
        this.space();
        this.printList(props, node, {
            indent: true,
            statement: true
        });
        this.space();
    }
    this.token(endToken);
}
function TupleExpression(node) {
    var elems = node.elements;
    var len = elems.length;
    var startToken;
    var endToken;
    if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "[|";
        endToken = "|]";
    } else if (this.format.recordAndTupleSyntaxType === "hash") {
        startToken = "#[";
        endToken = "]";
    } else {
        throw new Error("".concat(this.format.recordAndTupleSyntaxType, " is not a valid recordAndTuple syntax type"));
    }
    this.token(startToken);
    for(var i = 0; i < elems.length; i++){
        var elem = elems[i];
        if (elem) {
            if (i > 0) this.space();
            this.print(elem, node);
            if (i < len - 1) this.tokenChar(44);
        }
    }
    this.token(endToken);
}
function RegExpLiteral(node) {
    this.word("/".concat(node.pattern, "/").concat(node.flags));
}
function BooleanLiteral(node) {
    this.word(node.value ? "true" : "false");
}
function NullLiteral() {
    this.word("null");
}
function NumericLiteral(node) {
    var raw = this.getPossibleRaw(node);
    var opts = this.format.jsescOption;
    var value1 = node.value;
    var str = value1 + "";
    if (opts.numbers) {
        this.number((0, import_jsesc.default)(value1, opts), value1);
    } else if (raw == null) {
        this.number(str, value1);
    } else if (this.format.minified) {
        this.number(raw.length < str.length ? raw : str, value1);
    } else {
        this.number(raw, value1);
    }
}
function StringLiteral(node) {
    var raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== void 0) {
        this.token(raw);
        return;
    }
    var val = (0, import_jsesc.default)(node.value, this.format.jsescOption);
    this.token(val);
}
function BigIntLiteral(node) {
    var raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== void 0) {
        this.word(raw);
        return;
    }
    this.word(node.value + "n");
}
function DecimalLiteral(node) {
    var raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== void 0) {
        this.word(raw);
        return;
    }
    this.word(node.value + "m");
}
var validTopicTokenSet = /* @__PURE__ */ new Set([
    "^^",
    "@@",
    "^",
    "%",
    "#"
]);
function TopicReference() {
    var topicToken = this.format.topicToken;
    if (validTopicTokenSet.has(topicToken)) {
        this.token(topicToken);
    } else {
        var givenTopicTokenJSON = JSON.stringify(topicToken);
        var validTopics = Array.from(validTopicTokenSet, function(v) {
            return JSON.stringify(v);
        });
        throw new Error('The "topicToken" generator option must be one of '.concat(validTopics.join(", "), " (").concat(givenTopicTokenJSON, " received instead)."));
    }
}
function PipelineTopicExpression(node) {
    this.print(node.expression, node);
}
function PipelineBareFunction(node) {
    this.print(node.callee, node);
}
function PipelinePrimaryTopicReference() {
    this.tokenChar(35);
}
var isDeclareExportDeclaration2 = lib_exports.isDeclareExportDeclaration, isStatement$12 = lib_exports.isStatement;
function AnyTypeAnnotation() {
    this.word("any");
}
function ArrayTypeAnnotation(node) {
    this.print(node.elementType, node, true);
    this.tokenChar(91);
    this.tokenChar(93);
}
function BooleanTypeAnnotation() {
    this.word("boolean");
}
function BooleanLiteralTypeAnnotation(node) {
    this.word(node.value ? "true" : "false");
}
function NullLiteralTypeAnnotation() {
    this.word("null");
}
function DeclareClass(node, parent) {
    if (!isDeclareExportDeclaration2(parent)) {
        this.word("declare");
        this.space();
    }
    this.word("class");
    this.space();
    this._interfaceish(node);
}
function DeclareFunction(node, parent) {
    if (!isDeclareExportDeclaration2(parent)) {
        this.word("declare");
        this.space();
    }
    this.word("function");
    this.space();
    this.print(node.id, node);
    this.print(node.id.typeAnnotation.typeAnnotation, node);
    if (node.predicate) {
        this.space();
        this.print(node.predicate, node);
    }
    this.semicolon();
}
function InferredPredicate() {
    this.tokenChar(37);
    this.word("checks");
}
function DeclaredPredicate(node) {
    this.tokenChar(37);
    this.word("checks");
    this.tokenChar(40);
    this.print(node.value, node);
    this.tokenChar(41);
}
function DeclareInterface(node) {
    this.word("declare");
    this.space();
    this.InterfaceDeclaration(node);
}
function DeclareModule(node) {
    this.word("declare");
    this.space();
    this.word("module");
    this.space();
    this.print(node.id, node);
    this.space();
    this.print(node.body, node);
}
function DeclareModuleExports(node) {
    this.word("declare");
    this.space();
    this.word("module");
    this.tokenChar(46);
    this.word("exports");
    this.print(node.typeAnnotation, node);
}
function DeclareTypeAlias(node) {
    this.word("declare");
    this.space();
    this.TypeAlias(node);
}
function DeclareOpaqueType(node, parent) {
    if (!isDeclareExportDeclaration2(parent)) {
        this.word("declare");
        this.space();
    }
    this.OpaqueType(node);
}
function DeclareVariable(node, parent) {
    if (!isDeclareExportDeclaration2(parent)) {
        this.word("declare");
        this.space();
    }
    this.word("var");
    this.space();
    this.print(node.id, node);
    this.print(node.id.typeAnnotation, node);
    this.semicolon();
}
function DeclareExportDeclaration(node) {
    this.word("declare");
    this.space();
    this.word("export");
    this.space();
    if (node.default) {
        this.word("default");
        this.space();
    }
    FlowExportDeclaration.call(this, node);
}
function DeclareExportAllDeclaration(node) {
    this.word("declare");
    this.space();
    ExportAllDeclaration.call(this, node);
}
function EnumDeclaration(node) {
    var id = node.id, body = node.body;
    this.word("enum");
    this.space();
    this.print(id, node);
    this.print(body, node);
}
function enumExplicitType(context, name, hasExplicitType) {
    if (hasExplicitType) {
        context.space();
        context.word("of");
        context.space();
        context.word(name);
    }
    context.space();
}
function enumBody(context, node) {
    var members = node.members;
    context.token("{");
    context.indent();
    context.newline();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = members[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var member = _step.value;
            context.print(member, node);
            context.newline();
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    if (node.hasUnknownMembers) {
        context.token("...");
        context.newline();
    }
    context.dedent();
    context.token("}");
}
function EnumBooleanBody(node) {
    var explicitType = node.explicitType;
    enumExplicitType(this, "boolean", explicitType);
    enumBody(this, node);
}
function EnumNumberBody(node) {
    var explicitType = node.explicitType;
    enumExplicitType(this, "number", explicitType);
    enumBody(this, node);
}
function EnumStringBody(node) {
    var explicitType = node.explicitType;
    enumExplicitType(this, "string", explicitType);
    enumBody(this, node);
}
function EnumSymbolBody(node) {
    enumExplicitType(this, "symbol", true);
    enumBody(this, node);
}
function EnumDefaultedMember(node) {
    var id = node.id;
    this.print(id, node);
    this.tokenChar(44);
}
function enumInitializedMember(context, node) {
    var id = node.id, init = node.init;
    context.print(id, node);
    context.space();
    context.token("=");
    context.space();
    context.print(init, node);
    context.token(",");
}
function EnumBooleanMember(node) {
    enumInitializedMember(this, node);
}
function EnumNumberMember(node) {
    enumInitializedMember(this, node);
}
function EnumStringMember(node) {
    enumInitializedMember(this, node);
}
function FlowExportDeclaration(node) {
    if (node.declaration) {
        var declar = node.declaration;
        this.print(declar, node);
        if (!isStatement$12(declar)) this.semicolon();
    } else {
        this.tokenChar(123);
        if (node.specifiers.length) {
            this.space();
            this.printList(node.specifiers, node);
            this.space();
        }
        this.tokenChar(125);
        if (node.source) {
            this.space();
            this.word("from");
            this.space();
            this.print(node.source, node);
        }
        this.semicolon();
    }
}
function ExistsTypeAnnotation() {
    this.tokenChar(42);
}
function FunctionTypeAnnotation(node, parent) {
    this.print(node.typeParameters, node);
    this.tokenChar(40);
    if (node.this) {
        this.word("this");
        this.tokenChar(58);
        this.space();
        this.print(node.this.typeAnnotation, node);
        if (node.params.length || node.rest) {
            this.tokenChar(44);
            this.space();
        }
    }
    this.printList(node.params, node);
    if (node.rest) {
        if (node.params.length) {
            this.tokenChar(44);
            this.space();
        }
        this.token("...");
        this.print(node.rest, node);
    }
    this.tokenChar(41);
    var type = parent === null || parent === void 0 ? void 0 : parent.type;
    if (type != null && (type === "ObjectTypeCallProperty" || type === "ObjectTypeInternalSlot" || type === "DeclareFunction" || type === "ObjectTypeProperty" && parent.method)) {
        this.tokenChar(58);
    } else {
        this.space();
        this.token("=>");
    }
    this.space();
    this.print(node.returnType, node);
}
function FunctionTypeParam(node) {
    this.print(node.name, node);
    if (node.optional) this.tokenChar(63);
    if (node.name) {
        this.tokenChar(58);
        this.space();
    }
    this.print(node.typeAnnotation, node);
}
function InterfaceExtends(node) {
    this.print(node.id, node);
    this.print(node.typeParameters, node, true);
}
function _interfaceish(node) {
    var _node_extends;
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    if ((_node_extends = node.extends) === null || _node_extends === void 0 ? void 0 : _node_extends.length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(node.extends, node);
    }
    if (node.type === "DeclareClass") {
        var _node_mixins, _node_implements;
        if ((_node_mixins = node.mixins) === null || _node_mixins === void 0 ? void 0 : _node_mixins.length) {
            this.space();
            this.word("mixins");
            this.space();
            this.printList(node.mixins, node);
        }
        if ((_node_implements = node.implements) === null || _node_implements === void 0 ? void 0 : _node_implements.length) {
            this.space();
            this.word("implements");
            this.space();
            this.printList(node.implements, node);
        }
    }
    this.space();
    this.print(node.body, node);
}
function _variance(node) {
    var _node_variance;
    var kind = (_node_variance = node.variance) === null || _node_variance === void 0 ? void 0 : _node_variance.kind;
    if (kind != null) {
        if (kind === "plus") {
            this.tokenChar(43);
        } else if (kind === "minus") {
            this.tokenChar(45);
        }
    }
}
function InterfaceDeclaration(node) {
    this.word("interface");
    this.space();
    this._interfaceish(node);
}
function andSeparator() {
    this.space();
    this.tokenChar(38);
    this.space();
}
function InterfaceTypeAnnotation(node) {
    var _node_extends;
    this.word("interface");
    if ((_node_extends = node.extends) === null || _node_extends === void 0 ? void 0 : _node_extends.length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(node.extends, node);
    }
    this.space();
    this.print(node.body, node);
}
function IntersectionTypeAnnotation(node) {
    this.printJoin(node.types, node, {
        separator: andSeparator
    });
}
function MixedTypeAnnotation() {
    this.word("mixed");
}
function EmptyTypeAnnotation() {
    this.word("empty");
}
function NullableTypeAnnotation(node) {
    this.tokenChar(63);
    this.print(node.typeAnnotation, node);
}
function NumberTypeAnnotation() {
    this.word("number");
}
function StringTypeAnnotation() {
    this.word("string");
}
function ThisTypeAnnotation() {
    this.word("this");
}
function TupleTypeAnnotation(node) {
    this.tokenChar(91);
    this.printList(node.types, node);
    this.tokenChar(93);
}
function TypeofTypeAnnotation(node) {
    this.word("typeof");
    this.space();
    this.print(node.argument, node);
}
function TypeAlias(node) {
    this.word("type");
    this.space();
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right, node);
    this.semicolon();
}
function TypeAnnotation(node) {
    this.tokenChar(58);
    this.space();
    if (node.optional) this.tokenChar(63);
    this.print(node.typeAnnotation, node);
}
function TypeParameterInstantiation(node) {
    this.tokenChar(60);
    this.printList(node.params, node, {});
    this.tokenChar(62);
}
function TypeParameter(node) {
    this._variance(node);
    this.word(node.name);
    if (node.bound) {
        this.print(node.bound, node);
    }
    if (node.default) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.default, node);
    }
}
function OpaqueType(node) {
    this.word("opaque");
    this.space();
    this.word("type");
    this.space();
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    if (node.supertype) {
        this.tokenChar(58);
        this.space();
        this.print(node.supertype, node);
    }
    if (node.impltype) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.impltype, node);
    }
    this.semicolon();
}
function ObjectTypeAnnotation(node) {
    var _this = this;
    if (node.exact) {
        this.token("{|");
    } else {
        this.tokenChar(123);
    }
    var props = _to_consumable_array(node.properties).concat(_to_consumable_array(node.callProperties || []), _to_consumable_array(node.indexers || []), _to_consumable_array(node.internalSlots || []));
    if (props.length) {
        this.newline();
        this.space();
        this.printJoin(props, node, {
            addNewlines: function addNewlines(leading) {
                if (leading && !props[0]) return 1;
            },
            indent: true,
            statement: true,
            iterator: function() {
                if (props.length !== 1 || node.inexact) {
                    _this.tokenChar(44);
                    _this.space();
                }
            }
        });
        this.space();
    }
    if (node.inexact) {
        this.indent();
        this.token("...");
        if (props.length) {
            this.newline();
        }
        this.dedent();
    }
    if (node.exact) {
        this.token("|}");
    } else {
        this.tokenChar(125);
    }
}
function ObjectTypeInternalSlot(node) {
    if (node.static) {
        this.word("static");
        this.space();
    }
    this.tokenChar(91);
    this.tokenChar(91);
    this.print(node.id, node);
    this.tokenChar(93);
    this.tokenChar(93);
    if (node.optional) this.tokenChar(63);
    if (!node.method) {
        this.tokenChar(58);
        this.space();
    }
    this.print(node.value, node);
}
function ObjectTypeCallProperty(node) {
    if (node.static) {
        this.word("static");
        this.space();
    }
    this.print(node.value, node);
}
function ObjectTypeIndexer(node) {
    if (node.static) {
        this.word("static");
        this.space();
    }
    this._variance(node);
    this.tokenChar(91);
    if (node.id) {
        this.print(node.id, node);
        this.tokenChar(58);
        this.space();
    }
    this.print(node.key, node);
    this.tokenChar(93);
    this.tokenChar(58);
    this.space();
    this.print(node.value, node);
}
function ObjectTypeProperty(node) {
    if (node.proto) {
        this.word("proto");
        this.space();
    }
    if (node.static) {
        this.word("static");
        this.space();
    }
    if (node.kind === "get" || node.kind === "set") {
        this.word(node.kind);
        this.space();
    }
    this._variance(node);
    this.print(node.key, node);
    if (node.optional) this.tokenChar(63);
    if (!node.method) {
        this.tokenChar(58);
        this.space();
    }
    this.print(node.value, node);
}
function ObjectTypeSpreadProperty(node) {
    this.token("...");
    this.print(node.argument, node);
}
function QualifiedTypeIdentifier(node) {
    this.print(node.qualification, node);
    this.tokenChar(46);
    this.print(node.id, node);
}
function SymbolTypeAnnotation() {
    this.word("symbol");
}
function orSeparator() {
    this.space();
    this.tokenChar(124);
    this.space();
}
function UnionTypeAnnotation(node) {
    this.printJoin(node.types, node, {
        separator: orSeparator
    });
}
function TypeCastExpression(node) {
    this.tokenChar(40);
    this.print(node.expression, node);
    this.print(node.typeAnnotation, node);
    this.tokenChar(41);
}
function Variance(node) {
    if (node.kind === "plus") {
        this.tokenChar(43);
    } else {
        this.tokenChar(45);
    }
}
function VoidTypeAnnotation() {
    this.word("void");
}
function IndexedAccessType(node) {
    this.print(node.objectType, node, true);
    this.tokenChar(91);
    this.print(node.indexType, node);
    this.tokenChar(93);
}
function OptionalIndexedAccessType(node) {
    this.print(node.objectType, node);
    if (node.optional) {
        this.token("?.");
    }
    this.tokenChar(91);
    this.print(node.indexType, node);
    this.tokenChar(93);
}
function File(node) {
    if (node.program) {
        this.print(node.program.interpreter, node);
    }
    this.print(node.program, node);
}
function Program(node) {
    var _node_directives;
    this.noIndentInnerCommentsHere();
    this.printInnerComments();
    var directivesLen = (_node_directives = node.directives) === null || _node_directives === void 0 ? void 0 : _node_directives.length;
    if (directivesLen) {
        var _node_directives__trailingComments;
        var newline = node.body.length ? 2 : 1;
        this.printSequence(node.directives, node, {
            trailingCommentsLineOffset: newline
        });
        if (!((_node_directives__trailingComments = node.directives[directivesLen - 1].trailingComments) === null || _node_directives__trailingComments === void 0 ? void 0 : _node_directives__trailingComments.length)) {
            this.newline(newline);
        }
    }
    this.printSequence(node.body, node);
}
function BlockStatement(node) {
    var _node_directives;
    this.tokenChar(123);
    var directivesLen = (_node_directives = node.directives) === null || _node_directives === void 0 ? void 0 : _node_directives.length;
    if (directivesLen) {
        var _node_directives__trailingComments;
        var newline = node.body.length ? 2 : 1;
        this.printSequence(node.directives, node, {
            indent: true,
            trailingCommentsLineOffset: newline
        });
        if (!((_node_directives__trailingComments = node.directives[directivesLen - 1].trailingComments) === null || _node_directives__trailingComments === void 0 ? void 0 : _node_directives__trailingComments.length)) {
            this.newline(newline);
        }
    }
    this.printSequence(node.body, node, {
        indent: true
    });
    this.rightBrace(node);
}
function Directive(node) {
    this.print(node.value, node);
    this.semicolon();
}
var unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
var unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
function DirectiveLiteral(node) {
    var raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== void 0) {
        this.token(raw);
        return;
    }
    var value1 = node.value;
    if (!unescapedDoubleQuoteRE.test(value1)) {
        this.token('"'.concat(value1, '"'));
    } else if (!unescapedSingleQuoteRE.test(value1)) {
        this.token("'".concat(value1, "'"));
    } else {
        throw new Error("Malformed AST: it is not possible to print a directive containing both unescaped single and double quotes.");
    }
}
function InterpreterDirective(node) {
    this.token("#!".concat(node.value));
    this.newline(1, true);
}
function Placeholder(node) {
    this.token("%%");
    this.print(node.name);
    this.token("%%");
    if (node.expectedNode === "Statement") {
        this.semicolon();
    }
}
function JSXAttribute(node) {
    this.print(node.name, node);
    if (node.value) {
        this.tokenChar(61);
        this.print(node.value, node);
    }
}
function JSXIdentifier(node) {
    this.word(node.name);
}
function JSXNamespacedName(node) {
    this.print(node.namespace, node);
    this.tokenChar(58);
    this.print(node.name, node);
}
function JSXMemberExpression(node) {
    this.print(node.object, node);
    this.tokenChar(46);
    this.print(node.property, node);
}
function JSXSpreadAttribute(node) {
    this.tokenChar(123);
    this.token("...");
    this.print(node.argument, node);
    this.tokenChar(125);
}
function JSXExpressionContainer(node) {
    this.tokenChar(123);
    this.print(node.expression, node);
    this.tokenChar(125);
}
function JSXSpreadChild(node) {
    this.tokenChar(123);
    this.token("...");
    this.print(node.expression, node);
    this.tokenChar(125);
}
function JSXText(node) {
    var raw = this.getPossibleRaw(node);
    if (raw !== void 0) {
        this.token(raw, true);
    } else {
        this.token(node.value, true);
    }
}
function JSXElement(node) {
    var open = node.openingElement;
    this.print(open, node);
    if (open.selfClosing) return;
    this.indent();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = node.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var child = _step.value;
            this.print(child, node);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    this.dedent();
    this.print(node.closingElement, node);
}
function spaceSeparator() {
    this.space();
}
function JSXOpeningElement(node) {
    this.tokenChar(60);
    this.print(node.name, node);
    this.print(node.typeParameters, node);
    if (node.attributes.length > 0) {
        this.space();
        this.printJoin(node.attributes, node, {
            separator: spaceSeparator
        });
    }
    if (node.selfClosing) {
        this.space();
        this.token("/>");
    } else {
        this.tokenChar(62);
    }
}
function JSXClosingElement(node) {
    this.token("</");
    this.print(node.name, node);
    this.tokenChar(62);
}
function JSXEmptyExpression() {
    this.printInnerComments();
}
function JSXFragment(node) {
    this.print(node.openingFragment, node);
    this.indent();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = node.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var child = _step.value;
            this.print(child, node);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    this.dedent();
    this.print(node.closingFragment, node);
}
function JSXOpeningFragment() {
    this.tokenChar(60);
    this.tokenChar(62);
}
function JSXClosingFragment() {
    this.token("</");
    this.tokenChar(62);
}
function TSTypeAnnotation(node) {
    this.tokenChar(58);
    this.space();
    if (node.optional) this.tokenChar(63);
    this.print(node.typeAnnotation, node);
}
function TSTypeParameterInstantiation(node, parent) {
    this.tokenChar(60);
    this.printList(node.params, node, {});
    if (parent.type === "ArrowFunctionExpression" && node.params.length === 1) {
        this.tokenChar(44);
    }
    this.tokenChar(62);
}
function TSTypeParameter(node) {
    if (node.in) {
        this.word("in");
        this.space();
    }
    if (node.out) {
        this.word("out");
        this.space();
    }
    this.word(node.name.name);
    if (node.constraint) {
        this.space();
        this.word("extends");
        this.space();
        this.print(node.constraint, node);
    }
    if (node.default) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.default, node);
    }
}
function TSParameterProperty(node) {
    if (node.accessibility) {
        this.word(node.accessibility);
        this.space();
    }
    if (node.readonly) {
        this.word("readonly");
        this.space();
    }
    this._param(node.parameter);
}
function TSDeclareFunction(node, parent) {
    if (node.declare) {
        this.word("declare");
        this.space();
    }
    this._functionHead(node, parent);
    this.tokenChar(59);
}
function TSDeclareMethod(node) {
    this._classMethodHead(node);
    this.tokenChar(59);
}
function TSQualifiedName(node) {
    this.print(node.left, node);
    this.tokenChar(46);
    this.print(node.right, node);
}
function TSCallSignatureDeclaration(node) {
    this.tsPrintSignatureDeclarationBase(node);
    this.tokenChar(59);
}
function TSConstructSignatureDeclaration(node) {
    this.word("new");
    this.space();
    this.tsPrintSignatureDeclarationBase(node);
    this.tokenChar(59);
}
function TSPropertySignature(node) {
    var readonly = node.readonly;
    if (readonly) {
        this.word("readonly");
        this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.print(node.typeAnnotation, node);
    this.tokenChar(59);
}
function tsPrintPropertyOrMethodName(node) {
    if (node.computed) {
        this.tokenChar(91);
    }
    this.print(node.key, node);
    if (node.computed) {
        this.tokenChar(93);
    }
    if (node.optional) {
        this.tokenChar(63);
    }
}
function TSMethodSignature(node) {
    var kind = node.kind;
    if (kind === "set" || kind === "get") {
        this.word(kind);
        this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.tsPrintSignatureDeclarationBase(node);
    this.tokenChar(59);
}
function TSIndexSignature(node) {
    var readonly = node.readonly, isStatic2 = node.static;
    if (isStatic2) {
        this.word("static");
        this.space();
    }
    if (readonly) {
        this.word("readonly");
        this.space();
    }
    this.tokenChar(91);
    this._parameters(node.parameters, node);
    this.tokenChar(93);
    this.print(node.typeAnnotation, node);
    this.tokenChar(59);
}
function TSAnyKeyword() {
    this.word("any");
}
function TSBigIntKeyword() {
    this.word("bigint");
}
function TSUnknownKeyword() {
    this.word("unknown");
}
function TSNumberKeyword() {
    this.word("number");
}
function TSObjectKeyword() {
    this.word("object");
}
function TSBooleanKeyword() {
    this.word("boolean");
}
function TSStringKeyword() {
    this.word("string");
}
function TSSymbolKeyword() {
    this.word("symbol");
}
function TSVoidKeyword() {
    this.word("void");
}
function TSUndefinedKeyword() {
    this.word("undefined");
}
function TSNullKeyword() {
    this.word("null");
}
function TSNeverKeyword() {
    this.word("never");
}
function TSIntrinsicKeyword() {
    this.word("intrinsic");
}
function TSThisType() {
    this.word("this");
}
function TSFunctionType(node) {
    this.tsPrintFunctionOrConstructorType(node);
}
function TSConstructorType(node) {
    if (node.abstract) {
        this.word("abstract");
        this.space();
    }
    this.word("new");
    this.space();
    this.tsPrintFunctionOrConstructorType(node);
}
function tsPrintFunctionOrConstructorType(node) {
    var typeParameters = node.typeParameters;
    var parameters = node.params;
    this.print(typeParameters, node);
    this.tokenChar(40);
    this._parameters(parameters, node);
    this.tokenChar(41);
    this.space();
    this.token("=>");
    this.space();
    var returnType = node.returnType;
    this.print(returnType.typeAnnotation, node);
}
function TSTypeReference(node) {
    this.print(node.typeName, node, true);
    this.print(node.typeParameters, node, true);
}
function TSTypePredicate(node) {
    if (node.asserts) {
        this.word("asserts");
        this.space();
    }
    this.print(node.parameterName);
    if (node.typeAnnotation) {
        this.space();
        this.word("is");
        this.space();
        this.print(node.typeAnnotation.typeAnnotation);
    }
}
function TSTypeQuery(node) {
    this.word("typeof");
    this.space();
    this.print(node.exprName);
    if (node.typeParameters) {
        this.print(node.typeParameters, node);
    }
}
function TSTypeLiteral(node) {
    this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
}
function tsPrintTypeLiteralOrInterfaceBody(members, node) {
    tsPrintBraced(this, members, node);
}
function tsPrintBraced(printer, members, node) {
    printer.token("{");
    if (members.length) {
        printer.indent();
        printer.newline();
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = members[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var member = _step.value;
                printer.print(member, node);
                printer.newline();
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        printer.dedent();
    }
    printer.rightBrace(node);
}
function TSArrayType(node) {
    this.print(node.elementType, node, true);
    this.token("[]");
}
function TSTupleType(node) {
    this.tokenChar(91);
    this.printList(node.elementTypes, node);
    this.tokenChar(93);
}
function TSOptionalType(node) {
    this.print(node.typeAnnotation, node);
    this.tokenChar(63);
}
function TSRestType(node) {
    this.token("...");
    this.print(node.typeAnnotation, node);
}
function TSNamedTupleMember(node) {
    this.print(node.label, node);
    if (node.optional) this.tokenChar(63);
    this.tokenChar(58);
    this.space();
    this.print(node.elementType, node);
}
function TSUnionType(node) {
    tsPrintUnionOrIntersectionType(this, node, "|");
}
function TSIntersectionType(node) {
    tsPrintUnionOrIntersectionType(this, node, "&");
}
function tsPrintUnionOrIntersectionType(printer, node, sep) {
    printer.printJoin(node.types, node, {
        separator: function separator() {
            this.space();
            this.token(sep);
            this.space();
        }
    });
}
function TSConditionalType(node) {
    this.print(node.checkType);
    this.space();
    this.word("extends");
    this.space();
    this.print(node.extendsType);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.trueType);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.falseType);
}
function TSInferType(node) {
    this.token("infer");
    this.space();
    this.print(node.typeParameter);
}
function TSParenthesizedType(node) {
    this.tokenChar(40);
    this.print(node.typeAnnotation, node);
    this.tokenChar(41);
}
function TSTypeOperator(node) {
    this.word(node.operator);
    this.space();
    this.print(node.typeAnnotation, node);
}
function TSIndexedAccessType(node) {
    this.print(node.objectType, node, true);
    this.tokenChar(91);
    this.print(node.indexType, node);
    this.tokenChar(93);
}
function TSMappedType(node) {
    var nameType = node.nameType, optional = node.optional, readonly = node.readonly, typeParameter2 = node.typeParameter;
    this.tokenChar(123);
    this.space();
    if (readonly) {
        tokenIfPlusMinus(this, readonly);
        this.word("readonly");
        this.space();
    }
    this.tokenChar(91);
    this.word(typeParameter2.name.name);
    this.space();
    this.word("in");
    this.space();
    this.print(typeParameter2.constraint, typeParameter2);
    if (nameType) {
        this.space();
        this.word("as");
        this.space();
        this.print(nameType, node);
    }
    this.tokenChar(93);
    if (optional) {
        tokenIfPlusMinus(this, optional);
        this.tokenChar(63);
    }
    this.tokenChar(58);
    this.space();
    this.print(node.typeAnnotation, node);
    this.space();
    this.tokenChar(125);
}
function tokenIfPlusMinus(self, tok) {
    if (tok !== true) {
        self.token(tok);
    }
}
function TSLiteralType(node) {
    this.print(node.literal, node);
}
function TSExpressionWithTypeArguments(node) {
    this.print(node.expression, node);
    this.print(node.typeParameters, node);
}
function TSInterfaceDeclaration(node) {
    var declare = node.declare, id = node.id, typeParameters = node.typeParameters, extendz = node.extends, body = node.body;
    if (declare) {
        this.word("declare");
        this.space();
    }
    this.word("interface");
    this.space();
    this.print(id, node);
    this.print(typeParameters, node);
    if (extendz === null || extendz === void 0 ? void 0 : extendz.length) {
        this.space();
        this.word("extends");
        this.space();
        this.printList(extendz, node);
    }
    this.space();
    this.print(body, node);
}
function TSInterfaceBody(node) {
    this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
}
function TSTypeAliasDeclaration(node) {
    var declare = node.declare, id = node.id, typeParameters = node.typeParameters, typeAnnotation2 = node.typeAnnotation;
    if (declare) {
        this.word("declare");
        this.space();
    }
    this.word("type");
    this.space();
    this.print(id, node);
    this.print(typeParameters, node);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(typeAnnotation2, node);
    this.tokenChar(59);
}
function TSTypeExpression2(node) {
    var _expression2_trailingComments;
    var type = node.type, expression2 = node.expression, typeAnnotation2 = node.typeAnnotation;
    var forceParens = !!((_expression2_trailingComments = expression2.trailingComments) === null || _expression2_trailingComments === void 0 ? void 0 : _expression2_trailingComments.length);
    this.print(expression2, node, true, void 0, forceParens);
    this.space();
    this.word(type === "TSAsExpression" ? "as" : "satisfies");
    this.space();
    this.print(typeAnnotation2, node);
}
function TSTypeAssertion(node) {
    var typeAnnotation2 = node.typeAnnotation, expression2 = node.expression;
    this.tokenChar(60);
    this.print(typeAnnotation2, node);
    this.tokenChar(62);
    this.space();
    this.print(expression2, node);
}
function TSInstantiationExpression(node) {
    this.print(node.expression, node);
    this.print(node.typeParameters, node);
}
function TSEnumDeclaration(node) {
    var declare = node.declare, isConst = node.const, id = node.id, members = node.members;
    if (declare) {
        this.word("declare");
        this.space();
    }
    if (isConst) {
        this.word("const");
        this.space();
    }
    this.word("enum");
    this.space();
    this.print(id, node);
    this.space();
    tsPrintBraced(this, members, node);
}
function TSEnumMember(node) {
    var id = node.id, initializer = node.initializer;
    this.print(id, node);
    if (initializer) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(initializer, node);
    }
    this.tokenChar(44);
}
function TSModuleDeclaration(node) {
    var declare = node.declare, id = node.id;
    if (declare) {
        this.word("declare");
        this.space();
    }
    if (!node.global) {
        this.word(id.type === "Identifier" ? "namespace" : "module");
        this.space();
    }
    this.print(id, node);
    if (!node.body) {
        this.tokenChar(59);
        return;
    }
    var body = node.body;
    while(body.type === "TSModuleDeclaration"){
        this.tokenChar(46);
        this.print(body.id, body);
        body = body.body;
    }
    this.space();
    this.print(body, node);
}
function TSModuleBlock(node) {
    tsPrintBraced(this, node.body, node);
}
function TSImportType(node) {
    var argument = node.argument, qualifier = node.qualifier, typeParameters = node.typeParameters;
    this.word("import");
    this.tokenChar(40);
    this.print(argument, node);
    this.tokenChar(41);
    if (qualifier) {
        this.tokenChar(46);
        this.print(qualifier, node);
    }
    if (typeParameters) {
        this.print(typeParameters, node);
    }
}
function TSImportEqualsDeclaration(node) {
    var isExport = node.isExport, id = node.id, moduleReference = node.moduleReference;
    if (isExport) {
        this.word("export");
        this.space();
    }
    this.word("import");
    this.space();
    this.print(id, node);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(moduleReference, node);
    this.tokenChar(59);
}
function TSExternalModuleReference(node) {
    this.token("require(");
    this.print(node.expression, node);
    this.tokenChar(41);
}
function TSNonNullExpression(node) {
    this.print(node.expression, node);
    this.tokenChar(33);
}
function TSExportAssignment(node) {
    this.word("export");
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.expression, node);
    this.tokenChar(59);
}
function TSNamespaceExportDeclaration(node) {
    this.word("export");
    this.space();
    this.word("as");
    this.space();
    this.word("namespace");
    this.space();
    this.print(node.id, node);
}
function tsPrintSignatureDeclarationBase(node) {
    var typeParameters = node.typeParameters;
    var parameters = node.params;
    this.print(typeParameters, node);
    this.tokenChar(40);
    this._parameters(parameters, node);
    this.tokenChar(41);
    var returnType = node.returnType;
    this.print(returnType, node);
}
function tsPrintClassMemberModifiers(node) {
    var isField = node.type === "ClassAccessorProperty" || node.type === "ClassProperty";
    if (isField && node.declare) {
        this.word("declare");
        this.space();
    }
    if (node.accessibility) {
        this.word(node.accessibility);
        this.space();
    }
    if (node.static) {
        this.word("static");
        this.space();
    }
    if (node.override) {
        this.word("override");
        this.space();
    }
    if (node.abstract) {
        this.word("abstract");
        this.space();
    }
    if (isField && node.readonly) {
        this.word("readonly");
        this.space();
    }
}
var generatorFunctions = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    AnyTypeAnnotation: AnyTypeAnnotation,
    ArgumentPlaceholder: ArgumentPlaceholder,
    ArrayExpression: ArrayExpression,
    ArrayPattern: ArrayExpression,
    ArrayTypeAnnotation: ArrayTypeAnnotation,
    ArrowFunctionExpression: ArrowFunctionExpression,
    AssignmentExpression: AssignmentExpression,
    AssignmentPattern: AssignmentPattern,
    AwaitExpression: AwaitExpression,
    BigIntLiteral: BigIntLiteral,
    BinaryExpression: AssignmentExpression,
    BindExpression: BindExpression,
    BlockStatement: BlockStatement,
    BooleanLiteral: BooleanLiteral,
    BooleanLiteralTypeAnnotation: BooleanLiteralTypeAnnotation,
    BooleanTypeAnnotation: BooleanTypeAnnotation,
    BreakStatement: BreakStatement,
    CallExpression: CallExpression,
    CatchClause: CatchClause,
    ClassAccessorProperty: ClassAccessorProperty,
    ClassBody: ClassBody,
    ClassDeclaration: ClassDeclaration,
    ClassExpression: ClassDeclaration,
    ClassImplements: InterfaceExtends,
    ClassMethod: ClassMethod,
    ClassPrivateMethod: ClassPrivateMethod,
    ClassPrivateProperty: ClassPrivateProperty,
    ClassProperty: ClassProperty,
    ConditionalExpression: ConditionalExpression,
    ContinueStatement: ContinueStatement,
    DebuggerStatement: DebuggerStatement,
    DecimalLiteral: DecimalLiteral,
    DeclareClass: DeclareClass,
    DeclareExportAllDeclaration: DeclareExportAllDeclaration,
    DeclareExportDeclaration: DeclareExportDeclaration,
    DeclareFunction: DeclareFunction,
    DeclareInterface: DeclareInterface,
    DeclareModule: DeclareModule,
    DeclareModuleExports: DeclareModuleExports,
    DeclareOpaqueType: DeclareOpaqueType,
    DeclareTypeAlias: DeclareTypeAlias,
    DeclareVariable: DeclareVariable,
    DeclaredPredicate: DeclaredPredicate,
    Decorator: Decorator,
    Directive: Directive,
    DirectiveLiteral: DirectiveLiteral,
    DoExpression: DoExpression,
    DoWhileStatement: DoWhileStatement,
    EmptyStatement: EmptyStatement,
    EmptyTypeAnnotation: EmptyTypeAnnotation,
    EnumBooleanBody: EnumBooleanBody,
    EnumBooleanMember: EnumBooleanMember,
    EnumDeclaration: EnumDeclaration,
    EnumDefaultedMember: EnumDefaultedMember,
    EnumNumberBody: EnumNumberBody,
    EnumNumberMember: EnumNumberMember,
    EnumStringBody: EnumStringBody,
    EnumStringMember: EnumStringMember,
    EnumSymbolBody: EnumSymbolBody,
    ExistsTypeAnnotation: ExistsTypeAnnotation,
    ExportAllDeclaration: ExportAllDeclaration,
    ExportDefaultDeclaration: ExportDefaultDeclaration,
    ExportDefaultSpecifier: ExportDefaultSpecifier,
    ExportNamedDeclaration: ExportNamedDeclaration,
    ExportNamespaceSpecifier: ExportNamespaceSpecifier,
    ExportSpecifier: ExportSpecifier,
    ExpressionStatement: ExpressionStatement,
    File: File,
    ForInStatement: ForInStatement,
    ForOfStatement: ForOfStatement,
    ForStatement: ForStatement,
    FunctionDeclaration: FunctionExpression,
    FunctionExpression: FunctionExpression,
    FunctionTypeAnnotation: FunctionTypeAnnotation,
    FunctionTypeParam: FunctionTypeParam,
    GenericTypeAnnotation: InterfaceExtends,
    Identifier: Identifier,
    IfStatement: IfStatement,
    Import: Import,
    ImportAttribute: ImportAttribute,
    ImportDeclaration: ImportDeclaration,
    ImportDefaultSpecifier: ImportDefaultSpecifier,
    ImportExpression: ImportExpression,
    ImportNamespaceSpecifier: ImportNamespaceSpecifier,
    ImportSpecifier: ImportSpecifier,
    IndexedAccessType: IndexedAccessType,
    InferredPredicate: InferredPredicate,
    InterfaceDeclaration: InterfaceDeclaration,
    InterfaceExtends: InterfaceExtends,
    InterfaceTypeAnnotation: InterfaceTypeAnnotation,
    InterpreterDirective: InterpreterDirective,
    IntersectionTypeAnnotation: IntersectionTypeAnnotation,
    JSXAttribute: JSXAttribute,
    JSXClosingElement: JSXClosingElement,
    JSXClosingFragment: JSXClosingFragment,
    JSXElement: JSXElement,
    JSXEmptyExpression: JSXEmptyExpression,
    JSXExpressionContainer: JSXExpressionContainer,
    JSXFragment: JSXFragment,
    JSXIdentifier: JSXIdentifier,
    JSXMemberExpression: JSXMemberExpression,
    JSXNamespacedName: JSXNamespacedName,
    JSXOpeningElement: JSXOpeningElement,
    JSXOpeningFragment: JSXOpeningFragment,
    JSXSpreadAttribute: JSXSpreadAttribute,
    JSXSpreadChild: JSXSpreadChild,
    JSXText: JSXText,
    LabeledStatement: LabeledStatement,
    LogicalExpression: AssignmentExpression,
    MemberExpression: MemberExpression,
    MetaProperty: MetaProperty,
    MixedTypeAnnotation: MixedTypeAnnotation,
    ModuleExpression: ModuleExpression,
    NewExpression: NewExpression,
    NullLiteral: NullLiteral,
    NullLiteralTypeAnnotation: NullLiteralTypeAnnotation,
    NullableTypeAnnotation: NullableTypeAnnotation,
    NumberLiteralTypeAnnotation: NumericLiteral,
    NumberTypeAnnotation: NumberTypeAnnotation,
    NumericLiteral: NumericLiteral,
    ObjectExpression: ObjectExpression,
    ObjectMethod: ObjectMethod,
    ObjectPattern: ObjectExpression,
    ObjectProperty: ObjectProperty,
    ObjectTypeAnnotation: ObjectTypeAnnotation,
    ObjectTypeCallProperty: ObjectTypeCallProperty,
    ObjectTypeIndexer: ObjectTypeIndexer,
    ObjectTypeInternalSlot: ObjectTypeInternalSlot,
    ObjectTypeProperty: ObjectTypeProperty,
    ObjectTypeSpreadProperty: ObjectTypeSpreadProperty,
    OpaqueType: OpaqueType,
    OptionalCallExpression: OptionalCallExpression,
    OptionalIndexedAccessType: OptionalIndexedAccessType,
    OptionalMemberExpression: OptionalMemberExpression,
    ParenthesizedExpression: ParenthesizedExpression,
    PipelineBareFunction: PipelineBareFunction,
    PipelinePrimaryTopicReference: PipelinePrimaryTopicReference,
    PipelineTopicExpression: PipelineTopicExpression,
    Placeholder: Placeholder,
    PrivateName: PrivateName,
    Program: Program,
    QualifiedTypeIdentifier: QualifiedTypeIdentifier,
    RecordExpression: RecordExpression,
    RegExpLiteral: RegExpLiteral,
    RestElement: RestElement,
    ReturnStatement: ReturnStatement,
    SequenceExpression: SequenceExpression,
    SpreadElement: RestElement,
    StaticBlock: StaticBlock,
    StringLiteral: StringLiteral,
    StringLiteralTypeAnnotation: StringLiteral,
    StringTypeAnnotation: StringTypeAnnotation,
    Super: Super,
    SwitchCase: SwitchCase,
    SwitchStatement: SwitchStatement,
    SymbolTypeAnnotation: SymbolTypeAnnotation,
    TSAnyKeyword: TSAnyKeyword,
    TSArrayType: TSArrayType,
    TSAsExpression: TSTypeExpression2,
    TSBigIntKeyword: TSBigIntKeyword,
    TSBooleanKeyword: TSBooleanKeyword,
    TSCallSignatureDeclaration: TSCallSignatureDeclaration,
    TSConditionalType: TSConditionalType,
    TSConstructSignatureDeclaration: TSConstructSignatureDeclaration,
    TSConstructorType: TSConstructorType,
    TSDeclareFunction: TSDeclareFunction,
    TSDeclareMethod: TSDeclareMethod,
    TSEnumDeclaration: TSEnumDeclaration,
    TSEnumMember: TSEnumMember,
    TSExportAssignment: TSExportAssignment,
    TSExpressionWithTypeArguments: TSExpressionWithTypeArguments,
    TSExternalModuleReference: TSExternalModuleReference,
    TSFunctionType: TSFunctionType,
    TSImportEqualsDeclaration: TSImportEqualsDeclaration,
    TSImportType: TSImportType,
    TSIndexSignature: TSIndexSignature,
    TSIndexedAccessType: TSIndexedAccessType,
    TSInferType: TSInferType,
    TSInstantiationExpression: TSInstantiationExpression,
    TSInterfaceBody: TSInterfaceBody,
    TSInterfaceDeclaration: TSInterfaceDeclaration,
    TSIntersectionType: TSIntersectionType,
    TSIntrinsicKeyword: TSIntrinsicKeyword,
    TSLiteralType: TSLiteralType,
    TSMappedType: TSMappedType,
    TSMethodSignature: TSMethodSignature,
    TSModuleBlock: TSModuleBlock,
    TSModuleDeclaration: TSModuleDeclaration,
    TSNamedTupleMember: TSNamedTupleMember,
    TSNamespaceExportDeclaration: TSNamespaceExportDeclaration,
    TSNeverKeyword: TSNeverKeyword,
    TSNonNullExpression: TSNonNullExpression,
    TSNullKeyword: TSNullKeyword,
    TSNumberKeyword: TSNumberKeyword,
    TSObjectKeyword: TSObjectKeyword,
    TSOptionalType: TSOptionalType,
    TSParameterProperty: TSParameterProperty,
    TSParenthesizedType: TSParenthesizedType,
    TSPropertySignature: TSPropertySignature,
    TSQualifiedName: TSQualifiedName,
    TSRestType: TSRestType,
    TSSatisfiesExpression: TSTypeExpression2,
    TSStringKeyword: TSStringKeyword,
    TSSymbolKeyword: TSSymbolKeyword,
    TSThisType: TSThisType,
    TSTupleType: TSTupleType,
    TSTypeAliasDeclaration: TSTypeAliasDeclaration,
    TSTypeAnnotation: TSTypeAnnotation,
    TSTypeAssertion: TSTypeAssertion,
    TSTypeLiteral: TSTypeLiteral,
    TSTypeOperator: TSTypeOperator,
    TSTypeParameter: TSTypeParameter,
    TSTypeParameterDeclaration: TSTypeParameterInstantiation,
    TSTypeParameterInstantiation: TSTypeParameterInstantiation,
    TSTypePredicate: TSTypePredicate,
    TSTypeQuery: TSTypeQuery,
    TSTypeReference: TSTypeReference,
    TSUndefinedKeyword: TSUndefinedKeyword,
    TSUnionType: TSUnionType,
    TSUnknownKeyword: TSUnknownKeyword,
    TSVoidKeyword: TSVoidKeyword,
    TaggedTemplateExpression: TaggedTemplateExpression,
    TemplateElement: TemplateElement,
    TemplateLiteral: TemplateLiteral,
    ThisExpression: ThisExpression,
    ThisTypeAnnotation: ThisTypeAnnotation,
    ThrowStatement: ThrowStatement,
    TopicReference: TopicReference,
    TryStatement: TryStatement,
    TupleExpression: TupleExpression,
    TupleTypeAnnotation: TupleTypeAnnotation,
    TypeAlias: TypeAlias,
    TypeAnnotation: TypeAnnotation,
    TypeCastExpression: TypeCastExpression,
    TypeParameter: TypeParameter,
    TypeParameterDeclaration: TypeParameterInstantiation,
    TypeParameterInstantiation: TypeParameterInstantiation,
    TypeofTypeAnnotation: TypeofTypeAnnotation,
    UnaryExpression: UnaryExpression,
    UnionTypeAnnotation: UnionTypeAnnotation,
    UpdateExpression: UpdateExpression,
    V8IntrinsicIdentifier: V8IntrinsicIdentifier,
    VariableDeclaration: VariableDeclaration,
    VariableDeclarator: VariableDeclarator,
    Variance: Variance,
    VoidTypeAnnotation: VoidTypeAnnotation,
    WhileStatement: WhileStatement,
    WithStatement: WithStatement,
    YieldExpression: YieldExpression,
    _classMethodHead: _classMethodHead,
    _functionHead: _functionHead,
    _interfaceish: _interfaceish,
    _methodHead: _methodHead,
    _param: _param,
    _parameters: _parameters,
    _params: _params,
    _predicate: _predicate,
    _printAttributes: _printAttributes,
    _shouldPrintDecoratorsBeforeExport: _shouldPrintDecoratorsBeforeExport,
    _variance: _variance,
    tsPrintClassMemberModifiers: tsPrintClassMemberModifiers,
    tsPrintFunctionOrConstructorType: tsPrintFunctionOrConstructorType,
    tsPrintPropertyOrMethodName: tsPrintPropertyOrMethodName,
    tsPrintSignatureDeclarationBase: tsPrintSignatureDeclarationBase,
    tsPrintTypeLiteralOrInterfaceBody: tsPrintTypeLiteralOrInterfaceBody
});
var isFunction3 = lib_exports.isFunction, isStatement3 = lib_exports.isStatement, isClassBody2 = lib_exports.isClassBody, isTSInterfaceBody2 = lib_exports.isTSInterfaceBody, isTSEnumDeclaration2 = lib_exports.isTSEnumDeclaration;
var SCIENTIFIC_NOTATION = /e/i;
var ZERO_DECIMAL_INTEGER = /\.0+$/;
var HAS_NEWLINE = /[\n\r\u2028\u2029]/;
var HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
var needsParens = n.needsParens;
var Printer = /*#__PURE__*/ function() {
    "use strict";
    function Printer(format, map) {
        _class_call_check(this, Printer);
        __publicField(this, "inForStatementInitCounter", 0);
        __publicField(this, "_printStack", []);
        __publicField(this, "_indent", 0);
        __publicField(this, "_indentRepeat", 0);
        __publicField(this, "_insideAux", false);
        __publicField(this, "_parenPushNewlineState", null);
        __publicField(this, "_noLineTerminator", false);
        __publicField(this, "_printAuxAfterOnNextUserNode", false);
        __publicField(this, "_printedComments", /* @__PURE__ */ new Set());
        __publicField(this, "_endsWithInteger", false);
        __publicField(this, "_endsWithWord", false);
        __publicField(this, "_lastCommentLine", 0);
        __publicField(this, "_endsWithInnerRaw", false);
        __publicField(this, "_indentInnerComments", true);
        this.format = format;
        this._indentRepeat = format.indent.style.length;
        this._inputMap = map === null || map === void 0 ? void 0 : map._inputMap;
        this._buf = new Buffer2(map, format.indent.style[0]);
    }
    _create_class(Printer, [
        {
            key: "generate",
            value: function generate(ast) {
                this.print(ast);
                this._maybeAddAuxComment();
                return this._buf.get();
            }
        },
        {
            key: "indent",
            value: function indent() {
                if (this.format.compact || this.format.concise) return;
                this._indent++;
            }
        },
        {
            key: "dedent",
            value: function dedent() {
                if (this.format.compact || this.format.concise) return;
                this._indent--;
            }
        },
        {
            key: "semicolon",
            value: function semicolon() {
                var force = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
                this._maybeAddAuxComment();
                if (force) {
                    this._appendChar(59);
                } else {
                    this._queue(59);
                }
                this._noLineTerminator = false;
            }
        },
        {
            key: "rightBrace",
            value: function rightBrace(node) {
                if (this.format.minified) {
                    this._buf.removeLastSemicolon();
                }
                this.sourceWithOffset("end", node.loc, -1);
                this.tokenChar(125);
            }
        },
        {
            key: "rightParens",
            value: function rightParens(node) {
                this.sourceWithOffset("end", node.loc, -1);
                this.tokenChar(41);
            }
        },
        {
            key: "space",
            value: function space() {
                var force = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
                if (this.format.compact) return;
                if (force) {
                    this._space();
                } else if (this._buf.hasContent()) {
                    var lastCp = this.getLastChar();
                    if (lastCp !== 32 && lastCp !== 10) {
                        this._space();
                    }
                }
            }
        },
        {
            key: "word",
            value: function word(str) {
                var noLineTerminatorAfter = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                this._maybePrintInnerComments();
                if (this._endsWithWord || str.charCodeAt(0) === 47 && this.endsWith(47)) {
                    this._space();
                }
                this._maybeAddAuxComment();
                this._append(str, false);
                this._endsWithWord = true;
                this._noLineTerminator = noLineTerminatorAfter;
            }
        },
        {
            key: "number",
            value: function number(str, number) {
                function isNonDecimalLiteral(str2) {
                    if (str2.length > 2 && str2.charCodeAt(0) === 48) {
                        var secondChar = str2.charCodeAt(1);
                        return secondChar === 98 || secondChar === 111 || secondChar === 120;
                    }
                    return false;
                }
                this.word(str);
                this._endsWithInteger = Number.isInteger(number) && !isNonDecimalLiteral(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
            }
        },
        {
            key: "token",
            value: function token(str) {
                var maybeNewline = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
                this._maybePrintInnerComments();
                var lastChar = this.getLastChar();
                var strFirst = str.charCodeAt(0);
                if (lastChar === 33 && (str === "--" || strFirst === 61) || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
                    this._space();
                }
                this._maybeAddAuxComment();
                this._append(str, maybeNewline);
                this._noLineTerminator = false;
            }
        },
        {
            key: "tokenChar",
            value: function tokenChar(char) {
                this._maybePrintInnerComments();
                var lastChar = this.getLastChar();
                if (char === 43 && lastChar === 43 || char === 45 && lastChar === 45 || char === 46 && this._endsWithInteger) {
                    this._space();
                }
                this._maybeAddAuxComment();
                this._appendChar(char);
                this._noLineTerminator = false;
            }
        },
        {
            key: "newline",
            value: function newline() {
                var i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 1, force = arguments.length > 1 ? arguments[1] : void 0;
                if (i <= 0) return;
                if (!force) {
                    if (this.format.retainLines || this.format.compact) return;
                    if (this.format.concise) {
                        this.space();
                        return;
                    }
                }
                if (i > 2) i = 2;
                i -= this._buf.getNewlineCount();
                for(var j = 0; j < i; j++){
                    this._newline();
                }
                return;
            }
        },
        {
            key: "endsWith",
            value: function endsWith(char) {
                return this.getLastChar() === char;
            }
        },
        {
            key: "getLastChar",
            value: function getLastChar() {
                return this._buf.getLastChar();
            }
        },
        {
            key: "endsWithCharAndNewline",
            value: function endsWithCharAndNewline() {
                return this._buf.endsWithCharAndNewline();
            }
        },
        {
            key: "removeTrailingNewline",
            value: function removeTrailingNewline() {
                this._buf.removeTrailingNewline();
            }
        },
        {
            key: "exactSource",
            value: function exactSource(loc, cb) {
                if (!loc) {
                    cb();
                    return;
                }
                this._catchUp("start", loc);
                this._buf.exactSource(loc, cb);
            }
        },
        {
            key: "source",
            value: function source(prop, loc) {
                if (!loc) return;
                this._catchUp(prop, loc);
                this._buf.source(prop, loc);
            }
        },
        {
            key: "sourceWithOffset",
            value: function sourceWithOffset(prop, loc, columnOffset) {
                if (!loc) return;
                this._catchUp(prop, loc);
                this._buf.sourceWithOffset(prop, loc, columnOffset);
            }
        },
        {
            key: "withSource",
            value: function withSource(prop, loc, cb) {
                if (!loc) {
                    cb();
                    return;
                }
                this._catchUp(prop, loc);
                this._buf.withSource(prop, loc, cb);
            }
        },
        {
            key: "sourceIdentifierName",
            value: function sourceIdentifierName(identifierName, pos) {
                if (!this._buf._canMarkIdName) return;
                var sourcePosition = this._buf._sourcePosition;
                sourcePosition.identifierNamePos = pos;
                sourcePosition.identifierName = identifierName;
            }
        },
        {
            key: "_space",
            value: function _space() {
                this._queue(32);
            }
        },
        {
            key: "_newline",
            value: function _newline() {
                this._queue(10);
            }
        },
        {
            key: "_append",
            value: function _append(str, maybeNewline) {
                this._maybeAddParen(str);
                this._maybeIndent(str.charCodeAt(0));
                this._buf.append(str, maybeNewline);
                this._endsWithWord = false;
                this._endsWithInteger = false;
            }
        },
        {
            key: "_appendChar",
            value: function _appendChar(char) {
                this._maybeAddParenChar(char);
                this._maybeIndent(char);
                this._buf.appendChar(char);
                this._endsWithWord = false;
                this._endsWithInteger = false;
            }
        },
        {
            key: "_queue",
            value: function _queue(char) {
                this._maybeAddParenChar(char);
                this._maybeIndent(char);
                this._buf.queue(char);
                this._endsWithWord = false;
                this._endsWithInteger = false;
            }
        },
        {
            key: "_maybeIndent",
            value: function _maybeIndent(firstChar) {
                if (this._indent && firstChar !== 10 && this.endsWith(10)) {
                    this._buf.queueIndentation(this._getIndent());
                }
            }
        },
        {
            key: "_shouldIndent",
            value: function _shouldIndent(firstChar) {
                if (this._indent && firstChar !== 10 && this.endsWith(10)) {
                    return true;
                }
            }
        },
        {
            key: "_maybeAddParenChar",
            value: function _maybeAddParenChar(char) {
                var parenPushNewlineState = this._parenPushNewlineState;
                if (!parenPushNewlineState) return;
                if (char === 32) {
                    return;
                }
                if (char !== 10) {
                    this._parenPushNewlineState = null;
                    return;
                }
                this.tokenChar(40);
                this.indent();
                parenPushNewlineState.printed = true;
            }
        },
        {
            key: "_maybeAddParen",
            value: function _maybeAddParen(str) {
                var parenPushNewlineState = this._parenPushNewlineState;
                if (!parenPushNewlineState) return;
                var len = str.length;
                var i;
                for(i = 0; i < len && str.charCodeAt(i) === 32; i++)continue;
                if (i === len) {
                    return;
                }
                var cha = str.charCodeAt(i);
                if (cha !== 10) {
                    if (cha !== 47 || i + 1 === len) {
                        this._parenPushNewlineState = null;
                        return;
                    }
                    var chaPost = str.charCodeAt(i + 1);
                    if (chaPost === 42) {
                        return;
                    } else if (chaPost !== 47) {
                        this._parenPushNewlineState = null;
                        return;
                    }
                }
                this.tokenChar(40);
                this.indent();
                parenPushNewlineState.printed = true;
            }
        },
        {
            key: "catchUp",
            value: function catchUp(line) {
                if (!this.format.retainLines) return;
                var count = line - this._buf.getCurrentLine();
                for(var i = 0; i < count; i++){
                    this._newline();
                }
            }
        },
        {
            key: "_catchUp",
            value: function _catchUp(prop, loc) {
                var _loc_prop;
                if (!this.format.retainLines) return;
                var line = loc === null || loc === void 0 ? void 0 : (_loc_prop = loc[prop]) === null || _loc_prop === void 0 ? void 0 : _loc_prop.line;
                if (line != null) {
                    var count = line - this._buf.getCurrentLine();
                    for(var i = 0; i < count; i++){
                        this._newline();
                    }
                }
            }
        },
        {
            key: "_getIndent",
            value: function _getIndent() {
                return this._indentRepeat * this._indent;
            }
        },
        {
            key: "printTerminatorless",
            value: function printTerminatorless(node, parent, isLabel) {
                if (isLabel) {
                    this._noLineTerminator = true;
                    this.print(node, parent);
                } else {
                    var terminatorState = {
                        printed: false
                    };
                    this._parenPushNewlineState = terminatorState;
                    this.print(node, parent);
                    if (terminatorState.printed) {
                        this.dedent();
                        this.newline();
                        this.tokenChar(41);
                    }
                }
            }
        },
        {
            key: "print",
            value: function print(node, parent, noLineTerminatorAfter, trailingCommentsLineOffset, forceParens) {
                var _node_extra, _node_leadingComments;
                if (!node) return;
                this._endsWithInnerRaw = false;
                var nodeType = node.type;
                var format = this.format;
                var oldConcise = format.concise;
                if (node._compact) {
                    format.concise = true;
                }
                var printMethod = this[nodeType];
                if (printMethod === void 0) {
                    throw new ReferenceError("unknown node of type ".concat(JSON.stringify(nodeType), " with constructor ").concat(JSON.stringify(node.constructor.name)));
                }
                this._printStack.push(node);
                var oldInAux = this._insideAux;
                this._insideAux = node.loc == void 0;
                this._maybeAddAuxComment(this._insideAux && !oldInAux);
                var parenthesized = (_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.parenthesized;
                var shouldPrintParens = forceParens || parenthesized && format.retainFunctionParens && nodeType === "FunctionExpression" || needsParens(node, parent, this._printStack);
                if (!shouldPrintParens && parenthesized && ((_node_leadingComments = node.leadingComments) === null || _node_leadingComments === void 0 ? void 0 : _node_leadingComments.length) && node.leadingComments[0].type === "CommentBlock") {
                    var parentType = parent === null || parent === void 0 ? void 0 : parent.type;
                    switch(parentType){
                        case "ExpressionStatement":
                        case "VariableDeclarator":
                        case "AssignmentExpression":
                        case "ReturnStatement":
                            break;
                        case "CallExpression":
                        case "OptionalCallExpression":
                        case "NewExpression":
                            if (parent.callee !== node) break;
                        default:
                            shouldPrintParens = true;
                    }
                }
                if (shouldPrintParens) {
                    this.tokenChar(40);
                    this._endsWithInnerRaw = false;
                }
                this._lastCommentLine = 0;
                this._printLeadingComments(node, parent);
                var loc = nodeType === "Program" || nodeType === "File" ? null : node.loc;
                this.exactSource(loc, printMethod.bind(this, node, parent));
                if (shouldPrintParens) {
                    this._printTrailingComments(node, parent);
                    this.tokenChar(41);
                    this._noLineTerminator = noLineTerminatorAfter;
                } else if (noLineTerminatorAfter && !this._noLineTerminator) {
                    this._noLineTerminator = true;
                    this._printTrailingComments(node, parent);
                } else {
                    this._printTrailingComments(node, parent, trailingCommentsLineOffset);
                }
                this._printStack.pop();
                format.concise = oldConcise;
                this._insideAux = oldInAux;
                this._endsWithInnerRaw = false;
            }
        },
        {
            key: "_maybeAddAuxComment",
            value: function _maybeAddAuxComment(enteredPositionlessNode) {
                if (enteredPositionlessNode) this._printAuxBeforeComment();
                if (!this._insideAux) this._printAuxAfterComment();
            }
        },
        {
            key: "_printAuxBeforeComment",
            value: function _printAuxBeforeComment() {
                if (this._printAuxAfterOnNextUserNode) return;
                this._printAuxAfterOnNextUserNode = true;
                var comment = this.format.auxiliaryCommentBefore;
                if (comment) {
                    this._printComment({
                        type: "CommentBlock",
                        value: comment
                    }, 0);
                }
            }
        },
        {
            key: "_printAuxAfterComment",
            value: function _printAuxAfterComment() {
                if (!this._printAuxAfterOnNextUserNode) return;
                this._printAuxAfterOnNextUserNode = false;
                var comment = this.format.auxiliaryCommentAfter;
                if (comment) {
                    this._printComment({
                        type: "CommentBlock",
                        value: comment
                    }, 0);
                }
            }
        },
        {
            key: "getPossibleRaw",
            value: function getPossibleRaw(node) {
                var extra = node.extra;
                if ((extra === null || extra === void 0 ? void 0 : extra.raw) != null && extra.rawValue != null && node.value === extra.rawValue) {
                    return extra.raw;
                }
            }
        },
        {
            key: "printJoin",
            value: function printJoin(nodes2, parent) {
                var opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                if (!(nodes2 === null || nodes2 === void 0 ? void 0 : nodes2.length)) return;
                var indent = opts.indent;
                if (indent == null && this.format.retainLines) {
                    var _nodes2__loc;
                    var startLine = (_nodes2__loc = nodes2[0].loc) === null || _nodes2__loc === void 0 ? void 0 : _nodes2__loc.start.line;
                    if (startLine != null && startLine !== this._buf.getCurrentLine()) {
                        indent = true;
                    }
                }
                if (indent) this.indent();
                var newlineOpts = {
                    addNewlines: opts.addNewlines,
                    nextNodeStartLine: 0
                };
                var separator = opts.separator ? opts.separator.bind(this) : null;
                var len = nodes2.length;
                for(var i = 0; i < len; i++){
                    var _opts_iterator;
                    var node = nodes2[i];
                    if (!node) continue;
                    if (opts.statement) this._printNewline(i === 0, newlineOpts);
                    this.print(node, parent, void 0, opts.trailingCommentsLineOffset || 0);
                    (_opts_iterator = opts.iterator) === null || _opts_iterator === void 0 ? void 0 : _opts_iterator.call(opts, node, i);
                    if (i < len - 1) separator === null || separator === void 0 ? void 0 : separator();
                    if (opts.statement) {
                        var _node_trailingComments;
                        if (!((_node_trailingComments = node.trailingComments) === null || _node_trailingComments === void 0 ? void 0 : _node_trailingComments.length)) {
                            this._lastCommentLine = 0;
                        }
                        if (i + 1 === len) {
                            this.newline(1);
                        } else {
                            var _nextNode_loc;
                            var nextNode = nodes2[i + 1];
                            newlineOpts.nextNodeStartLine = ((_nextNode_loc = nextNode.loc) === null || _nextNode_loc === void 0 ? void 0 : _nextNode_loc.start.line) || 0;
                            this._printNewline(true, newlineOpts);
                        }
                    }
                }
                if (indent) this.dedent();
            }
        },
        {
            key: "printAndIndentOnComments",
            value: function printAndIndentOnComments(node, parent) {
                var indent = node.leadingComments && node.leadingComments.length > 0;
                if (indent) this.indent();
                this.print(node, parent);
                if (indent) this.dedent();
            }
        },
        {
            key: "printBlock",
            value: function printBlock(parent) {
                var node = parent.body;
                if (node.type !== "EmptyStatement") {
                    this.space();
                }
                this.print(node, parent);
            }
        },
        {
            key: "_printTrailingComments",
            value: function _printTrailingComments(node, parent, lineOffset) {
                var innerComments = node.innerComments, trailingComments = node.trailingComments;
                if (innerComments === null || innerComments === void 0 ? void 0 : innerComments.length) {
                    this._printComments(2, innerComments, node, parent, lineOffset);
                }
                if (trailingComments === null || trailingComments === void 0 ? void 0 : trailingComments.length) {
                    this._printComments(2, trailingComments, node, parent, lineOffset);
                }
            }
        },
        {
            key: "_printLeadingComments",
            value: function _printLeadingComments(node, parent) {
                var comments = node.leadingComments;
                if (!(comments === null || comments === void 0 ? void 0 : comments.length)) return;
                this._printComments(0, comments, node, parent);
            }
        },
        {
            key: "_maybePrintInnerComments",
            value: function _maybePrintInnerComments() {
                if (this._endsWithInnerRaw) this.printInnerComments();
                this._endsWithInnerRaw = true;
                this._indentInnerComments = true;
            }
        },
        {
            key: "printInnerComments",
            value: function printInnerComments() {
                var node = this._printStack[this._printStack.length - 1];
                var comments = node.innerComments;
                if (!(comments === null || comments === void 0 ? void 0 : comments.length)) return;
                var hasSpace = this.endsWith(32);
                var indent = this._indentInnerComments;
                var printedCommentsCount = this._printedComments.size;
                if (indent) this.indent();
                this._printComments(1, comments, node);
                if (hasSpace && printedCommentsCount !== this._printedComments.size) {
                    this.space();
                }
                if (indent) this.dedent();
            }
        },
        {
            key: "noIndentInnerCommentsHere",
            value: function noIndentInnerCommentsHere() {
                this._indentInnerComments = false;
            }
        },
        {
            key: "printSequence",
            value: function printSequence(nodes2, parent) {
                var opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                opts.statement = true;
                var _opts_indent;
                (_opts_indent = opts.indent) !== null && _opts_indent !== void 0 ? _opts_indent : opts.indent = false;
                this.printJoin(nodes2, parent, opts);
            }
        },
        {
            key: "printList",
            value: function printList(items, parent) {
                var opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                if (opts.separator == null) {
                    opts.separator = commaSeparator;
                }
                this.printJoin(items, parent, opts);
            }
        },
        {
            key: "_printNewline",
            value: function _printNewline(newLine, opts) {
                var format = this.format;
                if (format.retainLines || format.compact) return;
                if (format.concise) {
                    this.space();
                    return;
                }
                if (!newLine) {
                    return;
                }
                var startLine = opts.nextNodeStartLine;
                var lastCommentLine = this._lastCommentLine;
                if (startLine > 0 && lastCommentLine > 0) {
                    var offset = startLine - lastCommentLine;
                    if (offset >= 0) {
                        this.newline(offset || 1);
                        return;
                    }
                }
                if (this._buf.hasContent()) {
                    this.newline(1);
                }
            }
        },
        {
            key: "_shouldPrintComment",
            value: function _shouldPrintComment(comment) {
                if (comment.ignore) return 0;
                if (this._printedComments.has(comment)) return 0;
                if (this._noLineTerminator && HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)) {
                    return 2;
                }
                this._printedComments.add(comment);
                if (!this.format.shouldPrintComment(comment.value)) {
                    return 0;
                }
                return 1;
            }
        },
        {
            key: "_printComment",
            value: function _printComment(comment, skipNewLines) {
                var noLineTerminator = this._noLineTerminator;
                var isBlockComment = comment.type === "CommentBlock";
                var printNewLines = isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
                if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
                    this.newline(1);
                }
                var lastCharCode = this.getLastChar();
                if (lastCharCode !== 91 && lastCharCode !== 123) {
                    this.space();
                }
                var val;
                if (isBlockComment) {
                    var _parenPushNewlineState = this._parenPushNewlineState;
                    if ((_parenPushNewlineState === null || _parenPushNewlineState === void 0 ? void 0 : _parenPushNewlineState.printed) === false && HAS_NEWLINE.test(comment.value)) {
                        this.tokenChar(40);
                        this.indent();
                        _parenPushNewlineState.printed = true;
                    }
                    val = "/*".concat(comment.value, "*/");
                    if (this.format.indent.adjustMultilineComment) {
                        var _comment_loc;
                        var offset = (_comment_loc = comment.loc) === null || _comment_loc === void 0 ? void 0 : _comment_loc.start.column;
                        if (offset) {
                            var newlineRegex = new RegExp("\\n\\s{1," + offset + "}", "g");
                            val = val.replace(newlineRegex, "\n");
                        }
                        if (this.format.concise) {
                            val = val.replace(/\n(?!$)/g, "\n");
                        } else {
                            var indentSize = this.format.retainLines ? 0 : this._buf.getCurrentColumn();
                            if (this._shouldIndent(47) || this.format.retainLines) {
                                indentSize += this._getIndent();
                            }
                            val = val.replace(/\n(?!$)/g, "\n".concat(" ".repeat(indentSize)));
                        }
                    }
                } else if (!noLineTerminator) {
                    val = "//".concat(comment.value);
                } else {
                    val = "/*".concat(comment.value, "*/");
                }
                if (this.endsWith(47)) this._space();
                this.source("start", comment.loc);
                this._append(val, isBlockComment);
                if (!isBlockComment && !noLineTerminator) {
                    this.newline(1, true);
                }
                if (printNewLines && skipNewLines !== 3) {
                    this.newline(1);
                }
            }
        },
        {
            key: "_printComments",
            value: function _printComments(type, comments, node, parent) {
                var lineOffset = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0;
                var nodeLoc = node.loc;
                var len = comments.length;
                var hasLoc = !!nodeLoc;
                var nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
                var nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
                var lastLine = 0;
                var leadingCommentNewline = 0;
                var maybeNewline = this._noLineTerminator ? function maybeNewline() {} : this.newline.bind(this);
                for(var i = 0; i < len; i++){
                    var comment = comments[i];
                    var shouldPrint = this._shouldPrintComment(comment);
                    if (shouldPrint === 2) {
                        hasLoc = false;
                        break;
                    }
                    if (hasLoc && comment.loc && shouldPrint === 1) {
                        var commentStartLine = comment.loc.start.line;
                        var commentEndLine = comment.loc.end.line;
                        if (type === 0) {
                            var offset = 0;
                            if (i === 0) {
                                if (this._buf.hasContent() && (comment.type === "CommentLine" || commentStartLine != commentEndLine)) {
                                    offset = leadingCommentNewline = 1;
                                }
                            } else {
                                offset = commentStartLine - lastLine;
                            }
                            lastLine = commentEndLine;
                            maybeNewline(offset);
                            this._printComment(comment, 1);
                            if (i + 1 === len) {
                                maybeNewline(Math.max(nodeStartLine - lastLine, leadingCommentNewline));
                                lastLine = nodeStartLine;
                            }
                        } else if (type === 1) {
                            var offset1 = commentStartLine - (i === 0 ? nodeStartLine : lastLine);
                            lastLine = commentEndLine;
                            maybeNewline(offset1);
                            this._printComment(comment, 1);
                            if (i + 1 === len) {
                                maybeNewline(Math.min(1, nodeEndLine - lastLine));
                                lastLine = nodeEndLine;
                            }
                        } else {
                            var offset2 = commentStartLine - (i === 0 ? nodeEndLine - lineOffset : lastLine);
                            lastLine = commentEndLine;
                            maybeNewline(offset2);
                            this._printComment(comment, 1);
                        }
                    } else {
                        hasLoc = false;
                        if (shouldPrint !== 1) {
                            continue;
                        }
                        if (len === 1) {
                            var singleLine = comment.loc ? comment.loc.start.line === comment.loc.end.line : !HAS_NEWLINE.test(comment.value);
                            var shouldSkipNewline = singleLine && !isStatement3(node) && !isClassBody2(parent) && !isTSInterfaceBody2(parent) && !isTSEnumDeclaration2(parent);
                            if (type === 0) {
                                this._printComment(comment, shouldSkipNewline && node.type !== "ObjectExpression" || singleLine && isFunction3(parent, {
                                    body: node
                                }) ? 1 : 0);
                            } else if (shouldSkipNewline && type === 2) {
                                this._printComment(comment, 1);
                            } else {
                                this._printComment(comment, 0);
                            }
                        } else if (type === 1 && !(node.type === "ObjectExpression" && node.properties.length > 1) && node.type !== "ClassBody" && node.type !== "TSInterfaceBody") {
                            this._printComment(comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
                        } else {
                            this._printComment(comment, 0);
                        }
                    }
                }
                if (type === 2 && hasLoc && lastLine) {
                    this._lastCommentLine = lastLine;
                }
            }
        }
    ]);
    return Printer;
}();
Object.assign(Printer.prototype, generatorFunctions);
function commaSeparator() {
    this.tokenChar(44);
    this.space();
}
function normalizeOptions(code2, opts) {
    var _opts_recordAndTupleSyntaxType;
    var format = {
        auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
        auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
        shouldPrintComment: opts.shouldPrintComment,
        retainLines: opts.retainLines,
        retainFunctionParens: opts.retainFunctionParens,
        comments: opts.comments == null || opts.comments,
        compact: opts.compact,
        minified: opts.minified,
        concise: opts.concise,
        indent: {
            adjustMultilineComment: true,
            style: "  "
        },
        jsescOption: Object.assign({
            quotes: "double",
            wrap: true,
            minimal: true
        }, opts.jsescOption),
        recordAndTupleSyntaxType: (_opts_recordAndTupleSyntaxType = opts.recordAndTupleSyntaxType) !== null && _opts_recordAndTupleSyntaxType !== void 0 ? _opts_recordAndTupleSyntaxType : "hash",
        topicToken: opts.topicToken,
        importAttributesKeyword: opts.importAttributesKeyword
    };
    if (format.minified) {
        format.compact = true;
        format.shouldPrintComment = format.shouldPrintComment || function() {
            return format.comments;
        };
    } else {
        format.shouldPrintComment = format.shouldPrintComment || function(value1) {
            return format.comments || value1.includes("@license") || value1.includes("@preserve");
        };
    }
    if (format.compact === "auto") {
        format.compact = typeof code2 === "string" && code2.length > 5e5;
        if (format.compact) {
            console.error("[BABEL] Note: The code generator has deoptimised the styling of ".concat(opts.filename, " as it exceeds the max of ", "500KB", "."));
        }
    }
    if (format.compact) {
        format.indent.adjustMultilineComment = false;
    }
    var auxiliaryCommentBefore = format.auxiliaryCommentBefore, auxiliaryCommentAfter = format.auxiliaryCommentAfter, shouldPrintComment = format.shouldPrintComment;
    if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
        format.auxiliaryCommentBefore = void 0;
    }
    if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
        format.auxiliaryCommentAfter = void 0;
    }
    return format;
}
function generate(ast) {
    var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, code2 = arguments.length > 2 ? arguments[2] : void 0;
    var format = normalizeOptions(code2, opts);
    var map = opts.sourceMaps ? new SourceMap(opts, code2) : null;
    var printer = new Printer(format, map);
    return printer.generate(ast);
}
// node_modules/@babel/traverse/lib/index.js
var import_debug = __toESM(require_src(), 1);
// node_modules/@babel/helper-split-export-declaration/lib/index.js
var cloneNode3 = lib_exports.cloneNode, exportNamedDeclaration2 = lib_exports.exportNamedDeclaration, exportSpecifier2 = lib_exports.exportSpecifier, identifier3 = lib_exports.identifier, variableDeclaration2 = lib_exports.variableDeclaration, variableDeclarator2 = lib_exports.variableDeclarator;
function splitExportDeclaration(exportDeclaration) {
    if (!exportDeclaration.isExportDeclaration() || exportDeclaration.isExportAllDeclaration()) {
        throw new Error("Only default and named export declarations can be split.");
    }
    if (exportDeclaration.isExportDefaultDeclaration()) {
        var declaration2 = exportDeclaration.get("declaration");
        var standaloneDeclaration = declaration2.isFunctionDeclaration() || declaration2.isClassDeclaration();
        var exportExpr = declaration2.isFunctionExpression() || declaration2.isClassExpression();
        var scope2 = declaration2.isScope() ? declaration2.scope.parent : declaration2.scope;
        var id = declaration2.node.id;
        var needBindingRegistration = false;
        if (!id) {
            needBindingRegistration = true;
            id = scope2.generateUidIdentifier("default");
            if (standaloneDeclaration || exportExpr) {
                declaration2.node.id = cloneNode3(id);
            }
        } else if (exportExpr && scope2.hasBinding(id.name)) {
            needBindingRegistration = true;
            id = scope2.generateUidIdentifier(id.name);
        }
        var updatedDeclaration = standaloneDeclaration ? declaration2.node : variableDeclaration2("var", [
            variableDeclarator2(cloneNode3(id), declaration2.node)
        ]);
        var updatedExportDeclaration = exportNamedDeclaration2(null, [
            exportSpecifier2(cloneNode3(id), identifier3("default"))
        ]);
        exportDeclaration.insertAfter(updatedExportDeclaration);
        exportDeclaration.replaceWith(updatedDeclaration);
        if (needBindingRegistration) {
            scope2.registerDeclaration(exportDeclaration);
        }
        return exportDeclaration;
    } else if (exportDeclaration.get("specifiers").length > 0) {
        throw new Error("It doesn't make sense to split exported specifiers.");
    }
    var declaration = exportDeclaration.get("declaration");
    var bindingIdentifiers = declaration.getOuterBindingIdentifiers();
    var specifiers = Object.keys(bindingIdentifiers).map(function(name) {
        return exportSpecifier2(identifier3(name), identifier3(name));
    });
    var aliasDeclar = exportNamedDeclaration2(null, specifiers);
    exportDeclaration.insertAfter(aliasDeclar);
    exportDeclaration.replaceWith(declaration.node);
    return exportDeclaration;
}
// node_modules/@babel/helper-environment-visitor/lib/index.js
function requeueComputedKeyAndDecorators(path) {
    var context = path.context, node = path.node;
    if (node.computed) {
        context.maybeQueue(path.get("key"));
    }
    if (node.decorators) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = path.get("decorators")[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var decorator2 = _step.value;
                context.maybeQueue(decorator2);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
}
var visitor = {
    FunctionParent: function FunctionParent(path) {
        if (path.isArrowFunctionExpression()) {
            return;
        } else {
            path.skip();
            if (path.isMethod()) {
                requeueComputedKeyAndDecorators(path);
            }
        }
    },
    Property: function Property(path) {
        if (path.isObjectProperty()) {
            return;
        }
        path.skip();
        requeueComputedKeyAndDecorators(path);
    }
};
// node_modules/@babel/traverse/lib/index.js
var import_globals = __toESM(require_globals2(), 1);
// node_modules/@babel/helper-hoist-variables/lib/index.js
var assignmentExpression2 = lib_exports.assignmentExpression, expressionStatement3 = lib_exports.expressionStatement, identifier4 = lib_exports.identifier;
var visitor2 = {
    Scope: function Scope(path, state) {
        if (state.kind === "let") path.skip();
    },
    FunctionParent: function FunctionParent(path) {
        path.skip();
    },
    VariableDeclaration: function VariableDeclaration(path, state) {
        if (state.kind && path.node.kind !== state.kind) return;
        var nodes2 = [];
        var declarations = path.get("declarations");
        var firstId;
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var declar = _step.value;
                firstId = declar.node.id;
                if (declar.node.init) {
                    nodes2.push(expressionStatement3(assignmentExpression2("=", declar.node.id, declar.node.init)));
                }
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = Object.keys(declar.getBindingIdentifiers())[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var name = _step1.value;
                        state.emit(identifier4(name), name, declar.node.init !== null);
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        if (path.parentPath.isFor({
            left: path.node
        })) {
            path.replaceWith(firstId);
        } else {
            path.replaceWithMultiple(nodes2);
        }
    }
};
function hoistVariables(path, emit) {
    var kind = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "var";
    path.traverse(visitor2, {
        kind: kind,
        emit: emit
    });
}
// node_modules/@babel/helper-function-name/lib/index.js
var NOT_LOCAL_BINDING2 = lib_exports.NOT_LOCAL_BINDING, cloneNode4 = lib_exports.cloneNode, identifier5 = lib_exports.identifier, isAssignmentExpression3 = lib_exports.isAssignmentExpression, isAssignmentPattern3 = lib_exports.isAssignmentPattern, isFunction4 = lib_exports.isFunction, isIdentifier4 = lib_exports.isIdentifier, isLiteral3 = lib_exports.isLiteral, isNullLiteral2 = lib_exports.isNullLiteral, isObjectMethod2 = lib_exports.isObjectMethod, isObjectProperty2 = lib_exports.isObjectProperty, isRegExpLiteral2 = lib_exports.isRegExpLiteral, isRestElement2 = lib_exports.isRestElement, isTemplateLiteral2 = lib_exports.isTemplateLiteral, isVariableDeclarator2 = lib_exports.isVariableDeclarator, toBindingIdentifierName2 = lib_exports.toBindingIdentifierName;
function getFunctionArity(node) {
    var count = node.params.findIndex(function(param) {
        return isAssignmentPattern3(param) || isRestElement2(param);
    });
    return count === -1 ? node.params.length : count;
}
var buildPropertyMethodAssignmentWrapper = index.statement("\n  (function (FUNCTION_KEY) {\n    function FUNCTION_ID() {\n      return FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    }\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
var buildGeneratorPropertyMethodAssignmentWrapper = index.statement("\n  (function (FUNCTION_KEY) {\n    function* FUNCTION_ID() {\n      return yield* FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    };\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
var visitor3 = {
    "ReferencedIdentifier|BindingIdentifier": function(path, state) {
        if (path.node.name !== state.name) return;
        var localDeclar = path.scope.getBindingIdentifier(state.name);
        if (localDeclar !== state.outerDeclar) return;
        state.selfReference = true;
        path.stop();
    }
};
function getNameFromLiteralId(id) {
    if (isNullLiteral2(id)) {
        return "null";
    }
    if (isRegExpLiteral2(id)) {
        return "_".concat(id.pattern, "_").concat(id.flags);
    }
    if (isTemplateLiteral2(id)) {
        return id.quasis.map(function(quasi) {
            return quasi.value.raw;
        }).join("");
    }
    if (id.value !== void 0) {
        return id.value + "";
    }
    return "";
}
function wrap(state, method, id, scope2) {
    if (state.selfReference) {
        if (scope2.hasBinding(id.name) && !scope2.hasGlobal(id.name)) {
            scope2.rename(id.name);
        } else {
            if (!isFunction4(method)) return;
            var build = buildPropertyMethodAssignmentWrapper;
            if (method.generator) {
                build = buildGeneratorPropertyMethodAssignmentWrapper;
            }
            var _$template = build({
                FUNCTION: method,
                FUNCTION_ID: id,
                FUNCTION_KEY: scope2.generateUidIdentifier(id.name)
            }).expression;
            var params = _$template.callee.body.body[0].params;
            for(var i = 0, len = getFunctionArity(method); i < len; i++){
                params.push(scope2.generateUidIdentifier("x"));
            }
            return _$template;
        }
    }
    method.id = id;
    scope2.getProgramParent().references[id.name] = true;
}
function visit(node, name, scope2) {
    var state = {
        selfAssignment: false,
        selfReference: false,
        outerDeclar: scope2.getBindingIdentifier(name),
        name: name
    };
    var binding = scope2.getOwnBinding(name);
    if (binding) {
        if (binding.kind === "param") {
            state.selfReference = true;
        }
    } else if (state.outerDeclar || scope2.hasGlobal(name)) {
        scope2.traverse(node, visitor3, state);
    }
    return state;
}
function index2(param) {
    var node = param.node, parent = param.parent, scope2 = param.scope, id = param.id, localBinding = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false, supportUnicodeId = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    if (node.id) return;
    if ((isObjectProperty2(parent) || isObjectMethod2(parent, {
        kind: "method"
    })) && (!parent.computed || isLiteral3(parent.key))) {
        id = parent.key;
    } else if (isVariableDeclarator2(parent)) {
        id = parent.id;
        if (isIdentifier4(id) && !localBinding) {
            var binding = scope2.parent.getBinding(id.name);
            if (binding && binding.constant && scope2.getBinding(id.name) === binding) {
                node.id = cloneNode4(id);
                node.id[NOT_LOCAL_BINDING2] = true;
                return;
            }
        }
    } else if (isAssignmentExpression3(parent, {
        operator: "="
    })) {
        id = parent.left;
    } else if (!id) {
        return;
    }
    var name;
    if (id && isLiteral3(id)) {
        name = getNameFromLiteralId(id);
    } else if (id && isIdentifier4(id)) {
        name = id.name;
    }
    if (name === void 0) {
        return;
    }
    if (!supportUnicodeId && isFunction4(node) && /[\uD800-\uDFFF]/.test(name)) {
        return;
    }
    name = toBindingIdentifierName2(name);
    var newId = identifier5(name);
    newId[NOT_LOCAL_BINDING2] = true;
    var state = visit(node, name, scope2);
    return wrap(state, node, newId, scope2) || node;
}
// node_modules/@babel/traverse/lib/index.js
var ReferencedIdentifier = [
    "Identifier",
    "JSXIdentifier"
];
var ReferencedMemberExpression = [
    "MemberExpression"
];
var BindingIdentifier = [
    "Identifier"
];
var Statement = [
    "Statement"
];
var Expression = [
    "Expression"
];
var Scope$1 = [
    "Scopable",
    "Pattern"
];
var Referenced = null;
var BlockScoped = null;
var Var = [
    "VariableDeclaration"
];
var User = null;
var Generated = null;
var Pure = null;
var Flow = [
    "Flow",
    "ImportDeclaration",
    "ExportDeclaration",
    "ImportSpecifier"
];
var RestProperty2 = [
    "RestElement"
];
var SpreadProperty2 = [
    "RestElement"
];
var ExistentialTypeParam = [
    "ExistsTypeAnnotation"
];
var NumericLiteralTypeAnnotation = [
    "NumberLiteralTypeAnnotation"
];
var ForAwaitStatement = [
    "ForOfStatement"
];
var virtualTypes = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    BindingIdentifier: BindingIdentifier,
    BlockScoped: BlockScoped,
    ExistentialTypeParam: ExistentialTypeParam,
    Expression: Expression,
    Flow: Flow,
    ForAwaitStatement: ForAwaitStatement,
    Generated: Generated,
    NumericLiteralTypeAnnotation: NumericLiteralTypeAnnotation,
    Pure: Pure,
    Referenced: Referenced,
    ReferencedIdentifier: ReferencedIdentifier,
    ReferencedMemberExpression: ReferencedMemberExpression,
    RestProperty: RestProperty2,
    Scope: Scope$1,
    SpreadProperty: SpreadProperty2,
    Statement: Statement,
    User: User,
    Var: Var
});
var isBinding2 = lib_exports.isBinding, nodeIsBlockScoped = lib_exports.isBlockScoped, isExportDeclaration$1 = lib_exports.isExportDeclaration, nodeIsExpression = lib_exports.isExpression, nodeIsFlow = lib_exports.isFlow, isForStatement3 = lib_exports.isForStatement, isForXStatement2 = lib_exports.isForXStatement, isIdentifier$6 = lib_exports.isIdentifier, isImportDeclaration$1 = lib_exports.isImportDeclaration, isImportSpecifier2 = lib_exports.isImportSpecifier, isJSXIdentifier3 = lib_exports.isJSXIdentifier, isJSXMemberExpression2 = lib_exports.isJSXMemberExpression, isMemberExpression3 = lib_exports.isMemberExpression, nodeIsRestElement = lib_exports.isRestElement, nodeIsReferenced = lib_exports.isReferenced, nodeIsScope = lib_exports.isScope, nodeIsStatement = lib_exports.isStatement, nodeIsVar = lib_exports.isVar, isVariableDeclaration$2 = lib_exports.isVariableDeclaration, react$1 = lib_exports.react, isForOfStatement3 = lib_exports.isForOfStatement;
var isCompatTag2 = react$1.isCompatTag;
function isReferencedIdentifier(opts) {
    var _this = this, node = _this.node, parent = _this.parent;
    if (!isIdentifier$6(node, opts) && !isJSXMemberExpression2(parent, opts)) {
        if (isJSXIdentifier3(node, opts)) {
            if (isCompatTag2(node.name)) return false;
        } else {
            return false;
        }
    }
    return nodeIsReferenced(node, parent, this.parentPath.parent);
}
function isReferencedMemberExpression() {
    var _this = this, node = _this.node, parent = _this.parent;
    return isMemberExpression3(node) && nodeIsReferenced(node, parent);
}
function isBindingIdentifier() {
    var _this = this, node = _this.node, parent = _this.parent;
    var grandparent = this.parentPath.parent;
    return isIdentifier$6(node) && isBinding2(node, parent, grandparent);
}
function isStatement$13() {
    var _this = this, node = _this.node, parent = _this.parent;
    if (nodeIsStatement(node)) {
        if (isVariableDeclaration$2(node)) {
            if (isForXStatement2(parent, {
                left: node
            })) return false;
            if (isForStatement3(parent, {
                init: node
            })) return false;
        }
        return true;
    } else {
        return false;
    }
}
function isExpression$3() {
    if (this.isIdentifier()) {
        return this.isReferencedIdentifier();
    } else {
        return nodeIsExpression(this.node);
    }
}
function isScope2() {
    return nodeIsScope(this.node, this.parent);
}
function isReferenced2() {
    return nodeIsReferenced(this.node, this.parent);
}
function isBlockScoped2() {
    return nodeIsBlockScoped(this.node);
}
function isVar2() {
    return nodeIsVar(this.node);
}
function isUser() {
    return this.node && !!this.node.loc;
}
function isGenerated() {
    return !this.isUser();
}
function isPure(constantsOnly) {
    return this.scope.isPure(this.node, constantsOnly);
}
function isFlow2() {
    var node = this.node;
    if (nodeIsFlow(node)) {
        return true;
    } else if (isImportDeclaration$1(node)) {
        return node.importKind === "type" || node.importKind === "typeof";
    } else if (isExportDeclaration$1(node)) {
        return node.exportKind === "type";
    } else if (isImportSpecifier2(node)) {
        return node.importKind === "type" || node.importKind === "typeof";
    } else {
        return false;
    }
}
function isRestProperty2() {
    return nodeIsRestElement(this.node) && this.parentPath && this.parentPath.isObjectPattern();
}
function isSpreadProperty2() {
    return nodeIsRestElement(this.node) && this.parentPath && this.parentPath.isObjectExpression();
}
function isForAwaitStatement() {
    return isForOfStatement3(this.node, {
        await: true
    });
}
var NodePath_virtual_types_validator = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    isBindingIdentifier: isBindingIdentifier,
    isBlockScoped: isBlockScoped2,
    isExpression: isExpression$3,
    isFlow: isFlow2,
    isForAwaitStatement: isForAwaitStatement,
    isGenerated: isGenerated,
    isPure: isPure,
    isReferenced: isReferenced2,
    isReferencedIdentifier: isReferencedIdentifier,
    isReferencedMemberExpression: isReferencedMemberExpression,
    isRestProperty: isRestProperty2,
    isScope: isScope2,
    isSpreadProperty: isSpreadProperty2,
    isStatement: isStatement$13,
    isUser: isUser,
    isVar: isVar2
});
var DEPRECATED_KEYS2 = lib_exports.DEPRECATED_KEYS, DEPRECATED_ALIASES2 = lib_exports.DEPRECATED_ALIASES, FLIPPED_ALIAS_KEYS3 = lib_exports.FLIPPED_ALIAS_KEYS, TYPES2 = lib_exports.TYPES, deprecationWarning2 = lib_exports.__internal__deprecationWarning;
function isVirtualType(type) {
    return type in virtualTypes;
}
function isExplodedVisitor(visitor4) {
    return visitor4 === null || visitor4 === void 0 ? void 0 : visitor4._exploded;
}
function explode(visitor4) {
    if (isExplodedVisitor(visitor4)) return visitor4;
    visitor4._exploded = true;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(visitor4)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var nodeType = _step.value;
            if (shouldIgnoreKey(nodeType)) continue;
            var parts = nodeType.split("|");
            if (parts.length === 1) continue;
            var fns = visitor4[nodeType];
            delete visitor4[nodeType];
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                for(var _iterator1 = parts[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var part = _step1.value;
                    visitor4[part] = fns;
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    verify(visitor4);
    delete visitor4.__esModule;
    ensureEntranceObjects(visitor4);
    ensureCallbackArrays(visitor4);
    var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
    try {
        for(var _iterator2 = Object.keys(visitor4)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
            var nodeType1 = _step2.value;
            if (shouldIgnoreKey(nodeType1)) continue;
            if (!isVirtualType(nodeType1)) continue;
            var fns1 = visitor4[nodeType1];
            var _iteratorNormalCompletion3 = true, _didIteratorError3 = false, _iteratorError3 = undefined;
            try {
                for(var _iterator3 = Object.keys(fns1)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true){
                    var type = _step3.value;
                    fns1[type] = wrapCheck(nodeType1, fns1[type]);
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                        _iterator3.return();
                    }
                } finally{
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
            delete visitor4[nodeType1];
            var types2 = virtualTypes[nodeType1];
            if (types2 !== null) {
                var _iteratorNormalCompletion4 = true, _didIteratorError4 = false, _iteratorError4 = undefined;
                try {
                    for(var _iterator4 = types2[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true){
                        var type1 = _step4.value;
                        if (visitor4[type1]) {
                            mergePair(visitor4[type1], fns1);
                        } else {
                            visitor4[type1] = fns1;
                        }
                    }
                } catch (err) {
                    _didIteratorError4 = true;
                    _iteratorError4 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
                            _iterator4.return();
                        }
                    } finally{
                        if (_didIteratorError4) {
                            throw _iteratorError4;
                        }
                    }
                }
            } else {
                mergePair(visitor4, fns1);
            }
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                _iterator2.return();
            }
        } finally{
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }
    var _iteratorNormalCompletion5 = true, _didIteratorError5 = false, _iteratorError5 = undefined;
    try {
        for(var _iterator5 = Object.keys(visitor4)[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true){
            var nodeType2 = _step5.value;
            if (shouldIgnoreKey(nodeType2)) continue;
            var aliases = FLIPPED_ALIAS_KEYS3[nodeType2];
            if (nodeType2 in DEPRECATED_KEYS2) {
                var deprecatedKey = DEPRECATED_KEYS2[nodeType2];
                deprecationWarning2(nodeType2, deprecatedKey, "Visitor ");
                aliases = [
                    deprecatedKey
                ];
            } else if (nodeType2 in DEPRECATED_ALIASES2) {
                var deprecatedAlias = DEPRECATED_ALIASES2[nodeType2];
                deprecationWarning2(nodeType2, deprecatedAlias, "Visitor ");
                aliases = FLIPPED_ALIAS_KEYS3[deprecatedAlias];
            }
            if (!aliases) continue;
            var fns2 = visitor4[nodeType2];
            delete visitor4[nodeType2];
            var _iteratorNormalCompletion6 = true, _didIteratorError6 = false, _iteratorError6 = undefined;
            try {
                for(var _iterator6 = aliases[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true){
                    var alias = _step6.value;
                    var existing = visitor4[alias];
                    if (existing) {
                        mergePair(existing, fns2);
                    } else {
                        visitor4[alias] = Object.assign({}, fns2);
                    }
                }
            } catch (err) {
                _didIteratorError6 = true;
                _iteratorError6 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion6 && _iterator6.return != null) {
                        _iterator6.return();
                    }
                } finally{
                    if (_didIteratorError6) {
                        throw _iteratorError6;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
                _iterator5.return();
            }
        } finally{
            if (_didIteratorError5) {
                throw _iteratorError5;
            }
        }
    }
    var _iteratorNormalCompletion7 = true, _didIteratorError7 = false, _iteratorError7 = undefined;
    try {
        for(var _iterator7 = Object.keys(visitor4)[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true){
            var nodeType3 = _step7.value;
            if (shouldIgnoreKey(nodeType3)) continue;
            ensureCallbackArrays(visitor4[nodeType3]);
        }
    } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion7 && _iterator7.return != null) {
                _iterator7.return();
            }
        } finally{
            if (_didIteratorError7) {
                throw _iteratorError7;
            }
        }
    }
    return visitor4;
}
function verify(visitor4) {
    if (visitor4._verified) return;
    if (typeof visitor4 === "function") {
        throw new Error("You passed `traverse()` a function when it expected a visitor object, are you sure you didn't mean `{ enter: Function }`?");
    }
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(visitor4)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var nodeType = _step.value;
            if (nodeType === "enter" || nodeType === "exit") {
                validateVisitorMethods(nodeType, visitor4[nodeType]);
            }
            if (shouldIgnoreKey(nodeType)) continue;
            if (TYPES2.indexOf(nodeType) < 0) {
                throw new Error("You gave us a visitor for the node type ".concat(nodeType, " but it's not a valid type"));
            }
            var visitors2 = visitor4[nodeType];
            if (typeof visitors2 === "object") {
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = Object.keys(visitors2)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var visitorKey = _step1.value;
                        if (visitorKey === "enter" || visitorKey === "exit") {
                            validateVisitorMethods("".concat(nodeType, ".").concat(visitorKey), visitors2[visitorKey]);
                        } else {
                            throw new Error("You passed `traverse()` a visitor object with the property ".concat(nodeType, " that has the invalid property ").concat(visitorKey));
                        }
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    visitor4._verified = true;
}
function validateVisitorMethods(path, val) {
    var fns = [].concat(val);
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = fns[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var fn = _step.value;
            if (typeof fn !== "function") {
                throw new TypeError("Non-function found defined in ".concat(path, " with type ").concat(typeof fn === "undefined" ? "undefined" : _type_of(fn)));
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}
function merge2(visitors2) {
    var states = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [], wrapper = arguments.length > 2 ? arguments[2] : void 0;
    var mergedVisitor = {};
    for(var i = 0; i < visitors2.length; i++){
        var visitor4 = explode(visitors2[i]);
        var state = states[i];
        var topVisitor = visitor4;
        if (state || wrapper) {
            topVisitor = wrapWithStateOrWrapper(topVisitor, state, wrapper);
        }
        mergePair(mergedVisitor, topVisitor);
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = Object.keys(visitor4)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var key = _step.value;
                if (shouldIgnoreKey(key)) continue;
                var typeVisitor = visitor4[key];
                if (state || wrapper) {
                    typeVisitor = wrapWithStateOrWrapper(typeVisitor, state, wrapper);
                }
                var nodeVisitor = mergedVisitor[key] || (mergedVisitor[key] = {});
                mergePair(nodeVisitor, typeVisitor);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    {
        return Object.assign({}, mergedVisitor, {
            _exploded: true,
            _verified: true
        });
    }
}
function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
    var _loop = function(_i, _iter) {
        var phase = _iter[_i];
        var fns = oldVisitor[phase];
        if (!Array.isArray(fns)) return "continue";
        fns = fns.map(function(fn) {
            var newFn = fn;
            if (state) {
                newFn = function newFn(path) {
                    fn.call(state, path, state);
                };
            }
            if (wrapper) {
                newFn = wrapper(state === null || state === void 0 ? void 0 : state.key, phase, newFn);
            }
            if (newFn !== fn) {
                newFn.toString = function() {
                    return fn.toString();
                };
            }
            return newFn;
        });
        newVisitor[phase] = fns;
    };
    var newVisitor = {};
    for(var _i = 0, _iter = [
        "enter",
        "exit"
    ]; _i < _iter.length; _i++)_loop(_i, _iter);
    return newVisitor;
}
function ensureEntranceObjects(obj) {
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = Object.keys(obj)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            if (shouldIgnoreKey(key)) continue;
            var fns = obj[key];
            if (typeof fns === "function") {
                obj[key] = {
                    enter: fns
                };
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}
function ensureCallbackArrays(obj) {
    if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [
        obj.enter
    ];
    if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [
        obj.exit
    ];
}
function wrapCheck(nodeType, fn) {
    var fnKey = "is".concat(nodeType);
    var validator = NodePath_virtual_types_validator[fnKey];
    var newFn = function newFn(path) {
        if (validator.call(path)) {
            return fn.apply(this, arguments);
        }
    };
    newFn.toString = function() {
        return fn.toString();
    };
    return newFn;
}
function shouldIgnoreKey(key) {
    if (key[0] === "_") return true;
    if (key === "enter" || key === "exit" || key === "shouldSkip") return true;
    if (key === "denylist" || key === "noScope" || key === "skipKeys") {
        return true;
    }
    return false;
}
function mergePair(dest, src) {
    for(var _i = 0, _iter = [
        "enter",
        "exit"
    ]; _i < _iter.length; _i++){
        var phase = _iter[_i];
        if (!src[phase]) continue;
        dest[phase] = [].concat(dest[phase] || [], src[phase]);
    }
}
var visitors = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    explode: explode,
    isExplodedVisitor: isExplodedVisitor,
    merge: merge2,
    verify: verify
});
var pathsCache = /* @__PURE__ */ new WeakMap();
var scope = /* @__PURE__ */ new WeakMap();
function clear() {
    clearPath();
    clearScope();
}
function clearPath() {
    pathsCache = /* @__PURE__ */ new WeakMap();
}
function clearScope() {
    scope = /* @__PURE__ */ new WeakMap();
}
var nullHub = Object.freeze({});
function getCachedPaths(hub, parent) {
    var _pathsCache_get;
    return (_pathsCache_get = pathsCache.get(hub !== null && hub !== void 0 ? hub : nullHub)) === null || _pathsCache_get === void 0 ? void 0 : _pathsCache_get.get(parent);
}
function getOrCreateCachedPaths(hub, parent) {
    var parents = pathsCache.get(hub !== null && hub !== void 0 ? hub : nullHub);
    if (!parents) pathsCache.set(hub !== null && hub !== void 0 ? hub : nullHub, parents = /* @__PURE__ */ new WeakMap());
    var paths = parents.get(parent);
    if (!paths) parents.set(parent, paths = /* @__PURE__ */ new Map());
    return paths;
}
var cache = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    clear: clear,
    clearPath: clearPath,
    clearScope: clearScope,
    getCachedPaths: getCachedPaths,
    getOrCreateCachedPaths: getOrCreateCachedPaths,
    get path () {
        return pathsCache;
    },
    get scope () {
        return scope;
    }
});
var renameVisitor = {
    ReferencedIdentifier: function ReferencedIdentifier(param, state) {
        var node = param.node;
        if (node.name === state.oldName) {
            node.name = state.newName;
        }
    },
    Scope: function Scope(path, state) {
        if (!path.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
            path.skip();
            if (path.isMethod()) {
                requeueComputedKeyAndDecorators(path);
            }
        }
    },
    ObjectProperty: function ObjectProperty(param, state) {
        var node = param.node, scope2 = param.scope;
        var name = node.key.name;
        if (node.shorthand && (name === state.oldName || name === state.newName) && scope2.getBindingIdentifier(name) === state.binding.identifier) {
            var _node_extra;
            node.shorthand = false;
            if ((_node_extra = node.extra) === null || _node_extra === void 0 ? void 0 : _node_extra.shorthand) node.extra.shorthand = false;
        }
    },
    "AssignmentExpression|Declaration|VariableDeclarator": function(path, state) {
        if (path.isVariableDeclaration()) return;
        var ids = path.getOuterBindingIdentifiers();
        for(var name in ids){
            if (name === state.oldName) ids[name].name = state.newName;
        }
    }
};
var Renamer = /*#__PURE__*/ function() {
    "use strict";
    function Renamer(binding, oldName, newName) {
        _class_call_check(this, Renamer);
        this.newName = newName;
        this.oldName = oldName;
        this.binding = binding;
    }
    _create_class(Renamer, [
        {
            key: "maybeConvertFromExportDeclaration",
            value: function maybeConvertFromExportDeclaration(parentDeclar) {
                var maybeExportDeclar = parentDeclar.parentPath;
                if (!maybeExportDeclar.isExportDeclaration()) {
                    return;
                }
                if (maybeExportDeclar.isExportDefaultDeclaration()) {
                    var declaration = maybeExportDeclar.node.declaration;
                    if (isDeclaration(declaration) && !declaration.id) {
                        return;
                    }
                }
                if (maybeExportDeclar.isExportAllDeclaration()) {
                    return;
                }
                splitExportDeclaration(maybeExportDeclar);
            }
        },
        {
            key: "maybeConvertFromClassFunctionDeclaration",
            value: function maybeConvertFromClassFunctionDeclaration(path) {
                return path;
            }
        },
        {
            key: "maybeConvertFromClassFunctionExpression",
            value: function maybeConvertFromClassFunctionExpression(path) {
                return path;
            }
        },
        {
            key: "rename",
            value: function rename() {
                var _this = this, binding = _this.binding, oldName = _this.oldName, newName = _this.newName;
                var scope2 = binding.scope, path = binding.path;
                var parentDeclar = path.find(function(path2) {
                    return path2.isDeclaration() || path2.isFunctionExpression() || path2.isClassExpression();
                });
                if (parentDeclar) {
                    var bindingIds = parentDeclar.getOuterBindingIdentifiers();
                    if (bindingIds[oldName] === binding.identifier) {
                        this.maybeConvertFromExportDeclaration(parentDeclar);
                    }
                }
                var blockToTraverse = scope2.block;
                traverseNode(blockToTraverse, explode(renameVisitor), scope2, this, scope2.path, {
                    discriminant: true
                });
                {
                    scope2.removeOwnBinding(oldName);
                    scope2.bindings[newName] = binding;
                    this.binding.identifier.name = newName;
                }
                if (parentDeclar) {
                    this.maybeConvertFromClassFunctionDeclaration(path);
                    this.maybeConvertFromClassFunctionExpression(path);
                }
            }
        }
    ]);
    return Renamer;
}();
var Binding = /*#__PURE__*/ function() {
    "use strict";
    function Binding(param) {
        var identifier7 = param.identifier, scope2 = param.scope, path = param.path, kind = param.kind;
        _class_call_check(this, Binding);
        __publicField(this, "identifier");
        __publicField(this, "scope");
        __publicField(this, "path");
        __publicField(this, "kind");
        __publicField(this, "constantViolations", []);
        __publicField(this, "constant", true);
        __publicField(this, "referencePaths", []);
        __publicField(this, "referenced", false);
        __publicField(this, "references", 0);
        this.identifier = identifier7;
        this.scope = scope2;
        this.path = path;
        this.kind = kind;
        if ((kind === "var" || kind === "hoisted") && isDeclaredInLoop(path)) {
            this.reassign(path);
        }
        this.clearValue();
    }
    _create_class(Binding, [
        {
            key: "deoptValue",
            value: function deoptValue() {
                this.clearValue();
                this.hasDeoptedValue = true;
            }
        },
        {
            key: "setValue",
            value: function setValue(value1) {
                if (this.hasDeoptedValue) return;
                this.hasValue = true;
                this.value = value1;
            }
        },
        {
            key: "clearValue",
            value: function clearValue() {
                this.hasDeoptedValue = false;
                this.hasValue = false;
                this.value = null;
            }
        },
        {
            key: "reassign",
            value: function reassign(path) {
                this.constant = false;
                if (this.constantViolations.indexOf(path) !== -1) {
                    return;
                }
                this.constantViolations.push(path);
            }
        },
        {
            key: "reference",
            value: function reference(path) {
                if (this.referencePaths.indexOf(path) !== -1) {
                    return;
                }
                this.referenced = true;
                this.references++;
                this.referencePaths.push(path);
            }
        },
        {
            key: "dereference",
            value: function dereference() {
                this.references--;
                this.referenced = !!this.references;
            }
        }
    ]);
    return Binding;
}();
function isDeclaredInLoop(path) {
    var ref;
    for(var parentPath = path.parentPath, key = path.key; parentPath; ref = parentPath, parentPath = ref.parentPath, key = ref.key, ref){
        if (parentPath.isFunctionParent()) return false;
        if (parentPath.isWhile() || parentPath.isForXStatement() || parentPath.isForStatement() && key === "body") {
            return true;
        }
    }
    return false;
}
var NOT_LOCAL_BINDING3 = lib_exports.NOT_LOCAL_BINDING, callExpression$3 = lib_exports.callExpression, cloneNode$3 = lib_exports.cloneNode, getBindingIdentifiers$3 = lib_exports.getBindingIdentifiers, identifier$3 = lib_exports.identifier, isArrayExpression3 = lib_exports.isArrayExpression, isBinary3 = lib_exports.isBinary, isClass2 = lib_exports.isClass, isClassBody3 = lib_exports.isClassBody, isClassDeclaration3 = lib_exports.isClassDeclaration, isExportAllDeclaration2 = lib_exports.isExportAllDeclaration, isExportDefaultDeclaration3 = lib_exports.isExportDefaultDeclaration, isExportNamedDeclaration$1 = lib_exports.isExportNamedDeclaration, isFunctionDeclaration2 = lib_exports.isFunctionDeclaration, isIdentifier$5 = lib_exports.isIdentifier, isImportDeclaration2 = lib_exports.isImportDeclaration, isLiteral$12 = lib_exports.isLiteral, isMethod2 = lib_exports.isMethod, isModuleSpecifier2 = lib_exports.isModuleSpecifier, isNullLiteral3 = lib_exports.isNullLiteral, isObjectExpression3 = lib_exports.isObjectExpression, isProperty2 = lib_exports.isProperty, isPureish2 = lib_exports.isPureish, isRegExpLiteral3 = lib_exports.isRegExpLiteral, isSuper$1 = lib_exports.isSuper, isTaggedTemplateExpression2 = lib_exports.isTaggedTemplateExpression, isTemplateLiteral3 = lib_exports.isTemplateLiteral, isThisExpression2 = lib_exports.isThisExpression, isUnaryExpression2 = lib_exports.isUnaryExpression, isVariableDeclaration$1 = lib_exports.isVariableDeclaration, matchesPattern$1 = lib_exports.matchesPattern, memberExpression$1 = lib_exports.memberExpression, numericLiteral$2 = lib_exports.numericLiteral, toIdentifier2 = lib_exports.toIdentifier, variableDeclaration$1 = lib_exports.variableDeclaration, variableDeclarator$1 = lib_exports.variableDeclarator, isRecordExpression2 = lib_exports.isRecordExpression, isTupleExpression2 = lib_exports.isTupleExpression, isObjectProperty3 = lib_exports.isObjectProperty, isTopicReference2 = lib_exports.isTopicReference, isMetaProperty2 = lib_exports.isMetaProperty, isPrivateName2 = lib_exports.isPrivateName, isExportDeclaration3 = lib_exports.isExportDeclaration, buildUndefinedNode$1 = lib_exports.buildUndefinedNode;
function gatherNodeParts(node, parts) {
    switch(node === null || node === void 0 ? void 0 : node.type){
        default:
            if (isImportDeclaration2(node) || isExportDeclaration3(node)) {
                var _node_specifiers;
                if ((isExportAllDeclaration2(node) || isExportNamedDeclaration$1(node) || isImportDeclaration2(node)) && node.source) {
                    gatherNodeParts(node.source, parts);
                } else if ((isExportNamedDeclaration$1(node) || isImportDeclaration2(node)) && ((_node_specifiers = node.specifiers) === null || _node_specifiers === void 0 ? void 0 : _node_specifiers.length)) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = node.specifiers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var e = _step.value;
                            gatherNodeParts(e, parts);
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                } else if ((isExportDefaultDeclaration3(node) || isExportNamedDeclaration$1(node)) && node.declaration) {
                    gatherNodeParts(node.declaration, parts);
                }
            } else if (isModuleSpecifier2(node)) {
                gatherNodeParts(node.local, parts);
            } else if (isLiteral$12(node) && !isNullLiteral3(node) && !isRegExpLiteral3(node) && !isTemplateLiteral3(node)) {
                parts.push(node.value);
            }
            break;
        case "MemberExpression":
        case "OptionalMemberExpression":
        case "JSXMemberExpression":
            gatherNodeParts(node.object, parts);
            gatherNodeParts(node.property, parts);
            break;
        case "Identifier":
        case "JSXIdentifier":
            parts.push(node.name);
            break;
        case "CallExpression":
        case "OptionalCallExpression":
        case "NewExpression":
            gatherNodeParts(node.callee, parts);
            break;
        case "ObjectExpression":
        case "ObjectPattern":
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                for(var _iterator1 = node.properties[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var e1 = _step1.value;
                    gatherNodeParts(e1, parts);
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
            break;
        case "SpreadElement":
        case "RestElement":
            gatherNodeParts(node.argument, parts);
            break;
        case "ObjectProperty":
        case "ObjectMethod":
        case "ClassProperty":
        case "ClassMethod":
        case "ClassPrivateProperty":
        case "ClassPrivateMethod":
            gatherNodeParts(node.key, parts);
            break;
        case "ThisExpression":
            parts.push("this");
            break;
        case "Super":
            parts.push("super");
            break;
        case "Import":
            parts.push("import");
            break;
        case "DoExpression":
            parts.push("do");
            break;
        case "YieldExpression":
            parts.push("yield");
            gatherNodeParts(node.argument, parts);
            break;
        case "AwaitExpression":
            parts.push("await");
            gatherNodeParts(node.argument, parts);
            break;
        case "AssignmentExpression":
            gatherNodeParts(node.left, parts);
            break;
        case "VariableDeclarator":
            gatherNodeParts(node.id, parts);
            break;
        case "FunctionExpression":
        case "FunctionDeclaration":
        case "ClassExpression":
        case "ClassDeclaration":
            gatherNodeParts(node.id, parts);
            break;
        case "PrivateName":
            gatherNodeParts(node.id, parts);
            break;
        case "ParenthesizedExpression":
            gatherNodeParts(node.expression, parts);
            break;
        case "UnaryExpression":
        case "UpdateExpression":
            gatherNodeParts(node.argument, parts);
            break;
        case "MetaProperty":
            gatherNodeParts(node.meta, parts);
            gatherNodeParts(node.property, parts);
            break;
        case "JSXElement":
            gatherNodeParts(node.openingElement, parts);
            break;
        case "JSXOpeningElement":
            gatherNodeParts(node.name, parts);
            break;
        case "JSXFragment":
            gatherNodeParts(node.openingFragment, parts);
            break;
        case "JSXOpeningFragment":
            parts.push("Fragment");
            break;
        case "JSXNamespacedName":
            gatherNodeParts(node.namespace, parts);
            gatherNodeParts(node.name, parts);
            break;
    }
}
var collectorVisitor = {
    ForStatement: function ForStatement(path) {
        var declar = path.get("init");
        if (declar.isVar()) {
            var scope2 = path.scope;
            var parentScope = scope2.getFunctionParent() || scope2.getProgramParent();
            parentScope.registerBinding("var", declar);
        }
    },
    Declaration: function Declaration(path) {
        if (path.isBlockScoped()) return;
        if (path.isImportDeclaration()) return;
        if (path.isExportDeclaration()) return;
        var parent = path.scope.getFunctionParent() || path.scope.getProgramParent();
        parent.registerDeclaration(path);
    },
    ImportDeclaration: function ImportDeclaration(path) {
        var parent = path.scope.getBlockParent();
        parent.registerDeclaration(path);
    },
    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
        state.references.push(path);
    },
    ForXStatement: function ForXStatement(path, state) {
        var left = path.get("left");
        if (left.isPattern() || left.isIdentifier()) {
            state.constantViolations.push(path);
        } else if (left.isVar()) {
            var scope2 = path.scope;
            var parentScope = scope2.getFunctionParent() || scope2.getProgramParent();
            parentScope.registerBinding("var", left);
        }
    },
    ExportDeclaration: {
        exit: function exit(path) {
            var node = path.node, scope2 = path.scope;
            if (isExportAllDeclaration2(node)) return;
            var declar = node.declaration;
            if (isClassDeclaration3(declar) || isFunctionDeclaration2(declar)) {
                var id = declar.id;
                if (!id) return;
                var binding = scope2.getBinding(id.name);
                binding === null || binding === void 0 ? void 0 : binding.reference(path);
            } else if (isVariableDeclaration$1(declar)) {
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = declar.declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var decl = _step.value;
                        var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                        try {
                            for(var _iterator1 = Object.keys(getBindingIdentifiers$3(decl))[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                var name = _step1.value;
                                var binding1 = scope2.getBinding(name);
                                binding1 === null || binding1 === void 0 ? void 0 : binding1.reference(path);
                            }
                        } catch (err) {
                            _didIteratorError1 = true;
                            _iteratorError1 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                    _iterator1.return();
                                }
                            } finally{
                                if (_didIteratorError1) {
                                    throw _iteratorError1;
                                }
                            }
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        }
    },
    LabeledStatement: function LabeledStatement(path) {
        path.scope.getBlockParent().registerDeclaration(path);
    },
    AssignmentExpression: function AssignmentExpression(path, state) {
        state.assignments.push(path);
    },
    UpdateExpression: function UpdateExpression(path, state) {
        state.constantViolations.push(path);
    },
    UnaryExpression: function UnaryExpression(path, state) {
        if (path.node.operator === "delete") {
            state.constantViolations.push(path);
        }
    },
    BlockScoped: function BlockScoped(path) {
        var scope2 = path.scope;
        if (scope2.path === path) scope2 = scope2.parent;
        var parent = scope2.getBlockParent();
        parent.registerDeclaration(path);
        if (path.isClassDeclaration() && path.node.id) {
            var id = path.node.id;
            var name = id.name;
            path.scope.bindings[name] = path.scope.parent.getBinding(name);
        }
    },
    CatchClause: function CatchClause(path) {
        path.scope.registerBinding("let", path);
    },
    Function: function Function1(path) {
        var params = path.get("params");
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = params[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var param = _step.value;
                path.scope.registerBinding("param", param);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        if (path.isFunctionExpression() && path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING3]) {
            path.scope.registerBinding("local", path.get("id"), path);
        }
    },
    ClassExpression: function ClassExpression(path) {
        if (path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING3]) {
            path.scope.registerBinding("local", path);
        }
    }
};
var uid = 0;
var _Scope = /*#__PURE__*/ function() {
    "use strict";
    function _Scope(path) {
        _class_call_check(this, _Scope);
        __publicField(this, "uid");
        __publicField(this, "path");
        __publicField(this, "block");
        __publicField(this, "labels");
        __publicField(this, "inited");
        __publicField(this, "bindings");
        __publicField(this, "references");
        __publicField(this, "globals");
        __publicField(this, "uids");
        __publicField(this, "data");
        __publicField(this, "crawling");
        var node = path.node;
        var cached = scope.get(node);
        if ((cached === null || cached === void 0 ? void 0 : cached.path) === path) {
            return cached;
        }
        scope.set(node, this);
        this.uid = uid++;
        this.block = node;
        this.path = path;
        this.labels = /* @__PURE__ */ new Map();
        this.inited = false;
    }
    _create_class(_Scope, [
        {
            key: "parent",
            get: function get() {
                var parent, path = this.path;
                do {
                    var shouldSkip = path.key === "key" || path.listKey === "decorators";
                    path = path.parentPath;
                    if (shouldSkip && path.isMethod()) path = path.parentPath;
                    if (path && path.isScope()) parent = path;
                }while (path && !parent);
                return parent === null || parent === void 0 ? void 0 : parent.scope;
            }
        },
        {
            key: "parentBlock",
            get: function get() {
                return this.path.parent;
            }
        },
        {
            key: "hub",
            get: function get() {
                return this.path.hub;
            }
        },
        {
            key: "traverse",
            value: function traverse(node, opts, state) {
                traverse3(node, opts, this, state, this.path);
            }
        },
        {
            key: "generateDeclaredUidIdentifier",
            value: function generateDeclaredUidIdentifier(name) {
                var id = this.generateUidIdentifier(name);
                this.push({
                    id: id
                });
                return cloneNode$3(id);
            }
        },
        {
            key: "generateUidIdentifier",
            value: function generateUidIdentifier(name) {
                return identifier$3(this.generateUid(name));
            }
        },
        {
            key: "generateUid",
            value: function generateUid() {
                var name = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "temp";
                name = toIdentifier2(name).replace(/^_+/, "").replace(/[0-9]+$/g, "");
                var uid2;
                var i = 1;
                do {
                    uid2 = this._generateUid(name, i);
                    i++;
                }while (this.hasLabel(uid2) || this.hasBinding(uid2) || this.hasGlobal(uid2) || this.hasReference(uid2));
                var program3 = this.getProgramParent();
                program3.references[uid2] = true;
                program3.uids[uid2] = true;
                return uid2;
            }
        },
        {
            key: "_generateUid",
            value: function _generateUid(name, i) {
                var id = name;
                if (i > 1) id += i;
                return "_".concat(id);
            }
        },
        {
            key: "generateUidBasedOnNode",
            value: function generateUidBasedOnNode(node, defaultName) {
                var parts = [];
                gatherNodeParts(node, parts);
                var id = parts.join("$");
                id = id.replace(/^_/, "") || defaultName || "ref";
                return this.generateUid(id.slice(0, 20));
            }
        },
        {
            key: "generateUidIdentifierBasedOnNode",
            value: function generateUidIdentifierBasedOnNode(node, defaultName) {
                return identifier$3(this.generateUidBasedOnNode(node, defaultName));
            }
        },
        {
            key: "isStatic",
            value: function isStatic(node) {
                if (isThisExpression2(node) || isSuper$1(node) || isTopicReference2(node)) {
                    return true;
                }
                if (isIdentifier$5(node)) {
                    var binding = this.getBinding(node.name);
                    if (binding) {
                        return binding.constant;
                    } else {
                        return this.hasBinding(node.name);
                    }
                }
                return false;
            }
        },
        {
            key: "maybeGenerateMemoised",
            value: function maybeGenerateMemoised(node, dontPush) {
                if (this.isStatic(node)) {
                    return null;
                } else {
                    var id = this.generateUidIdentifierBasedOnNode(node);
                    if (!dontPush) {
                        this.push({
                            id: id
                        });
                        return cloneNode$3(id);
                    }
                    return id;
                }
            }
        },
        {
            key: "checkBlockScopedCollisions",
            value: function checkBlockScopedCollisions(local, kind, name, id) {
                if (kind === "param") return;
                if (local.kind === "local") return;
                var duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";
                if (duplicate) {
                    throw this.hub.buildError(id, 'Duplicate declaration "'.concat(name, '"'), TypeError);
                }
            }
        },
        {
            key: "rename",
            value: function rename(oldName, newName) {
                var binding = this.getBinding(oldName);
                if (binding) {
                    newName || (newName = this.generateUidIdentifier(oldName).name);
                    var renamer = new Renamer(binding, oldName, newName);
                    {
                        renamer.rename();
                    }
                }
            }
        },
        {
            key: "_renameFromMap",
            value: function _renameFromMap(map, oldName, newName, value1) {
                if (map[oldName]) {
                    map[newName] = value1;
                    map[oldName] = null;
                }
            }
        },
        {
            key: "dump",
            value: function dump() {
                var sep = "-".repeat(60);
                console.log(sep);
                var scope2 = this;
                do {
                    console.log("#", scope2.block.type);
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = Object.keys(scope2.bindings)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var name = _step.value;
                            var binding = scope2.bindings[name];
                            console.log(" -", name, {
                                constant: binding.constant,
                                references: binding.references,
                                violations: binding.constantViolations.length,
                                kind: binding.kind
                            });
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                }while (scope2 = scope2.parent);
                console.log(sep);
            }
        },
        {
            key: "toArray",
            value: function toArray(node, i, arrayLikeIsIterable) {
                if (isIdentifier$5(node)) {
                    var binding = this.getBinding(node.name);
                    if ((binding === null || binding === void 0 ? void 0 : binding.constant) && binding.path.isGenericType("Array")) {
                        return node;
                    }
                }
                if (isArrayExpression3(node)) {
                    return node;
                }
                if (isIdentifier$5(node, {
                    name: "arguments"
                })) {
                    return callExpression$3(memberExpression$1(memberExpression$1(memberExpression$1(identifier$3("Array"), identifier$3("prototype")), identifier$3("slice")), identifier$3("call")), [
                        node
                    ]);
                }
                var helperName;
                var args = [
                    node
                ];
                if (i === true) {
                    helperName = "toConsumableArray";
                } else if (typeof i === "number") {
                    args.push(numericLiteral$2(i));
                    helperName = "slicedToArray";
                } else {
                    helperName = "toArray";
                }
                if (arrayLikeIsIterable) {
                    args.unshift(this.hub.addHelper(helperName));
                    helperName = "maybeArrayLike";
                }
                return callExpression$3(this.hub.addHelper(helperName), args);
            }
        },
        {
            key: "hasLabel",
            value: function hasLabel(name) {
                return !!this.getLabel(name);
            }
        },
        {
            key: "getLabel",
            value: function getLabel(name) {
                return this.labels.get(name);
            }
        },
        {
            key: "registerLabel",
            value: function registerLabel(path) {
                this.labels.set(path.node.label.name, path);
            }
        },
        {
            key: "registerDeclaration",
            value: function registerDeclaration(path) {
                if (path.isLabeledStatement()) {
                    this.registerLabel(path);
                } else if (path.isFunctionDeclaration()) {
                    this.registerBinding("hoisted", path.get("id"), path);
                } else if (path.isVariableDeclaration()) {
                    var declarations = path.get("declarations");
                    var kind = path.node.kind;
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = declarations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var declar = _step.value;
                            this.registerBinding(kind === "using" || kind === "await using" ? "const" : kind, declar);
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                } else if (path.isClassDeclaration()) {
                    if (path.node.declare) return;
                    this.registerBinding("let", path);
                } else if (path.isImportDeclaration()) {
                    var isTypeDeclaration = path.node.importKind === "type" || path.node.importKind === "typeof";
                    var specifiers = path.get("specifiers");
                    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                    try {
                        for(var _iterator1 = specifiers[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                            var specifier = _step1.value;
                            var isTypeSpecifier = isTypeDeclaration || specifier.isImportSpecifier() && (specifier.node.importKind === "type" || specifier.node.importKind === "typeof");
                            this.registerBinding(isTypeSpecifier ? "unknown" : "module", specifier);
                        }
                    } catch (err) {
                        _didIteratorError1 = true;
                        _iteratorError1 = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                _iterator1.return();
                            }
                        } finally{
                            if (_didIteratorError1) {
                                throw _iteratorError1;
                            }
                        }
                    }
                } else if (path.isExportDeclaration()) {
                    var declar1 = path.get("declaration");
                    if (declar1.isClassDeclaration() || declar1.isFunctionDeclaration() || declar1.isVariableDeclaration()) {
                        this.registerDeclaration(declar1);
                    }
                } else {
                    this.registerBinding("unknown", path);
                }
            }
        },
        {
            key: "buildUndefinedNode",
            value: function buildUndefinedNode() {
                return buildUndefinedNode$1();
            }
        },
        {
            key: "registerConstantViolation",
            value: function registerConstantViolation(path) {
                var ids = path.getBindingIdentifiers();
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = Object.keys(ids)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var name = _step.value;
                        var _this_getBinding;
                        (_this_getBinding = this.getBinding(name)) === null || _this_getBinding === void 0 ? void 0 : _this_getBinding.reassign(path);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        },
        {
            key: "registerBinding",
            value: function registerBinding(kind, path) {
                var bindingPath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : path;
                if (!kind) throw new ReferenceError("no `kind`");
                if (path.isVariableDeclaration()) {
                    var declarators = path.get("declarations");
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = declarators[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var declar = _step.value;
                            this.registerBinding(kind, declar);
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return;
                }
                var parent = this.getProgramParent();
                var ids = path.getOuterBindingIdentifiers(true);
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = Object.keys(ids)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var name = _step1.value;
                        parent.references[name] = true;
                        var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
                        try {
                            for(var _iterator2 = ids[name][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
                                var id = _step2.value;
                                var local = this.getOwnBinding(name);
                                if (local) {
                                    if (local.identifier === id) continue;
                                    this.checkBlockScopedCollisions(local, kind, name, id);
                                }
                                if (local) {
                                    this.registerConstantViolation(bindingPath);
                                } else {
                                    this.bindings[name] = new Binding({
                                        identifier: id,
                                        scope: this,
                                        path: bindingPath,
                                        kind: kind
                                    });
                                }
                            }
                        } catch (err) {
                            _didIteratorError2 = true;
                            _iteratorError2 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                                    _iterator2.return();
                                }
                            } finally{
                                if (_didIteratorError2) {
                                    throw _iteratorError2;
                                }
                            }
                        }
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            }
        },
        {
            key: "addGlobal",
            value: function addGlobal(node) {
                this.globals[node.name] = node;
            }
        },
        {
            key: "hasUid",
            value: function hasUid(name) {
                var scope2 = this;
                do {
                    if (scope2.uids[name]) return true;
                }while (scope2 = scope2.parent);
                return false;
            }
        },
        {
            key: "hasGlobal",
            value: function hasGlobal(name) {
                var scope2 = this;
                do {
                    if (scope2.globals[name]) return true;
                }while (scope2 = scope2.parent);
                return false;
            }
        },
        {
            key: "hasReference",
            value: function hasReference(name) {
                return !!this.getProgramParent().references[name];
            }
        },
        {
            key: "isPure",
            value: function isPure(node, constantsOnly) {
                if (isIdentifier$5(node)) {
                    var binding = this.getBinding(node.name);
                    if (!binding) return false;
                    if (constantsOnly) return binding.constant;
                    return true;
                } else if (isThisExpression2(node) || isMetaProperty2(node) || isTopicReference2(node) || isPrivateName2(node)) {
                    return true;
                } else if (isClass2(node)) {
                    var _node_decorators;
                    if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
                        return false;
                    }
                    if (((_node_decorators = node.decorators) === null || _node_decorators === void 0 ? void 0 : _node_decorators.length) > 0) {
                        return false;
                    }
                    return this.isPure(node.body, constantsOnly);
                } else if (isClassBody3(node)) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = node.body[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var method = _step.value;
                            if (!this.isPure(method, constantsOnly)) return false;
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return true;
                } else if (isBinary3(node)) {
                    return this.isPure(node.left, constantsOnly) && this.isPure(node.right, constantsOnly);
                } else if (isArrayExpression3(node) || isTupleExpression2(node)) {
                    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                    try {
                        for(var _iterator1 = node.elements[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                            var elem = _step1.value;
                            if (elem !== null && !this.isPure(elem, constantsOnly)) return false;
                        }
                    } catch (err) {
                        _didIteratorError1 = true;
                        _iteratorError1 = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                _iterator1.return();
                            }
                        } finally{
                            if (_didIteratorError1) {
                                throw _iteratorError1;
                            }
                        }
                    }
                    return true;
                } else if (isObjectExpression3(node) || isRecordExpression2(node)) {
                    var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
                    try {
                        for(var _iterator2 = node.properties[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
                            var prop = _step2.value;
                            if (!this.isPure(prop, constantsOnly)) return false;
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                                _iterator2.return();
                            }
                        } finally{
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                    return true;
                } else if (isMethod2(node)) {
                    var _node_decorators1;
                    if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
                    if (((_node_decorators1 = node.decorators) === null || _node_decorators1 === void 0 ? void 0 : _node_decorators1.length) > 0) {
                        return false;
                    }
                    return true;
                } else if (isProperty2(node)) {
                    var _node_decorators2;
                    if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
                    if (((_node_decorators2 = node.decorators) === null || _node_decorators2 === void 0 ? void 0 : _node_decorators2.length) > 0) {
                        return false;
                    }
                    if (isObjectProperty3(node) || node.static) {
                        if (node.value !== null && !this.isPure(node.value, constantsOnly)) {
                            return false;
                        }
                    }
                    return true;
                } else if (isUnaryExpression2(node)) {
                    return this.isPure(node.argument, constantsOnly);
                } else if (isTaggedTemplateExpression2(node)) {
                    return matchesPattern$1(node.tag, "String.raw") && !this.hasBinding("String", true) && this.isPure(node.quasi, constantsOnly);
                } else if (isTemplateLiteral3(node)) {
                    var _iteratorNormalCompletion3 = true, _didIteratorError3 = false, _iteratorError3 = undefined;
                    try {
                        for(var _iterator3 = node.expressions[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true){
                            var expression2 = _step3.value;
                            if (!this.isPure(expression2, constantsOnly)) return false;
                        }
                    } catch (err) {
                        _didIteratorError3 = true;
                        _iteratorError3 = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                                _iterator3.return();
                            }
                        } finally{
                            if (_didIteratorError3) {
                                throw _iteratorError3;
                            }
                        }
                    }
                    return true;
                } else {
                    return isPureish2(node);
                }
            }
        },
        {
            key: "setData",
            value: function setData(key, val) {
                return this.data[key] = val;
            }
        },
        {
            key: "getData",
            value: function getData(key) {
                var scope2 = this;
                do {
                    var data = scope2.data[key];
                    if (data != null) return data;
                }while (scope2 = scope2.parent);
            }
        },
        {
            key: "removeData",
            value: function removeData(key) {
                var scope2 = this;
                do {
                    var data = scope2.data[key];
                    if (data != null) scope2.data[key] = null;
                }while (scope2 = scope2.parent);
            }
        },
        {
            key: "init",
            value: function init() {
                if (!this.inited) {
                    this.inited = true;
                    this.crawl();
                }
            }
        },
        {
            key: "crawl",
            value: function crawl() {
                var path = this.path;
                this.references = /* @__PURE__ */ Object.create(null);
                this.bindings = /* @__PURE__ */ Object.create(null);
                this.globals = /* @__PURE__ */ Object.create(null);
                this.uids = /* @__PURE__ */ Object.create(null);
                this.data = /* @__PURE__ */ Object.create(null);
                var programParent = this.getProgramParent();
                if (programParent.crawling) return;
                var state = {
                    references: [],
                    constantViolations: [],
                    assignments: []
                };
                this.crawling = true;
                if (path.type !== "Program" && isExplodedVisitor(collectorVisitor)) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = collectorVisitor.enter[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var visit3 = _step.value;
                            visit3.call(state, path, state);
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    var typeVisitors = collectorVisitor[path.type];
                    if (typeVisitors) {
                        var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                        try {
                            for(var _iterator1 = typeVisitors.enter[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                var visit31 = _step1.value;
                                visit31.call(state, path, state);
                            }
                        } catch (err) {
                            _didIteratorError1 = true;
                            _iteratorError1 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                    _iterator1.return();
                                }
                            } finally{
                                if (_didIteratorError1) {
                                    throw _iteratorError1;
                                }
                            }
                        }
                    }
                }
                path.traverse(collectorVisitor, state);
                this.crawling = false;
                var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
                try {
                    for(var _iterator2 = state.assignments[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
                        var path2 = _step2.value;
                        var ids = path2.getBindingIdentifiers();
                        var _iteratorNormalCompletion3 = true, _didIteratorError3 = false, _iteratorError3 = undefined;
                        try {
                            for(var _iterator3 = Object.keys(ids)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true){
                                var name = _step3.value;
                                if (path2.scope.getBinding(name)) continue;
                                programParent.addGlobal(ids[name]);
                            }
                        } catch (err) {
                            _didIteratorError3 = true;
                            _iteratorError3 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                                    _iterator3.return();
                                }
                            } finally{
                                if (_didIteratorError3) {
                                    throw _iteratorError3;
                                }
                            }
                        }
                        path2.scope.registerConstantViolation(path2);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                            _iterator2.return();
                        }
                    } finally{
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }
                var _iteratorNormalCompletion4 = true, _didIteratorError4 = false, _iteratorError4 = undefined;
                try {
                    for(var _iterator4 = state.references[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true){
                        var ref = _step4.value;
                        var binding = ref.scope.getBinding(ref.node.name);
                        if (binding) {
                            binding.reference(ref);
                        } else {
                            programParent.addGlobal(ref.node);
                        }
                    }
                } catch (err) {
                    _didIteratorError4 = true;
                    _iteratorError4 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
                            _iterator4.return();
                        }
                    } finally{
                        if (_didIteratorError4) {
                            throw _iteratorError4;
                        }
                    }
                }
                var _iteratorNormalCompletion5 = true, _didIteratorError5 = false, _iteratorError5 = undefined;
                try {
                    for(var _iterator5 = state.constantViolations[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true){
                        var path21 = _step5.value;
                        path21.scope.registerConstantViolation(path21);
                    }
                } catch (err) {
                    _didIteratorError5 = true;
                    _iteratorError5 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
                            _iterator5.return();
                        }
                    } finally{
                        if (_didIteratorError5) {
                            throw _iteratorError5;
                        }
                    }
                }
            }
        },
        {
            key: "push",
            value: function push(opts) {
                var path = this.path;
                if (path.isPattern()) {
                    path = this.getPatternParent().path;
                } else if (!path.isBlockStatement() && !path.isProgram()) {
                    path = this.getBlockParent().path;
                }
                if (path.isSwitchStatement()) {
                    path = (this.getFunctionParent() || this.getProgramParent()).path;
                }
                var init = opts.init, unique = opts.unique, _opts_kind = opts.kind, kind = _opts_kind === void 0 ? "var" : _opts_kind, id = opts.id;
                if (!init && !unique && (kind === "var" || kind === "let") && path.isFunction() && !path.node.name && isCallExpression(path.parent, {
                    callee: path.node
                }) && path.parent.arguments.length <= path.node.params.length && isIdentifier(id)) {
                    path.pushContainer("params", id);
                    path.scope.registerBinding("param", path.get("params")[path.node.params.length - 1]);
                    return;
                }
                if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
                    path.ensureBlock();
                    path = path.get("body");
                }
                var blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
                var dataKey = "declaration:".concat(kind, ":").concat(blockHoist);
                var declarPath = !unique && path.getData(dataKey);
                if (!declarPath) {
                    var declar = variableDeclaration$1(kind, []);
                    declar._blockHoist = blockHoist;
                    var ref;
                    ref = _sliced_to_array(path.unshiftContainer("body", [
                        declar
                    ]), 1), declarPath = ref[0], ref;
                    if (!unique) path.setData(dataKey, declarPath);
                }
                var declarator = variableDeclarator$1(id, init);
                var len = declarPath.node.declarations.push(declarator);
                path.scope.registerBinding(kind, declarPath.get("declarations")[len - 1]);
            }
        },
        {
            key: "getProgramParent",
            value: function getProgramParent() {
                var scope2 = this;
                do {
                    if (scope2.path.isProgram()) {
                        return scope2;
                    }
                }while (scope2 = scope2.parent);
                throw new Error("Couldn't find a Program");
            }
        },
        {
            key: "getFunctionParent",
            value: function getFunctionParent() {
                var scope2 = this;
                do {
                    if (scope2.path.isFunctionParent()) {
                        return scope2;
                    }
                }while (scope2 = scope2.parent);
                return null;
            }
        },
        {
            key: "getBlockParent",
            value: function getBlockParent() {
                var scope2 = this;
                do {
                    if (scope2.path.isBlockParent()) {
                        return scope2;
                    }
                }while (scope2 = scope2.parent);
                throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
            }
        },
        {
            key: "getPatternParent",
            value: function getPatternParent() {
                var scope2 = this;
                do {
                    if (!scope2.path.isPattern()) {
                        return scope2.getBlockParent();
                    }
                }while (scope2 = scope2.parent.parent);
                throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
            }
        },
        {
            key: "getAllBindings",
            value: function getAllBindings() {
                var ids = /* @__PURE__ */ Object.create(null);
                var scope2 = this;
                do {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = Object.keys(scope2.bindings)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var key = _step.value;
                            if (key in ids === false) {
                                ids[key] = scope2.bindings[key];
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    scope2 = scope2.parent;
                }while (scope2);
                return ids;
            }
        },
        {
            key: "getAllBindingsOfKind",
            value: function getAllBindingsOfKind() {
                for(var _len = arguments.length, kinds = new Array(_len), _key = 0; _key < _len; _key++){
                    kinds[_key] = arguments[_key];
                }
                var ids = /* @__PURE__ */ Object.create(null);
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = kinds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var kind = _step.value;
                        var scope2 = this;
                        do {
                            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                            try {
                                for(var _iterator1 = Object.keys(scope2.bindings)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                    var name = _step1.value;
                                    var binding = scope2.bindings[name];
                                    if (binding.kind === kind) ids[name] = binding;
                                }
                            } catch (err) {
                                _didIteratorError1 = true;
                                _iteratorError1 = err;
                            } finally{
                                try {
                                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                        _iterator1.return();
                                    }
                                } finally{
                                    if (_didIteratorError1) {
                                        throw _iteratorError1;
                                    }
                                }
                            }
                            scope2 = scope2.parent;
                        }while (scope2);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return ids;
            }
        },
        {
            key: "bindingIdentifierEquals",
            value: function bindingIdentifierEquals(name, node) {
                return this.getBindingIdentifier(name) === node;
            }
        },
        {
            key: "getBinding",
            value: function getBinding(name) {
                var scope2 = this;
                var previousPath;
                do {
                    var binding = scope2.getOwnBinding(name);
                    if (binding) {
                        if ((previousPath === null || previousPath === void 0 ? void 0 : previousPath.isPattern()) && binding.kind !== "param" && binding.kind !== "local") ;
                        else {
                            return binding;
                        }
                    } else if (!binding && name === "arguments" && scope2.path.isFunction() && !scope2.path.isArrowFunctionExpression()) {
                        break;
                    }
                    previousPath = scope2.path;
                }while (scope2 = scope2.parent);
            }
        },
        {
            key: "getOwnBinding",
            value: function getOwnBinding(name) {
                return this.bindings[name];
            }
        },
        {
            key: "getBindingIdentifier",
            value: function getBindingIdentifier(name) {
                var _this_getBinding;
                return (_this_getBinding = this.getBinding(name)) === null || _this_getBinding === void 0 ? void 0 : _this_getBinding.identifier;
            }
        },
        {
            key: "getOwnBindingIdentifier",
            value: function getOwnBindingIdentifier(name) {
                var binding = this.bindings[name];
                return binding === null || binding === void 0 ? void 0 : binding.identifier;
            }
        },
        {
            key: "hasOwnBinding",
            value: function hasOwnBinding(name) {
                return !!this.getOwnBinding(name);
            }
        },
        {
            key: "hasBinding",
            value: function hasBinding(name, opts) {
                if (!name) return false;
                if (this.hasOwnBinding(name)) return true;
                {
                    if (typeof opts === "boolean") opts = {
                        noGlobals: opts
                    };
                }
                if (this.parentHasBinding(name, opts)) return true;
                if (!(opts === null || opts === void 0 ? void 0 : opts.noUids) && this.hasUid(name)) return true;
                if (!(opts === null || opts === void 0 ? void 0 : opts.noGlobals) && _Scope.globals.includes(name)) return true;
                if (!(opts === null || opts === void 0 ? void 0 : opts.noGlobals) && _Scope.contextVariables.includes(name)) return true;
                return false;
            }
        },
        {
            key: "parentHasBinding",
            value: function parentHasBinding(name, opts) {
                var _this_parent;
                return (_this_parent = this.parent) === null || _this_parent === void 0 ? void 0 : _this_parent.hasBinding(name, opts);
            }
        },
        {
            key: "moveBindingTo",
            value: function moveBindingTo(name, scope2) {
                var info = this.getBinding(name);
                if (info) {
                    info.scope.removeOwnBinding(name);
                    info.scope = scope2;
                    scope2.bindings[name] = info;
                }
            }
        },
        {
            key: "removeOwnBinding",
            value: function removeOwnBinding(name) {
                delete this.bindings[name];
            }
        },
        {
            key: "removeBinding",
            value: function removeBinding(name) {
                var _this_getBinding;
                (_this_getBinding = this.getBinding(name)) === null || _this_getBinding === void 0 ? void 0 : _this_getBinding.scope.removeOwnBinding(name);
                var scope2 = this;
                do {
                    if (scope2.uids[name]) {
                        scope2.uids[name] = false;
                    }
                }while (scope2 = scope2.parent);
            }
        }
    ]);
    return _Scope;
}();
__publicField(_Scope, "globals", Object.keys(import_globals.default.builtin));
__publicField(_Scope, "contextVariables", [
    "arguments",
    "undefined",
    "Infinity",
    "NaN"
]);
var Scope2 = _Scope;
var VISITOR_KEYS$4 = lib_exports.VISITOR_KEYS;
function findParent(callback) {
    var path = this;
    while(path = path.parentPath){
        if (callback(path)) return path;
    }
    return null;
}
function find(callback) {
    var path = this;
    do {
        if (callback(path)) return path;
    }while (path = path.parentPath);
    return null;
}
function getFunctionParent() {
    return this.findParent(function(p) {
        return p.isFunction();
    });
}
function getStatementParent() {
    var path = this;
    do {
        if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
            break;
        } else {
            path = path.parentPath;
        }
    }while (path);
    if (path && (path.isProgram() || path.isFile())) {
        throw new Error("File/Program node, we can't possibly find a statement parent to this");
    }
    return path;
}
function getEarliestCommonAncestorFrom(paths) {
    return this.getDeepestCommonAncestorFrom(paths, function(deepest, i, ancestries) {
        var earliest;
        var keys = VISITOR_KEYS$4[deepest.type];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = ancestries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var ancestry = _step.value;
                var path = ancestry[i + 1];
                if (!earliest) {
                    earliest = path;
                    continue;
                }
                if (path.listKey && earliest.listKey === path.listKey) {
                    if (path.key < earliest.key) {
                        earliest = path;
                        continue;
                    }
                }
                var earliestKeyIndex = keys.indexOf(earliest.parentKey);
                var currentKeyIndex = keys.indexOf(path.parentKey);
                if (earliestKeyIndex > currentKeyIndex) {
                    earliest = path;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return earliest;
    });
}
function getDeepestCommonAncestorFrom(paths, filter) {
    var _this = this;
    if (!paths.length) {
        return this;
    }
    if (paths.length === 1) {
        return paths[0];
    }
    var minDepth = Infinity;
    var lastCommonIndex, lastCommon;
    var ancestries = paths.map(function(path) {
        var ancestry = [];
        do {
            ancestry.unshift(path);
        }while ((path = path.parentPath) && path !== _this);
        if (ancestry.length < minDepth) {
            minDepth = ancestry.length;
        }
        return ancestry;
    });
    var first = ancestries[0];
    depthLoop: for(var i = 0; i < minDepth; i++){
        var shouldMatch = first[i];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = ancestries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var ancestry = _step.value;
                if (ancestry[i] !== shouldMatch) {
                    break depthLoop;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        lastCommonIndex = i;
        lastCommon = shouldMatch;
    }
    if (lastCommon) {
        if (filter) {
            return filter(lastCommon, lastCommonIndex, ancestries);
        } else {
            return lastCommon;
        }
    } else {
        throw new Error("Couldn't find intersection");
    }
}
function getAncestry() {
    var path = this;
    var paths = [];
    do {
        paths.push(path);
    }while (path = path.parentPath);
    return paths;
}
function isAncestor(maybeDescendant) {
    return maybeDescendant.isDescendant(this);
}
function isDescendant(maybeAncestor) {
    return !!this.findParent(function(parent) {
        return parent === maybeAncestor;
    });
}
function inType() {
    for(var _len = arguments.length, candidateTypes = new Array(_len), _key = 0; _key < _len; _key++){
        candidateTypes[_key] = arguments[_key];
    }
    var path = this;
    while(path){
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = candidateTypes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var type = _step.value;
                if (path.node.type === type) return true;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        path = path.parentPath;
    }
    return false;
}
var NodePath_ancestry = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    find: find,
    findParent: findParent,
    getAncestry: getAncestry,
    getDeepestCommonAncestorFrom: getDeepestCommonAncestorFrom,
    getEarliestCommonAncestorFrom: getEarliestCommonAncestorFrom,
    getFunctionParent: getFunctionParent,
    getStatementParent: getStatementParent,
    inType: inType,
    isAncestor: isAncestor,
    isDescendant: isDescendant
});
var createFlowUnionType2 = lib_exports.createFlowUnionType, createTSUnionType2 = lib_exports.createTSUnionType, createUnionTypeAnnotation = lib_exports.createUnionTypeAnnotation, isFlowType2 = lib_exports.isFlowType, isTSType2 = lib_exports.isTSType;
function createUnionType(types2) {
    {
        if (types2.every(function(v) {
            return isFlowType2(v);
        })) {
            return createFlowUnionType2(types2);
        }
        if (types2.every(function(v) {
            return isTSType2(v);
        })) {
            return createTSUnionType2(types2);
        }
    }
}
var BOOLEAN_NUMBER_BINARY_OPERATORS2 = lib_exports.BOOLEAN_NUMBER_BINARY_OPERATORS, createTypeAnnotationBasedOnTypeof2 = lib_exports.createTypeAnnotationBasedOnTypeof, numberTypeAnnotation$1 = lib_exports.numberTypeAnnotation, voidTypeAnnotation$2 = lib_exports.voidTypeAnnotation;
function infererReference(node) {
    if (!this.isReferenced()) return;
    var binding = this.scope.getBinding(node.name);
    if (binding) {
        if (binding.identifier.typeAnnotation) {
            return binding.identifier.typeAnnotation;
        } else {
            return getTypeAnnotationBindingConstantViolations(binding, this, node.name);
        }
    }
    if (node.name === "undefined") {
        return voidTypeAnnotation$2();
    } else if (node.name === "NaN" || node.name === "Infinity") {
        return numberTypeAnnotation$1();
    } else if (node.name === "arguments") ;
}
function getTypeAnnotationBindingConstantViolations(binding, path, name) {
    var types2 = [];
    var functionConstantViolations = [];
    var constantViolations = getConstantViolationsBefore(binding, path, functionConstantViolations);
    var testType = getConditionalAnnotation(binding, path, name);
    if (testType) {
        var testConstantViolations = getConstantViolationsBefore(binding, testType.ifStatement);
        constantViolations = constantViolations.filter(function(path2) {
            return testConstantViolations.indexOf(path2) < 0;
        });
        types2.push(testType.typeAnnotation);
    }
    if (constantViolations.length) {
        var _constantViolations;
        (_constantViolations = constantViolations).push.apply(_constantViolations, _to_consumable_array(functionConstantViolations));
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = constantViolations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var violation = _step.value;
                types2.push(violation.getTypeAnnotation());
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    if (!types2.length) {
        return;
    }
    return createUnionType(types2);
}
function getConstantViolationsBefore(binding, path, functions) {
    var violations = binding.constantViolations.slice();
    violations.unshift(binding.path);
    return violations.filter(function(violation) {
        violation = violation.resolve();
        var status = violation._guessExecutionStatusRelativeTo(path);
        if (functions && status === "unknown") functions.push(violation);
        return status === "before";
    });
}
function inferAnnotationFromBinaryExpression(name, path) {
    var operator = path.node.operator;
    var right = path.get("right").resolve();
    var left = path.get("left").resolve();
    var target;
    if (left.isIdentifier({
        name: name
    })) {
        target = right;
    } else if (right.isIdentifier({
        name: name
    })) {
        target = left;
    }
    if (target) {
        if (operator === "===") {
            return target.getTypeAnnotation();
        }
        if (BOOLEAN_NUMBER_BINARY_OPERATORS2.indexOf(operator) >= 0) {
            return numberTypeAnnotation$1();
        }
        return;
    }
    if (operator !== "===" && operator !== "==") return;
    var typeofPath;
    var typePath;
    if (left.isUnaryExpression({
        operator: "typeof"
    })) {
        typeofPath = left;
        typePath = right;
    } else if (right.isUnaryExpression({
        operator: "typeof"
    })) {
        typeofPath = right;
        typePath = left;
    }
    if (!typeofPath) return;
    if (!typeofPath.get("argument").isIdentifier({
        name: name
    })) return;
    typePath = typePath.resolve();
    if (!typePath.isLiteral()) return;
    var typeValue = typePath.node.value;
    if (typeof typeValue !== "string") return;
    return createTypeAnnotationBasedOnTypeof2(typeValue);
}
function getParentConditionalPath(binding, path, name) {
    var parentPath;
    while(parentPath = path.parentPath){
        if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
            if (path.key === "test") {
                return;
            }
            return parentPath;
        }
        if (parentPath.isFunction()) {
            if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
        }
        path = parentPath;
    }
}
function getConditionalAnnotation(binding, path, name) {
    var ifStatement2 = getParentConditionalPath(binding, path, name);
    if (!ifStatement2) return;
    var test = ifStatement2.get("test");
    var paths = [
        test
    ];
    var types2 = [];
    for(var i = 0; i < paths.length; i++){
        var path2 = paths[i];
        if (path2.isLogicalExpression()) {
            if (path2.node.operator === "&&") {
                paths.push(path2.get("left"));
                paths.push(path2.get("right"));
            }
        } else if (path2.isBinaryExpression()) {
            var type = inferAnnotationFromBinaryExpression(name, path2);
            if (type) types2.push(type);
        }
    }
    if (types2.length) {
        return {
            typeAnnotation: createUnionType(types2),
            ifStatement: ifStatement2
        };
    }
    return getConditionalAnnotation(binding, ifStatement2, name);
}
var BOOLEAN_BINARY_OPERATORS2 = lib_exports.BOOLEAN_BINARY_OPERATORS, BOOLEAN_UNARY_OPERATORS2 = lib_exports.BOOLEAN_UNARY_OPERATORS, NUMBER_BINARY_OPERATORS2 = lib_exports.NUMBER_BINARY_OPERATORS, NUMBER_UNARY_OPERATORS2 = lib_exports.NUMBER_UNARY_OPERATORS, STRING_UNARY_OPERATORS2 = lib_exports.STRING_UNARY_OPERATORS, anyTypeAnnotation$1 = lib_exports.anyTypeAnnotation, arrayTypeAnnotation2 = lib_exports.arrayTypeAnnotation, booleanTypeAnnotation2 = lib_exports.booleanTypeAnnotation, buildMatchMemberExpression2 = lib_exports.buildMatchMemberExpression, genericTypeAnnotation2 = lib_exports.genericTypeAnnotation, identifier$2 = lib_exports.identifier, nullLiteralTypeAnnotation2 = lib_exports.nullLiteralTypeAnnotation, numberTypeAnnotation2 = lib_exports.numberTypeAnnotation, stringTypeAnnotation$1 = lib_exports.stringTypeAnnotation, tupleTypeAnnotation2 = lib_exports.tupleTypeAnnotation, unionTypeAnnotation2 = lib_exports.unionTypeAnnotation, voidTypeAnnotation$1 = lib_exports.voidTypeAnnotation, isIdentifier$4 = lib_exports.isIdentifier;
function VariableDeclarator2() {
    if (!this.get("id").isIdentifier()) return;
    return this.get("init").getTypeAnnotation();
}
function TypeCastExpression2(node) {
    return node.typeAnnotation;
}
TypeCastExpression2.validParent = true;
function TSAsExpression2(node) {
    return node.typeAnnotation;
}
TSAsExpression2.validParent = true;
function TSNonNullExpression2() {
    return this.get("expression").getTypeAnnotation();
}
function NewExpression2(node) {
    if (node.callee.type === "Identifier") {
        return genericTypeAnnotation2(node.callee);
    }
}
function TemplateLiteral2() {
    return stringTypeAnnotation$1();
}
function UnaryExpression2(node) {
    var operator = node.operator;
    if (operator === "void") {
        return voidTypeAnnotation$1();
    } else if (NUMBER_UNARY_OPERATORS2.indexOf(operator) >= 0) {
        return numberTypeAnnotation2();
    } else if (STRING_UNARY_OPERATORS2.indexOf(operator) >= 0) {
        return stringTypeAnnotation$1();
    } else if (BOOLEAN_UNARY_OPERATORS2.indexOf(operator) >= 0) {
        return booleanTypeAnnotation2();
    }
}
function BinaryExpression2(node) {
    var operator = node.operator;
    if (NUMBER_BINARY_OPERATORS2.indexOf(operator) >= 0) {
        return numberTypeAnnotation2();
    } else if (BOOLEAN_BINARY_OPERATORS2.indexOf(operator) >= 0) {
        return booleanTypeAnnotation2();
    } else if (operator === "+") {
        var right = this.get("right");
        var left = this.get("left");
        if (left.isBaseType("number") && right.isBaseType("number")) {
            return numberTypeAnnotation2();
        } else if (left.isBaseType("string") || right.isBaseType("string")) {
            return stringTypeAnnotation$1();
        }
        return unionTypeAnnotation2([
            stringTypeAnnotation$1(),
            numberTypeAnnotation2()
        ]);
    }
}
function LogicalExpression2() {
    var argumentTypes = [
        this.get("left").getTypeAnnotation(),
        this.get("right").getTypeAnnotation()
    ];
    return createUnionType(argumentTypes);
}
function ConditionalExpression2() {
    var argumentTypes = [
        this.get("consequent").getTypeAnnotation(),
        this.get("alternate").getTypeAnnotation()
    ];
    return createUnionType(argumentTypes);
}
function SequenceExpression2() {
    return this.get("expressions").pop().getTypeAnnotation();
}
function ParenthesizedExpression2() {
    return this.get("expression").getTypeAnnotation();
}
function AssignmentExpression2() {
    return this.get("right").getTypeAnnotation();
}
function UpdateExpression2(node) {
    var operator = node.operator;
    if (operator === "++" || operator === "--") {
        return numberTypeAnnotation2();
    }
}
function StringLiteral2() {
    return stringTypeAnnotation$1();
}
function NumericLiteral2() {
    return numberTypeAnnotation2();
}
function BooleanLiteral2() {
    return booleanTypeAnnotation2();
}
function NullLiteral2() {
    return nullLiteralTypeAnnotation2();
}
function RegExpLiteral2() {
    return genericTypeAnnotation2(identifier$2("RegExp"));
}
function ObjectExpression2() {
    return genericTypeAnnotation2(identifier$2("Object"));
}
function ArrayExpression2() {
    return genericTypeAnnotation2(identifier$2("Array"));
}
function RestElement2() {
    return ArrayExpression2();
}
RestElement2.validParent = true;
function Func() {
    return genericTypeAnnotation2(identifier$2("Function"));
}
var isArrayFrom = buildMatchMemberExpression2("Array.from");
var isObjectKeys = buildMatchMemberExpression2("Object.keys");
var isObjectValues = buildMatchMemberExpression2("Object.values");
var isObjectEntries = buildMatchMemberExpression2("Object.entries");
function CallExpression2() {
    var callee = this.node.callee;
    if (isObjectKeys(callee)) {
        return arrayTypeAnnotation2(stringTypeAnnotation$1());
    } else if (isArrayFrom(callee) || isObjectValues(callee) || isIdentifier$4(callee, {
        name: "Array"
    })) {
        return arrayTypeAnnotation2(anyTypeAnnotation$1());
    } else if (isObjectEntries(callee)) {
        return arrayTypeAnnotation2(tupleTypeAnnotation2([
            stringTypeAnnotation$1(),
            anyTypeAnnotation$1()
        ]));
    }
    return resolveCall(this.get("callee"));
}
function TaggedTemplateExpression2() {
    return resolveCall(this.get("tag"));
}
function resolveCall(callee) {
    callee = callee.resolve();
    if (callee.isFunction()) {
        var node = callee.node;
        if (node.async) {
            if (node.generator) {
                return genericTypeAnnotation2(identifier$2("AsyncIterator"));
            } else {
                return genericTypeAnnotation2(identifier$2("Promise"));
            }
        } else {
            if (node.generator) {
                return genericTypeAnnotation2(identifier$2("Iterator"));
            } else if (callee.node.returnType) {
                return callee.node.returnType;
            } else ;
        }
    }
}
var inferers = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    ArrayExpression: ArrayExpression2,
    ArrowFunctionExpression: Func,
    AssignmentExpression: AssignmentExpression2,
    BinaryExpression: BinaryExpression2,
    BooleanLiteral: BooleanLiteral2,
    CallExpression: CallExpression2,
    ClassDeclaration: Func,
    ClassExpression: Func,
    ConditionalExpression: ConditionalExpression2,
    FunctionDeclaration: Func,
    FunctionExpression: Func,
    Identifier: infererReference,
    LogicalExpression: LogicalExpression2,
    NewExpression: NewExpression2,
    NullLiteral: NullLiteral2,
    NumericLiteral: NumericLiteral2,
    ObjectExpression: ObjectExpression2,
    ParenthesizedExpression: ParenthesizedExpression2,
    RegExpLiteral: RegExpLiteral2,
    RestElement: RestElement2,
    SequenceExpression: SequenceExpression2,
    StringLiteral: StringLiteral2,
    TSAsExpression: TSAsExpression2,
    TSNonNullExpression: TSNonNullExpression2,
    TaggedTemplateExpression: TaggedTemplateExpression2,
    TemplateLiteral: TemplateLiteral2,
    TypeCastExpression: TypeCastExpression2,
    UnaryExpression: UnaryExpression2,
    UpdateExpression: UpdateExpression2,
    VariableDeclarator: VariableDeclarator2
});
var anyTypeAnnotation2 = lib_exports.anyTypeAnnotation, isAnyTypeAnnotation2 = lib_exports.isAnyTypeAnnotation, isArrayTypeAnnotation3 = lib_exports.isArrayTypeAnnotation, isBooleanTypeAnnotation2 = lib_exports.isBooleanTypeAnnotation, isEmptyTypeAnnotation2 = lib_exports.isEmptyTypeAnnotation, isFlowBaseAnnotation2 = lib_exports.isFlowBaseAnnotation, isGenericTypeAnnotation2 = lib_exports.isGenericTypeAnnotation, isIdentifier$3 = lib_exports.isIdentifier, isMixedTypeAnnotation2 = lib_exports.isMixedTypeAnnotation, isNumberTypeAnnotation2 = lib_exports.isNumberTypeAnnotation, isStringTypeAnnotation2 = lib_exports.isStringTypeAnnotation, isTSArrayType2 = lib_exports.isTSArrayType, isTSTypeAnnotation2 = lib_exports.isTSTypeAnnotation, isTSTypeReference2 = lib_exports.isTSTypeReference, isTupleTypeAnnotation2 = lib_exports.isTupleTypeAnnotation, isTypeAnnotation2 = lib_exports.isTypeAnnotation, isUnionTypeAnnotation2 = lib_exports.isUnionTypeAnnotation, isVoidTypeAnnotation2 = lib_exports.isVoidTypeAnnotation, stringTypeAnnotation2 = lib_exports.stringTypeAnnotation, voidTypeAnnotation2 = lib_exports.voidTypeAnnotation;
function getTypeAnnotation() {
    var type = this.getData("typeAnnotation");
    if (type != null) {
        return type;
    }
    type = this._getTypeAnnotation() || anyTypeAnnotation2();
    if (isTypeAnnotation2(type) || isTSTypeAnnotation2(type)) {
        type = type.typeAnnotation;
    }
    this.setData("typeAnnotation", type);
    return type;
}
var typeAnnotationInferringNodes = /* @__PURE__ */ new WeakSet();
function _getTypeAnnotation() {
    var node = this.node;
    if (!node) {
        if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
            var declar = this.parentPath.parentPath;
            var declarParent = declar.parentPath;
            if (declar.key === "left" && declarParent.isForInStatement()) {
                return stringTypeAnnotation2();
            }
            if (declar.key === "left" && declarParent.isForOfStatement()) {
                return anyTypeAnnotation2();
            }
            return voidTypeAnnotation2();
        } else {
            return;
        }
    }
    if (node.typeAnnotation) {
        return node.typeAnnotation;
    }
    if (typeAnnotationInferringNodes.has(node)) {
        return;
    }
    typeAnnotationInferringNodes.add(node);
    try {
        var inferer = inferers[node.type];
        if (inferer) {
            return inferer.call(this, node);
        }
        inferer = inferers[this.parentPath.type];
        if (inferer === null || inferer === void 0 ? void 0 : inferer.validParent) {
            return this.parentPath.getTypeAnnotation();
        }
    } finally{
        typeAnnotationInferringNodes.delete(node);
    }
}
function isBaseType(baseName, soft) {
    return _isBaseType(baseName, this.getTypeAnnotation(), soft);
}
function _isBaseType(baseName, type, soft) {
    if (baseName === "string") {
        return isStringTypeAnnotation2(type);
    } else if (baseName === "number") {
        return isNumberTypeAnnotation2(type);
    } else if (baseName === "boolean") {
        return isBooleanTypeAnnotation2(type);
    } else if (baseName === "any") {
        return isAnyTypeAnnotation2(type);
    } else if (baseName === "mixed") {
        return isMixedTypeAnnotation2(type);
    } else if (baseName === "empty") {
        return isEmptyTypeAnnotation2(type);
    } else if (baseName === "void") {
        return isVoidTypeAnnotation2(type);
    } else {
        if (soft) {
            return false;
        } else {
            throw new Error("Unknown base type ".concat(baseName));
        }
    }
}
function couldBeBaseType(name) {
    var type = this.getTypeAnnotation();
    if (isAnyTypeAnnotation2(type)) return true;
    if (isUnionTypeAnnotation2(type)) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = type.types[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var type2 = _step.value;
                if (isAnyTypeAnnotation2(type2) || _isBaseType(name, type2, true)) {
                    return true;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return false;
    } else {
        return _isBaseType(name, type, true);
    }
}
function baseTypeStrictlyMatches(rightArg) {
    var left = this.getTypeAnnotation();
    var right = rightArg.getTypeAnnotation();
    if (!isAnyTypeAnnotation2(left) && isFlowBaseAnnotation2(left)) {
        return right.type === left.type;
    }
    return false;
}
function isGenericType(genericName) {
    var type = this.getTypeAnnotation();
    if (genericName === "Array") {
        if (isTSArrayType2(type) || isArrayTypeAnnotation3(type) || isTupleTypeAnnotation2(type)) {
            return true;
        }
    }
    return isGenericTypeAnnotation2(type) && isIdentifier$3(type.id, {
        name: genericName
    }) || isTSTypeReference2(type) && isIdentifier$3(type.typeName, {
        name: genericName
    });
}
var NodePath_inference = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _getTypeAnnotation: _getTypeAnnotation,
    baseTypeStrictlyMatches: baseTypeStrictlyMatches,
    couldBeBaseType: couldBeBaseType,
    getTypeAnnotation: getTypeAnnotation,
    isBaseType: isBaseType,
    isGenericType: isGenericType
});
var FUNCTION_TYPES2 = lib_exports.FUNCTION_TYPES, arrowFunctionExpression$2 = lib_exports.arrowFunctionExpression, assignmentExpression$2 = lib_exports.assignmentExpression, awaitExpression2 = lib_exports.awaitExpression, blockStatement$2 = lib_exports.blockStatement, buildUndefinedNode2 = lib_exports.buildUndefinedNode, callExpression$2 = lib_exports.callExpression, cloneNode$2 = lib_exports.cloneNode, conditionalExpression$1 = lib_exports.conditionalExpression, expressionStatement$2 = lib_exports.expressionStatement, getBindingIdentifiers$2 = lib_exports.getBindingIdentifiers, identifier$1 = lib_exports.identifier, inheritLeadingComments2 = lib_exports.inheritLeadingComments, inheritTrailingComments2 = lib_exports.inheritTrailingComments, inheritsComments2 = lib_exports.inheritsComments, isBlockStatement$1 = lib_exports.isBlockStatement, isEmptyStatement2 = lib_exports.isEmptyStatement, isExpression$2 = lib_exports.isExpression, isExpressionStatement4 = lib_exports.isExpressionStatement, isIfStatement3 = lib_exports.isIfStatement, isProgram2 = lib_exports.isProgram, isStatement4 = lib_exports.isStatement, isVariableDeclaration2 = lib_exports.isVariableDeclaration, removeComments2 = lib_exports.removeComments, returnStatement$1 = lib_exports.returnStatement, sequenceExpression$1 = lib_exports.sequenceExpression, validate$13 = lib_exports.validate, yieldExpression2 = lib_exports.yieldExpression;
function replaceWithMultiple(nodes2) {
    var _getCachedPaths;
    this.resync();
    nodes2 = this._verifyNodeList(nodes2);
    inheritLeadingComments2(nodes2[0], this.node);
    inheritTrailingComments2(nodes2[nodes2.length - 1], this.node);
    (_getCachedPaths = getCachedPaths(this.hub, this.parent)) === null || _getCachedPaths === void 0 ? void 0 : _getCachedPaths.delete(this.node);
    this.node = this.container[this.key] = null;
    var paths = this.insertAfter(nodes2);
    if (this.node) {
        this.requeue();
    } else {
        this.remove();
    }
    return paths;
}
function replaceWithSourceString(replacement) {
    this.resync();
    var ast;
    try {
        replacement = "(".concat(replacement, ")");
        ast = parse(replacement);
    } catch (err) {
        var loc = err.loc;
        if (loc) {
            err.message += " - make sure this is an expression.\n" + codeFrameColumns(replacement, {
                start: {
                    line: loc.line,
                    column: loc.column + 1
                }
            });
            err.code = "BABEL_REPLACE_SOURCE_ERROR";
        }
        throw err;
    }
    var expressionAST = ast.program.body[0].expression;
    traverse3.removeProperties(expressionAST);
    return this.replaceWith(expressionAST);
}
function replaceWith(replacementPath) {
    this.resync();
    if (this.removed) {
        throw new Error("You can't replace this node, we've already removed it");
    }
    var replacement = _instanceof(replacementPath, NodePath) ? replacementPath.node : replacementPath;
    if (!replacement) {
        throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
    }
    if (this.node === replacement) {
        return [
            this
        ];
    }
    if (this.isProgram() && !isProgram2(replacement)) {
        throw new Error("You can only replace a Program root node with another Program node");
    }
    if (Array.isArray(replacement)) {
        throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
    }
    if (typeof replacement === "string") {
        throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
    }
    var nodePath = "";
    if (this.isNodeType("Statement") && isExpression$2(replacement)) {
        if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
            replacement = expressionStatement$2(replacement);
            nodePath = "expression";
        }
    }
    if (this.isNodeType("Expression") && isStatement4(replacement)) {
        if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
            return this.replaceExpressionWithStatements([
                replacement
            ]);
        }
    }
    var oldNode = this.node;
    if (oldNode) {
        inheritsComments2(replacement, oldNode);
        removeComments2(oldNode);
    }
    this._replaceWith(replacement);
    this.type = replacement.type;
    this.setScope();
    this.requeue();
    return [
        nodePath ? this.get(nodePath) : this
    ];
}
function _replaceWith(node) {
    var _getCachedPaths;
    if (!this.container) {
        throw new ReferenceError("Container is falsy");
    }
    if (this.inList) {
        validate$13(this.parent, this.key, [
            node
        ]);
    } else {
        validate$13(this.parent, this.key, node);
    }
    this.debug("Replace with ".concat(node === null || node === void 0 ? void 0 : node.type));
    (_getCachedPaths = getCachedPaths(this.hub, this.parent)) === null || _getCachedPaths === void 0 ? void 0 : _getCachedPaths.set(node, this).delete(this.node);
    this.node = this.container[this.key] = node;
}
function replaceExpressionWithStatements(nodes2) {
    var _this = this;
    this.resync();
    var declars = [];
    var nodesAsSingleExpression = gatherSequenceExpressions(nodes2, declars);
    if (nodesAsSingleExpression) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = declars[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var id = _step.value;
                this.scope.push({
                    id: id
                });
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return this.replaceWith(nodesAsSingleExpression)[0].get("expressions");
    }
    var functionParent = this.getFunctionParent();
    var isParentAsync = functionParent === null || functionParent === void 0 ? void 0 : functionParent.is("async");
    var isParentGenerator = functionParent === null || functionParent === void 0 ? void 0 : functionParent.is("generator");
    var container = arrowFunctionExpression$2([], blockStatement$2(nodes2));
    this.replaceWith(callExpression$2(container, []));
    var callee = this.get("callee");
    hoistVariables(callee.get("body"), function(id) {
        _this.scope.push({
            id: id
        });
    }, "var");
    var completionRecords = this.get("callee").getCompletionRecords();
    var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
    try {
        for(var _iterator1 = completionRecords[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
            var path = _step1.value;
            if (!path.isExpressionStatement()) continue;
            var loop = path.findParent(function(path2) {
                return path2.isLoop();
            });
            if (loop) {
                var uid2 = loop.getData("expressionReplacementReturnUid");
                if (!uid2) {
                    uid2 = callee.scope.generateDeclaredUidIdentifier("ret");
                    callee.get("body").pushContainer("body", returnStatement$1(cloneNode$2(uid2)));
                    loop.setData("expressionReplacementReturnUid", uid2);
                } else {
                    uid2 = identifier$1(uid2.name);
                }
                path.get("expression").replaceWith(assignmentExpression$2("=", cloneNode$2(uid2), path.node.expression));
            } else {
                path.replaceWith(returnStatement$1(path.node.expression));
            }
        }
    } catch (err) {
        _didIteratorError1 = true;
        _iteratorError1 = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                _iterator1.return();
            }
        } finally{
            if (_didIteratorError1) {
                throw _iteratorError1;
            }
        }
    }
    callee.arrowFunctionToExpression();
    var newCallee = callee;
    var needToAwaitFunction = isParentAsync && traverse3.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES2);
    var needToYieldFunction = isParentGenerator && traverse3.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES2);
    if (needToAwaitFunction) {
        newCallee.set("async", true);
        if (!needToYieldFunction) {
            this.replaceWith(awaitExpression2(this.node));
        }
    }
    if (needToYieldFunction) {
        newCallee.set("generator", true);
        this.replaceWith(yieldExpression2(this.node, true));
    }
    return newCallee.get("body.body");
}
function gatherSequenceExpressions(nodes2, declars) {
    var exprs = [];
    var ensureLastUndefined = true;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = nodes2[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var node = _step.value;
            if (!isEmptyStatement2(node)) {
                ensureLastUndefined = false;
            }
            if (isExpression$2(node)) {
                exprs.push(node);
            } else if (isExpressionStatement4(node)) {
                exprs.push(node.expression);
            } else if (isVariableDeclaration2(node)) {
                if (node.kind !== "var") return;
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = node.declarations[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var declar = _step1.value;
                        var bindings = getBindingIdentifiers$2(declar);
                        var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
                        try {
                            for(var _iterator2 = Object.keys(bindings)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
                                var key = _step2.value;
                                declars.push(cloneNode$2(bindings[key]));
                            }
                        } catch (err) {
                            _didIteratorError2 = true;
                            _iteratorError2 = err;
                        } finally{
                            try {
                                if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                                    _iterator2.return();
                                }
                            } finally{
                                if (_didIteratorError2) {
                                    throw _iteratorError2;
                                }
                            }
                        }
                        if (declar.init) {
                            exprs.push(assignmentExpression$2("=", declar.id, declar.init));
                        }
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
                ensureLastUndefined = true;
            } else if (isIfStatement3(node)) {
                var consequent = node.consequent ? gatherSequenceExpressions([
                    node.consequent
                ], declars) : buildUndefinedNode2();
                var alternate = node.alternate ? gatherSequenceExpressions([
                    node.alternate
                ], declars) : buildUndefinedNode2();
                if (!consequent || !alternate) return;
                exprs.push(conditionalExpression$1(node.test, consequent, alternate));
            } else if (isBlockStatement$1(node)) {
                var body = gatherSequenceExpressions(node.body, declars);
                if (!body) return;
                exprs.push(body);
            } else if (isEmptyStatement2(node)) {
                if (nodes2.indexOf(node) === 0) {
                    ensureLastUndefined = true;
                }
            } else {
                return;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    if (ensureLastUndefined) exprs.push(buildUndefinedNode2());
    if (exprs.length === 1) {
        return exprs[0];
    } else {
        return sequenceExpression$1(exprs);
    }
}
function replaceInline(nodes2) {
    this.resync();
    if (Array.isArray(nodes2)) {
        if (Array.isArray(this.container)) {
            nodes2 = this._verifyNodeList(nodes2);
            var paths = this._containerInsertAfter(nodes2);
            this.remove();
            return paths;
        } else {
            return this.replaceWithMultiple(nodes2);
        }
    } else {
        return this.replaceWith(nodes2);
    }
}
var NodePath_replacement = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _replaceWith: _replaceWith,
    replaceExpressionWithStatements: replaceExpressionWithStatements,
    replaceInline: replaceInline,
    replaceWith: replaceWith,
    replaceWithMultiple: replaceWithMultiple,
    replaceWithSourceString: replaceWithSourceString
});
var VALID_OBJECT_CALLEES = [
    "Number",
    "String",
    "Math"
];
var VALID_IDENTIFIER_CALLEES = [
    "isFinite",
    "isNaN",
    "parseFloat",
    "parseInt",
    "decodeURI",
    "decodeURIComponent",
    "encodeURI",
    "encodeURIComponent",
    "btoa",
    "atob"
];
var INVALID_METHODS = [
    "random"
];
function isValidObjectCallee(val) {
    return VALID_OBJECT_CALLEES.includes(val);
}
function isValidIdentifierCallee(val) {
    return VALID_IDENTIFIER_CALLEES.includes(val);
}
function isInvalidMethod(val) {
    return INVALID_METHODS.includes(val);
}
function evaluateTruthy() {
    var res = this.evaluate();
    if (res.confident) return !!res.value;
}
function deopt(path, state) {
    if (!state.confident) return;
    state.deoptPath = path;
    state.confident = false;
}
var Globals = /* @__PURE__ */ new Map([
    [
        "undefined",
        void 0
    ],
    [
        "Infinity",
        Infinity
    ],
    [
        "NaN",
        NaN
    ]
]);
function evaluateCached(path, state) {
    var node = path.node;
    var seen = state.seen;
    if (seen.has(node)) {
        var existing = seen.get(node);
        if (existing.resolved) {
            return existing.value;
        } else {
            deopt(path, state);
            return;
        }
    } else {
        var item = {
            resolved: false
        };
        seen.set(node, item);
        var val = _evaluate(path, state);
        if (state.confident) {
            item.resolved = true;
            item.value = val;
        }
        return val;
    }
}
function _evaluate(path, state) {
    if (!state.confident) return;
    if (path.isSequenceExpression()) {
        var exprs = path.get("expressions");
        return evaluateCached(exprs[exprs.length - 1], state);
    }
    if (path.isStringLiteral() || path.isNumericLiteral() || path.isBooleanLiteral()) {
        return path.node.value;
    }
    if (path.isNullLiteral()) {
        return null;
    }
    if (path.isTemplateLiteral()) {
        return evaluateQuasis(path, path.node.quasis, state);
    }
    if (path.isTaggedTemplateExpression() && path.get("tag").isMemberExpression()) {
        var object = path.get("tag.object");
        var name = object.node.name;
        var property = path.get("tag.property");
        if (object.isIdentifier() && name === "String" && !path.scope.getBinding(name) && property.isIdentifier() && property.node.name === "raw") {
            return evaluateQuasis(path, path.node.quasi.quasis, state, true);
        }
    }
    if (path.isConditionalExpression()) {
        var testResult = evaluateCached(path.get("test"), state);
        if (!state.confident) return;
        if (testResult) {
            return evaluateCached(path.get("consequent"), state);
        } else {
            return evaluateCached(path.get("alternate"), state);
        }
    }
    if (path.isExpressionWrapper()) {
        return evaluateCached(path.get("expression"), state);
    }
    if (path.isMemberExpression() && !path.parentPath.isCallExpression({
        callee: path.node
    })) {
        var property1 = path.get("property");
        var object1 = path.get("object");
        if (object1.isLiteral()) {
            var value1 = object1.node.value;
            var type = typeof value1 === "undefined" ? "undefined" : _type_of(value1);
            var key = null;
            if (path.node.computed) {
                key = evaluateCached(property1, state);
                if (!state.confident) return;
            } else if (property1.isIdentifier()) {
                key = property1.node.name;
            }
            if ((type === "number" || type === "string") && key != null && (typeof key === "number" || typeof key === "string")) {
                return value1[key];
            }
        }
    }
    if (path.isReferencedIdentifier()) {
        var binding = path.scope.getBinding(path.node.name);
        if (binding) {
            if (binding.constantViolations.length > 0 || path.node.start < binding.path.node.end) {
                deopt(binding.path, state);
                return;
            }
            if (binding.hasValue) {
                return binding.value;
            }
        }
        var name1 = path.node.name;
        if (Globals.has(name1)) {
            if (!binding) {
                return Globals.get(name1);
            }
            deopt(binding.path, state);
            return;
        }
        var resolved = path.resolve();
        if (resolved === path) {
            deopt(path, state);
            return;
        } else {
            return evaluateCached(resolved, state);
        }
    }
    if (path.isUnaryExpression({
        prefix: true
    })) {
        if (path.node.operator === "void") {
            return void 0;
        }
        var argument = path.get("argument");
        if (path.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
            return "function";
        }
        var arg = evaluateCached(argument, state);
        if (!state.confident) return;
        switch(path.node.operator){
            case "!":
                return !arg;
            case "+":
                return +arg;
            case "-":
                return -arg;
            case "~":
                return ~arg;
            case "typeof":
                return typeof arg === "undefined" ? "undefined" : _type_of(arg);
        }
    }
    if (path.isArrayExpression()) {
        var arr = [];
        var elems = path.get("elements");
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = elems[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var elem = _step.value;
                var elemValue = elem.evaluate();
                if (elemValue.confident) {
                    arr.push(elemValue.value);
                } else {
                    deopt(elemValue.deopt, state);
                    return;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return arr;
    }
    if (path.isObjectExpression()) {
        var obj = {};
        var props = path.get("properties");
        var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
        try {
            for(var _iterator1 = props[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                var prop = _step1.value;
                if (prop.isObjectMethod() || prop.isSpreadElement()) {
                    deopt(prop, state);
                    return;
                }
                var keyPath = prop.get("key");
                var key1 = void 0;
                if (prop.node.computed) {
                    key1 = keyPath.evaluate();
                    if (!key1.confident) {
                        deopt(key1.deopt, state);
                        return;
                    }
                    key1 = key1.value;
                } else if (keyPath.isIdentifier()) {
                    key1 = keyPath.node.name;
                } else {
                    key1 = keyPath.node.value;
                }
                var valuePath = prop.get("value");
                var value2 = valuePath.evaluate();
                if (!value2.confident) {
                    deopt(value2.deopt, state);
                    return;
                }
                value2 = value2.value;
                obj[key1] = value2;
            }
        } catch (err) {
            _didIteratorError1 = true;
            _iteratorError1 = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                    _iterator1.return();
                }
            } finally{
                if (_didIteratorError1) {
                    throw _iteratorError1;
                }
            }
        }
        return obj;
    }
    if (path.isLogicalExpression()) {
        var wasConfident = state.confident;
        var left = evaluateCached(path.get("left"), state);
        var leftConfident = state.confident;
        state.confident = wasConfident;
        var right = evaluateCached(path.get("right"), state);
        var rightConfident = state.confident;
        switch(path.node.operator){
            case "||":
                state.confident = leftConfident && (!!left || rightConfident);
                if (!state.confident) return;
                return left || right;
            case "&&":
                state.confident = leftConfident && (!left || rightConfident);
                if (!state.confident) return;
                return left && right;
            case "??":
                state.confident = leftConfident && (left != null || rightConfident);
                if (!state.confident) return;
                return left !== null && left !== void 0 ? left : right;
        }
    }
    if (path.isBinaryExpression()) {
        var left1 = evaluateCached(path.get("left"), state);
        if (!state.confident) return;
        var right1 = evaluateCached(path.get("right"), state);
        if (!state.confident) return;
        switch(path.node.operator){
            case "-":
                return left1 - right1;
            case "+":
                return left1 + right1;
            case "/":
                return left1 / right1;
            case "*":
                return left1 * right1;
            case "%":
                return left1 % right1;
            case "**":
                return Math.pow(left1, right1);
            case "<":
                return left1 < right1;
            case ">":
                return left1 > right1;
            case "<=":
                return left1 <= right1;
            case ">=":
                return left1 >= right1;
            case "==":
                return left1 == right1;
            case "!=":
                return left1 != right1;
            case "===":
                return left1 === right1;
            case "!==":
                return left1 !== right1;
            case "|":
                return left1 | right1;
            case "&":
                return left1 & right1;
            case "^":
                return left1 ^ right1;
            case "<<":
                return left1 << right1;
            case ">>":
                return left1 >> right1;
            case ">>>":
                return left1 >>> right1;
        }
    }
    if (path.isCallExpression()) {
        var callee = path.get("callee");
        var context;
        var func;
        if (callee.isIdentifier() && !path.scope.getBinding(callee.node.name) && (isValidObjectCallee(callee.node.name) || isValidIdentifierCallee(callee.node.name))) {
            func = global[callee.node.name];
        }
        if (callee.isMemberExpression()) {
            var object2 = callee.get("object");
            var property2 = callee.get("property");
            if (object2.isIdentifier() && property2.isIdentifier() && isValidObjectCallee(object2.node.name) && !isInvalidMethod(property2.node.name)) {
                context = global[object2.node.name];
                var key2 = property2.node.name;
                if (Object.hasOwnProperty.call(context, key2)) {
                    func = context[key2];
                }
            }
            if (object2.isLiteral() && property2.isIdentifier()) {
                var type1 = _type_of(object2.node.value);
                if (type1 === "string" || type1 === "number") {
                    context = object2.node.value;
                    func = context[property2.node.name];
                }
            }
        }
        if (func) {
            var args = path.get("arguments").map(function(arg) {
                return evaluateCached(arg, state);
            });
            if (!state.confident) return;
            return func.apply(context, args);
        }
    }
    deopt(path, state);
}
function evaluateQuasis(path, quasis, state) {
    var raw = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    var str = "";
    var i = 0;
    var exprs = path.isTemplateLiteral() ? path.get("expressions") : path.get("quasi.expressions");
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = quasis[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var elem = _step.value;
            if (!state.confident) break;
            str += raw ? elem.value.raw : elem.value.cooked;
            var expr = exprs[i++];
            if (expr) str += String(evaluateCached(expr, state));
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    if (!state.confident) return;
    return str;
}
function evaluate() {
    var state = {
        confident: true,
        deoptPath: null,
        seen: /* @__PURE__ */ new Map()
    };
    var value1 = evaluateCached(this, state);
    if (!state.confident) value1 = void 0;
    return {
        confident: state.confident,
        deopt: state.deoptPath,
        value: value1
    };
}
var NodePath_evaluation = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    evaluate: evaluate,
    evaluateTruthy: evaluateTruthy
});
var arrowFunctionExpression$1 = lib_exports.arrowFunctionExpression, assignmentExpression$1 = lib_exports.assignmentExpression, binaryExpression2 = lib_exports.binaryExpression, blockStatement$1 = lib_exports.blockStatement, callExpression$1 = lib_exports.callExpression, conditionalExpression2 = lib_exports.conditionalExpression, expressionStatement$1 = lib_exports.expressionStatement, identifier6 = lib_exports.identifier, isIdentifier$22 = lib_exports.isIdentifier, jsxIdentifier2 = lib_exports.jsxIdentifier, logicalExpression2 = lib_exports.logicalExpression, LOGICAL_OPERATORS2 = lib_exports.LOGICAL_OPERATORS, memberExpression2 = lib_exports.memberExpression, metaProperty2 = lib_exports.metaProperty, numericLiteral$1 = lib_exports.numericLiteral, objectExpression2 = lib_exports.objectExpression, restElement2 = lib_exports.restElement, returnStatement2 = lib_exports.returnStatement, sequenceExpression2 = lib_exports.sequenceExpression, spreadElement2 = lib_exports.spreadElement, stringLiteral3 = lib_exports.stringLiteral, _super2 = lib_exports.super, thisExpression$1 = lib_exports.thisExpression, toExpression2 = lib_exports.toExpression, unaryExpression$1 = lib_exports.unaryExpression;
function toComputedKey2() {
    var key;
    if (this.isMemberExpression()) {
        key = this.node.property;
    } else if (this.isProperty() || this.isMethod()) {
        key = this.node.key;
    } else {
        throw new ReferenceError("todo");
    }
    if (!this.node.computed) {
        if (isIdentifier$22(key)) key = stringLiteral3(key.name);
    }
    return key;
}
function ensureBlock2() {
    var body = this.get("body");
    var bodyNode = body.node;
    if (Array.isArray(body)) {
        throw new Error("Can't convert array path to a block statement");
    }
    if (!bodyNode) {
        throw new Error("Can't convert node without a body");
    }
    if (body.isBlockStatement()) {
        return bodyNode;
    }
    var statements2 = [];
    var stringPath = "body";
    var key;
    var listKey;
    if (body.isStatement()) {
        listKey = "body";
        key = 0;
        statements2.push(body.node);
    } else {
        stringPath += ".body.0";
        if (this.isFunction()) {
            key = "argument";
            statements2.push(returnStatement2(body.node));
        } else {
            key = "expression";
            statements2.push(expressionStatement$1(body.node));
        }
    }
    this.node.body = blockStatement$1(statements2);
    var parentPath = this.get(stringPath);
    body.setup(parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key);
    return this.node;
}
function unwrapFunctionEnvironment() {
    if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
        throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
    }
    hoistFunctionEnvironment(this);
}
function setType(path, type) {
    path.node.type = type;
}
function arrowFunctionToExpression() {
    var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, _ref_allowInsertArrow = _ref.allowInsertArrow, allowInsertArrow = _ref_allowInsertArrow === void 0 ? true : _ref_allowInsertArrow, _ref_allowInsertArrowWithRest = _ref.allowInsertArrowWithRest, allowInsertArrowWithRest = _ref_allowInsertArrowWithRest === void 0 ? allowInsertArrow : _ref_allowInsertArrowWithRest, _ref_noNewArrows = _ref.noNewArrows, noNewArrows = _ref_noNewArrows === void 0 ? true : _ref_noNewArrows;
    if (!this.isArrowFunctionExpression()) {
        throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
    }
    var _hoistFunctionEnvironment = hoistFunctionEnvironment(this, noNewArrows, allowInsertArrow, allowInsertArrowWithRest), thisBinding = _hoistFunctionEnvironment.thisBinding, fn = _hoistFunctionEnvironment.fnPath;
    fn.ensureBlock();
    setType(fn, "FunctionExpression");
    if (!noNewArrows) {
        var checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");
        if (checkBinding) {
            fn.parentPath.scope.push({
                id: checkBinding,
                init: objectExpression2([])
            });
        }
        fn.get("body").unshiftContainer("body", expressionStatement$1(callExpression$1(this.hub.addHelper("newArrowCheck"), [
            thisExpression$1(),
            checkBinding ? identifier6(checkBinding.name) : identifier6(thisBinding)
        ])));
        fn.replaceWith(callExpression$1(memberExpression2(index2(this, true) || fn.node, identifier6("bind")), [
            checkBinding ? identifier6(checkBinding.name) : thisExpression$1()
        ]));
        return fn.get("callee.object");
    }
    return fn;
}
var getSuperCallsVisitor = merge2([
    {
        CallExpression: function CallExpression(child, param) {
            var allSuperCalls = param.allSuperCalls;
            if (!child.get("callee").isSuper()) return;
            allSuperCalls.push(child);
        }
    },
    visitor
]);
function hoistFunctionEnvironment(fnPath) {
    var noNewArrows = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, allowInsertArrow = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true, allowInsertArrowWithRest = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
    var arrowParent;
    var thisEnvFn = fnPath.findParent(function(p) {
        if (p.isArrowFunctionExpression()) {
            arrowParent !== null && arrowParent !== void 0 ? arrowParent : arrowParent = p;
            return false;
        }
        return p.isFunction() || p.isProgram() || p.isClassProperty({
            static: false
        }) || p.isClassPrivateProperty({
            static: false
        });
    });
    var inConstructor = thisEnvFn.isClassMethod({
        kind: "constructor"
    });
    if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
        if (arrowParent) {
            thisEnvFn = arrowParent;
        } else if (allowInsertArrow) {
            fnPath.replaceWith(callExpression$1(arrowFunctionExpression$1([], toExpression2(fnPath.node)), []));
            thisEnvFn = fnPath.get("callee");
            fnPath = thisEnvFn.get("body");
        } else {
            throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
        }
    }
    var _getScopeInformation = getScopeInformation(fnPath), thisPaths = _getScopeInformation.thisPaths, argumentsPaths = _getScopeInformation.argumentsPaths, newTargetPaths = _getScopeInformation.newTargetPaths, superProps = _getScopeInformation.superProps, superCalls = _getScopeInformation.superCalls;
    if (inConstructor && superCalls.length > 0) {
        if (!allowInsertArrow) {
            throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', it's not possible to compile `super()` in an arrow function without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
        }
        if (!allowInsertArrowWithRest) {
            throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-parameters', it's not possible to compile `super()` in an arrow function with default or rest parameters without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
        }
        var allSuperCalls = [];
        thisEnvFn.traverse(getSuperCallsVisitor, {
            allSuperCalls: allSuperCalls
        });
        var superBinding = getSuperBinding(thisEnvFn);
        allSuperCalls.forEach(function(superCall) {
            var callee = identifier6(superBinding);
            callee.loc = superCall.node.callee.loc;
            superCall.get("callee").replaceWith(callee);
        });
    }
    if (argumentsPaths.length > 0) {
        var argumentsBinding = getBinding(thisEnvFn, "arguments", function() {
            var args = function() {
                return identifier6("arguments");
            };
            if (thisEnvFn.scope.path.isProgram()) {
                return conditionalExpression2(binaryExpression2("===", unaryExpression$1("typeof", args()), stringLiteral3("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
            } else {
                return args();
            }
        });
        argumentsPaths.forEach(function(argumentsChild) {
            var argsRef = identifier6(argumentsBinding);
            argsRef.loc = argumentsChild.node.loc;
            argumentsChild.replaceWith(argsRef);
        });
    }
    if (newTargetPaths.length > 0) {
        var newTargetBinding = getBinding(thisEnvFn, "newtarget", function() {
            return metaProperty2(identifier6("new"), identifier6("target"));
        });
        newTargetPaths.forEach(function(targetChild) {
            var targetRef = identifier6(newTargetBinding);
            targetRef.loc = targetChild.node.loc;
            targetChild.replaceWith(targetRef);
        });
    }
    if (superProps.length > 0) {
        if (!allowInsertArrow) {
            throw superProps[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', it's not possible to compile `super.prop` in an arrow function without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
        }
        var flatSuperProps = superProps.reduce(function(acc, superProp) {
            return acc.concat(standardizeSuperProperty(superProp));
        }, []);
        flatSuperProps.forEach(function(superProp) {
            var key = superProp.node.computed ? "" : superProp.get("property").node.name;
            var superParentPath = superProp.parentPath;
            var isAssignment = superParentPath.isAssignmentExpression({
                left: superProp.node
            });
            var isCall = superParentPath.isCallExpression({
                callee: superProp.node
            });
            var isTaggedTemplate = superParentPath.isTaggedTemplateExpression({
                tag: superProp.node
            });
            var superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
            var args = [];
            if (superProp.node.computed) {
                args.push(superProp.get("property").node);
            }
            if (isAssignment) {
                var value1 = superParentPath.node.right;
                args.push(value1);
            }
            var call2 = callExpression$1(identifier6(superBinding), args);
            if (isCall) {
                superParentPath.unshiftContainer("arguments", thisExpression$1());
                superProp.replaceWith(memberExpression2(call2, identifier6("call")));
                thisPaths.push(superParentPath.get("arguments.0"));
            } else if (isAssignment) {
                superParentPath.replaceWith(call2);
            } else if (isTaggedTemplate) {
                superProp.replaceWith(callExpression$1(memberExpression2(call2, identifier6("bind"), false), [
                    thisExpression$1()
                ]));
                thisPaths.push(superProp.get("arguments.0"));
            } else {
                superProp.replaceWith(call2);
            }
        });
    }
    var thisBinding;
    if (thisPaths.length > 0 || !noNewArrows) {
        thisBinding = getThisBinding(thisEnvFn, inConstructor);
        if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
            thisPaths.forEach(function(thisChild) {
                var thisRef = thisChild.isJSX() ? jsxIdentifier2(thisBinding) : identifier6(thisBinding);
                thisRef.loc = thisChild.node.loc;
                thisChild.replaceWith(thisRef);
            });
            if (!noNewArrows) thisBinding = null;
        }
    }
    return {
        thisBinding: thisBinding,
        fnPath: fnPath
    };
}
function isLogicalOp(op) {
    return LOGICAL_OPERATORS2.includes(op);
}
function standardizeSuperProperty(superProp) {
    if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
        var assignmentPath = superProp.parentPath;
        var op = assignmentPath.node.operator.slice(0, -1);
        var value1 = assignmentPath.node.right;
        var isLogicalAssignment = isLogicalOp(op);
        if (superProp.node.computed) {
            var tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
            var object = superProp.node.object;
            var property = superProp.node.property;
            assignmentPath.get("left").replaceWith(memberExpression2(object, assignmentExpression$1("=", tmp, property), true));
            assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression2(object, identifier6(tmp.name), true), value1));
        } else {
            var object1 = superProp.node.object;
            var property1 = superProp.node.property;
            assignmentPath.get("left").replaceWith(memberExpression2(object1, property1));
            assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression2(object1, identifier6(property1.name)), value1));
        }
        if (isLogicalAssignment) {
            assignmentPath.replaceWith(logicalExpression2(op, assignmentPath.node.left, assignmentPath.node.right));
        } else {
            assignmentPath.node.operator = "=";
        }
        return [
            assignmentPath.get("left"),
            assignmentPath.get("right").get("left")
        ];
    } else if (superProp.parentPath.isUpdateExpression()) {
        var updateExpr = superProp.parentPath;
        var tmp1 = superProp.scope.generateDeclaredUidIdentifier("tmp");
        var computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
        var parts = [
            assignmentExpression$1("=", tmp1, memberExpression2(superProp.node.object, computedKey ? assignmentExpression$1("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)),
            assignmentExpression$1("=", memberExpression2(superProp.node.object, computedKey ? identifier6(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression2(superProp.parentPath.node.operator[0], identifier6(tmp1.name), numericLiteral$1(1)))
        ];
        if (!superProp.parentPath.node.prefix) {
            parts.push(identifier6(tmp1.name));
        }
        updateExpr.replaceWith(sequenceExpression2(parts));
        var left = updateExpr.get("expressions.0.right");
        var right = updateExpr.get("expressions.1.left");
        return [
            left,
            right
        ];
    }
    return [
        superProp
    ];
    function rightExpression(op, left, right) {
        if (op === "=") {
            return assignmentExpression$1("=", left, right);
        } else {
            return binaryExpression2(op, left, right);
        }
    }
}
function hasSuperClass(thisEnvFn) {
    return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
}
var assignSuperThisVisitor = merge2([
    {
        CallExpression: function CallExpression(child, param) {
            var supers = param.supers, thisBinding = param.thisBinding;
            if (!child.get("callee").isSuper()) return;
            if (supers.has(child.node)) return;
            supers.add(child.node);
            child.replaceWithMultiple([
                child.node,
                assignmentExpression$1("=", identifier6(thisBinding), identifier6("this"))
            ]);
        }
    },
    visitor
]);
function getThisBinding(thisEnvFn, inConstructor) {
    return getBinding(thisEnvFn, "this", function(thisBinding) {
        if (!inConstructor || !hasSuperClass(thisEnvFn)) return thisExpression$1();
        thisEnvFn.traverse(assignSuperThisVisitor, {
            supers: /* @__PURE__ */ new WeakSet(),
            thisBinding: thisBinding
        });
    });
}
function getSuperBinding(thisEnvFn) {
    return getBinding(thisEnvFn, "supercall", function() {
        var argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
        return arrowFunctionExpression$1([
            restElement2(argsBinding)
        ], callExpression$1(_super2(), [
            spreadElement2(identifier6(argsBinding.name))
        ]));
    });
}
function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
    var op = isAssignment ? "set" : "get";
    return getBinding(thisEnvFn, "superprop_".concat(op, ":").concat(propName || ""), function() {
        var argsList = [];
        var fnBody;
        if (propName) {
            fnBody = memberExpression2(_super2(), identifier6(propName));
        } else {
            var method = thisEnvFn.scope.generateUidIdentifier("prop");
            argsList.unshift(method);
            fnBody = memberExpression2(_super2(), identifier6(method.name), true);
        }
        if (isAssignment) {
            var valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
            argsList.push(valueIdent);
            fnBody = assignmentExpression$1("=", fnBody, identifier6(valueIdent.name));
        }
        return arrowFunctionExpression$1(argsList, fnBody);
    });
}
function getBinding(thisEnvFn, key, init) {
    var cacheKey = "binding:" + key;
    var data = thisEnvFn.getData(cacheKey);
    if (!data) {
        var id = thisEnvFn.scope.generateUidIdentifier(key);
        data = id.name;
        thisEnvFn.setData(cacheKey, data);
        thisEnvFn.scope.push({
            id: id,
            init: init(data)
        });
    }
    return data;
}
var getScopeInformationVisitor = merge2([
    {
        ThisExpression: function ThisExpression(child, param) {
            var thisPaths = param.thisPaths;
            thisPaths.push(child);
        },
        JSXIdentifier: function JSXIdentifier(child, param) {
            var thisPaths = param.thisPaths;
            if (child.node.name !== "this") return;
            if (!child.parentPath.isJSXMemberExpression({
                object: child.node
            }) && !child.parentPath.isJSXOpeningElement({
                name: child.node
            })) {
                return;
            }
            thisPaths.push(child);
        },
        CallExpression: function CallExpression(child, param) {
            var superCalls = param.superCalls;
            if (child.get("callee").isSuper()) superCalls.push(child);
        },
        MemberExpression: function MemberExpression(child, param) {
            var superProps = param.superProps;
            if (child.get("object").isSuper()) superProps.push(child);
        },
        Identifier: function Identifier(child, param) {
            var argumentsPaths = param.argumentsPaths;
            if (!child.isReferencedIdentifier({
                name: "arguments"
            })) return;
            var curr = child.scope;
            do {
                if (curr.hasOwnBinding("arguments")) {
                    curr.rename("arguments");
                    return;
                }
                if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
                    break;
                }
            }while (curr = curr.parent);
            argumentsPaths.push(child);
        },
        MetaProperty: function MetaProperty(child, param) {
            var newTargetPaths = param.newTargetPaths;
            if (!child.get("meta").isIdentifier({
                name: "new"
            })) return;
            if (!child.get("property").isIdentifier({
                name: "target"
            })) return;
            newTargetPaths.push(child);
        }
    },
    visitor
]);
function getScopeInformation(fnPath) {
    var thisPaths = [];
    var argumentsPaths = [];
    var newTargetPaths = [];
    var superProps = [];
    var superCalls = [];
    fnPath.traverse(getScopeInformationVisitor, {
        thisPaths: thisPaths,
        argumentsPaths: argumentsPaths,
        newTargetPaths: newTargetPaths,
        superProps: superProps,
        superCalls: superCalls
    });
    return {
        thisPaths: thisPaths,
        argumentsPaths: argumentsPaths,
        newTargetPaths: newTargetPaths,
        superProps: superProps,
        superCalls: superCalls
    };
}
var NodePath_conversion = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    arrowFunctionToExpression: arrowFunctionToExpression,
    ensureBlock: ensureBlock2,
    toComputedKey: toComputedKey2,
    unwrapFunctionEnvironment: unwrapFunctionEnvironment
});
var STATEMENT_OR_BLOCK_KEYS2 = lib_exports.STATEMENT_OR_BLOCK_KEYS, VISITOR_KEYS$3 = lib_exports.VISITOR_KEYS, isBlockStatement3 = lib_exports.isBlockStatement, isExpression$1 = lib_exports.isExpression, isIdentifier$12 = lib_exports.isIdentifier, isLiteral4 = lib_exports.isLiteral, isStringLiteral4 = lib_exports.isStringLiteral, isType3 = lib_exports.isType, _matchesPattern = lib_exports.matchesPattern;
function matchesPattern2(pattern, allowPartial) {
    return _matchesPattern(this.node, pattern, allowPartial);
}
function has2(key) {
    var val = this.node && this.node[key];
    if (val && Array.isArray(val)) {
        return !!val.length;
    } else {
        return !!val;
    }
}
function isStatic() {
    return this.scope.isStatic(this.node);
}
var is2 = has2;
function isnt(key) {
    return !this.has(key);
}
function equals(key, value1) {
    return this.node[key] === value1;
}
function isNodeType(type) {
    return isType3(this.type, type);
}
function canHaveVariableDeclarationOrExpression() {
    return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
}
function canSwapBetweenExpressionAndStatement(replacement) {
    if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
        return false;
    }
    if (this.isExpression()) {
        return isBlockStatement3(replacement);
    } else if (this.isBlockStatement()) {
        return isExpression$1(replacement);
    }
    return false;
}
function isCompletionRecord(allowInsideFunction) {
    var path = this;
    var first = true;
    do {
        var type = path.type, container = path.container;
        if (!first && (path.isFunction() || type === "StaticBlock")) {
            return !!allowInsideFunction;
        }
        first = false;
        if (Array.isArray(container) && path.key !== container.length - 1) {
            return false;
        }
    }while ((path = path.parentPath) && !path.isProgram() && !path.isDoExpression());
    return true;
}
function isStatementOrBlock() {
    if (this.parentPath.isLabeledStatement() || isBlockStatement3(this.container)) {
        return false;
    } else {
        return STATEMENT_OR_BLOCK_KEYS2.includes(this.key);
    }
}
function referencesImport(moduleSource, importName) {
    if (!this.isReferencedIdentifier()) {
        if (this.isJSXMemberExpression() && this.node.property.name === importName || (this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral4(this.node.property, {
            value: importName
        }) : this.node.property.name === importName)) {
            var object = this.get("object");
            return object.isReferencedIdentifier() && object.referencesImport(moduleSource, "*");
        }
        return false;
    }
    var binding = this.scope.getBinding(this.node.name);
    if (!binding || binding.kind !== "module") return false;
    var path = binding.path;
    var parent = path.parentPath;
    if (!parent.isImportDeclaration()) return false;
    if (parent.node.source.value === moduleSource) {
        if (!importName) return true;
    } else {
        return false;
    }
    if (path.isImportDefaultSpecifier() && importName === "default") {
        return true;
    }
    if (path.isImportNamespaceSpecifier() && importName === "*") {
        return true;
    }
    if (path.isImportSpecifier() && isIdentifier$12(path.node.imported, {
        name: importName
    })) {
        return true;
    }
    return false;
}
function getSource() {
    var node = this.node;
    if (node.end) {
        var code2 = this.hub.getCode();
        if (code2) return code2.slice(node.start, node.end);
    }
    return "";
}
function willIMaybeExecuteBefore(target) {
    return this._guessExecutionStatusRelativeTo(target) !== "after";
}
function getOuterFunction(path) {
    return path.isProgram() ? path : (path.parentPath.scope.getFunctionParent() || path.parentPath.scope.getProgramParent()).path;
}
function isExecutionUncertain(type, key) {
    switch(type){
        case "LogicalExpression":
            return key === "right";
        case "ConditionalExpression":
        case "IfStatement":
            return key === "consequent" || key === "alternate";
        case "WhileStatement":
        case "DoWhileStatement":
        case "ForInStatement":
        case "ForOfStatement":
            return key === "body";
        case "ForStatement":
            return key === "body" || key === "update";
        case "SwitchStatement":
            return key === "cases";
        case "TryStatement":
            return key === "handler";
        case "AssignmentPattern":
            return key === "right";
        case "OptionalMemberExpression":
            return key === "property";
        case "OptionalCallExpression":
            return key === "arguments";
        default:
            return false;
    }
}
function isExecutionUncertainInList(paths, maxIndex) {
    for(var i = 0; i < maxIndex; i++){
        var path = paths[i];
        if (isExecutionUncertain(path.parent.type, path.parentKey)) {
            return true;
        }
    }
    return false;
}
var SYMBOL_CHECKING = Symbol();
function _guessExecutionStatusRelativeTo(target) {
    return _guessExecutionStatusRelativeToCached(this, target, /* @__PURE__ */ new Map());
}
function _guessExecutionStatusRelativeToCached(base, target, cache2) {
    var funcParent = {
        this: getOuterFunction(base),
        target: getOuterFunction(target)
    };
    if (funcParent.target.node !== funcParent.this.node) {
        return _guessExecutionStatusRelativeToDifferentFunctionsCached(base, funcParent.target, cache2);
    }
    var paths = {
        target: target.getAncestry(),
        this: base.getAncestry()
    };
    if (paths.target.indexOf(base) >= 0) return "after";
    if (paths.this.indexOf(target) >= 0) return "before";
    var commonPath;
    var commonIndex = {
        target: 0,
        this: 0
    };
    while(!commonPath && commonIndex.this < paths.this.length){
        var path = paths.this[commonIndex.this];
        commonIndex.target = paths.target.indexOf(path);
        if (commonIndex.target >= 0) {
            commonPath = path;
        } else {
            commonIndex.this++;
        }
    }
    if (!commonPath) {
        throw new Error("Internal Babel error - The two compared nodes don't appear to belong to the same program.");
    }
    if (isExecutionUncertainInList(paths.this, commonIndex.this - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
        return "unknown";
    }
    var divergence = {
        this: paths.this[commonIndex.this - 1],
        target: paths.target[commonIndex.target - 1]
    };
    if (divergence.target.listKey && divergence.this.listKey && divergence.target.container === divergence.this.container) {
        return divergence.target.key > divergence.this.key ? "before" : "after";
    }
    var keys = VISITOR_KEYS$3[commonPath.type];
    var keyPosition = {
        this: keys.indexOf(divergence.this.parentKey),
        target: keys.indexOf(divergence.target.parentKey)
    };
    return keyPosition.target > keyPosition.this ? "before" : "after";
}
function _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache2) {
    if (!target.isFunctionDeclaration()) {
        if (_guessExecutionStatusRelativeToCached(base, target, cache2) === "before") {
            return "before";
        }
        return "unknown";
    } else if (target.parentPath.isExportDeclaration()) {
        return "unknown";
    }
    var binding = target.scope.getBinding(target.node.id.name);
    if (!binding.references) return "before";
    var referencePaths = binding.referencePaths;
    var allStatus;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = referencePaths[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var path = _step.value;
            var childOfFunction = !!path.find(function(path2) {
                return path2.node === target.node;
            });
            if (childOfFunction) continue;
            if (path.key !== "callee" || !path.parentPath.isCallExpression()) {
                return "unknown";
            }
            var status = _guessExecutionStatusRelativeToCached(base, path, cache2);
            if (allStatus && allStatus !== status) {
                return "unknown";
            } else {
                allStatus = status;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return allStatus;
}
function _guessExecutionStatusRelativeToDifferentFunctionsCached(base, target, cache2) {
    var nodeMap = cache2.get(base.node);
    var cached;
    if (!nodeMap) {
        cache2.set(base.node, nodeMap = /* @__PURE__ */ new Map());
    } else if (cached = nodeMap.get(target.node)) {
        if (cached === SYMBOL_CHECKING) {
            return "unknown";
        }
        return cached;
    }
    nodeMap.set(target.node, SYMBOL_CHECKING);
    var result = _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache2);
    nodeMap.set(target.node, result);
    return result;
}
function resolve3(dangerous, resolved) {
    return this._resolve(dangerous, resolved) || this;
}
function _resolve(dangerous, resolved) {
    if (resolved && resolved.indexOf(this) >= 0) return;
    resolved = resolved || [];
    resolved.push(this);
    if (this.isVariableDeclarator()) {
        if (this.get("id").isIdentifier()) {
            return this.get("init").resolve(dangerous, resolved);
        }
    } else if (this.isReferencedIdentifier()) {
        var binding = this.scope.getBinding(this.node.name);
        if (!binding) return;
        if (!binding.constant) return;
        if (binding.kind === "module") return;
        if (binding.path !== this) {
            var ret = binding.path.resolve(dangerous, resolved);
            if (this.find(function(parent) {
                return parent.node === ret.node;
            })) return;
            return ret;
        }
    } else if (this.isTypeCastExpression()) {
        return this.get("expression").resolve(dangerous, resolved);
    } else if (dangerous && this.isMemberExpression()) {
        var targetKey = this.toComputedKey();
        if (!isLiteral4(targetKey)) return;
        var targetName = targetKey.value;
        var target = this.get("object").resolve(dangerous, resolved);
        if (target.isObjectExpression()) {
            var props = target.get("properties");
            var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
            try {
                for(var _iterator = props[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                    var prop = _step.value;
                    if (!prop.isProperty()) continue;
                    var key = prop.get("key");
                    var match = prop.isnt("computed") && key.isIdentifier({
                        name: targetName
                    });
                    match = match || key.isLiteral({
                        value: targetName
                    });
                    if (match) return prop.get("value").resolve(dangerous, resolved);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                } finally{
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        } else if (target.isArrayExpression() && !isNaN(+targetName)) {
            var elems = target.get("elements");
            var elem = elems[targetName];
            if (elem) return elem.resolve(dangerous, resolved);
        }
    }
}
function isConstantExpression() {
    if (this.isIdentifier()) {
        var binding = this.scope.getBinding(this.node.name);
        if (!binding) return false;
        return binding.constant;
    }
    if (this.isLiteral()) {
        if (this.isRegExpLiteral()) {
            return false;
        }
        if (this.isTemplateLiteral()) {
            return this.get("expressions").every(function(expression2) {
                return expression2.isConstantExpression();
            });
        }
        return true;
    }
    if (this.isUnaryExpression()) {
        if (this.node.operator !== "void") {
            return false;
        }
        return this.get("argument").isConstantExpression();
    }
    if (this.isBinaryExpression()) {
        var operator = this.node.operator;
        return operator !== "in" && operator !== "instanceof" && this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
    }
    return false;
}
function isInStrictMode() {
    var start = this.isProgram() ? this : this.parentPath;
    var strictParent = start.find(function(path) {
        if (path.isProgram({
            sourceType: "module"
        })) return true;
        if (path.isClass()) return true;
        if (path.isArrowFunctionExpression() && !path.get("body").isBlockStatement()) {
            return false;
        }
        var body;
        if (path.isFunction()) {
            body = path.node.body;
        } else if (path.isProgram()) {
            body = path.node;
        } else {
            return false;
        }
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = body.directives[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var directive2 = _step.value;
                if (directive2.value.value === "use strict") {
                    return true;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    });
    return !!strictParent;
}
var NodePath_introspection = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _guessExecutionStatusRelativeTo: _guessExecutionStatusRelativeTo,
    _resolve: _resolve,
    canHaveVariableDeclarationOrExpression: canHaveVariableDeclarationOrExpression,
    canSwapBetweenExpressionAndStatement: canSwapBetweenExpressionAndStatement,
    equals: equals,
    getSource: getSource,
    has: has2,
    is: is2,
    isCompletionRecord: isCompletionRecord,
    isConstantExpression: isConstantExpression,
    isInStrictMode: isInStrictMode,
    isNodeType: isNodeType,
    isStatementOrBlock: isStatementOrBlock,
    isStatic: isStatic,
    isnt: isnt,
    matchesPattern: matchesPattern2,
    referencesImport: referencesImport,
    resolve: resolve3,
    willIMaybeExecuteBefore: willIMaybeExecuteBefore
});
function call(key) {
    var opts = this.opts;
    this.debug(key);
    if (this.node) {
        if (this._call(opts[key])) return true;
    }
    if (this.node) {
        var _opts_this_node_type;
        return this._call((_opts_this_node_type = opts[this.node.type]) === null || _opts_this_node_type === void 0 ? void 0 : _opts_this_node_type[key]);
    }
    return false;
}
function _call(fns) {
    if (!fns) return false;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = fns[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var fn = _step.value;
            if (!fn) continue;
            var node = this.node;
            if (!node) return true;
            var ret = fn.call(this.state, this, this.state);
            if (ret && typeof ret === "object" && typeof ret.then === "function") {
                throw new Error("You appear to be using a plugin with an async traversal visitor, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.");
            }
            if (ret) {
                throw new Error("Unexpected return value from visitor method ".concat(fn));
            }
            if (this.node !== node) return true;
            if (this._traverseFlags > 0) return true;
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return false;
}
function isDenylisted() {
    var _this_opts_denylist;
    var denylist = (_this_opts_denylist = this.opts.denylist) !== null && _this_opts_denylist !== void 0 ? _this_opts_denylist : this.opts.blacklist;
    return denylist && denylist.indexOf(this.node.type) > -1;
}
function restoreContext(path, context) {
    if (path.context !== context) {
        path.context = context;
        path.state = context.state;
        path.opts = context.opts;
    }
}
function visit2() {
    var _this_opts_shouldSkip, _this_opts;
    if (!this.node) {
        return false;
    }
    if (this.isDenylisted()) {
        return false;
    }
    if ((_this_opts_shouldSkip = (_this_opts = this.opts).shouldSkip) === null || _this_opts_shouldSkip === void 0 ? void 0 : _this_opts_shouldSkip.call(_this_opts, this)) {
        return false;
    }
    var currentContext = this.context;
    if (this.shouldSkip || this.call("enter")) {
        this.debug("Skip...");
        return this.shouldStop;
    }
    restoreContext(this, currentContext);
    this.debug("Recursing into...");
    this.shouldStop = traverseNode(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
    restoreContext(this, currentContext);
    this.call("exit");
    return this.shouldStop;
}
function skip() {
    this.shouldSkip = true;
}
function skipKey(key) {
    if (this.skipKeys == null) {
        this.skipKeys = {};
    }
    this.skipKeys[key] = true;
}
function stop() {
    this._traverseFlags |= SHOULD_SKIP | SHOULD_STOP;
}
function setScope() {
    var _this_opts, _this_scope;
    if ((_this_opts = this.opts) === null || _this_opts === void 0 ? void 0 : _this_opts.noScope) return;
    var path = this.parentPath;
    if ((this.key === "key" || this.listKey === "decorators") && path.isMethod() || this.key === "discriminant" && path.isSwitchStatement()) {
        path = path.parentPath;
    }
    var target;
    while(path && !target){
        var _path_opts;
        if ((_path_opts = path.opts) === null || _path_opts === void 0 ? void 0 : _path_opts.noScope) return;
        target = path.scope;
        path = path.parentPath;
    }
    this.scope = this.getScope(target);
    (_this_scope = this.scope) === null || _this_scope === void 0 ? void 0 : _this_scope.init();
}
function setContext(context) {
    if (this.skipKeys != null) {
        this.skipKeys = {};
    }
    this._traverseFlags = 0;
    if (context) {
        this.context = context;
        this.state = context.state;
        this.opts = context.opts;
    }
    this.setScope();
    return this;
}
function resync() {
    if (this.removed) return;
    this._resyncParent();
    this._resyncList();
    this._resyncKey();
}
function _resyncParent() {
    if (this.parentPath) {
        this.parent = this.parentPath.node;
    }
}
function _resyncKey() {
    if (!this.container) return;
    if (this.node === this.container[this.key]) {
        return;
    }
    if (Array.isArray(this.container)) {
        for(var i = 0; i < this.container.length; i++){
            if (this.container[i] === this.node) {
                this.setKey(i);
                return;
            }
        }
    } else {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = Object.keys(this.container)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var key = _step.value;
                if (this.container[key] === this.node) {
                    this.setKey(key);
                    return;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    this.key = null;
}
function _resyncList() {
    if (!this.parent || !this.inList) return;
    var newContainer = this.parent[this.listKey];
    if (this.container === newContainer) return;
    this.container = newContainer || null;
}
function _resyncRemoved() {
    if (this.key == null || !this.container || this.container[this.key] !== this.node) {
        this._markRemoved();
    }
}
function popContext() {
    this.contexts.pop();
    if (this.contexts.length > 0) {
        this.setContext(this.contexts[this.contexts.length - 1]);
    } else {
        this.setContext(void 0);
    }
}
function pushContext(context) {
    this.contexts.push(context);
    this.setContext(context);
}
function setup(parentPath, container, listKey, key) {
    this.listKey = listKey;
    this.container = container;
    this.parentPath = parentPath || this.parentPath;
    this.setKey(key);
}
function setKey(key) {
    var _this_node;
    this.key = key;
    this.node = this.container[this.key];
    this.type = (_this_node = this.node) === null || _this_node === void 0 ? void 0 : _this_node.type;
}
function requeue() {
    var pathToQueue = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this;
    if (pathToQueue.removed) return;
    {
        pathToQueue.shouldSkip = false;
    }
    var contexts = this.contexts;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = contexts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var context = _step.value;
            context.maybeQueue(pathToQueue);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}
function _getQueueContexts() {
    var path = this;
    var contexts = this.contexts;
    while(!contexts.length){
        path = path.parentPath;
        if (!path) break;
        contexts = path.contexts;
    }
    return contexts;
}
var NodePath_context = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _call: _call,
    _getQueueContexts: _getQueueContexts,
    _resyncKey: _resyncKey,
    _resyncList: _resyncList,
    _resyncParent: _resyncParent,
    _resyncRemoved: _resyncRemoved,
    call: call,
    isBlacklisted: isDenylisted,
    isDenylisted: isDenylisted,
    popContext: popContext,
    pushContext: pushContext,
    requeue: requeue,
    resync: resync,
    setContext: setContext,
    setKey: setKey,
    setScope: setScope,
    setup: setup,
    skip: skip,
    skipKey: skipKey,
    stop: stop,
    visit: visit2
});
var hooks = [
    function(self, parent) {
        var removeParent = self.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self.key === "declaration" && parent.isExportDeclaration() || self.key === "body" && parent.isLabeledStatement() || self.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self.key === "expression" && parent.isExpressionStatement();
        if (removeParent) {
            parent.remove();
            return true;
        }
    },
    function(self, parent) {
        if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
            parent.replaceWith(parent.node.expressions[0]);
            return true;
        }
    },
    function(self, parent) {
        if (parent.isBinary()) {
            if (self.key === "left") {
                parent.replaceWith(parent.node.right);
            } else {
                parent.replaceWith(parent.node.left);
            }
            return true;
        }
    },
    function(self, parent) {
        if (parent.isIfStatement() && self.key === "consequent" || self.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
            self.replaceWith({
                type: "BlockStatement",
                body: []
            });
            return true;
        }
    }
];
var getBindingIdentifiers$1 = lib_exports.getBindingIdentifiers;
function remove() {
    var _this_opts;
    this._assertUnremoved();
    this.resync();
    if (!((_this_opts = this.opts) === null || _this_opts === void 0 ? void 0 : _this_opts.noScope)) {
        this._removeFromScope();
    }
    if (this._callRemovalHooks()) {
        this._markRemoved();
        return;
    }
    this.shareCommentsWithSiblings();
    this._remove();
    this._markRemoved();
}
function _removeFromScope() {
    var _this = this;
    var bindings = getBindingIdentifiers$1(this.node, false, false, true);
    Object.keys(bindings).forEach(function(name) {
        return _this.scope.removeBinding(name);
    });
}
function _callRemovalHooks() {
    if (this.parentPath) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = hooks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var fn = _step.value;
                if (fn(this, this.parentPath)) return true;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
}
function _remove() {
    if (Array.isArray(this.container)) {
        this.container.splice(this.key, 1);
        this.updateSiblingKeys(this.key, -1);
    } else {
        this._replaceWith(null);
    }
}
function _markRemoved() {
    this._traverseFlags |= SHOULD_SKIP | REMOVED;
    if (this.parent) {
        getCachedPaths(this.hub, this.parent).delete(this.node);
    }
    this.node = null;
}
function _assertUnremoved() {
    if (this.removed) {
        throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
    }
}
var NodePath_removal = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _assertUnremoved: _assertUnremoved,
    _callRemovalHooks: _callRemovalHooks,
    _markRemoved: _markRemoved,
    _remove: _remove,
    _removeFromScope: _removeFromScope,
    remove: remove
});
var react2 = lib_exports.react;
var cloneNode$1 = lib_exports.cloneNode, jsxExpressionContainer2 = lib_exports.jsxExpressionContainer, variableDeclaration3 = lib_exports.variableDeclaration, variableDeclarator3 = lib_exports.variableDeclarator;
var referenceVisitor = {
    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
        if (path.isJSXIdentifier() && react2.isCompatTag(path.node.name) && !path.parentPath.isJSXMemberExpression()) {
            return;
        }
        if (path.node.name === "this") {
            var scope2 = path.scope;
            do {
                if (scope2.path.isFunction() && !scope2.path.isArrowFunctionExpression()) {
                    break;
                }
            }while (scope2 = scope2.parent);
            if (scope2) state.breakOnScopePaths.push(scope2.path);
        }
        var binding = path.scope.getBinding(path.node.name);
        if (!binding) return;
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = binding.constantViolations[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var violation = _step.value;
                if (violation.scope !== binding.path.scope) {
                    state.mutableBinding = true;
                    path.stop();
                    return;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        if (binding !== state.scope.getBinding(path.node.name)) return;
        state.bindings[path.node.name] = binding;
    }
};
var PathHoister = /*#__PURE__*/ function() {
    "use strict";
    function PathHoister(path, scope2) {
        _class_call_check(this, PathHoister);
        __publicField(this, "breakOnScopePaths");
        __publicField(this, "bindings");
        __publicField(this, "mutableBinding");
        __publicField(this, "scopes");
        __publicField(this, "scope");
        __publicField(this, "path");
        __publicField(this, "attachAfter");
        this.breakOnScopePaths = [];
        this.bindings = {};
        this.mutableBinding = false;
        this.scopes = [];
        this.scope = scope2;
        this.path = path;
        this.attachAfter = false;
    }
    _create_class(PathHoister, [
        {
            key: "isCompatibleScope",
            value: function isCompatibleScope(scope2) {
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = Object.keys(this.bindings)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var key = _step.value;
                        var binding = this.bindings[key];
                        if (!scope2.bindingIdentifierEquals(key, binding.identifier)) {
                            return false;
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return true;
            }
        },
        {
            key: "getCompatibleScopes",
            value: function getCompatibleScopes() {
                var scope2 = this.path.scope;
                do {
                    if (this.isCompatibleScope(scope2)) {
                        this.scopes.push(scope2);
                    } else {
                        break;
                    }
                    if (this.breakOnScopePaths.indexOf(scope2.path) >= 0) {
                        break;
                    }
                }while (scope2 = scope2.parent);
            }
        },
        {
            key: "getAttachmentPath",
            value: function getAttachmentPath() {
                var path = this._getAttachmentPath();
                if (!path) return;
                var targetScope = path.scope;
                if (targetScope.path === path) {
                    targetScope = path.scope.parent;
                }
                if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
                    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(var _iterator = Object.keys(this.bindings)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            var name = _step.value;
                            if (!targetScope.hasOwnBinding(name)) continue;
                            var binding = this.bindings[name];
                            if (binding.kind === "param" || binding.path.parentKey === "params") {
                                continue;
                            }
                            var bindingParentPath = this.getAttachmentParentForPath(binding.path);
                            if (bindingParentPath.key >= path.key) {
                                this.attachAfter = true;
                                path = binding.path;
                                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                                try {
                                    for(var _iterator1 = binding.constantViolations[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                        var violationPath = _step1.value;
                                        if (this.getAttachmentParentForPath(violationPath).key > path.key) {
                                            path = violationPath;
                                        }
                                    }
                                } catch (err) {
                                    _didIteratorError1 = true;
                                    _iteratorError1 = err;
                                } finally{
                                    try {
                                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                            _iterator1.return();
                                        }
                                    } finally{
                                        if (_didIteratorError1) {
                                            throw _iteratorError1;
                                        }
                                    }
                                }
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                }
                return path;
            }
        },
        {
            key: "_getAttachmentPath",
            value: function _getAttachmentPath() {
                var scopes = this.scopes;
                var scope2 = scopes.pop();
                if (!scope2) return;
                if (scope2.path.isFunction()) {
                    if (this.hasOwnParamBindings(scope2)) {
                        if (this.scope === scope2) return;
                        var bodies = scope2.path.get("body").get("body");
                        for(var i = 0; i < bodies.length; i++){
                            if (bodies[i].node._blockHoist) continue;
                            return bodies[i];
                        }
                    } else {
                        return this.getNextScopeAttachmentParent();
                    }
                } else if (scope2.path.isProgram()) {
                    return this.getNextScopeAttachmentParent();
                }
            }
        },
        {
            key: "getNextScopeAttachmentParent",
            value: function getNextScopeAttachmentParent() {
                var scope2 = this.scopes.pop();
                if (scope2) return this.getAttachmentParentForPath(scope2.path);
            }
        },
        {
            key: "getAttachmentParentForPath",
            value: function getAttachmentParentForPath(path) {
                do {
                    if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
                        return path;
                    }
                }while (path = path.parentPath);
            }
        },
        {
            key: "hasOwnParamBindings",
            value: function hasOwnParamBindings(scope2) {
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = Object.keys(this.bindings)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var name = _step.value;
                        if (!scope2.hasOwnBinding(name)) continue;
                        var binding = this.bindings[name];
                        if (binding.kind === "param" && binding.constant) return true;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return false;
            }
        },
        {
            key: "run",
            value: function run() {
                this.path.traverse(referenceVisitor, this);
                if (this.mutableBinding) return;
                this.getCompatibleScopes();
                var attachTo = this.getAttachmentPath();
                if (!attachTo) return;
                if (attachTo.getFunctionParent() === this.path.getFunctionParent()) return;
                var uid2 = attachTo.scope.generateUidIdentifier("ref");
                var declarator = variableDeclarator3(uid2, this.path.node);
                var insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
                var _attachTo_insertFn = _sliced_to_array(attachTo[insertFn]([
                    attachTo.isVariableDeclarator() ? declarator : variableDeclaration3("var", [
                        declarator
                    ])
                ]), 1), attached = _attachTo_insertFn[0];
                var parent = this.path.parentPath;
                if (parent.isJSXElement() && this.path.container === parent.node.children) {
                    uid2 = jsxExpressionContainer2(uid2);
                }
                this.path.replaceWith(cloneNode$1(uid2));
                return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
            }
        }
    ]);
    return PathHoister;
}();
var arrowFunctionExpression2 = lib_exports.arrowFunctionExpression, assertExpression2 = lib_exports.assertExpression, assignmentExpression3 = lib_exports.assignmentExpression, blockStatement3 = lib_exports.blockStatement, callExpression2 = lib_exports.callExpression, cloneNode5 = lib_exports.cloneNode, expressionStatement4 = lib_exports.expressionStatement, isAssignmentExpression4 = lib_exports.isAssignmentExpression, isCallExpression4 = lib_exports.isCallExpression, isExportNamedDeclaration3 = lib_exports.isExportNamedDeclaration, isExpression2 = lib_exports.isExpression, isIdentifier5 = lib_exports.isIdentifier, isSequenceExpression2 = lib_exports.isSequenceExpression, isSuper2 = lib_exports.isSuper, thisExpression2 = lib_exports.thisExpression;
function insertBefore(nodes_) {
    this._assertUnremoved();
    var nodes2 = this._verifyNodeList(nodes_);
    var _this = this, parentPath = _this.parentPath, parent = _this.parent;
    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration3(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
        return parentPath.insertBefore(nodes2);
    } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
        if (this.node) nodes2.push(this.node);
        return this.replaceExpressionWithStatements(nodes2);
    } else if (Array.isArray(this.container)) {
        return this._containerInsertBefore(nodes2);
    } else if (this.isStatementOrBlock()) {
        var node = this.node;
        var shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
        this.replaceWith(blockStatement3(shouldInsertCurrentNode ? [
            node
        ] : []));
        return this.unshiftContainer("body", nodes2);
    } else {
        throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
    }
}
function _containerInsert(from, nodes2) {
    var _this_container;
    this.updateSiblingKeys(from, nodes2.length);
    var paths = [];
    (_this_container = this.container).splice.apply(_this_container, [
        from,
        0
    ].concat(_to_consumable_array(nodes2)));
    for(var i = 0; i < nodes2.length; i++){
        var _this_context;
        var to = from + i;
        var path = this.getSibling(to);
        paths.push(path);
        if ((_this_context = this.context) === null || _this_context === void 0 ? void 0 : _this_context.queue) {
            path.pushContext(this.context);
        }
    }
    var contexts = this._getQueueContexts();
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = paths[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var path1 = _step.value;
            path1.setScope();
            path1.debug("Inserted.");
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                for(var _iterator1 = contexts[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var context = _step1.value;
                    context.maybeQueue(path1, true);
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return paths;
}
function _containerInsertBefore(nodes2) {
    return this._containerInsert(this.key, nodes2);
}
function _containerInsertAfter(nodes2) {
    return this._containerInsert(this.key + 1, nodes2);
}
var last = function(arr) {
    return arr[arr.length - 1];
};
function isHiddenInSequenceExpression(path) {
    return isSequenceExpression2(path.parent) && (last(path.parent.expressions) !== path.node || isHiddenInSequenceExpression(path.parentPath));
}
function isAlmostConstantAssignment(node, scope2) {
    if (!isAssignmentExpression4(node) || !isIdentifier5(node.left)) {
        return false;
    }
    var blockScope = scope2.getBlockParent();
    return blockScope.hasOwnBinding(node.left.name) && blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1;
}
function insertAfter(nodes_) {
    this._assertUnremoved();
    if (this.isSequenceExpression()) {
        return last(this.get("expressions")).insertAfter(nodes_);
    }
    var nodes2 = this._verifyNodeList(nodes_);
    var _this = this, parentPath = _this.parentPath, parent = _this.parent;
    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration3(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
        return parentPath.insertAfter(nodes2.map(function(node) {
            return isExpression2(node) ? expressionStatement4(node) : node;
        }));
    } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
        if (this.node) {
            var node = this.node;
            var _this1 = this, scope2 = _this1.scope;
            if (scope2.path.isPattern()) {
                assertExpression2(node);
                this.replaceWith(callExpression2(arrowFunctionExpression2([], node), []));
                this.get("callee.body").insertAfter(nodes2);
                return [
                    this
                ];
            }
            if (isHiddenInSequenceExpression(this)) {
                nodes2.unshift(node);
            } else if (isCallExpression4(node) && isSuper2(node.callee)) {
                nodes2.unshift(node);
                nodes2.push(thisExpression2());
            } else if (isAlmostConstantAssignment(node, scope2)) {
                nodes2.unshift(node);
                nodes2.push(cloneNode5(node.left));
            } else if (scope2.isPure(node, true)) {
                nodes2.push(node);
            } else {
                if (parentPath.isMethod({
                    computed: true,
                    key: node
                })) {
                    scope2 = scope2.parent;
                }
                var temp = scope2.generateDeclaredUidIdentifier();
                nodes2.unshift(expressionStatement4(assignmentExpression3("=", cloneNode5(temp), node)));
                nodes2.push(expressionStatement4(cloneNode5(temp)));
            }
        }
        return this.replaceExpressionWithStatements(nodes2);
    } else if (Array.isArray(this.container)) {
        return this._containerInsertAfter(nodes2);
    } else if (this.isStatementOrBlock()) {
        var node1 = this.node;
        var shouldInsertCurrentNode = node1 && (!this.isExpressionStatement() || node1.expression != null);
        this.replaceWith(blockStatement3(shouldInsertCurrentNode ? [
            node1
        ] : []));
        return this.pushContainer("body", nodes2);
    } else {
        throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
    }
}
function updateSiblingKeys(fromIndex, incrementBy) {
    if (!this.parent) return;
    var paths = getCachedPaths(this.hub, this.parent) || [];
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = paths[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var _step_value = _sliced_to_array(_step.value, 2), path = _step_value[1];
            if (typeof path.key === "number" && path.key >= fromIndex) {
                path.key += incrementBy;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}
function _verifyNodeList(nodes2) {
    if (!nodes2) {
        return [];
    }
    if (!Array.isArray(nodes2)) {
        nodes2 = [
            nodes2
        ];
    }
    for(var i = 0; i < nodes2.length; i++){
        var node = nodes2[i];
        var msg = void 0;
        if (!node) {
            msg = "has falsy node";
        } else if (typeof node !== "object") {
            msg = "contains a non-object node";
        } else if (!node.type) {
            msg = "without a type";
        } else if (_instanceof(node, NodePath)) {
            msg = "has a NodePath when it expected a raw object";
        }
        if (msg) {
            var type = Array.isArray(node) ? "array" : typeof node === "undefined" ? "undefined" : _type_of(node);
            throw new Error("Node list ".concat(msg, " with the index of ").concat(i, " and type of ").concat(type));
        }
    }
    return nodes2;
}
function unshiftContainer(listKey, nodes2) {
    this._assertUnremoved();
    nodes2 = this._verifyNodeList(nodes2);
    var path = NodePath.get({
        parentPath: this,
        parent: this.node,
        container: this.node[listKey],
        listKey: listKey,
        key: 0
    }).setContext(this.context);
    return path._containerInsertBefore(nodes2);
}
function pushContainer(listKey, nodes2) {
    this._assertUnremoved();
    var verifiedNodes = this._verifyNodeList(nodes2);
    var container = this.node[listKey];
    var path = NodePath.get({
        parentPath: this,
        parent: this.node,
        container: container,
        listKey: listKey,
        key: container.length
    }).setContext(this.context);
    return path.replaceWithMultiple(verifiedNodes);
}
function hoist() {
    var scope2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.scope;
    var hoister = new PathHoister(this, scope2);
    return hoister.run();
}
var NodePath_modification = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _containerInsert: _containerInsert,
    _containerInsertAfter: _containerInsertAfter,
    _containerInsertBefore: _containerInsertBefore,
    _verifyNodeList: _verifyNodeList,
    hoist: hoist,
    insertAfter: insertAfter,
    insertBefore: insertBefore,
    pushContainer: pushContainer,
    unshiftContainer: unshiftContainer,
    updateSiblingKeys: updateSiblingKeys
});
var _getBindingIdentifiers = lib_exports.getBindingIdentifiers, _getOuterBindingIdentifiers = lib_exports.getOuterBindingIdentifiers, isDeclaration2 = lib_exports.isDeclaration, numericLiteral2 = lib_exports.numericLiteral, unaryExpression2 = lib_exports.unaryExpression;
var NORMAL_COMPLETION = 0;
var BREAK_COMPLETION = 1;
function NormalCompletion(path) {
    return {
        type: NORMAL_COMPLETION,
        path: path
    };
}
function BreakCompletion(path) {
    return {
        type: BREAK_COMPLETION,
        path: path
    };
}
function getOpposite() {
    if (this.key === "left") {
        return this.getSibling("right");
    } else if (this.key === "right") {
        return this.getSibling("left");
    }
    return null;
}
function addCompletionRecords(path, records, context) {
    if (path) {
        var _records;
        (_records = records).push.apply(_records, _to_consumable_array(_getCompletionRecords(path, context)));
    }
    return records;
}
function completionRecordForSwitch(cases, records, context) {
    var _records;
    var lastNormalCompletions = [];
    for(var i = 0; i < cases.length; i++){
        var _records1;
        var casePath = cases[i];
        var caseCompletions = _getCompletionRecords(casePath, context);
        var normalCompletions = [];
        var breakCompletions = [];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = caseCompletions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var c = _step.value;
                if (c.type === NORMAL_COMPLETION) {
                    normalCompletions.push(c);
                }
                if (c.type === BREAK_COMPLETION) {
                    breakCompletions.push(c);
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        if (normalCompletions.length) {
            lastNormalCompletions = normalCompletions;
        }
        (_records1 = records).push.apply(_records1, _to_consumable_array(breakCompletions));
    }
    (_records = records).push.apply(_records, _to_consumable_array(lastNormalCompletions));
    return records;
}
function normalCompletionToBreak(completions) {
    completions.forEach(function(c) {
        c.type = BREAK_COMPLETION;
    });
}
function replaceBreakStatementInBreakCompletion(completions, reachable) {
    completions.forEach(function(c) {
        if (c.path.isBreakStatement({
            label: null
        })) {
            if (reachable) {
                c.path.replaceWith(unaryExpression2("void", numericLiteral2(0)));
            } else {
                c.path.remove();
            }
        }
    });
}
function getStatementListCompletion(paths, context) {
    var completions = [];
    if (context.canHaveBreak) {
        var _loop = function(i) {
            var path = paths[i];
            var newContext = Object.assign({}, context, {
                inCaseClause: false
            });
            if (path.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
                newContext.shouldPopulateBreak = true;
            } else {
                newContext.shouldPopulateBreak = false;
            }
            var statementCompletions = _getCompletionRecords(path, newContext);
            if (statementCompletions.length > 0 && statementCompletions.every(function(c) {
                return c.type === BREAK_COMPLETION;
            })) {
                if (lastNormalCompletions.length > 0 && statementCompletions.every(function(c) {
                    return c.path.isBreakStatement({
                        label: null
                    });
                })) {
                    var _completions;
                    normalCompletionToBreak(lastNormalCompletions);
                    (_completions = completions).push.apply(_completions, _to_consumable_array(lastNormalCompletions));
                    if (lastNormalCompletions.some(function(c) {
                        return c.path.isDeclaration();
                    })) {
                        var _completions1;
                        (_completions1 = completions).push.apply(_completions1, _to_consumable_array(statementCompletions));
                        replaceBreakStatementInBreakCompletion(statementCompletions, true);
                    }
                    replaceBreakStatementInBreakCompletion(statementCompletions, false);
                } else {
                    var _completions2;
                    (_completions2 = completions).push.apply(_completions2, _to_consumable_array(statementCompletions));
                    if (!context.shouldPopulateBreak) {
                        replaceBreakStatementInBreakCompletion(statementCompletions, true);
                    }
                }
                return "break";
            }
            if (i === paths.length - 1) {
                var _completions3;
                (_completions3 = completions).push.apply(_completions3, _to_consumable_array(statementCompletions));
            } else {
                lastNormalCompletions = [];
                for(var i2 = 0; i2 < statementCompletions.length; i2++){
                    var c = statementCompletions[i2];
                    if (c.type === BREAK_COMPLETION) {
                        completions.push(c);
                    }
                    if (c.type === NORMAL_COMPLETION) {
                        lastNormalCompletions.push(c);
                    }
                }
            }
        };
        var lastNormalCompletions = [];
        for(var i = 0; i < paths.length; i++){
            var _ret = _loop(i);
            if (_ret === "break") break;
        }
    } else if (paths.length) {
        for(var i1 = paths.length - 1; i1 >= 0; i1--){
            var pathCompletions = _getCompletionRecords(paths[i1], context);
            if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
                var _completions;
                (_completions = completions).push.apply(_completions, _to_consumable_array(pathCompletions));
                break;
            }
        }
    }
    return completions;
}
function _getCompletionRecords(path, context) {
    var records = [];
    if (path.isIfStatement()) {
        records = addCompletionRecords(path.get("consequent"), records, context);
        records = addCompletionRecords(path.get("alternate"), records, context);
    } else if (path.isDoExpression() || path.isFor() || path.isWhile() || path.isLabeledStatement()) {
        return addCompletionRecords(path.get("body"), records, context);
    } else if (path.isProgram() || path.isBlockStatement()) {
        return getStatementListCompletion(path.get("body"), context);
    } else if (path.isFunction()) {
        return _getCompletionRecords(path.get("body"), context);
    } else if (path.isTryStatement()) {
        records = addCompletionRecords(path.get("block"), records, context);
        records = addCompletionRecords(path.get("handler"), records, context);
    } else if (path.isCatchClause()) {
        return addCompletionRecords(path.get("body"), records, context);
    } else if (path.isSwitchStatement()) {
        return completionRecordForSwitch(path.get("cases"), records, context);
    } else if (path.isSwitchCase()) {
        return getStatementListCompletion(path.get("consequent"), {
            canHaveBreak: true,
            shouldPopulateBreak: false,
            inCaseClause: true
        });
    } else if (path.isBreakStatement()) {
        records.push(BreakCompletion(path));
    } else {
        records.push(NormalCompletion(path));
    }
    return records;
}
function getCompletionRecords() {
    var records = _getCompletionRecords(this, {
        canHaveBreak: false,
        shouldPopulateBreak: false,
        inCaseClause: false
    });
    return records.map(function(r) {
        return r.path;
    });
}
function getSibling(key) {
    return NodePath.get({
        parentPath: this.parentPath,
        parent: this.parent,
        container: this.container,
        listKey: this.listKey,
        key: key
    }).setContext(this.context);
}
function getPrevSibling() {
    return this.getSibling(this.key - 1);
}
function getNextSibling() {
    return this.getSibling(this.key + 1);
}
function getAllNextSiblings() {
    var _key = this.key;
    var sibling = this.getSibling(++_key);
    var siblings = [];
    while(sibling.node){
        siblings.push(sibling);
        sibling = this.getSibling(++_key);
    }
    return siblings;
}
function getAllPrevSiblings() {
    var _key = this.key;
    var sibling = this.getSibling(--_key);
    var siblings = [];
    while(sibling.node){
        siblings.push(sibling);
        sibling = this.getSibling(--_key);
    }
    return siblings;
}
function get2(key) {
    var context = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    if (context === true) context = this.context;
    var parts = key.split(".");
    if (parts.length === 1) {
        return this._getKey(key, context);
    } else {
        return this._getPattern(parts, context);
    }
}
function _getKey(key, context) {
    var _this = this;
    var node = this.node;
    var container = node[key];
    if (Array.isArray(container)) {
        return container.map(function(_, i) {
            return NodePath.get({
                listKey: key,
                parentPath: _this,
                parent: node,
                container: container,
                key: i
            }).setContext(context);
        });
    } else {
        return NodePath.get({
            parentPath: this,
            parent: node,
            container: node,
            key: key
        }).setContext(context);
    }
}
function _getPattern(parts, context) {
    var path = this;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = parts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var part = _step.value;
            if (part === ".") {
                path = path.parentPath;
            } else {
                if (Array.isArray(path)) {
                    path = path[part];
                } else {
                    path = path.get(part, context);
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return path;
}
function getBindingIdentifiers2(duplicates) {
    return _getBindingIdentifiers(this.node, duplicates);
}
function getOuterBindingIdentifiers2(duplicates) {
    return _getOuterBindingIdentifiers(this.node, duplicates);
}
function getBindingIdentifierPaths() {
    var duplicates = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, outerOnly = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
    var path = this;
    var search = [
        path
    ];
    var ids = /* @__PURE__ */ Object.create(null);
    while(search.length){
        var id = search.shift();
        if (!id) continue;
        if (!id.node) continue;
        var keys = _getBindingIdentifiers.keys[id.node.type];
        if (id.isIdentifier()) {
            if (duplicates) {
                var _ids = ids[id.node.name] = ids[id.node.name] || [];
                _ids.push(id);
            } else {
                ids[id.node.name] = id;
            }
            continue;
        }
        if (id.isExportDeclaration()) {
            var declaration = id.get("declaration");
            if (isDeclaration2(declaration)) {
                search.push(declaration);
            }
            continue;
        }
        if (outerOnly) {
            if (id.isFunctionDeclaration()) {
                search.push(id.get("id"));
                continue;
            }
            if (id.isFunctionExpression()) {
                continue;
            }
        }
        if (keys) {
            for(var i = 0; i < keys.length; i++){
                var key = keys[i];
                var child = id.get(key);
                if (Array.isArray(child)) {
                    var _search;
                    (_search = search).push.apply(_search, _to_consumable_array(child));
                } else if (child.node) {
                    search.push(child);
                }
            }
        }
    }
    return ids;
}
function getOuterBindingIdentifierPaths() {
    var duplicates = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    return this.getBindingIdentifierPaths(duplicates, true);
}
var NodePath_family = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    _getKey: _getKey,
    _getPattern: _getPattern,
    get: get2,
    getAllNextSiblings: getAllNextSiblings,
    getAllPrevSiblings: getAllPrevSiblings,
    getBindingIdentifierPaths: getBindingIdentifierPaths,
    getBindingIdentifiers: getBindingIdentifiers2,
    getCompletionRecords: getCompletionRecords,
    getNextSibling: getNextSibling,
    getOpposite: getOpposite,
    getOuterBindingIdentifierPaths: getOuterBindingIdentifierPaths,
    getOuterBindingIdentifiers: getOuterBindingIdentifiers2,
    getPrevSibling: getPrevSibling,
    getSibling: getSibling
});
var _addComment = lib_exports.addComment, _addComments = lib_exports.addComments;
function shareCommentsWithSiblings() {
    if (typeof this.key === "string") return;
    var node = this.node;
    if (!node) return;
    var trailing = node.trailingComments;
    var leading = node.leadingComments;
    if (!trailing && !leading) return;
    var prev = this.getSibling(this.key - 1);
    var next = this.getSibling(this.key + 1);
    var hasPrev = Boolean(prev.node);
    var hasNext = Boolean(next.node);
    if (hasPrev) {
        if (leading) {
            prev.addComments("trailing", removeIfExisting(leading, prev.node.trailingComments));
        }
        if (trailing && !hasNext) prev.addComments("trailing", trailing);
    }
    if (hasNext) {
        if (trailing) {
            next.addComments("leading", removeIfExisting(trailing, next.node.leadingComments));
        }
        if (leading && !hasPrev) next.addComments("leading", leading);
    }
}
function removeIfExisting(list, toRemove) {
    if (!(toRemove === null || toRemove === void 0 ? void 0 : toRemove.length)) return list;
    var set = new Set(toRemove);
    return list.filter(function(el) {
        return !set.has(el);
    });
}
function addComment2(type, content, line) {
    _addComment(this.node, type, content, line);
}
function addComments2(type, comments) {
    _addComments(this.node, type, comments);
}
var NodePath_comments = /* @__PURE__ */ Object.freeze({
    __proto__: null,
    addComment: addComment2,
    addComments: addComments2,
    shareCommentsWithSiblings: shareCommentsWithSiblings
});
var validate3 = lib_exports.validate;
var debug = (0, import_debug.default)("babel");
var REMOVED = 1 << 0;
var SHOULD_STOP = 1 << 1;
var SHOULD_SKIP = 1 << 2;
var NodePath = /*#__PURE__*/ function() {
    "use strict";
    function _NodePath(hub, parent) {
        _class_call_check(this, _NodePath);
        __publicField(this, "contexts", []);
        __publicField(this, "state", null);
        __publicField(this, "opts", null);
        __publicField(this, "_traverseFlags", 0);
        __publicField(this, "skipKeys", null);
        __publicField(this, "parentPath", null);
        __publicField(this, "container", null);
        __publicField(this, "listKey", null);
        __publicField(this, "key", null);
        __publicField(this, "node", null);
        __publicField(this, "type", null);
        this.parent = parent;
        this.hub = hub;
        this.data = null;
        this.context = null;
        this.scope = null;
    }
    _create_class(_NodePath, [
        {
            key: "getScope",
            value: function getScope(scope2) {
                return this.isScope() ? new Scope2(this) : scope2;
            }
        },
        {
            key: "setData",
            value: function setData(key, val) {
                if (this.data == null) {
                    this.data = /* @__PURE__ */ Object.create(null);
                }
                return this.data[key] = val;
            }
        },
        {
            key: "getData",
            value: function getData(key, def) {
                if (this.data == null) {
                    this.data = /* @__PURE__ */ Object.create(null);
                }
                var val = this.data[key];
                if (val === void 0 && def !== void 0) val = this.data[key] = def;
                return val;
            }
        },
        {
            key: "hasNode",
            value: function hasNode() {
                return this.node != null;
            }
        },
        {
            key: "buildCodeFrameError",
            value: function buildCodeFrameError(msg) {
                var Error2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : SyntaxError;
                return this.hub.buildError(this.node, msg, Error2);
            }
        },
        {
            key: "traverse",
            value: function traverse(visitor4, state) {
                traverse3(this.node, visitor4, this.scope, state, this);
            }
        },
        {
            key: "set",
            value: function set(key, node) {
                validate3(this.node, key, node);
                this.node[key] = node;
            }
        },
        {
            key: "getPathLocation",
            value: function getPathLocation() {
                var parts = [];
                var path = this;
                do {
                    var key = path.key;
                    if (path.inList) key = "".concat(path.listKey, "[").concat(key, "]");
                    parts.unshift(key);
                }while (path = path.parentPath);
                return parts.join(".");
            }
        },
        {
            key: "debug",
            value: function debug1(message) {
                if (!debug.enabled) return;
                debug("".concat(this.getPathLocation(), " ").concat(this.type, ": ").concat(message));
            }
        },
        {
            key: "toString",
            value: function toString() {
                return generate(this.node).code;
            }
        },
        {
            key: "inList",
            get: function get() {
                return !!this.listKey;
            },
            set: function set(inList) {
                if (!inList) {
                    this.listKey = null;
                }
            }
        },
        {
            key: "parentKey",
            get: function get() {
                return this.listKey || this.key;
            }
        },
        {
            key: "shouldSkip",
            get: function get() {
                return !!(this._traverseFlags & SHOULD_SKIP);
            },
            set: function set(v) {
                if (v) {
                    this._traverseFlags |= SHOULD_SKIP;
                } else {
                    this._traverseFlags &= ~SHOULD_SKIP;
                }
            }
        },
        {
            key: "shouldStop",
            get: function get() {
                return !!(this._traverseFlags & SHOULD_STOP);
            },
            set: function set(v) {
                if (v) {
                    this._traverseFlags |= SHOULD_STOP;
                } else {
                    this._traverseFlags &= ~SHOULD_STOP;
                }
            }
        },
        {
            key: "removed",
            get: function get() {
                return !!(this._traverseFlags & REMOVED);
            },
            set: function set(v) {
                if (v) {
                    this._traverseFlags |= REMOVED;
                } else {
                    this._traverseFlags &= ~REMOVED;
                }
            }
        }
    ], [
        {
            key: "get",
            value: function get(param) {
                var hub = param.hub, parentPath = param.parentPath, parent = param.parent, container = param.container, listKey = param.listKey, key = param.key;
                if (!hub && parentPath) {
                    hub = parentPath.hub;
                }
                if (!parent) {
                    throw new Error("To get a node path the parent needs to exist");
                }
                var targetNode = container[key];
                var paths = getOrCreateCachedPaths(hub, parent);
                var path = paths.get(targetNode);
                if (!path) {
                    path = new _NodePath(hub, parent);
                    if (targetNode) paths.set(targetNode, path);
                }
                path.setup(parentPath, container, listKey, key);
                return path;
            }
        }
    ]);
    return _NodePath;
}();
Object.assign(NodePath.prototype, NodePath_ancestry, NodePath_inference, NodePath_replacement, NodePath_evaluation, NodePath_conversion, NodePath_introspection, NodePath_context, NodePath_removal, NodePath_modification, NodePath_family, NodePath_comments);
var _iteratorNormalCompletion6 = true, _didIteratorError6 = false, _iteratorError6 = undefined;
try {
    var _loop4 = function() {
        var type = _step6.value;
        var typeKey = "is".concat(type);
        var fn = lib_exports[typeKey];
        NodePath.prototype[typeKey] = function(opts) {
            return fn(this.node, opts);
        };
        NodePath.prototype["assert".concat(type)] = function(opts) {
            if (!fn(this.node, opts)) {
                throw new TypeError("Expected node path of type ".concat(type));
            }
        };
    };
    for(var _iterator6 = TYPES[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true)_loop4();
} catch (err) {
    _didIteratorError6 = true;
    _iteratorError6 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion6 && _iterator6.return != null) {
            _iterator6.return();
        }
    } finally{
        if (_didIteratorError6) {
            throw _iteratorError6;
        }
    }
}
Object.assign(NodePath.prototype, NodePath_virtual_types_validator);
var _iteratorNormalCompletion7 = true, _didIteratorError7 = false, _iteratorError7 = undefined;
try {
    for(var _iterator7 = Object.keys(virtualTypes)[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true){
        var type2 = _step7.value;
        if (type2[0] === "_") continue;
        if (!TYPES.includes(type2)) TYPES.push(type2);
    }
} catch (err) {
    _didIteratorError7 = true;
    _iteratorError7 = err;
} finally{
    try {
        if (!_iteratorNormalCompletion7 && _iterator7.return != null) {
            _iterator7.return();
        }
    } finally{
        if (_didIteratorError7) {
            throw _iteratorError7;
        }
    }
}
var VISITOR_KEYS$2 = lib_exports.VISITOR_KEYS;
var TraversalContext = /*#__PURE__*/ function() {
    "use strict";
    function TraversalContext(scope2, opts, state, parentPath) {
        _class_call_check(this, TraversalContext);
        __publicField(this, "queue", null);
        __publicField(this, "priorityQueue", null);
        this.parentPath = parentPath;
        this.scope = scope2;
        this.state = state;
        this.opts = opts;
    }
    _create_class(TraversalContext, [
        {
            key: "shouldVisit",
            value: function shouldVisit(node) {
                var opts = this.opts;
                if (opts.enter || opts.exit) return true;
                if (opts[node.type]) return true;
                var keys = VISITOR_KEYS$2[node.type];
                if (!(keys === null || keys === void 0 ? void 0 : keys.length)) return false;
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var key = _step.value;
                        if (node[key]) {
                            return true;
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                return false;
            }
        },
        {
            key: "create",
            value: function create(node, container, key, listKey) {
                return NodePath.get({
                    parentPath: this.parentPath,
                    parent: node,
                    container: container,
                    key: key,
                    listKey: listKey
                });
            }
        },
        {
            key: "maybeQueue",
            value: function maybeQueue(path, notPriority) {
                if (this.queue) {
                    if (notPriority) {
                        this.queue.push(path);
                    } else {
                        this.priorityQueue.push(path);
                    }
                }
            }
        },
        {
            key: "visitMultiple",
            value: function visitMultiple(container, parent, listKey) {
                if (container.length === 0) return false;
                var queue = [];
                for(var key = 0; key < container.length; key++){
                    var node = container[key];
                    if (node && this.shouldVisit(node)) {
                        queue.push(this.create(parent, container, key, listKey));
                    }
                }
                return this.visitQueue(queue);
            }
        },
        {
            key: "visitSingle",
            value: function visitSingle(node, key) {
                if (this.shouldVisit(node[key])) {
                    return this.visitQueue([
                        this.create(node, node, key)
                    ]);
                } else {
                    return false;
                }
            }
        },
        {
            key: "visitQueue",
            value: function visitQueue(queue) {
                this.queue = queue;
                this.priorityQueue = [];
                var visited = /* @__PURE__ */ new WeakSet();
                var stop2 = false;
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = queue[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var path = _step.value;
                        path.resync();
                        if (path.contexts.length === 0 || path.contexts[path.contexts.length - 1] !== this) {
                            path.pushContext(this);
                        }
                        if (path.key === null) continue;
                        var node = path.node;
                        if (visited.has(node)) continue;
                        if (node) visited.add(node);
                        if (path.visit()) {
                            stop2 = true;
                            break;
                        }
                        if (this.priorityQueue.length) {
                            stop2 = this.visitQueue(this.priorityQueue);
                            this.priorityQueue = [];
                            this.queue = queue;
                            if (stop2) break;
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = queue[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var path1 = _step1.value;
                        path1.popContext();
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
                this.queue = null;
                return stop2;
            }
        },
        {
            key: "visit",
            value: function visit(node, key) {
                var nodes2 = node[key];
                if (!nodes2) return false;
                if (Array.isArray(nodes2)) {
                    return this.visitMultiple(nodes2, node, key);
                } else {
                    return this.visitSingle(node, key);
                }
            }
        }
    ]);
    return TraversalContext;
}();
var VISITOR_KEYS$1 = lib_exports.VISITOR_KEYS;
function traverseNode(node, opts, scope2, state, path, skipKeys, visitSelf) {
    var keys = VISITOR_KEYS$1[node.type];
    if (!keys) return false;
    var context = new TraversalContext(scope2, opts, state, path);
    if (visitSelf) {
        if (skipKeys === null || skipKeys === void 0 ? void 0 : skipKeys[path.parentKey]) return false;
        return context.visitQueue([
            path
        ]);
    }
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            if (skipKeys === null || skipKeys === void 0 ? void 0 : skipKeys[key]) continue;
            if (context.visit(node, key)) {
                return true;
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return false;
}
var VISITOR_KEYS2 = lib_exports.VISITOR_KEYS, removeProperties2 = lib_exports.removeProperties, traverseFast2 = lib_exports.traverseFast;
function traverse3(parent) {
    var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, scope2 = arguments.length > 2 ? arguments[2] : void 0, state = arguments.length > 3 ? arguments[3] : void 0, parentPath = arguments.length > 4 ? arguments[4] : void 0, visitSelf = arguments.length > 5 ? arguments[5] : void 0;
    if (!parent) return;
    if (!opts.noScope && !scope2) {
        if (parent.type !== "Program" && parent.type !== "File") {
            throw new Error("You must pass a scope and parentPath unless traversing a Program/File. Instead of that you tried to traverse a ".concat(parent.type, " node without passing scope and parentPath."));
        }
    }
    if (!parentPath && visitSelf) {
        throw new Error("visitSelf can only be used when providing a NodePath.");
    }
    if (!VISITOR_KEYS2[parent.type]) {
        return;
    }
    explode(opts);
    traverseNode(parent, opts, scope2, state, parentPath, null, visitSelf);
}
traverse3.visitors = visitors;
traverse3.verify = verify;
traverse3.explode = explode;
traverse3.cheap = function(node, enter) {
    traverseFast2(node, enter);
    return;
};
traverse3.node = function(node, opts, scope2, state, path, skipKeys) {
    traverseNode(node, opts, scope2, state, path, skipKeys);
};
traverse3.clearNode = function(node, opts) {
    removeProperties2(node, opts);
};
traverse3.removeProperties = function(tree, opts) {
    traverseFast2(tree, traverse3.clearNode, opts);
    return tree;
};
function hasDenylistedType(path, state) {
    if (path.node.type === state.type) {
        state.has = true;
        path.stop();
    }
}
traverse3.hasType = function(tree, type, denylistTypes) {
    if (denylistTypes === null || denylistTypes === void 0 ? void 0 : denylistTypes.includes(tree.type)) return false;
    if (tree.type === type) return true;
    var state = {
        has: false,
        type: type
    };
    traverse3(tree, {
        noScope: true,
        denylist: denylistTypes,
        enter: hasDenylistedType
    }, null, state);
    return state.has;
};
traverse3.cache = cache;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
    codeFrameColumns: codeFrameColumns,
    generate: generate,
    parse: parse,
    parseExpression: parseExpression,
    template: template,
    tokTypes: tokTypes,
    traverse: traverse,
    types: types
});
